//
// ASURA_AdEngine.h
//
// Created by DWW 27/06/06
// 
// Copyright (C) 2006 Strangelite, All Rights Reserved.
//


#pragma once

#ifndef _ASURA_INGAMEADENGINE_
#define _ASURA_INGAMEADENGINE_

#include "Core/Asura_LinkList.h"
#include "Core/Asura_String.h"

class Asura_AdObject;

class Asura_InGameAdEngine
{
public:
	Asura_InGameAdEngine(void);
	~Asura_InGameAdEngine(void);

	static void Initialise(void);
	static void Shutdown(void);
	static void Update(const float fFrameTime);
	static void CreateAdObjects(void);
	static void ReleaseAdObjects(void);
	static void StartZone(const Asura_UnicodeChar* szLevelName);
	static void LeaveZone();

private:
	static void RegisterObject(Asura_AdObject* pxObjectToAdd);
	static void UnregisterObject(Asura_AdObject* pxAdObject);
	static const bool GetIsInitialised();
	static void DestroyAllAdObjects(void);

	// core platform 
	static void Platform_Initialise(void);
	static void Platform_Shutdown(void);
	static void Platform_Update(const float fFrameTime);
	static void Platform_CreateAdObjects(void);
	static void Platform_StartZone(const Asura_UnicodeChar* szLevelName);
	static void Platform_LeaveZone();

	// per project/platform
	static void PlatformProject_Initialise(void);
	static void PlatformProject_Shutdown(void);
	static void PlatformProject_Update(const float fFrameTime);
	static void PlatformProject_CreateAdObjects(void);

	static void PlatformProject_StartZone(const Asura_UnicodeChar* szLevelName);
	static void PlatformProject_LeaveZone();

private:
	static bool m_bInitialised;

	static Asura_LinkList<Asura_AdObject*> m_xListOfAdObjects;
};

#endif