//
// Asura_Animation_IK_Template_Chain_LOS.cpp
//
// Created by Richard Rice - 12/05/2008
// 
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//

#include "Core/Asura.h"
#include "Animation/IK/Asura_Animation_IK_Template_Chain_LOS.h"

#ifdef ASURA_USE_ANIMATION_IK_SOLVER

#include "Animation/IK/Asura_Animation_IK_Chain_LOS.h"
#include "ChunkSystem/Asura_Chunk_Stream.h"

#define ASURA_ANIMATION_IK_TEMPLATE_CHAIN_LOS_VERSION 0

Asura_Animation_IK_Template_Chain_LOS::Asura_Animation_IK_Template_Chain_LOS()
:m_xLocalLOSDirection(0.0f,1.0f,0.0f)
{
	m_bRootBoneMover = true;
}

Asura_Animation_IK_Chain* Asura_Animation_IK_Template_Chain_LOS::CreateChainFromTemplate(const Asura_Animation* pxAnim) const
{
	Asura_Animation_IK_Chain* pxChain = new Asura_Animation_IK_Chain_LOS(GetBoneArray(), GetTwistBoneArray(), m_xLocalLOSDirection);
	SetupChain(pxChain);

	return pxChain;
}

bool Asura_Animation_IK_Template_Chain_LOS::ReadFromChunkStream(Asura_Chunk_Stream& xStream)
{
	//check this class's version
	int iVersion;
	xStream >> iVersion;

	if(iVersion > ASURA_ANIMATION_IK_TEMPLATE_CHAIN_LOS_VERSION)
	{
		Asura_Assertf(0, ("Unrecognised chunk version %d for LOS IK chain template", iVersion));
		return false;
	}

	//read the parent
	if(!PARENT::ReadFromChunkStream(xStream)) return false;

	//read the rest of this class
	xStream >> m_xLocalLOSDirection;

	return true;
}

#ifdef ASURA_TOOLS
void Asura_Animation_IK_Template_Chain_LOS::WriteToChunkStream(Asura_Chunk_Stream& xStream) const
{
	//write his class's version
	xStream << ASURA_ANIMATION_IK_TEMPLATE_CHAIN_LOS_VERSION;

	//write the parent
	PARENT::WriteToChunkStream(xStream);
		
	//write the rest of this
	xStream << m_xLocalLOSDirection;
}
#endif //ASURA_TOOLS



#endif //ASURA_USE_ANIMATION_IK_SOLVER
