//
// Asura_Animation_IK_Template_Chain_MarkerPoint.h
//
// Created by Richard Rice - 12/05/2008
// 
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __ASURA_ANIMATION_IK_TEMPLATE_CHAIN_MARKERPOINT_H__
#define __ASURA_ANIMATION_IK_TEMPLATE_CHAIN_MARKERPOINT_H__
#ifdef ASURA_USE_ANIMATION_IK_SOLVER

#include "Animation/IK/Asura_Animation_IK_Template_Chain.h"

#ifdef ASURA_TOOLS
//Flag defines for use by the tickbox controls
#define ASURA_IKTEMPLATEFLAG_MARKERPOINT_USEORI 0x00000001
#endif //ASURA_TOOLS

class Asura_Animation_IK_Template_Chain_MarkerPoint : public Asura_Animation_IK_Template_Chain
{
	friend class Tools_Animation_IK_Template_System;
	typedef Asura_Animation_IK_Template_Chain PARENT;
public :
	Asura_Animation_IK_Template_Chain_MarkerPoint();

	//Creates an instance of the IK chain from this template
	virtual Asura_Animation_IK_Chain* CreateChainFromTemplate(const Asura_Animation* pxAnim) const;

	void SetMarkerPoint(const char* szName);

	virtual Asura_IKChain_Type GetType() const {return ASURA_IKCHAIN_MARKERPOINT;}

	virtual bool ReadFromChunkStream(Asura_Chunk_Stream& xStream);
	#ifdef ASURA_TOOLS
	virtual void WriteToChunkStream(Asura_Chunk_Stream& xStream) const;
	#endif

private :
	Asura_Hash_ID m_uMarkerPointHash;
	union
	{
		u_int m_uMarkerPointFlags;
		struct
		{
			u_int m_bUseOri:1;
		};
	};

	#ifdef ASURA_TOOLS
	Asura_String m_xMarkerPointName;
	#endif

};




#endif //ASURA_USE_ANIMATION_IK_SOLVER
#endif //__ASURA_ANIMATION_IK_TEMPLATE_CHAIN_MARKERPOINT_H__
