//
// Asura_Attractor_Node_Data.h
//
// Created by JGP 10/05/06
//
// Copyright (C) 2006 Rebellion (Derby), All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_ATTRACTOR_NODE_DATA_H__
#define __ASURA_ATTRACTOR_NODE_DATA_H__


// base class
#include "Core/Asura_Maths.h"


/*
	Asura_Attractor_Node_Data

	Storage class for a single
	node on an attractor
*/
class Asura_Attractor_Node_Data
{
public:

	Asura_Attractor_Node_Data();
	#ifdef ASURA_TOOLS
	Asura_Attractor_Node_Data( class Asura_Attractor_Data* const pxAttractor );
	#endif
	~Asura_Attractor_Node_Data();

	const Asura_Vector_3& GetPosition() const { return m_xPosition; }
	void SetPosition( const Asura_Vector_3 xPosition ) { m_xPosition = xPosition; }

	#ifdef ASURA_TOOLS
	class Asura_Attractor_Data* GetAttractorData() { return m_pxAttractorData; }
	const class Asura_Attractor_Data* GetAttractorData() const { return m_pxAttractorData; }

	void SetAttractorData(Asura_Attractor_Data* pxAttractorData){m_pxAttractorData = pxAttractorData;}
	#endif
		
private:

	Asura_Vector_3 m_xPosition;
	#ifdef ASURA_TOOLS
	class Asura_Attractor_Data* m_pxAttractorData;
	#endif

};


#endif // __ASURA_ATTRACTOR_NODE_DATA_H__
