//*******************************************************************
//
// File: Asura_Botanical_Game_Render_Instance.h
//
// Created: 30 Nov 2006
//
// Description: 
//
//*******************************************************************

#ifndef _ASURA_BOTANICAL_GAME_RENDER_INSTANCE_H_
#define _ASURA_BOTANICAL_GAME_RENDER_INSTANCE_H_

// other libraries
#include "Botanicals/Asura_Platform_Botanical_Game_Render_Instance.h"

// internal dependencies

// forward declarations
class Asura_AMatrix3x3;
class Asura_AVector3;
class Asura_Matrix_3x3;
class Asura_Vector_3;
class Asura_BGR_InstanceTransform;
class Asura_BGR_InstanceLighting;
class Asura_Chunk_Stream;

//*******************************************************************
// Constants
//*******************************************************************


//*******************************************************************
// Class Definitions
//*******************************************************************

class Asura_BGR_Instance : public Asura_Platform_BGR_Instance
{
public:
	template< class Tdata> void GetInstanceData( Tdata& tData) const;
	
	void GetInstancePosition( Asura_AVector3& xInstancePosition) const;
	void GetInstancePosition( Asura_Vector_3& xInstancePosition) const;
	void GetInstanceUp( Asura_AVector3& xInstancePosition) const;
	void GetOrientation( Asura_AMatrix3x3& xInstanceOrientation) const;
	void GetOrientationTransposed( Asura_AMatrix3x3& xInstanceOrientation) const;
	
	void GetOrientation( Asura_Matrix_3x3& xInstanceOrientation) const;
	void GetOrientationTransposed( Asura_Matrix_3x3& xInstanceOrientation) const;
	void GetOrientationInversed( Asura_Matrix_3x3& xInstanceOrientation) const;
	float GetScale(void) const;

	void GetInstanceData( Asura_BGR_InstanceTransform& xInstanceTransform, Asura_BGR_InstanceLighting& xInstanceLighting) const;
	void GetInstanceData( Asura_BGR_InstanceLighting& xInstanceLighting) const;
	void GetInstanceData( Asura_BGR_InstanceTransform& xInstanceTransform) const;
	
	void GetInstanceSpherical( float* afSphericalR, float* afSphericalG, float* afSphericalB) const;
	
	bool Process( Asura_Chunk_Stream& xStream);
	
#if defined( ASURA_TOOLS)
	bool Export( Asura_Chunk_Stream& xStream) const;
	
	void SetInstanceBrightness( float fBrightness ) { this->m_fBrightness = fBrightness;}
	void SetInstanceData( const Asura_BGR_InstanceTransform& xInstanceTransform, const Asura_BGR_InstanceLighting& xInstanceLighting);
	void SetInstanceData( const Asura_BGR_InstanceTransform& xInstanceTransform);
	void SetInstanceData( const Asura_BGR_InstanceLighting& xInstanceLighting);
	bool IsActive() const { return( this->m_bActive);}
	void SetActive( const bool bActive) { this->m_bActive = bActive;}
	void Relight();	
#endif
	
private:

};

//*******************************************************************
// Inline Function Definitions
//*******************************************************************

#include "Botanicals/Asura_Platform_Botanical_Game_Render_Instance_Inline.h"

//*******************************************************************
//
// (c) 2006 Rebellion
//
// Warning: This computer program is protected by copyright law and 
// international treaties. Unauthorized reproduction or distribution
// of this program, or any portion of it, may result in severe civil and
// criminal penalties, and will be prosecuted to the maximum extent 
// possible under the law.
//
//*******************************************************************

#endif // _ASURA_BOTANICAL_GAME_RENDER_INSTANCE_H_
