//*******************************************************************
//
// File: Asura_Botanical_Game_Render_Instance_Header.cpp
//
// Created: 30 Nov 2006
//
// Description: 
//
//*******************************************************************

// system libraries
#include "Core/Asura.h"

#if defined( ASURA_USE_BOTANICALS)

// main header
#include "Botanicals/Asura_Botanical_Game_Render_Instance_Header.h"

// other libraries
#include "Botanicals/Asura_Botanical_Game_Render_Manager.h"
#include "Botanicals/Asura_Botanical_Game_Render_Type.h"

#include "Core/Memory/Asura_Mem.h"

// internal dependencies

//*******************************************************************
// Constants
//*******************************************************************


//*******************************************************************
// Local Classes
//*******************************************************************


//*******************************************************************
// Function Definitions
//*******************************************************************

#if defined( ASURA_BOTANICAL_SUPPORT_DYNAMIC_DATA) && 1 == ASURA_BOTANICAL_SUPPORT_DYNAMIC_DATA
bool Asura_BGR_Instances_Header::AllocateDynamicData( const u_int uDynamicCountInstances)
{
	delete[] this->m_pucDynamicInstanceData;
	this->m_pucDynamicInstanceData = NULL;
	this->m_uDynamicCountInstances = 0;
	
	if( 0 == this->m_xDynamicDataLayout.m_uDynamicSizeInstance)
	{
		return( true);
	}
	
//	Asura_Assert( NULL == this->m_pucDynamicInstanceData, "Dynamic Data already setup");
	this->m_uDynamicCountInstances = uDynamicCountInstances;
	
	if(uDynamicCountInstances)
	{
		const size_t uDynamicInstanceDataSize = this->m_uDynamicCountInstances * this->m_xDynamicDataLayout.m_uDynamicSizeInstance;
		this->m_pucDynamicInstanceData = new uint8[ uDynamicInstanceDataSize];
		
		// DLH - 01 November 2006 11:43:19 - Clear the data block as no constructor can be run on it
		Asura_Mem::Set( this->m_pucDynamicInstanceData, 0, uDynamicInstanceDataSize);
	}
	return( true);
}
#endif

#if defined( ASURA_BOTANICAL_SUPPORT_DYNAMIC_DATA) && 1 == ASURA_BOTANICAL_SUPPORT_DYNAMIC_DATA
void Asura_BGR_Instances_Header::DeallocateDynamicData()
{
	delete[] this->m_pucDynamicInstanceData;
	this->m_pucDynamicInstanceData = NULL;
	this->m_uDynamicCountInstances = 0;
}
#endif

#if defined( ASURA_BOTANICAL_SUPPORT_DYNAMIC_DATA) && 1 == ASURA_BOTANICAL_SUPPORT_DYNAMIC_DATA
void Asura_BGR_Instances_Header::ClearDynamicData()
{
	this->m_xDynamicDataLayout.Clear();
	
	delete[] this->m_pucDynamicInstanceData;
	this->m_pucDynamicInstanceData = NULL;
	this->m_uDynamicCountInstances = 0;
}
#endif

#if defined( ASURA_BOTANICAL_SUPPORT_DYNAMIC_DATA) && 1 == ASURA_BOTANICAL_SUPPORT_DYNAMIC_DATA
void Asura_BGR_Instances_Header::ResetDynamicData()
{
	if( NULL == this->m_pucDynamicInstanceData)
	{
		return;
	}
	
	const size_t uDynamicInstanceDataSize = this->m_uDynamicCountInstances * this->m_xDynamicDataLayout.m_uDynamicSizeInstance;
	
	// DLH - 01 November 2006 11:43:19 - Clear the data block
	Asura_Mem::Set( this->m_pucDynamicInstanceData, 0, uDynamicInstanceDataSize);
}
#endif

#if defined( ASURA_BOTANICAL_SUPPORT_DYNAMIC_DATA) && 1 == ASURA_BOTANICAL_SUPPORT_DYNAMIC_DATA
bool Asura_BGR_Instances_Header::SetupDynamicData( const Asura_BGR_Type& xType)
{
	this->m_xDynamicDataLayout = xType.GetDynamicDataLayout();
	return( true);
}
#endif

#if defined( ASURA_BOTANICAL_SUPPORT_DYNAMIC_DATA) && 1 == ASURA_BOTANICAL_SUPPORT_DYNAMIC_DATA
void Asura_BGR_Manager::ResetDynamicData()
{
	const u_int uInstanceHeaderCount = this->GetInstanceHeaderCount();
	for( u_int uInstanceHeaderIndex = 0; uInstanceHeaderIndex < uInstanceHeaderCount; uInstanceHeaderIndex += 1)
	{
		Asura_BGR_Instances_Header* pxInstanceHeader = this->GetInstanceHeader( uInstanceHeaderIndex);
		if( NULL == pxInstanceHeader)
		{
			continue;
		}
		
		pxInstanceHeader->ResetDynamicData();
	}		
}
#endif

//*******************************************************************
//
// (c) 2006 Rebellion
//
// Warning: This computer program is protected by copyright law and 
// international treaties. Unauthorized reproduction or distribution
// of this program, or any portion of it, may result in severe civil and
// criminal penalties, and will be prosecuted to the maximum extent 
// possible under the law.
//
//*******************************************************************

#endif //defined( ASURA_USE_BOTANICALS)
