//*******************************************************************
//
// File: Asura_Botanical_Game_Render_TypeID.h
//
// Created: 30 Nov 2006
//
// Description: 
//
//*******************************************************************

#ifndef _ASURA_BOTANICAL_GAME_RENDER_TYPEID_H_
#define _ASURA_BOTANICAL_GAME_RENDER_TYPEID_H_

// other libraries

// internal dependencies

// forward declarations
class Asura_Chunk_Stream;

//*******************************************************************
// Constants
//*******************************************************************


//*******************************************************************
// Class Definitions
//*******************************************************************

struct Asura_BGR_TypeID
{
public:
	enum 
	{
		INVALID_ID = static_cast< uint32>( 0x7FFFFFFFL),
	};
	
	Asura_BGR_TypeID();
	Asura_BGR_TypeID( const uint32 uID);
	
	void Clear();
	
	uint32 GetID() const;
	
	inline bool operator==( const Asura_BGR_TypeID& xRHS) const { return( this->m_uID == xRHS.m_uID);}
	inline bool operator!=( const Asura_BGR_TypeID& xRHS) const { return( this->m_uID != xRHS.m_uID);}
	
	bool Process( Asura_Chunk_Stream& xStream);
#if defined( ASURA_TOOLS)
	bool Export( Asura_Chunk_Stream& xStream) const;
#endif

private:
	uint32 m_uID;
};

//*******************************************************************
// Inline Function Definitions
//*******************************************************************

inline Asura_BGR_TypeID::Asura_BGR_TypeID( const uint32 uID)
{
	this->m_uID = uID;
}

inline Asura_BGR_TypeID::Asura_BGR_TypeID() 
{ 
	this->m_uID = INVALID_ID; 
}

inline void Asura_BGR_TypeID::Clear()
{
	this->m_uID = INVALID_ID;
}

inline uint32 Asura_BGR_TypeID::GetID() const
{
	return( this->m_uID);
}


//*******************************************************************
//
// (c) 2006 Rebellion
//
// Warning: This computer program is protected by copyright law and 
// international treaties. Unauthorized reproduction or distribution
// of this program, or any portion of it, may result in severe civil and
// criminal penalties, and will be prosecuted to the maximum extent 
// possible under the law.
//
//*******************************************************************

#endif // _ASURA_BOTANICAL_GAME_RENDER_TYPEID_H_
