/**
*
* \file Asura_Chunk_AnimationTable.h
*
* Created by Richard May - 18/06/2002 14:28:01
*
* Copyright (C) 2002 Rebellion, All Rights Reserved.
*
* \brief
*
**/

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif

#ifndef __ASURA_CHUNK_ANIMATIONTABLE_H__
#define __ASURA_CHUNK_ANIMATIONTABLE_H__

// I N C L U D E S ///////////////////////////////////////////////////////////

// Engine independent.
#include "ChunkSystem/Asura_Chunk_Loaders.h"

// C O N S T A N T S /////////////////////////////////////////////////////////

// Flags used in chunk header, for both types of anim table chunk.
const u_int uASURA_CHUNK_ANIMTABLE_HAS_ENTRY_FLAGS = 1 << 0;

// C L A S S E S /////////////////////////////////////////////////////////////

class Asura_Chunk_AnimationTable : public Asura_Chunk_Header
{

public:

    enum { CURRENT_VERSION = 5 };

	/* Public interface functions. */
#ifdef ASURA_MAIN
	bool Process( Asura_Handle fileHandle );
#endif

// (MP - 04.02.2007) I've moved this code out into the animprocessor utility
// since it was going to get more complex and that's the only place this is
// required these days, AFAIK. When exporting from tools, we write the chunk
// below instead.
//	static void Create( const class Asura_String& name, const class Asura_String* stringBuffer, class Asura_SaveBlock* saveBlock, unsigned int uPrimaries, unsigned int uSecondaries );

	int NumberOfPrimaryStates;
	int NumberOfSecondaryStates;

};
/* end of class Asura_Chunk_AnimationTable */


//Variant of anmation table chunk used by level exports. RAR 19/01/2006

class Asura_Chunk_ExportedAnimationTable : public Asura_Chunk_Header
{

public:

#ifdef ASURA_MAIN
	bool Process(class Asura_Chunk_Stream& xStream) const;
	bool Process(Asura_Handle iFileHandle) const;
#endif

#ifdef ASURA_TOOLS
	static void Create(const class Asura_AnimTable* pxTable,class Asura_Chunk_Stream& xStream);
	static void Create(const class Asura_AnimTable* pxTable,class Asura_SaveBlock* pxSaveBlock);
#endif

};

/****************/
/* End of file. */
/****************/
#endif//__ASURA_CHUNK_ANIMATIONTABLE_H__
