
/**
*
* \file Asura_Chunk_Carpet_Mesh.cpp
*
* Created by Dave Reed - 02/12/2005
*
* Copyright (C) 2002 Rebellion (Derby), All Rights Reserved.
*
**/

#include "Core/Asura.h"

#ifdef ASURA_USE_CARPET

#include "ChunkSystem/Asura_Chunk_Macros.h"
#include "ChunkSystem/Asura_SaveBlock.h"
#include "ChunkSystem/Asura_Chunk_Stream.h"
#include "Core/Asura_Handle.h"
#include "Core/Asura_String.h"
#include "Core/Asura_TextureFlags.h"
#include "Debugging/Asura_Assert.h"
#include "FileAccess/Asura_FileAccess.h"

#include "ChunkSystem/Asura_Chunk_Carpet_Mesh.h"
#include "Carpet/Asura_Carpet_StyleManager.h"
#include "Carpet/Asura_Carpet_MeshManager.h"



#ifdef ASURA_TOOLS



bool Asura_Chunk_Carpet_Mesh::Create(char* szFileName)
{

	//Create saveblock and chunk
	Asura_SaveBlock* pxSaveBlock = new Asura_SaveBlock();
	Asura_Assert(pxSaveBlock, "Unable to create saveblock");	
	
	if(pxSaveBlock)
	{
		Asura_Chunk_SaveBlock_Stream	xStream (pxSaveBlock);
		xStream.WriteChunk_Start	(ASURA_CHUNK_CARPET_MESH, Asura_Carpet_MeshManager::GetCurrentChunkVersion(), 0);

		// Serialize the mesh to the chunk
		Asura_Carpet_MeshManager::Serialize(xStream);

		xStream.WriteChunk_End();
		xStream.WriteAsuraTerminator();

		bool bSuccess=pxSaveBlock->SaveFile(szFileName, false );
		delete pxSaveBlock;

		return bSuccess;		
	}

	return false;
}



bool Asura_Chunk_Carpet_Mesh::Process(Asura_Handle iFileHandle) const
{

	// Clear any existing mesh
	Asura_Carpet_MeshManager::Reset();	

	// Read the mesh from the chunk
	Asura_Carpet_MeshManager::Deserialize(Version,iFileHandle);

	return true;
}
#endif	// ASURA_TOOLS

#endif // ASURA_USE_CARPET
