//
// Asura_Chunk_Definitions.h
//
// Created by Kevin Lea - 12/06/2001 11:17:14
// 
// Copyright (C) 2001 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __ASURA_CHUNK_DEFINITIONS_H__
#define __ASURA_CHUNK_DEFINITIONS_H__

#ifdef ASURA_TOOLS
#include "ChunkSystem/Asura_Chunk_Mesh.h"
#include "ChunkSystem/Asura_Chunk_EnvironmentalLightTransport.h"
#include "ChunkSystem/Asura_Chunk_GlobalIllumination.h"
#include "ChunkSystem/Tools_Chunk_HelperObject.h"
#include "ChunkSystem/Tools_Chunk_ToolsLights.h"
#endif

#include "ChunkSystem/Asura_Chunk_Env.h"
#include "ChunkSystem/Asura_Chunk_FileInfo.h"
#include "ChunkSystem/Asura_Chunk_Fragment.h"
#include "ChunkSystem/Asura_Chunk_Hierarchy.h"
#include "ChunkSystem/Asura_Chunk_Material.h"
#include "ChunkSystem/Asura_Chunk_ShapeData.h"
#include "ChunkSystem/Asura_Chunk_StartPosition.h"
#include "ChunkSystem/Asura_Chunk_Texture.h"
#include "ChunkSystem/Asura_Chunk_TextureAnimation.h"

#if defined(ASURA_USE_MATERIAL_RESPONSE_SYSTEM) && defined(ASURA_TOOLS)
#include "ChunkSystem/Tools_Chunk_MaterialResponse.h"
#endif

#ifndef ASURAIMPORT_EXPORTS

#include "ChunkSystem/Asura_Chunk_Shape.h"
#include "ChunkSystem/Asura_Chunk_GI_Solution.h"
#include "ChunkSystem/Asura_Chunk_Lights.h"
#include "ChunkSystem/Asura_Chunk_Corona.h"
#include "ChunkSystem/Asura_Chunk_Phonons.h"
#include "ChunkSystem/Asura_Chunk_ModuleReverb.h"
#include "ChunkSystem/Asura_Chunk_Navigation.h"
#include "ChunkSystem/Asura_Chunk_ResourceFile.h"
#include "ChunkSystem/Asura_Chunk_ResourceFileList.h"
#include "ChunkSystem/Asura_Chunk_Skybox.h"
#include "ChunkSystem/Asura_Chunk_Cutscene.h"
#include "ChunkSystem/Asura_Chunk_ModuleLinking.h"
#include "ChunkSystem/Asura_Chunk_Entity.h"
#include "ChunkSystem/Asura_Chunk_AnimationTable.h"
#include "ChunkSystem/Asura_Chunk_TiledTexture.h"
#include "ChunkSystem/Asura_Chunk_Font.h"
#include "ChunkSystem/Asura_Chunk_LocalText.h"
#include "ChunkSystem/Asura_Chunk_HashedLocalisedText.h"
#include "ChunkSystem/Asura_Chunk_HierarchyBodyPart.h"
#include "ChunkSystem/Asura_Chunk_StreamingBackgroundSound.h"
#include "ChunkSystem/Asura_Chunk_MetaMusic.h"
#include "ChunkSystem/Asura_Chunk_RenderSettings.h"
#include "ChunkSystem/Asura_Chunk_EnvironmentLBAABBTree.h"
#include "ChunkSystem/Asura_Chunk_PhysicsEnvironment.h"
#include "ChunkSystem/Asura_Chunk_Blueprints.h"
#include "ChunkSystem/Asura_Chunk_WaypointingSettings.h"

#ifdef ASURA_USE_BILLBOARD_PLANTS
#include "ChunkSystem/Asura_Chunk_BillboardPlant_Template.h"
#include "ChunkSystem/Asura_Chunk_BillboardPlant_Batches.h"
#endif //ASURA_USE_BILLBOARD_PLANTS

#ifdef ASURA_SUPPORT_WEATHER_SYSTEM
#include "ChunkSystem/Asura_Chunk_Fog.h"
#include "ChunkSystem/Asura_Chunk_WeatherSystem.h"
#endif //ASURA_SUPPORT_WEATHER_SYSTEM

#ifdef ASURA_SUPPORT_MULTIPLAYER_COMMS
#include "ChunkSystem/Asura_Chunk_MPComms_BannedWordList.h"
#endif // ASURA_SUPPORT_MULTIPLAYER_COMMS

#include "ChunkSystem/Asura_Chunk_PFX.h"

#ifdef ASURA_USE_WATER
#include "ChunkSystem/Asura_Chunk_Water.h"
#endif //ASURA_USE_WATER

#include "ChunkSystem/Asura_Chunk_FMVSubtitles.h"

#ifdef ASURA_USE_BOTANICALS
#include "ChunkSystem/Asura_Chunk_Botanicals_Templates.h"
#include "ChunkSystem/Asura_Chunk_Botanicals_Instances.h"
#include "ChunkSystem/Asura_Chunk_Botanicals_Definition.h"
#endif //ASURA_USE_BOTANICALS

#ifdef ASURA_USE_CARPET
#include "ChunkSystem/Asura_Chunk_Carpet_Styles.h"
#include "ChunkSystem/Asura_Chunk_Carpet_Mesh.h"
#endif //ASURA_USE_CARPET

#ifdef ASURA_USE_FSFX
#include "ChunkSystem/Asura_Chunk_FSFX.h"
#include "ChunkSystem/Asura_Chunk_FSFXOverrides.h"
#ifdef ASURA_TOOLS
#include "ChunkSystem/Tools_Chunk_FSFXOverrides.h"
#endif
#endif

#ifdef ASURA_USE_ATTRACTORS
#include "ChunkSystem/Asura_Chunk_Attractors.h"
#endif

#if defined( ASURA_USE_NEW_VISIBILITY_SYSTEM )
#include "ChunkSystem/Asura_Chunk_Visibility.h"
#endif

#ifdef ASURA_USE_PSP_BLUR
#include "ChunkSystem/Asura_Chunk_PSP_Blur.h"
#endif //ASURA_USE_PSP_BLUR

#ifdef ASURA_USE_PSP_FILTER
#include "ChunkSystem/Asura_Chunk_PSP_Filter.h"
#endif //ASURA_USE_PSP_FILTER

#ifdef ASURA_USE_STREAMING
#include "ChunkSystem/Asura_Chunk_StreamingConnections.h"
#endif

#if defined(ASURA_USE_STREAMING) && defined(ASURA_TOOLS)
#include "ChunkSystem/Asura_Chunk_StreamingModuleNames.h"
#endif

#include "ChunkSystem/Asura_Chunk_SoundEvent.h"

#ifdef ASURA_USE_DIALOGUE_SYSTEM
#include "ChunkSystem/Asura_Chunk_Dialogue.h"
#endif

#ifdef ASURA_USE_ARTICULATION_SYSTEM
#include "ChunkSystem/Asura_Chunk_Lipsync.h"
#endif

#ifdef ASURA_USE_AXON
//#include "ChunkSystem/Axon_Chunk_LocationSystem.h"
#include "ChunkSystem/Axon_Chunk_AnimTemplates.h"
#endif

#ifdef ASURA_USE_GUI_MENU_SYSTEM
#include "ChunkSystem/Asura_Chunk_GUIMenu.h"
#endif

#ifdef ASURA_USE_MATERIAL_RESPONSE_SYSTEM
#ifdef ASURA_TOOLS
#include "ChunkSystem/Tools_Chunk_MaterialResponseOverrides.h"
#endif
#include "ChunkSystem/Asura_Chunk_MaterialResponse.h"
#include "ChunkSystem/Asura_Chunk_MaterialResponseOverrides.h"
#endif

#include "ChunkSystem/Asura_Chunk_PFXOverrides.h"
#ifdef ASURA_TOOLS
#include "ChunkSystem/Tools_Chunk_PFXOverrides.h"
#endif


#ifdef ASURA_USE_DECAL_MANAGER
#include "ChunkSystem/Asura_Chunk_Decals.h"
#endif

#ifdef ASURA_TARGET_SM3
#ifdef ASURA_TOOLS
#include "ChunkSystem/Asura_Chunk_DynamicLightTemplate.h"
#endif
#endif

#ifdef ASURA_USE_STATIC_DECAL_SYSTEM
#ifdef ASURA_TOOLS
#include "ChunkSystem/Tools_Chunk_StaticDecals.h"
#endif
#endif

#ifdef ASURA_USE_REVERBVOLUME_SYSTEM
#include "ChunkSystem/Asura_Chunk_ReverbVolumes.h"
#endif

#if defined(ASURA_USE_TEXTURE_STREAMING)
#include "ChunkSystem/Asura_Chunk_Texture_Streaming.h"
#endif

#ifdef ASURA_USE_CONTAINER_SYSTEM
#include "ChunkSystem/Asura_Chunk_Container.h"
#endif //#idef ASURA_USE_CONTAINER_SYSTEM

#ifdef ASURA_USE_ANIMATION_IK_SOLVER
#include "ChunkSystem/Asura_Chunk_IK_Template.h"
#endif

#ifdef ASURA_USE_AUDIO_SYSTEM
#include "ChunkSystem/Asura_Chunk_DSP.h"
#include "ChunkSystem/Asura_Chunk_ReverbPresets.h"
#include "ChunkSystem/Asura_Chunk_StreamingSounds.h"
#ifdef ASURA_TOOLS
#include "ChunkSystem/Tools_Chunk_StreamingSounds.h"
#endif
#endif

#endif // ASURAIMPORT_EXPORTS


#endif//__ASURA_CHUNK_DEFINITIONS_H__
