//
// Asura_Chunk_Env.h
//
// Created by Kevin Lea - 12/06/2001 11:18:01
// 
// Copyright (C) 2001 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __ASURA_CHUNK_ENV_H__
#define __ASURA_CHUNK_ENV_H__

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "Asura_Chunk_Loaders.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class Asura_Environment;
class Asura_SaveBlock;
class Asura_Chunk_Stream;

// C L A S S E S /////////////////////////////////////////////////////////////

class Asura_Chunk_Environment_ModuleList : public Asura_Chunk_Header
{
public:
	bool Process(Asura_Handle fileHandle);
    
#if  defined(ASURA_TOOLS) || defined(ASURAIMPORT_EXPORTS)
	//piMaterialIDToIndexConversion is used for converting the material IDs in the collision meshes to values suitable
	//for saving. It can be NULL if no conversion is required (such as in Max exports)
	//szMeshStrippedFilename is used when saving out only some of the modules in the environment. If null then all the 
	//modules will be saved
	static void Create( const Asura_Environment* env, Asura_SaveBlock* saveBlock,const int* piMaterialIDToIndexConversion,const char* szMeshStrippedFilename);
	static void Create( const Asura_Environment* env, Asura_Chunk_Stream& xStream,const int* piMaterialIDToIndexConversion,const char* szMeshStrippedFilename);
#endif

	int m_iNumberOfModules;
};


#endif//__ASURA_CHUNK_ENV_H__
