//
// Asura_FSFX_System.cpp
//
// Created by JGP 02/02/06
// 
// Copyright (C) 2006 Rebellion (Derby), All Rights Reserved.
//

#include "Core/Asura.h"

#ifdef ASURA_USE_FSFX

// This file's header.
#include "ChunkSystem/Asura_Chunk_FSFX.h"

// Asura headers
#include "FSFX/Asura_FSFX_System.h"
#include "FSFX/Asura_FSFX_Template.h"
#include "ChunkSystem/Asura_Chunk_Loaders.h"
#include "ChunkSystem/Asura_Chunk_Stream.h"
#include "ChunkSystem/Asura_SaveBlock.h"
#include "FileAccess/Asura_FileAccess.h"
#include "SpecialFX/PFX/Asura_PFX_System.h"
#include "SpecialFX/PFX/Asura_PFX_Templates.h"

#ifdef ASURA_TOOLS
#include "FSFX/Tools_FSFX_System.h"
#endif


bool Asura_Chunk_FSFX::Process( Asura_Handle iFileHandle ) const
{
	Asura_Assert( ( Version > 0 ) && ( Version <= CHUNK_VERSION ) , "Wrong version number" );

	Asura_Chunk_File_Stream xStream( iFileHandle );

	Asura_FSFX_Template* const pxTemplate = new Asura_FSFX_Template;
	pxTemplate->ReadFromChunkStream( xStream, Version );

#ifdef ASURA_TOOLS
	pxTemplate->SetLoadedFromFile( Asura_FileAccess::GetFilename( iFileHandle ) );
	// Only add to tools system if
	// we're doing a load all templates
	// otherwise this is one of the ones
	// in the ASR file and we just ignore it
	if ( Tools_FSFX_System::IsLoadingAllTemplates() )
	{
        Tools_FSFX_System::AddTemplate( pxTemplate );
	}
	else
	{
		delete pxTemplate;
	}
#else
	Asura_FSFX_System::AddTemplate( pxTemplate );
#endif
	
	xStream.Skip4BytePadding();
	
	return true;
}

#ifdef ASURA_TOOLS

void Asura_Chunk_FSFX::Create( const Asura_FSFX_Template* const pxTemplate, Asura_Chunk_Stream& xStream )
{
	xStream.WriteChunk_Start( ASURA_CHUNK_FSFX, CHUNK_VERSION, 0 );
	pxTemplate->WriteToChunkStream( xStream );
	xStream.Write4BytePadding();
	xStream.WriteChunk_End();
}

#endif // ASURA_TOOLS

#endif	// ASURA_USE_FSFX
