/**
*
* \file Asura_Chunk_Font.h
*
* Created by James Paulin - 22/07/2002 12:32:15
*
* Copyright (C) 2002 Rebellion, All Rights Reserved.
*
* \brief
*
**/
#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif

#ifndef __ASURA_CHUNK_FONT_H__
#define __ASURA_CHUNK_FONT_H__

#include "ChunkSystem/Asura_Chunk_Loaders.h"

class Asura_Chunk_Stream;
class Asura_Font;
union Asura_Font_KerningData;
class Asura_SaveBlock;

class Asura_Chunk_Font : public Asura_Chunk_Header
{

	public:

#ifdef _FONTMAKER
		static void Create( const Asura_Font* Font, Asura_SaveBlock* saveBlock);
		static void Create( const Asura_Font* Font, Asura_Chunk_Stream& xStream);
#else
		bool Process(Asura_Handle fileHandle) const;
#endif

};

class Asura_Chunk_Font_Kerning : public Asura_Chunk_Header
{

public:

    enum { VERSION = 0 };

#ifdef _FONTMAKER
    static void Create( const Asura_Font_KerningData* pxKerningData, u_int uNumEntries, Asura_Chunk_Stream& xStream );
#else
    bool Process( Asura_Handle iFileHandle ) const;
#endif

};

#endif//__ASURA_CHUNK_FONT_H__
