//////////////////////////////////////////////////////////////////////////////
//
// Asura_Chunk_LipSync.cpp
//
// Created by Stuart Middleton - 20 June 2007
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

#include "Core/Asura.h"

#ifdef ASURA_USE_ARTICULATION_SYSTEM

#include "ChunkSystem/Asura_Chunk_LipSync.h"

bool Asura_Chunk_LipSync::Process( Asura_Handle iFileHandle ) const
{
	Asura_Chunk_File_Stream xStream(iFileHandle);
	return Asura_LipSync_Articulation::ReadArtData(xStream);
}


bool Asura_Chunk_LipSync::Process( const char* pcChunkBuffer ) const
{
	
	return true;
}

#ifdef ASURA_TOOLS

void Asura_Chunk_LipSync::Create( Asura_Chunk_SaveBlock_Stream& pxSaveBlock, Asura_LipSync_Articulation* pxLipArt)
{
	pxSaveBlock.SetSwapEndian(Tools_Level_Export::ShouldExportBigEndian());
	pxSaveBlock.WriteChunk_Start(ASURA_CHUNK_LIPSYNC_ARTICULATION, Asura_LipSync_Articulation::SS2_LIPSYNC_ARTICULATION_CHUNK_VERSION, 0);
	pxLipArt->WriteArtData(pxLipArt, pxSaveBlock);

	pxSaveBlock.WriteChunk_End();

}

void Asura_Chunk_LipSync::Create( Asura_Chunk_SaveBlock_Stream& pxSaveBlock, Asura_LipSync_Articulation* pxLipArt, int iLanguage)
{
	// Manually load the language version requested, save it and then unload it.
	char szNewPath[512];

	Tools_LipSync::GetLanguageVersionOfPath(szNewPath, pxLipArt->m_pszFilename.GetString(), iLanguage);

	// This will load it over our english version
	LoadAsuraFile(szNewPath);

	// Call the original save now we're loaded ourselves up with the foriegn version
	Create(pxSaveBlock, pxLipArt);

	// Reload the English one
	LoadAsuraFile(pxLipArt->m_pszFilename.GetString());
}

#endif

#endif
