//////////////////////////////////////////////////////////////////////////////
//
// Asura_Chunk_MaterialResponse.h
//
// Copyright (c) 2006 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

#if defined ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#if !defined __ASURA_CHUNK_MATERIALRESPONSE_H__
#define __ASURA_CHUNK_MATERIALRESPONSE_H__

#if defined ASURA_USE_MATERIAL_RESPONSE_SYSTEM

/******************************************************************************/
/* Included Files                                                             */
/******************************************************************************/

#include "ChunkSystem/Asura_Chunk_Loaders.h"
#include "Core/Asura_Handle.h"

/******************************************************************************/
/* Classes                                                                    */
/******************************************************************************/

class Asura_SaveBlock;
class Asura_HashTree;

////////////////////////////////////////////////////////////////////////////////
//
// Asura_Chunk_MaterialResponse
//
// Chunk containing material response properties
//
////////////////////////////////////////////////////////////////////////////////

class Asura_Chunk_MaterialResponse : public Asura_Chunk_Header
{
public:

	bool Process( const Asura_Handle iFileHandle );

#if defined ASURA_TOOLS
	static void Create( Asura_SaveBlock& xSaveBlock, Asura_HashTree* const pxMaterialsToExport, Asura_HashTree* const pxSlaveMaterialsToExport );
#endif

	static const int iCURRENT_VERSION;
};

#endif // defined ASURA_USE_MATERIAL_RESPONSE_SYSTEM

#endif // !defined __ASURA_CHUNK_MATERIALRESPONSE_H__
