#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __ASURA_CHUNK_MODULELINKING_H__
#define __ASURA_CHUNK_MODULELINKING_H__

#include "ChunkSystem/Asura_Chunk_Loaders.h"

class Asura_SaveBlock;

class Asura_Chunk_ModuleLinking : public Asura_Chunk_Header
{
public:
	bool Process(Asura_Handle fileHandle) const;
#ifdef ASURA_TOOLS
	static void Create(Asura_SaveBlock* saveBlock);
#endif

	int m_iNumberOfModules;
};

#ifdef ASURA_TOOLS
class Asura_Chunk_ModuleNames : public Asura_Chunk_Header
{
public:
	bool Process(Asura_Handle fileHandle) const;
	static void Create(Asura_SaveBlock* saveBlock);
	static void Create(Asura_Chunk_Stream& xStream);

	int m_iNumberOfModules;
};
#endif

class Asura_ModuleIndex_Conversion
{
public :
	static void ClearArray();

	static void CheckNumberOfModules(int oldNumberOfModules,int currentNumberOfModules);
	static int ConvertIndex(int moduleIndex);

#ifdef ASURA_TOOLS
    static bool DidNumberOfModulesChange( void ) { return s_bNumModulesChanged; }
#endif

private :
	static int m_iNumberOfModules;
	static int* ConversionArray;	
	static bool ConversionValid;
#ifdef ASURA_TOOLS
    static bool s_bNumModulesChanged;
#endif

	friend class Asura_Chunk_ModuleNames;
};

#endif //__ASURA_CHUNK_MODULELINKING_H__
