//
// Asura_Chunk_Navigation.h
//
// Created by Kevin Lea - 25/07/2001 17:06:59
// 
// Copyright (C) 2001 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __ASURA_CHUNK_NAVIGATION_H__
#define __ASURA_CHUNK_NAVIGATION_H__

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "ChunkSystem/Asura_Chunk_Loaders.h"
#include "Core/Asura_Handle.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class Asura_Chunk_Stream;
class Asura_SaveBlock;

// C L A S S E S /////////////////////////////////////////////////////////////

class Asura_Chunk_Navigation : public Asura_Chunk_Header
{
public:
	bool Process( Asura_Chunk_Stream& xStream ) const;
	bool Process( Asura_Handle hFile ) const;			// TO BE REMOVED
#ifdef ASURA_TOOLS
	static bool Create( Asura_Chunk_Stream& xStream );
#endif

private:
#ifdef ASURA_TOOLS
    bool ProcessOldVersions( Asura_Handle hFile ) const;
#endif

	enum ChunkFlags
	{
		ChunkFlag_IncludeUserDefinedWaypoints = 0x00000001,
		ChunkFlag_IncludeToolsInterZoneWaypoints = 0x00000002,
		ChunkFlag_IncludeAsuraInterZoneWaypoints = 0x00000004,
	};

	int m_iNumWaypoints;
	int m_iNumCoverpoints;
};

#endif//__ASURA_CHUNK_NAVIGATION_H__
