//
// Asura_Chunk_ResourceFile.h
//
// Created by Kevin Lea - 14/09/2001 11:21:59
// 
// Copyright (C) 2001 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __ASURA_CHUNK_RESOURCEFILE_H__
#define __ASURA_CHUNK_RESOURCEFILE_H__

#include "Asura_Chunk_Loaders.h"

class Asura_Chunk_ResourceFile : public Asura_Chunk_Header
{
public:
	bool Process(Asura_Handle fileHandle);
#ifdef ASURA_TOOLS
	void Create(int size, int flags, unsigned int type, unsigned int subtype, unsigned int filesize, int iVersion=0);	
#endif

	unsigned int Type;
	unsigned int SubType;
	unsigned int FileSize;

	// Can have a separate flag set for each resource type
	enum TextureFlags
	{
		TF_XBOX360_TEXTURE_XPR = 0x1,	// 360 texture chunk contains an .xpr instead of a .dds
		TF_SRGB                = 0x2,	// Texture is in sRGB space instead of linear
	};

	enum SoundFlags
	{
		SF_LOOPING = 0x1, // Sound loops (until stopped)
	};

	enum FilenameResourceFlags
	{
		FRF_LOCALISE_FILENAME = 0x1, // Indicates that the filename of the file to be loaded needs to be localised
	};

    
protected:

	#ifndef ASURA_USE_AUDIO_SYSTEM
	bool LoadSoundPropertiesFromResource(Asura_Handle iFileHandle);
	bool LoadSoundMappingsFromResource(Asura_Handle iFileHandle);
	#endif

    bool Platform_Process( Asura_Handle hFile, const char* szOriginalFileName );
    // (MP - 03.04.2002) TODO: Presumably we want a ProjectProcess() here too
    // eventually. I didn't really want to go adding it into every project at
    // the moment though.

};

enum ASURA_RESOURCEFILE_TYPE_ID
{
	ASURA_RESOURCEFILE_TYPE_PLATFORMSPECIFIC,
	ASURA_RESOURCEFILE_TYPE_PROJECTSPECIFIC,

	ASURA_RESOURCEFILE_TYPE_TEXTURE,
	ASURA_RESOURCEFILE_TYPE_SOUND,
	ASURA_RESOURCEFILE_TYPE_SOUNDPROPERTIES,
	ASURA_RESOURCEFILE_TYPE_SOUNDMAPPING,
	ASURA_RESOURCEFILE_TYPE_ASURAFILENAME,//resource is just a filename of a file to be loaded seperately
};

//sub-version number for soundmapping resource. RAR 27/07/2006
#define ASURA_RESOURCEFILE_SOUNDMAPPING_VERSION 1



#endif//__ASURA_CHUNK_RESOURCEFILE_H__
