//
// Asura_Chunk_Skybox.h
//
// Created by Kevin Lea - 02/10/2001 16:56:25
// 
// Copyright (C) 2001 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __ASURA_CHUNK_SKYBOX_H__
#define __ASURA_CHUNK_SKYBOX_H__

#include "ChunkSystem/Asura_Chunk_Loaders.h"

class Asura_Chunk_Stream;

enum 
{
	ASURA_CHUNK_SKYBOX_VERSION = 13,

	ASURA_CHUNK_SKYBOX_DRAW_CLOUD_FLAG				= 0x00000001,
	ASURA_CHUNK_SKYBOX_BACK_IS_FRONT_UPSIDE_DOWN	= 0x00000002,
	ASURA_CHUNK_SKYBOX_RIGHT_IS_LEFT_UPSIDE_DOWN	= 0x00000004,
	ASURA_CHUNK_SKYBOX_MIRROR_BELOW_HORIZON			= 0x00000008,
};

class Asura_Chunk_SkyBox : public Asura_Chunk_Header
{
	public:
		bool Process(Asura_Handle fileHandle);

		float m_fRed;
		float m_fGreen;
		float m_fBlue;
};

#if defined( ASURA_TARGET_SM3)
class Asura_Chunk_SkyBox_Shader : public Asura_Chunk_Header
{
public:
	bool Process(Asura_Handle fileHandle);

	float m_fRed;
	float m_fGreen;
	float m_fBlue;
};
#endif

#endif//__ASURA_CHUNK_SKYBOX_H__
