//
// Asura_Chunk_SoundEvent.h
//
// Created by Richard Rice - 10/07/2006
// 
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//

#ifndef __ASURA_CHUNK_SOUNDEVENT__
#define __ASURA_CHUNK_SOUNDEVENT__

#include "ChunkSystem/Asura_Chunk_Loaders.h"
#include "Network/Asura_Guid.h"

class Asura_Chunk_SoundEvent_Sample : public Asura_Chunk_Header
{
public :
	bool Process(class Asura_Chunk_Stream& xStream) const;
	bool Process(Asura_Handle iFileHandle) const;
#ifdef ASURA_TOOLS
	static void Create(const class Asura_Sound_Sample* pxSample,class Asura_Chunk_Stream& xStream);
	static void Create(const class Asura_Sound_Sample* pxSample,class Asura_SaveBlock* pxSaveBlock);
#endif


};


class Asura_Chunk_SoundEvent_Event : public Asura_Chunk_Header
{
public :
	bool Process(class Asura_Chunk_Stream& xStream) const;
	bool Process(Asura_Handle iFileHandle) const;
#ifdef ASURA_TOOLS
	static void Create(const class Asura_Sound_Event* pxEvent,class Asura_Chunk_Stream& xStream);
	static void Create(const class Asura_Sound_Event* pxEvent,class Asura_SaveBlock* pxSaveBlock);
#endif


};

class Asura_Chunk_SoundEvent_Mapping : public Asura_Chunk_Header
{
public :
	bool Process(class Asura_Chunk_Stream& xStream) const;
	bool Process(Asura_Handle iFileHandle) const;
#ifdef ASURA_TOOLS
	static void Create(const class Asura_Sound_Event* pxEvent,class Asura_Chunk_Stream& xStream);
	static void Create(const class Asura_Sound_Event* pxEvent,class Asura_SaveBlock* pxSaveBlock);
#endif


};


class Asura_Chunk_SoundEvent_Mixer : public Asura_Chunk_Header
{
public :
	bool Process(class Asura_Chunk_Stream& xStream) const;
	bool Process(Asura_Handle iFileHandle) const;
#ifdef ASURA_TOOLS
	static void Create(class Asura_Chunk_Stream& xStream);
	static void Create(class Asura_SaveBlock* pxSaveBlock);
#endif


};


class Asura_Chunk_SoundEvent_Phonon : public Asura_Chunk_Header
{
public :
	bool Process(class Asura_Chunk_Stream& xStream) const;
	bool Process(Asura_Handle iFileHandle) const;
#ifdef ASURA_TOOLS
	//extract a single phonon from the chunk , assigning it the new guid
	class Asura_Phonon* ProcessSinglePhonon(const char* pcChunkBuffer,Asura_Guid uOldGuid,Asura_Guid uNewGuid, bool bMissionFile) const;

	static void Create(class Asura_Chunk_Stream& xStream, bool bMissionFile);
	static void Create(class Asura_SaveBlock* pxSaveBlock, bool bMissionFile);
#endif

	enum ChunkFlags
	{
		ChunkFlag_HasToolsData = 0x00000001,
	};
private :
	void ProcessSinglePhonon(class Asura_Phonon* pxPhonon,Asura_Chunk_Stream& xStream) const;

};

class Asura_Chunk_SoundEvent_GlobalSettings : public Asura_Chunk_Header
{
public :
	bool Process(class Asura_Chunk_Stream& xStream) const;
	bool Process(Asura_Handle iFileHandle) const;

#ifdef ASURA_TOOLS
	static void Create(class Asura_Chunk_Stream& xStream);
	static void Create(class Asura_SaveBlock* pxSaveBlock);
#endif
};

#ifdef ASURA_TOOLS
class Asura_Chunk_SoundEvent_ToolsGlobalSettings : public Asura_Chunk_Header
{
public :
	bool Process(class Asura_Chunk_Stream& xStream) const;
	bool Process(Asura_Handle iFileHandle) const;

	static void Create(class Asura_Chunk_Stream& xStream);
	static void Create(class Asura_SaveBlock* pxSaveBlock);

};
#endif //ASURA_TOOLS

#endif //__ASURA_CHUNK_SOUNDEVENT__

//eof
