//
// Asura_Chunk_TiledTexture.h
//
// Created by Neil Massey - 26/07/2002 14:50:00
// 
// Copyright (C) 2002 Rebellion, All Rights Reserved.
//

#ifndef __ASURA_CHUNK_TILEDTEXTURE_H__
#define __ASURA_CHUNK_TILEDTEXTURE_H__

#include "Asura_Chunk_Loaders.h"

class Asura_Chunk_Stream;
class Asura_SaveBlock;
class Asura_TiledTextureInfo;

// #ifdef ASURA_TOOLS
class Asura_String;
// #endif

class Asura_Chunk_TiledTexture : public Asura_Chunk_Header
{
	public:
		bool Process( Asura_Handle xFileHandle ) const;

		 // A tools version of Process which fills a container with the original NameOfTextureUsed strings, as they are defined in the chunk file
		bool Process( Asura_Chunk_Stream& xStream,Asura_String* const pxTileNameBegin = NULL,Asura_String* const pxTileNameEnd = NULL ) const; 

#ifdef ASURA_TOOLS
		static void Create(const Asura_String &sTiledTextureName, int iNTiles, 
						   const Asura_TiledTextureInfo *pUVInfoList, Asura_SaveBlock& xSaveBlock); 
		static void Create(const Asura_String &sTiledTextureName, int iNTiles, 
						   const Asura_TiledTextureInfo *pUVInfoList, Asura_Chunk_Stream& xStream); 
#endif

		int	m_iNTiles;
};

// stream read operator for tiled texture info
const Asura_TiledTextureInfo& operator>>( Asura_Chunk_Stream& xStream,Asura_TiledTextureInfo& xOut );

#ifdef ASURA_TOOLS
const char* Tools_TT_StripPath( const Asura_String& xPath );
#endif

#endif
