
///////////////////////////////////////////////////////////////////////////////
//
// File   : Asura_ProcessChunkTimingList.h
// Author : Andy Tate
// Date   : 25-Jul-2006
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __ASURA_PROCESSCHUNKTIMINGLIST_H__
#define __ASURA_PROCESSCHUNKTIMINGLIST_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Core/Asura_HashTree.h"
#include "Core/Asura_Timers.h"
#include "ChunkSystem/Asura_Chunk_Loaders.h"

// Temporary...
#if !defined(ASURA_TOOLS) && !defined(ASURA_CHUNK_LOADERS_ALLOW_DEBUG_TIMING)
//#define ASURA_CHUNK_LOADERS_ALLOW_DEBUG_TIMING	1
#endif	// !defined(ASURA_TOOLS)


////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class        : Asura_ProcessChunkTimingList
// Author       : Andy Tate
// Date         : 25-Jul-2006
//
// Description  : Class to keep track of chunk timings.
////////////////////////////////////////////////////////////////////////////////

class Asura_ProcessChunkTimingList
{
public:
	// Public functions...
	static	void	Reset				(void)		{ s_xDurationTree.Reset(); }

	static	void	BeginTiming			(void);
	static	void	EndTiming			(const ASURA_CHUNKID eChunkID);

	static	void	OutputToDebugger	(const char* szFilename);


protected:
	// Protected variables...


	// Protected functions...


private:
	// Private variables...
	static	Asura_TickCount					s_xStartTickCount;
	static	Asura_TemplateHashTree<float>	s_xDurationTree;


	// Private functions...
	Asura_ProcessChunkTimingList  (void);
	Asura_ProcessChunkTimingList  (const Asura_ProcessChunkTimingList& xOther);
	~Asura_ProcessChunkTimingList ();

	Asura_ProcessChunkTimingList&	operator=	(const Asura_ProcessChunkTimingList& xOther);

};   // End of class 'Asura_ProcessChunkTimingList'.


#endif   // ifndef __ASURA_PROCESSCHUNKTIMINGLIST_H__


/// End of file. ///
