//////////////////////////////////////////////////////////////////////////////
//
// Asura_Chunk_Lipsync.h
//
// Created by Stuart Middleton - 20 June 2007
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////


#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifdef ASURA_USE_ARTICULATION_SYSTEM

#ifndef __ASURA_CHUNK_LIPSYNC_H__
#define __ASURA_CHUNK_LIPSYNC_H__

#include "ChunkSystem/Asura_Chunk_Macros.h"
#include "ChunkSystem/Asura_SaveBlock.h"
#include "FileAccess/Asura_FileAccess.h"

#include "ChunkSystem/Asura_Chunk_Loaders.h"

#include "LipSync/Asura_Lipsync_Manager.h"

class Asura_LipSync_Articulation;

class Asura_Chunk_LipSync : public Asura_Chunk_Header
{
public:

	enum{ CURRENT_VERSION = 0};
	bool Process( Asura_Handle iFileHandle ) const ;
	bool Process( const char* pcChunkBuffer )  const ;
#ifdef ASURA_TOOLS
	static void Create( Asura_Chunk_SaveBlock_Stream& pxSaveBlock, Asura_LipSync_Articulation* pxLipArt);
	static void Create( Asura_Chunk_SaveBlock_Stream& pxSaveBlock, Asura_LipSync_Articulation* pxLipArt, int iLanguage);
#endif

protected:
private:
};

#endif // __ASURA_CHUNK_LIPSYNC_H__
#endif // ASURA_USE_ARTICULATION_SYSTEM
