//
// Asura.h
//
// Created by Kevin Lea - 05/10/2001 15:09:32
// 
// Copyright (C) 2001 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __ASURA_H__
#define __ASURA_H__

// (MH - 17.07.2002) added these typedefs
typedef	unsigned char	u_char;
typedef	unsigned short	u_short;
typedef	unsigned int	u_int;
typedef	unsigned long	u_long;

// (MH - 17.07.2002) moved these from Asura_Maths.h
typedef signed char		int8;		// (ART - 09.06.05) Added
typedef signed short	int16;		// (ART - 09.06.05) Added
typedef signed int		int32;		// (ART - 09.06.05) Added

typedef unsigned char	uint8;		// (ART - 09.06.05) Added
typedef unsigned short	uint16;
typedef unsigned int	uint32;

// (MH - 16.05.2007) moved these from Asura_Handle.h, Asura_Hash.h, Asura_Guid.h
typedef int Asura_Handle;
typedef unsigned Asura_Hash_ID;
typedef unsigned Asura_Guid;

static const Asura_Handle ASURA_INVALID_HANDLE = -1;
static const Asura_Hash_ID ASURA_HASH_ID_UNSET = 0;

// (MH - 23.10.2002) standard includes for providing precprocessor defines without having
// to deal with the hideous user-interface of the MSVC project settings dialog. 
#include "ProjectSettings/Asura_EngineConfiguration.h" // platform-specific, per project

#include "Core/Compiler.h"

#include "Core/Asura_MemoryManagement.h"

#endif//__ASURA_H__
