////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __ASURA_MEM_TRACKER_H__
#define __ASURA_MEM_TRACKER_H__

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//#define ASURA_ENABLE_MEMTRACKER

#ifdef ASURA_ENABLE_MEMTRACKER

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define ASURA_MEMTRACKER_NUM_BUCKETS	(1000)

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

class Asura_MemTracker
{
	public:
		static Asura_MemTracker* GetInstance ();
		static void DestroyInstance ();

		static void Initialise_ConsoleCommands ();

		static void Render ();

		void AddAllocation (void* pAddress, unsigned int uSize, const bool bUse2ndTracker = false);
		void RemoveAllocation (void* pAddress, unsigned int uSize);

		void SetMemoryMin (const unsigned int uMemoryMin);
		void SetMemoryMax (const unsigned int uMemoryMax);

	private:
		Asura_MemTracker (); // Not externally instantiable
		Asura_MemTracker (Asura_MemTracker const&) {} // Not copyable
		Asura_MemTracker& operator= (Asura_MemTracker const&); // Not assignable

		void WalkProcessHeap ();

		static Asura_MemTracker* s_pxObject;

		static bool s_bShowMemTracker;

		unsigned int m_uMaxAllocations;

		unsigned int m_uMemoryMax;
		unsigned int m_uMemoryMin;

		float m_fBucketSize;

		float m_fCoefficient; // Used as a temporary to save calculating it every alloc/dealloc

		unsigned int m_auBuckets [ASURA_MEMTRACKER_NUM_BUCKETS];
};

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#endif // ASURA_ENABLE_MEMTRACKER

#endif // __ASURA_MEM_TRACKER_H__

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
