/**
*
* \file Asura_MemoryManagement_DebugOn.h
*
* Created by Kevin Lea - 01/11/2001 10:21:03
*
* Copyright (C) 2001 Rebellion, All Rights Reserved.
*
* \brief
*
**/

/// Kevin Lea - 08/12/2001 16:14:32 - Note! this file should NOT
/// be wrapped so they can only be included once - it may need
/// to be included multiple times.

// (MP - 14.11.2002) Fix Lint warning.
//lint -efile(766, Asura_MemoryManagement_DebugOn.h)

#ifdef ASURA_MEMORYMANAGEMENT_ENABLED

// (MP - 18.09.2002) Shut Lint up.
//lint -e652

#define new new( __FILE__, __LINE__, ASURA_PLATFORM_MEMORYMANAGEMENT_GETRETURNADDR() )

#define Asura_Allocate(numbytes) Asura_Allocate(numbytes, __FILE__, __LINE__, ASURA_PLATFORM_MEMORYMANAGEMENT_GETRETURNADDR())
#define Asura_Deallocate(addr) Asura_Deallocate(addr, __FILE__, __LINE__)

#define Asura_AllocateAlign(numbytes, align) Asura_AllocateAlign(numbytes, align, __FILE__, __LINE__, ASURA_PLATFORM_MEMORYMANAGEMENT_GETRETURNADDR())
#define Asura_DeallocateAlign(addr) Asura_DeallocateAlign(addr, __FILE__, __LINE__)

#define Asura_ResourceAllocateArray(rpxData, uNumEntries) Asura_ResourceAllocateArray(rpxData, uNumEntries, __FILE__, __LINE__, ASURA_PLATFORM_MEMORYMANAGEMENT_GETRETURNADDR())
#define Asura_ResourceDeallocateArray(rpxData) Asura_ResourceDeallocateArray(rpxData, __FILE__, __LINE__)
#define Asura_ResourceAllocateMemoryBlock(rpxData, uSizeInBytes, eAlignment) Asura_ResourceAllocateMemoryBlock(rpxData, uSizeInBytes, eAlignment, __FILE__, __LINE__, ASURA_PLATFORM_MEMORYMANAGEMENT_GETRETURNADDR())
#define Asura_ResourceDeallocateMemoryBlock(rpxData) Asura_ResourceDeallocateMemoryBlock(rpxData, __FILE__, __LINE__)

//lint +e652

#endif
