//
// Asura_StrippedHashedFilename.h
//
// Created by Richard Rice - 30/03/2007
// 
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __ASURA_STRIPPEDHASHEDFILENAME_H__
#define __ASURA_STRIPPEDHASHEDFILENAME_H__

#include "Core/Asura_String.h"


#ifdef ASURA_SUPPORT_PLATFORM_HASHED_FILENAMES
#include "Misc/Tools_Platform.h"
#endif

//Used as entry in stripped filename tree for Asura_HashedFilename_System
class Asura_StrippedHashedFilename
{
public :
	Asura_StrippedHashedFilename()
	{
		m_iFullIndex = -1;
		#ifdef ASURA_SUPPORT_PLATFORM_HASHED_FILENAMES
		for(int i=0;i<TOOLS_PLATFORM_NUM_PLATFORMS;i++)
		{
			m_aiPlatformIndex[i] = -1;
		}
		m_bHasPlatformVersions = false;
		#endif
	}

	Asura_String m_xStrippedFilename;
	int m_iFullIndex;//index into full filename array

	#ifdef ASURA_SUPPORT_PLATFORM_HASHED_FILENAMES
	//indeces for platform specific files.
	int m_aiPlatformIndex[TOOLS_PLATFORM_NUM_PLATFORMS];
	//true if any of the platform indeces are set
	bool m_bHasPlatformVersions;
	#endif	

};



#endif //__ASURA_STRIPPEDHASHEDFILENAME_H__