
///////////////////////////////////////////////////////////////////////////////
//
// File   : Asura_ResourceBank.cpp
// Author : Andy Tate
// Date   : 20-Jun-2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Core/Asura.h"

// This file's header...
#include "Core/Resources/Asura_ResourceBank.h"

// Asura independent header-files...
#include "Core/Resources/Asura_ResourceSet.h"


////////////////////////////////////////////////////////////////////////////////
// Constant declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Static variable declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Private functions...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Protected functions...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Public functions...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Function     : Asura_ResourceBank::~Asura_ResourceBank
// Author       : Andy Tate
// Date         : 23-Jun-2008
////////////////////////////////////////////////////////////////////////////////

Asura_ResourceBank::~Asura_ResourceBank()
{
	Asura_Texture_Management::Reset(m_uTextureResetGroup);
}

/// End of function 'Asura_ResourceBank::~Asura_ResourceBank'. ///



////////////////////////////////////////////////////////////////////////////////
// Function     : Asura_ResourceBank::SetTextureResetGroup
// Author       : Andy Tate
// Date         : 23-Jun-2008
////////////////////////////////////////////////////////////////////////////////

void Asura_ResourceBank::Initialise(const Asura_Hash_ID uHash,
									const char* szName,
									const u_int uTextureResetGroup)
{
	// Initialise the variables...
	m_uHash					= uHash;
	m_xName					= szName;
	m_uTextureResetGroup	= uTextureResetGroup;

	// Ensure that we're using this texture reset-group...
	Asura_Texture_Management::SetTextureResetGroup(uTextureResetGroup);
}

/// End of function 'Asura_ResourceBank::SetTextureResetGroup'. ///


/// End of file. ///
