//
// Asura_Cutscene_Camera_Shake.h
//
// Created by KOR - 05/02/2008
// 
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __ASURA_CUTSCENE_CAMERA_SHAKE_H__
#define __ASURA_CUTSCENE_CAMERA_SHAKE_H__

class Asura_Matrix_3x3;
class Asura_Chunk_Stream;

class Asura_Cutscene_Camera_Shake
{
	friend class Tools_CutsceneActor_Object;
	friend class Tools_Cutscene_Event_ChangeCameraShake;
public:
	Asura_Cutscene_Camera_Shake();
	~Asura_Cutscene_Camera_Shake() {}

	Asura_Cutscene_Camera_Shake& operator = (const Asura_Cutscene_Camera_Shake& xFrom);

	void CopyFrom(const Asura_Cutscene_Camera_Shake& xFrom);
	void Lerp(const Asura_Cutscene_Camera_Shake& xInput1, const Asura_Cutscene_Camera_Shake& xInput2, float fLambda);
	void ApplyShake(float fTime, float fSpeed, Asura_Matrix_3x3& xOrientation) const;
	void SaveToChunk(char*& pcChunkBuffer) const;
	void LoadFromChunk(Asura_Handle iFileHandle);
	void WriteToChunkStream(Asura_Chunk_Stream& xStream) const;
	void ReadFromChunkStream(Asura_Chunk_Stream& xStream);

	float GetFrequency() const { return m_fFrequency; }
	float GetPitch() const { return m_fPitch; }
	float GetYaw() const { return m_fYaw; }
	float GetRoll() const { return m_fRoll; }
	float GetSpeedScale() const { return m_fSpeedScale; }
	float GetMinScale() const { return m_fMinScale; }
	bool IsEnabled() const { return m_bEnabled; }

	void SetFrequency(float fFrequency) { m_fFrequency = fFrequency; }
	void SetPitch(float fPitch) { m_fPitch = fPitch; }
	void SetYaw(float fYaw) { m_fYaw = fYaw; } 
	void SetRoll(float fRoll) { m_fRoll = fRoll; }
	void SetSpeedScale(float fSpeedScale) { m_fSpeedScale = fSpeedScale; }
	void SetMinScale(float fMinScale) { m_fMinScale = fMinScale; }
	void SetEnabled(bool bEnabled) { m_bEnabled = bEnabled; }
protected:
	float m_fFrequency;
	float m_fPitch;
	float m_fYaw;
	float m_fRoll;
	float m_fSpeedScale;
	float m_fMinScale;
	union
	{
		u_int m_uFlags;
		struct  
		{
			u_int m_bEnabled : 1;
		};
	};
private:
	// Version 2 - 05/02/2008 - KOR - previous versions did not have a number, but started with 0 or 1 depending on enabled state.
	enum { CHUNK_VERSION = 2 };
};

#endif //__ASURA_CUTSCENE_CAMERA_SHAKE_H__
