//
// Asura_ServerEntity_EnvTextureAnimControl.h
//
// Created by Richard Rice - 24/05/2005
// 
// Copyright (C) 2005 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __ASURA_SERVERENTITY_ENVTEXTUREANIMCONTROL_H__
#define __ASURA_SERVERENTITY_ENVTEXTUREANIMCONTROL_H__

#include "Core/Asura_Hash.h"
#include "Entity/Asura_Entity.h"

#ifdef ASURA_TOOLS
#include "Entity/Asura_Entity_Classification.h"
#endif


//This entity is bound to a single texture animation used on the environment , and is used
//as a recipient for texture animation change messages.

class Asura_ServerEntity_EnvTextureAnimControl : public Asura_Entity_Server
{
	public :
		Asura_ServerEntity_EnvTextureAnimControl(Asura_Guid uGuid = ASURA_GUID_UNREGISTERED);
		Asura_ServerEntity_EnvTextureAnimControl(Asura_Guid, const char*& pcChunkBuffer);
		
		static void CreateFromChunkBuffer(Asura_Guid uGuid, const char*& pcChunkBuffer);
		
		// override of HasClientEntities() - we don't have any.
		virtual bool HasClientEntities() const { return false; }

		virtual bool HandleMessage(const Asura_Message* pxMessage);


		//virtual function overides for saving
		virtual bool CanBeSavedToChunk() const {return true;}
		virtual int GetChunkBufferSize();
		virtual void FillInChunkBuffer(char*& pcChunkBuffer);
		virtual void InitialiseFromChunkBuffer(const char*& pcChunkBuffer);

		virtual void WriteToChunkStream(Asura_Chunk_Stream& xStream) const;
		virtual void ReadFromChunkStream(Asura_Chunk_Stream& xStream);

		virtual void PostLoadInitialise();


		#ifdef ASURA_TOOLS
		virtual bool CanBeIncludedInTemplate() const {return Classification == AsuraEntityClass_EnvTextureAnimControl;}
		//virtual void ApplyChangesForTemplateInstance(class Tools_EntityTemplateInstance* pxInstance)
		#endif

		// Accessors
		Asura_Hash_ID GetAnimHash() const { return m_uAnimHash; }

	protected :
		virtual void MakeClientUpdateMessage(void);

		Asura_Hash_ID m_uAnimHash;
		u_int m_uSequence;
		float m_fSpeed;

	private :
	
		friend class Tools_Entity_EnvTextureAnimControl;
};


#endif //__ASURA_SERVERENTITY_ENVTEXTUREANIMCONTROL_H__
