//
// Asura_Entity_Classification.h
//
// Created by Richard Rice - 30/04/2002
// 
// Copyright (C) 2002 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __ASURA_ENTITY_CLASSIFICATION_H__
#define __ASURA_ENTITY_CLASSIFICATION_H__


//Note that values from this enumeration are saved out in the entity files , so
//changing existing entries would be a bad plan.
//-Richard.

enum ASURA_ENTITY_CLASSIFICATION
{
	AsuraEntityClass_NotSet							= 0,				//default value = 0

	AsuraEntityClass_TimeTrigger					= 1,
	AsuraEntityClass_VolumeTriggerRedundant			= 2,// (AW - 03.06.2004) - Class now removed
	AsuraEntityClass_CutsceneController				= 3,
    AsuraEntityClass_ServerCutscene					= 4,
    AsuraEntityClass_ServerCutsceneActorHierarchy	= 5,
	AsuraEntityClass_Glass							= 6,
	AsuraEntityClass_PhysicsObject					= 7,
	AsuraEntityClass_PickupObjectRedundant			= 8,// (MH - 25.09.2008) - Class removed
    AsuraEntityClass_DestructibleLight				= 9, // (WGP - 18/11/2008) - only in non SM3 builds

	AsuraEntityClass_ParticleGenerator				= 10,
	AsuraEntityClass_SplitterBlock					= 11,
    AsuraEntityClass_ServerCutsceneActorCamera		= 12,
    AsuraEntityClass_CountedTrigger					= 13,
    AsuraEntityClass_SoundController				= 14,
	AsuraEntityClass_DirectionalWind_UNUSED			= 15, // (MH - 25.09.2008) - class removed
	AsuraEntityClass_PointWind_UNUSED				= 16, // (MH - 25.09.2008) - class removed
	AsuraEntityClass_AdvancedLight					= 17, // (WGP - 18/11/2008) - only in non SM3 builds
    AsuraEntityClass_ServerCutsceneActorShape		= 18,
	AsuraEntityClass_Door_UNUSED					= 19, // (AAM - 02.09.2008) - Class now removed

	AsuraEntityClass_AdvancedVolumeTrigger			= 20,
	AsuraEntityClass_Lift							= 21,
    AsuraEntityClass_DamageVolume					= 22,
	AsuraEntityClass_SwitchObject_UNUSED			= 23, // (AAM - 21.11.2008) - class removed
	AsuraEntityClass_MusicTrigger					= 24,
	AsuraEntityClass_ExtendedParticleGenerator		= 25,
	AsuraEntityClass_Explosion						= 26,
	AsuraEntityClass_DirectionalWindVolume_UNUSED	= 27, // (MH - 25.09.2008) - class removed
	AsuraEntityClass_FMVTrigger						= 28,
	AsuraEntityClass_DebugObject_UNUSED				= 29, // (MH - 25.09.2008) - class removed

	AsuraEntityClass_MessageSniffer_UNUSED			= 30, // (MH - 25.09.2008) - class removed
	AsuraEntityClass_MetaMusicTrigger				= 31,
	AsuraEntityClass_MultiDamageVolume				= 32, 
	AsuraEntityClass_PFX_Effect						= 33,
	AsuraEntityClass_Template						= 34,
	AsuraEntityClass_LookAtTrigger					= 35,
    AsuraEntityClass_ClockTrigger					= 36,
    AsuraEntityClass_Ragdoll						= 37,
	AsuraEntityClass_LogicTrigger					= 38,
	AsuraEntityClass_Tannoy_UNUSED					= 39, // (MH - 25.09.2008) - class removed

	AsuraEntityClass_ClientVolumeTrigger			= 40,
	AsuraEntityClass_StartPoint						= 41,
	AsuraEntityClass_TimelineTrigger				= 42,
	AsuraEntityClass_EnvTextureAnimControl			= 43,
    AsuraEntityClass_CountedVolumeTrigger			= 44,
    AsuraEntityClass_Deformatron_UNUSED				= 45, // (MH - 25.09.2008) - class removed
	AsuraEntityClass_FSFX_Effect_UNUSED				= 46, // JGP 30/1/06 shouldn't be used but can't take out of list
	AsuraEntityClass_DebugMessageTrigger			= 47,
	AsuraEntityClass_AudioLocator					= 48,
	AsuraEntityClass_Fragment						= 49,

	AsuraEntityClass_Ephemeron						= 50,
	AsuraEntityClass_CameraVolume					= 51,
	AsuraEntityClass_ProxyTrigger					= 52,
    AsuraEntityClass_Node                           = 53,
    AsuraEntityClass_OrientedNode                   = 54,
    AsuraEntityClass_GamesceneNode                  = 55,
    AsuraEntityClass_CoverpointNode                 = 56,
    AsuraEntityClass_GuardZone                      = 57,
    AsuraEntityClass_AttractorNode                  = 58,
    AsuraEntityClass_Spline                         = 59,

    AsuraEntityClass_GamesceneSpline                = 60,
    //actually needs its own for derivative tests
    AsuraEntityClass_GamesceneBase                  = 61,
	AsuraEntityClass_DialogueTrigger				= 62,
	AsuraEntityClass_LiftNode						= 63,
	AsuraEntityClass_LiftSpline						= 64,

	AsuraEntityClass_Affector						= 65,
	AsuraEntityClass_Affector_Wind					= 66,
	AsuraEntityClass_Projector						= 67,	
	AsuraEntityClass_Teleporter						= 68,
	AsuraEntityClass_TeleportDestination			= 69,

	AsuraEntityClass_DebugWaypointTrigger			= 70,

	AsuraEntityClass_DynamicLight					= 71,

	AsuraEntityClass_ForceField_Conveyor			= 72,

	AsuraEntityClass_AttractorController			= 73,
	AsuraEntityClass_ConsoleVar						= 74,

	AsuraEntityClass_LightShaft						= 75,
	AsuraEntityClass_StreamingBackgroundSoundController = 76,

	AsuraEntityClass_WaypointBlockerVolume			= 77,

	AsuraEntityClass_VolumeTrigger					= 78,

	AsuraEntityClass_Objective						= 79,

	AsuraEntityClass_GS2Node						= 80,
	AsuraEntityClass_GS2Spline						= 81,
	AsuraEntityClass_GS2Attractor					= 82,

	AsuraEntityClass_Container						= 83,

	AsuraEntityClass_DynamicMusicTrigger			= 84,

	AsuraEntityClass_DialogueController				= 85,

	AsuraEntityClass_FMVController					= 86,
	AsuraEntityClass_EffectVolume					= 87,

	AsuraEntityClass_FMVSpeaker						= 88,

	// KOR - 23/03/2006 - please remember to add any new entries to
	// Asura_Network::GetEntityClassificationDesc() in Asura_Network.cpp
	//
	// (MH - 06.01.2004) last entry used to convert project range from 
	// [32768,(32768 + num_project_entries)] to range next in sequence 
	// i.e. [AsuraEntityClass_LastEngineClassification - 
	// (AsuraEntityClass_LastEngineClassification + num_project_entries)]
	// when sending data over the network.
	AsuraEntityClass_LastEngineClassification,
    
	//first id for project specific entities
	AsuraEntityClass_ProjectSpecific = 0x8000,
};


#endif //__ASURA_ENTITY_CLASSIFICATION_H__
