//////////////////////////////////////////////////////////////////////////////
//
// Asura_ServerEntity_ServerCutscene.cpp
//
// Created by Mike Healey.
//
// Copyright (c) 2002 Rebellion. All rights reserved.
//
// Entity to control cutscenes that run on the server. 
//
//////////////////////////////////////////////////////////////////////////////

#include "Core/Asura.h"

#ifdef ASURA_SUPPORT_SERVERCUTSCENES	// the Gunfighter-style cutscenes with entities

#include "Entity/Cutscene/Asura_ServerEntity_ServerCutscene.h"

//#include "Asura_Message.h"
//#include "Asura_Cutscene_System.h"
//#include "Asura_Cutscene.h"
//#include "Asura_TextureManagement.h"
#include "Debugging/Asura_Assert.h"
#include "Entity/Asura_Entity_Classification.h"
//
//#include "Asura_Network.h"


Asura_ServerEntity_ServerCutscene::Asura_ServerEntity_ServerCutscene(const Asura_String& cutsceneName,Asura_Guid guid /*= ASURA_GUID_UNREGISTERED*/)
: Asura_Entity_Server(guid)
{
	Classification = AsuraEntityClass_ServerCutscene;
	CutsceneName = cutsceneName;
}

Asura_ServerEntity_ServerCutscene::Asura_ServerEntity_ServerCutscene(Asura_Guid guid,const char*& chunkBuffer)
:Asura_Entity_Server(guid)
{
	Classification = AsuraEntityClass_ServerCutscene;

	//check the version
	int version;
	ASURA_CHUNK_EXTRACT( chunkBuffer, version,int);
	Asura_Assert(version==0,"");

	//read in the rest
	ASURA_CHUNK_EXTRACT_STRING(chunkBuffer, CutsceneName);
}

Asura_ServerEntity_ServerCutscene::~Asura_ServerEntity_ServerCutscene()
{
}


bool Asura_ServerEntity_ServerCutscene::HandleMessage(const Asura_Message* pxMessage)
{
	Asura_Assert(pxMessage,"");
	if (!pxMessage) return false;

//		switch(pxMessage->GetMsgID())
//		{
//			case ASURA_MSG_ACTIVATE:
//			{
//				//get the index for this cutscene
//				int cutsceneIndex = Asura_Cutscene_System::GetCutsceneIndex(CutsceneName);
//				Asura_Assert(cutsceneIndex>=0,"Failed to find cutscene");
//				if(cutsceneIndex<0) break;//giveup
//
//				//fill in the index in the data part of the messafe
//				Asura_Message* m = Asura_Network::CreateMessage(ASURA_MSG_CUTSCENECONTROLLER_ACTIVATE,sizeof(unsigned short));
//				void* data = m->GetData();
//				*(unsigned short*)data = (unsigned short)cutsceneIndex;
//
//		 		m->To = ASURA_GUID_MY_CLIENT_ENTITIES;
//				m->From = Guid;
//
//				Asura_Network::Send(m);
//				return true;
//			}
//			case ASURA_MSG_DEACTIVATE:
//			{
//				Asura_Message* m = Asura_Network::CreateMessage(ASURA_MSG_DEACTIVATE);
//		 		m->To = ASURA_GUID_MY_CLIENT_ENTITIES;
//				m->From = Guid;
//
//				Asura_Network::Send(m);
//				return true;
//			}
//			default:
//			{
//				Asura_Assert(0,"Unhandled message");
//				break;
//			}
//		
//		}

	// Pass to parent?
	return false;
}

int Asura_ServerEntity_ServerCutscene::GetChunkBufferSize()
{
	int chunkSize = 0;
	ASURA_CHUNK_SIZE(chunkSize, version ,int);
	ASURA_CHUNK_SIZE_STRING(chunkSize,CutsceneName);
	return chunkSize;
}

void Asura_ServerEntity_ServerCutscene::FillInChunkBuffer(char*& chunkBuffer)
{
	int version = 0;
	ASURA_CHUNK_FILLANDVERIFY( chunkBuffer, version,int);
	ASURA_CHUNK_FILL_STRING(chunkBuffer, CutsceneName);
}
#endif // #ifdef ASURA_SUPPORT_SERVERCUTSCENES	// the Gunfighter-style cutscenes with entities
