

///////////////////////////////////////////////////////////////////////////////
//
// File   : Asura_DynamicLight_Messages.h
// Author : Dave Reed
// Date   : 22-Apr-2007
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __ASURA_DYNAMICLIGHT_MESSAGES_H__
#define __ASURA_DYNAMICLIGHT_MESSAGES_H__


////////////////////////////////////////////////////////////////////////////////
// Class        : Asura_Message_DynamicLight_Fade
// Author       : Dave Reed
// Date         : 22/04/07
//
// Description  : Message telling a light to start a fade
////////////////////////////////////////////////////////////////////////////////

#define ASURA_DYNAMICLIGHT_FADE_FLAG_USECOLOUR		(1<<0)
#define ASURA_DYNAMICLIGHT_FADE_FLAG_USERANGE		(1<<1)
#define ASURA_DYNAMICLIGHT_FADE_FLAG_USEINTENSITY	(1<<2)
#define ASURA_DYNAMICLIGHT_FADE_FLAG_ACTIVATE		(1<<3)
#define ASURA_DYNAMICLIGHT_FADE_FLAG_DEACTIVATE		(1<<4)


class Asura_Message_DynamicLight_Fade
{
public:	
	float			m_fTargetR;
	float			m_fTargetG;
	float			m_fTargetB;
	float			m_fTargetRange;
	float			m_fTargetIntensity;
	float			m_fDuration;
	uint32			m_uFlags;

};   // End of class 'Asura_Message_Teleport'.


#endif //__ASURA_DYNAMICLIGHT_MESSAGES_H__
