//
// Asura_FMVController_Messages.h
//
// Created by JCT - 22 Dec 2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_FMVCONTROLLER_MESSAGES_H__
#define __ASURA_FMVCONTROLLER_MESSAGES_H__

#include "Core/Asura.h"
#include "ChunkSystem/Asura_Chunk_Stream.h"

class Asura_ServerEntity_FMVController;

class Asura_Message_FMVController_ClientCreate
{
public:
	friend class Asura_ClientEntity_FMVController;

	void FillFMVController(Asura_ServerEntity_FMVController* pxServer); 

private:
	static const unsigned int s_FMVNameLength = 48;

	char			m_szFMVName[s_FMVNameLength];
	unsigned int	m_uFlags;
};

class Asura_Msg_FMV_Controller_Play
{
public:
	enum { CURRENT_VERSION = 0 };
	unsigned int m_uVersion;

	void Initialise()
	{
		m_uVersion      = CURRENT_VERSION;
	}
};

class Asura_Msg_FMV_Controller_Pause
{
public:
	enum { CURRENT_VERSION = 0 };
	unsigned int m_uVersion;

	void Initialise()
	{
		m_uVersion      = CURRENT_VERSION;
	}
};

#endif	//__ASURA_FMVCONTROLLER_MESSAGES_H__