/**
*
* \file Asura_Entity_Glass_Messages.h
*
* Created by Andrew Weinkove - 18/07/2002
*
* Copyright (C) 2002 Rebellion, All Rights Reserved.
*
* \brief
*
**/
#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif

#ifndef __ASURA_ENTITY_GLASS_MESSAGES_H__
#define __ASURA_ENTITY_GLASS_MESSAGES_H__

#include "Core/Asura_Maths.h"

#include "Entity/Glass/Asura_WorldSpace_Rectangle.h"
#define ASURA_ENTITY_GLASS_DEFAULT_COLOUR 0x70afafff

////////////////////////////////////
// Asura_Message_Glass_ApplyDecal //
////////////////////////////////////
class Asura_Message_Glass_ApplyDecal
{
public:
	Asura_Vector_2 m_xDecalCoordinates;
};

///////////////////////////////////////////
// Asura_Message_Glass_SmashWithPosition //
///////////////////////////////////////////
class Asura_Message_Glass_SmashWithPosition
{
public:
	Asura_Vector_2 m_xHitCoordinates;
	float m_fPower;	// Arbitrary units - values between 0 and 1.
	Asura_Vector_3 m_xDirection;
};

///////////////////////////////
// Asura_Message_Glass_Smash //
///////////////////////////////
class Asura_Message_Glass_Smash
{
public:
	void Initialise()
	{
		m_fPower = 0.5f;
		m_bSmashInPositiveZDir = true;
	}

	float m_fPower; // Arbitrary units - values between 0 and 1.

	union
	{
		u_int	m_uFlags;

		struct
		{
			// NOTE: These bit's are written out, adding any new bits means
			// ~~~~~ that you will need to add those bits to the bitfield
			//       preparation code in "WriteToChunkStream".
			u_int	m_bSmashInPositiveZDir	: 1; // Which way out does it smash? Is the Z co-ordinate positive? (from the point of view of the glass)
		};
	};
};

#endif//__ASURA_ENTITY_GLASS_MESSAGES_H__
