#ifdef ASURA_USE_AXON
//////////////////////////////////////////////////////////////////////////////
//
// Asura_ServerNode_GuardZone.h
//
// (TI - 09.11.2006)
//
// Copyright (c) 2006 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef ASURA_SERVERNODE_GUARDZONE_H___
#define ASURA_SERVERNODE_GUARDZONE_H___ 1

// I N C L U D E S ///////////////////////////////////////////////////////////

// asura
#include "Entity/Locations/Asura_ServerEntity_Node.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class Asura_Message;
class Asura_OrientedVolume;
class Asura_ServerNode_OrientedNode;

//////////////////////////////////////////////////////////////////////////////
//
// Asura_ServerNode_GuardZone
//
//////////////////////////////////////////////////////////////////////////////

class Asura_ServerNode_GuardZone : public Asura_ServerEntity_Node
{
private:
	typedef Asura_ServerEntity_Node PARENT;
	friend class Tools_EntityNode_GuardZone;
	friend class Tools_GuardZone_VolumeEdit_Controller;
    friend class Tools_Object_Axon_Verification;

public:
	Asura_ServerNode_GuardZone( Asura_Guid uGuid );
	virtual ~Asura_ServerNode_GuardZone();

	static void CreateFromChunkStream( Asura_Guid uGuid, Asura_Chunk_Stream& xStream );
	virtual void WriteToChunkStream( Asura_Chunk_Stream& xStream ) const;
	virtual	void ReadFromChunkStream( Asura_Chunk_Stream& xStream );

	float GetRadius() const { return m_fRadius; }
	Asura_ServerNode_OrientedNode* GetRandomUnoccupiedGuardPoint() const;
    int                            GetNumGuardPoints() const { return m_iNumGuardPoints; }
    Asura_Guid                     GetGuardPointGuid( const int iIndex ) const 
    { 
        return iIndex < m_iNumGuardPoints ? m_puGuardPointGuids[ iIndex ] : ASURA_GUID_UNREGISTERED; 
    }

	virtual bool IsBaseOrDerivativeOf( u_short usClassification ) const;

#ifdef ASURA_TOOLS
	virtual void ApplyChangesForTemplateInstance( class Tools_EntityTemplateInstance* pxInstance );
	virtual bool CanBeIncludedInTemplate() const;
	static  void CreateFromTools( Asura_Guid uGuid ) { new Asura_ServerNode_GuardZone( uGuid ); }
	void AddGuardPoint( Asura_Guid uGuid );
	virtual bool RemoveGuardPoint( Asura_Guid uGuid );
#endif

protected:
	int m_iNumGuardPoints;
	Asura_Guid* m_puGuardPointGuids;

	//simple sphere volume
	float m_fRadius;

	//advanced multiple volumes
	bool m_bUseAdvancedVolumes;
	int  m_iNumVolumes;
	Asura_OrientedVolume* m_pxVolumes;

private:
	enum { CURRENT_CHUNK_VERSION = 2 };
};

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

#endif // #ifndef ASURA_SERVERNODE_GUARDZONE_H___
#endif //ASURA_USE_AXON
