//
// Asura_Entity_PFX_Effect_Data.h
//
// Created by KOR - 25/01/2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif

#ifndef __ASURA_ENTITY_PFX_EFFECT_DATA_H__
#define __ASURA_ENTITY_PFX_EFFECT_DATA_H__

#include "SpecialFX/PFX/Asura_PFX_Volume.h"

// Constants

// Version 1 - 28/01/2008 - KOR - added splines
static const u_int uASURA_ENTITY_PFX_EFFECT_DATA_VERSION = 1;

// Forward defines
class Asura_Chunk_Stream;
class Asura_Matrix_3x3;
class Asura_Vector_3;
template <typename T> class Asura_Spline;

class Asura_Entity_PFX_Effect_Data
{
public:
	Asura_Entity_PFX_Effect_Data();
	virtual ~Asura_Entity_PFX_Effect_Data();

	Asura_Entity_PFX_Effect_Data& operator = (const Asura_Entity_PFX_Effect_Data& xOriginal);

	// Server effect stores its own pos and ori, whereas the client uses the renderable pos and ori
	virtual	void ReadFromChunkStream(Asura_Chunk_Stream& xStream, Asura_Vector_3& xPos, Asura_Matrix_3x3& xOri);
	virtual	void WriteToChunkStream(Asura_Chunk_Stream& xStream, const Asura_Vector_3& xPos, const Asura_Matrix_3x3& xOri) const;

#ifdef ASURA_TOOLS
	virtual void ApplyChangesForTemplateInstance(class Tools_EntityTemplateInstance* pxInstance);
#endif
		
	// Property members
	Asura_Hash_ID				m_uEffectTemplateHash;

	// Collision plane
	Asura_Vector_3				m_xCollisionPosition;
	Asura_Vector_3				m_xCollisionDirection;

	// An optional over-riding source volume
	Asura_PFX_Volume			m_xSourceVolume;

	float						m_fMinRetriggerTime;
	float						m_fMaxRetriggerTime;

	Asura_Spline<Asura_Vector_3>* m_pxSpline;

	// State members
	union
	{
		u_int			m_uFlags;
		struct
		{
			// NOTE: These bit's are written out, adding any new bits means
			// ~~~~~ that you will need to add those bits to the bitfield
			//       preparation code in "WriteToChunkStream".
			u_int		m_bOldActiveFlag		: 1;
			u_int		m_bIgnoreModuleLinking	: 1;
			u_int		m_bSkyboxEffect			: 1;
			u_int		m_bWaterDistorterEffect : 1;
			u_int		m_bUsesSpline		    : 1;
		};
	};
};

#endif//__ASURA_ENTITY_PFX_EFFECT_DATA_H__
