// Asura_ApplyForce_Messages.h
// Emil Popovic- 22.4.09
// Copyright (C) 2008 Rebellion, All Rights Reserved.

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef ___ASURA_APPLYFORCE_MESSAGES_H___
#define ___ASURA_APPLYFORCE_MESSAGES_H___

#include "Core/Asura_Maths.h"
class Asura_Chunk_Stream;

class Asura_Msg_ApplyForce_Linear
{
public:
	u_int			m_uVersion;
	Asura_Vector_3	m_xOffsetFromCentreOfMass;
	Asura_Guid		m_uSourcePosObjectGuid;		// This guid is used to get position from which the force "emerge". It is because, that some objects don't have position at all, so that means, we have to specify object (by this guid) which has a position and this position will be used as a source position.
	Asura_Hash_ID	m_uExtraInfoBPHash;

	void SetDefaults ();
	void WriteToChunkStream(Asura_Chunk_Stream& xStream) const;

	enum { CURRENT_VERSION = 0 };
};


class Asura_Msg_ApplyForce_Radial
{
public:
	u_int			m_uVersion;
//	Asura_Vector_3	m_xPositionOfSource;		// Position of source of force. It might be different that position of the object that is actually sending this message.
	Asura_Guid		m_uSourcePosObjectGuid;		// This guid is used to get position from which the force "emerge". It is because, that some objects don't have position at all, so that means, we have to specify object (by this guid) which has a position and this position will be used as a source position.
	Asura_Hash_ID	m_uExtraInfoBPHash;			// Lot of additional info, that will be used to process the message and process and create result.

	void SetDefaults ();
	void WriteToChunkStream(Asura_Chunk_Stream& xStream) const;

	enum { CURRENT_VERSION = 0 };
};



class ApplyForceMsg_ImpulseData
{
public:
	ApplyForceMsg_ImpulseData()	
		: m_fNearDamage(0.0f)
		, m_fFarDamage(0.0f)
		, m_fNearRange(0.0f)
		, m_fFarRange(0.0f)
		, m_fNearImpulse(0.0f)
		, m_fFarImpulse(0.0f)
		, m_iDamageType(0)
		, m_uPlayPFXHash(ASURA_HASH_ID_UNSET)
		, m_uPlaySoundHash(ASURA_HASH_ID_UNSET)
	{
	}

	bool  FillFromBlueprint( const Asura_Hash_ID uExtraInfoBPHash );
	float CalculateImplusePower( float fLength );

	float m_fNearDamage;
	float m_fFarDamage;
	float m_fNearRange;
	float m_fFarRange;
	float m_fNearImpulse;
	float m_fFarImpulse;
	int   m_iDamageType;
	Asura_Hash_ID m_uPlayPFXHash;
	Asura_Hash_ID m_uPlaySoundHash;
};


#endif //___ASURA_APPLYFORCE_MESSAGES_H___