//////////////////////////////////////////////////////////////////////////////
//
// Asura_ClientEntity_StartPoint.h
//
// Copyright (c) 2005 Rebellion. All rights reserved.
//
// Description:
//
//     Player start point entity
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef ___ASURA_CLIENTENTITY_STARTPOINT_H___
#define ___ASURA_CLIENTENTITY_STARTPOINT_H___ 1

#include "Entity/Asura_Entity.h"

class Asura_ClientEntity_StartPoint : public Asura_Entity_Client
{
protected:
	Asura_ClientEntity_StartPoint(Asura_Guid uGuid);
	virtual ~Asura_ClientEntity_StartPoint();

public:
	virtual	void ReadFromChunkStream( Asura_Chunk_Stream& xStream );
	
	Asura_Vector_3& GetPosition()					{ return m_xPosition; }
	const Asura_Vector_3& GetPosition() const		{ return m_xPosition; }
	Asura_Matrix_3x3& GetOrientation()				{ return m_xOrientation; }
	const Asura_Matrix_3x3& GetOrientation() const	{ return m_xOrientation; }

	static void Create( Asura_Guid uGuid, Asura_Chunk_Stream& xStream );
	static Asura_ClientEntity_StartPoint* FindEntity( Asura_Guid uGuid )		   { return s_xList.FindEntity(uGuid); }
	static const Asura_Hashed_List<Asura_ClientEntity_StartPoint>* GetList( void ) { return &s_xList; }

	#ifdef ASURA_TOOLS
	virtual void ApplyChangesForTemplateInstance(class Tools_EntityTemplateInstance* pxInstance);
	#endif

protected:
	Asura_Vector_3 m_xPosition;
	Asura_Matrix_3x3 m_xOrientation;

private:
	static Asura_Hashed_List<Asura_ClientEntity_StartPoint> s_xList;
};

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

#endif // #ifndef ___ASURA_CLIENTENTITY_STARTPOINT_H___
