//////////////////////////////////////////////////////////////////////////////
//
// Asura_ServerEntity_StartPoint.h
//
// Copyright (c) 2005 Rebellion. All rights reserved.
//
// Description:
//
//     Player start point entity
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef ___ASURA_SERVERENTITY_STARTPOINT_H___
#define ___ASURA_SERVERENTITY_STARTPOINT_H___ 1

#include "Entity/Asura_Entity.h"

#ifdef ASURA_TOOLS
#include "Entity/Asura_Entity_Classification.h"
#endif


class Asura_ServerEntity_StartPoint : public Asura_Entity_Server
{
protected:
	Asura_ServerEntity_StartPoint(Asura_Guid uGuid);
	virtual ~Asura_ServerEntity_StartPoint();

		virtual	bool	IsFilledFromChunkBuffer() const							{ return false; }
		virtual bool 	CanBeSavedToChunk() const								{ return true; }

		virtual	void	ReadFromChunkStream(Asura_Chunk_Stream& xStream);
		virtual	void	WriteToChunkStream(Asura_Chunk_Stream& xStream) const;

public:
	static void Create(Asura_Guid uGuid, Asura_Chunk_Stream& xStream);

	Asura_Vector_3& GetPosition()												{ return m_xPosition; }
	const Asura_Vector_3& GetPosition() const									{ return m_xPosition; }
	Asura_Matrix_3x3& GetOrientation()											{ return m_xOrientation; }
	const Asura_Matrix_3x3& GetOrientation() const								{ return m_xOrientation; }

	static Asura_ServerEntity_StartPoint* Create(Asura_Guid uGuid);
	static Asura_ServerEntity_StartPoint* FindEntity(Asura_Guid uGuid)			{ return s_xList.FindEntity(uGuid); }
	static const Asura_Hashed_List<Asura_ServerEntity_StartPoint>* GetList()	{ return &s_xList;	}

	#ifdef ASURA_TOOLS
	virtual bool CanBeIncludedInTemplate() const {return Classification == AsuraEntityClass_StartPoint;}
	virtual void ApplyChangesForTemplateInstance(class Tools_EntityTemplateInstance* pxInstance);
	#endif

protected:
	Asura_Vector_3 m_xPosition;
	Asura_Matrix_3x3 m_xOrientation;

private:
	enum { CURRENT_CHUNK_VERSION = 2 };

	static Asura_Hashed_List<Asura_ServerEntity_StartPoint> s_xList;

	friend class Tools_System;
	friend class Tools_Entity_StartPoint;
	friend class Asura_ClientEntity_StartPoint;
};

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

#endif // #ifndef ___ASURA_SERVERENTITY_STARTPOINT_H___
