//
// Asura_ClientEntity_ClientVolumeTrigger.cpp
//
// Created by Richard Rice - 22/11/2004
// 
// Copyright (C) 2004 Rebellion, All Rights Reserved.
//

#include "Core/Asura.h"
#include "Entity/Triggers/Asura_ClientEntity_ClientVolumeTrigger.h"

#include "Camera/Asura_Camera.h"
#include "Debugging/Asura_Assert.h"
#include "Entity/Asura_Entity_Classification.h"


Asura_ClientEntity_ClientVolumeTrigger::Asura_ClientEntity_ClientVolumeTrigger(Asura_Guid uGuid)
:Asura_ClientEntity_AdvancedVolumeTrigger(uGuid)
{
	Classification = AsuraEntityClass_ClientVolumeTrigger;
}

Asura_ClientEntity_ClientVolumeTrigger::Asura_ClientEntity_ClientVolumeTrigger(Asura_Guid uGuid,const char*& pcChunkBuffer)
:Asura_ClientEntity_AdvancedVolumeTrigger(uGuid,pcChunkBuffer)
{
	Classification = AsuraEntityClass_ClientVolumeTrigger;
	
	//check the version
	int iVersion;
	ASURA_CHUNK_EXTRACT( pcChunkBuffer, iVersion, int );
    Asura_Assert( iVersion <= 0,"Asura_ClientEntity_ClientVolumeTrigger - incompatible chunk version number");

}

bool Asura_ClientEntity_ClientVolumeTrigger::IsVolumeOccupied()
{
	for(int i=0;i<Asura_Camera::GetNumberOfCameras();i++)
	{
		Asura_Camera::SetCameraIndex(i);
		if(Asura_Camera::IsCameraActive())
		{
			if(Contains(*Asura_Camera::GetPosition()))
			{
				return true;
			}
		}
	}
	return false;
}

void Asura_ClientEntity_ClientVolumeTrigger::Update()
{
	Asura_ClientEntity_AdvancedVolumeTrigger::Update();
	
	//If volume has become deactivated while triggered , then un-trigger it now.
	//Since these volumes are intended to trigger special effects while within the are covered,
	//it is likely that the effect should be stopped if the volume stops being used.
	if(m_bHasAlreadyTriggered && !m_bActive)
	{
		m_bHasAlreadyTriggered = false;
		OnUnTrigger();
	}

}
