//
// Asura_ClientEntity_Trigger.h
//
// Created by Richard Rice - 22/11/2004
// 
// Copyright (C) 2004 Rebellion, All Rights Reserved.
//


#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __ASURA_CLIENTENTITY_TRIGGER_H__
#define __ASURA_CLIENTENTITY_TRIGGER_H__

#include "Entity/Triggers/Asura_ClientEntity_Activatable.h"
#include "Entity/Triggers/Asura_ServerEntity_Trigger.h"

class Asura_ClientEntity_Trigger : public Asura_ClientEntity_Activatable
{
	friend class Tools_Entity_Trigger_Object;

	public :
		Asura_ClientEntity_Trigger(Asura_Guid uGuid,const char*& pcChunkBuffer);
		Asura_ClientEntity_Trigger(Asura_Guid uGuid);
		~Asura_ClientEntity_Trigger();
		virtual void ReadFromChunkStream(Asura_Chunk_Stream& xStream);

		virtual void Update();

	protected :
		/// Kevin Lea - 16/04/2002 10:37:44 - this trigger method is the core
		/// functionality for derived classes.
		virtual bool IsTriggered(void) = 0;
		virtual bool IsUnTriggered(void) {return false;}
		/// Kevin Lea - 22/04/2002 10:46:21 - Reset is called when object is made active (e.g. to trigger logic)
		virtual void Reset(void){};

		//virtual function overides from Activatable
		virtual void OnActivation();
		virtual void OnDeactivation();
		virtual void OnTrigger();
		virtual void OnDestruction();
		virtual void OnUnTrigger();

		//Indicates that the message blocks contain messages that can be sent on the client
		virtual bool SendMessagesOnClient(){return false;}


		void SendMessages(enum ASURA_TRIGGER_ENTITY_STATE state);

		unsigned short MessageBlock[ASURA_TRIGGER_ENTITY_NOOFSTATES];

};


#endif //__ASURA_CLIENTENTITY_TRIGGER_H__ 
