// Asura_ServerEntity_DynamicMusicTrigger.h
// Thomas Young - 14.08.08
// Copyright (C) 2008 Rebellion, All Rights Reserved.

// F I L E   W R A P P E R ///////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_SERVERENTITY_DYNAMICMUSICTRIGGER_H__
#define __ASURA_SERVERENTITY_DYNAMICMUSICTRIGGER_H__

#ifdef ASURA_SUPPORT_DYNAMIC_MUSIC_SYSTEM

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "Entity/Triggers/Asura_ServerEntity_Activatable.h"
#include "Entity/Triggers/Asura_ServerEntity_Trigger.h"

#ifdef ASURA_TOOLS
#include "Entity/Asura_Entity_Classification.h"
#endif

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class Asura_Dynamic_Music_Trigger_Data;

// C L A S S   D E C L A R A T I O N S ///////////////////////////////////////

class Asura_ServerEntity_DynamicMusicTrigger : public Asura_ServerEntity_Trigger
{
	friend class Tools_Entity_DynamicMusicTrigger_Object;
	friend class Tools_Overlay_DynamicMusic;
	friend class Asura_Dynamic_Music_System;

	public :
	
		Asura_ServerEntity_DynamicMusicTrigger			(bool bActive = true);
		Asura_ServerEntity_DynamicMusicTrigger			(Asura_Guid uGuid);
		virtual ~Asura_ServerEntity_DynamicMusicTrigger	();

		static void CreateFromChunkStream(Asura_Guid uGuid, Asura_Chunk_Stream& xStream);

		#ifdef ASURA_TOOLS
		virtual bool CanBeIncludedInTemplate() const {return Classification == AsuraEntityClass_DynamicMusicTrigger;}
		#endif

		static Asura_ServerEntity_DynamicMusicTrigger*							FindEntity	( Asura_Guid uGuid )	{ return s_xList.FindEntity( uGuid ); }

	protected:

		void OnTrigger		();
		bool IsTriggered	();

		//virtual function overides for saving
		virtual void WriteToChunkStream		(Asura_Chunk_Stream& xStream) const;
		virtual void ReadFromChunkStream	(Asura_Chunk_Stream& xStream);

		virtual	bool IsFilledFromChunkBuffer(void) const { return false; }
		
		static Asura_ServerEntity_DynamicMusicTrigger*							FindEntityByHash(Asura_Hash_ID uHash);
		static const Asura_Hashed_List<Asura_ServerEntity_DynamicMusicTrigger>* GetList		()						{ return &s_xList; }

		// ----------- Trigger data -------------

		Asura_Hash_ID					m_uTriggerHash;


	private:

		typedef Asura_ServerEntity_Trigger PARENT;

		static Asura_Hashed_List<Asura_ServerEntity_DynamicMusicTrigger> s_xList;
};

#endif // ASURA_SUPPORT_DYNAMIC_MUSIC_SYSTEM

#endif //__ASURA_SERVERENTITY_DYNAMICMUSICTRIGGER_H__

//eof
