
//////////////////////////////////////////////////////////////////////////////
//
// Asura_VideoToTexture_System.h
// Author    : Jason Turner
// Copyright (c) 2008 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif

#ifndef __ASURA_VIDEOTOTEXTURE_SYSTEM_H__
#define __ASURA_VIDEOTOTEXTURE_SYSTEM_H__

#include "Core/Asura_LinkList.h"
#include "FMV/Asura_VideoToTexture.h"

class Asura_VideoToTexture_System
{
	public:
		static void Initialise(void);
		static void Reset(void);
		static void Shutdown(void);
		static void Update(void);
		static void Render(void);

		static void AddVideo(Asura_VideoToTexture* pxVideo) { m_xVideoStorage.Push_Back(pxVideo); }
		static bool RemoveVideo(Asura_VideoToTexture* pxVideo);

	private:
		static void Platform_Initialise();
		static void Platform_Shutdown();
		static void Platform_Update();

		static bool m_bInitFirstTime;
		static bool	m_bInitOnDemand;
		static Asura_LinkList<Asura_VideoToTexture*> m_xVideoStorage;	// Storage of all videos to update
};

#endif	//__ASURA_VIDEOTOTEXTURE_SYSTEM_H__
