
///////////////////////////////////////////////////////////////////////////////
//
// File   : Asura_FacialAnimation_AnimationHandler_PhysicalObject.cpp
// Author : Andy Tate
// Date   : 22-May-2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Core/Asura.h"

#if defined(ASURA_USE_FACIAL_ANIMATION_SYSTEM)

// This file's header...
#include "FacialAnimation/Asura_FacialAnimation_AnimationHandler_PhysicalObject.h"

// Asura independent header-files...
#include "Entity/PhysicalObject/Asura_ClientEntity_PhysicalObject.h"


////////////////////////////////////////////////////////////////////////////////
// Constant declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Static variable declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Private functions...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Protected functions...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Public functions...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Function     : Asura_FacialAnimation_AnimationHandler_PhysicalObject::Asura_FacialAnimation_AnimationHandler_PhysicalObject
// Author       : Andy Tate
// Date         : 22-May-2008
////////////////////////////////////////////////////////////////////////////////

Asura_FacialAnimation_AnimationHandler_PhysicalObject::Asura_FacialAnimation_AnimationHandler_PhysicalObject(const Asura_Guid uOwnerGuid,
																											 const Asura_Hash_ID uFaceHash,
																											 const char* szAnimationGroupName,
																											 const u_int uAnimationGroupPriority,
																											 const Asura_Hash_ID uParentAnimationGroupHash)
: PARENT(uFaceHash, szAnimationGroupName, uAnimationGroupPriority, uParentAnimationGroupHash)
, m_uOwnerGuid(uOwnerGuid)
{
}

/// End of function 'Asura_FacialAnimation_AnimationHandler_PhysicalObject::Asura_FacialAnimation_AnimationHandler_PhysicalObject'. ///



////////////////////////////////////////////////////////////////////////////////
// Function     : Asura_FacialAnimation_AnimationHandler_PhysicalObject::Update
// Author       : Andy Tate
// Date         : 22-May-2008
////////////////////////////////////////////////////////////////////////////////

void Asura_FacialAnimation_AnimationHandler_PhysicalObject::Update(const float fTimeStep)
{
	Asura_ClientEntity_PhysicalObject*	pxClient	= Asura_ClientEntity_PhysicalObject::FindEntity(m_uOwnerGuid);

	if(pxClient != NULL)
	{
		Asura_Shape_Instance&	xShapeInstance	= pxClient->GetShapeInstance();
		Asura_Animation*		pxAnimation		= xShapeInstance.GetAnimation();

		if(pxAnimation != NULL)
		{
			UpdateAnimation(fTimeStep, *pxAnimation);
		}
	}
}

/// End of function 'Asura_FacialAnimation_AnimationHandler_PhysicalObject::Update'. ///

#endif	//defined(ASURA_USE_FACIAL_ANIMATION_SYSTEM)


/// End of file. ///
