
///////////////////////////////////////////////////////////////////////////////
//
// File   : Asura_FacialAnimation_AnimationHandler_PhysicalObject.h
// Author : Andy Tate
// Date   : 22-May-2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __ASURA_FACIALANIMATION_ANIMATIONHANDLER_PHYSICALOBJECT_H__
#define __ASURA_FACIALANIMATION_ANIMATIONHANDLER_PHYSICALOBJECT_H__

#if defined(ASURA_USE_FACIAL_ANIMATION_SYSTEM)

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "FacialAnimation/Asura_FacialAnimation_AnimationHandler.h"


////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class        : Asura_FacialAnimation_AnimationHandler_PhysicalObject
// Author       : Andy Tate
// Date         : 22-May-2008
//
// Description  : Class used to interface between the facial-animation and the
//				  entity it's being played on.
////////////////////////////////////////////////////////////////////////////////

class Asura_FacialAnimation_AnimationHandler_PhysicalObject : public Asura_FacialAnimation_AnimationHandler
{
public:
	// Public functions...
	Asura_FacialAnimation_AnimationHandler_PhysicalObject(const Asura_Guid uOwnerGuid, const Asura_Hash_ID uFaceHash, const char* szAnimationGroupName, const u_int uAnimationGroupPriority, const Asura_Hash_ID uParentAnimationGroupHash = ASURA_HASH_ID_UNSET);
//	virtual ~Asura_FacialAnimation_AnimationHandler_PhysicalObject();

	// Overridden functions...
	virtual	void	Update(const float fTimeStep);


protected:
	// Protected variables...

	// Protected functions...


private:
	// Private typedefs...
	typedef Asura_FacialAnimation_AnimationHandler PARENT;

	// Private variables...
	Asura_Guid	m_uOwnerGuid;	// The GUID of the entity that owns this handler.

	// Private functions...
	Asura_FacialAnimation_AnimationHandler_PhysicalObject(void);
	Asura_FacialAnimation_AnimationHandler_PhysicalObject(const Asura_FacialAnimation_AnimationHandler_PhysicalObject& xOther);

	Asura_FacialAnimation_AnimationHandler_PhysicalObject&	operator=(const Asura_FacialAnimation_AnimationHandler_PhysicalObject& xOther);

};   // End of class 'Asura_FacialAnimation_AnimationHandler_PhysicalObject'.

#endif	//defined(ASURA_USE_FACIAL_ANIMATION_SYSTEM)

#endif   // ifndef __ASURA_FACIALANIMATION_ANIMATIONHANDLER_PHYSICALOBJECT_H__


/// End of file. ///
