// ------------------------------------------------------------------------------------ //
//																						//
//	File: Asura_GUIMenu_Allocators.h													//
//																						//
//	Description: this file is a group of functions that allocate the GUIMenu objects.	//
//				 it's been added to seperate it off from GUIMenu_System so i can use	//
//				 in the new chunk functions without creating cyclic header dependancies	//
//																						//
//	Created: Steve Keen - 23.03.07														//
//																						//
//	Copyright (C) 2006 Rebellion (Derby), All Rights Reserved.							//
// ------------------------------------------------------------------------------------ //

#ifndef __ASURA_GUIMENU_ALLOCATORS_H__
#define __ASURA_GUIMENU_ALLOCATORS_H__

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifdef ASURA_USE_GUI_MENU_SYSTEM
class Asura_GUIMenu_Root;
class Asura_GUIMenu_Menu_Page;

Asura_GUIMenu_Menu_Page* Asura_GUIMenu_CreateMenuPage( void);
Asura_GUIMenu_Root* Asura_GUIMenu_CreateAnimationElement( void);
Asura_GUIMenu_Root* Asura_GUIMenu_CreateTextElement( void);
Asura_GUIMenu_Root* Asura_GUIMenu_CreateStatusTextElement( void);
Asura_GUIMenu_Root* Asura_GUIMenu_CreateFMV( void);
Asura_GUIMenu_Root* Asura_GUIMenu_CreateImageElement( void);
Asura_GUIMenu_Root* Asura_GUIMenu_CreatePathElement( void);
Asura_GUIMenu_Root* Asura_GUIMenu_CreateButtonWidget( void);
Asura_GUIMenu_Root* Asura_GUIMenu_CreateCheckBoxWidget( void);
Asura_GUIMenu_Root* Asura_GUIMenu_CreateAnimImageWidget( void);
Asura_GUIMenu_Root* Asura_GUIMenu_CreateSliderWidget( void);
Asura_GUIMenu_Root* Asura_GUIMenu_CreateGroupWidget( void);
Asura_GUIMenu_Root* Asura_GUIMenu_CreateTextListBoxWidget( void);
Asura_GUIMenu_Root* Asura_GUIMenu_CreateListBoxWidget( void);
Asura_GUIMenu_Root* Asura_GUIMenu_CreateNumericWidget( void);
Asura_GUIMenu_Root* Asura_GUIMenu_CreateProgressBarWidget( void);
Asura_GUIMenu_Root* Asura_GUIMenu_CreateSliderWidget( void);
Asura_GUIMenu_Root* Asura_GUIMenu_CreateTextBoxWidget( void);

#endif // ASURA_USE_GUI_MENU_SYSTEM
#endif // __ASURA_GUIMENU_ALLOCATORS_H__
