// ------------------------------------------------------------------------------------ //
//																						//
//	File: Asura_GUIMenu_Element_Path.h													//
//																						//
//	Description: element path class.  movement paths for other elements or widgets		//
//																						//
//	Created: Steve Keen - 9/11/06														//
//																						//
//	Copyright (C) 2006 Rebellion (Derby), All Rights Reserved.							//
// ------------------------------------------------------------------------------------ //

#ifndef __ASURA_GUIMENU_ELEMENT_PATH_H__
#define __ASURA_GUIMENU_ELEMENT_PATH_H__

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifdef ASURA_USE_GUI_MENU_SYSTEM
#include "Asura_GUIMenu_Element_Base.h"

// -- Typedef -------------------------------------------------------------------------

// -- Enums ---------------------------------------------------------------------------

// -- Defines -------------------------------------------------------------------------
#define ASURA_GUIMENU_ELEMENT_PATH_LOCAL_FLAG_START	16


// 0 : initial version
// 1 : switch to 2d path - NY - 01/08/2008
#define ASURA_CHUNK_ELEMENT_PATH_VERSION 1

// -- Structures ----------------------------------------------------------------------
template <class T> class Asura_Graph;

class Asura_GUIMenu_Element_Path : public Asura_GUIMenu_Element_Base
{
public:
	enum Asura_GUIMenu_Inherit_Flag_Element_Path_Type
	{
		//ASURA_GUIMENU_ELEMENT_PATH_OVERIDE_MAX is here to stop another programmer adding past bit flag 31
		ASURA_GUIMENU_ELEMENT_PATH_LOCAL_FLAG_MAX			= (1<<(ASURA_GUIMENU_ELEMENT_PATH_LOCAL_FLAG_START+15))
	};


	Asura_GUIMenu_Element_Path( void);
	virtual ~Asura_GUIMenu_Element_Path( void);

	virtual void	Update( float fElapsedTime);
	virtual void 	Render( u_int uState);
	virtual void	Render( u_int uState, const Asura_Bounding_Rectangle& xBounds) {}
	virtual void	Copy( const Asura_GUIMenu_Root* pxSource );

	//virtual void	Resize( const Asura_Bounding_Rectangle& xBounds ) { SetBounds(xBounds);}
	Asura_Vector_2	GetCurrentPathPosition( float fPosition) const;
	void			SetCurrentPathValue( float fPosition);//	{	m_fPosition = fPosition;	}

	float			GetPathValueNearestPosition(const Asura_Vector_2& xPos) const;

	virtual Asura_Vector_2	GetChildPosOffset() const;

	void			SetPointArray( const Asura_Vector_2* pxPointArray, u_int uPointCount);
	u_int			GetNumberOfPoints() const;
	Asura_Vector_2	GetPoint(u_int uIndex) const;

	Asura_Graph<Asura_Vector_2>* GetActiveGraphPointer( void);
	void			SetActiveGraphPointer( Asura_Graph<Asura_Vector_2>* pxPath);

#ifdef ASURA_TOOLS
	virtual void	WriteToChunkStream( Asura_Chunk_Stream& xStream) const;
	virtual void	ExportToXML(Tools_GUIMenu_XMLExporter* pxExporter) const;
	virtual void	UpdateLocalDataFromStyle( void);
#endif
	virtual void	ReadFromChunkStream( Asura_Chunk_Stream& xStream, Asura_GUIMenu_Root* pxParentObject, u_int uChunkVersion);
protected:
	

private:

	// -- Variables -------------------------------------------------------------------
public:

protected:

private:

	Asura_Graph<Asura_Vector_2>*	m_pxPath;
	float							m_fPosition;

	// --------------------------------------------------------------------------------
	typedef Asura_GUIMenu_Element_Base PARENT;
};

#endif // ASURA_USE_GUI_MENU_SYSTEM
#endif // __ASURA_GUIMENU_ELEMENT_PATH_H__
