//
// Asura_Menubar_System.h
//
// Created by Kevin Lea - 25/06/2001 14:54:49
// 
// Copyright (C) 2001 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __ASURA_MENUBAR_SYSTEM_H__
#define __ASURA_MENUBAR_SYSTEM_H__

#include "Core/Asura_Handle.h"
#include "Core/Asura_Maths.h"
#include "Core/Asura_String.h"

class Asura_Menubar_Item;
class Asura_Menubar_Title;
class Asura_Menubar;

class Asura_Menubar_System
{
	public:

		static void Initialise(void);
		static void Shutdown(void);

		static void Update(void);
		static void Render(void);

		static bool IsUsingMenus(void);
		static void ForceRecalculateWidths(void);

		static void TitleIsActive(Asura_Menubar_Title* title)
		{
			ActiveTitle = title;
		}
		static bool AreAnyOtherTitlesActive(Asura_Menubar_Title* title)
		{
			return (ActiveTitle != title);
		}

		static void Asura_Menubar_System::RenderBox(Asura_Vector_2 topleft, float width, float height);


		static Asura_Handle Asura_Menubar_System::CreateMenuSection(void);
		static void Asura_Menubar_System::DestroyMenuSection(Asura_Handle handle);
		static Asura_Menubar_Title* Asura_Menubar_System::AddTitle(Asura_Handle handle, const Asura_Char* name);
		static Asura_Menubar_Title* Asura_Menubar_System::GetTitle(Asura_Handle handle, const Asura_Char* name);




		static float CursorX;
		static float CursorY;
	
	private:
		static bool UsingMenus;
		static bool UserDidSomething;
		static bool MenusDidSomething;
		static bool MenusActive;

		static Asura_Menubar_Title* ActiveTitle;

		static Asura_Menubar** MenubarStorage;
		static Asura_Handle_List* MenubarHandleList;

};

#endif//__ASURA_MENUBAR_SYSTEM_H__
