/**
*
* \file Asura_Guid.h
*
* Created by Kevin Lea - 23/11/2001 15:27:25
*
* Copyright (C) 2001 Rebellion, All Rights Reserved.
*
* \brief Globally Unique IDentifier
*
**/

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __ASURA_GUID_H__
#define __ASURA_GUID_H__


// (MH - 16.05.2007) moved this into Asura.h
//typedef unsigned int Asura_Guid;

/// Kevin Lea - 23/11/2001 15:33:49 - fixed guids:

const Asura_Guid ASURA_GUID_SERVER                       =       0;
const Asura_Guid ASURA_GUID_CLIENT                       =       1;
const Asura_Guid ASURA_GUID_MY_CLIENT_ENTITIES           =       2;
const Asura_Guid ASURA_GUID_PLAYER                       =       3;
const Asura_Guid ASURA_GUID_PLAYER_ONTHISMACHINE         =       4;
const Asura_Guid ASURA_GUID_ALL_PLAYERS                  =       5;
const Asura_Guid ASURA_GUID_OTHER_PLAYERS                =       6;
const Asura_Guid ASURA_GUID_ALL_MACHINES                 =       7;
const Asura_Guid ASURA_GUID_ALL_CLIENTMACHINES           =       8;
const Asura_Guid ASURA_GUID_ALL_OTHER_CLIENTMACHINES     =       9;
const Asura_Guid ASURA_GUID_OTHER_PLAYERS_CLIENTMACHINES =      10;
const Asura_Guid ASURA_GUID_PLAYERS_CLIENTMACHINE        =      11;
const Asura_Guid ASURA_GUID_DIALOGUE_SPEAKER             =      12;//special target for static messages used by dialogue system

#ifdef ASURA_TOOLS
const Asura_Guid ASURA_GUID_TOOLSUSER                    =     998;
#endif

const Asura_Guid ASURA_GUID_UNREGISTERED                 =     999;

const Asura_Guid ASURA_GUID_CLIENT_START                 =    1000;
const Asura_Guid ASURA_GUID_CLIENT_END                   =   99999;

//This guid gets stored in static messages for those messages that are sent to player 1. RAR 19/04/2006
const Asura_Guid ASURA_GUID_FIRSTPLAYER                  = ASURA_GUID_CLIENT_START;

const Asura_Guid ASURA_GUID_TOOLSCREATEDENTITY_START     =  100000;
const Asura_Guid ASURA_GUID_TOOLSCREATEDENTITY_END       = 1199999;
const Asura_Guid ASURA_GUID_TOOLS_ENTITYFILE_START       =  100000;
const Asura_Guid ASURA_GUID_TOOLS_ENTITYFILE_END         =  949999;
const Asura_Guid ASURA_GUID_TOOLS_CUTSCENEFILE_START     =  950000;
const Asura_Guid ASURA_GUID_TOOLS_CUTSCENEFILE_END       =  989999;
const Asura_Guid ASURA_GUID_TOOLS_PROJECT_START          =  990000;
const Asura_Guid ASURA_GUID_TOOLS_PROJECT_END            =  999999;
const Asura_Guid ASURA_GUID_TOOLS_SOUNDFILE_START        = 1000000;
const Asura_Guid ASURA_GUID_TOOLS_SOUNDFILE_END          = 1099999;
const Asura_Guid ASURA_GUID_TOOLS_MISSIONSOUNDFILE_START = 1100000;
const Asura_Guid ASURA_GUID_TOOLS_MISSIONSOUNDFILE_END   = 1199999;

#if defined(ASURA_USE_STREAMING)
// This is the first GUID used by the streaming system...
const Asura_Guid ASURA_GUID_STREAMING_ENTITY_START		 =       0;
const Asura_Guid ASURA_GUID_STREAMING_ZONE_MULTIPLE		 = 2000000;

const Asura_Guid ASURA_GUID_GAMECREATEDENTITY_START      =1000000000;

#else
const Asura_Guid ASURA_GUID_GAMECREATEDENTITY_START      =  2000000;
#endif	// defined(ASURA_USE_STREAMING)

#endif//__ASURA_GUID_H__


/// End of file. ///
