//////////////////////////////////////////////////////////////////////////////
//
// Asura_LanGameFinder.h
//
// Copyright (c) 2009 Rebellion. All rights reserved.
//
// Description:
//
//     class to deal with LAN game finding using simple broadcast. Should
//     work for any platform using standard sockets. On 360 it's used only if
//     ASURA_XBOX360_BYPASS_NETWORK_SECURITY is defined.
//     Note that it's just a group of 4 functions originally defined in each
//     platform as members of Asura_NetTransport_System. As such it's very
//     intertwined with that class and is a friend of it to allow data to be
//     directly manipulated. It would be nice to tidy & refactor at some point
//     although it's unlikely that will ever be a priority...
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef ASURA_LANGAMEFINDER_H___
#define ASURA_LANGAMEFINDER_H___ 1

#include "Network/Asura_NetSocket.h"

class Asura_LanGameFinder
{
public:

	static bool SendEnumHostsBroadcast();
	static void ProcessEnumHostsRequest( Asura_NetAddress xAddress, u_short usPort, const char* pcData, u_int uDataLength );
	static void SendEnumHostsResponse( Asura_NetAddress xAddress, u_short usPort);
	static void ProcessEnumHostsResponse( Asura_NetAddress xAddress, u_short usPort, const char* pcData, int iDataSize );

	// minor hack to allow lobby system to request a specific server.
	static void SetRequestedServerSessionID(u_int uServerSessionID) { s_uServerSessionID = uServerSessionID; }

private:
	static u_int s_uServerSessionID;
};

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

#endif // #ifndef ASURA_LANGAMEFINDER_H___
