//
// Asura_DemonWare_ConnectionListener.cpp
//
// Created by Andrew Catlender - 09 February 2006 12:21:32
//
// Copyright (C) 2006 Rebellion (Derby), All Rights Reserved.
//
//
// Wrapper class to allow integration of DemonWare's Matchmaking+ SDK
//

// Asura include
#include "Core/Asura.h"

#if defined(ASURA_SUPPORT_EXTERNAL_NETWORK) && defined (ASURA_SUPPORT_DEMONWARE)

// Middleware includes (must be guarded by Asura_MemoryManagement_DebugOff/On)
#if defined(SN_TARGET_PS2)
// ARC - 23 March 2006 16:13:24 - I know this is supposed to be platform independent, but it's necessary for the DemonWare stuff
#pragma mathwarn off
#endif

#include "Core/Asura_MemoryManagement_DebugOff.h"
#include "DemonWare/bdCore/bdCore.h"
#include "DemonWare/bdConnection/bdConnection.h"
#include "DemonWare/bdConnection/bdConnectionListener.h"

#if defined(SN_TARGET_PS2)
#pragma mathwarn on
#endif // SN_TARGET_PS2

// Engine includes
#include "Debugging/Asura_Assert.h"
#include "Network/Asura_DemonWare_LogSubscriber.h"

// This file's header
#include "Network/Asura_DemonWare_ConnectionListener.h"

#include "Core/Asura_MemoryManagement_DebugOn.h"
// MRD we should not be including project includes in a core asura file!!!
//#include "Core/COD_Core.h"
#include "Core/Asura_MemoryManagement_DebugOff.h"

//
//	onConnect()
//
void Asura_DemonWare_ConnectionListener::onConnect(bdConnectionRef xConnection)
{
	ASURA_DEMONWARE_LOG(("Connection established"));

	bdAddr xAddress = xConnection->getAddressHandle()->getRealAddr();
	bdInAddr pxInAddr = xAddress.getAddress().getInAddr();

	// MRD call the project specific setserver to join function
	Project_SetServerToJoin(pxInAddr.m_inAddri, xAddress.getPort());
}

//
//	onConnectFailed()
//
void Asura_DemonWare_ConnectionListener::onConnectFailed(bdConnectionRef xConnection)
{
	ASURA_DEMONWARE_LOG(("Connection failed"));
}

//
//	onDisconnect()
//
void Asura_DemonWare_ConnectionListener::onDisconnect(bdConnectionRef xConnection)
{
	ASURA_DEMONWARE_LOG(("Disconnecting"));
}

//
//	OnReconnect()
//
void Asura_DemonWare_ConnectionListener::onReconnect(bdConnectionRef xConnection)
{
	ASURA_DEMONWARE_LOG(("Reconnecting"));
}


#endif // ASURA_SUPPORT_EXTERNAL_NETWORK && ASURA_SUPPORT_DEMONWARE
