//
// Asura_DemonWare_ConnectionListener.h
//
// Created by Andrew Catlender - 09 February 2006 12:21:32
//
// Copyright (C) 2006 Rebellion (Derby), All Rights Reserved.
//
//
// Wrapper class to allow integration of DemonWare's Matchmaking+ SDK
//

#if defined(ASURA_USE_PRAGMA_ONCE)
#pragma once
#endif

#if !defined(__ASURA_DEMONWARE_CONNECTIONLISTENER_H__)
#define __ASURA_DEMONWARE_CONNECTIONLISTENER_H__

#if defined(ASURA_SUPPORT_EXTERNAL_NETWORK) && defined (ASURA_SUPPORT_DEMONWARE)
#include "DemonWare/bdConnection/bdConnectionListener.h"

// Forward declaration
//class bdConnectionListener;

//
//	Asura_DemonWare_ConnectionListener
//
class Asura_DemonWare_ConnectionListener : public bdConnectionListener
{
public:
	BD_DECLARE_NEW_AND_DELETE_OPERATORS

	// Call to notify a new connection
	virtual void onConnect(bdConnectionRef xConnection);

	// Call to notify an outgoing connection has failed to connect
	virtual void onConnectFailed(bdConnectionRef xConnection);

	// Call to notify a disconnected connection
	virtual void onDisconnect(bdConnectionRef xConnection);

	// Call to notify a reconnected connection
	virtual void onReconnect(bdConnectionRef xConnection);

	void Project_SetServerToJoin( u_int uIP, u_short usPort );
	

protected:
private:
};

#endif // ASURA_SUPPORT_EXTERNAL_NETWORK && ASURA_SUPPORT_DEMONWARE

#endif // __ASURA_DEMONWARE_CONNECTIONLISTENER_H__