//
// Asura_DemonWare_MatchMakingManager.h
//
// Created by Andrew Catlender - 30 May 2006 07:29:20
//
// Copyright (C) 2006 Rebellion (Derby), All Rights Reserved.
//
//
// MatchMaking information manager class
//

#if defined(ASURA_USE_PRAGMA_ONCE)
#pragma once
#endif

#if !defined(__ASURA_DEMONWARE_MATCHMAKINGMANAGER_H__)
#define __ASURA_DEMONWARE_MATCHMAKINGMANAGER_H__

#if defined(ASURA_SUPPORT_EXTERNAL_NETWORK) && defined (ASURA_SUPPORT_DEMONWARE)

#include <bdLobby/bdLobbyCommon/bdCustomQueryParams.h>
#include "Network/Asura_Demonware_CustomMatchMakingInfo.h"

// Forward declarations
class bdCustomQueryParams;
class bdMatchMakingInfo;
class bdQueryResult;

class Asura_DemonWare_MatchMakingManager
{
public:
	Asura_DemonWare_MatchMakingManager(u_int uiMaxResults);
	~Asura_DemonWare_MatchMakingManager();

	bdMatchMakingInfo* GetCurrentSession(void) { return m_pxCurrentSession; };
	bdCustomQueryParams* CreateQuery(u_int uiQueryID);
	bdQueryResult* GetResultHandler(void) { return m_pxResultHandler; };

protected:
	void Project_Initialise(u_int uiMaxResults);

protected:
	bdMatchMakingInfo* m_pxCurrentSession;
	bdCustomQueryParams* m_pxQuery;
	bdQueryResult* m_pxResultHandler;
	u_int m_uiMaxResults;

private:
};

#define MAX_FIND_SESSIONS_BY_GAME_TYPE_RESULTS (25u)

enum SearchId
{
	FIND_SESSIONS_BY_GAME_TYPE = 1
};

/// Encapsulates and handles matchmaking results for a query by session ID.
class FindSessionByIDResult : public bdQueryResult
{
public :

	BD_DECLARE_NEW_AND_DELETE_OPERATORS

		FindSessionByIDResult();

	virtual ~FindSessionByIDResult();

	virtual bdBool handleResult(const bdUInt numResults, 
		bdBitBufferRef buffer);

	Asura_Demonware_CustomMatchMakingInfo m_customMMInfo;
};

/// Encapsulates a matchmaking query.
class FindSessionsByGameType : public bdCustomQueryParams
{
public:

	BD_DECLARE_NEW_AND_DELETE_OPERATORS

		FindSessionsByGameType(const bdUInt maxNumResults,
		const bdInt gameType);

	virtual ~FindSessionsByGameType();

	virtual void serialize(bdBitBuffer &buffer);

protected:

	bdInt m_gameType;
};

/// Encapsulates and handles results from the query.
class FindSessionsByGameTypeResult : public bdQueryResult
{
public:

	BD_DECLARE_NEW_AND_DELETE_OPERATORS

		FindSessionsByGameTypeResult();

	virtual ~FindSessionsByGameTypeResult();

	virtual bdBool handleResult(const bdUInt numResults, 
		bdBitBufferRef buffer);		

	Asura_Demonware_CustomMatchMakingInfo m_customMMInfo[MAX_FIND_SESSIONS_BY_GAME_TYPE_RESULTS];
};


#endif // ASURA_SUPPORT_EXTERNAL_NETWORK && ASURA_SUPPORT_DEMONWARE
#endif // __ASURA_DEMONWARE_MATCHMAKINGMANAGER_H__
