//////////////////////////////////////////////////////////////////////////////
//
// Asura_GameSpy_Peer_Dummy.cpp
//
// Copyright (c) 2004 Rebellion. All rights reserved.
//
// Description:
//
//     for projects which do not support the Peer SDK, this file provides
//     dummy implementations of functions used by the server browsing
//     interface.
//
//////////////////////////////////////////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "Core/Asura.h"

#include "Network/GameSpy/Asura_GameSpy_Peer.h"

#include "Debugging/Asura_Assert.h"

PEER Asura_GameSpy_Peer::s_pxPeer;
u_int Asura_GameSpy_Peer::s_uNumGroupRooms;
bool Asura_GameSpy_Peer::s_bErrorAddingServer;

// placeholders for linkage
u_int Asura_GameSpy_Peer::GetMyPublicIPAddress()
{
	Asura_Assert(false, "shouldn't be called");
	return 0;
}

bool Asura_GameSpy_Peer::SendNatNegotiateCookie(u_int uIP, u_short usPort, int iCookie)
{
	Asura_Assert(false, "shouldn't be called");
	return false;
}

void Asura_GameSpy_Peer::ParsePeerQuery( u_int uIP, u_short usPort, char* pcQueryData, u_int uDataLength )
{
	Asura_Assert(false, "shouldn't be called");
}

void Asura_GameSpy_Peer::Update()
{
	// (MH - 17.12.2004) this now gets called without checking for initialised so just return.
}

bool Asura_GameSpy_Peer::IsInitialised( void )
{
	return false;
}
