//
// Asura_Physics_ForceField_Conveyor.h
//
// Created by KJFL - 18 April 2007
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_PHYSICS_FORCEFIELD_CONVEYOR_H__
#define __ASURA_PHYSICS_FORCEFIELD_CONVEYOR_H__

#include "Core/Asura_Maths.h"
#include "Physics/ForceFields/Asura_Physics_ForceField.h"

class Asura_Physics_ForceField_Conveyor : public Asura_Physics_ForceField
{
	public:

		// OBB containing volume and a velocity in m/s
		Asura_Physics_ForceField_Conveyor( const Asura_AVector3& xVelocity, const Asura_OBB& xVolume );

		virtual ~Asura_Physics_ForceField_Conveyor() {}
		
		virtual void Update( void );
		virtual void DebugRender( void );

		const Asura_OBB& GetOBB( void ) const;
		const Asura_AVector3& GetVelocity( void ) const;

		void SetOBB( const Asura_OBB& xVolume );
		void SetVelocity( const Asura_AVector3& xVelocity );


	protected: 

		Asura_OBB		m_xOBB;
		Asura_AVector3	m_xVelocity;
};

#endif//__ASURA_PHYSICS_FORCEFIELD_CONVEYOR_H__

