//////////////////////////////////////////////////////////////////////////////
//
// Asura_AmbientOcclusion.h
//
// Created by Ben Weston 14/11/2008
//
// Copyright (c) 2008 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////


#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __ASURA_AMBIENTOCCLUSION_H__
#define __ASURA_AMBIENTOCCLUSION_H__


class Asura_AmbientOcclusion {

public:
#ifdef ASURA_USE_AMBIENT_OCCLUSION

	static void		Initialise() { Platform_Initialise(); }
	static void		Shutdown() { Platform_Shutdown(); }
	static void		Reset() { Platform_Reset(); }
	static void		PrepareDepthData() { Platform_PrepareDepthData(); }
	static void		Render() { Platform_Render(); }

#else

	static void		Initialise() {  }
	static void		Shutdown() {  }
	static void		Reset() {  }
	static void		Render() {  }
	static void		PrepareDepthData() { }
	static void		ApplyToScene() { }

#endif

protected:
	static void		Platform_Initialise();
	static void		Platform_Shutdown();
	static void		Platform_Reset();
	static void		Platform_PrepareDepthData();
	static void		Platform_Render();

};


#endif

