/**
*
* \file Asura_MovieToTexture_System.h
*
* Created by Kevin Lea - 19/08/2002 15:06:51
*
* Copyright (C) 2002 Rebellion, All Rights Reserved.
*
* \brief
*
**/
#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif

#ifndef __ASURA_MOVIETOTEXTURE_SYSTEM_H__
#define __ASURA_MOVIETOTEXTURE_SYSTEM_H__

#include "Core/Asura_Handle.h"

class Asura_Tracking_Handle_List;
class Asura_Platform_MovieToTextureStream;

class Asura_MovieToTexture_System
{
	public:
		static void Initialise(const u_int uMaxNumberOfMovieStreams, const bool bStartAllFMVTextures=false);
		static void Shutdown(void);
		static void Reset(void);

		static void Update(void);
	
		static Asura_Handle CreateStream(const int iTextureIndex, const char* pxMovieName, bool bLooping = true, bool bHoldAtEnd = false);
		static bool IsReadyToBeDestroyed(Asura_Handle iMovieHandle);
		static void DestroyStream(Asura_Handle iMovieHandle);
        
        static Asura_Platform_MovieToTextureStream* GetStreamByTexID( int iTextureID );

	private:

        static void Platform_Initialise( void );
        static void Platform_Shutdown( void );
        static void Platform_Reset( void );

        static void Platform_Update( void );

		static u_int									s_uMaxNumberOfMovieStreams;
		static Asura_Tracking_Handle_List*				s_pxHandleList;
		static Asura_Platform_MovieToTextureStream**	s_ppxStreamStorage;

};

#endif//__ASURA_MOVIETOTEXTURE_SYSTEM_H__
