//
// Asura_ShadowBuffer.h
//
// Created by RCD - 15 February 2005
//
// Copyright (C) 2005 Rebellion, All Rights Reserved.
//

// This file initially created to provide platform independent access to functions 
// which may very well not be implemented on all platforms
// So far the only specific case is the pre-allocation system, however this could 
// very easily be extended to other areas should there be any benefit.

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_SHADOWBUFFER_H__
#define __ASURA_SHADOWBUFFER_H__

/************/
/* Includes.*/
/************/

#include "Core/Asura.h"


/************/
/* Classes. */
/************/

class Asura_Animation;

class Asura_ShadowBuffer_System
{
public:
	enum BUFFERSIZE { SIZE_DEFAULT, SIZE_LARGE };
	static void PreAllocateBuffer(const Asura_Animation* pxAnim, BUFFERSIZE eBufferSize, float fScale);
	static void PreProcessLevelData(void);	// only required to do anything for PS2 - please implement empty function for other platforms
};


#endif//__ASURA_SHADOWBUFFER_H__

