// Asura_Audio_Systems_Manager.h
// Thomas Young - 03.12.08
// Copyright (C) 2008 Rebellion, All Rights Reserved.

// F I L E   W R A P P E R ///////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_AUDIO_SYSTEMS_MANAGER_H__
#define __ASURA_AUDIO_SYSTEMS_MANAGER_H__

#ifdef ASURA_USE_AUDIO_SYSTEM

// E N U M E R A T I O N S ///////////////////////////////////////////////////

enum ASURA_ASM_UPDATE_FLAGS
{
	ASURA_AUDIO_UPDATE_SOUND_EVENTS		= 0x00000001,
	ASURA_AUDIO_UPDATE_DIALOGUE			= 0x00000002,
	ASURA_AUDIO_UPDATE_PHONONS			= 0x00000004,
	ASURA_AUDIO_UPDATE_DYNAMIC_MUSIC	= 0x00000008,
	ASURA_AUDIO_UPDATE_STREAMING_BGND	= 0x00000010,
	ASURA_AUDIO_UPDATE_REVERB_VOLUMES	= 0x00000020,
	ASURA_AUDIO_UPDATE_OCCLUSION		= 0x00000040,
		
	ASURA_AUDIO_UPDATE_EVERYTHING		= 0x0000FFFF
};

// C L A S S   D E C L A R A T I O N S ///////////////////////////////////////

class Asura_Audio_Systems_Manager
{
	public:

		static void Initialise		( );
		static void Update			( ) { Update( ASURA_AUDIO_UPDATE_EVERYTHING ); }
		static void Update			( const u_int uUpdateFlags );
		static void Shutdown		( );
		
		static void Reset			( );

		static bool IsInitialised	( );

	protected:

		static bool		s_bIsInitialised;
};


#endif // ASURA_USE_AUDIO_SYSTEM

#endif // __ASURA_AUDIO_SYSTEMS_MANAGER_H__

//eof
