//
// Asura_MetaMusic_ZoneController.cpp
//
// Created by Richard Rice - 11/01/05
// 
// Copyright (C) 2005 Rebellion, All Rights Reserved.
//

#include "Core/Asura.h"

#ifndef ASURA_SUPPORT_DYNAMIC_MUSIC_SYSTEM

#include "Sound/Asura_MetaMusic_ZoneController.h"

#include "ChunkSystem/Asura_Chunk_Stream.h"

#include "Sound/Asura_MetaMusic_Zone.h"


#define ASURA_METAMUSIC_ZONE_CONTROLLER_VERSION 0



Asura_Zone* Asura_MetaMusic_ZoneController::AllocateZone( const bool bFromChunkBuffer /*= false*/ )
{
	return new Asura_MetaMusic_Zone( bFromChunkBuffer );
}


void Asura_MetaMusic_ZoneController::ReadFromChunkStream(Asura_Chunk_Stream& xStream)
{
	Asura_Zone_Controller::ReadFromChunkStream(xStream);

	int iVersion;
	xStream >> iVersion;

	Asura_Assertf(iVersion<=ASURA_METAMUSIC_ZONE_CONTROLLER_VERSION,("Unknown chunk version %d in Asura_MetaMusic_ZoneController",iVersion));
}


#ifdef ASURA_TOOLS
void Asura_MetaMusic_ZoneController::WriteToChunkStream(Asura_Chunk_Stream& xStream)
{
	Asura_Zone_Controller::WriteToChunkStream(xStream);

	xStream << ASURA_METAMUSIC_ZONE_CONTROLLER_VERSION;
}
#endif // ASURA_TOOLS

#endif

//eof
