// Asura_XAPO_DSP_Monitor.cpp
// Thomas Young - 27.03.09
// Copyright (C) 2009 Rebellion, All Rights Reserved.

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "Core/Asura.h"

#ifdef ASURA_USE_AUDIO_SYSTEM
#ifdef ASURA_TOOLS

#include "Sound/XAPO_DSP/Asura_XAPO_DSP_Monitor.h"
#include "Sound/Asura_Audio_DSP.h"

#include <intrin.h>

#pragma intrinsic(_ReadWriteBarrier)

// F U N C T I O N   D E F I N I T I O N S ///////////////////////////////////

Asura_XAPO_DSP_Monitor::Asura_XAPO_DSP_Monitor( ) : Asura_XAPOBase< Asura_XAPO_DSP_Monitor, Asura_XAPO_DSP_Monitor_Params >( )
{
}


Asura_XAPO_DSP_Monitor::~Asura_XAPO_DSP_Monitor()
{
}


void Asura_XAPO_DSP_Monitor::DoProcess ( float* pfInputBuffer, u_int uFrames, u_int uChannels, const Asura_XAPO_DSP_Monitor_Params& xParams )
{
	if( !( *xParams.m_pbBufferWritten ) )
	{
		u_int uFramesToWrite = uFrames;

		if( xParams.m_uBufferSize < uFrames * uChannels )
		{
			uFramesToWrite = xParams.m_uBufferSize / uChannels;
		}

		if( xParams.m_puChannels )
		{
			*xParams.m_puChannels = uChannels;
		}
		if( xParams.m_puSamples )
		{
			*xParams.m_puSamples = uFramesToWrite;
		}

		Asura_Mem::Copy( xParams.m_pfBuffer, pfInputBuffer, sizeof( float ) * uFramesToWrite * uChannels );

		_ReadWriteBarrier();

		*xParams.m_pbBufferWritten = true;
	}
}

#endif	// ASURA_TOOLS
#endif	// ASURA_USE_AUDIO_SYSTEM

//eof
