// Asura_XAPO_DSP_Monitor.h
// Thomas Young - 27.03.09
// Copyright (C) 2009 Rebellion, All Rights Reserved.

// F I L E   W R A P P E R ///////////////////////////////////////////////////

#if defined ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#if !defined __ASURA_XAPO_DSP_MONITOR_H__
#define __ASURA_XAPO_DSP_MONITOR_H__

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "Core/Asura.h"

#ifdef ASURA_USE_AUDIO_SYSTEM
#ifdef ASURA_TOOLS

#include "Sound/XAPO_DSP/Asura_XAPO_DSP.h"

// C L A S S   D E C L A R A T I O N S ///////////////////////////////////////

class Asura_XAPO_DSP_Monitor_Params
{
	public:

		Asura_XAPO_DSP_Monitor_Params()
		{
			m_pfBuffer			= 0;
			m_uBufferSize		= 0;
			m_pbBufferWritten	= 0;
			m_puChannels		= 0;
			m_puSamples			= 0;
		}

		u_int			m_uBufferSize;
		float*			m_pfBuffer;
		volatile bool*	m_pbBufferWritten;
		u_int*			m_puChannels;
		u_int*			m_puSamples;
};

class __declspec( uuid( "{BDD2C061-F45B-4471-B174-78B5FAEC9D8B}" ) ) Asura_XAPO_DSP_Monitor : public Asura_XAPOBase< Asura_XAPO_DSP_Monitor, Asura_XAPO_DSP_Monitor_Params >
{
	// This is a 'special' type of DSP, it records the audio buffer for display in tools

	public:

		Asura_XAPO_DSP_Monitor		( );
		~Asura_XAPO_DSP_Monitor		( );

	private:

		void DoProcess ( float* pfInputBuffer, u_int uFrames, u_int uChannels, const Asura_XAPO_DSP_Monitor_Params& xParams );
};

#endif // ASURA_TOOLS
#endif // ASURA_USE_AUDIO_SYSTEM

#endif // __ASURA_XAPO_DSP_MONITOR_H__

//eof
