//
// Asura_Deformatron_System.h
//
// Created by KOR - 24/11/2004
//
// Copyright (C) 2004 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __ASURA_DEFORMATRON_SYSTEM_H__
#define __ASURA_DEFORMATRON_SYSTEM_H__

#include "Core/Asura_Handle.h"
#include "Core/Asura_Maths.h"
#include "Core/Asura_MempoolFactory_Template.h"

class Asura_Deformatron
{
public:
	Asura_Vector_3	m_xPosition;
	float			m_fRange;
	float			m_fDepth;
};

#define ASURA_MAX_DEFORMATRONS_IN_LIST 16

class Asura_Deformatron_System
{
public:
	// Standard system functions
	static void Initialise();
	static void Shutdown();
	static void Reset();
	static void Update();

	// Access methods
	static Asura_Handle CreateDeformatron();
	static void DestroyDeformatron(Asura_Handle iHandle);
	static Asura_Deformatron* GetDeformatron(Asura_Handle iHandle);

	static void MakeDeformatronListForBB(Asura_Bounding_Box& xBB, u_int uMaxDeformatrons = ASURA_MAX_DEFORMATRONS_IN_LIST);
	static void DeformatronCallback(Asura_Deformatron* pxDeformatron);
	static u_int GetNumDeformatronsInList();
	static const Asura_Deformatron* GetDeformatronInList(u_int uNum);
private:
	// Static members
	static Asura_MempoolFactory_Template<Asura_Deformatron>*	s_pxFactory;

	static Asura_Deformatron*	s_apxDeformatronList[ASURA_MAX_DEFORMATRONS_IN_LIST];
	static u_int				s_uNumDeformatronsInList;
	static Asura_Bounding_Box*	s_pxProximityTestBoundingBox;
};

#endif//__ASURA_DEFORMATRON_SYSTEM_H__
