//////////////////////////////////////////////////////////////////////////////
//
// Asura_FullScreenSFX_System.h
//
// Copyright (c) 2003 Rebellion. All rights reserved.
//
// Description:
//
//     Full screen effects like fades, flashes, etc.
//
//////////////////////////////////////////////////////////////////////////////

#if defined ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif

#if !defined __ASURA_FULLSCREENSFX_SYSTEM_H__
#define __ASURA_FULLSCREENSFX_SYSTEM_H__

// C L A S S E S /////////////////////////////////////////////////////////////

class Asura_FullScreenSFX_System
{

    public:

        // T Y P E S /////////////////////////////////////////////////////////

        enum FADE
        {
            FADE_NONE,
            FADE_TO_COLOUR,
            FADE_FROM_COLOUR,
        };

        // C L A S S   M E T H O D S /////////////////////////////////////////

        static void Initialise( void );
        static void Reset( void );
        static void Shutdown( void );

        static void Update( void );
        static void Render_Early( void );
        static void Render_Late( void );
		static void Render2DEffects();

        static void BeginFade( FADE eFadeType, float fDuration, u_int uColour );
        static void CancelFade( void );
        static bool IsFadeComplete( void );

		static void EnableGlow( bool bEnableGlow );
		static bool IsGlowEnabled();

		static void EnableMotionBlur( bool bEnableMotionBlur );
		static void SetMotionBlurAlpha( u_char uMotionBlurAlpha );	

    private:
        
        // C L A S S   M E T H O D S /////////////////////////////////////////

        static void Platform_RenderFade( u_int uColour );
		static void Platform_RenderMotionBlur( u_char uAlpha );

		static void Platform_InitialiseMotionBlur();
};

#endif // !defined __ASURA_FULLSCREENSFX_SYSTEM_H_
