//////////////////////////////////////////////////////////////////////////////
//
// Asura_Glow_System.h
//
// Created by AAM - 15/04/2004 12:04:20
//
// Copyright (C) 2004 Rebellion, All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

#if defined ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif

#if !defined __ASURA_GLOW_SYSTEM_H__
#define __ASURA_GLOW_SYSTEM_H__

#include "Rendering/Asura_Colour.h"

/******************************************************************************/
/* Types                                                                      */
/******************************************************************************/

class Asura_Glow_System
{
public:

	static void Initialise();
	static void Reset();
	static void Shutdown();

	// PreReset and PostReset should perhaps be renamed PreDeviceReset etc.
	// as they are actually called from PC code to manage the dynamically-
	// allocated render targets during Asura_Direct3D::RestoreAll(). 
	static void PreReset();
	static void PostReset();

	static void Render();

	// (MH - 19.10.2004) added per-camera setting of glow level. 
	// No glow will be done for level 0.0f and overall glow level done for 1.0f.
	static void SetCameraGlowLevel( float fLevel, u_int uCameraIndex );
	static float GetCameraGlowLevel( u_int uCameraIndex );

	static void SetGlowTint(float fRed, float fGreen, float fBlue);
	static void SetGlowTint(Asura_RGBA values);
	static void SetGlowLevel(float fLevel);
	static Asura_RGBA GetGlowTint();
	static float GetGlowLevel();

protected:

	static float s_afColorParams[4];	// tint and overall level, only implemented on XBox and PC?
	static float s_afCameraLevel[4];	// per-camera level (0-1)

	static bool Platform_Initialise();
	static void Platform_Shutdown();

	static void Platform_PreReset();
	static void Platform_PostReset();

	static void Platform_Render(float fRed, float fGreen, float fBlue, float fLevel);
};

#endif // !defined __ASURA_GLOW_SYSTEM_H__
