/**
*
* \file Asura_SFX_GlassSmash.h
*
* Created by Andrew Weinkove - 23/07/2002
*
* Copyright (C) 2002 Rebellion, All Rights Reserved.
*
* \brief
*
**/
#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif

#ifndef __ASURA_SFX_GLASSSMASH_H__
#define __ASURA_SFX_GLASSSMASH_H__

#include "Core/Asura_Maths.h"
class Asura_ClientEntity_Glass;

// The purpose of this class is to create an Asura_Shard_Effect from a piece of glass
// when it is broken. This is implemented in a separate class (as opposed to being
// part of Asura_Shard_Effect) for tidiness reasons only.aw.
class Asura_SFX_GlassSmash
{
	public:
		static void Create(const Asura_ClientEntity_Glass& xGlass, const float fPower, const Asura_Vector_2& xHitCoordinates, const Asura_Vector_3& xDirection);
		static void Create(const Asura_ClientEntity_Glass& xGlass, const float fPower, const bool bSmashInPositiveZDir);
	private:
		static void Create(const Asura_ClientEntity_Glass& xGlass, const float fPower, const Asura_Vector_2& xHitCoordinates, const Asura_Vector_3& xDirection, bool bBlast);
		static Asura_Vector_3 CalculateInitialVelocityFromBlast(const Asura_Vector_2& xVertexPosition, const float fPower, const Asura_Vector_2& xHitCoordinates, const Asura_Vector_3& xDirection);
		static Asura_Vector_3 CalculateInitialVelocityFromShot(const Asura_Vector_2& xVertexPosition, const float fPower, const Asura_Vector_2& xHitCoordinates, const Asura_Vector_3& xDirection, float *pfWaitTime);

		static const float s_fVelocityMultiplier;
		static const float s_fAlphaOutTime;
};

#endif//__ASURA_SFX_GLASSSMASH_H__
