//
// Asura_EffectVolume_Camera.h
//
// Created by Emil Popovic - 19/12/2008
// 
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_EFFECTVOLUME_CAMERA_H__
#define __ASURA_EFFECTVOLUME_CAMERA_H__


#include "Core/Asura_HashTree.h"
#include "Core/Asura_List.h"
#include "SpecialFX/EffectVolume/Asura_EffectVolume_Camera_EntityData.h"
#include "SpecialFX/EffectVolume/Asura_EffectVolume_EffectState.h"


class Asura_EffectVolume_Camera
{
public:

	void Initialise();
	void Reset();
	void Shutdown();
	void Update( const Asura_Vector_3& xPosition, u_int uCameraIndex );

	protected:

	void AddNewEffectStateToList( Asura_EffectVolume_EffectState* pxNewEffectState, float fStrength );
	void UpdateAllEffectStates();
	void BlendEffectVolume( Asura_Guid uEffectVolumeGuid, float fEffectVolumeStrength );
	void BlendNewEffectStateToCurrentOnes( Asura_EffectVolume_EffectState* pxNewEffectState, float fStrength );


private:

	typedef Asura_TemplateHashTree<Asura_EffectVolume_Camera_EntityData> EntityDataContainer;
	typedef Asura_TemplateHashTree_Iterator<Asura_EffectVolume_Camera_EntityData> EntityDataIterator;
	typedef Asura_TemplateHashTree_ConstIterator<Asura_EffectVolume_Camera_EntityData> EntityDataConstIterator;

	typedef Asura_List<Asura_EffectVolume_EffectState> EffectStateList;
	typedef Asura_List_It<Asura_EffectVolume_EffectState> EffectStateIterator;
	typedef Asura_List_ConstIt<Asura_EffectVolume_EffectState> EffectStateConstIterator;

	EntityDataContainer m_xEntityDataContainer;
	EffectStateList		m_xEffectStateList;


	void CheckForNewEntitiesInCameraRadius( const Asura_Vector_3& xPosition, u_int uCameraIndex );
	void UpdateCurrentEntities( const Asura_Vector_3& xPosition, u_int uCameraIndex );



	Asura_EffectVolume_Camera_EntityData*	CreateOrGetExistingEntityData(const Asura_Hash_ID uHash);
	bool									DestroyEntityData(const Asura_Hash_ID uHash)							{ return(m_xEntityDataContainer.DeleteNodeByHash(uHash)); }
	Asura_EffectVolume_Camera_EntityData*	FindEntityData(const Asura_Hash_ID uHash)								{ return(m_xEntityDataContainer.GetDataByHash(uHash)); }

};



#endif// __ASURA_EFFECTVOLUME_CAMERA_ENTITYDATA_H__