//////////////////////////////////////////////////////////////////////////////
//
// Asura_EffectVolume_System.cpp
//
// Copyright (c) 2008 Rebellion. All rights reserved.
//
// Created by Emil Popovic - 19/12/2008
//
//////////////////////////////////////////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// Core
#include "Core/Asura.h"

// This file's header.
#include "SpecialFX/EffectVolume/Asura_EffectVolume_System.h"

// Engine independent.
#include "Camera/Asura_Camera.h"
#include "Rendering/Asura_Fog.h"

// Tools
#ifdef ASURA_TOOLS
#include "Tools_System.h"
#endif


// C L A S S   I M P L E M E N T A T I O N S /////////////////////////////////

//----------------------------------------------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------------


//Asura_EffectVolume_System::CameraContainer						Asura_EffectVolume_System::s_xCameraContainer;
//Asura_EffectVolume_System::ClientEntityEffectVolumeContainer	Asura_EffectVolume_System::s_xClientEntityEffectVolumeContainer;


Asura_EffectVolume_Camera Asura_EffectVolume_System::s_xCamera;



void Asura_EffectVolume_System::Initialise( void )
{
    Reset();

	s_xCamera.Reset();
}

void Asura_EffectVolume_System::Reset( void )
{
	s_xCamera.Reset();
}

void Asura_EffectVolume_System::Shutdown( void )
{
	s_xCamera.Shutdown();
}

void Asura_EffectVolume_System::Update( void )
{

	Asura_Fog::SetFog( Asura_Fog::GetInitialFog() );	// Restore fog from original values.

	const Asura_Vector_3* pxPosition = Asura_Camera::GetPosition();
	
	if( pxPosition )
	{
		u_int uCameraIndex = Asura_Camera::GetCameraIndex();
		
		s_xCamera.Update( *pxPosition, uCameraIndex );
	}

}

void Asura_EffectVolume_System::Render( void )
{

}
