//////////////////////////////////////////////////////////////////////////////
//
// Asura_PlatformInput.cpp
//
// Copyright (c) 2003 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "Core/Asura.h"

// Engine independent.
#include "Core/Asura_UserInput.h"
#include "Interface/Asura_Cursor.h"
#include "Network/Asura_Network.h"

// C L A S S   I M P L E M E N T A T I O N S /////////////////////////////////

//
// Asura_UserInput.
//

int  Asura_UserInput::Platform_GetNumberOfActiveControllers( bool ) { return 0; }
void Asura_UserInput::Platform_Initialise( void ) { }
bool Asura_UserInput::Platform_IsControllerActive( int ) { return false; }
bool Asura_UserInput::Platform_IsKeyToggled( int ) { return false; }
void Asura_UserInput::Platform_Reset( void ) { }
void Asura_UserInput::Platform_Shutdown( void ) { }

static float g_fTurnDirection = 0.0f;
DEBUGVAR float dbg_fFakeTurnRate = 0.5f;

#include "GUIMenu/Asura_GUIMenu_System.h"
//static bool ShouldBePressingEnter()
//{
//	switch (Asura_GUIMenu_System::GetFocusedMenuHashID())
//	{
//	case 0x636B2446: // Asura_GetHashID("MP_Team_Selection")
//	case 0xBF679E15: // Asura_GetHashID("MP_Spawn_Location")
//	case 0x5D30E453: // Asura_GetHashID("MP_Zone_Select")
//		return true;
//	}
//	return false;
//}

void Asura_UserInput::Platform_Update( void ) {}
int  Asura_UserInput::Platform_GetPortForPlayer(int iPlayerNum) { return 0; }
void Asura_UserInput::Platform_UpdateInputBuffer(Asura_UnicodeChar* wszBuffer, u_int uMaxChars, u_int& uInputCursorPos,
								   bool (*pfnHandleInputOverride)(ASURA_KEYID eKey), 
								   const Asura_UnicodeChar* wszInputBuffer,
								   u_int uInputBufferSize) {}


#ifdef ASURA_USE_CURSOR

void Asura_Cursor::Initialise()
{
}

void Asura_Cursor::Shutdown()
{
}

void Asura_Cursor::GetScreenSpaceCoords(int& sx, int& sy)
{
	sx = 0;
	sy = 0;
}

Asura_Cursor_PosInfo::Asura_Cursor_PosInfo()
: m_fX(0.5f)
, m_fY(0.5f)
, m_fDeltaX(0.f)
, m_fDeltaY(0.f)
, m_fOngoingDeltaX(0.f)
, m_fOngoingDeltaY(0.f)
, m_fCursorSpeed(1.f)
, m_fTimeSpentStatic(0.f)
, m_bCursorMovementEnabled(true)
, m_bTeleportedSinceLastUpdate(false)
, m_bOffscreen(false)
{

};

u_int												Asura_Cursor::s_uCurrentCursorIndex = 0;
Asura_Cursor_PosInfo								Asura_Cursor::s_axCursorPosInfo[ASURA_NUM_CURSORS];
Asura_Hash_ID										Asura_Cursor::s_uCurrentCursorHash = ASURA_HASH_ID_UNSET;
Asura_Cursor_RenderInfo*							Asura_Cursor::s_pxCurrentCursor;
Asura_TemplateHashTree<Asura_Cursor_RenderInfo>		Asura_Cursor::s_xCursorTree;
bool Asura_Cursor::s_bHideCursor = false;

#endif //def ASURA_USE_CURSOR
