///////////////////////////////////////////////////////////////////////////////
//
// File   : Asura_PC-CLI_Manager.h
// Author : Johan Lerstrom
// Date   : 19-Mar-2009
//
// Copyright (C) 2009 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef ASURA_PCCLI_MANAGER_H___
#define ASURA_PCCLI_MANAGER_H___ 1

// CLASSES

class Asura_PCCLI_Manager
{
public:
	static void InitCommandLineArgs(LPSTR& lpCmdLine);
	static bool Initialise(LPSTR& lpCmdLine);
	static void InitLogFiles( LPSTR& lpCmdLine );
	static void Shutdown( void );

	static void Update( void );
	static void UpdateFrontEnd( void );

	static bool ConsoleCmd_SpawnBots(int iLimit, bool bInterrogate, bool bHelp);
	static bool ConsoleCmd_SpawnAutomatchTestingBots(int iLimit, bool bInterrogate, bool bHelp );
	static bool ConsoleCmd_LanOnly(bool bHelp);
	static bool ConsoleCmd_ExecConfig(const Asura_UnicodeChar* wszFile, bool bInterrogate, bool bHelp);
	static bool ConsoleCmd_Port(int iPort, bool bInterrogate, bool bHelp);

	static bool Project_ConsoleCmd_RequestHost(bool bHelp);
	static bool Project_ConsoleCmd_RequestJoin(const Asura_UnicodeChar* wszAddress, bool bInterrogate, bool bHelp);
	static bool Project_ConsoleCmd_RequestMap(const Asura_UnicodeChar* wszMap, bool bInterrogate, bool bHelp);
	static bool Project_ConsoleCmd_ListPlayers(bool bHelp);

	static bool GetHostRequested() { return s_bHostRequested; }
	static bool GetJoinRequested() { return s_bJoinRequested; }

#ifdef ASURA_SUPPORT_GAMESPY
	static bool ConsoleCmd_RefreshGameSpyQR2( bool bHelp );
#endif // #ifdef ASURA_SUPPORT_GAMESPY

private:
	static void Project_Initialise( void );
	static void Project_Update( void );

	static void SpawnBot( void );
	static void SpawnAutomatchTestingBot( void );
	static void Project_GetDefaultSpawnBotCommandline( Asura_Char* szCmdLineBuffer, const u_int uMaxChar, const u_int uNumSpawned );
	static void Project_GetAutomatchTestingSpawnBotCommandline( Asura_Char* szCmdLineBuffer, const u_int uMaxChar, const u_int uNumSpawned );

	static bool ProcessCommandLine(LPSTR lpCmdLine, bool bPriorityCommands);
	static bool ProcessCommandLine(int iNumArgs, const char** aszArgs, bool bPriorityCommands);

	static int s_iBotsToSpawn;
	static int s_iAutomatchTestingBotsToSpawn;
	static u_int s_uNextBotSpawnTime;
	static bool s_bPlayingOnline;
	static bool s_bHostRequested;
	static bool s_bJoinRequested;
};

#endif //ASURA_PCCLI_MANAGER_H___
