//////////////////////////////////////////////////////////////////////////////
//
// Asura_Platform_Shapes.cpp
//
// Copyright (c) 2003 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "Core/Asura.h"

// Engine independent.
#include "Core/Asura_Material_System.h"
#include "Shapes/Asura_Shapes.h"

// Engine platform-specific.
#include "Shapes/Asura_Platform_Shape.h"

// C L A S S   I M P L E M E N T A T I O N S /////////////////////////////////

//
// Asura_Platform_Shape_RenderData.
//

Asura_Platform_Shape_RenderData::Asura_Platform_Shape_RenderData( const char*& pcChunkBfr ) { pcChunkBfr += sizeof(MY_TEMP_FILENAME); }

void Asura_Platform_Shape_RenderData::FillInChunkBuffer( char*& ) { }
int  Asura_Platform_Shape_RenderData::GetChunkBufferSize( void ) { return 0; }
void Asura_Platform_Shape_RenderData::GetFragmentHashFromMesh( Asura_Hash_ID& uHash ) const { uHash = ASURA_HASH_ID_UNSET; }
void Asura_Platform_Shape_RenderData::Load( Asura_Hash_ID ) { }

//
// Asura_Shape.
//

int  Asura_Shape::Platform_GetMaterialIdx( void ) const { return ASURA_MATERIAL_NONE; }
void Asura_Shape::Platform_Render( const Asura_Shape_Instance*, u_int, u_int ) const { }
bool Asura_Shape::Platform_IsOpaque(void)const { return true; }
void Asura_Shape::Platform_RenderShadow( const Asura_Shape_Instance* pxShapeInst, const class Asura_Shadow& xShadow, u_int uCamVisFlags ) const {}

//
// Asura_Shape_Instance.
//
// range of ambient light for each component is 0x00 to 0xFF
void Asura_Shape_Instance::Platform_SetAmbientRGB( const unsigned char ucR, const unsigned char ucG, const unsigned char ucB, const unsigned char ucA) {}
void Asura_Shape_Instance::Platform_SetAmbientARGB( const unsigned int uARGB ) {}
void Asura_Shape_Instance::Platform_SetDefaultAmbientRGB( void ) {}
