//////////////////////////////////////////////////////////////////////////////
//
// Asura_Platform_Audio.cpp
//
// Copyright (c) 2008 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

/******************************************************************************/
/* Included Files                                                             */
/******************************************************************************/

#include "Core/Asura.h"

#if defined ASURA_USE_AUDIO_SYSTEM

#include "Sound/Asura_Audio_System.h"

// Asura Platform-independent
#include "ChunkSystem/Asura_Chunk_Loaders.h"
#include "Debugging/Asura_Assert.h"

// Tools
#if defined ASURA_TOOLS
	#include "Sound/Tools_Audio_DSP.h"
	#include "Sound/Tools_Sound_System.h"
#endif

// Misc
#include <objbase.h>

/******************************************************************************/
/* Asura_Audio_System Static Class Functions                                  */
/******************************************************************************/

void Asura_Audio_System::Platform_Initialise() {}
void Asura_Audio_System::Platform_Reset() {}
void Asura_Audio_System::Platform_Shutdown() {}
void Asura_Audio_System::Platform_Update() {}
void Asura_Audio_System::Platform_CreateDSPChain( const Asura_Hash_ID uHash, const Asura_Audio_DSPChain& xChain ) {}
void Asura_Audio_System::Platform_DestroyVoice( const Asura_Handle iVoiceHandle ) {}
void Asura_Audio_System::Platform_SetMasterDSP( const Asura_Hash_ID uDSPChain, const float fFadeTime ) {}

Asura_Handle Asura_Audio_System::Platform_CreateVoice( const Asura_Hash_ID uWave,
	const bool bFilter, const bool bMusic, const Asura_Hash_ID uDSPChain /* = ASURA_HASH_ID_UNSET*/ )
{
	return 0;
}

Asura_Handle Asura_Audio_System::Platform_CreateStreamingVoice( const Asura_Hash_ID uStreamHash,
	const bool bMusic,const bool bFilter, const float fTimeOffset, const Asura_Hash_ID uDSPChain /* = ASURA_HASH_ID_UNSET*/ )
{
	return 0;
}

Asura_Handle Asura_Audio_System::Platform_CreateSubmixVoice( const bool bFilter, const bool bMusic,
	const Asura_Hash_ID uDSPChain /* = ASURA_HASH_ID_UNSET*/ )
{
	return 0;
}

Asura_Audio_Voice* Asura_Audio_System::Platform_GetVoice( const Asura_Handle iVoiceHandle )
{
	return NULL; 
}

bool Asura_Audio_System::Platform_LoadWave( Asura_Chunk_Stream& xStream, const u_int uFileSize,
	const u_int uSubType, const u_int uFlags, const char* const szFilename )
{
	return false;
}

#if defined ASURA_AUDIO_STORE_FILENAMES

const char* Asura_Audio_System::Platform_GetWaveFilename( const Asura_Hash_ID uWave )
{
	return NULL;
}

#endif // defined ASURA_AUDIO_STORE_FILENAMES

#endif // defined ASURA_USE_AUDIO_SYSTEM
