//*******************************************************************
//
// File: Asura_Direct3D_Botanicals_Game_Render_MakeData.cpp
//
// Created: 13 Mar 2006
//
// Description: 
//
//*******************************************************************

// system libraries
#include "Core/Asura.h"

#if defined( ASURA_USE_BOTANICALS)

// main header
#include "Botanical/Asura_Direct3D_Botanicals_Game_Render.h"

// other libraries
#include "Botanical/Asura_Direct3D_Botanicals_Game_Render_Manager.h"

#if defined( ASURA_BOTANICAL_SUPPORT_INTERACTIVE)
	#include "Botanicals/Asura_Botanical_Game_Render_Type_BasicInteractive.h"
#endif

#include "Core/Memory/Asura_Mem.h"

//*******************************************************************
// Constants
//*******************************************************************

#if !defined( ASURA_DIRECT3D_BGR_RENDER_CACHE_SIZE)
#define ASURA_DIRECT3D_BGR_RENDER_CACHE_SIZE 1000
#endif

#if !defined( ASURA_DIRECT3D_BGR_DYNAMIC_LIGHT_CACHE_SIZE)
#define ASURA_DIRECT3D_BGR_DYNAMIC_LIGHT_CACHE_SIZE ASURA_DIRECT3D_BGR_RENDER_CACHE_SIZE
#endif

//*******************************************************************
// Local Classes
//*******************************************************************

//*******************************************************************
// Local Data
//*******************************************************************

//*******************************************************************
// Function Definitions
//*******************************************************************

Asura_Direct3D_BGR_DynamicLightCache::Asura_Direct3D_BGR_DynamicLightCache() :
#if defined( ASURA_DIRECT3D_BGR_SUPPORT_IMPOSTERS)
	m_xDIPCache( Asura_Direct3D_BGR_Manager::DrawTreeBillboardInstancesDIPCache, 0),
#endif
	m_xCacheInstances(ASURA_DIRECT3D_BGR_DYNAMIC_LIGHT_CACHE_SIZE)
{
}

bool Asura_Direct3D_BGR_DynamicLightCache::ClearDirect3DData()
{
#if defined( ASURA_DIRECT3D_BGR_SUPPORT_SM30) && 1 == ASURA_DIRECT3D_BGR_SUPPORT_SM30
	if( false == this->m_xCacheVertexGeometrys.ClearDirect3DData())
	{
		return( false);
	}
	if( false == this->m_xCacheIndexGeometrys.ClearDirect3DData())
	{
		return( false);
	}
#endif
	return( true);
}

bool Asura_Direct3D_BGR_DynamicLightCache::CreateDirect3DData()
{
#if defined( ASURA_DIRECT3D_BGR_SUPPORT_SM30) && 1 == ASURA_DIRECT3D_BGR_SUPPORT_SM30
	if( false == this->m_xCacheVertexGeometrys.CreateDirect3DData())
	{
		return( false);
	}
	if( false == this->m_xCacheIndexGeometrys.CreateDirect3DData())
	{
		return( false);
	}
#endif
	return( true);
}

Asura_Direct3D_BGR_RenderCache::Asura_Direct3D_BGR_RenderCache() :
#if defined( ASURA_DIRECT3D_BGR_SUPPORT_IMPOSTERS)
	m_xDIPCache( Asura_Direct3D_BGR_Manager::DrawTreeBillboardInstancesDIPCache, 0),
#endif
	m_xCacheInstances(ASURA_DIRECT3D_BGR_RENDER_CACHE_SIZE)
{
	this->m_xArray_xDynamicLightCache.SetSize( ASURA_MAX_NO_OF_LOCAL_PHOTONS);
}

#if defined( ASURA_BOTANICAL_SUPPORT_SECTION_VERSIONS) && 1 == ASURA_BOTANICAL_SUPPORT_SECTION_VERSIONS
u_int Asura_Direct3D_BGR_Type::GetSectionCount() const
{
	return( this->m_xArray_xSections.Size());
}
#endif

#if defined( ASURA_BOTANICAL_SUPPORT_SECTION_VERSIONS) && 1 == ASURA_BOTANICAL_SUPPORT_SECTION_VERSIONS
Asura_BGR_Section_ID Asura_Direct3D_BGR_Type::GetSectionID( const Asura_Hash_ID& xHashID) const
{
	Asura_BGR_Section_ID* pxSectionID = this->m_xHashTree_xSectionID.GetDataByHash( xHashID);
	if( NULL == pxSectionID)
	{
		return( ASURA_BGR_SECTION_ID_INVALID);
	}

	return( *pxSectionID);
}
#endif

#if defined( ASURA_BOTANICAL_SUPPORT_SECTION_VERSIONS) && 1 == ASURA_BOTANICAL_SUPPORT_SECTION_VERSIONS
Asura_BGR_Version_ID Asura_Direct3D_BGR_Type::GetVersionID( const Asura_Hash_ID& xHashID) const
{
	Asura_BGR_Version_ID* pxVersionID = this->m_xHashTree_xVersionID.GetDataByHash( xHashID);
	if( NULL == pxVersionID)
	{
		return( ASURA_BGR_VERSION_ID_OFF);
	}
	
	return( *pxVersionID);
}
#endif
	
#if (defined( ASURA_BOTANICAL_SUPPORT_SECTION_VERSIONS) && 1 == ASURA_BOTANICAL_SUPPORT_SECTION_VERSIONS) && defined( ASURA_TOOLS)
Asura_BGR_Section_ID Asura_Direct3D_BGR_Type::GetSectionID( const char* pszSectionName) const
{
	Asura_Hash_ID xSectionHashID = Asura_GetHashID( pszSectionName);
	
	return( this->GetSectionID( xSectionHashID));
}
#endif

#if (defined( ASURA_BOTANICAL_SUPPORT_SECTION_VERSIONS) && 1 == ASURA_BOTANICAL_SUPPORT_SECTION_VERSIONS) && defined( ASURA_TOOLS)
Asura_BGR_Version_ID Asura_Direct3D_BGR_Type::GetVersionID( const char* pszVersionName) const
{
	Asura_Hash_ID xVersionHashID = Asura_GetHashID( pszVersionName);
	
	return( this->GetVersionID( xVersionHashID));
}
#endif

#if defined( ASURA_BOTANICAL_SUPPORT_SECTION_VERSIONS) && 1 == ASURA_BOTANICAL_SUPPORT_SECTION_VERSIONS
void Asura_Direct3D_BGR_RenderCache::CreateSectionCache( const Asura_Direct3D_BGR_Manager& xBGRManager)
{
	const u_int uSectionCount = xBGRManager.m_xArraySection_xVersionCountMax.Size();
	
	this->m_xArraySection_xArrayVersion_bUsed.Clear();
	this->m_xArraySection_xArrayVersion_bUsed.SetSize( uSectionCount);
	for( u_int uSectionIndex = 0; uSectionIndex < uSectionCount; uSectionIndex += 1)
	{
		Asura_Botanical_Array< bool>& xArrayVersion_bUsed = this->m_xArraySection_xArrayVersion_bUsed[ uSectionIndex];
		
		u_int uVersionSize = xBGRManager.m_xArraySection_xVersionCountMax[ uSectionIndex];
		xArrayVersion_bUsed.SetSize( uVersionSize);
	}
}
#endif

Asura_Direct3D_BGR_Geometry::Asura_Direct3D_BGR_Geometry()
{
}

Asura_Direct3D_BGR_Geometry::~Asura_Direct3D_BGR_Geometry()
{
}

Asura_Direct3D_BGR_Type::Asura_Direct3D_BGR_Type()
{
#if defined( ASURA_DIRECT3D_BGR_SUPPORT_IMPOSTERS) || defined( ASURA_DIRECT3D_BGR_SUPPORT_IMPOSTERS_INTERACTIVE)
	this->m_bHasImposters = false;
#endif
#if defined( ASURA_TOOLS)
	this->m_bHidden = false;
#endif
}

Asura_Direct3D_BGR_Type::~Asura_Direct3D_BGR_Type()
{
#if defined( ASURA_BOTANICAL_SUPPORT_INTERACTIVE)
	this->ClearBasicInteractive();
#endif
}

Asura_Direct3D_BGR_Manager::Asura_Direct3D_BGR_Manager()
{
	this->Init();
}

Asura_Direct3D_BGR_Manager::~Asura_Direct3D_BGR_Manager()
{
	this->Clear();
}

void Asura_Direct3D_BGR_Manager::Init()
{	
	this->m_bDrawGlobalRenderStatesSet = false;
	this->m_bDirect3DImpostersOutofDate = false;
	this->m_iAttenuationMap = ASURA_TEXTURE_INVALID;
	
#if defined( ASURA_DIRECT3D_BGR_SUPPORT_SM30) && 1 == ASURA_DIRECT3D_BGR_SUPPORT_SM30
	this->m_pxVertexDeclaration_3DGeom = NULL;
	this->m_pxVertexDeclaration_Leaf = NULL;
	this->m_pxVertexDeclaration_Imposter = NULL;
	this->m_pxVertexDeclaration_Interactive_Imposter = NULL;
#endif
}

// MGH 21/1/2008:  Free up all of the allocated memory and return the BGR manager to the state
// it was in before doing the first level load. This is to prevent memory fragmentation.
void Asura_Direct3D_BGR_Manager::Platform_Reset()
{
	Clear();
#if defined( ASURA_BOTANICAL_SUPPORT_SECTION_VERSIONS) && 1 == ASURA_BOTANICAL_SUPPORT_SECTION_VERSIONS
	m_xArraySection_xVersionCountMax.Clear();
#endif
	m_xRenderCache.Reset();
}

void Asura_Direct3D_BGR_Manager::Clear()
{
	this->ClearDirect3DData();
	
	this->m_xArray_xTypes.Clear();
	
	const uint32 uInstanceHeaderCount = this->m_xArray_pxInstanceHeaders.Size();
	for( uint32 uInstanceHeaderIndex = 0; uInstanceHeaderIndex < uInstanceHeaderCount; uInstanceHeaderIndex += 1)
	{
		Asura_Direct3D_BGR_Instances_Header*& pxInstanceHeader = this->m_xArray_pxInstanceHeaders[ uInstanceHeaderIndex];
		if( NULL == pxInstanceHeader)
		{
			continue;
		}
		
		this->DeleteInstanceHeader( pxInstanceHeader);
	}
	
	this->m_xArray_xModule.Clear();
	this->m_xArray_pxInstanceHeaders.Clear();
	this->m_xArrayTypeCache.Clear();
	this->m_xRenderCache.Clear();
}

void Asura_Direct3D_BGR_Manager::DeleteInstanceHeader( Asura_Direct3D_BGR_Instances_Header*& pxInstanceHeader)
{
#if defined( ASURA_BOTANICAL_SUPPORT_DYNAMIC_DATA) && 1 == ASURA_BOTANICAL_SUPPORT_DYNAMIC_DATA
	pxInstanceHeader->DeallocateDynamicData();
#endif
	
	delete pxInstanceHeader;
	
	pxInstanceHeader = NULL;
}

Asura_Direct3D_BGR_Instances_Header* Asura_Direct3D_BGR_Manager::CreateInstanceHeader( const uint32 uInstanceCount)
{
	Asura_Direct3D_BGR_Instances_Header* pxInstanceHeader = new Asura_Direct3D_BGR_Instances_Header;
	
	Asura_BGR_TypeID xTypeID;
	
	xTypeID.Clear();
	
	pxInstanceHeader->SetType( xTypeID);
	pxInstanceHeader->m_xArrayInstances.SetSize( uInstanceCount);
    pxInstanceHeader->m_xInstanceVisQueries.SetSize( uInstanceCount );
	
	pxInstanceHeader->m_uImposterIBSize = 0;
	pxInstanceHeader->m_uImposterIBStart = 0;
	pxInstanceHeader->m_uImposterVBOffset = 0;
	pxInstanceHeader->m_uImposterVBSize = 0;
	pxInstanceHeader->m_uImposterVBStart = 0;
	
#if defined( ASURA_BOTANICAL_SUPPORT_DYNAMIC_DATA) && 1 == ASURA_BOTANICAL_SUPPORT_DYNAMIC_DATA
	pxInstanceHeader->ClearDynamicData();
#endif

	return( pxInstanceHeader);
}

bool Asura_Direct3D_Botanicals_Game_Render::ClearDataSet()
{
	Asura_Direct3D_BGR_Manager& xBGRManager = GetDirect3DBGRManager();
	
	xBGRManager.Clear();
	
	return( true);
}

void Asura_Direct3D_BGR_Type::CalcBoundingZeroRadius()
{
	const Asura_Bounding_Box& xBoundingBox = this->m_xBoundingBox;
	const Asura_Vector_3 xBBMin = xBoundingBox.GetMin();
	const Asura_Vector_3 xBBMax = xBoundingBox.GetMax();
	
	float fRadius = 0;
	
	fRadius = Asura_Maths::Max( fRadius, Asura_Vector_3( xBBMin.GetX(), xBBMin.GetY(), xBBMin.GetZ()).Magnitude());
	fRadius = Asura_Maths::Max( fRadius, Asura_Vector_3( xBBMin.GetX(), xBBMin.GetY(), xBBMax.GetZ()).Magnitude());
	fRadius = Asura_Maths::Max( fRadius, Asura_Vector_3( xBBMin.GetX(), xBBMax.GetY(), xBBMin.GetZ()).Magnitude());
	fRadius = Asura_Maths::Max( fRadius, Asura_Vector_3( xBBMin.GetX(), xBBMax.GetY(), xBBMax.GetZ()).Magnitude());
	
	fRadius = Asura_Maths::Max( fRadius, Asura_Vector_3( xBBMax.GetX(), xBBMin.GetY(), xBBMin.GetZ()).Magnitude());
	fRadius = Asura_Maths::Max( fRadius, Asura_Vector_3( xBBMax.GetX(), xBBMin.GetY(), xBBMax.GetZ()).Magnitude());
	fRadius = Asura_Maths::Max( fRadius, Asura_Vector_3( xBBMax.GetX(), xBBMax.GetY(), xBBMin.GetZ()).Magnitude());
	fRadius = Asura_Maths::Max( fRadius, Asura_Vector_3( xBBMax.GetX(), xBBMax.GetY(), xBBMax.GetZ()).Magnitude());
	
	this->m_fBoundingRadius = fRadius;
}

void Asura_Direct3D_BGR_Geometry::Clear()
{
#if defined( ASURA_DIRECT3D_BGR_SUPPORT_IMPOSTERS)
	this->m_xArrayBillboards.Clear();
#endif
#if defined( ASURA_DIRECT3D_BGR_SUPPORT_GEOMETRY3D)
	this->m_xArrayBranchs.Clear();
	this->m_xArrayFronds.Clear();
#endif
#if defined( ASURA_DIRECT3D_BGR_SUPPORT_LEAVES)
	this->m_xArrayLeaves.Clear();
#endif
	
}

void Asura_Direct3D_BGR_Type::ClearGeometry()
{
	this->m_xArray_xSections.Clear();
	
#if defined( ASURA_TOOLS)
	this->m_pxBotanicalToolShape = NULL;
#endif

#if defined( ASURA_DIRECT3D_BGR_SUPPORT_IMPOSTERS) || defined( ASURA_DIRECT3D_BGR_SUPPORT_IMPOSTERS_INTERACTIVE)
	this->m_bHasImposters = false;
#endif
}

void Asura_Direct3D_BGR_Type::Clear()
{
	this->ClearGeometry();
	
	this->m_xTypeID.Clear();
	
#if defined( ASURA_TOOLS)
	this->m_xName = "";
#endif

#if defined( ASURA_BOTANICAL_SUPPORT_INTERACTIVE)
	this->ClearBasicInteractive();
#endif
}

//*******************************************************************
//
// (c) 2006 Rebellion (Derby)
//
// Warning: This computer program is protected by copyright law and 
// international treaties. Unauthorized reproduction or distribution
// of this program, or any portion of it, may result in severe civil and
// criminal penalties, and will be prosecuted to the maximum extent 
// possible under the law.
//
//*******************************************************************

#endif //defined( ASURA_USE_BOTANICALS)
