//*******************************************************************
//
// File: Asura_Platform_Botanical_Game_Render_Instance.h
//
// Created: 15 December 2006 DLH
//
// Description: 
//
//*******************************************************************

#ifndef __ASURA_PLATFORM_BOTANICAL_GAME_RENDER_INSTANCE_H__
#define __ASURA_PLATFORM_BOTANICAL_GAME_RENDER_INSTANCE_H__

// other libraries

// internal dependencies

// forward declarations

//*******************************************************************
// Constants
//*******************************************************************

#define ASURA_DIRECT3D_BGR_INSTANCE_SCALE_MAX (4.0f)
#define ASURA_DIRECT3D_BGR_INSTANCE_SPHERICAL_MAX (2.0f)

#define ASURA_DIRECT3D_BGR_INSTANCE_ENABLE_COMPRESSED_DATA 

#if defined( ASURA_DIRECT3D_BGR_INSTANCE_ENABLE_COMPRESSED_DATA)
#define ASURA_DIRECT3D_BGR_INSTANCE_SPHERICAL_EXPAND (ASURA_DIRECT3D_BGR_INSTANCE_SPHERICAL_MAX / 128.0f)
#define ASURA_DIRECT3D_BGR_INSTANCE_SPHERICAL_COMPRESS (128.0f / ASURA_DIRECT3D_BGR_INSTANCE_SPHERICAL_MAX)

#define ASURA_DIRECT3D_BGR_INSTANCE_SCALE_EXPAND (ASURA_DIRECT3D_BGR_INSTANCE_SCALE_MAX / 128.0f)
#define ASURA_DIRECT3D_BGR_INSTANCE_SCALE_COMPRESS (128.0f / ASURA_DIRECT3D_BGR_INSTANCE_SCALE_MAX)
#endif

//*******************************************************************
// Class Definitions
//*******************************************************************
class Asura_Platform_BGR_Instance
{
public:
	bool IsVisible() const { return m_bVisible; }
	mutable bool m_bVisible;

protected:
#if defined( ASURA_TOOLS)
	bool  m_bActive;
	float m_fBrightness;
#endif

#if !defined( ASURA_DIRECT3D_BGR_INSTANCE_ENABLE_COMPRESSED_DATA)
	Asura_AVector3 m_xPosition;

	D3DXMATRIX m_xTransformMatrix;

	float m_fScale;

	float m_afSphericalR[4];
	float m_afSphericalG[4];
	float m_afSphericalB[4];
#else
	float m_afPosition[3];

	int8 m_aiTransformMatrix3x3[3][3];

	uint8 m_auSphericalR[4];
	uint8 m_auSphericalG[4];
	uint8 m_auSphericalB[4];

	float m_fDecompSHScale;
	float m_fDecompSHBias;
#endif
};

//*******************************************************************
// Inline Function Definitions
//*******************************************************************


//*******************************************************************
//
// (c) 2006 Rebellion
//
// Warning: This computer program is protected by copyright law and 
// international treaties. Unauthorized reproduction or distribution
// of this program, or any portion of it, may result in severe civil and
// criminal penalties, and will be prosecuted to the maximum extent 
// possible under the law.
//
//*******************************************************************

#endif // __ASURA_PLATFORM_BOTANICAL_GAME_RENDER_INSTANCE_H__
