//////////////////////////////////////////////////////////////////////////////
//
// Asura_Platform_CPUProfile.h
//
// Copyright (c) 2004 Rebellion. All rights reserved.
//
// Description:
//
//     PC defines for CPU profiling
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef ___ASURA_PLATFORM_CPUPROFILE_H___
#define ___ASURA_PLATFORM_CPUPROFILE_H___ 1

#if defined( ASURA_USE_PROFILING_SYSTEM)
	#include "Debugging/Asura_CPUProfile_Renderer.h"

	#define	ASURA_CPU_PROFILE__START(x)			Asura_CPUProfile_Renderer::StartProfile((x))
	#define	ASURA_CPU_PROFILE__END(x)			Asura_CPUProfile_Renderer::StopProfile((x))

	#define ASURA_CPU_PROFILE__START_LABEL(x,y) Asura_CPUProfile_Renderer::SetName((x),(y)); Asura_CPUProfile_Renderer::StartProfile((x))

#if defined( ASURA_USE_PROFILING_SYSTEM_MULTITHREADED)
	#define ASURA_CPU_PROFILE__START_THREAD( x)	Asura_CPUProfile_Renderer::StartThread( (x))
	#define ASURA_CPU_PROFILE__STOP_THREAD() Asura_CPUProfile_Renderer::StopThread()
#endif

#else // not profiling

	#define	ASURA_CPU_PROFILE__START(x)
	#define	ASURA_CPU_PROFILE__END(x)

#if defined( ASURA_USE_PROFILING_SYSTEM_MULTITHREADED)
	#define ASURA_CPU_PROFILE__START_THREAD( x)	
	#define ASURA_CPU_PROFILE__STOP_THREAD()
#endif

#endif // end else not profiling

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

#endif // #ifndef ___ASURA_PLATFORM_CPUPROFILE_H___
