///////////////////////////////////////////////////////////////////////////////
//
// File   : Asura_Platform_FMV.cpp
// Author : Jason Turner
//
// Copyright (C) 2009 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

//Asura main header
#include "Core/Asura.h"

// independent includes
#include "Core/Asura_UserInput.h"
#include "FMV/Asura_FMV.h"

// PC includes
#include "Core/Asura_Windows.h"

////////////////////////////////////////////////////////////////////////////////
//  Asura_FMV::Platform_Update
////////////////////////////////////////////////////////////////////////////////

bool Asura_FMV::Platform_Update()
{
	Asura_Windows::CheckForWindowsMessages();
	return true;
}

////////////////////////////////////////////////////////////////////////////////
//  Asura_FMV::Platform_CheckForFMVSkip
////////////////////////////////////////////////////////////////////////////////

bool Asura_FMV::Platform_CheckForFMVSkip()
{
	// Escape should probably always skip.
	if( Asura_UserInput::DebouncedKeyPressed(ASURA_KEYID_ESCAPE) ) { return true; }
	if( Asura_UserInput::DebouncedKeyPressed(ASURA_KEYID_SPACE) ) { return true; }
	if( Asura_UserInput::DebouncedKeyPressed(ASURA_KEYID_MOUSEBUTTON1) ) { return true; }
	if( Asura_UserInput::DebouncedKeyPressed(ASURA_KEYID_ENTER) ) { return true; }

	return false;
}

////////////////////////////////////////////////////////////////////////////////
//  Asura_FMV::Platform_PrePlay
////////////////////////////////////////////////////////////////////////////////

void Asura_FMV::Platform_PrePlay()
{
}

////////////////////////////////////////////////////////////////////////////////
//  Asura_FMV::Platform_PostPlay
////////////////////////////////////////////////////////////////////////////////

void Asura_FMV::Platform_PostPlay()
{
}

////////////////////////////////////////////////////////////////////////////////
