// Asura_Platform_Client.cpp
//
// Created by Richard Rice - 09/09/2003
// 
// Copyright (C) 2003 Rebellion, All Rights Reserved.
//

#include "Core/Asura.h"
#include "Network/Asura_Network.h"

#include "Network/Asura_Message.h"

#include "Network/Asura_PC_Message.h"

#ifdef ASURA_PC_SUPPORT_GCDKEY
#include "Network/Asura_PC_GCDKey.h"
#endif


bool Asura_Network::Platform_ClientMessageHandler(const Asura_Message* pxMessage)
{
	switch(pxMessage->GetMsgID())
	{
		#ifdef ASURA_PC_SUPPORT_GCDKEY
		case ASURA_PC_MSG_GCDCHALLENGE :
		{
			const Asura_Msg_GCD_Challenge* pxData = (const Asura_Msg_GCD_Challenge*)pxMessage->GetData();
			if(pxData)
			{
				Asura_PC_GCDKey::HandleGCDChallenge(pxMessage->From,pxData->m_szChallenge);
			}
			return true;
		}
		case ASURA_PC_MSG_GCDAUTHORISATION :
		{
			const Asura_Msg_GCD_Authorisation* pxData = (const Asura_Msg_GCD_Authorisation*)pxMessage->GetData();
			if(pxData)
			{
				Asura_PC_GCDKey::SetWaitingForAuthorisation(false);
				Asura_PC_GCDKey::SetAuthorised(pxData->m_ucAuthorised!=0);
				char* pszErrorMessage = (char*)(pxData+1);
				Asura_PC_GCDKey::SetErrorMessage(pszErrorMessage);
			}
			return true;
		}

		#endif //ASURA_PC_SUPPORT_GCDKEY
		default :
			break;
	}
	return false;
}
