/**
*
* \file Asura_Platform_Network_StatLogging.cpp
*
* Created by Richard May - 26/11/2003 15:13:25
*
* Copyright (C) 2002 Rebellion, All Rights Reserved.
*
* note: this file is used by PC and PS2 to interface with GameSpy's gstats
* SDK. It is currently shared on SourceSafe so must compile on both platforms.
*
* \brief
*
**/

/************/
/* Includes.*/
/************/

// main asura header
#include "Core/Asura.h"

// local header
#include "Network/Asura_Network_StatLogging.h"

// asura
#include "Network/Asura_Gamespy_StatLogging.h"

#ifdef ASURA_USE_NETWORK_STATLOGGING

/**************/
/* Functions. */
/**************/

/*************************************************************
 *
 * Name          : Asura_Network_StatLogging::Platform_Initialise
 *
 * Author        : Richard May
 *
 * Description   : PC/PS2 specific initialise function - connects to
 *				   the gamespy stat logging server
 *
 *************************************************************/
void Asura_Network_StatLogging::Platform_Initialise ( void )
{
	Asura_GameSpy_StatLogging::Initialise();
}
/* end of function Platform_Initialise */


/*************************************************************
 *
 * Name          : Asura_Network_StatLogging::Platform_Shutdown
 *
 * Author        : Richard May
 *
 * Description   : PC/PS2 specific shutdown - closes the connection
 *				   to the gamespy stat logging server
 *
 *************************************************************/
void Asura_Network_StatLogging::Platform_Shutdown ( void )
{
	Asura_GameSpy_StatLogging::Shutdown();
}
/* end of function Platform_Shutdown */


/*************************************************************
 *
 * Name          : Asura_Network_StatLogging::Platform_StartSession
 *
 * Author        : Richard May
 *
 * Description   : 
 *
 *************************************************************/
bool Asura_Network_StatLogging::Platform_StartSession ( void )
{
	return Asura_GameSpy_StatLogging::StartSession();
}
/* end of function Platform_StartSession */


/*************************************************************
 *
 * Name          : Asura_Network_StatLogging::Platform_EndSession
 *
 * Author        : Richard May
 *
 * Description   : 
 *
 *************************************************************/
void Asura_Network_StatLogging::Platform_EndSession ( void )
{
	Asura_GameSpy_StatLogging::EndSession();
}
/* end of function Platform_EndSession */


/*************************************************************
 *
 * Name          : Asura_Network_StatLogging::Platform_SendSnapshot
 *
 * Author        : Richard May
 *
 * Description   : Generates the gamespy-specific snapshot format
 *				   and sends it to the stat logging server
 *
 *************************************************************/
bool Asura_Network_StatLogging::Platform_SendSnapshot ( bool bGameEnd )
{
	return Asura_GameSpy_StatLogging::SendSnapshot(bGameEnd);
}
/* end of function Platform_SendSnapshot */

#endif // ASURA_USE_NETWORK_STATLOGGING

/****************/
/* End of file. */
/****************/
