//////////////////////////////////////////////////////////////////////////////
//
// Asura_Platform_FriendsList.cpp
//
// Copyright (c) 2008 Rebellion. All rights reserved.
//
// Description:
//
//     PC implementations of Asura_FriendsList functions
//
//////////////////////////////////////////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "Core/Asura.h"

#ifdef ASURA_SUPPORT_LOBBY

#include "Network/Online/Asura_Lobby.h"
#include "Network/Online/Asura_FriendsList.h"
#ifdef ASURA_PC_SUPPORT_STEAMWORKS
#include "Network/Steamworks/Asura_PC_Steamworks.h"
#include "Network/Steamworks/Asura_PC_SteamworksClient.h"
#endif
#include "Network/Online/Asura_Lobby.h"

void Asura_FriendsList::Platform_Initialise()
{}

void Asura_FriendsList::Platform_Shutdown()
{}

void Asura_FriendsList::Platform_Refresh()
{
}

bool Asura_FriendsList::Platform_ShowFriendsGUI()
{
#ifdef ASURA_PC_SUPPORT_STEAMWORKS
	if( Asura_PC_Steamworks::IsSteamworksEnabled() )
	{
		Asura_PC_Steamworks::ShowSteamOverlay( ASURA_PC_STEAMWORKS_OVERLAY_FRIENDS );
		return true;
	}
#endif

	return false;
}

bool Asura_FriendsList::Platform_IsPlayerAFriend(const Asura_Lobby_Player& xPlayer)
{
#ifdef ASURA_PC_SUPPORT_STEAMWORKS
	if( Asura_PC_Steamworks::IsSteamworksEnabled() )
	{
		return Asura_PC_SteamworksClient::IsFriend( CSteamID( xPlayer.GetPlatformData().m_uSteamID ) );
	}
#endif

	return false;
}

#endif // #ifdef ASURA_SUPPORT_LOBBY
