//////////////////////////////////////////////////////////////////////////////
//
// Asura_Platform_Lobby.h
//
// Copyright (c) 2008 Rebellion. All rights reserved.
//
// Description:
//
//     PC types for online lobby
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef ASURA_PLATFORM_LOBBY_H___
#define ASURA_PLATFORM_LOBBY_H___ 1

//Asura_Lobby_Types.h provides an dummy for Asura_Platform_Lobby_GameConnectData when
//lobby support is not enabled - PJC 14/04/09
#ifdef ASURA_SUPPORT_LOBBY

#include "Network/Asura_Platform_NetSocket.h"	// for Asura_NetAddress

class Asura_Platform_Lobby_LobbyData
{
public:
	u_int m_uSessionID; // only used for non steamworks
};

// KOR - in order to maintain compatibility, Asura_Platform_Lobby_ConnectData
// must be the same size and alignment for all platforms. Currently Xbox360
// gives the strictest limits with a size of 48 bytes with 8-byte alignment.

// sent to the game server along with connection attempt
class Asura_Platform_Lobby_GameConnectData
{
public:
	// only used for steamworks lobby
	uint64 m_uSteamID;
	
	// only used for non-steamworks lobby
	DWORD m_dwProcessID;
	Asura_Hash_ID m_uComputerName;
	
	// padding
	u_char m_aucDummy[24]; // total 40 bytes.
};

class Asura_Platform_Lobby_PlayerData
{
	public:

	Asura_Platform_Lobby_PlayerData() {}
	Asura_Platform_Lobby_PlayerData(const Asura_Platform_Lobby_PlayerData& xConnectData)
	{
		m_uSteamID = xConnectData.m_uSteamID;
		m_dwProcessID = xConnectData.m_dwProcessID;
		m_uComputerName = xConnectData.m_uComputerName;
	}

	// member data
	uint64 m_uSteamID;
	DWORD m_dwProcessID;
	Asura_Hash_ID m_uComputerName;

	bool operator==( const Asura_Platform_Lobby_GameConnectData& xOther ) const;
	bool operator==( const Asura_Platform_Lobby_PlayerData& xOther ) const;
};

class Asura_Platform_Lobby_ListEntry
{
	public:

		#ifdef ASURA_PC_SUPPORT_STEAMWORKS
		CSteamID m_xLobbySteamID;
		#endif

		// These should not be used when using steamworks, we simply need
		// them here in case steamworks is disabled
		Asura_NetAddress m_xAddress;
		u_short m_usPort; 

};

#endif

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

#endif // #ifndef ASURA_PLATFORM_LOBBY_H___
