//////////////////////////////////////////////////////////////////////////////
//
// Asura_PC_SteamworksStats.h
//
// Copyright (c) 2009 Rebellion. All rights reserved.
//
// Description:
//
//     Asura wrapper class for steam user stats storage
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef ASURA_PC_STEAMWORKSSTATS_H___
#define ASURA_PC_STEAMWORKSSTATS_H___ 1

#ifdef ASURA_PC_SUPPORT_STEAMWORKS

#include "Network/Steamworks/Asura_PC_Steamworks.h"

class Asura_PC_SteamworksStats
{
public:
	static void Initialise();
	static void Update();
	static void Shutdown();

	// NY - 21 April 2009 - returns true once stats data received from steam. stats, achievements and leaderboards cannot be used before then.
	static bool IsInitComplete();

	static void StoreStats();

	static void SetStat(const char* szStat, int iValue);
	static void IncrementStat(const char* szStat, int iIncrement);
	static void SetStat(const char* szStat, float fValue);
	static void IncrementStat(const char* szStat, float fIncrement);
	static void UpdateAverageStat(const char* szStat, float fIncrement, float fTimeIncrement);

	static int GetIntStat(const char* szStat);
	static float GetFloatStat(const char* szStat);

private:

	static Asura_PC_Steam_Callback< UserStatsReceived_t > s_xCallback_StatsReceived;
	static void Callback_StatsReceived ( const UserStatsReceived_t* const pxParam );

	static Asura_PC_Steam_Callback< UserStatsStored_t > s_xCallback_StatsStored;
	static void Callback_StatsStored ( const UserStatsStored_t* const pxParam );

	static bool s_bStatsRequested;
	static bool s_bStatsReceived;
	static bool s_bStoreStats;
};

#endif // #ifdef ASURA_PC_SUPPORT_STEAMWORKS

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

#endif // #ifndef ASURA_PC_STEAMWORKSSTATS_H___
