
///////////////////////////////////////////////////////////////////////////////
//
// File   : Asura_PSP_SCEUtility_FileListHandler.h
// Author : Andy Tate
// Date   : 5-Oct-2005
//
// Copyright (C) 2005 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __ASURA_PSP_SCEUTILITY_FILELISTHANDLER_H__
#define __ASURA_PSP_SCEUTILITY_FILELISTHANDLER_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Core/Asura_PlatformBasics.h"

#include "PSPEmul/SCEUtility/Asura_PSP_SCEUtility_FileData.h"
#include "PSPEmul/SCEUtility/Asura_PSP_SCEUtility_Handler.h"


////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

class Asura_PSP_SCEUtility_FileListHandler : public Asura_PSP_SCEUtility_Handler
{
public:
	// Public functions...

	Asura_PSP_SCEUtility_FileListHandler          (const Asura_UnicodeChar* wszTitle, const int iMaxSlots, const bool bDisplayEmpty);
	virtual ~Asura_PSP_SCEUtility_FileListHandler ();

	// Virtual functions...
	virtual	bool									Update					(bool& bCancelled);
	virtual	void									Render					(void);


protected:
	// Protected variables...

	// The title for the screen...
	const Asura_UnicodeChar*		m_wszTitle;

	// Flag for displaying empty slots...
	bool							m_bDisplayEmpty;

	// Current slot data...
	int								m_iMaxSlots;
	int								m_iNumSlots;
	int								m_iCurrentSlot;
	Asura_PSP_SCEUtility_FileData**	m_ppxFileData;


	// Protected functions...

	// Abstract functions...
	virtual	bool									OnSelect				(Asura_PSP_SCEUtility_FileData& xFileData)	= 0;

	// Virtual functions...
	virtual void									RenderTitle				(const float fScreenScale) const;
	virtual void									RenderNoSlotsMessage	(const float fScreenScale) const;
	virtual	void									RenderSlot				(const float fScreenScale, const Asura_PSP_SCEUtility_FileData& xFileData) const;
	virtual	void									RenderEmptySlot			(const float fScreenScale, const Asura_PSP_SCEUtility_FileData& xFileData) const;

	// List manipulation functions...
			void									DeleteList				(void);
			void									RefreshList				(void);


private:
	// Private variables...


	// Private functions...

	Asura_PSP_SCEUtility_FileListHandler  (void);
	Asura_PSP_SCEUtility_FileListHandler  (const Asura_PSP_SCEUtility_FileListHandler& xOther);

			Asura_PSP_SCEUtility_FileListHandler&	operator=				(const Asura_PSP_SCEUtility_FileListHandler& xOther);

};   // End of class 'Asura_PSP_SCEUtility_FileListHandler'.


#endif   // ifndef __ASURA_PSP_SCEUTILITY_FILELISTHANDLER_H__


/// End of file. ///
