//////////////////////////////////////////////////////////////////////////////
//
// Asura_Direct3D_HDR.h
//
// Copyright (c) 2007 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

#if defined ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#if !defined __ASURA_DIRECT3D_HDR_H__
#define __ASURA_DIRECT3D_HDR_H__

#if defined ASURA_USE_HDR

/******************************************************************************/
/* Classes                                                                    */
/******************************************************************************/

////////////////////////////////////////////////////////////////////////////////
//
// Asura_Direct3D_HDR
//
// Class for managing HDR rendering on PC
//
////////////////////////////////////////////////////////////////////////////////

class Asura_Direct3D_HDR
{
public:

	static void Initialise();
	static void Shutdown();
	static bool PreReset(void*p=NULL);
	static bool PostReset(void*p=NULL);

	static void ApplyToneMapping();

#if defined ASURA_TOOLS
	// NB This is asynchronous. Result won't be updated till next render call
	static void CaptureFixedLuminance( float& fResult );

	struct HDR_Histogram_Data {
		u_int m_auR[256];
		u_int m_auG[256];
		u_int m_auB[256];
		u_int m_auL[256];

		u_int m_uRHeight;
		u_int m_uGHeight;
		u_int m_uBHeight;
		u_int m_uLHeight;

		u_int m_uAppDefined;
	};

	// NB This is asynchronous. Result won't be updated till next render call
	static void SetPreToneMapHDRHistogramCallback( void (*pCb)(const HDR_Histogram_Data &xData), u_int uAppDefined);
	static void SetPreToneMapHDRHistogramRange( float fRange);
	static void SetPostToneMapHDRHistogramCallback( void (*pCb)(const HDR_Histogram_Data &xData), u_int uAppDefined);
	static void SetPostToneMapHDRHistogramRange( float fRange);

	// For the Tools options overlay
	static bool* GetShowRegionVar();
#endif
};

#endif // !defined __ASURA_DIRECT3D_HDR_H__

#endif // defined ASURA_USE_HDR
