/**
*
* \file Asura_PlatformRenderWater.h
*
* Created by Robert Dibley - 16/11/2004 14:18:36
*
* Copyright (C) 2004 Rebellion, All Rights Reserved.
*
* \brief
*
**/

//*********************************************
//** NOTE : DUMMY PC VERSION, NO ACTIVE CODE **
//*********************************************

#ifndef __ASURA_PLATFORM_RENDER_WATER_H__
#define __ASURA_PLATFORM_RENDER_WATER_H__

#include "Core/Asura.h"
#include "Rendering/Asura_Water.h"

#include "Rendering/Asura_Direct3D.h"

#ifdef ASURA_USE_WATER

struct Asura_PC_Water_Vertex
{
	Asura_Vector_3	m_xPosition;
	D3DCOLOR		m_xColour;
	float			m_afTexCoords[2];
};

// container class for the data packets
class Asura_Platform_Water_Packet
{
public:

	friend class Asura_Water_System;

	Asura_Platform_Water_Packet();
	~Asura_Platform_Water_Packet();

	void Reset( void );

	void SetVertexCount(u_int uVertexCount);

	void AddVertex(float x, float y, float z, float r, float g, float b, float u, float v);

	void Close( void );

protected:
	u_int m_uVertexCount;
	u_int m_uVerticesWritten;
	Direct3D_VertexBuffer* m_pxVertices;
	Asura_PC_Water_Vertex* m_pxNextVertexToWrite;
};
// End class Asura_Platform_Water_Packet

const float fWATER_SYSTEM_REQUIRED_PIXEL_SHADER = 1.4f;

#endif

#endif
