//
// Asura_Platform_DisplayLimits.cpp
//
// Created by RJF - 24 August 2006
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//

#include "Core/Asura.h"

// This file's header.
#include "Rendering/Asura_DisplayLimits.h"

#include "Rendering/Asura_Viewport.h"

#include "Core/Asura_Windows.h"
#include "Rendering/Asura_Direct3D.h"
#include "Rendering/Asura_Direct3D_UserOptions.h"

Asura_Bounding_Rectangle Asura_DisplayLimits::Platform_GetPrimaryDisplayBounds()
{
#ifdef ASURA_SUPPORT_MULTIPLE_MONITORS
	if(Asura_Direct3D_UserOptions::GetMultiheadEnabled() && Asura_Windows::RunningFullScreen())
	{
		return Asura_Direct3D::GetSwapChainDisplayLimits(0);
	}
	else
#endif
	{
		return Asura_Bounding_Rectangle(0, 
										0, 
										static_cast<float>(Asura_Viewport::GetWidth()),
										static_cast<float>(Asura_Viewport::GetHeight())
									   );
	}
}

Asura_Bounding_Rectangle Asura_DisplayLimits::Platform_GetBoundingRectangle()
{
#ifdef ASURA_SUPPORT_MULTIPLE_MONITORS
	if(Asura_Direct3D_UserOptions::GetMultiheadEnabled() && Asura_Windows::RunningFullScreen())
	{
		Asura_Bounding_Rectangle xLimits = Asura_Direct3D::GetSwapChainDisplayLimits(0);
		for(u_int u = 1; u < Asura_Direct3D::GetNumSwapChains(); ++u)
		{
			Asura_Bounding_Rectangle xNewRect = Asura_Direct3D::GetSwapChainDisplayLimits(u);
			xLimits.MinX = Asura_Maths::Min(xLimits.MinX, xNewRect.MinX);
			xLimits.MaxX = Asura_Maths::Max(xLimits.MaxX, xNewRect.MaxX);
			xLimits.MinY = Asura_Maths::Min(xLimits.MinY, xNewRect.MinY);
			xLimits.MaxY = Asura_Maths::Max(xLimits.MaxY, xNewRect.MaxY);
		}
		return xLimits;
	}
	else
#endif
	return Platform_GetPrimaryDisplayBounds();
}

