//////////////////////////////////////////////////////////////////////////////
//
// Asura_Platform_Fog.cpp
//
// Copyright (c) 2004 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "Core/Asura.h"

// Engine independent.
#include "Rendering/Asura_Fog.h"

#if defined(ASURA_TARGET_SM3)
#include "Rendering/Asura_Direct3D_Fog.h"
#else
#include "SpecialFX/Asura_Skybox.h"
#endif

// C L A S S   I M P L E M E N T A T I O N S /////////////////////////////////

void Asura_Fog::Platform_UpdateForNewParameters( void )
{
#if defined(ASURA_TARGET_SM3)
	Asura_Direct3D_Fog::UpdateForNewParameters();
#else
	// Skybox needs to know how fogged it is.
	Asura_Skybox::RequestRenderSetup();
#endif
}

void Asura_Fog::Platform_Render( void )
{
#if defined(ASURA_TARGET_SM3)
	Asura_Direct3D_Fog::Render();
#endif
}
