//////////////////////////////////////////////////////////////////////////////////////////
//
//  FILE        :  Asura_D3D_PS_ShadowMapping_DepthTexture.cpp
//
//  CREATED     :  Richard J. Fine  (16.11.2004)
//
//  Copyright (C) 2004 Rebellion, All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////////////////


#include "Core/Asura.h"

// This file's header.
#include "Rendering/Asura_Direct3D_Shaders.h"

const char* const szPS_SHADOWMAPPING_CODE =

"ps.1.1 \n"

// write 0x00 for no change
// and 0xFF for full black

"texkill t0 \n"
"texkill t1 \n"
"tex t2 \n"
// t1 == 0x00 if we are in shadow, 0xFF if we are not
"texcoord t3 \n"
// t2 == scaled distance from base plane

// assuming that we are in shadow, t1 is the fade value for it
"mul r0, 1-t2, t3 \n"
"mul r0, r0, v0 \n";

// Register the shader with Asura

const Asura_Direct3D_PixelShader xPS_SHADOWMAPPING_SHADER(ASURA_D3D_PS_SHADOWMAPPING_DEPTHTEXTURE, szPS_SHADOWMAPPING_CODE);
