//
// Asura_D3D_PS_Specular.cpp
//
// Created by RJF - 21 June 2005
//
// Copyright (C) 2005 Rebellion, All Rights Reserved.
//

#include "Core/Asura.h"

// This file's header.
#include "Rendering/Asura_Direct3D_Shaders.h"

const Asura_Direct3D_PixelShader xSHADER_SPECSOFT(ASURA_D3D_PS_SPECULAR_SOFT,
"ps_1_1						\n" // 
"tex t0						\n" // Base texture
"texcoord t1				\n" // Direction to camera
"texcoord t2				\n" // Normal
"dp3_sat r0, t1_bx2, t2_bx2	\n" // r1 = N.V clamped to [0,1]
"mul r0.w, r0.w, r0.w		\n" // ^2
"mul r0.w, r0.w, r0.w		\n" // ^4
"mul r0.w, r0.w, r0.w		\n" // ^8
"mul r0.w, t0.w, r0.w		\n" // ^8 * texalpha
"mul r0, c2, r0.w			\n" // ^8 * texalpha * spec colour
"mul_x2 r1.xyz, t0, v0		\n" // tex * lighting * 2
"mad r0.xyz, r0, v0, r1		\n" // lighting * ^8 * texalpha * spec colour + tex * lighting * 2
"+ mov r0.w, v0.w			\n" // alpha = lightingalpha
);

const Asura_Direct3D_PixelShader xSHADER_SPECSHARP(ASURA_D3D_PS_SPECULAR_SHARP,
"ps_1_1						\n" // 
"tex t0						\n" // Base texture
"texcoord t1				\n" // Direction to camera
"texcoord t2				\n" // Normal
"dp3_sat r0, t1_bx2, t2_bx2	\n" // r1 = N.V clamped to [0,1]
"mul r0.w, r0.w, r0.w		\n" // ^2
"mul r0.w, r0.w, r0.w		\n" // ^4
"mul r0.w, r0.w, r0.w		\n" // ^8
"mul r0.w, r0.w, r0.w		\n" // ^16
"mul r0.w, r0.w, r0.w		\n" // ^32
"mul r0.w, t0.w, r0.w		\n" // ^32 * texalpha
"+ mul_x2 r1.xyz, t0, v0	\n" // tex * lighting * 2
"mad r0.xyz, r0.w, v0, r1	\n" // lighting * ^32 * texalpha + tex * lighting * 2
"+ mov r0.w, v0.w			\n" // alpha = lightingalpha
);

const Asura_Direct3D_PixelShader xSHADER_SPECSOFTTEXALPHA(ASURA_D3D_PS_SPECULAR_SOFT_TEXALPHA,
"ps_1_1						\n" // 
"tex t0						\n" // Base texture
"texcoord t1				\n" // Direction to camera
"texcoord t2				\n" // Normal
"dp3_sat r0, t1_bx2, t2_bx2	\n" // r1 = N.V clamped to [0,1]
"mul r0.w, r0.w, r0.w		\n" // ^2
"mul r0.w, r0.w, r0.w		\n" // ^4
"mul r0.w, r0.w, r0.w		\n" // ^8
"mul r0.w, t0.w, r0.w		\n" // ^8 * texalpha
"+ mul_x2 r1.xyz, t0, v0	\n" // tex * lighting * 2
"mad r0.xyz, r0.w, v0, r1	\n" // lighting * ^8 * texalpha + tex * lighting * 2
"+ mul r0.w, v0.w, t0.w		\n" // alpha = lightingalpha
);

const Asura_Direct3D_PixelShader xSHADER_SPECSHARPTEXALPHA(ASURA_D3D_PS_SPECULAR_SHARP_TEXALPHA,
"ps_1_1						\n" // 
"tex t0						\n" // Base texture
"texcoord t1				\n" // Direction to camera
"texcoord t2				\n" // Normal
"dp3_sat r0, t1_bx2, t2_bx2	\n" // r1 = N.V clamped to [0,1]
"mul r0.w, r0.w, r0.w		\n" // ^2
"mul r0.w, r0.w, r0.w		\n" // ^4
"mul r0.w, r0.w, r0.w		\n" // ^8
"mul r0.w, r0.w, r0.w		\n" // ^16
"mul r0.w, r0.w, r0.w		\n" // ^32
"mul r0.w, t0.w, r0.w		\n" // ^32 * texalpha
"+ mul_x2 r1.xyz, t0, v0	\n" // tex * lighting * 2
"mad r0.xyz, r0.w, v0, r1	\n" // lighting * ^32 * texalpha + tex * lighting * 2
"+ mul r0.w, v0.w, t0.w		\n" // alpha = lightingalpha
);
