//*******************************************************************
//
// File: Asura_D3D_VS_Cubic.cpp              
//
// Created: 23 Feb 2006
//
// Description: 
//
//*******************************************************************

// system libraries
#include "Core/Asura.h"

#if defined( ASURA_USE_FSFX)

// main header
#include "Rendering/Asura_Direct3D_Shaders.h"

// other libraries

// internal dependencies

//*******************************************************************
// Constants
//*******************************************************************


//*******************************************************************
// Local Classes
//*******************************************************************


//*******************************************************************
// Local Data
//*******************************************************************

// Vertex Declarator

static Direct3D_VertexElement auVSD[] =
{
	{ 0,	0,	D3DDECLTYPE_FLOAT3,	D3DDECLMETHOD_DEFAULT,	D3DDECLUSAGE_POSITION,	0 },
	{ 0,   12,	D3DDECLTYPE_FLOAT2,	D3DDECLMETHOD_DEFAULT,	D3DDECLUSAGE_TEXCOORD,	0 },
	D3DDECL_END()
};

//Apply Blur shader
//expected constants:
// c0-c3	Texcoord offsets
const char* const g_szVS_CUBIC_CODE =

"vs.1.1 \n"
"dcl_position0 v0 \n"
"dcl_texcoord0 v1 \n"

"mov oPos, v0 \n"
"mov oT0, v1 \n"
"\n";

//register it with Asura
const Asura_Direct3D_VertexShader g_xVS_CUBIC_SHADER( ASURA_D3D_VS_CUBIC, g_szVS_CUBIC_CODE, auVSD);
const Asura_Direct3D_VertexShader g_xVS_QUADRATIC_SHADER( ASURA_D3D_VS_QUADRATIC, g_szVS_CUBIC_CODE, auVSD);
const Asura_Direct3D_VertexShader g_xVS_LINEAR_SHADER( ASURA_D3D_VS_LINEAR, g_szVS_CUBIC_CODE, auVSD);

//*******************************************************************
// Function Definitions
//*******************************************************************


//*******************************************************************
//
// (c) 2006 Rebellion (Derby)
//
// Warning: This computer program is protected by copyright law and 
// international treaties. Unauthorized reproduction or distribution
// of this program, or any portion of it, may result in severe civil and
// criminal penalties, and will be prosecuted to the maximum extent 
// possible under the law.
//
//*******************************************************************

#endif //defined( ASURA_USE_FSFX)
