//
// Asura_D3D_VS_Glow.cpp
//
// Created by RJF - 14 September 2004
//
// Copyright (C) 2004 Rebellion, All Rights Reserved.
//

#include "Core/Asura.h"

// This file's header.
#include "Rendering/Asura_Direct3D_Shaders.h"

// Vertex Declarator
// (Shared by both shaders in the file)

static Direct3D_VertexElement auVSD[] =
{
	{ 0,	0,	D3DDECLTYPE_FLOAT3,	D3DDECLMETHOD_DEFAULT,	D3DDECLUSAGE_POSITION,	0 },
	{ 0,   12,	D3DDECLTYPE_FLOAT2,	D3DDECLMETHOD_DEFAULT,	D3DDECLUSAGE_TEXCOORD,	0 },
	D3DDECL_END()
};

// Extract Glow shader
// expected constants: none
const char* const g_szVS_EXTRACT_GLOW_CODE =

"vs.1.1 \n"
"dcl_position0 v0 \n"
"dcl_texcoord0 v1 \n"

"mov oPos, v0 \n"
"mov oT0, v1 \n";

//register the shader with Asura
const Asura_Direct3D_VertexShader g_xVS_EXTRACT_GLOW_SHADER(ASURA_D3D_VS_EXTRACTGLOW, g_szVS_EXTRACT_GLOW_CODE, auVSD);

//Apply Blur shader
//expected constants:
// c0-c3	Texcoord offsets
const char* const g_szVS_APPLY_BLUR_CODE =

"vs.1.1 \n"
"dcl_position0 v0 \n"
"dcl_texcoord0 v1 \n"

"mov oPos, v0 \n"
"add oT0, v1, c0 \n"
"add oT1, v1, c1 \n"
"add oT2, v1, c2 \n"
"add oT3, v1, c3 \n";

//register it with Asura
const Asura_Direct3D_VertexShader g_xVS_APPLY_BLUR_SHADER(ASURA_D3D_VS_APPLYBLUR, g_szVS_APPLY_BLUR_CODE, auVSD);
