/**
*
* \file Asura_D3D_VS_Skin_3Lights.cpp
*
* Created by Kevin Lea - 07/10/2002 10:34:07
*
* Copyright (C) 2002 Rebellion, All Rights Reserved.
*
* \brief
*
**/

#include "Core/Asura.h"

#include "Rendering/Asura_Direct3D_Shaders.h"

static DWORD Asura_Direct3D_CharacterVertex_Decl[] =
{
    D3DVSD_STREAM( 0 ),
    D3DVSD_REG( 0,	D3DVSDT_FLOAT3 ),
    D3DVSD_REG( 1,	D3DVSDT_FLOAT3 ),
    D3DVSD_REG( 2,	D3DVSDT_FLOAT2 ),
    D3DVSD_REG( 3,	D3DVSDT_FLOAT4 ),
	D3DVSD_REG( 4,	D3DVSDT_FLOAT4 ),

   D3DVSD_END()
};

static char* VertexShader="vs.1.1 \n\
					;add r0, v0, v3 \n\
					mov r0, v0 \n\
									\n\
					mov a0.x, v3.x \n\
					dp4 r1.x, c[a0.x+9], r0 \n\
					dp4 r1.y, c[a0.x+10], r0 \n\
					dp4 r1.z, c[a0.x+11], r0 \n\
					mul r1.xyz, r1, v4.x \n\
\n\
					dp3 r3.x, c[a0.x+9], v1 \n\
					dp3 r3.y, c[a0.x+10], v1 \n\
					dp3 r3.z, c[a0.x+11], v1 \n\
					;mov r3, v1\n\
												\n\
					mov a0.x, v3.y \n\
					dp4 r2.x, c[a0.x+9], r0 \n\
					dp4 r2.y, c[a0.x+10], r0 \n\
					dp4 r2.z, c[a0.x+11], r0 \n\
					mad r1.xyz, r2, v4.y, r1 \n\
												\n\
					mov a0.x, v3.z \n\
					dp4 r2.x, c[a0.x+9], r0 \n\
					dp4 r2.y, c[a0.x+10], r0 \n\
					dp4 r2.z, c[a0.x+11], r0 \n\
					mad r1.xyz, r2, v4.z, r1 \n\
												\n\
					mov a0.x, v3.w \n\
					dp4 r2.x, c[a0.x+9], r0 \n\
					dp4 r2.y, c[a0.x+10], r0 \n\
					dp4 r2.z, c[a0.x+11], r0 \n\
					mad r1.xyz, r2, v4.w, r1 \n\
\n\
					mov r1.w, r0.w \n\
\n\
					dp3 r4, r3, c[4] ; normal * light1 direction \n\
					max r4, r4, c[10] \n\
					mov r5, c[11] ; Ambient light and alpha \n\
					mad r5, c[5], r4.x, r5 ; multiply and add light1's colour \n\
					dp3 r4, r3, c[6]		\n\
					max r4, r4, c[10] \n\
					mad r5, c[7], r4.x, r5 \n\
					dp3 r4, r3, c[8]		\n\
					max r4, r4, c[10] \n\
					mad oD0, c[9], r4.x, r5 \n\
					mov oT0.xy, v2 \n\
\n\
					dp4 oPos.x, r1, c[0] \n\
					dp4 oPos.y, r1, c[1] \n\
					dp4 oPos.z, r1, c[2] \n\
					dp4 oPos.w, r1, c[3] \n\
					";

static Asura_Direct3D_VertexShader Shader(ASURA_D3D_VS_4BONES3LIGHTS,VertexShader,Asura_Direct3D_CharacterVertex_Decl);

#ifdef ASURA_TOOLS

static char* VertexShader3Bones="vs.1.1 \n\
					;add r0, v0, v3 \n\
					mov r0, v0 \n\
									\n\
					mov a0.x, v3.x \n\
					dp4 r1.x, c[a0.x+9], r0 \n\
					dp4 r1.y, c[a0.x+10], r0 \n\
					dp4 r1.z, c[a0.x+11], r0 \n\
					mul r1.xyz, r1, v4.x \n\
\n\
					dp3 r3.x, c[a0.x+9], v1 \n\
					dp3 r3.y, c[a0.x+10], v1 \n\
					dp3 r3.z, c[a0.x+11], v1 \n\
					;mov r3, v1\n\
												\n\
					mov a0.x, v3.y \n\
					dp4 r2.x, c[a0.x+9], r0 \n\
					dp4 r2.y, c[a0.x+10], r0 \n\
					dp4 r2.z, c[a0.x+11], r0 \n\
					mad r1.xyz, r2, v4.y, r1 \n\
												\n\
					mov a0.x, v3.z \n\
					dp4 r2.x, c[a0.x+9], r0 \n\
					dp4 r2.y, c[a0.x+10], r0 \n\
					dp4 r2.z, c[a0.x+11], r0 \n\
					mad r1.xyz, r2, v4.z, r1 \n\
\n\
					mov r1.w, v4.x ; Add up weight of bones used\n\
					add r1.w, r1.w, v4.y  \n\
					add r1.w, r1.w, v4.z  \n\
					rcp r1.w, r1.w  ;divide by total weight \n\
					mul r1.xyz, r1.xyz, r1.w \n\
\n\
					mov r1.w, r0.w \n\
\n\
					dp3 r4, r3, c[4] ; normal * light1 direction \n\
					max r4, r4, c[10] \n\
					mov r5, c[11] ; Ambient light and alpha \n\
					mad r5, c[5], r4.x, r5 ; multiply and add light1's colour \n\
					dp3 r4, r3, c[6]		\n\
					max r4, r4, c[10] \n\
					mad r5, c[7], r4.x, r5 \n\
					dp3 r4, r3, c[8]		\n\
					max r4, r4, c[10] \n\
					mad oD0, c[9], r4.x, r5 \n\
					mov oT0.xy, v2 \n\
\n\
					dp4 oPos.x, r1, c[0] \n\
					dp4 oPos.y, r1, c[1] \n\
					dp4 oPos.z, r1, c[2] \n\
					dp4 oPos.w, r1, c[3] \n\
					";

static Asura_Direct3D_VertexShader Shader3Bones(ASURA_D3D_VS_3BONES3LIGHTS,VertexShader3Bones,Asura_Direct3D_CharacterVertex_Decl);

static char* VertexShader2Bones="vs.1.1 \n\
					;add r0, v0, v3 \n\
					mov r0, v0 \n\
									\n\
					mov a0.x, v3.x \n\
					dp4 r1.x, c[a0.x+9], r0 \n\
					dp4 r1.y, c[a0.x+10], r0 \n\
					dp4 r1.z, c[a0.x+11], r0 \n\
					mul r1.xyz, r1, v4.x \n\
\n\
					dp3 r3.x, c[a0.x+9], v1 \n\
					dp3 r3.y, c[a0.x+10], v1 \n\
					dp3 r3.z, c[a0.x+11], v1 \n\
					;mov r3, v1\n\
												\n\
					mov a0.x, v3.y \n\
					dp4 r2.x, c[a0.x+9], r0 \n\
					dp4 r2.y, c[a0.x+10], r0 \n\
					dp4 r2.z, c[a0.x+11], r0 \n\
					mad r1.xyz, r2, v4.y, r1 \n\
\n\
					mov r1.w, v4.x ; Add up weight of bones used\n\
					add r1.w, r1.w, v4.y  \n\
					rcp r1.w, r1.w  ;divide by total weight \n\
					mul r1.xyz, r1.xyz, r1.w \n\
\n\
					mov r1.w, r0.w \n\
\n\
					dp3 r4, r3, c[4] ; normal * light1 direction \n\
					max r4, r4, c[10] \n\
					mov r5, c[11] ; Ambient light and alpha \n\
					mad r5, c[5], r4.x, r5 ; multiply and add light1's colour \n\
					dp3 r4, r3, c[6]		\n\
					max r4, r4, c[10] \n\
					mad r5, c[7], r4.x, r5 \n\
					dp3 r4, r3, c[8]		\n\
					max r4, r4, c[10] \n\
					mad oD0, c[9], r4.x, r5 \n\
					mov oT0.xy, v2 \n\
\n\
					dp4 oPos.x, r1, c[0] \n\
					dp4 oPos.y, r1, c[1] \n\
					dp4 oPos.z, r1, c[2] \n\
					dp4 oPos.w, r1, c[3] \n\
					";

static Asura_Direct3D_VertexShader Shader2Bones(ASURA_D3D_VS_2BONES3LIGHTS,VertexShader2Bones,Asura_Direct3D_CharacterVertex_Decl);

static char* VertexShader1Bone="vs.1.1 \n\
					;add r0, v0, v3 \n\
					mov r0, v0 \n\
									\n\
					mov a0.x, v3.x \n\
					dp4 r1.x, c[a0.x+9], r0 \n\
					dp4 r1.y, c[a0.x+10], r0 \n\
					dp4 r1.z, c[a0.x+11], r0 \n\
					mul r1.xyz, r1, v4.x \n\
\n\
					dp3 r3.x, c[a0.x+9], v1 \n\
					dp3 r3.y, c[a0.x+10], v1 \n\
					dp3 r3.z, c[a0.x+11], v1 \n\
					;mov r3, v1\n\
\n\
					mov r1.w, v4.x ; Add up weight of bones used\n\
					rcp r1.w, r1.w  ;divide by total weight \n\
					mul r1.xyz, r1.xyz, r1.w \n\
\n\
					mov r1.w, r0.w \n\
\n\
					dp3 r4, r3, c[4] ; normal * light1 direction \n\
					max r4, r4, c[10] \n\
					mov r5, c[11] ; Ambient light and alpha \n\
					mad r5, c[5], r4.x, r5 ; multiply and add light1's colour \n\
					dp3 r4, r3, c[6]		\n\
					max r4, r4, c[10] \n\
					mad r5, c[7], r4.x, r5 \n\
					dp3 r4, r3, c[8]		\n\
					max r4, r4, c[10] \n\
					mad oD0, c[9], r4.x, r5 \n\
					mov oT0.xy, v2 \n\
\n\
					dp4 oPos.x, r1, c[0] \n\
					dp4 oPos.y, r1, c[1] \n\
					dp4 oPos.z, r1, c[2] \n\
					dp4 oPos.w, r1, c[3] \n\
					";

static Asura_Direct3D_VertexShader Shader1Bone(ASURA_D3D_VS_1BONE3LIGHTS,VertexShader1Bone,Asura_Direct3D_CharacterVertex_Decl);


#endif //ASURA_TOOLS
