//
// Asura_D3D_VS_Skin_PlanarShadow.cpp
//
// Created by KJFL - 2004-02-19 14:25:13
//
// Copyright (C) 2004 Rebellion, All Rights Reserved.
//

#include "Core/Asura.h"

// This file's header.
#include "Rendering/Asura_Direct3D_Shaders.h"

static Direct3D_VertexElement g_axCharacter_Vertex_Decl[] = 
{
	{0,  0,  D3DDECLTYPE_FLOAT3,	D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_POSITION,		0},
	{0,  12, D3DDECLTYPE_FLOAT3,	D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_NORMAL,			0},
	{0,  24, D3DDECLTYPE_FLOAT2,	D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_TEXCOORD,		0},
	{0,  32, D3DDECLTYPE_FLOAT4,	D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_BLENDINDICES,	0},
	{0,	 48, D3DDECLTYPE_FLOAT4,	D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_BLENDWEIGHT,	0},

	D3DDECL_END()
};


// VGP 27Mar2006 Converted to vs.1.1
static char* g_szVertexShader =
{
	"vs.1.1 \n"

	"dcl_position		v0 \n"
	"dcl_normal			v1 \n"
	"dcl_texcoord		v2 \n"
	"dcl_blendindices	v3 \n"
	"dcl_blendweight	v4 \n"

	// get the most important bone index for this vertex
	"mov a0.x, v3.x \n"

	// set the y position (fixed because planar shadow) and w value (nominally 1.0f)
	"mov r1.yw, c[5] \n"

	// calc the x & z values by rotation & translation of bone matrix
	"dp4 r1.x, c[a0.x+12], v0 \n"
	"dp4 r1.z, c[a0.x+14], v0 \n"

	// move in the colour and alpha info
	"mov oD0, c[4] \n"

	// rotate the position into world space
	"dp4 oPos.x, r1, c[0] \n"
	"dp4 oPos.y, r1, c[1] \n"
	"dp4 oPos.z, r1, c[2] \n"
	"dp4 oPos.w, r1, c[3] \n"
};

static Asura_Direct3D_VertexShader Shader(
	ASURA_D3D_VS_SKIN_PLANARSHADOW, 
	g_szVertexShader, 
	g_axCharacter_Vertex_Decl);
