//
// Asura_D3D_VS_SunGlare.cpp
//
// Created by RJF - 22 July 2005
//
// Copyright (C) 2005 Rebellion, All Rights Reserved.
//

#include "Core/Asura.h"

// This file's header.
#include "Rendering/Asura_Direct3D_Shaders.h"

// Vertex Declarator

static Direct3D_VertexElement auVSD[] =
{
	{ 0,	0,	D3DDECLTYPE_FLOAT2,		D3DDECLMETHOD_DEFAULT,	D3DDECLUSAGE_POSITION,	0 },
	{ 0,    8,	D3DDECLTYPE_D3DCOLOR,	D3DDECLMETHOD_DEFAULT,	D3DDECLUSAGE_COLOR,		0 },
	D3DDECL_END()
};

// Sun geometry
// c0: (xy) projected position (z) projected z	(w) -
// c1: (xyz) sun color							(w) alpha
const char* const g_szVS_SUN_GLARE_CODE =

"vs.1.1 \n"
"dcl_position0	v0 \n"
"dcl_color0		v1 \n"

"mul oD0, v1, c1 \n"
"mul r0.xy, c2.ww, c2.xy \n"
"mad oPos.xy, v0.xy, r0.xy, c0.xy \n"
"mov oPos.z, c0.z \n"
"mov oPos.w, v0.w \n";

//register the shader with Asura
const Asura_Direct3D_VertexShader g_xVS_SUN_GLARE_SHADER(ASURA_D3D_VS_SUNGLARE, g_szVS_SUN_GLARE_CODE, auVSD);

static Direct3D_VertexElement auVSDSunRect[] =
{
	{ 0,	0,	D3DDECLTYPE_FLOAT3,		D3DDECLMETHOD_DEFAULT,	D3DDECLUSAGE_POSITION,	0 },
	{ 0,   12,	D3DDECLTYPE_FLOAT2, 	D3DDECLMETHOD_DEFAULT,	D3DDECLUSAGE_TEXCOORD,	0 },
	D3DDECL_END()
};

// Sun geometry
// c0: (xy) projected position (z) projected z	(w) -
// c1: (xyz) sun color							(w) alpha
const char* const g_szVS_SUN_RECT_CODE =

"vs.1.1 \n"
"dcl_position0 v0 \n"
"dcl_texcoord0 v1 \n"

"mov oPos, v0 \n"
"mad oT0.xy, v1.xy, c0.xy, c0.zw \n";

//register the shader with Asura
const Asura_Direct3D_VertexShader g_xVS_SUN_RECT_SHADER(ASURA_D3D_VS_SUNRECT, g_szVS_SUN_RECT_CODE, auVSDSunRect);
