//
// Asura_D3D_VS_Tools_Specular.cpp
//
// Created by AAM - 2004-08-06 12:06:39
//
// Copyright (C) 2004 Rebellion, All Rights Reserved.
//

#include "Core/Asura.h"

#ifdef ASURA_TOOLS

// This file's header.
#include "Rendering/Asura_Direct3D_Shaders.h"

static Direct3D_VertexElement g_axCharacter_Vertex_Decl[] = 
{
	{0,  0,  D3DDECLTYPE_FLOAT3,	D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_POSITION,	0},
	{0,  12, D3DDECLTYPE_FLOAT3,	D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_NORMAL,		0},
	{0,  24, D3DDECLTYPE_D3DCOLOR,	D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_COLOR,		0},
	{0,  28, D3DDECLTYPE_FLOAT2,	D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_TEXCOORD,	0},
	{0,  36, D3DDECLTYPE_FLOAT2,	D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_TEXCOORD,	1},
	D3DDECL_END()
};


static char* g_szVertexShader =
{
	"vs.1.1 \n"

	"dcl_position	v0 \n"
	"dcl_normal		v1 \n"
	"dcl_color		v2 \n"
	"dcl_texcoord0	v3 \n"
	"dcl_texcoord1	v4 \n"

	// lighting
	"mov oD0.xyz, c[88] \n"
	"mov oD0.w, c[87].w \n"

	// output uv co-ords
	"mov oT0.xy, v3 \n"

	// Output camera direction into tex coords for iteration
	"sub r2, c[86], v0 \n"					// Put camera pos - vertex pos (world space) in r0
	"dp3 r2.w, r2, r2 \n"					// r2.w = magnitude squared
	"rsq r2.w, r2.w \n"						// r2.w = 1 / magnitude
	"mul r2, r2, r2.w \n"					// r2 = camera dir / camera dir magnitude = V

	// Need to unscale and unbias vectors, since texcoord in ps clamps result to [0,1]
	"mad oT1.xyz, r2, c[87].x, c[87].x \n"	// oT1 = V*0.5 + 0.5

	// Copy world-space normal into oT2
	"mad oT2.xyz, v1, c[87].x, c[87].x \n"

	// Transform to screen space and write to output position register.
	"m4x4 oPos, v0, c[91] \n"

};

static Asura_Direct3D_VertexShader xShader( ASURA_D3D_VS_TOOLS_SPECULAR, g_szVertexShader, g_axCharacter_Vertex_Decl );

#endif // #ifdef ASURA_TOOLS
