
//------------------------------------
#include "Shared.fxh"

//------------------------------------

sampler TextureSampler = sampler_state 
{
    AddressU  = WRAP;        
    AddressV  = WRAP;
    AddressW  = CLAMP;
    MIPFILTER = LINEAR;
    MINFILTER = LINEAR;
    MAGFILTER = LINEAR;
};

struct vertexInput
{
    float4 Position	: POSITION0;
    float2 UV		: TEXCOORD0;
};

struct vertexOutput
{
    float4 Position : POSITION0;
    float2 UV		: TEXCOORD0;
};

//------------------------------------
vertexOutput VS_TransformDiffuse(vertexInput IN) 
{
    vertexOutput OUT;

    OUT.Position	= mul(IN.Position, g_xViewProjectionMatrix); 
	
	OUT.UV = IN.UV;
   
    return OUT;
}

float4 PS_GetTexture( vertexOutput IN ) : COLOR
{
	float4 xTexture = tex2D( TextureSampler, IN.UV);
	return xTexture;
}


//-----------------------------------
technique OcclusionPass
{
    pass p0 
    {		
		VertexShader = compile vs_3_0 VS_TransformDiffuse();
			
		PixelShader = compile ps_3_0 PS_GetTexture();
    }
}