//////////////////////////////////////////////////////////////////////////////
//
// Asura_PC_ShadowBuffer.h
//
// Copyright (c) 2008 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

#ifndef _ASURA_PC_SHADOWBUFFER_H_
#define _ASURA_PC_SHADOWBUFFER_H_

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

class Asura_PC_ShadowBuffer
{
public:
	Asura_PC_ShadowBuffer(u_int uTextureSize, Direct3D_Surface* pxDepthSurface);
	~Asura_PC_ShadowBuffer();

	void Bind() const;

	u_int				GetTextureSize		(void) const	{ return(m_uTextureSize); }
	Direct3D_Texture*	GetTexture			(void) const    { return(m_pxShadowTexture);}

	Direct3D_Surface*	GetFrontSurface(void) const			{ return(IsNvidiaDepthMap() ? m_pxOtherSurface : m_pxShadowTextureSurface);}
	Direct3D_Surface*	GetDepthSurface(void) const			{ return(IsNvidiaDepthMap() ? m_pxShadowTextureSurface : m_pxOtherSurface);}


	static bool IsNvidiaDepthMap(){return m_bNvidiaDepthMap;}
	static void SetNvidiaDepthMap(bool bVal) {m_bNvidiaDepthMap = bVal;}

private:
	static bool m_bNvidiaDepthMap;
	u_int m_uTextureSize;
	Direct3D_Texture* m_pxShadowTexture;
	Direct3D_Surface* m_pxShadowTextureSurface;
	Direct3D_Surface* m_pxOtherSurface;
};

#endif

