//////////////////////////////////////////////////////////////////////////////
//
// Asura_PlatformHierarchy.cpp
//
// Copyright (c) 2002-2004 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "Core/Asura.h"

// This file's header.
#include "Animation/Asura_PlatformHierarchy.h"

// Engine independent.
#include "Animation/Asura_Hierarchy.h"

// Engine platform-specific.
#include "Animation/Asura_PS2_Hierarchy.h"

// C L A S S   I M P L E M E N T A T I O N S /////////////////////////////////

//
// Asura_Hierarchy_System.
//

void Asura_Hierarchy_System::Platform_Initialise( void )
{
    Asura_PS2_SkinSystem::Initialise();
}

void Asura_Hierarchy_System::Platform_Reset( void )
{
    Asura_PS2_SkinSystem::Reset();
}

void Asura_Hierarchy_System::Platform_Shutdown( void )
{
    Asura_PS2_SkinSystem::Shutdown();
}

//
// Asura_Hierarchy_Skin.
//

int Asura_Hierarchy_Skin::Platform_GetTextureIndex( void ) const
{
    return Asura_PS2_SkinSystem::GetTextureID( m_uNameHashID );
}

bool Asura_Hierarchy_Skin::Platform_IsOpaque( void ) const
{
    return Asura_PS2_SkinSystem::IsOpaque( m_uNameHashID );
}
