#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __Asura_PS2_IRX_h__
#define __Asura_PS2_IRX_h__

// I N C L U D E S ///////////////////////////////////////////////////////////

// Stdlib platform-specific.
#include <sifdev.h>

// Project platform-specific.
#include "main.h"
#include "ProjectSettings/Asura_PS2_ProjectControllerDefines.h"

// D E F I N E S /////////////////////////////////////////////////////////////

#ifdef ASURA_PS2_CDEMUL

#ifdef ASURA_PS2_DEMODISK
    #define IRX_MODULE_ROOT "cdrom0:\\" ASURA_PS2_DEMODISK_ROOT "\\IRX\\"
#else
    #define IRX_MODULE_ROOT "cdrom0:\\IRX\\"
#endif
    #define IRX_MODULE_TAIL ";1"

    // (MH - 10.05.2002) modules which are only used in CD builds
#ifdef ASURA_PS2_ENABLE_DNAS
// ARC - 24 August 2006 11:31:47 - Allow project specific DNAS image file (SS2 uses DNAS300.IMG, for example) by defining it in Asura_EngineConfiguration.h
#if !defined(DNAS_IMAGE_FILE)
	#define DNAS_IMAGE_FILE "DNAS280.IMG"
#endif
    #define IOPRP                           IRX_MODULE_ROOT DNAS_IMAGE_FILE IRX_MODULE_TAIL
#else
    #define IOPRP                           IRX_MODULE_ROOT IOP_IMAGE_FILE IRX_MODULE_TAIL
#endif
    #define IOP_EXCEPTION_HANDLER_MODULE    IRX_MODULE_ROOT "PANICSYS.IRX"  IRX_MODULE_TAIL

#else // not defined ASURA_PS2_CDEMUL

    #define IRX_MODULE_ROOT ASURA_PS2_PCFILEROOT "IRX\\"
    #define IRX_MODULE_TAIL ""

#endif // else not defined ASURA_PS2_CDEMUL

    #define SIO2MAN                         "\\IRX\\SIO2MAN.IRX"
    #define PADMAN                          "\\IRX\\PADMAN.IRX"
    #define MTAPMAN                         "\\IRX\\MTAPMAN.IRX"
    #define _MOD_SD                         "\\IRX\\LIBSD.IRX"

#ifndef _MOD_STREAM
	#ifdef ASURA_PS2_SUPPORT_DTS
		#define _MOD_STREAM                     "\\IRX\\STRM_DTS.IRX"
	#else
		#define _MOD_STREAM                     "\\IRX\\STREAM.IRX"
	#endif //ASURA_PS2_SUPPORT_DTS
#endif //_MOD_STREAM

#ifdef ASURA_PS2_SUPPORT_DTS
    #define _MOD_STREAM_DBG                 "\\IRX\\DBGSTREAM_DTS.IRX"
#else
    #define _MOD_STREAM_DBG                 "\\IRX\\DBGSTREAM.IRX"
#endif
    #define SDRDRV_MODULE                   "\\IRX\\SDRDRV.IRX"
    #define USBD_MODULE                     "\\IRX\\USBD.IRX"
#if ASURA_PS2_SUPPORT_MOUSE || ASURA_PS2_SUPPORT_KEYBOARD
    #define USB_LGKBM_MODULE				"\\IRX\\LGKBM.IRX"
#endif
#ifdef ASURA_PS2_SUPPORT_USB_HEADSET
	#define USB_LGAUD_MODULE				"\\IRX\\LGAUD.IRX"
#endif 
	#define MCMAN							"\\IRX\\MCMAN.IRX"
	#define MCSERV							"\\IRX\\MCSERV.IRX"

    #define IRX_RESOURCE_FILENAME           "\\IRX\\IRX.ASR"
    #define DBG_IRX_RESOURCE_FILENAME       "\\IRX\\DBGIRX.ASR"

#if ASURA_PS2_SUPPORT_GUNCON2
    #define IRX_GUNCON2_FILENAME	        "\\IRX\\USBGUN.IRX"
#endif

	#define CDVD_STREAM						"\\IRX\\CDVDSTM.IRX"

#endif //__Asura_PS2_IRX_h__
