/********************************************************************
	filename: 	Asura_PS2_Kernel.cpp
	created:	18.3.2002
	author:		Mike Healey
	
	purpose:	definitions of kernel functions which are missing from
                the PS2-supplied libraries
*********************************************************************/

#include "Core/Asura.h"
#include <eekernel.h>

#ifdef ASURA_MEMORYMANAGEMENT_ENABLED
void ReleaseMemoryManager(void);
#endif

int main(int,char**);

extern "C" 
{
    void __do_global_dtors();
    void exit(int code) 
    {
        __do_global_dtors();
#ifdef ASURA_MEMORYMANAGEMENT_ENABLED
        ReleaseMemoryManager();
#endif
        Exit(code);
        // (MH - 30.09.2002) added a while (1) here to get rid of warning that
        // this function should not return
        while (1)
        {}
    }

    int ps2main(int argc,char **argv) 
    {
        exit(main(argc,argv));
        return 0;
    }
}
