//////////////////////////////////////////////////////////////////////////////
//
// Asura_PS2_Timers.cpp
//
// Copyright (c) 2002-2004 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "Core/Asura.h"

// This file's header.
#include "Core/Asura_PS2_Timers.h"

// C L A S S   I M P L E M E N T A T I O N S /////////////////////////////////

float Asura_PS2_Timers::ConvertCyclesToSeconds( u_int uCycles )
{
    // Avoid software u_int->float conversion while retaining full range...
    u_int uTopBit = uCycles & 0x80000000u;
    uCycles &= 0x7FFFFFFFu;
    float fCycles = static_cast<int>( uCycles );
    if( uTopBit ) { fCycles += 2147483648.0f; }

    return( fCycles / ASURA_PS2_EE_CYCLES_PER_SEC );
}
