//////////////////////////////////////////////////////////////////////////////
//
// Asura_PS2_DemoSystem.h
//
// Copyright (c) 2003 Rebellion. All rights reserved.
//
// Description:
//
//     Demo system for PS2 European Demo Disks
//
// (AW - 14.12.2004) - Updated for new SCEA/SCEE combined demo SDK
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef ___ASURA_PS2_DEMOSYSTEM_H___
#define ___ASURA_PS2_DEMOSYSTEM_H___ 1

#include "libscedemo.h"

class Asura_PS2_DemoSystem
{
	public:
		static void Initialise(int argc, char **argv);
		static void Shutdown();
		static void Update(float fFrameTime, float fGameTime);
		static void	SetEndReason(sceDemoEndReason eReasonForEnding);
		static sceDemoEndReason GetEndReason() {return s_eReasonForEnding;}

		static u_short GetLanguage(void);
		static u_short GetAspectRatio(void);
		static u_short GetPlaymode(void);
        static void    SetPlaymode(u_short);

		static void  ResetGameplayTimer(void);	// call this at the start of the game

		static bool  GoToAttractMode(void);
		static bool  GameplayTimerExpired(void);
		static bool  IsQuitRequested(void);			// returns if start + select is pressed for 3 seconds

        static void  FakeInput();   // sometimes you really don't want the inactivity timer kicking in...
		struct DemoParms
		{
		   unsigned short usLanguage;
		   unsigned short usAspect;
		   unsigned short usPlaymode;
		   unsigned short usToInactive;
		   unsigned short usToGameplay;
		};

	private:
		static DemoParms s_xDemoParms;

		static float s_fInactivityTimer;
		static float s_fMaxInactivity;
		static float s_fGameplayTimer;
		static float s_fMaxGameplay;

		static float s_fPressButtonTimer;

		static bool	 s_bGamePlayStarted;
		static sceDemoEndReason s_eReasonForEnding;
};

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

#endif // #ifndef ___ASURA_PS2_DEMOSYSTEM_H___
