/*************************************************************************
 *
 * Module:
 * lgkbmerr.h
 *
 * Description:
 * Logitech common library file for Sony PlayStation(tm)2
 *
 * COPYRIGHT (C) 2002-2004 LOGITECH, INC. ALL RIGHTS RESERVED.
 *
 * This program is a trade secret of LOGITECH, and it is not to be
 * reproduced, published, disclosed to others, copied, adapted,
 * distributed or displayed without the prior authorization of
 * LOGITECH.
 *
 * Licensee agrees to attach or embed this notice on all copies of the
 * program, including partial copies or modified versions thereof.
 *
 ************************************************************************/

#ifndef _LGKBMERR_H_INCLUDED_
#define _LGKBMERR_H_INCLUDED_



#define LGKBM_INVALID_HANDLE                (-1)
#define LGKBM_INVALID_DEVICE                (-1)



#define LGKBM_STATUS_OK                     (1)

//************************************************************************
// Error codes
//************************************************************************

#define LGKBM_SUCCESS                          (0x00000000)

#ifndef LGKBM_ERROR
#define LGKBM_ERROR                            (0x80000000)
#endif

// These are the library generated error codes.
#define LGKBM_ERR_NO_MORE_DEVICES               (0x80000002)
#define LGKBM_ERR_INVALID_DEVICETYPE            (0x80000003)
#define LGKBM_ERR_INVALID_PARAMETER             (0x80000004)
#define LGKBM_ERR_ALREADY_OPENED                (0x80000005)
#define LGKBM_ERR_DEVICE_LOST                   (0x80000006)
#define LGKBM_ERR_OUT_OF_MEMORY                 (0x80000007)
#define LGKBM_ERR_ASYNC_CALL_PENDING            (0x80000008)
#define LGKBM_ERR_NO_SPACE_LEFT                 (0x80000009)
#define LGKBM_ERR_DEVICE_ERROR                  (0x8000000a)
#define LGKBM_ERR_RPC_WAIT                      (0x8000000b)
#define LGKBM_ERR_ROLLOVER                      (0x8000000c)
#define LGKBM_ERR_BUFFER_OVERFLOW               (0x8000000d)
#define LGKBM_ERR_ALREADY_TRANSLATED            (0x8000000e)
#define LGKBM_ERR_DEVICE_NOT_OPENED             (0x8000000f)
#define LGKBM_ERR_USBD_REGISTER_FAILED          (0x80000010)
#define LGKBM_ERR_NOT_SUPPORTED                 (0x80000011)
#define LGKBM_ERR_sceUsbd_NOTRESP               (0x80000105)


#endif //~_LGKBMERR_H_INCLUDED_

//** end of lgkbmerr.h ***************************************************
