//
// Asura_PS2_Main.cpp
//
// Copyright (C) 2005 Rebellion, All Rights Reserved.
//


#include "Core/Asura.h"

// Engine independent.
#include "Core/Asura_Core.h"
#include "Debugging/Asura_Logfile.h"

// Engine PS2.
#include "Core/Asura_PS2_OS.h"
#ifdef ASURA_PS2_DEMODISK
#include "Demo/Asura_PS2_DemoSystem.h"
#endif

// Project headers
#include "Main/Asura_Project_Main.h"

extern "C" int main( int iNumArgs, char** aszArgs )
{
	Asura_OutputToDebugger(( "******************************************************************\n" ));
	Asura_OutputToDebugger(( "***                                                            ***\n" ));
	Asura_OutputToDebugger(( "***                           PS2 Main                         ***\n" ));
	Asura_OutputToDebugger(( "***                                                            ***\n" ));
	Asura_OutputToDebugger(( "******************************************************************\n\n" ));

#ifdef ASURA_PS2_DEMODISK
	Asura_PS2_DemoSystem::Initialise(iNumArgs, aszArgs);
#endif

	Asura_PS2_OS::ParseCommandLine( iNumArgs, aszArgs );

	// Early initialise, should get localised text and font systems running
	Asura_Core::EarlyInitialise();
	// Game core early initialise, might display loading message.
	Asura_Project::EarlyInitialise();

	// Any other inits
	Asura_Core::LateInitialise();
	Asura_Project::LateInitialise();
		
	// Game main loop.
    while( Asura_Project::MainLoop() ) { }

	// only shutdown if debug (for leak checks) or Demodisk (as it's required).
#if _DEBUG || defined(ASURA_PS2_DEMODISK)
	// Game shutdown
	Asura_Project::Shutdown();
	// Asure core shutdown.
	Asura_Core::Shutdown();
#endif

#if defined(ASURA_PS2_DEMODISK) && !_DEBUG
	Asura_PS2_DemoSystem::Shutdown();
#endif

	return 0;
}
