#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __Asura_PS2_NETGUI_H__
#define __Asura_PS2_NETGUI_H__

// I N C L U D E S ///////////////////////////////////////////////////////////

// Stdlib platform-specific.
#include <sifdev.h>

// Project platform-specific.
#include "main.h"
//#include "ProjectSettings/Asura_PS2_ProjectControllerDefines.h"

// D E F I N E S /////////////////////////////////////////////////////////////


class Asura_PS2_NetGui
{

public:

	enum NetState
	{
		NetState_None,
		NetState_LoadingIRXs,				// loading eznetcnf IRXs from CD
		NetState_WaitingForMemCardState,	// checking for MC present
		NetState_GettingConfigs,			// memory card is being read
		NetState_DisplayingConfigs,			// waiting to be told 
		NetState_Initialising,				// waiting for selected config to be initialised
		NetState_Connected,					// everything's OK
		NetState_Error,
	};

	// todo - check each of these error conditions
	enum NetCnfError
	{
		Error_None,
		Error_LoadingIRXsFailed,		// probably CD tray open
		Error_NoConfigsOnMemoryCard,	// display appropriate message
		Error_MagicError,				// created on different PS2 - display special message
		Error_NoMemoryCardInSlot1,		// display appropriate message
		Error_MemoryCardNotFormatted,	// display appropriate message
		Error_CorruptedData,			// display appropriate message
		Error_HardwareNotConnected,		// display appropriate message, using GetConfigType
		Error_HardwareNotSupported,		// display appropriate message, using GetConfigType
		Error_CableUnplugged,			// display appropriate message
		Error_ConnectionFailed,			// display appropriate message
		Error_AuthorisationError,		// special case of connection failed.
		Error_ConnectionTimedOut,		// display appropriate message
		Error_LoadingNetworkIRXsFailed,	// probably CD tray open
	};

	static void LaunchNetGui(const char *szFilename, int argc, const char *argv, bool bForceHost0 = false);	

private:

};





#endif //__Asura_PS2_NETGUI_H__
