//
// Asura_Platform_NetSocket.h
//
// PS2 version
//
// Created by MH - 19.07.2004
//
// Copyright (C) 2004 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif

#ifndef __ASURA_PLATFORM_NETSOCKET_H__
#define __ASURA_PLATFORM_NETSOCKET_H__

// stuff to make code compile on PS2 as it would on PC with an include of winsock.h
#include <libeenet.h>
#include <eenetctl.h>
#include <ifaddrs.h>
#include <sys/socket.h>
#include <sys/errno.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <net/if.h>
#include <sys/select.h>

#define SOCKET int
#define SOCKET_ERROR (-1)
#define INVALID_SOCKET (-1)

#define WSAGetLastError() sceEENetErrno

#define closesocket sceEENetClose
#define ioctlsocket ioctl

#undef getsockname
#define getsockname(a,b,c) sceEENetGetsockname((a),(b),reinterpret_cast<u_int*>((c)))

#undef recvfrom
#define recvfrom(a,b,c,d,e,f) sceEENetRecvfrom((a),(b),(c),(d),(e),reinterpret_cast<u_int*>((f)))


#define WSAEWOULDBLOCK EWOULDBLOCK             
#define WSAEINPROGRESS EINPROGRESS             
#define WSAEALREADY EALREADY                
#define WSAENOTSOCK ENOTSOCK                
#define WSAEDESTADDRREQ EDESTADDRREQ            
#define WSAEMSGSIZE EMSGSIZE                
#define WSAEPROTOTYPE EPROTOTYPE              
#define WSAENOPROTOOPT ENOPROTOOPT             
#define WSAEPROTONOSUPPORT EPROTONOSUPPORT         
#define WSAESOCKTNOSUPPORT ESOCKTNOSUPPORT         
#define WSAEOPNOTSUPP EOPNOTSUPP              
#define WSAEPFNOSUPPORT EPFNOSUPPORT            
#define WSAEAFNOSUPPORT EAFNOSUPPORT            
#define WSAEADDRINUSE EADDRINUSE              
#define WSAEADDRNOTAVAIL EADDRNOTAVAIL           
#define WSAENETDOWN ENETDOWN                
#define WSAENETUNREACH ENETUNREACH             
#define WSAENETRESET ENETRESET               
#define WSAECONNABORTED ECONNABORTED            
#define WSAECONNRESET ECONNRESET              
#define WSAENOBUFS ENOBUFS                 
#define WSAEISCONN EISCONN                 
#define WSAENOTCONN ENOTCONN                
#define WSAESHUTDOWN ESHUTDOWN               
#define WSAETOOMANYREFS ETOOMANYREFS            
#define WSAETIMEDOUT ETIMEDOUT               
#define WSAECONNREFUSED ECONNREFUSED            
#define WSAELOOP ELOOP                   
#define WSAENAMETOOLONG ENAMETOOLONG            
#define WSAEHOSTDOWN EHOSTDOWN               
#define WSAEHOSTUNREACH EHOSTUNREACH            
#define WSAENOTEMPTY ENOTEMPTY               
#define WSAEPROCLIM EPROCLIM                
#define WSAEUSERS EUSERS                  
#define WSAEDQUOT EDQUOT                  
#define WSAESTALE ESTALE                  
#define WSAEREMOTE EREMOTE
#define WSAEINVAL EINVAL

typedef struct sockaddr SOCKADDR;
typedef struct sockaddr_in SOCKADDR_IN;
typedef struct in_addr IN_ADDR;
typedef struct hostent HOSTENT;
typedef struct timeval TIMEVAL;
// end of winsock compatability on PS2

// Asura_NetSocket platform defines

// Asura_NetAddress is just the IP on PS2
typedef u_int Asura_NetAddress;

// On the Xbox, use the VDP protocol which allows for combined game and voice data
// (game data is sent encrypted, voice unencrypted)
// On other platforms, we will want to use IPPROTO_UDP
#define ASURA_NETSOCKET_PROTOCOL IPPROTO_UDP

// On XBox the IP+VDP header size ranges from 44 to 51, so say 48 on average.
// On PC/PS2 IP+UDP header size is 28 bytes
#define ASURA_NETSOCKET_PROTOCOL_PACKETHEADERSIZE (28)

// 3658 is the IANA-registered PS2 port. 1000 should be used by Xbox as it gives the smallest packet header.
#define ASURA_NETSOCKET_DEFAULTPORT (3658)

#endif//__ASURA_PLATFORM_NETSOCKET_H__
