//////////////////////////////////////////////////////////////////////////////
//
// Asura_PS2_Lighting.h
//
// Copyright (c) 2004 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef ___ASURA_PS2_LIGHTING_H___
#define ___ASURA_PS2_LIGHTING_H___ 1

// I N C L U D E S ///////////////////////////////////////////////////////////

#include <libvu0.h>

// M A C R O S ///////////////////////////////////////////////////////////////

#define ASURA_PS2_MAX_LIGHTS_FOR_VU (3)

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class Asura_Animation;
class Asura_Vector_3;

// T Y P E S /////////////////////////////////////////////////////////////////

class Asura_PS2_VU_Light
{
	public:
		
		sceVu0FVECTOR direction;
        sceVu0FVECTOR colour;
};

// P R O T O T Y P E S   A N D   I N L I N E   F U N C T I O N S /////////////

void Asura_PS2_SetupCharacterLighting( const Asura_Animation* pxAnim, const Asura_Vector_3& xBBCentre, float* pfLightLevel = NULL );
#ifdef ASURA_PS2_SUPPORT_GRAPHIC_NOVEL
void Asura_PS2_SetupCharacterLighting_GraphicNovel( const Asura_Animation* pxAnim, const Asura_Vector_3& xBBCentre, float* pfLightLevel = NULL );
#endif

// G L O B A L S /////////////////////////////////////////////////////////////

extern sceVu0FVECTOR g_CharacterAmbientColour;//rgb of environment lighting value
extern Asura_PS2_VU_Light g_CharacterTransformedLights[ASURA_PS2_MAX_LIGHTS_FOR_VU];
extern u_int g_CharacterNumLocalLights;

extern sceVu0FVECTOR g_CharacterSpecularLightPosition;
extern sceVu0FVECTOR g_CharacterSpecularColour;

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

#endif // #ifndef ___ASURA_PS2_LIGHTING_H___
