//////////////////////////////////////////////////////////////////////////////
//
// Asura_PS2_RenderingOptions.h
//
// Copyright (c) 2003 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef ___ASURA_PS2_RENDERINGOPTIONS_H___
#define ___ASURA_PS2_RENDERINGOPTIONS_H___ 1

// C L A S S E S /////////////////////////////////////////////////////////////

class Asura_PS2_RenderingOptions
{

    public:

        // T Y P E S /////////////////////////////////////////////////////////

        enum OPTION
        {
/*	   0 */	OPTION_DRAW_FRACTAL_SKY,
/*	   1 */	OPTION_DRAW_SKYBOX,
/*	   2 */	OPTION_DRAW_ENV,
/*	   3 */	OPTION_DRAW_OBJS,
/*     4 */ OPTION_ENABLE_OBJ_SHADOWS,
/*	   5 */	OPTION_DRAW_HIERS,
/*     6 */ OPTION_ENABLE_HIER_SHADOWS,
/*	   7 */	OPTION_DRAW_SMOOTH_SKINS,
/*	   8 */	OPTION_ENABLE_SMOOTH_SKIN_SHADOWS,
/*	   9 */	OPTION_DRAW_WEAPON,
/*	  10 */	OPTION_DRAW_CORONAS,
/*	  11 */	OPTION_DRAW_PARTICLES,
/*	  12 */	OPTION_DRAW_DECALS,
/*	  13 */	OPTION_DRAW_OVERLAYS,
/*    14 */ OPTION_DRAW_GLASS,
/*	  15 */	OPTION_DYN_LIGHT_ENV,
/*	  16 */	OPTION_ENABLE_FOG,
/*	  17 */	OPTION_ENABLE_REFLECTION,
/*	  18 */	OPTION_ENABLE_RAINSPLASH,
#ifdef ASURA_PS2_SUPPORT_GRAPHIC_NOVEL
/*	  19 */	OPTION_USE_GN_SMOOTH_SKIN_RENDERER,
/*	  20 */	OPTION_USE_GN_HIER_SKIN_RENDERER,
#endif
/* 19/21 */	OPTION_ENABLE_SUNGLARE,
/* 20/22 */	OPTION_SUNGLARE_LEAVE_BRIGHTNESS_VALUE_IN_ALPHA,
/* 21/23 */ OPTION_ENABLE_DUAL_TEXTURING,
/* 22/24 */ OPTION_ENABLE_GLOW,
#if defined( ASURA_USE_CARPET )
			OPTION_DRAW_CARPET,
#endif // #if defined( ASURA_USE_CARPET )
#if defined( ASURA_USE_BOTANICALS )
			OPTION_DRAW_BOTANICALS,
#endif // #if defined( ASURA_USE_BOTANICALS )
            NUM_OPTIONS,
        };

        // C L A S S   M E T H O D S /////////////////////////////////////////

        static bool GetOption( OPTION eOption ) { return s_abOptions[eOption]; }

        static void SetOption( OPTION eOption, bool bValue ) { s_abOptions[eOption] = bValue; }

    private:

        // C L A S S   S T A T E /////////////////////////////////////////////

        static bool s_abOptions[NUM_OPTIONS]; // Initialised in project-specific code.

};

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

#endif // #ifndef ___ASURA_PS2_RENDERINGOPTIONS_H___

