//////////////////////////////////////////////////////////////////////////////
//
// Asura_PlatformRenderObject.h
//
// Copyright (c) 2003 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef ___ASURA_PLATFORMRENDEROBJECT_H___
#define ___ASURA_PLATFORMRENDEROBJECT_H___ 1

// I N C L U D E S ///////////////////////////////////////////////////////////

// Engine independent.
#include "Core/Asura_Handle.h"
#include "Core/Asura_Maths.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class Asura_PS2_Shape_ShapeHdr;
union Asura_PS2_QW;
class Asura_Shape_Instance;

// C L A S S E S /////////////////////////////////////////////////////////////

class Asura_PS2_StrippedObject
{
    public:

        Asura_PS2_StrippedObject( const char* szName );
        ~Asura_PS2_StrippedObject();

        bool LoadStrippedObject( Asura_Handle iFileHandle, u_int uNumBytes, const Asura_PS2_Shape_ShapeHdr& xShapeHdr );

        void Render( const Asura_Shape_Instance* pxShapeInst, u_int uObjectARGB, u_int uCamVisFlags ) const;

        int GetMaterialIndex( void ) const { return m_iMaterialID; }

    private:

#if _DEBUG
        char*               m_szName;
#endif
        int                 m_iMaterialID;
        u_int               m_uNumTris;
        void*               m_pvDMAChain;

};

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

#endif // #ifndef ___ASURA_PLATFORMRENDEROBJECT_H___
