//////////////////////////////////////////////////////////////////////////////
//
// Asura_PS3_Botanicals.h
//
// Copyright (c) 2006 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

#if defined ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#if !defined __ASURA_PS3_BOTANICALS_H__
#define __ASURA_PS3_BOTANICALS_H__

/******************************************************************************/
/* Included Files                                                             */
/******************************************************************************/

// Asura BGR
#include "Botanicals/Asura_Botanical_Game_Render_Manager.h"
#include "Botanicals/Asura_Botanical_Game_Render_Instance.h"
#include "Botanicals/Asura_Botanical_Game_Render_Instance_Header.h"
#include "Botanicals/Asura_Botanical_Game_Render_Type.h"

// Asura Platform-independent
#include "Core/Asura.h"
#include "Core/Asura_HalfFloat.h"
#include "Core/Asura_Hash.h"
#include "Core/Asura_Maths.h"
#include "Core/Asura_String.h"

// Asura PS3
//#include "Rendering/Asura_PS3_Effect_System.h"
#include "Rendering/Asura_PS3_Graphics.h"
#include "Rendering/Asura_PS3_GCM_VertexBuffer.h"
#include "Rendering/Asura_PS3_GCM_IndexBuffer.h"
#include "Rendering/Asura_PS3_MaterialResponse_System.h"

//Botanicals include
enum Asura_PS3_Botanicals_Mesh_Type
{
	TYPE_BOTANICALS_GEOMETRY_1SIDED	= 0,
	TYPE_BOTANICALS_GEOMETRY_2SIDED	= 1,
	TYPE_BOTANICALS_BILLBOARDS		= 2,
	TYPE_BOTANICALS_IMPOSTER		= 3,
	TYPE_BOTANICALS_NUM_TYPES
};

class Asura_PS3_Botanicals_InstanceCache;
class Asura_PS3_Botanicals_Template;
class Asura_PS3_Botanicals_Shape;

#include "Asura_PS3_BotanicalsLODGeometry.h"
#include "Asura_PS3_BotanicalsLODBilboard.h"
#include "Asura_PS3_BotanicalsLODImposter.h"
#include "Asura_PS3_BotanicalsLOD.h"
#include "Asura_PS3_BotanicalsElement.h"
#include "Asura_PS3_BotanicalsShapes.h"
#include "Asura_PS3_BotanicalsTemplate.h"
#include "Asura_PS3_BotanicalsSystem.h"

#endif // !defined __ASURA_PS3_BOTANICALS_H__
