//////////////////////////////////////////////////////////////////////////////
//
// Asura_PS3_BotanicalsSystem.h
//
// Copyright (c) 2006 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

#if defined ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __ASURA_PS3_BOTANICALS_SYSTEM_H__
#define __ASURA_PS3_BOTANICALS_SYSTEM_H__

class Asura_PS3_Botanicals_InstanceCache;

class Asura_PS3_GCM_VertexShaderUniformParameter;
class Asura_PS3_GCM_FragmentShaderUniformParameter;
class Asura_PS3_GCM_VertexShader;
class Asura_PS3_GCM_VertexBuffer;
class Asura_PS3_FragmentShaderCopy;

class Asura_PS3_Botanicals_System : public Asura_BGR_Manager
{
	friend class Asura_Chunk_ResourceFile_PS3_Botanicals;

public:

	// BGR Manager functions
	virtual u_int								GetInstanceHeaderCount( void ) const;
	virtual const Asura_BGR_Instances_Header*	GetInstanceHeader( const u_int uInstanceHeaderIndex ) const;
	virtual Asura_BGR_Instances_Header*			GetInstanceHeader( const u_int uInstanceHeaderIndex );
	virtual Asura_BGR_Type*						GetType( const Asura_BGR_TypeID xTypeID );

	// Static functions

	static void Initialise( void );
	static void Reset( void );
	static void Shutdown( void );
	static void Render( const float fFade );

	// removed on PS3 is hiding the parent call
//	static void Update( const float fTime );

	static Asura_PS3_GCM_VertexShader* GetBotanicalsGeometryVP( void );
	static Asura_PS3_GCM_VertexShader* GetBotanicalsBillboardVP( void );
	static Asura_PS3_GCM_VertexShader* GetBotanicalsImpostersVP( void );

	static void SetMaterial( Asura_Hash_ID uMaterialHash, Asura_PS3_FragmentShaderCopy* pxFragmentShader );
	static void BindInstanceData( u_int uRenderStartInstance, u_short usStride );


protected:

	static void CalculateLODs( void );
	static Asura_PS3_Botanicals_Instance::RenderData* CalculateLODsCache( Asura_PS3_Botanicals_Element& xCurrElement,
                                                                          const Asura_PS3_Botanicals_InstanceCache* paxInstanceCache,
                                                                          const u_int uInstanceCacheMax,
                                                                          Asura_PS3_Botanicals_Instance::RenderData* pxCurrRenderData,
                                                                          Asura_PS3_Botanicals_Instance::RenderData* const pxRenderDataEnd );

	// Shape and template lists

	static Asura_PS3_Botanicals_Shape*		s_pxShapes;
	static Asura_PS3_Botanicals_Template*	s_pxTemplates;
	static u_int							s_uNumShapes;
	static u_int							s_uNumTemplates;

	enum
	{
		NUM_INSTANCE_BUFFERS = 2
	};

	// Instance buffer. Now double-buffered to avoid lock stalls (DMR 21/11/06)
	static int								s_iCurrentInstanceBuffer;
	static Asura_PS3_GCM_VertexBuffer		s_axInstanceVBs[ NUM_INSTANCE_BUFFERS ];

};

#endif // !defined __ASURA_PS3_BOTANICALS_SYSTEM_H__
