///////////////////////////////////////////////////////////////////////////////
//
// File      : Asura_Chunk_ResourceFile_PS3_StreamedSounds.h
// Author    : Philip Hall
// Created   : 14/11/2007
//
// Copyright (C) 2007 Rebellion. All Rights Reserved
//
///////////////////////////////////////////////////////////////////////////////

#ifndef ___ASURA_CHUNK_RESOURCEFILE_PS3_STREAMEDSOUNDS_H___
#define ___ASURA_CHUNK_RESOURCEFILE_PS3_STREAMEDSOUNDS_H___

#ifndef ASURA_USE_AUDIO_SYSTEM

#include "ChunkSystem/Asura_Chunk_ResourceFile.h"

//
// Version history:
//
//     (PGH - 14.11.2007) -  0 - Initial version.
//
#define ASURA_PS3_STREAMEDSOUNDS_CHUNK_VERSION (0)

// using chunk flags to indicate whether the soundID is in fact a hashID.
// This is just copied from the PS2 where it was done to avoid changing version.
static const u_int uASURA_PS3_STREAMEDSOUNDS_FLAG_SOUNDIDS_ARE_DYNAMIC = 0x00000001;


////PGH/////////////////////////////////////////
// Streamed sound chunk 'header' and processing 
////////////////////////////////////////////////
class Asura_Chunk_ResourceFile_PS3_StreamedSounds : public Asura_Chunk_ResourceFile
{
public:
    struct HdrEntry
    {
        int   iSoundID;
        u_int uOffset;
        u_int uSize;
    };

    void Process( const char* szSection, Asura_Chunk_File_Stream& );
};



#endif // #ifndef ___ASURA_CHUNK_RESOURCEFILE_PS3_STREAMEDSOUNDS_H___

#endif // #ifndef ASURA_USE_AUDIO_SYSTEM

//eof
