//////////////////////////////////////////////////////////////////////////////
//
// Asura_PlatformBasics.h
//
// Copyright (c) 2006 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef ___ASURA_PLATFORMBASICS_H___
#define ___ASURA_PLATFORMBASICS_H___ 1

// I N C L U D E S ///////////////////////////////////////////////////////////

// Stdlib independent.
#include <string.h>
#include <wctype.h> // (MP - 10.04.2006) Shouldn't need this here but the
                    // definitions don't appear anywhere else (unlike in .NET,
                    // for example) and it can't be included in platform-
                    // independent code since some older compilers (eg. GCC
                    // <= 3.2 as used on PS2) don't correctly provide it.

// M A C R O S ///////////////////////////////////////////////////////////////

// ART - Needed to allow streaming code to read/write "wchar_t" because
// the GCC compiler treats them as distinct types of 2 bytes in size rather
// than something typedefed to a "u_short"...
#define ASURA_UNICODE_CHAR_DISTINCT_TYPE (1)

// T Y P E S /////////////////////////////////////////////////////////////////

typedef char    Asura_Char;
typedef wchar_t Asura_UnicodeChar;

// P R O T O T Y P E S   A N D   I N L I N E   F U N C T I O N S /////////////

extern "C"
{

// These are named differently in our headers from the narrow string standard.
// But on SPU they are implemented at all. We don't need them, so just declare them.
#ifdef SPU
int stricmp( const Asura_Char* szA, const Asura_Char* szB );
int strnicmp( const Asura_Char* szA, const Asura_Char* szB, size_t uMax );
#else
inline int stricmp( const Asura_Char* szA, const Asura_Char* szB ) { return strcasecmp_ascii( szA, szB ); }
inline int strnicmp( const Asura_Char* szA, const Asura_Char* szB, size_t uMax ) { return strncasecmp_ascii( szA, szB, uMax ); }
#endif

// These don't exist in the PS3 standard libraries at all, it seems.
int wcsicmp( const Asura_UnicodeChar* wszA, const Asura_UnicodeChar* wszB );
int wcsnicmp( const Asura_UnicodeChar* wszA, const Asura_UnicodeChar* wszB, size_t uMax );

}; // extern "C"

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

#endif // #ifndef ___ASURA_PLATFORMBASICS_H___
