//////////////////////////////////////////////////////////////////////////////
//
// Asura_Platform_MemoryManagement.h
//
// Copyright (c) 2006 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef ___ASURA_PLATFORM_MEMORYMANAGEMENT_H___
#define ___ASURA_PLATFORM_MEMORYMANAGEMENT_H___ 1

// I N C L U D E S ///////////////////////////////////////////////////////////

#ifndef ASURA_MEMORYMANAGEMENT_ENABLED
#include <vec_types.h>
#include <stdlib.h>
#endif

#include <stdint.h> // uintptr_t, etc.

// M A C R O S ///////////////////////////////////////////////////////////////

#define ASURA_MEMORYMANAGEMENT_INIT_OBJ_IN_PLATFORM_CODE   (1)
#define ASURA_MEMORYMANAGEMENT_PLATFORM_INIT_WHEN_DISABLED (0)

// P R O T O T Y P E S   A N D   I N L I N E   F U N C T I O N S /////////////

#if !defined(ASURA_MEMORYMANAGEMENT_ENABLED)

inline void* Asura_AllocateAlign( u_int uNumBytes, ASURA_ALIGN_ID eAlignment )
{
	// we override malloc in Asura_Platform_MemoryManagement.cpp so this will go through our code.
	return memalign( eAlignment, uNumBytes );
}

inline void Asura_DeallocateAlign( void* pvAddr )
{
    free( pvAddr );
}

#endif // !defined(ASURA_MEMORYMANAGEMENT_ENABLED)

void Asura_PS3_MapAllMemoryToRSX( void* pCommandBuffer, u_int uCommandBufferSize );

u_int Asura_PS3_GetFreeMainMemory();

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

#endif // #ifndef ___ASURA_PLATFORM_MEMORYMANAGEMENT_H___
