
///////////////////////////////////////////////////////////////////////////////
//
// File   : Asura_Platform_CPUProfile.h
// Author : Andy Tate
// Date   : 20-Jun-2005
//
// Copyright (C) 2005 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __ASURA_PLATFORM_CPUPROFILE_H__
#define __ASURA_PLATFORM_CPUPROFILE_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_PS3_SUPPORT_SNTUNER
#include <libsntuner.h>
#endif

#ifdef ASURA_USE_PROFILING_SYSTEM
#include "Debugging/Asura_CPUProfile_Renderer.h"
#endif


////////////////////////////////////////////////////////////////////////////////
// Macro declaration...
////////////////////////////////////////////////////////////////////////////////
#ifdef ASURA_PS3_SUPPORT_SNTUNER
#define ASURA_PS3_SNTUNER_START(x,y) snStartMarker((x)&31, (y))
#define ASURA_PS3_SNTUNER_STOP(x) snStopMarker((x)&31)
#else
#define ASURA_PS3_SNTUNER_START(x,y)
#define ASURA_PS3_SNTUNER_STOP(x)
#endif

#ifdef ASURA_USE_PROFILING_SYSTEM
#define	ASURA_PS3_PROFILEBAR_START(x) Asura_CPUProfile_Renderer::StartProfile((x))
#define	ASURA_PS3_PROFILEBAR_END(x) Asura_CPUProfile_Renderer::StopProfile((x))
#define ASURA_PS3_PROFILEBAR_SETNAME(x,y) Asura_CPUProfile_Renderer::SetName((x),(y))
#else
#define	ASURA_PS3_PROFILEBAR_START(x)
#define	ASURA_PS3_PROFILEBAR_END(x) 
#define ASURA_PS3_PROFILEBAR_SETNAME(x,y)
#endif

#define ASURA_CPU_PROFILE__START_LABEL(x,y) \
{	ASURA_PS3_SNTUNER_START((x),(y)); \
	ASURA_PS3_PROFILEBAR_SETNAME((x),(y)); \
	ASURA_PS3_PROFILEBAR_START((x)); }

#define	ASURA_CPU_PROFILE__START(x) ASURA_PS3_SNTUNER_START((x), "?"); ASURA_PS3_PROFILEBAR_START((x));
#define	ASURA_CPU_PROFILE__END(x) ASURA_PS3_SNTUNER_STOP((x)); ASURA_PS3_PROFILEBAR_END((x));


////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////


#endif   // ifndef __ASURA_PLATFORM_CPUPROFILE_H__


/// End of file. ///
