///////////////////////////////////////////////////////////////////////////////
//
// File      : Asura_PS3_FMV_pamf.h
// Author    : Philip Hall
// Created   : 18/10/2007
//
// Copyright (C) 2007 Rebellion. All Rights Reserved
//
///////////////////////////////////////////////////////////////////////////////

#if !defined __ASURA_PS3_FMV_PAMF_H__
#define __ASURA_PS3_FMV_PAMF_H__

// Asura PS3 Headers
#include "Core/Asura_PlatformBasics.h"
#include "FileAccess/Asura_PS3_FileSystem.h"

#include <cell/codec.h>
#include <cell/codec/pamf.h>


////PGH/////////////////////////////////////////
// From PAMF sample                     
////////////////////////////////////////////////
struct SPamfVideoStreamInfo;
struct SPamfAudioStreamInfo;


////PGH/////////////////////////////////////////
// libpamf wrapper - (single use)
////////////////////////////////////////////////
class Asura_PS3_FMV_pamf
{
public:
	Asura_PS3_FMV_pamf();
	~Asura_PS3_FMV_pamf();
	
	bool Open(const char* szFilename);
	void Close();

	bool GetVideoStreamInfo(SPamfVideoStreamInfo* pVideoInfo);
	bool GetAudioStreamInfo(SPamfAudioStreamInfo* pAudioInfo, int iStream);
	
	const char* GetFilename() const { return m_szFilename; }
	uint64_t	GetStreamOffset() const { return m_uStreamOffset; } 
	uint64_t	GetStreamSize() const { return m_uStreamSize; } 
	
private:
	Asura_PS3_FileSystem::Handle m_xFileHandle;
	char            m_szFilename[ASURA_PS3_MAX_PATH];
	uint64_t        m_uHeaderSize;
	uint64_t        m_uFileSize;
	uint64_t        m_uStreamOffset;
	uint64_t        m_uStreamSize;
	uint8_t*        m_pWorkMemory;
	CellPamfReader  m_xReader;
};


#endif




