// Asura_PS3_FSFX.h
//
// Created by Catalin Arsenescu - 11 September 2007
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef _ASURA_PS3_FSFX_H_
#define _ASURA_PS3_FSFX_H_

#ifdef ASURA_USE_FSFX

class Asura_PS3_Texture;

class Asura_PS3_FSFX
{
public:
	static void Initialise( void );
	static void Reset( void );
	static void Shutdown( void );

	static void GaussianBlur( const float fIntensity );										//Not supported
	static void DepthOfField( const float fIntensity );										//Not supported
	static void Test( const float fIntensity );												//Not supported

	static void BrightnessAndContrast( float* pfCoef );										//Done
	static void DesaturateAndTint( float* pfTintStrength );									//Done
	static void Noise( float* pfUV, int iTextureIndex, float* pfEffecStrength );			//Done
	static void RadialBlur( float* pfSampleWeights, const float* pxVertexTransforms );		//Done
	static void Gamma( float* pfCoef0, float* pfCoef1, float* pfCoef2, float* pfCoef3 );	//Done
	static void ColourMap( const float fIntensity, int iTextureIndex );						//Done
	static void SM30_Bloom( const float fIntensity, float* afInputThreshold, float* afAdvBloom, bool m_bAccumulate, float m_iBlurPasses, float m_fBlurRadius, float m_fROutputCol, float m_fGOutputCol, float m_fBOutputCol ); //Done
	static void SM30_FishEye( float* pfData1, float* pfData2 );								//Done
	static void SM30_DoubleVision( float* pfData1, float* pfData2 );						//Done
	static void SM30_DepthOfField( const float fIntensity, int iBlurPasses, float fBlurRadius, float fBlurDesaturate, float* afDistances, float fBlendScale ); //Done

	static void  UpdateBlurredBuffer( int iBlurPasses, float fBlurRadius, float fSaturation, bool bExtractDepthOfField = false, float fDist0 = 0, float fDist1 = 0, float fBleedScale = 1 );
	static Asura_PS3_Texture* GetBlurredBuffer( void );

	static void Bloom( const float fIntensity, const float* afTint, const float fThreshold );
};

#endif //#ifdef ASURA_USE_FSFX

#endif //#ifndef _ASURA_PS3_FSFX_H_
