//////////////////////////////////////////////////////////////////////////////
//
// Asura_PS3_DLC_System.h
//
// Copyright (c) 2009 Rebellion. All rights reserved.
//
// Description:	PS3-specific class for handling DLC files. Interfaces with the
//				NP and commerce systems of the PS3, and provides a way to work
//				out the directory to open files from if using a downloaded
//				file.
//
//////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef ___ASURA_PS3_DLC_SYSTEM_H___
#define ___ASURA_PS3_DLC_SYSTEM_H___ 1

#ifdef ASURA_SUPPORT_DOWNLOADABLE_CONTENT

#include <np/drm.h>

#include "Core/Asura_HashTree.h"

class Asura_DLC_DownloadedFileData;
class Asura_PS3_GameContent;

class Asura_PS3_DLC_System
{
public:
	static void Initialise();
	static void Shutdown();

	static void UpdateDownloadedFiles(Asura_TemplateHashTree<Asura_DLC_DownloadedFileData*>& xDLCFiles);

	static bool IsNewContentAvailable();
	static void OpenStore();

	static const SceNpDrmKey* GetDRMKey() { return &s_xDRMKey; }
	static const char* GetRootDirectory();

	static bool IsEncryptedFile(const char* szFilename);

private:
	static const SceNpDrmKey s_xDRMKey;

	static Asura_PS3_GameContent* s_pxGameContent;
	static char s_acRootDirectory[128];
};

#endif //#ifdef ASURA_SUPPORT_DOWNLOADABLE_CONTENT

#endif // #ifndef ___ASURA_PS3_DLC_SYSTEM_H___
