//
// Asura_Platform_NetTransport_System.cpp
//
// PS3 version, copied from PC/PS2 version. 
//
// Created by MH - 3.12.07
//
// Copyright (C) 2003 Rebellion, All Rights Reserved.
//

#include "Core/Asura.h"

// This file's header.
#include "Network/Asura_NetTransport_System.h"

#ifdef ASURA_SUPPORT_EXTERNAL_NETWORK

// Asura includes
#include "Debugging/Asura_Assert.h"
#include "Network/Asura_LanGameFinder.h"
#include "Network/Asura_NetSocket_BSD.h"

// Asura_PS3
#include "Network/Asura_PS3_Network.h"



void Asura_NetTransport_System::Platform_Initialise()
{
	Asura_Assert(Asura_PS3_Network::IsConnected(), "PS3 network not initialised - use the Asura_NetLinkManager class");
}

void Asura_NetTransport_System::Platform_Update()
{
}

void Asura_NetTransport_System::Platform_Shutdown()
{
}

void Asura_NetTransport_System::Platform_StartServer(bool bInternetGame)
{
}

void Asura_NetTransport_System::Platform_StopServer()
{
}

bool Asura_NetTransport_System::Platform_SendEnumHostsBroadcast()
{
	return Asura_LanGameFinder::SendEnumHostsBroadcast();
}

void Asura_NetTransport_System::Platform_ProcessEnumHostsRequest( Asura_NetAddress xAddress, u_short usPort, const char* pcData, u_int uDataLength )
{
	Asura_LanGameFinder::ProcessEnumHostsRequest(xAddress, usPort, pcData, uDataLength);
}

void Asura_NetTransport_System::Platform_SendEnumHostsResponse( Asura_NetAddress xAddress, u_short usPort)
{
	Asura_LanGameFinder::SendEnumHostsResponse(xAddress, usPort);
}

void Asura_NetTransport_System::Platform_ProcessEnumHostsResponse( Asura_NetAddress xAddress, u_short usPort, const char* pcData, int iDataSize )
{
	Asura_LanGameFinder::ProcessEnumHostsResponse(xAddress, usPort, pcData, iDataSize);
}


void Asura_NetTransport_System::Platform_Client_ClientConnected(Asura_NetConnection* pxConnection)
{
	// KOR - This empty function was originally used for initiating the peer-to-peer voice message
	// exchange, which was moved to the Platform_StartGame (see below) to stop it overflowing during load.
	// It may come in useful later or on other platforms though.
}

void Asura_NetTransport_System::Platform_Client_ClientDisconnected(Asura_NetConnection* pxConnection)
{
	// Do nothing
}

void Asura_NetTransport_System::Platform_StartGame()
{
}

bool Asura_NetTransport_System::Platform_HandleMessage( Asura_NetAddress xAddress, u_short usPort, const char* pcMessage, int iLength)
{
	return false;
}

u_int Asura_NetTransport_System::Platform_GetNetAdaptorIP( int iAdapter ) 
{ 	
	// TODO
	return 0;
}

const char* Asura_NetTransport_System::Platform_GetStringFromAddress(Asura_NetAddress xAddress, unsigned short usPort)
{
	return Asura_NetSocket_BSD::GetStringFromAddress( xAddress, usPort );
}

void Asura_NetTransport_System::Platform_GetAddressFromString(const char* szAddress, Asura_NetAddress* pxAddress, unsigned short* pusPort)
{
	Asura_NetSocket_BSD::GetAddressFromString( szAddress, pxAddress, pusPort );
}

Asura_NetSocket* Asura_NetTransport_System::Platform_AllocateNetSocket( u_int uMaxMachines )
{
	return new Asura_NetSocket_BSD( uMaxMachines );
}

bool Asura_Network_SessionInfo::Platform_IsSameHost(Asura_Network_SessionInfo* pxSession)
{
	return ((m_xHostAddr == pxSession->m_xHostAddr) && (m_usHostPort == pxSession->m_usHostPort));
}

#endif //#ifdef ASURA_SUPPORT_EXTERNAL_NETWORK
