//////////////////////////////////////////////////////////////////////////////
//
// Asura_Platform_Lobby.h
//
// Copyright (c) 2008 Rebellion. All rights reserved.
//
// Description:
//
//     PS3 types for online lobby
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef ASURA_PLATFORM_LOBBY_H___
#define ASURA_PLATFORM_LOBBY_H___ 1

//Asura_Lobby_Types.h provides an dummy for Asura_Platform_Lobby_GameConnectData when
//lobby support is not enabled - PJC 14/04/09
#ifdef ASURA_SUPPORT_LOBBY

#include <np.h>

#include "Core\Memory\Asura_Mem.h"

class Asura_Platform_Lobby_LobbyData
{
public:
	u_int m_uDummy;
};

// KOR - in order to maintain compatibility, Asura_Platform_Lobby_GameConnectData
// must be the same size and alignment for all platforms. Currently PS3
// gives the strictest limits with a size of 40 bytes with 8-byte alignment.
class Asura_Platform_Lobby_GameConnectData
{
public:
	SceNpId m_xNpID;							// 36 bytes
	u_char m_aucPad[4];							// 4 bytes
												// 40 bytes total
};

class Asura_Platform_Lobby_PlayerData
{
public:
	Asura_Platform_Lobby_PlayerData() {}
	Asura_Platform_Lobby_PlayerData(const Asura_Platform_Lobby_PlayerData& xConnectData)
	{
		Asura_Mem::Copy(&m_xNpID, &xConnectData.m_xNpID, sizeof(SceNpId));
		m_xRoomMemberID = xConnectData.m_xRoomMemberID;
	}

	SceNpId m_xNpID;
	SceNpMatching2RoomMemberId m_xRoomMemberID;

	bool operator==( const Asura_Platform_Lobby_GameConnectData& xOther ) const
	{
		return (sceNpUtilCmpNpId(&xOther.m_xNpID, &m_xNpID) == 0);
	}

	bool operator==( const Asura_Platform_Lobby_PlayerData& xOther ) const
	{
		return (sceNpUtilCmpNpId(&xOther.m_xNpID, &m_xNpID) == 0);
	}
};

class Asura_Platform_Lobby_ListEntry
{
public:
	SceNpMatching2RoomId m_xRoomID;
};

#endif

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

#endif // #ifndef ASURA_PLATFORM_LOBBY_H___
