//////////////////////////////////////////////////////////////////////////////
//
// Asura_PS3_SPURS_TaskController.h
//
// Copyright (c) 2009 Rebellion. All rights reserved.
//
// Description:
//
//     
//////////////////////////////////////////////////////////////////////////////    

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef ASURA_PS3_SPURS_TASKCONTROLLER
#define ASURA_PS3_SPURS_TASKCONTROLLER 1

#include "PPU_SPU_Utils/Asura_PS3_SPURS.h"

class	Asura_PS3_SPURS_TaskController
{
public:
	Asura_PS3_SPURS_TaskController( u_int uNumSPUs, const char* szGroupName, const void* pvELFAddr, u_int uQueueEntrySize, u_int uMaxQueueEntries );
	virtual ~Asura_PS3_SPURS_TaskController();


				void									Begin( void* pvTaskArg );
				void									Begin( void* pvTaskArg, void* pContext );
				void									End( void );

				int										PushTask_Blocking( void* pBuffer );
				int										PushTask( void* pBuffer );
				void									PushTerminators( void );
				int										PopTask_Blocking( void* pBuffer );
				int										PopTask( void* pBuffer );

				u_int									GetNumEntriesInQueue( void );
					
				int										ClearQueue( void );

	inline		void										SetTerminator( const void* pvTerminatorJob )	{	m_pvTerminatorJob = pvTerminatorJob; }
	inline		CellSpursLFQueue*							GetQueue( void )								{	return m_pxQueueEA; }
	inline		Asura_PS3_SPURS::Asura_PS3_SPURS_Taskset*	GetTaskset( void )								{	return m_pxTaskset; }

protected:
	Asura_PS3_SPURS::Asura_PS3_SPURS_Taskset*	m_pxTaskset;
	Task*										m_pxTasks[5];	//	TODO: Need a better way of holding this
	
	CellSpursLFQueue*							m_pxQueueEA;
	void*										m_pQueueBuffer;

	const void*									m_pvTerminatorJob;
	const void*									m_pvELFAddr;
	
	u_int										m_uNumTasks;
	bool										m_bQueueTerminated;


	Asura_PS3_SPURS								m_xSPURS;
private:
};

#endif