// SCE CONFIDENTIAL
// PLAYSTATION(R)3 Programmer Tool Runtime Library 250.001
// Copyright (C) 2008 Sony Computer Entertainment Inc.
// All Rights Reserved.

#include "cellUtilSpursCommandListDispatcher.h"

__CELL_UTIL_SPURS_BEGIN

int CommandListDispatcher::create(CommandListDispatcher* jobChain,
								  const char *name,
								  Spurs* spurs,
								  uint16_t sizeJobDescriptor,
								  uint8_t priority,
								  uint8_t mask)
{
	__RETURN_IF(EventFlag::initialize(&jobChain->mEventFlag, spurs));
	__RETURN_IF(Job::Notification::initialize(&jobChain->mNotification, &jobChain->mEventFlag));
	__RETURN_IF(JobGuard::initialize(&jobChain->mGuard, jobChain, 1));

	jobChain->mJobList.numJobs = 1;
	jobChain->mJobList.sizeOfJob = sizeof(Job::Notification);
	jobChain->mJobList.eaJobList = (uintptr_t)&jobChain->mNotification;

	jobChain->mHasSet = 0;
	jobChain->__reserved__ = 0;
	jobChain->mCommand[0] = Job::Guard(jobChain->mGuard);
	jobChain->mCommand[1] = Job::End();
	jobChain->mCommand[2] = Job::Sync();
	jobChain->mCommand[3] = Job::JobList(jobChain->mJobList);
	jobChain->mCommand[4] = Job::Sync();
	jobChain->mCommand[5] = Job::Flush();
	jobChain->mCommand[6] = Job::ResetPC(jobChain->mCommand);
	__builtin_memset(jobChain->__aligned_to_128bytes__, 0, sizeof(jobChain->__aligned_to_128bytes__));

	return JobChain::create(jobChain, name, spurs, jobChain->mCommand, sizeJobDescriptor, priority, mask);
}

__CELL_UTIL_SPURS_END

// Local Variables:
// mode: C++
// c-file-style: "stroustrup"
// tab-width: 4
// End:
// vim:sw=4:sts=4:ts=4
