// SCE CONFIDENTIAL
// PLAYSTATION(R)3 Programmer Tool Runtime Library 250.001
// Copyright (C) 2008 Sony Computer Entertainment Inc.
// All Rights Reserved.

#include "cellUtilSpursJobChain.h"

__CELL_UTIL_SPURS_BEGIN

int JobChain::create(JobChain* jobChain,
					 const char *name,
					 Spurs* spurs,
					 const uint64_t* commandList,
					 uint16_t sizeJobDescriptor,
					 uint8_t priority_,
					 uint8_t mask)
{
	uint8_t priority[CELL_SPURS_MAX_SPU];
	unsigned max = 0;

	for (uint32_t spu = 0; spu < CELL_SPURS_MAX_SPU; ++spu) {
		priority[spu] = (mask & 1) ? priority_ : 0;
		max += mask & 1;
		mask >>= 1;
	}

	CellSpursJobChainAttribute attr;
	__RETURN_IF(cellSpursJobChainAttributeInitialize(&attr,
													 commandList,
													 sizeJobDescriptor,
													 4,        // maxGrabbedJob,
													 priority, //priorityTable
													 8,        //max contention
													 true,     // auto ready count
													 0,        // tag1
													 1,        // tag2
													 false,    //isFixedMemAlloc
													 1024,     // maxSizeJobDescriptor
													 8         // readyCount
					));
	__RETURN_IF(cellSpursJobChainAttributeSetName(&attr, name));
	__RETURN_IF(cellSpursJobChainAttributeSetHaltOnError(&attr));

	return cellSpursCreateJobChainWithAttribute(spurs, jobChain, &attr);
}

__CELL_UTIL_SPURS_END

// Local Variables:
// mode: C++
// c-file-style: "stroustrup"
// tab-width: 4
// End:
// vim:sw=4:sts=4:ts=4
