
//
// Asura_PS3_DeferredShading.h
//
// Created by DMR 13/02/07
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
// Handles deferred lighting passes
//

#ifndef __ASURA_PS3_DEFERREDSHADING_H__
#define __ASURA_PS3_DEFERREDSHADING_H__

#include "Rendering/Asura_PS3_Graphics.h"

#include "Rendering/Asura_PS3_GCM_IndexBuffer.h"
#include "Rendering/Asura_PS3_GCM_VertexBuffer.h"

class Asura_Photon;
class Asura_Vector_3;

#define ASURA_DEFERRED_BUFFERS		8

class Asura_PS3_DeferredShading
{
	friend class Asura_DeferredShading;
	friend class Asura_PS3_Graphics;

public:
	static void RenderSphereLOD( int iLod );

private:
	static Asura_PS3_GCM_IndexBuffer	s_xIndexBuffer;
	static Asura_PS3_GCM_VertexBuffer	s_xVertexBuffer[ ASURA_DEFERRED_BUFFERS ];
	static Asura_PS3_GCM_VertexBuffer*	s_apxSphereVB[4];
	static int							s_aiSphereNumVerts[4];

	static void Initialise(void);
	static void Shutdown(void);
	static void Reset(void);
	static void BeginFrame(void);
	static void EndFrame(void);
	static void RenderPhotons(bool bWithDarkeningShadows, bool bWithRealShadows, bool bWithNoShadows);
	static void RenderDebugOutput(void);

	static void SetShaderParameters( Asura_Photon *pxPhoton, int iPass, Asura_Vector_3 &xMeshPos, float fMeshScale, float fDistFade );
	static void DebugRenderDeferredBuffers(void);
	static void RenderPhotons_Callback( class Asura_Photon* pxPhoton, void* pData );
	static void RenderPhotonOutlines_Callback( class Asura_Photon* pxPhoton, void* pData );
};

#endif	// __ASURA_PS3_DEFERREDSHADING_H__
