
///////////////////////////////////////////////////////////////////////////////
//
// File		: Asura_PS3_LineRenderer.h
// Author	: Andy Tate ( 8-Sep-2005 )
// Modified	: Catalin Arsenescu ( 19-June-2007 )
//
// Copyright (C) 2005 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __ASURA_PS3_LINERENDERER_H__
#define __ASURA_PS3_LINERENDERER_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////
class Asura_Vector_2;
class Asura_Vector_3;

////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

class Asura_PS3_LineRenderer
{
public:
	// Public functions...

	// Initialisation/shutdown functions...
	static	void	Initialise	(void);
	static	void	Reset		(void);
	static	void	Shutdown	(void);

	static	void	BeginFrame	( void );
	static	void	EndFrame	( void );

	// Render functions...
	static void Render2DLine( const Asura_Vector_2& xP1, const Asura_Vector_2& xP2, const u_int uColour );
	static void Render3DLine( const Asura_Vector_3& xP1, const Asura_Vector_3& xP2, const u_int uColour );

private:
	static	u_int	s_u2DLinesToRender;
	static	u_int	s_u3DLinesToRender;
	static	u_int	s_u2DBuffer;
	static	u_int	s_u3DBuffer;

	static	void	Flush2DLines( void );
	static	void	Flush3DLines( void );

	Asura_PS3_LineRenderer  (void);
	Asura_PS3_LineRenderer  (const Asura_PS3_LineRenderer& xOther);
	~Asura_PS3_LineRenderer ();
	Asura_PS3_LineRenderer&	operator=		(const Asura_PS3_LineRenderer& xOther);
};   // End of class 'Asura_PS3_LineRenderer'.

#endif   // ifndef __ASURA_PS3_LINERENDERER_H__

/// End of file. ///
