//////////////////////////////////////////////////////////////////////////////
//
// Asura_PS3_RenderingOptions.h
//
// Copyright (c) 2005 Rebellion. All rights reserved.
//
// Description:
//
//     toggles for rendering various types of things on PS3
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef ___ASURA_PS3_RENDERINGOPTIONS_H___
#define ___ASURA_PS3_RENDERINGOPTIONS_H___ 1

class Asura_PS3_RenderingOptions
{

    public:

        // T Y P E S /////////////////////////////////////////////////////////

        enum OPTION
        {
/*     0 */ OPTION_DRAW_FRACTAL_SKY,
/*     1 */ OPTION_DRAW_SKYBOX,
/*     2 */ OPTION_DRAW_ENV,
/*     3 */ OPTION_DRAW_OBJS,
/*     4 */ OPTION_ENABLE_OBJ_SHADOWS,
/*     5 */ OPTION_DRAW_HIERS,
/*     6 */ OPTION_ENABLE_HIER_SHADOWS,
/*     7 */ OPTION_DRAW_SMOOTH_SKINS,
/*     8 */ OPTION_ENABLE_SMOOTH_SKIN_SHADOWS,
/*     9 */ OPTION_DRAW_WEAPON,
/*    10 */ OPTION_DRAW_CORONAS,
/*    11 */ OPTION_DRAW_PARTICLES,
/*    12 */ OPTION_DRAW_DECALS,
/*    13 */ OPTION_DRAW_OVERLAYS,
/*    14 */ OPTION_ENABLE_PARALLAX_MAP_ENV,
/*    15 */ OPTION_ENABLE_DYNAMIC_LIGHTS_ENV,
            NUM_OPTIONS,
        };

        // C L A S S   M E T H O D S /////////////////////////////////////////

        static bool GetOption( OPTION eOption ) { return s_xOptions.m_abOptions[eOption]; }

        static void SetOption( OPTION eOption, bool bValue ) { s_xOptions.m_abOptions[eOption] = bValue; }

    private:

        // C L A S S   S T A T E /////////////////////////////////////////////

        static union OptionsUnion
		{
			bool m_abOptions[NUM_OPTIONS];
			struct 
			{
				bool m_bDrawFractalSky;
				bool m_b_DrawSkybox;
				bool m_b_DrawEnv;
				bool m_b_DrawObjs;
				bool m_b_EnableObjShadows;
				bool m_b_DrawHiers;
				bool m_b_EnableHierShadows;
				bool m_b_DrawSmoothSkins;
				bool m_b_EnableSmoothSkinShadows;
				bool m_b_DrawWeapon;
				bool m_b_DrawCoronas;
				bool m_b_DrawParticles;
				bool m_b_DrawDecals;
				bool m_b_DrawOverlays;
				bool m_b_EnableParallaxMapEnv;
				bool m_b_EnableDynamicLightsEnv;
			}m_xOptions;
		} s_xOptions;

};


// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

#endif // #ifndef ___ASURA_PS3_RENDERINGOPTIONS_H___
