//////////////////////////////////////////////////////////////////////////////
//
// Asura_Platform_Module.cpp
//
// Copyright (c) 2006 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "Core/Asura.h"

// Engine independent.
#include "Rendering/Asura_Module.h"

// Engine platform-specific.
#include "Rendering/Asura_PS3_EnvironmentRenderer.h"

// C L A S S   I M P L E M E N T A T I O N S /////////////////////////////////

void Asura_Module_Handler::Platform_BeginRender( void )
{
}

void Asura_Module_Handler::Platform_Render( void )
{
    Asura_PS3_EnvironmentRenderer::Render( false );
}

void Asura_Module_Handler::Platform_EndRender( void )
{
}

void Asura_Module_Handler::Platform_Initialise( void )
{
}

void Asura_Module_Handler::Platform_Shutdown( void )
{
}

#ifdef ASURA_TARGET_SM3
// This is to be called when the deferred lighting has been done, but before specialFX 
// rendering, for rendering of translucency and water.
void Asura_Module_Handler::Platform_RenderLate(void)
{	
	Asura_PS3_EnvironmentRenderer::Render( true );
	Asura_PS3_EnvironmentRenderer::RenderWater();
}
#endif
