//
// Corona_FP.h
//
// Created by Catalin Arsenescu - 26 August 2007
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_PS3_CORONA_FP_H__
#define __ASURA_PS3_CORONA_FP_H__

extern u_int _binary_PS3_Corona_FP_bin_start;
extern u_int _binary_PS3_Corona_FP_bin_end;

extern u_int _binary_PS3_Corona_Soft_FP_bin_start;
extern u_int _binary_PS3_Corona_Soft_FP_bin_end;

enum FRAGMENT_SHADER_UNIFORM
{
	FP_DepthAdjustment,

	FP_ELEMENTS
};

enum TEXTURE_UNITS
{
	FP_DepthBufferSampler,
	FP_Sampler,
	FP_TU_ELEMENTS
};

class Asura_PS3_Corona_Handles : public Asura_PS3_FP_Handles
{
public:
	Asura_PS3_Corona_Handles() : Asura_PS3_FP_Handles( FP_ELEMENTS, FP_TU_ELEMENTS )
	{}

	void InitialiseFromShader( Asura_PS3_FragmentShaderBase* pxShader )
	{
		pxShader->InitUniformElement( FP_DepthAdjustment,	"g_xDepthAdjustment",		1 );

		pxShader->InitTextureUnit( FP_DepthBufferSampler,	"g_xDepthBufferSampler",	CELL_GCM_TEXTURE_CLAMP, CELL_GCM_TEXTURE_CLAMP, CELL_GCM_TEXTURE_NEAREST, CELL_GCM_TEXTURE_NEAREST );
		pxShader->InitTextureUnit( FP_Sampler,				"g_xSampler",				CELL_GCM_TEXTURE_CLAMP, CELL_GCM_TEXTURE_CLAMP, CELL_GCM_TEXTURE_LINEAR_LINEAR, CELL_GCM_TEXTURE_LINEAR
			, true
			);
	}
};

#endif //#ifndef __ASURA_PS3_CORONA_FP_H__
