//
// FSFX_FishEye_FP.h
//
// Created by Catalin Arsenescu - 11 September 2007
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_PS3_FSFX_FISHEYE_FP_H__
#define __ASURA_PS3_FSFX_FISHEYE_FP_H__

extern u_int _binary_PS3_FSFX_FishEye_FP_bin_start;
extern u_int _binary_PS3_FSFX_FishEye_FP_bin_end;

extern u_int _binary_PS3_FSFX_FishEye_FP0_bin_start;
extern u_int _binary_PS3_FSFX_FishEye_FP0_bin_end;
extern u_int _binary_PS3_FSFX_FishEye_FP1_bin_start;
extern u_int _binary_PS3_FSFX_FishEye_FP1_bin_end;
extern u_int _binary_PS3_FSFX_FishEye_FP2_bin_start;
extern u_int _binary_PS3_FSFX_FishEye_FP2_bin_end;
extern u_int _binary_PS3_FSFX_FishEye_FP3_bin_start;
extern u_int _binary_PS3_FSFX_FishEye_FP3_bin_end;

enum FRAGMENT_SHADER_UNIFORM_FE
{
	FPFE_Data1,
	FPFE_Data2,
	FPFE_ELEMENTS
};

enum TEXTURE_UNITS_FE
{
	FPFE_TextureSampler,
	FPFE_TU_ELEMENTS
};

class Asura_PS3_FSFX_FE_Handles : public Asura_PS3_FP_Handles
{
public:
	Asura_PS3_FSFX_FE_Handles() : Asura_PS3_FP_Handles( FPFE_ELEMENTS, FPFE_TU_ELEMENTS )
	{}

	void InitialiseFromShader( Asura_PS3_FragmentShaderBase* pxShader )
	{
		pxShader->InitUniformElement( FPFE_Data1,	"g_fData1", 1 );
		pxShader->InitUniformElement( FPFE_Data2,	"g_fData1Consts", 1 );
		pxShader->InitTextureUnit( FPFE_TextureSampler, "g_xTextureSampler", CELL_GCM_TEXTURE_CLAMP, CELL_GCM_TEXTURE_CLAMP, CELL_GCM_TEXTURE_LINEAR, CELL_GCM_TEXTURE_LINEAR
			, true
			);
	}
};

#endif //#ifndef __ASURA_PS3_FSFX_FISHEYE_FP_H__
