//
// FSFX_Gamma_FP.h
//
// Created by Catalin Arsenescu - 11 September 2007
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_PS3_FSFX_GAMMA_FP_H__
#define __ASURA_PS3_FSFX_GAMMA_FP_H__

extern u_int _binary_PS3_FSFX_Gamma_FP_bin_start;
extern u_int _binary_PS3_FSFX_Gamma_FP_bin_end;

enum FRAGMENT_SHADER_UNIFORM_G
{
	FPG_Coefficients0,
	FPG_Coefficients1,
	FPG_Coefficients2,
	FPG_Coefficients3,

	FPG_ELEMENTS
};

enum TEXTURE_UNITS_G
{
	FPG_InitialImage,

	FPG_TU_ELEMENTS
};

class Asura_PS3_FSFX_G_Handles : public Asura_PS3_FP_Handles
{
public:
	Asura_PS3_FSFX_G_Handles() : Asura_PS3_FP_Handles( FPG_ELEMENTS, FPG_TU_ELEMENTS )
	{}

	void InitialiseFromShader( Asura_PS3_FragmentShaderBase* pxShader )
	{
		pxShader->InitUniformElement( FPG_Coefficients0,	"g_xCoefficients0",		1 );
		pxShader->InitUniformElement( FPG_Coefficients1,	"g_xCoefficients1",		1 );
		pxShader->InitUniformElement( FPG_Coefficients2,	"g_xCoefficients2",		1 );
		pxShader->InitUniformElement( FPG_Coefficients3,	"g_xCoefficients3",		1 );

		pxShader->InitTextureUnit( FPG_InitialImage,	"g_xInitialImage",	CELL_GCM_TEXTURE_CLAMP, CELL_GCM_TEXTURE_CLAMP, CELL_GCM_TEXTURE_NEAREST, CELL_GCM_TEXTURE_NEAREST
			, true
			);
	}
};

#endif //#ifndef __ASURA_PS3_FSFX_GAMMA_FP_H__
