//
// FSFX_SM30_Bloom_FP.h
//
// Created by Catalin Arsenescu - 11 September 2007
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_PS3_FSFX_SM30_BLOOM_FP_H__
#define __ASURA_PS3_FSFX_SM30_BLOOM_FP_H__

extern u_int _binary_PS3_FSFX_SM30_Bloom_FP0000_bin_start;
extern u_int _binary_PS3_FSFX_SM30_Bloom_FP0000_bin_end;
extern u_int _binary_PS3_FSFX_SM30_Bloom_FP0100_bin_start;
extern u_int _binary_PS3_FSFX_SM30_Bloom_FP0100_bin_end;
extern u_int _binary_PS3_FSFX_SM30_Bloom_FP0110_bin_start;
extern u_int _binary_PS3_FSFX_SM30_Bloom_FP0110_bin_end;
extern u_int _binary_PS3_FSFX_SM30_Bloom_FP1000_bin_start;
extern u_int _binary_PS3_FSFX_SM30_Bloom_FP1000_bin_end;
extern u_int _binary_PS3_FSFX_SM30_Bloom_FP1100_bin_start;
extern u_int _binary_PS3_FSFX_SM30_Bloom_FP1100_bin_end;
extern u_int _binary_PS3_FSFX_SM30_Bloom_FP1110_bin_start;
extern u_int _binary_PS3_FSFX_SM30_Bloom_FP1110_bin_end;


extern u_int _binary_PS3_FSFX_SM30_Bloom_FP0001_bin_start;
extern u_int _binary_PS3_FSFX_SM30_Bloom_FP0001_bin_end;
extern u_int _binary_PS3_FSFX_SM30_Bloom_FP0101_bin_start;
extern u_int _binary_PS3_FSFX_SM30_Bloom_FP0101_bin_end;
extern u_int _binary_PS3_FSFX_SM30_Bloom_FP0111_bin_start;
extern u_int _binary_PS3_FSFX_SM30_Bloom_FP0111_bin_end;
extern u_int _binary_PS3_FSFX_SM30_Bloom_FP1001_bin_start;
extern u_int _binary_PS3_FSFX_SM30_Bloom_FP1001_bin_end;
extern u_int _binary_PS3_FSFX_SM30_Bloom_FP1101_bin_start;
extern u_int _binary_PS3_FSFX_SM30_Bloom_FP1101_bin_end;
extern u_int _binary_PS3_FSFX_SM30_Bloom_FP1111_bin_start;
extern u_int _binary_PS3_FSFX_SM30_Bloom_FP1111_bin_end;

enum FRAGMENT_SHADER_UNIFORM_B30
{
	FPB30_OutputColour,
	FPB30_InputThreshold,
	FPB30_FocalDistances,
	FPB30_UVCorrection,
	FPB30_Saturation,
	FPB30_InputScale,
	FPB30_AccumFade,
	FPB30_DepthAdjustment,

	FPB30_ELEMENTS
};

enum TEXTURE_UNITS_B30
{
	FPB30_Texture,
	FPB30_AccumTexture,
	FPB30_DepthTexture,

	FPB30_TU_ELEMENTS
};

class Asura_PS3_FSFX_SM30Bloom_Handles : public Asura_PS3_FP_Handles
{
public:
	Asura_PS3_FSFX_SM30Bloom_Handles() : Asura_PS3_FP_Handles( FPB30_ELEMENTS, FPB30_TU_ELEMENTS )
	{}

	void InitialiseFromShader( Asura_PS3_FragmentShaderBase* pxShader )
	{
		pxShader->InitUniformElement( FPB30_OutputColour,		"g_xOutputColour",		1 );
		pxShader->InitUniformElement( FPB30_InputThreshold,		"g_xInputThreshold",	1 );
		pxShader->InitUniformElement( FPB30_FocalDistances,		"g_xFocalDistances",	1 );
		pxShader->InitUniformElement( FPB30_UVCorrection,		"g_xUVCorrection",		1 );
		pxShader->InitUniformElement( FPB30_Saturation,			"g_fSaturation",		1 );
		pxShader->InitUniformElement( FPB30_InputScale,			"g_fInputScale",		1 );
		pxShader->InitUniformElement( FPB30_AccumFade,			"g_fAccumFade",			1 );
		pxShader->InitUniformElement( FPB30_DepthAdjustment,	"g_xDepthAdjustment",			1 );

		pxShader->InitTextureUnit( FPB30_Texture,		"g_xTexture",		CELL_GCM_TEXTURE_CLAMP, CELL_GCM_TEXTURE_CLAMP, CELL_GCM_TEXTURE_LINEAR, CELL_GCM_TEXTURE_LINEAR
			, true
			);
		pxShader->InitTextureUnit( FPB30_AccumTexture,	"g_xAccumTexture",	CELL_GCM_TEXTURE_CLAMP, CELL_GCM_TEXTURE_CLAMP, CELL_GCM_TEXTURE_LINEAR, CELL_GCM_TEXTURE_LINEAR
			, true
			);
		pxShader->InitTextureUnit( FPB30_DepthTexture,	"g_xDepthTexture",	CELL_GCM_TEXTURE_CLAMP, CELL_GCM_TEXTURE_CLAMP, CELL_GCM_TEXTURE_NEAREST, CELL_GCM_TEXTURE_NEAREST );
	}
};

#endif //#ifndef __ASURA_PS3_FSFX_SM30_BLOOM_FP_H__
