//
// FSFX_SM30_DepthOfField_FP.h
//
// Created by Catalin Arsenescu - 30 November 2007
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_PS3_FSFX_SM30_DEPTHOFFIELD_FP_H__
#define __ASURA_PS3_FSFX_SM30_DEPTHOFFIELD_FP_H__

extern u_int _binary_PS3_FSFX_SM30_DepthOfField_bin_start;
extern u_int _binary_PS3_FSFX_SM30_DepthOfField_bin_end;

enum FRAGMENT_SHADER_UNIFORM_DOF30
{
	FPDOF30_EffectStrength,
	FPDOF30_FocalDistances,
	FPDOF30_DepthAdjustment,

	FPDOF30_ELEMENTS
};

enum TEXTURE_UNITS_DOF30
{
	FPDOF30_BlurredTexture,
	FPDOF30_DepthTexture,

	FPDOF30_TU_ELEMENTS
};

class Asura_PS3_FSFX_SM30DepthOfField_Handles : public Asura_PS3_FP_Handles
{
public:
	Asura_PS3_FSFX_SM30DepthOfField_Handles() : Asura_PS3_FP_Handles( FPDOF30_ELEMENTS, FPDOF30_TU_ELEMENTS )
	{}

	void InitialiseFromShader( Asura_PS3_FragmentShaderBase* pxShader )
	{
		pxShader->InitUniformElement( FPDOF30_EffectStrength,	"g_fEffectStrength",	1 );
		pxShader->InitUniformElement( FPDOF30_FocalDistances,	"g_xFocalDistances",	1 );
		pxShader->InitUniformElement( FPDOF30_DepthAdjustment,	"g_xDepthAdjustment",	1 );
		

		pxShader->InitTextureUnit( FPDOF30_BlurredTexture,	"g_xBlurredTexture",	CELL_GCM_TEXTURE_CLAMP, CELL_GCM_TEXTURE_CLAMP, CELL_GCM_TEXTURE_LINEAR, CELL_GCM_TEXTURE_LINEAR
			, true
			);
		pxShader->InitTextureUnit( FPDOF30_DepthTexture,	"g_xDepthTexture",		CELL_GCM_TEXTURE_CLAMP, CELL_GCM_TEXTURE_CLAMP, CELL_GCM_TEXTURE_NEAREST, CELL_GCM_TEXTURE_NEAREST );
	}
};

#endif //#ifndef __ASURA_PS3_FSFX_SM30_DEPTHOFFIELD_FP_H__
