//
// Fog_FP.h
//
// Created by Catalin Arsenescu - 08 September 2007
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_PS3_FOG_FP_H__
#define __ASURA_PS3_FOG_FP_H__

extern u_int _binary_PS3_Fog_FP_bin_start;
extern u_int _binary_PS3_Fog_FP_bin_end;

enum FRAGMENT_SHADER_UNIFORM
{
	FP_FogColour,
	FP_Fog,
	FP_DepthAdjustment,

	FP_ELEMENTS,
};

enum TEXTURE_UNITS
{
	FP_DepthTexture,
	FP_FogTexture,

	FP_TU_ELEMENTS
};

class Asura_PS3_Fog_Handles : public Asura_PS3_FP_Handles
{
public:
	Asura_PS3_Fog_Handles() : Asura_PS3_FP_Handles( FP_ELEMENTS, FP_TU_ELEMENTS )
	{}

	void InitialiseFromShader( Asura_PS3_FragmentShaderBase* pxShader )
	{
		pxShader->InitUniformElement( FP_FogColour,			"g_xFogColour",		1 );
		pxShader->InitUniformElement( FP_Fog,				"g_xFog",			1 );
		pxShader->InitUniformElement( FP_DepthAdjustment,	"g_xDepthAdjustment",			1 );

		pxShader->InitTextureUnit( FP_DepthTexture,	"g_xDepthTexture",	CELL_GCM_TEXTURE_CLAMP, CELL_GCM_TEXTURE_CLAMP, CELL_GCM_TEXTURE_NEAREST, CELL_GCM_TEXTURE_NEAREST );
		pxShader->InitTextureUnit( FP_FogTexture,	"g_xFogSampler",	CELL_GCM_TEXTURE_CLAMP, CELL_GCM_TEXTURE_CLAMP, CELL_GCM_TEXTURE_NEAREST, CELL_GCM_TEXTURE_NEAREST );
	}
};

#endif //#ifndef __ASURA_PS3_FOG_FP_H__
