//
// YUV_to_RGB_FP.h
//
// Created by Jason Turner - 19 Nov 2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_PS3_YUV_TO_RGB_FP_H__
#define __ASURA_PS3_YUV_TO_RGB_FP_H__

extern u_int _binary_PS3_YUV_to_RGB_FP_bin_start;
extern u_int _binary_PS3_YUV_to_RGB_FP_bin_end;

enum TEXTURE_UNITS
{
	Y_Sampler,
	U_Sampler,
	V_Sampler,

	FP_TU_ELEMENTS
};

class Asura_PS3_YUV_to_RGB_FP_Handles : public Asura_PS3_FP_Handles
{
public:
	// Asura_PS3_FP_Handles( <total shader constants>, <total samplers> )
	Asura_PS3_YUV_to_RGB_FP_Handles() : Asura_PS3_FP_Handles( 0, FP_TU_ELEMENTS )
	{}

	void InitialiseFromShader( Asura_PS3_FragmentShaderBase* pxShader )
	{
		pxShader->InitTextureUnit( Y_Sampler,	"g_xYMap",	CELL_GCM_TEXTURE_CLAMP, CELL_GCM_TEXTURE_CLAMP, CELL_GCM_TEXTURE_CONVOLUTION_MIN, CELL_GCM_TEXTURE_CONVOLUTION_MAG, false );
		pxShader->InitTextureUnit( U_Sampler,	"g_xUMap",	CELL_GCM_TEXTURE_CLAMP, CELL_GCM_TEXTURE_CLAMP, CELL_GCM_TEXTURE_CONVOLUTION_MIN, CELL_GCM_TEXTURE_CONVOLUTION_MAG, false );
		pxShader->InitTextureUnit( V_Sampler,	"g_xVMap",	CELL_GCM_TEXTURE_CLAMP, CELL_GCM_TEXTURE_CLAMP, CELL_GCM_TEXTURE_CONVOLUTION_MIN, CELL_GCM_TEXTURE_CONVOLUTION_MAG, false );
	}
};

#endif // __ASURA_PS3_YUV_TO_RGB_FP_H__
