//
// BotaniclasImposters_VP.h
//
// Created by Catalin Arsenescu - 06 September 2007
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_PS3_BOTANICALS_IMPOSTERS_VP_H__
#define __ASURA_PS3_BOTANICALS_IMPOSTERS_VP_H__

extern uint32_t _binary_PS3_Botanicals_Imposters_VP_bin_start;
extern uint32_t _binary_PS3_Botanicals_Imposters_VP_bin_end;

static Asura_PS3_GCM_VertexShaderUniformParameter g_axVertexShaderImpostersUniform[] =
{
	//m_szName, m_usArraySize, m_sizeInFloat4ForOneElement, m_usRegister
	{ "g_xViewProjectionMatrix",		1, 4, NULL },
	{ "g_xCameraRightVector",			1, 1, NULL },
	{ "g_xCameraUpVector",				1, 1, NULL },
	{ "g_xCameraForwardsVector",		1, 1, NULL },
	{ "g_xCameraPosition",			    1, 1, NULL },
	{ "g_xUV_Offsets",					1, 1, NULL },
};

enum VERTEX_SHADER_UNIFORM_IMPOSTERS
{
	VSI_ViewProjectionMatrix,
	VSI_CameraRightVector,
	VSI_CameraUpVector,
	VSI_CameraForwardsVector,
	VSI_CameraPosition,
	VSI_UV_Offsets,
};

class Asura_PS3_VP_BotanicalImposter : public Asura_PS3_GCM_VertexShader
{
public:
	Asura_PS3_VP_BotanicalImposter() : Asura_PS3_GCM_VertexShader( (unsigned char *)&_binary_PS3_Botanicals_Imposters_VP_bin_start, (unsigned char *)&_binary_PS3_Botanicals_Imposters_VP_bin_end, g_axVertexShaderImpostersUniform, sizeof ( g_axVertexShaderImpostersUniform ) / sizeof ( Asura_PS3_GCM_VertexShaderUniformParameter ) )
	{
	}

	~Asura_PS3_VP_BotanicalImposter()
	{
		u_int i;
		for( i = 0; i < sizeof( g_axVertexShaderImpostersUniform ) / sizeof( Asura_PS3_GCM_VertexShaderUniformParameter ); ++i )
		{
			g_axVertexShaderImpostersUniform[ i ].CleanUp();
		}
	}
};

#endif //#ifndef __ASURA_PS3_BOTANICALS_IMPOSTERS_VP_H__
