//
// Decals_VP.h
//
// Created by Catalin Arsenescu - 26 August 2007
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_PS3_DECALS_SPEC_VP_H__
#define __ASURA_PS3_DECALS_SPEC_VP_H__

extern uint32_t _binary_PS3_Decals_Spec_VP_bin_start;
extern uint32_t _binary_PS3_Decals_Spec_VP_bin_end;

namespace PS3_Decals_Spec_VP
{

static Asura_PS3_GCM_VertexShaderUniformParameter g_axVertexShaderUniform[] =
{
	//m_szName, m_usArraySize, m_sizeInFloat4ForOneElement, m_usRegister
	{ "g_xViewProjectionMatrix",	1, 4, NULL },
	{ "g_xCameraPosition",			1, 1, NULL },
	{ "g_xFadeValues",				1, 1, NULL },
	{ "g_xUVScroll",				1, 1, NULL },
};

enum VERTEX_SHADER_UNIFORM
{
	VS_ViewProjectionMatrix,
	VS_CameraPosition,
	VS_FadeValues,
	VS_UVScroll,
};

class Asura_PS3_VP_Decals_Spec : public Asura_PS3_GCM_VertexShader
{
public:
	Asura_PS3_VP_Decals_Spec() : Asura_PS3_GCM_VertexShader( (unsigned char *)&_binary_PS3_Decals_Spec_VP_bin_start, (unsigned char *)&_binary_PS3_Decals_Spec_VP_bin_end, g_axVertexShaderUniform, sizeof ( g_axVertexShaderUniform ) / sizeof ( Asura_PS3_GCM_VertexShaderUniformParameter ) )
	{
	}

	~Asura_PS3_VP_Decals_Spec()
	{
		u_int i;
		for( i = 0; i < sizeof( g_axVertexShaderUniform ) / sizeof( Asura_PS3_GCM_VertexShaderUniformParameter ); ++i )
		{
			g_axVertexShaderUniform[ i ].CleanUp();
		}
	}
};

};
#endif //#ifndef __ASURA_PS3_DECALS_SPEC_VP_H__
