//
// Env_Shadow_VP.h
//
// Created by Catalin Arsenescu - 21 April 2008
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_PS3_ENV_SHADOW_VP_H__
#define __ASURA_PS3_ENV_SHADOW_VP_H__

extern uint32_t _binary_PS3_Env_ShadowsCubicMap_VP_bin_start;
extern uint32_t _binary_PS3_Env_ShadowsCubicMap_VP_bin_end;

static Asura_PS3_GCM_VertexShaderUniformParameter g_axEnvironmentShadowCubicMapUniform[] =
{
	//m_szName, m_usArraySize, m_sizeInFloat4ForOneElement, m_usRegister
	{ "g_xViewProjectionMatrix",		1,	4,	NULL },
	{ "g_fShadowFrustumNearPlaneDepth",	1,	1,	NULL },
	{ "g_xCameraPosition",				1,	1,	NULL },
};

enum VERTEX_SHADER_UNIFORM_SHADOW
{
	VIEW_PROJECTION_MATRIX_SHADOW = 0,
	SHADOW_FRUSTUM_NEAR_PLANE_SHADOW,
	CAMERA_POSITION_SHADOW,
};

class Asura_PS3_VP_Env_Shadow_CubicMap : public Asura_PS3_GCM_VertexShader
{
public:
	Asura_PS3_VP_Env_Shadow_CubicMap() : Asura_PS3_GCM_VertexShader( (unsigned char *)&_binary_PS3_Env_ShadowsCubicMap_VP_bin_start, (unsigned char *)&_binary_PS3_Env_ShadowsCubicMap_VP_bin_end, g_axEnvironmentShadowCubicMapUniform, sizeof ( g_axEnvironmentShadowCubicMapUniform ) / sizeof ( Asura_PS3_GCM_VertexShaderUniformParameter ) )
	{
	}

	~Asura_PS3_VP_Env_Shadow_CubicMap()
	{
		u_int i;
		for( i = 0; i < sizeof( g_axEnvironmentShadowCubicMapUniform ) / sizeof( Asura_PS3_GCM_VertexShaderUniformParameter ); ++i )
		{
			g_axEnvironmentShadowCubicMapUniform[ i ].CleanUp();
		}
	}
};

#endif //#ifndef __ASURA_PS3_ENV_SHADOW_VP_H__
