//
// Env_ZPass_VP.h
//
// Created by Catalin Arsenescu - 26 August 2007
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_PS3_ENV_ZPASS_VP_H__
#define __ASURA_PS3_ENV_ZPASS_VP_H__

extern uint32_t _binary_PS3_Env_ZPass_VP_bin_start;
extern uint32_t _binary_PS3_Env_ZPass_VP_bin_end;

static Asura_PS3_GCM_VertexShaderUniformParameter g_axEnvironmentZPassUniform[] =
{
	//m_szName, m_usArraySize, m_sizeInFloat4ForOneElement, m_usRegister
	{ "g_xViewProjectionMatrix",	1, 4, NULL },
};

enum VERTEX_SHADER_UNIFORM_ZPASS
{
	VIEW_PROJECTION_MATRIX_ZPASS = 0,
};

class Asura_PS3_VP_Env_ZPass : public Asura_PS3_GCM_VertexShader
{
public:
	Asura_PS3_VP_Env_ZPass() : Asura_PS3_GCM_VertexShader( (unsigned char *)&_binary_PS3_Env_ZPass_VP_bin_start, (unsigned char *)&_binary_PS3_Env_ZPass_VP_bin_end, g_axEnvironmentZPassUniform, sizeof ( g_axEnvironmentZPassUniform ) / sizeof ( Asura_PS3_GCM_VertexShaderUniformParameter ) )
	{
	}

	~Asura_PS3_VP_Env_ZPass()
	{
		u_int i;
		for( i = 0; i < sizeof( g_axEnvironmentZPassUniform ) / sizeof( Asura_PS3_GCM_VertexShaderUniformParameter ); ++i )
		{
			g_axEnvironmentZPassUniform[ i ].CleanUp();
		}
	}
};

#endif //#ifndef __ASURA_PS3_ENV_ZPASS_VP_H__
