//
// LightShaft_VP.h
//
// Created by Catalin Arsenescu - 29 August 2007
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_PS3_LIGHTSHAFT_VP_H__
#define __ASURA_PS3_LIGHTSHAFT_VP_H__

extern u_int _binary_PS3_LightShaft_VP_bin_start;
extern u_int _binary_PS3_LightShaft_VP_bin_end;

static Asura_PS3_GCM_VertexShaderUniformParameter g_axVertexShaderUniformShaft[] =
{
	//m_szName, m_usArraySize, m_sizeInFloat4ForOneElement, m_usRegister
	{ "g_xViewProjectionMatrix",	1, 4, NULL },
	{ "g_xPosOrient",				1, 4, NULL },
	{ "g_xCameraPosition",			1, 1, NULL },
	{ "g_xConeGeometry",			1, 1, NULL },
	{ "g_xTextureParams",			1, 1, NULL },
	{ "g_xNearColour",				1, 1, NULL },
	{ "g_xFarColour",				1, 1, NULL },
};

enum VERTEX_SHADER_UNIFORM_SHAFT
{
	VPS_ViewProjectionMatrix,
	VPS_PosOrient,
	VPS_CameraPosition,
	VPS_ConeGeometry,
	VPS_TextureParams,
	VPS_NearColour,
	VPS_FarColour,
};

class Asura_PS3_VP_LightShaft : public Asura_PS3_GCM_VertexShader
{
public:
	Asura_PS3_VP_LightShaft() : Asura_PS3_GCM_VertexShader( (unsigned char *)&_binary_PS3_LightShaft_VP_bin_start, (unsigned char *)&_binary_PS3_LightShaft_VP_bin_end, g_axVertexShaderUniformShaft, sizeof ( g_axVertexShaderUniformShaft ) / sizeof ( Asura_PS3_GCM_VertexShaderUniformParameter ) )
	{
	}

	~Asura_PS3_VP_LightShaft()
	{
		u_int i;
		for( i = 0; i < sizeof( g_axVertexShaderUniformShaft ) / sizeof( Asura_PS3_GCM_VertexShaderUniformParameter ); ++i )
		{
			g_axVertexShaderUniformShaft[ i ].CleanUp();
		}
	}
};

#endif //#ifndef __ASURA_PS3_LIGHTSHAFT_VP_H__
