//
// ObjectShadow_VP.h
//
// Created by Catalin Arsenescu - 26 August 2007
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_PS3_OBJECTSHADOW_VP_H__
#define __ASURA_PS3_OBJECTSHADOW_VP_H__

extern uint32_t _binary_PS3_Object_Shadow_VP_bin_start;
extern uint32_t _binary_PS3_Object_Shadow_VP_bin_end;

static Asura_PS3_GCM_VertexShaderUniformParameter g_axVertexUniformShadow[] =
{
	//m_szName, m_usArraySize, m_sizeInFloat4ForOneElement, m_usRegister
	{ "g_xWorldViewProjectionMatrix",	1, 4, NULL },
};

enum VERTEX_SHADER_UNIFORM_SHADOW
{
	VSS_WorldViewProjectionMatrix,
};

class Asura_PS3_VP_ObjectHShadow : public Asura_PS3_GCM_VertexShader
{
public:
	Asura_PS3_VP_ObjectHShadow() : Asura_PS3_GCM_VertexShader( (unsigned char *)&_binary_PS3_Object_Shadow_VP_bin_start, (unsigned char *)&_binary_PS3_Object_Shadow_VP_bin_end, g_axVertexUniformShadow, sizeof ( g_axVertexUniformShadow ) / sizeof ( Asura_PS3_GCM_VertexShaderUniformParameter ) )
	{
	}

	~Asura_PS3_VP_ObjectHShadow()
	{
		u_int i;
		for( i = 0; i < sizeof( g_axVertexUniformShadow ) / sizeof( Asura_PS3_GCM_VertexShaderUniformParameter ); ++i )
		{
			g_axVertexUniformShadow[ i ].CleanUp();
		}
	}
};

#endif //#ifndef __ASURA_PS3_OBJECTSHADOW_VP_H__
