//
// SFX_PFX_VP.h
//
// Created by Catalin Arsenescu - 26 August 2007
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_PS3_SFX_PFX_VP_H__
#define __ASURA_PS3_SFX_PFX_VP_H__

extern u_int _binary_PS3_SFX_PFX_VP_bin_start;
extern u_int _binary_PS3_SFX_PFX_VP_bin_end;

static Asura_PS3_GCM_VertexShaderUniformParameter g_axVertexShaderUniform[] =
{
	//m_szName, m_usArraySize, m_sizeInFloat4ForOneElement, m_usRegister
	{ "ViewProjectionMatrix",					1, 4, NULL },
	{ "g_xPosOffsetAndSizeScaleVolDepthScale",	1, 1, NULL },
};

enum VERTEX_SHADER_UNIFORM
{
	VIEW_PROJECTION_MATRIX,
	VP_PosOffsetAndSizeScaleVolDepthScale
};

class Asura_PS3_VP_PFX : public Asura_PS3_GCM_VertexShader
{
public:
	Asura_PS3_VP_PFX() : Asura_PS3_GCM_VertexShader( (unsigned char *)&_binary_PS3_SFX_PFX_VP_bin_start, (unsigned char *)&_binary_PS3_SFX_PFX_VP_bin_end, g_axVertexShaderUniform, sizeof ( g_axVertexShaderUniform ) / sizeof ( Asura_PS3_GCM_VertexShaderUniformParameter ) )
	{
	}

	~Asura_PS3_VP_PFX()
	{
		u_int i;
		for( i = 0; i < sizeof( g_axVertexShaderUniform ) / sizeof( Asura_PS3_GCM_VertexShaderUniformParameter ); ++i )
		{
			g_axVertexShaderUniform[ i ].CleanUp();
		}
	}
};

#endif //#ifndef __ASURA_PS3_SFX_PFX_VP_H__
