//
// SmoothSkinShadow_VP.h
//
// Created by Catalin Arsenescu - 26 August 2007
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_PS3_SMOOTHSKIN_SHADOW_VP_H__
#define __ASURA_PS3_SMOOTHSKIN_SHADOW_VP_H__

extern uint32_t _binary_PS3_SmoothSkin_Shadow_VP_bin_start;
extern uint32_t _binary_PS3_SmoothSkin_Shadow_VP_bin_end;

extern uint32_t _binary_PS3_SmoothSkin_ZPass_VP_bin_start;
extern uint32_t _binary_PS3_SmoothSkin_ZPass_VP_bin_end;

extern uint32_t _binary_PS3_SmoothSkin_ZPass_DM_VP_bin_start;
extern uint32_t _binary_PS3_SmoothSkin_ZPass_DM_VP_bin_end;

static Asura_PS3_GCM_VertexShaderUniformParameter g_axVertexShaderShadowUniform[] =
{
	//m_szName, m_usArraySize, m_sizeInFloat4ForOneElement, m_usRegister
	{ "g_xWorldViewProjectionMatrix",	1, 4, NULL },
	{ "g_axTransforms",			   80, 4, NULL },
};

static Asura_PS3_GCM_VertexShaderUniformParameter g_axVertexShaderZPassUniform[] =
{
	//m_szName, m_usArraySize, m_sizeInFloat4ForOneElement, m_usRegister
	{ "g_xWorldViewProjectionMatrix",	1, 4, NULL },
	{ "g_axTransforms",			   80, 4, NULL },
};

static Asura_PS3_GCM_VertexShaderUniformParameter g_axVertexShaderZPassDMUniform[] =
{
	//m_szName, m_usArraySize, m_sizeInFloat4ForOneElement, m_usRegister
	{ "g_xWorldViewProjectionMatrix",	1, 4, NULL },
	{ "g_axTransforms",			   80, 4, NULL },
};

enum VERTEX_SHADER_UNIFORM_ZPASS
{
	SKZ_WorldViewProj,
	SKZ_BoneTransforms,
};

enum VERTEX_SHADER_UNIFORM_SHADOW
{
	SKS_WorldViewProj,
	SKS_BoneTransforms,
};

class Asura_PS3_VP_SmoothSkinShadow : public Asura_PS3_GCM_VertexShader
{
public:
	Asura_PS3_VP_SmoothSkinShadow() : Asura_PS3_GCM_VertexShader( (unsigned char *)&_binary_PS3_SmoothSkin_Shadow_VP_bin_start, (unsigned char *)&_binary_PS3_SmoothSkin_Shadow_VP_bin_end, g_axVertexShaderShadowUniform, sizeof ( g_axVertexShaderShadowUniform ) / sizeof ( Asura_PS3_GCM_VertexShaderUniformParameter ) )
	{
	}

	~Asura_PS3_VP_SmoothSkinShadow()
	{
		u_int i;
		for( i = 0; i < sizeof( g_axVertexShaderShadowUniform ) / sizeof( Asura_PS3_GCM_VertexShaderUniformParameter ); ++i )
		{
			g_axVertexShaderShadowUniform[ i ].CleanUp();
		}
	}
};

class Asura_PS3_VP_SmoothSkinZPass : public Asura_PS3_GCM_VertexShader
{
public:
	Asura_PS3_VP_SmoothSkinZPass() : Asura_PS3_GCM_VertexShader( (unsigned char *)&_binary_PS3_SmoothSkin_ZPass_VP_bin_start, (unsigned char *)&_binary_PS3_SmoothSkin_ZPass_VP_bin_end, g_axVertexShaderZPassUniform, sizeof ( g_axVertexShaderZPassUniform ) / sizeof ( Asura_PS3_GCM_VertexShaderUniformParameter ) )
	{
	}

	~Asura_PS3_VP_SmoothSkinZPass()
	{
		u_int i;
		for( i = 0; i < sizeof( g_axVertexShaderZPassUniform ) / sizeof( Asura_PS3_GCM_VertexShaderUniformParameter ); ++i )
		{
			g_axVertexShaderZPassUniform[ i ].CleanUp();
		}
	}
};

class Asura_PS3_VP_SmoothSkinZPassDM : public Asura_PS3_GCM_VertexShader
{
public:
	Asura_PS3_VP_SmoothSkinZPassDM() : Asura_PS3_GCM_VertexShader( (unsigned char *)&_binary_PS3_SmoothSkin_ZPass_DM_VP_bin_start, (unsigned char *)&_binary_PS3_SmoothSkin_ZPass_DM_VP_bin_end, g_axVertexShaderZPassDMUniform, sizeof ( g_axVertexShaderZPassDMUniform ) / sizeof ( Asura_PS3_GCM_VertexShaderUniformParameter ) )
	{
	}

	~Asura_PS3_VP_SmoothSkinZPassDM()
	{
		u_int i;
		for( i = 0; i < sizeof( g_axVertexShaderZPassDMUniform ) / sizeof( Asura_PS3_GCM_VertexShaderUniformParameter ); ++i )
		{
			g_axVertexShaderZPassDMUniform[ i ].CleanUp();
		}
	}
};

#endif //#ifndef __ASURA_PS3_SMOOTHSKIN_SHADOW_VP_H__
