///////////////////////////////////////////////////////////////////////////////
//
// File   : HDR_Shared_FP.fpx
// Author : Catalin Arsenescu
// Date   : 28-September-07
//
///////////////////////////////////////////////////////////////////////////////

//#include "Shaders/Project_ShaderConfiguration.fxh"
#include "MaterialResponse_Shared.ps3FXH"

const	sampler2D	g_xDownsizeSampler				:register( s1 ); // Copy of the scene to be downsized
const	sampler2D	g_xCurrentLuminanceSampler		:register( s2 ); // Single texel holding the current adapted luminance
const	sampler2D	g_xSceneLuminanceSampler		:register( s3 ); // Single texel holding the scene's luminance, our target value over time
const	sampler2D	g_xInputSceneSampler			:register( s4 ); // Current HDR scene to apply tone mapping on

float4 g_xExtractLumUVScaleOffset;

float g_fAdaptationFactor;  // Adaption rate * time elapsed this frame
float g_fMaxLuminance;      // Maximum luminance to adapt to
float g_fMinLuminance;      // Minimum luminance to adapt to
float g_fKeyValue;          // Exposure setting for the scene
float g_fWhitePointSquared; // World luminances beyond this point are whited out

// (white pt / (white pt - black pt), -black pt * white pt / (white pt - black pt)
float2 g_xScaleParams;

float g_fFixedLuminance;

/******************************************************************************/
/* Constants                                                                  */
/******************************************************************************/

/// End of file. ///
