////////////////////////////////////////////////////////////////////////////////
//
// File   : Asura_PS3_DiscBootGame.h
// Author : Anthony Gregson
//
// Copyright (C) 2009 Rebellion, All Rights Reserved.
//
// Wrapper for data obtained from the disc boot game utility. In the current SDK
// version (250), this can be used to get hold of the product code and the
// parental level.
//
////////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif

#ifndef __ASURA_PS3_DISCBOOTGAME_H__
#define __ASURA_PS3_DISCBOOTGAME_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

const u_int uASURA_PS3_PRODUCT_CODE_LENGTH = 10; //"ABCD12345", null terminated.

class Asura_PS3_DiscBootGame
{
public:
	// These are called by the engine, project code shouldn't need to ever call them
	static void Initialise();
	static void Shutdown();

	static const char* GetProductCode()		{ return s_szProductCode; }
	static const char* GetLeadProductCode();
	static u_int GetParentalLevel()		{ return s_uParentalLevel; }

private:

	static char s_szProductCode[uASURA_PS3_PRODUCT_CODE_LENGTH];
	static u_int s_uParentalLevel;
};

#endif //#ifndef __ASURA_PS3_DISCBOOTGAME_H__