
///////////////////////////////////////////////////////////////////////////////
//
// File   : Asura_PS3_Corona_System.h
// Author : Catalin Arsenescu
// Date   : 12-March-2008
//
// Copyright (C) 2005 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef ___ASURA_PS3_CORONA_SYSTEM_H___
#define ___ASURA_PS3_CORONA_SYSTEM_H___ 1

// I N C L U D E S ///////////////////////////////////////////////////////////
#include "Core/Asura_Maths.h"
#include "SpecialFX/Asura_Corona_System.h"

const int iASURA_MAX_BATCHABLE_CORONA_TEXTURES	   = 8;
const int iASURA_MAX_BATCHABLE_CORONAS_PER_TEXTURE = 32;

struct CoronaVertex
{
	float	X, Y, Z;
	float	U, V, U2;
	float	Diffuse[ 3 ];
};

class Asura_PS3_CoronaSystem
{
public:
	static void		Initialise();
	static void		Shutdown();
	static void		RenderStart();
	static void		RenderEnd();
	static void		RenderCorona(const Asura_Corona* pxCorona, u_int uCamVisFlags);	

private:
	static void		FlushBatch(int iTextureSlot);
	static float	CalcLightScale(const Asura_Corona *pxCorona, const Asura_Vector_3 *pxCameraPosition, const Asura_Vector_3 &xShiftForward, const Asura_Matrix_3x3 *pxCameraOrientation);

	static int				   s_aiBatchedTextures  [iASURA_MAX_BATCHABLE_CORONA_TEXTURES];
	static int				   s_aiNumBatchedCoronas[iASURA_MAX_BATCHABLE_CORONA_TEXTURES];
	static const Asura_Corona* s_apxBatchedCoronas  [iASURA_MAX_BATCHABLE_CORONA_TEXTURES][iASURA_MAX_BATCHABLE_CORONAS_PER_TEXTURE];
	static uint32			   s_auBatchedVisFlags	[iASURA_MAX_BATCHABLE_CORONA_TEXTURES][iASURA_MAX_BATCHABLE_CORONAS_PER_TEXTURE];
	static CoronaVertex		   s_axVertices			[iASURA_MAX_BATCHABLE_CORONAS_PER_TEXTURE*4];
};

#endif //#ifndef ___ASURA_PS3_CORONA_SYSTEM_H___
