///////////////////////////////////////////////////////////////////////////////
//
// File   : Asura_PSP_BotanicalsSystem.h
// Author : Catalin Arsenescu
// Date   : 09-March-2007
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////
#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif //ASURA_USE_PRAGMA_ONCE

#ifdef ASURA_USE_BOTANICALS
#ifndef __ASURA_PSP_BOTANICALS_SYSTEM__
#define __ASURA_PSP_BOTANICALS_SYSTEM__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////
#include "Botanicals/Asura_Botanical_Game_Render_TypeID.h"
#include "Botanicals/Asura_Botanical_Game_Render_Manager.h"
#include "ChunkSystem/Asura_Chunk_ResourceFile_PSP_Botanicals.h"

////////////////////////////////////////////////////////////////////////////////
// Forward class declaration...
////////////////////////////////////////////////////////////////////////////////
class Asura_PSP_BotanicalsShape;
class Asura_PSP_BotanicalsTemplate;
class Asura_BGR_Instances_Header;
class Asura_BGR_Instances_Header;
class Asura_BGR_Type;
class Asura_PSP_BotanicalBillboard_Vertex;


////////////////////////////////////////////////////////////////////////////////
// Class        : Asura_PSP_BotanicalsSystem
// Author       : Catalin Arsenescu
// Date         : 09-March-2007
////////////////////////////////////////////////////////////////////////////////
class Asura_PSP_BotanicalsSystem : public Asura_BGR_Manager
{
	friend class Asura_Chunk_ResourceFile_PSP_Botanicals;

public:
	static Asura_PSP_BotanicalBillboard_Vertex*	s_pxBillboardBuffer;
	static unsigned int							s_uBillboardBufferOffset; 

//Public static functions
	static	void	Initialise();
	static	void	Reset();
	static	void	Shutdown();

	static	void	Render( const float fFade );

// BGR Manager functions
	virtual	u_int										GetInstanceHeaderCount( void ) const;
	virtual	const Asura_BGR_Instances_Header* const		GetInstanceHeader( const u_int uInstanceHeaderIndex ) const;
	virtual	Asura_BGR_Instances_Header*					GetInstanceHeader( const u_int uInstanceHeaderIndex );
	virtual	Asura_BGR_Type*								GetType( const Asura_BGR_TypeID xTypeID );

	virtual	bool	Update( const float fTime );

protected:
//Protected static members
	static Asura_PSP_BotanicalsShape*			s_pxShapes;
	static Asura_PSP_BotanicalsTemplate*		s_pxTemplates;

	static u_int								s_uNumShapes;
	static u_int								s_uNumTemplates;
};


#endif //__ASURA_PSP_BOTANICALS_SYSTEM__
#endif //ASURA_USE_BOTANICALS
