//
// Asura_Chunk_ResourceFile_PSP_Botanicals.h
//
// Created by JG - Monday, October 09, 2006
//
// Copyright (C) 2004 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_CHUNK_RESOURCEFILE_PSP_BOTANICALS_H__
#define __ASURA_CHUNK_RESOURCEFILE_PSP_BOTANICALS_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////
#include "ChunkSystem/Asura_Chunk_ResourceFile.h"
#include "Core/Asura_Handle.h"

////////////////////////////////////////////////////////////////////////////////
// Forward class declaration...
////////////////////////////////////////////////////////////////////////////////
class Asura_PSP_BotanicalsElement;

////////////////////////////////////////////////////////////////////////////////
// Class        : Asura_PSP_BotanicalsSystem
// Author       : JG
// Date         : 09-October-2006
// Revision 1   : Catalin Arsenescu, 09-March-2007
////////////////////////////////////////////////////////////////////////////////
class Asura_Chunk_ResourceFile_PSP_Botanicals : public Asura_Chunk_ResourceFile
{
protected:
//Protected static functions
#if defined ASURA_USE_BOTANICALS

	unsigned int	ProcessShapes( Asura_Handle hFile, unsigned int uNumberOfShapes, unsigned int uCurrentShape, void** xTemplateList );
	unsigned int	ProcessBotanicalsShapes( Asura_Handle hFile, unsigned int uNumberOfBotanicalShapes, unsigned int uCurrentShape, void** xTemplateList );
	void			Process2And1SidedMesh( Asura_Handle hFile, Asura_PSP_BotanicalsElement* pxCurrentElement, unsigned int uType, unsigned int uLOD );
	void			ProcessBillboards( Asura_Handle hFile, Asura_PSP_BotanicalsElement* pxCurrentElement, unsigned int uType, unsigned int uLOD );
	void			ProcessImposters( Asura_Handle hFile, Asura_PSP_BotanicalsElement* pxCurrentElement, unsigned int uType, unsigned int uLOD );

#endif //#if defined ASURA_USE_BOTANICALS

public:
//Public static functions
	void			Process( Asura_Handle hFile );
};


#endif//__ASURA_CHUNK_RESOURCEFILE_PSP_BOTANICALS_H__

