//////////////////////////////////////////////////////////////////////////////
//
// Asura_Chunk_ResourceFile_PSP_StreamedSounds.h
//
// Copyright (c) 2007 Rebellion. All rights reserved.
//
// Description:
//
//     chunk for PSP streamed sound header
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef ___ASURA_CHUNK_RESOURCEFILE_PSP_STREAMEDSOUNDS_H___
#define ___ASURA_CHUNK_RESOURCEFILE_PSP_STREAMEDSOUNDS_H___ 1

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "ChunkSystem/Asura_Chunk_ResourceFile.h"

// D E F I N E S /////////////////////////////////////////////////////////////

//
// Version history:
//
//     (MH - 29.03.2007) -  0 - Initial version.
//
#define ASURA_PSP_STREAMEDSOUNDS_CHUNK_VERSION (0)

// using chunk flags to indicate whether the soundID is in fact a hashID.
// This is just copied from the PS2 where it was done to avoid changing version.
static const u_int uASURA_PSP_STREAMEDSOUNDS_FLAG_SOUNDIDS_ARE_DYNAMIC = 0x00000001;

// C L A S S E S /////////////////////////////////////////////////////////////

class Asura_Chunk_ResourceFile_PSP_StreamedSounds : public Asura_Chunk_ResourceFile
{

    public:

        // T Y P E S /////////////////////////////////////////////////////////

        struct HdrEntry
        {
            int iSoundID;
            int iOffset;
            int iSize;
        };

        // M E T H O D S /////////////////////////////////////////////////////

        bool Process( Asura_Handle hFile );

};
// End class Asura_Chunk_ResourceFile_PSP_StreamedSounds.

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

#endif // #ifndef ___ASURA_CHUNK_RESOURCEFILE_PSP_STREAMEDSOUNDS_H___
