//
// Asura_Platform_MainLoop.cpp
//
// Created by RWM - 31/03/2009
//
// Copyright (C) 2009 Rebellion, All Rights Reserved.
//

#include "Core/Asura.h"

// This file's header
#include "Core/Asura_MainLoop.h"

#include "Core/Asura_FunctionSequencer.h"
#include "Debugging/Asura_CPUProfile.h"
#include "Rendering/Asura_PSP_Blur.h"
#include "Rendering/Asura_PSP_Filter.h"
#ifdef ASURA_USE_STREAMING
#include "Streaming/Asura_Streaming_System.h"
#endif
#include "SpecialFX/Asura_SpecialFX.h"

void Asura_MainLoop::Platform_ModifyDefaultRenderSequence()
{
#ifdef ASURA_USE_STREAMING
	s_xRenderSequence.AFS_ADD_BEFORE(&Asura_PSP_Blur::Render, &Asura_Streaming_System::RenderSpecialFX, "PSP Blur Render", ASURA_CPU_PROFILE__SPECIALFX_RENDER);
#else 
	s_xRenderSequence.AFS_ADD_BEFORE(&Asura_PSP_Blur::Render, &Asura_SpecialFX_System::Render, "PSP Blur Render", ASURA_CPU_PROFILE__SPECIALFX_RENDER);
#endif //#ifdef ASURA_USE_STREAMING

	s_xRenderSequence.AFS_ADD_AFTER(&Asura_PSP_Filter::Render, &Asura_SpecialFX_System::Render2DEffects, "PSP Filter Render", ASURA_CPU_PROFILE__SPECIALFX_RENDER);
}
