//
// Asura_PSP_ObjectRenderer_Internal.h
//
// Created by KJFL - Wednesday, April 07, 2004
//
// Copyright (C) 2004 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_PSP_OBJECTRENDERER_INTERNAL_H__
#define __ASURA_PSP_OBJECTRENDERER_INTERNAL_H__

#include "Core/Memory/Asura_ResourceAllocator.h"


class Asura_PSP_ObjectStrip_Vertex
{
	public:
		
		// order of member determined by PSP GPU

		float			m_fU;
		float			m_fV;

		float			m_afNormal[3];
		float			m_afPosition[3];
};

class Asura_PSP_ObjectStrip
{
	public:
		Asura_PSP_ObjectStrip()
		{
			m_pxVertices	= NULL;
			m_pusIndices	= NULL;
		}
		~Asura_PSP_ObjectStrip()
		{
			Asura_ResourcePushType(ASURA_RESOURCE_OBJECT_MESH);
			{
				Asura_ResourceDeallocateArray(m_pxVertices);
				Asura_ResourceDeallocateArray(m_pusIndices);
			}
			Asura_ResourcePopType();
		}

		int								m_iMaterial;
		u_int							m_uNumberOfTriangles;
		u_int							m_uNumberOfVertices;
		u_int							m_uNumberOfIndices;

		Asura_PSP_ObjectStrip_Vertex*	m_pxVertices;
		u_short*						m_pusIndices;

		float m_fMinDistance;
		u_int m_uLODHash;
};

#endif//__ASURA_PSP_OBJECTRENDERER_INTERNAL_H__
