
///////////////////////////////////////////////////////////////////////////////
//
// File   : Asura_PSP_RenderStates.h
// Author : Andy Tate
// Date   : 13-Jun-2006
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __ASURA_PSP_RENDERSTATES_H__
#define __ASURA_PSP_RENDERSTATES_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Rendering/Asura_PSP_GU.h"


////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class        : Asura_PSP_RenderStates
// Author       : Andy Tate
// Date         : 13-Jun-2006
//
// Description  : 
////////////////////////////////////////////////////////////////////////////////

class Asura_PSP_RenderStates
{
public:
	// Public functions...
#if 1
	static	void	RequestAmbient			(const u_int uColour)				{ if(s_uAmbient != uColour) { s_uAmbient = uColour; GU_Ambient(uColour); } }
	static	void	RequestColourMaterial	(const int iMaterial)				{ if(s_iColourMaterial != iMaterial) { s_iColourMaterial = iMaterial; GU_ColorMaterial(iMaterial); } }
	static	void	RequestDepthOffset		(const int iOffset)					{ if(s_iDepthOffset != iOffset) { s_iDepthOffset = iOffset; GU_DepthOffset(iOffset); } }
	static	void	RequestPixelMask		(const u_int uMask)					{ if(s_uPixelMask != uMask) { s_uPixelMask = uMask; GU_PixelMask(uMask); } }
	static	void	RequestTexOffset		(const float fTU, const float fTV)	{ if((s_fTU != fTU) || (s_fTV != fTV)) { s_fTU = fTU; s_fTV = fTV; GU_TexOffset(fTU, fTV); } }
	static	void	RequestTexScale			(const float fSU, const float fSV)	{ if((s_fSU != fSU) || (s_fSV != fSV)) { s_fSU = fSU; s_fSV = fSV; GU_TexScale(fSU, fSV); } }
	static	void	RequestTexSlope			(const float fTexSlope)				{ if( fTexSlope != s_fTexSlope ) { s_fTexSlope = fTexSlope; GU_TexSlope( fTexSlope ); } }
#else
	static	void	RequestAmbient			(const u_int uColour)				{ GU_Ambient(uColour); }
	static	void	RequestColourMaterial	(const int iMaterial)				{ GU_ColorMaterial(iMaterial); }
	static	void	RequestDepthOffset		(const int iOffset)					{ GU_DepthOffset(iOffset); }
	static	void	RequestPixelMask		(const u_int uMask)					{ GU_PixelMask(uMask); }
	static	void	RequestTexOffset		(const float fTU, const float fTV)	{ GU_TexOffset(fTU, fTV); }
	static	void	RequestTexScale			(const float fSU, const float fSV)	{ GU_TexScale(fSU, fSV); }
	static	void	RequestTexSlope			(const float fTexSlope)				{ GU_TexSlope( fTexSlope ); }
#endif

	// Accessor(s)
	static u_int	GetAmbient()		{ return s_uAmbient; }

protected:
	// Protected variables...


	// Protected functions...


private:
	// Private variables...
	static	u_int	s_uAmbient;
	static	int		s_iColourMaterial;
	static	int		s_iDepthOffset;
	static	u_int	s_uPixelMask;
	static	float	s_fSU;
	static	float	s_fSV;
	static	float	s_fTU;
	static	float	s_fTV;
	static	float	s_fTexSlope;


	// Private functions...

	Asura_PSP_RenderStates  (void);
	Asura_PSP_RenderStates  (const Asura_PSP_RenderStates& xOther);
	~Asura_PSP_RenderStates ();

	Asura_PSP_RenderStates&	operator=	(const Asura_PSP_RenderStates& xOther);

};   // End of class 'Asura_PSP_RenderStates'.


#endif   // ifndef __ASURA_PSP_RENDERSTATES_H__


/// End of file. ///
