//
// Asura_Platform_Decal.h
//
// Created by KJFL - Tuesday, March 30, 2004
// Renderer implemented by Andrew Weinkove - 15/04/2004, based heavily on PC implementation.
//
// Copyright (C) 2004 Rebellion, All Rights Reserved.
//


#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_PLATFORM_DECAL_H__
#define __ASURA_PLATFORM_DECAL_H__

#include "Core/Asura.h"

#include "Rendering/Asura_PSP_Graphics.h"
#include "SpecialFX/Asura_Decal_System.h"

#ifndef ASURA_PSP_NUM_DECAL_VERTICES_PER_BUFFER
	#define ASURA_PSP_NUM_DECAL_VERTICES_PER_BUFFER (2048)
#endif

class Asura_Decal_Template;
class Asura_Decal_Vertex;

//////////////////////////////////
// Asura_PSP_RenderDecal_Vertex //
//////////////////////////////////
struct Asura_PSP_RenderDecal_Vertex
{
	// fully 32bit - 20 bytes
	float			m_fU;
	float			m_fV;
	float			m_afPosition[3];

	inline bool operator != ( const Asura_PSP_RenderDecal_Vertex& xVertex) const
	{
	    return (m_afPosition[0] != xVertex.m_afPosition[0] ||
				m_afPosition[1] != xVertex.m_afPosition[1] ||
				m_afPosition[2] != xVertex.m_afPosition[2] ||
				m_fU != xVertex.m_fU ||
				m_fV != xVertex.m_fV);
	}
};

// Constant
const int iASURA_PSP_DECAL_VERTEX_FORMAT = SCEGU_TEXTURE_FLOAT | SCEGU_VERTEX_FLOAT;

///////////////////////////
// Asura_PSP_DecalBuffer //
///////////////////////////
class Asura_PSP_DecalBuffer : public Asura_DecalBuffer
{
public:
	Asura_PSP_DecalBuffer(const Asura_Decal_Template* pxDecalTemplate);
	~Asura_PSP_DecalBuffer();

	void AddStrip(const Asura_Decal_Vertex* pxStrip, const u_int uNumberOfVertices);

	void Render(void);

	Asura_PSP_DecalBuffer* m_pxNextDecalBuffer;
	int m_iTextureIndex;

private:
	Asura_PSP_RenderDecal_Vertex m_axVertices[ASURA_PSP_NUM_DECAL_VERTICES_PER_BUFFER];
	unsigned int m_uMaxNumberOfIndices;
	unsigned int m_uNumberOfVerticesToDraw;
	unsigned int m_uCurrentIndex;
	u_int m_uMaxIndex;

};

#endif//__ASURA_PLATFORM_DECAL_H__
