//
// Asura_Platform_Core.cpp
//
// Created by KOR - 09 October 2006
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//

#include "Core/Asura.h"

// This file's header.
#include "Core/Asura_Core.h"

// Asura
#include "Camera/Asura_Camera.h"

// Asura Wii headers
#include "HomeButton/Asura_Wii_HomeButtonMenu.h"
#include "LoadAndSave/Asura_Wii_NAND.h"
#include "Rendering/Asura_GX.h"


// Library headers
#include <revolution.h> // needed for SDK version, includes all other SDK headers

// KOR - 03/01/2007 - ensure we're all on the same SDK version. Update this when we upgrade.
#if __SDKVERNUMERIC__ != 2008073002L
#error Using incorrect SDK version
#endif

static OSThread* g_pxMainThread;

static void ResetCallback()
{
	Asura_GX::SetResetButtonPressed();
}

static void PowerCallback()
{
	Asura_GX::SetPowerButtonPressed();
}

void Asura_Core::PlatformInitialise(void)
{
	// This function MUST be called from the main thread for Platform_IsMainThread to function correctly.
	g_pxMainThread = OSGetCurrentThread();

	// Initialise Gamecube DVD drive
	DVDInit();

	Asura_Wii_NAND::Initialise();
	OSSetResetCallback(&ResetCallback);
	OSSetPowerCallback(&PowerCallback);
	OSInitFastCast();

	Asura_Camera::SetPhysicalScreenAspectRatio	(SCGetAspectRatio() == SC_ASPECT_RATIO_16x9   ? 16.0f / 9.0f : 4.f/3.f);
}

void Asura_Core::PlatformShutdown(void)
{
	Asura_Wii_NAND::Shutdown();
}

void Asura_Core::PlatformReset(void)
{
}

bool Asura_Core::Platform_IsMainThread()
{
	// Get current thread details
    return (g_pxMainThread == OSGetCurrentThread());
}

void Platform_LoadEnvironment(void)
{
}

