//
// Asura_Platform_MemoryManagement.h
//
// Created by KOR - 06 October 2006
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_PLATFORM_MEMORYMANAGEMENT_H__
#define __ASURA_PLATFORM_MEMORYMANAGEMENT_H__

#include <stdint.h> // uintptr_t, etc.

#define ASURA_MEMORYMANAGEMENT_PLATFORM_INIT_WHEN_DISABLED (1)

#ifndef ASURA_MEMORYMANAGEMENT_ENABLED
#include <stdlib.h>

// Not declared by Codewarrior headers
extern "C"
{
	void*  memalign(size_t, size_t);
};

inline void* Asura_AllocateAlign(unsigned int bytes, enum ASURA_ALIGN_ID alignment)
{
    void* pvMem = memalign( alignment, bytes );
    return pvMem;
}

inline void Asura_DeallocateAlign(void* address)
{
	free(address);
}

inline void* operator new(size_t size)
{
	return malloc(size);
}

inline void* operator new[](size_t size)
{
    return malloc(size);
} 

inline void operator delete( void *address ) throw()
{
	free(address);
}

inline void operator delete[]( void *address ) throw()
{	
	free(address);
}

#endif // ASURA_MEMORYMANAGEMENT_ENABLED

#endif//__ASURA_PLATFORM_MEMORYMANAGEMENT_H__