//
// Asura_Assert.h
//
// Created by KOR - 06 October 2006
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_PLATFORM_ASSERT_H__
#define __ASURA_PLATFORM_ASSERT_H__

inline void Asura_Wii_Debug_Break(void)
{
	// This will stop the Codewarrior debugger.
	// Taken from "Resumable breakpoint" post on rvl.cpu, 13/04/2007
	register unsigned int reg0;
	register unsigned int reg1;
	asm
	{
		mfmsr reg0;
		ori reg1, reg0, 0x400;
		mtmsr reg1;
		mtmsr reg0;
	}
}

#ifdef ASURA_ASSERT

	#define ASURA_PLATFORM_DEBUGBREAK() Asura_Wii_Debug_Break()

	// Internal functions
	const char* Asura_Platform_Assert_GetLogFileName();

#endif

// KJFL - 22 March 2006 - Static, i.e. compile-time, assertions
// For documentation see http://asurawiki.rebellion.co.uk/twiki/bin/viewauth/Programming/AsuraStaticAssert
//
// KJFL - 23 March 2006 - changed macro to use __COUNTER__ instead of __LINE__
//
template<bool b> struct ASURA_STATIC_ASSERTION_FAILURE;
template <> struct ASURA_STATIC_ASSERTION_FAILURE<true> {};

#define ASURA_COMBINE_LITERALS( a, b ) a ## b
#define ASURA_STATIC_ASSERT_UNIQUENAME( a ) ASURA_COMBINE_LITERALS( ASURA_STATIC_ASSERT_FAILED_, a )

#define ASURA_STATIC_ASSERT( bCondition ) { static ASURA_STATIC_ASSERTION_FAILURE<(bCondition != 0)> ASURA_STATIC_ASSERT_UNIQUENAME(__COUNTER__); }

#endif//__ASURA_PLATFORM_ASSERT_H__