//
// Asura_Wii_ROMFont.h
//
// Created by KOR - 09 October 2006
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_WII_ROMFONT_H__
#define __ASURA_WII_ROMFONT_H__

#include "Core/Asura_PlatformBasics.h"

#include <revolution/types.h>
#include <revolution/os.h>

// Uses the in-built ROM font to print to screen
class Asura_Wii_ROMFont
{
public:
	static void Initialise();
	static void Shutdown();
	static void SetSize( short sSize, short sSpace );
	static void GetSize( short* psSize, short* psSpace );
	static int  RenderString( short sX, short sY, short sZ, const char* szString );
	static int  RenderString( short sX, short sY, short sZ, const Asura_UnicodeChar* wszString );
private:
	static void DrawFontChar(int iX, int iY, int iZ, int iXChar, int iYChar);
	static void LoadSheet(void* pvImage);

	static OSFontHeader* s_pxFontData;
	static void*         s_pvLastSheet;
	static s16           s_sFontSize;      // GX_S16, 4
	static s16           s_sFontSpace;     // GX_S16, 4
};

#endif//__ASURA_WII_ROMFONT_H__