//
// Asura_Wii_StrapReminder.h
//
// Created by KOR - 18 December 2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_WII_STRAPREMINDER_H__
#define __ASURA_WII_STRAPREMINDER_H__

// Asura headers
#include "Core/Asura_LocalisedText.h"

// Lib
#include <revolution/gx/gxstruct.h>
#include <revolution/tpl.h>

class Asura_Wii_StrapReminder
{
public:
	// Public interface
	static void Initialise();
	static void Update();
	static void CheckForFinish();

	// Accessors
	static void SetInsideStrapReminder(bool bInside) { s_bInsideStrapReminder = bInside; }
	static bool IsInsideStrapReminder() { return s_bInsideStrapReminder; }

	static void SetShownStrapReminder(bool bShown) { s_bStrapReminderShown = bShown; }
	static bool HasShownStrapReminder() { return s_bStrapReminderShown; }

private:
	enum StrapReminderMode
	{
		MODE_START,
		MODE_FADE_IN,
		MODE_SCREENA_NOSKIP,
		MODE_SCREENA_LOADB,
		MODE_SCREENA_AFTERLOADB,
		MODE_SCREENB_NOSKIP,
		MODE_SCREENB_SKIP,
		MODE_SCREENA_REPEAT,
		MODE_SCREENB_REPEAT,
		MODE_FADE_OUT,
		MODE_QUIT,
	};

	static void* ThreadFunc(void*);
	static void Render();
	static const char* GetTextureFilename(bool bScreenB);
	static Asura_LocalisedText_Language GetLanguage();
	static TPLPalette* LoadTPL(const char* szFilename, GXTexObj &xTexObj);

	static bool s_bInsideStrapReminder;
	static bool s_bStrapReminderShown;
	static StrapReminderMode s_eWiiStrapState;
	static char* s_pcWiiStrapThreadStack;
};

#endif//__ASURA_WII_STRAPREMINDER_H__