//*******************************************************************
// File: Asura_Platform_Botanical_Game_Render.cpp
//
// Created: 14 December 2006 DLH
//
// Description: 
//
//*******************************************************************

// system libraries
#include "Core/Asura.h"

// main header
#include "Botanicals/Asura_Botanical_Game_Render_Manager.h"
#include "Botanicals/Asura_Xbox360_Botanicals.h"

// other libraries

// internal dependencies

//*******************************************************************
// Constants
//*******************************************************************


//*******************************************************************
// Local Classes
//*******************************************************************


//*******************************************************************
// Local Data
//*******************************************************************

Asura_Xbox360_Botanicals_System s_xXbox360_Botanicals_System;

//*******************************************************************
// Function Definitions
//*******************************************************************

Asura_BGR_Manager& Asura_BGR_Manager::GetBGRManager( void)
{
	return( s_xXbox360_Botanicals_System);
}

u_int Asura_Xbox360_Botanicals_System::GetInstanceHeaderCount( void) const
{
	return( s_uNumTemplates);
}

const Asura_BGR_Instances_Header* Asura_Xbox360_Botanicals_System::GetInstanceHeader( const u_int uInstanceHeaderIndex) const
{
	Asura_Assertf( uInstanceHeaderIndex < static_cast< u_int>( this->s_uNumTemplates), ("Instance Header %d is out of %d range.", uInstanceHeaderIndex, this->s_uNumTemplates));
	const Asura_BGR_Instances_Header* const pxInstanceHeader = s_pxTemplates + uInstanceHeaderIndex;
	return( pxInstanceHeader);
}

Asura_BGR_Instances_Header* Asura_Xbox360_Botanicals_System::GetInstanceHeader( const u_int uInstanceHeaderIndex)
{
	Asura_Assertf( uInstanceHeaderIndex < static_cast< u_int>( this->s_uNumTemplates), ("Instance Header %d is out of %d range.", uInstanceHeaderIndex, this->s_uNumTemplates));
	Asura_BGR_Instances_Header* pxInstanceHeader = s_pxTemplates + uInstanceHeaderIndex;
	return( pxInstanceHeader);
}

Asura_BGR_Type* Asura_Xbox360_Botanicals_System::GetType( const Asura_BGR_TypeID xTypeID)
{
	Asura_Assertf( xTypeID.GetID() < s_uNumShapes, ("xTypeID %d is out of %D range.", xTypeID.GetID(), s_uNumShapes));
	Asura_BGR_Type* pxType = this->s_pxShapes + xTypeID.GetID();
	
	return( pxType);
}

u_int Asura_Xbox360_Botanicals_Template::GetInstanceCount() const
{
	return( this->m_iNumInstances);
}

const Asura_BGR_Instance* Asura_Xbox360_Botanicals_Template::GetInstance( const u_int uInstanceIndex) const
{
	Asura_Assertf( uInstanceIndex < static_cast< u_int>( this->m_iNumInstances), ("Instance %d is out of %d range.", uInstanceIndex, this->m_iNumInstances));
	const Asura_BGR_Instance* const pxInstance = this->m_pxInstances + uInstanceIndex;
	
	return( pxInstance);
}

#if defined( ASURA_BOTANICAL_SUPPORT_SECTION_VERSIONS) && 1 == ASURA_BOTANICAL_SUPPORT_SECTION_VERSIONS
u_int Asura_Xbox360_Botanicals_Shape::GetSectionCount() const
{
	return( this->m_uSectionCount);
}
#endif


//*******************************************************************
//
// (c) 2006 Rebellion
//
// Warning: This computer program is protected by copyright law and 
// international treaties. Unauthorized reproduction or distribution
// of this program, or any portion of it, may result in severe civil and
// criminal penalties, and will be prosecuted to the maximum extent 
// possible under the law.
//
//*******************************************************************
