//
// Asura_Chunk_ResourceFile_Xbox360_Environment.h
//
// Created by KJFL - 27 June 2005
//
// Copyright (C) 2005 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_CHUNK_RESOURCEFILE_XBOX360_ENVIRONMENT_H__
#define __ASURA_CHUNK_RESOURCEFILE_XBOX360_ENVIRONMENT_H__

#include "ChunkSystem/Asura_Chunk_ResourceFile.h"
#include "Core/Asura_Handle.h"

// Version history
// 0 (AAM - 27.02.2008) Original versions
// 1 (AAM - 27.02.2008) Added pixel shader hash per strip
// 2 (AS  - 29.05.2008) Added second tangent and removed binormal
// 3 (AAM - 09.12.2008) Switched to just one VB/IB for the whole environment
// 4 (FBS - 09.04.2009) Added EdgeInfo (used for edge antialiasing)
// 5 (AAM - 07.05.2009) Removed pixel shader hash per strip - now generated on the fly
const int iASURA_CHUNK_XBOX360_ENVIRONMENT_VERSION = 5;

class Asura_Chunk_Stream;

class Asura_Chunk_ResourceFile_Xbox360_Environment : public Asura_Chunk_ResourceFile
{
    public:

        // M E T H O D S /////////////////////////////////////////////////////

        bool Process(const char* szFilename, Asura_Chunk_Stream& xStream);
};



#endif//__ASURA_CHUNK_RESOURCEFILE_XBOX360_ENVIRONMENT_H__
