// Asura_Xbox360_XMV.h
// TY 17/10/07
// Copyright (C) 2001 Rebellion, All Rights Reserved.

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_XBOX360_XMV_H__
#define __ASURA_XBOX360_XMV_H__

#include "Rendering/Asura_Xbox360_Graphics.h"

#define ASURA_USE_XMV2	ASURA_USE_AUDIO_SYSTEM

#if ASURA_USE_XMV2
struct IXMedia2XmvPlayer;
#else
struct IXMediaXmvPlayer;
#endif

class Asura_Xbox360_XMV
{
	public:

		Asura_Xbox360_XMV();
		~Asura_Xbox360_XMV();	

		static void	Play	(const char* szFilename, int iAudioStream = 0, bool bLoop = false);
		static void AllowSkip (bool bAllow);

	private:

		//If people want it, a callback can be added which will be called after each frame is rendered
		//in which case these functions may be of some use and should be made public
		static void Pause	();
		static void Resume  ();
		static void Stop	();

		static bool	Playing	();
		static bool Paused	();

		static void ResetD3DDevice	();
		static void VidCallback		(void* pVid);
		static void SetRectangle	(const int iTop, const int iLeft, const int iBottom, const int iRight);

		static bool IsApproximately_16_9 (u_int uWidth, u_int uHeight);
		static bool IsApproximately_4_3	 (u_int uWidth, u_int uHeight);

		static bool s_bAllowSkip;	
		static bool s_bSkipping;

#if ASURA_USE_XMV2
		static IXMedia2XmvPlayer* s_pxXMVPlayer;
#else
		static IXMediaXmvPlayer* s_pxXMVPlayer;
#endif
};

#endif

//eof
