///////////////////////////////////////////////////////////////////////////////
//
// File   : Asura_PlatformInput.h
// Author : Kevin Floyer-Lea
// Date   : 23-Jun-2005
//
// Copyright (C) 2005 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif

#ifndef __ASURA_PLATFORMINPUT_H__
#define __ASURA_PLATFORMINPUT_H__

/******************************************************************************/
/* Included Files                                                             */
/******************************************************************************/

#include "Core/Asura_UserInput.h"

/******************************************************************************/
/* Types                                                                      */
/******************************************************************************/

enum ASURA_XBOX360_KEYID
{
	ASURA_XBOX360_KEYID_PAD1_A			= ASURA_KEYID_PAD1_BUTTON1, 
	ASURA_XBOX360_KEYID_PAD1_B			= ASURA_KEYID_PAD1_BUTTON2, 
	ASURA_XBOX360_KEYID_PAD1_X			= ASURA_KEYID_PAD1_BUTTON3, 
	ASURA_XBOX360_KEYID_PAD1_Y			= ASURA_KEYID_PAD1_BUTTON4, 
	ASURA_XBOX360_KEYID_PAD1_L_BUMPER	= ASURA_KEYID_PAD1_BUTTON5, 
	ASURA_XBOX360_KEYID_PAD1_R_BUMPER	= ASURA_KEYID_PAD1_BUTTON6, 
	ASURA_XBOX360_KEYID_PAD1_L_TRIGGER	= ASURA_KEYID_PAD1_BUTTON7, 
	ASURA_XBOX360_KEYID_PAD1_R_TRIGGER	= ASURA_KEYID_PAD1_BUTTON8, 
	ASURA_XBOX360_KEYID_PAD1_L_THUMB	= ASURA_KEYID_PAD1_BUTTON9, 
	ASURA_XBOX360_KEYID_PAD1_R_THUMB	= ASURA_KEYID_PAD1_BUTTON10,
	ASURA_XBOX360_KEYID_PAD1_START		= ASURA_KEYID_PAD1_BUTTON11,
	ASURA_XBOX360_KEYID_PAD1_BACK		= ASURA_KEYID_PAD1_BUTTON12,
	ASURA_XBOX360_KEYID_PAD1_UP			= ASURA_KEYID_PAD1_BUTTON13,
	ASURA_XBOX360_KEYID_PAD1_DOWN		= ASURA_KEYID_PAD1_BUTTON14,
	ASURA_XBOX360_KEYID_PAD1_LEFT		= ASURA_KEYID_PAD1_BUTTON15,
	ASURA_XBOX360_KEYID_PAD1_RIGHT		= ASURA_KEYID_PAD1_BUTTON16,

	ASURA_XBOX360_KEYID_PAD2_A			= ASURA_KEYID_PAD2_BUTTON1, 
	ASURA_XBOX360_KEYID_PAD2_B			= ASURA_KEYID_PAD2_BUTTON2, 
	ASURA_XBOX360_KEYID_PAD2_X			= ASURA_KEYID_PAD2_BUTTON3, 
	ASURA_XBOX360_KEYID_PAD2_Y			= ASURA_KEYID_PAD2_BUTTON4, 
	ASURA_XBOX360_KEYID_PAD2_L_BUMPER	= ASURA_KEYID_PAD2_BUTTON5, 
	ASURA_XBOX360_KEYID_PAD2_R_BUMPER	= ASURA_KEYID_PAD2_BUTTON6, 
	ASURA_XBOX360_KEYID_PAD2_L_TRIGGER	= ASURA_KEYID_PAD2_BUTTON7, 
	ASURA_XBOX360_KEYID_PAD2_R_TRIGGER	= ASURA_KEYID_PAD2_BUTTON8, 
	ASURA_XBOX360_KEYID_PAD2_L_THUMB	= ASURA_KEYID_PAD2_BUTTON9, 
	ASURA_XBOX360_KEYID_PAD2_R_THUMB	= ASURA_KEYID_PAD2_BUTTON10,
	ASURA_XBOX360_KEYID_PAD2_START		= ASURA_KEYID_PAD2_BUTTON11,
	ASURA_XBOX360_KEYID_PAD2_BACK		= ASURA_KEYID_PAD2_BUTTON12,
	ASURA_XBOX360_KEYID_PAD2_UP			= ASURA_KEYID_PAD2_BUTTON13,
	ASURA_XBOX360_KEYID_PAD2_DOWN		= ASURA_KEYID_PAD2_BUTTON14,
	ASURA_XBOX360_KEYID_PAD2_LEFT		= ASURA_KEYID_PAD2_BUTTON15,
	ASURA_XBOX360_KEYID_PAD2_RIGHT		= ASURA_KEYID_PAD2_BUTTON16,

	ASURA_XBOX360_KEYID_PAD3_A			= ASURA_KEYID_PAD3_BUTTON1, 
	ASURA_XBOX360_KEYID_PAD3_B			= ASURA_KEYID_PAD3_BUTTON2, 
	ASURA_XBOX360_KEYID_PAD3_X			= ASURA_KEYID_PAD3_BUTTON3, 
	ASURA_XBOX360_KEYID_PAD3_Y			= ASURA_KEYID_PAD3_BUTTON4, 
	ASURA_XBOX360_KEYID_PAD3_L_BUMPER	= ASURA_KEYID_PAD3_BUTTON5, 
	ASURA_XBOX360_KEYID_PAD3_R_BUMPER	= ASURA_KEYID_PAD3_BUTTON6, 
	ASURA_XBOX360_KEYID_PAD3_L_TRIGGER	= ASURA_KEYID_PAD3_BUTTON7, 
	ASURA_XBOX360_KEYID_PAD3_R_TRIGGER	= ASURA_KEYID_PAD3_BUTTON8, 
	ASURA_XBOX360_KEYID_PAD3_L_THUMB	= ASURA_KEYID_PAD3_BUTTON9, 
	ASURA_XBOX360_KEYID_PAD3_R_THUMB	= ASURA_KEYID_PAD3_BUTTON10,
	ASURA_XBOX360_KEYID_PAD3_START		= ASURA_KEYID_PAD3_BUTTON11,
	ASURA_XBOX360_KEYID_PAD3_BACK		= ASURA_KEYID_PAD3_BUTTON12,
	ASURA_XBOX360_KEYID_PAD3_UP			= ASURA_KEYID_PAD3_BUTTON13,
	ASURA_XBOX360_KEYID_PAD3_DOWN		= ASURA_KEYID_PAD3_BUTTON14,
	ASURA_XBOX360_KEYID_PAD3_LEFT		= ASURA_KEYID_PAD3_BUTTON15,
	ASURA_XBOX360_KEYID_PAD3_RIGHT		= ASURA_KEYID_PAD3_BUTTON16,

	ASURA_XBOX360_KEYID_PAD4_A			= ASURA_KEYID_PAD4_BUTTON1, 
	ASURA_XBOX360_KEYID_PAD4_B			= ASURA_KEYID_PAD4_BUTTON2, 
	ASURA_XBOX360_KEYID_PAD4_X			= ASURA_KEYID_PAD4_BUTTON3, 
	ASURA_XBOX360_KEYID_PAD4_Y			= ASURA_KEYID_PAD4_BUTTON4, 
	ASURA_XBOX360_KEYID_PAD4_L_BUMPER	= ASURA_KEYID_PAD4_BUTTON5, 
	ASURA_XBOX360_KEYID_PAD4_R_BUMPER	= ASURA_KEYID_PAD4_BUTTON6, 
	ASURA_XBOX360_KEYID_PAD4_L_TRIGGER	= ASURA_KEYID_PAD4_BUTTON7, 
	ASURA_XBOX360_KEYID_PAD4_R_TRIGGER	= ASURA_KEYID_PAD4_BUTTON8, 
	ASURA_XBOX360_KEYID_PAD4_L_THUMB	= ASURA_KEYID_PAD4_BUTTON9, 
	ASURA_XBOX360_KEYID_PAD4_R_THUMB	= ASURA_KEYID_PAD4_BUTTON10,
	ASURA_XBOX360_KEYID_PAD4_START		= ASURA_KEYID_PAD4_BUTTON11,
	ASURA_XBOX360_KEYID_PAD4_BACK		= ASURA_KEYID_PAD4_BUTTON12,
	ASURA_XBOX360_KEYID_PAD4_UP			= ASURA_KEYID_PAD4_BUTTON13,
	ASURA_XBOX360_KEYID_PAD4_DOWN		= ASURA_KEYID_PAD4_BUTTON14,
	ASURA_XBOX360_KEYID_PAD4_LEFT		= ASURA_KEYID_PAD4_BUTTON15,
	ASURA_XBOX360_KEYID_PAD4_RIGHT		= ASURA_KEYID_PAD4_BUTTON16
};

enum ASURA_XBOX360_AXISID
{
	ASURA_XBOX360_AXISID_PAD1_LSTICK_H	= ASURA_AXIS_PAD1_LSTICK_H,
	ASURA_XBOX360_AXISID_PAD1_LSTICK_V	= ASURA_AXIS_PAD1_LSTICK_V,
	ASURA_XBOX360_AXISID_PAD1_RSTICK_H	= ASURA_AXIS_PAD1_RSTICK_H,
	ASURA_XBOX360_AXISID_PAD1_RSTICK_V	= ASURA_AXIS_PAD1_RSTICK_V,

	ASURA_XBOX360_AXISID_PAD2_LSTICK_H	= ASURA_AXIS_PAD2_LSTICK_H,
	ASURA_XBOX360_AXISID_PAD2_LSTICK_V	= ASURA_AXIS_PAD2_LSTICK_V,
	ASURA_XBOX360_AXISID_PAD2_RSTICK_H	= ASURA_AXIS_PAD2_RSTICK_H,
	ASURA_XBOX360_AXISID_PAD2_RSTICK_V	= ASURA_AXIS_PAD2_RSTICK_V,

	ASURA_XBOX360_AXISID_PAD3_LSTICK_H	= ASURA_AXIS_PAD3_LSTICK_H,
	ASURA_XBOX360_AXISID_PAD3_LSTICK_V	= ASURA_AXIS_PAD3_LSTICK_V,
	ASURA_XBOX360_AXISID_PAD3_RSTICK_H	= ASURA_AXIS_PAD3_RSTICK_H,
	ASURA_XBOX360_AXISID_PAD3_RSTICK_V	= ASURA_AXIS_PAD3_RSTICK_V,

	ASURA_XBOX360_AXISID_PAD4_LSTICK_H	= ASURA_AXIS_PAD4_LSTICK_H,
	ASURA_XBOX360_AXISID_PAD4_LSTICK_V	= ASURA_AXIS_PAD4_LSTICK_V,
	ASURA_XBOX360_AXISID_PAD4_RSTICK_H	= ASURA_AXIS_PAD4_RSTICK_H,
	ASURA_XBOX360_AXISID_PAD4_RSTICK_V	= ASURA_AXIS_PAD4_RSTICK_V
};


/******************************************************************************/
/* Constants                                                                  */
/******************************************************************************/

const u_int uASURA_XBOX360_NUM_BUTTONS_IN_PAD = 16;
const u_int uASURA_XBOX360_NUM_AXES_IN_PAD = 4;


#endif   // ifndef __ASURA_PLATFORMINPUT_H__
