//////////////////////////////////////////////////////////////////////////////
//
// Asura_Xbox360_Main.cpp
//
// Copyright (c) 2006 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

/******************************************************************************/
/* Included Files                                                             */
/******************************************************************************/

#include "Core/Asura.h"

// Asura independent
#include "Core/Asura_Core.h"
#include "Core/Asura_MaterialResponse_System.h"

// Asura Xbox 360
#include "Core/Asura_Platform_MultithreadTypes.h"
#include "Core/Asura_XBox360_Notifications.h"
#include "Rendering/Asura_Xbox360_Graphics.h"

// Project
#include "Main/Asura_Project_Main.h"

/******************************************************************************/
/* Functions                                                                  */
/******************************************************************************/

////////////////////////////////////////////////////////////////////////////////
//
// main()
//
// Program entry point
//
// Parameters:		None
// Return value:	None
//
////////////////////////////////////////////////////////////////////////////////

void main()
{
	Asura_Xbox360_SetThreadName( "MainThread" );

	Asura_XBox360_Notifications::Initialise(); //Optionally move this into Asura_Core::EarlyInitialise
	Asura_Core::EarlyInitialise();
	Asura_Project::EarlyInitialise();
	Asura_Core::LateInitialise();
	Asura_Project::LateInitialise();

	#if defined ASURA_USE_MATERIAL_RESPONSE_SYSTEM
		Asura_MaterialResponse_System::SetGlobalResetPointHit();
	#endif

	while( Asura_Project::MainLoop() )
	{
		Asura_XBox360_Notifications::Update();
	}

	Asura_XBox360_Notifications::Shutdown();
	Asura_Project::Shutdown();
	Asura_Core::Shutdown();
}
