//////////////////////////////////////////////////////////////////////////////
//
// Asura_Platform_FriendsList.cpp
//
// Copyright (c) 2008 Rebellion. All rights reserved.
//
// Description:
//
//     Xbox 360 implementations of Asura_FriendsList functions
//
//////////////////////////////////////////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "Core/Asura.h"

#ifdef ASURA_SUPPORT_LOBBY

// Asura independent 
#include "Network/Online/Asura_FriendsList.h"
#include "Network/Online/Asura_Lobby.h"

// Asura 360
#include "Network/Online/Asura_Xbox360_Friends.h"


void Asura_FriendsList::Platform_Initialise()
{
	Asura_Xbox360_Friends::Initialise();
}

void Asura_FriendsList::Platform_Shutdown()
{
	Asura_Xbox360_Friends::Shutdown();
}

void Asura_FriendsList::Platform_Refresh()
{
	Asura_Xbox360_Friends::Refresh();
}

bool Asura_FriendsList::Platform_ShowFriendsGUI()
{
	return Asura_Xbox360_Friends::ShowFriendsGUI();
}

bool Asura_FriendsList::Platform_IsPlayerAFriend(const Asura_Lobby_Player& xPlayer)
{
	return Asura_Xbox360_Friends::IsPlayerAFriend(xPlayer.GetPlatformData().m_xXUID);
}

#endif // #ifdef ASURA_SUPPORT_LOBBY
