//////////////////////////////////////////////////////////////////////////////
//
// Asura_Platform_Lobby.h
//
// Copyright (c) 2008 Rebellion. All rights reserved.
//
// Description:
//
//     Xbox360 types for online lobby
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef ASURA_PLATFORM_LOBBY_H___
#define ASURA_PLATFORM_LOBBY_H___ 1

//Asura_Lobby_Types.h provides an dummy for Asura_Platform_Lobby_GameConnectData when
//lobby support is not enabled - PJC 14/04/09
#ifdef ASURA_SUPPORT_LOBBY

#include <xbox.h>

class Asura_Platform_Lobby_LobbyData
{
public:
	Asura_Platform_Lobby_LobbyData()
	{
		m_ulSessionNonce = 0;
	}

	uint64 m_ulSessionNonce;
};

// KOR - in order to maintain compatibility, Asura_Platform_Lobby_GameConnectData
// must be the same size and alignment for all platforms. Currently PS3
// gives the strictest limits with a size of 40 bytes with 8-byte alignment.

// sent to the game server along with connection attempt
class Asura_Platform_Lobby_GameConnectData
{
public:
	XUID m_xXUID;		// 8 bytes
	u_int m_auPad[8];	// 32 bytes
						// 40 bytes total
};

// sent to all clients as information about each lobby member
class Asura_Platform_Lobby_PlayerData
 {
public:
	Asura_Platform_Lobby_PlayerData() {}
	Asura_Platform_Lobby_PlayerData(const Asura_Platform_Lobby_PlayerData& xConnectData)
	{
		m_xXUID = xConnectData.m_xXUID;
		m_xXNAddr = xConnectData.m_xXNAddr;
	}

	XUID m_xXUID;
	XNADDR m_xXNAddr;

	bool operator==( const Asura_Platform_Lobby_GameConnectData& xOther ) const
	{
		return (IsEqualXUID( m_xXUID, xOther.m_xXUID ) == TRUE); 
	}

	bool operator==( const Asura_Platform_Lobby_PlayerData& xOther ) const
	{
		return (IsEqualXUID( m_xXUID, xOther.m_xXUID ) == TRUE); 
	}
};

class Asura_Platform_Lobby_ListEntry
{
public:
	XSESSION_INFO m_xSessionInfo;
	u_int m_uNumPublicSlots;
	u_int m_uNumPrivateSlots;
	bool m_bIsRanked;
};

#endif

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

#endif // #ifndef ASURA_PLATFORM_LOBBY_H___
