//////////////////////////////////////////////////////////////////////////////
//
// Asura_Xbox360_Fog.h
//
// Copyright (c) 2006 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

#if defined ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#if !defined __ASURA_XBOX360_FOG_H__
#define __ASURA_XBOX360_FOG_H__

#include "Asura_Xbox360_Graphics.h"

/******************************************************************************/
/* Classes                                                                    */
/******************************************************************************/

////////////////////////////////////////////////////////////////////////////////
//
// Asura_Xbox360_Fog
//
// Manages fog on Xbox 360
//
////////////////////////////////////////////////////////////////////////////////

class Asura_Xbox360_Fog
{
public:

	static void Initialise();
	static void Shutdown();

	static void UpdateForNewParameters();
	static void RenderFog();

	static Direct3D_LineTexture* GetRenderTexture();

private:

	static void StepOntoNextTexture(void);
};




class Asura_Xbox360_FogEffectParameters
{
public:
	Asura_Xbox360_FogEffectParameters() {m_pxEffect = NULL;}

	void Apply(bool bEnabled, ASURA_TRANSLUCENCY_MODE eTranslucency);
	void Capture(Asura_Xbox360_Effect *pxEffect);

private:
	Asura_Xbox360_Effect *m_pxEffect;

	Asura_Xbox360_Effect_System::Handle	m_xFogEnabledHandle;
	Asura_Xbox360_Effect_System::Handle	m_xTextureHandle;
	Asura_Xbox360_Effect_System::Handle	m_xFogParamsHandle;
	Asura_Xbox360_Effect_System::Handle m_xColourHandle;
};


#endif // !defined __ASURA_XBOX360_FOG_H__
