//////////////////////////////////////////////////////////////////////////////
//
// Asura_Xbox360_LineRenderer.h
//
// Copyright (c) 2006 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

#if defined ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#if !defined __ASURA_XBOX360_LINERENDERER_H__
#define __ASURA_XBOX360_LINERENDERER_H__

/******************************************************************************/
/* Included Files                                                             */
/******************************************************************************/

#include "Core/Asura.h"

/******************************************************************************/
/* Classes                                                                    */
/******************************************************************************/

class Asura_Vector_2;
class Asura_Vector_3;

////////////////////////////////////////////////////////////////////////////////
//
// Asura_Xbox360_LineRenderer
//
// Handles rendering of 2D & 3D lines on Xbox 360
//
////////////////////////////////////////////////////////////////////////////////

class Asura_Xbox360_LineRenderer
{
public:

	static void Initialise();
	static void Reset();
	static void Shutdown();

	static void Render2DLine( const Asura_Vector_2& xP1, const Asura_Vector_2& xP2, const u_int uColour );
	static void Render3DLine( const Asura_Vector_3& xP1, const Asura_Vector_3& xP2, const u_int uColour );
};

#endif // !defined __ASURA_XBOX360_LINERENDERER_H__
