//////////////////////////////////////////////////////////////////////////////
//
// Asura_Xbox360_XPR_System.h
//
// Copyright (c) 2007 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

#if defined ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#if !defined __ASURA_XBOX360_XPR_SYSTEM_H__
#define __ASURA_XBOX360_XPR_SYSTEM_H__

/******************************************************************************/
/* Included Files                                                             */
/******************************************************************************/

#if !defined ASURA_XBOX360_MAX_NUM_XPRS && !defined ASURA_MAX_NO_OF_TEXTURES
	// Must include this to get ASURA_MAX_NO_OF_TEXTURES, needed below
	#include "Core/Asura_TextureManagement.h"
#endif

/******************************************************************************/
/* Constants                                                                  */
/******************************************************************************/

/******************************************************************************/
/* Classes                                                                    */
/******************************************************************************/

class Asura_Chunk_Stream;

////////////////////////////////////////////////////////////////////////////////
//
// Asura_Xbox360_XPR
//
// A loaded XPR package created using Bundler. Most textures' data are actually
// stored in these
//
////////////////////////////////////////////////////////////////////////////////

class Asura_Xbox360_XPR
{
public:

	Asura_Xbox360_XPR();

	void Create( char* const pcHeader, void* const pData );
	void Destroy();

	u_int AddRef();
	u_int GetRefCount() const { return m_uRefCount; }
	u_int Release();

protected:

	char* m_pcHeader;
	void* m_pData;
	u_int m_uRefCount;
};

////////////////////////////////////////////////////////////////////////////////
//
// Asura_Xbox360_XPR_System
//
// Manages XPR files produced by the Bundler tool
//
////////////////////////////////////////////////////////////////////////////////

class Asura_Xbox360_XPR_System
{
public:

	static void Initialise();
	static void Reset();
	static void Shutdown();

	static void ParseXPR( Asura_Chunk_Stream& xStream, bool bStreamedTexture = false );

protected:

	static Asura_Xbox360_XPR* FindFreeSlot();
};

#endif // !defined __ASURA_XBOX360_XPR_SYSTEM_H__
