//////////////////////////////////////////////////////////////////////////////
//
// Asura_Platform_Rewards_System.cpp
//
// Copyright (c) 2009 Rebellion. All rights reserved.
//
// Description:
//
//     Engine class to unify platform Reward (achievement) systems
//
//////////////////////////////////////////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "Core/Asura.h"

#ifdef ASURA_USE_REWARDS

// This file's header.
#include "Rewards/Asura_Rewards_System.h"

#include "Rewards/Asura_Xbox360_Achievements_System.h"

void Asura_Rewards_System::Platform_Initialise()
{
	Asura_Xbox360_Achievements_System::Initialise();
}

void Asura_Rewards_System::Platform_Shutdown()
{
	Asura_Xbox360_Achievements_System::Shutdown();
}

void Asura_Rewards_System::Platform_Reset()
{
	Asura_Xbox360_Achievements_System::Reset();
}

void Asura_Rewards_System::Platform_UnlockReward(u_int uRewardIndex)
{
	u_int uAchievement = Asura_Xbox360_Achievements_System::Project_ConvertReward(uRewardIndex);
	if (uAchievement != Asura_Xbox360_Achievements_System::s_uInvalid_Achievement)
	{
		Asura_Xbox360_Achievements_System::UnlockAchievement(uAchievement);
	}
}

void Asura_Rewards_System::Platform_RewardProgress(u_int uRewardIndex, u_int uProgress, u_int uTarget)
{
	// NY - 25 March 2009 - stubbed out for now as nothing in SDK to handle this
}

bool Asura_Rewards_System::Platform_IsRewardUnlocked(u_int uRewardIndex)
{
	int uAchievement = Asura_Xbox360_Achievements_System::Project_ConvertReward(uRewardIndex);
	if (uAchievement != Asura_Xbox360_Achievements_System::s_uInvalid_Achievement)
	{
		return false;
	}
	return Asura_Xbox360_Achievements_System::IsAchievementUnlocked(uAchievement);
}

bool Asura_Rewards_System::Platform_IsRewardAvailable(u_int uRewardIndex)
{
	return Asura_Xbox360_Achievements_System::Project_ConvertReward(uRewardIndex) != Asura_Xbox360_Achievements_System::s_uInvalid_Achievement;
}

bool Asura_Rewards_System::Platform_IsInitComplete()
{
	return Asura_Xbox360_Achievements_System::IsInitComplete();
}

bool Asura_Rewards_System::Platform_IsReadyToUnlock()
{
	// NY - 31 March 2009 - can't unlock achievements if no-one signed in, which can be determined by checking if the wrapper if init-ed
	return Asura_Xbox360_Achievements_System::IsInitComplete();
}


#endif // #ifdef ASURA_USE_REWARDS
