
//------------------------------------
#include "Shared.fxh"

//------------------------------------
float4	g_xScale	= { 1.0f, 1.0f, 1.0f, 1.0f };
float4	g_xOffset	= { 0.0f, 0.0f, 0.0f, 0.0f };

//------------------------------------
struct vertexInput
{
    float4 Position	: POSITION0;
};

struct vertexOutput
{
    float4 Position : POSITION0;
};

//------------------------------------
vertexOutput VS_TransformDiffuse(vertexInput IN) 
{
    vertexOutput OUT;
   
   	float4 xV = g_xOffset + (IN.Position * g_xScale);
   	 	 	
    OUT.Position = mul( xV, g_xViewProjectionMatrix );
    return OUT;
}
struct pixelOutput
{
	float4 diffuse : COLOR;
	
};

pixelOutput PS_Shader( vertexOutput IN )
{
	pixelOutput OUT;
	
	OUT.diffuse.rgba = 0.05f;
	OUT.diffuse.r = 1.0f;
	
	return OUT;
}
//-----------------------------------
technique textured
{
    pass p0 
    {		
		AlphaTestEnable = TRUE;
		CullMode = NONE;
		ZEnable = TRUE;
		ZWriteEnable = FALSE;

		VertexShader = compile vs_1_1 VS_TransformDiffuse();
		PixelShader = 0;
		//PixelShader = compile ps_1_1 PS_Shader();
    }
}