/******************************************************************************/
/* Parameters                                                                 */
/******************************************************************************/

const float g_fColour;

const sampler2D g_xNoiseTexture = sampler_state
{
	AddressU = WRAP;
	AddressV = WRAP;
};

/******************************************************************************/
/* Types                                                                      */
/******************************************************************************/

struct Vertex
{
	float4 m_xPosition : POSITION;
	float2 m_xUV       : TEXCOORD;
};

/******************************************************************************/
/* Functions                                                                  */
/******************************************************************************/

Vertex VShader( const Vertex xIn )
{
	return xIn;
}

float4 PShader( const Vertex xIn ) : COLOR
{
	// Can't access structs in asm blocks
	const float2 xUV = xIn.m_xUV;

	float4 xTexture;
	asm
	{
		tfetch2D xTexture, xUV, g_xNoiseTexture, MinFilter=linear, MagFilter=linear, MipFilter=point, AnisoFilter=disabled
	};

	// Ultra-simple shader, but needs to use the 'Ugh' Asura blend mode
	return xTexture * float4( g_fColour, g_fColour, g_fColour, 1.0 );
}

/******************************************************************************/
/* Techniques                                                                 */
/******************************************************************************/

technique
{
	pass
	{
		AlphaTestEnable = FALSE;
		CullMode = NONE;
		ZEnable = FALSE;
		ZWriteEnable = FALSE;

		VertexShader = compile vs_3_0 VShader();
		PixelShader = compile ps_3_0 PShader();
	}
}