
///////////////////////////////////////////////////////////////////////////////
//
// File   : Asura_Platform_FullScreenSFX_System.cpp
// Author : Kevin Floyer-Lea
// Date   : 29-Jun-2005
//
// Copyright (C) 2005 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

/******************************************************************************/
/* Included Files                                                             */
/******************************************************************************/

#include "Core/Asura.h"

#include "SpecialFX/Asura_FullScreenSFX_System.h"

// Asura Platform-independent
#include "Core/Asura_TextureFlags.h"
#include "Rendering/Asura_Render.h"
#include "Rendering/Asura_RenderStates.h"
#include "Rendering/Asura_Viewport.h"

/******************************************************************************/
/* Asura_FullScreenSFX_System Static Class Functions                          */
/******************************************************************************/

////////////////////////////////////////////////////////////////////////////////
//
// Asura_FullScreenSFX_System::Platform_RenderFade()
//
// Renders a simple quad over the current viewport, for fades
//
// Parameters:		uARGB - Packed 32-bit colour for the fade, including alpha
// Return value:	None
//
////////////////////////////////////////////////////////////////////////////////

void Asura_FullScreenSFX_System::Platform_RenderFade( u_int uARGB )
{
	Asura_Render::Overlay.Colour           = uARGB;
	Asura_Render::Overlay.TranslucencyMode = ASURA_TRANSLUCENCY_NORMAL;
	Asura_Render::Overlay.TextureIndex     = ASURA_TEXTURE_NONE;

	const float fWidth  = static_cast< float >( Asura_Viewport::GetWidth() );
	const float fHeight = static_cast< float >( Asura_Viewport::GetHeight() );

	Asura_Render::Overlay.SetRectXY( 0.0f, 0.0f, fWidth, fHeight );

	Asura_Render::Overlay.Render();
}

void Asura_FullScreenSFX_System::Platform_InitialiseMotionBlur()
{
}

void Asura_FullScreenSFX_System::Platform_RenderMotionBlur( u_char uMotionBlurAlpha )
{
}
