
///////////////////////////////////////////////////////////////////////////////
//
// File   : Asura_Platform_SpecialFX_System.cpp
// Author : Kevin Floyer-Lea
// Date   : 29-Jun-2005
//
// Copyright (C) 2005 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Core/Asura.h"

// This file's header...
#include "SpecialFX/Asura_SpecialFX.h"

// Asura header-files...

// Game header-files...


////////////////////////////////////////////////////////////////////////////////
// Constant declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Static variable declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Private functions...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Protected functions...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Public functions...
////////////////////////////////////////////////////////////////////////////////

void Asura_SpecialFX_System::Platform_Initialise (void)
{
}

void Asura_SpecialFX_System::Platform_Update (void)
{
}

void Asura_SpecialFX_System::Platform_BeginRender(const RenderType eRenderType)
{
#if defined(ASURA_XBOX360_ENABLE_PIX)
	const char*	szName;

	switch(eRenderType)
	{
		case RT_MAIN:
		{
			szName	= "SpecialFX (RT_MAIN)";
			break;
		}

		case RT_HUD_EFFECTS:
		{
			szName	= "SpecialFX (RT_HUD_EFFECTS)";
			break;
		}

		case RT_DECALS:
		{
			szName	= "SpecialFX (RT_DECALS)";
			break;
		}

		case RT_SKYBOX_EFFECTS:
		{
			szName	= "SpecialFX (RT_SKYBOX_EFFECTS)";
			break;
		}

		case RT_PROJECT_EFFECTS:
		{
			szName	= "SpecialFX (RT_PROJECT_EFFECTS)";
			break;
		}

		case RT_2D_EFFECTS:
		{
			szName	= "SpecialFX (RT_2D_EFFECTS)";
			break;
		}

#if defined(ASURA_USE_3DDECAL_SYSTEM)
		case RT_3D_DECALS_PRE_WORLD:
		{
			szName	= "SpecialFX (RT_3D_DECALS_PRE_WORLD)";
			break;
		}

		case RT_3D_DECALS_POST_WORLD:
		{
			szName	= "SpecialFX (RT_3D_DECALS_POST_WORLD()";
			break;
		}
#endif	//defined(ASURA_USE_3DDECAL_SYSTEM)

		default:
		{
			szName	= "SpecialFX (Unknown)";
			break;
		}
	}		// End of switch.

	PIXBeginNamedEvent(D3DCOLOR_XRGB(0xFF, 0xFF, 0xFF), szName);
#endif	//defined(ASURA_XBOX360_ENABLE_PIX)
}

void Asura_SpecialFX_System::Platform_Render (void)
{
}

void Asura_SpecialFX_System::Platform_EndRender(const RenderType eRenderType)
{
#if defined(ASURA_XBOX360_ENABLE_PIX)
	PIXEndNamedEvent();
#endif	//defined(ASURA_XBOX360_ENABLE_PIX)
}

void Asura_SpecialFX_System::Platform_Reset (void)
{
}

void Asura_SpecialFX_System::Platform_Shutdown (void)
{
}


/// End of file. ///
