; nsitemplate.nsi
;
!include WinMessages.nsh
!define WriteEnvStr_RegKey 'HKLM "SYSTEM\CurrentControlSet\Control\Session Manager\Environment"'

Function WriteEnvStr
  Exch $1 ; $1 has environment variable value
  Exch
  Exch $0 ; $0 has environment variable name
  Push $2
  
  WriteRegExpandStr ${WriteEnvStr_RegKey} $0 $1
  SendMessage ${HWND_BROADCAST} ${WM_WININICHANGE} 0 "STR:Environment" /TIMEOUT=5000
    Pop $2
    Pop $1
    Pop $0
FunctionEnd

;--------------------------------
; The name of the installer
Name "DemonWare"

; The file to write
OutFile "..\DemonWare.exe"

; The default installation directory
InstallDir $PROGRAMFILES\DemonWare-1.75-full-matchmaking-win32

; Registry key to check for directory (so if you install again, it will 
; overwrite the old one automatically)
InstallDirRegKey HKLM "Software\Demonware\DemonWare" "Install_Dir"

;--------------------------------

; Pages

Page license
Page components
Page directory
Page instfiles

LicenseData "license.rtf"

UninstPage uninstConfirm
UninstPage instfiles

;--------------------------------
; The stuff to install

Section "DemonWare (required)"

  SectionIn RO
  
  ; Set output path to the installation directory.
  SetOutPath "$INSTDIR"
  
  File /R *.*
  ; Write the installation path into the registry
  WriteRegStr HKLM SOFTWARE\Demonware\DemonWare "Install_Dir" "$INSTDIR"
  
  ; Write the uninstall keys for Windows
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\DemonWare" "DisplayName" "Demonware INSTALLERNAME"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\DemonWare" "UninstallString" '"$INSTDIR\DemonWare-uninstall.exe"'
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\DemonWare" "NoModify" 1
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\DemonWare" "NoRepair" 1
  WriteUninstaller "DemonWare-uninstall.exe"
  
SectionEnd

; Optional section (can be disabled by the user)
Section "Start Menu Shortcuts"

  CreateDirectory "$SMPROGRAMS\DemonWare-1.75-full-matchmaking-win32"
  CreateShortCut "$SMPROGRAMS\DemonWare-1.75-full-matchmaking-win32\DemonWare-Uninstall.lnk" "$INSTDIR\DemonWare-uninstall.exe" "" "$INSTDIR\DemonWare-uninstall.exe" 0
SectionEnd

Section "Modify PATH variable for custom DLLs"
  ReadEnvStr $R0 "PATH"
  Push "PATH"
  Push $R0;$INSTDIR\external\QSDK\win32\bin\Release
  Call WriteEnvStr
SectionEnd

;--------------------------------

; Uninstaller

Section "Uninstall"
  
  ; Remove registry keys
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\DemonWare"
  DeleteRegKey HKLM SOFTWARE\Demonware\DemonWare

  ; Remove files and uninstaller

  ; Remove shortcuts, if any
  Delete "$SMPROGRAMS\DemonWare-1.75-full-matchmaking-win32\*.*"

  ; Remove directories used
  RMDir "$SMPROGRAMS\DemonWare-1.75-full-matchmaking-win32"
  RMDir "$INSTDIR"

SectionEnd
