// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: WIN32 PS2 UNIX OSX PSP-INFRA PSP-ADHOC PS3
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS

#include <bdCore/bdCrypto/bdHashTiger192.h>
#include <bdCore/bdCrypto/bdCryptoConfig.h>
#include <bdCore/bdLog/bdLog.h>

#define BD_LOG_LEVEL "hashtiger192"

bdHashTiger192::bdHashTiger192()
{
	if (register_hash(&tiger_desc) == -1)
	{
		BD_ERR(BD_LOG_LEVEL,"Unable to register hash.");
	}
}

bdHashTiger192::~bdHashTiger192()
{
}

bdBool bdHashTiger192::hash(const bdUByte8 *data, const bdUInt dataSize, bdUByte8 *result, bdUInt &resultSize)
{
	unsigned long resultSz = resultSize;
	const bdInt error = hash_memory(find_hash("tiger"), data, dataSize, result, &resultSz);
	if (error != CRYPT_OK)
	{
		BD_ERR(BD_LOG_LEVEL,"Unable to create hash.");
		return false;
	}
	resultSize = resultSz;
	return true;
}

