// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS

#ifndef BD_LOG_SUBSCRIBER_H
#define BD_LOG_SUBSCRIBER_H

#include <bdCore/bdMemory/bdMemory.h>
#include <bdCore/bdContainers/bdSingleton.h>
#include <bdCore/bdContainers/bdHashMap.h>


#if defined BD_PLATFORM_UNIX
#ifndef _SYS_SYSLOG_H
#include <syslog.h>
#endif
#define BD_LOG_UNIXSYSLOG_FACILITY LOG_LOCAL0
#define BD_LOG_UNIXSYSLOG_FLAGS LOG_PERROR+LOG_PID
#endif

class bdLogSubscriber
{

	public:

		BD_DECLARE_NEW_AND_DELETE_OPERATORS;

		/// Default constructor
		bdLogSubscriber();

		/// Virtual Destructor
		virtual ~bdLogSubscriber();

		virtual void publish(const bdNChar8 *const fullChannelName,
							 const bdNChar8 *const file,
							 const bdNChar8 *const function,
							 const bdUInt line,
							 const bdNChar8 *const msg);

#ifdef BD_PLATFORM_UNIX
		void setProcessName(const bdNChar8 *const processName);

	protected:

		bdNChar8 m_processName[255];
#endif // BD_PLATFORM_UNIX
};

#endif // BD_LOG_SUBSCRIBER_H
