// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS

#include <bdCore/bdStreams/bdStdioFileStreambuf.h>
#include <bdCore/bdLog/bdLog.h>

#include <stdio.h>

bdStdioFileStreambuf::bdStdioFileStreambuf(const bdNChar8 *const filename,
										   const OpenMode mode)
{
	const bdNChar8* fileMode = BD_NULL;

	switch(mode)
	{
		case READ:
			fileMode = "rb";
			break;
		case WRITE:
			fileMode = "wb";
			break;
		case APPEND:
			fileMode = "ab";
			break;
		default:
			{
				bdBool fail = false;
				BD_ASSERT(fail, "Unknown OpenMode for bdStdioFileStreambuf");
			}
	}

	if (fileMode)
	{
		m_handle = ::fopen(filename, fileMode);
	}
	else
	{
		m_handle = BD_NULL;
	}

	if (m_handle == BD_NULL)
	{
		m_flags |= END_OF_FILE;
	}
}

bdStdioFileStreambuf::~bdStdioFileStreambuf()
{
	if (m_handle != BD_NULL)
	{
		flush();
		fclose(m_handle);
		m_handle = BD_NULL;
	}
}
