
// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS

// PURPOSE:

#ifndef BD_MATCHMAKING_QUERIES_H
#define BD_MATCHMAKING_QUERIES_H

#include <bdLobby/bdLobbyCommon/bdCustomQueryParams.h>
#include "CustomMatchMakingInfo.h"


#define BD_MAX_FINDSESSIONS_RESULTS (25u)

enum SearchId
{
	FINDSESSIONS = 1
};

/// Encapsulates and handles matchmaking results for a query by session ID.
class FindSessionByIDResult : public bdQueryResult
{
	public :
		BD_DECLARE_NEW_AND_DELETE_OPERATORS

		FindSessionByIDResult();

		virtual bdBool handleResult(const bdUInt numReplies, bdBitBufferRef buffer);

		CustomMatchMakingInfo m_customMMInfo;

		// if game info is present in m_customMMInfo
		bdBool m_gotResult;
};

/// Encapsulates a matchmaking query.
class FindSessions : public bdCustomQueryParams
{
	public:
		BD_DECLARE_NEW_AND_DELETE_OPERATORS

		FindSessions (bdUInt maxNumResults);

		virtual void serialize(bdBitBuffer &buffer);

};

/// Encapsulates and handles results from the query.
class FindSessionsResult : public bdQueryResult
{
	public:
		BD_DECLARE_NEW_AND_DELETE_OPERATORS

		FindSessionsResult();

		virtual bdBool handleResult(const bdUInt numReplies, bdBitBufferRef buffer);

		CustomMatchMakingInfo m_customMMInfo[BD_MAX_FINDSESSIONS_RESULTS];
};

#endif // BD_MATCHMAKING_QUERIES_H
