// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS

#define BD_QUERY_RESULT_LOG_LEVEL "Leaderboard Query Results"

template <bdUInt N>
LeaderboardQueryResult<N>::LeaderboardQueryResult()
{
}

template <bdUInt N>
LeaderboardQueryResult<N>::~LeaderboardQueryResult()
{
}

template <bdUInt N>
bdBool LeaderboardQueryResult<N>::handleResult(const bdUInt numResults,
											   bdBitBufferRef buffer)
{
	init();
	
	const bdUInt resultsToRead = BD_MIN(numResults, N);
	if(resultsToRead != numResults)
	{
		BD_WARN(BD_QUERY_RESULT_LOG_LEVEL, "Received %u results but can only store %u.", 
			numResults, N);
	}

	bdBool ok = bdStatsQueryResult::handleResult(numResults, buffer);
	for(bdUInt i=0; ok && (i < resultsToRead); i++)
	{
		ok = m_results[i].deserialize(buffer);
		if(ok)
		{
			m_numResults++;
		}
	}
	
	return ok;
}

template <bdUInt N>
bdUInt LeaderboardQueryResult<N>::getResults(LeaderboardEntry *const results,
											 const bdUInt numResults)
{
	const bdUInt resultsToCopy = BD_MIN3(m_numResults, numResults, N);
	for(bdUInt i = 0; i < resultsToCopy; i++)
	{
		results[i] = m_results[i];
	}
	return resultsToCopy;
}

template <bdUInt N>
LeaderboardEntry& LeaderboardQueryResult<N>::operator[] (const bdUInt i)
{
	BD_ASSERT((i < N) && (i < m_numResults), "Rangecheck failed");
	return m_results[i];
}
