// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS

// PURPOSE:

#ifndef BD_SAMPLELEADERBOARD1_SEARCH_QUERIES_H
#define BD_SAMPLELEADERBOARD1_SEARCH_QUERIES_H

#include <bdLobby/bdLobbyCommon/bdCustomQueryParams.h>
#include <bdLobby/bdStats/bdStatsQueryResult.h>
#include "SampleLeaderboard1.h"

#define BD_MAX_SEARCH_RESULTS (20u)

#define BD_MAX_BESTDEATHTOKILLSRATIO_RESULTS (25u)


enum bdSearchId
{
	BD_BESTDEATHTOKILLSRATIO = 1
};
	
/// Encapsulates a  query.
class bdBestDeathToKillsRatio : public bdCustomQueryParams
{
	public:
		BD_DECLARE_NEW_AND_DELETE_OPERATORS

		bdBestDeathToKillsRatio(bdUInt maxNumResults);
		
		virtual void serialize(bdBitBuffer &buffer);

	

};
/// Encapsulates and handles results from the bdBestDeathToKillsRatio query.
class bdBestDeathToKillsRatioResult : public bdStatsQueryResult
{
	public:
		BD_DECLARE_NEW_AND_DELETE_OPERATORS

		bdBestDeathToKillsRatioResult();

		virtual bdBool handleResult(bdUInt numReplies, bdBitBufferRef buffer);

		bdUInt m_numRows;

		SampleLeaderboard1 m_SampleLeaderboard1[BD_MAX_BESTDEATHTOKILLSRATIO_RESULTS];
};

#endif // BD_SAMPLELEADERBOARD1_SEARCH_QUERIES_H
