// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS

#ifndef BD_FF_USER_INFO_H
#define BD_FF_USER_INFO_H

#include<bdLobby/bdLobbyCommon/bdQueryParams.h>
#include<bdLobby/bdLobbyCommon/bdQueryResult.h>
#include<bdLobby/bdLobbyCommon/bdLobbyServicesCommon.h>

/// Sample of Profiles class to be auto-generated by IMP-Profiles
class PublicProfileInfo : public bdQueryParams
{
public:

	PublicProfileInfo(){};

	~PublicProfileInfo();

	virtual void serialize(bdBitBuffer& buffer);

	virtual bdBool deserialize(bdBitBufferRef buffer);

	bdInt32 m_experiencePoints;
};

/// Sample of Profiles class to be auto-generated by IMP-Profiles
class PrivateProfileInfo : public bdQueryParams
{
public:

	PrivateProfileInfo(){};

	~PrivateProfileInfo();

	virtual void serialize(bdBitBuffer& buffer);

	virtual bdBool deserialize(bdBitBufferRef buffer);

	bdString m_email;
};

class GetPrivateProfileResult : public bdQueryResult
{
public:

	GetPrivateProfileResult(){};

	~GetPrivateProfileResult(){};

	bdBool handleResult(bdUInt numRows, bdBitBufferRef buffer);

	bdUInt64 profileId;
	PrivateProfileInfo data;
};

class GetPublicProfileResult : public bdQueryResult
{
public:

	GetPublicProfileResult(){};

	~GetPublicProfileResult(){};

	bdBool handleResult(bdUInt numRows, bdBitBufferRef buffer);

	bdUInt64 profileId;
	PublicProfileInfo data;
};

#endif
