// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS

#ifndef DEBUG_SESSION_LISTENER_H
#define DEBUG_SESSION_LISTENER_H

#include <bdCore/bdCore.h>

#include <bdPeer/bdSession/bdSessionListener.h>

class DebugSessionListener : public bdSessionListener
{
	public:

		BD_DECLARE_NEW_AND_DELETE_OPERATORS
		
		DebugSessionListener ();
		~DebugSessionListener ();

		/// bdSessionListener interface.
		/// By registering a session listener with the peer
		///  we will be called back about the following session events.
		void onSessionConnectError();
		void onSessionConnectDefer();
		void onSessionConnectRefuse(const bdUInt32 reason);
		void onSessionConnectFail();
		void onSessionConnectSuccess();
		void onSessionConnect(const bdConnectionRef peer);
		void onSessionDisconnect(const bdConnectionRef peer);
		void onSessionStatusChange(const bdSession::bdSessionStatus previous,
								   const bdSession::bdSessionStatus current);
		void onSessionRolePromote();
		void onSessionHostChange(const bdAddr& sessionHost);		
};

#endif // DEBUG_SESSION_LISTENER_H
