// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS

#include <bdExampleCommon/bdExampleCommonCS.h>

bdBool BD_CALL parseCommandLine(bdInt32 argc, 
								bdNChar8* argv[],
								bdPort& localPort,
								bdAddr& serverHost,
								bdServerRef& server,
								bdClientRef& client,
								bdBool& doDiscovery)
{
	bdBool paramsOk = false;
	doDiscovery = true;
	if (argc >= 2)
	{
		// First parameter is the local port.
		bdNChar8 *endPtr;
		localPort = static_cast<bdPort>(bdStrtoui32(argv[1], &endPtr, 10));

		if (argc >= 3)
		{
			// Second parameter is either "server" or "client".
			if (bdStrcasecmp(argv[2], "server") == 0)
			{
				// Instantiate the server interface.
				server = new bdServer;
				
				if (argc >= 4)
				{
					if (bdStrcasecmp(argv[3], "-nodiscovery") == 0)
					{
						doDiscovery = false;
					}
				}
				paramsOk = true;
			}
			else if (bdStrcasecmp(argv[2], "client") == 0)
			{
				// Instantiate the client interface.
				client = new bdClient;
				paramsOk = true;
				if(argc >= 4)
				{
					// Set the server host as specified by the arguments.
					serverHost.set(argv[3]);
					doDiscovery = false;
					paramsOk = true;
				}
			}
		}
	}

	if(!paramsOk)
	{
		bdPrintf( "Parameters: <localport> <server|client >\n");
	}
	
	return paramsOk;
}

