// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS
// PURPOSE: The result set of a call to bdChannelChat::getChannelMembers.

#ifndef BD_GET_CHANNEL_MEMBERS_RESULT_H
#define BD_GET_CHANNEL_MEMBERS_RESULT_H

#include <bdCore/bdCore.h>
#include <bdLobby/bdLobbyCommon/bdLobbyServicesCommon.h>
#include <bdLobby/bdLobbyCommon/bdQueryResult.h>

/// The result set obtained following a call to bdChannelChat::getChannelMembers.
/// An instance of this class should be passed to bdChannelChat::handleTask following
/// successful completion of a task returned from getChannelMembers function.
class bdGetChannelMembersResult : public bdQueryResult
{
	public:
		BD_DECLARE_NEW_AND_DELETE_OPERATORS

		class bdChannelMember
		{
			public:
				BD_DECLARE_NEW_AND_DELETE_OPERATORS

				~bdChannelMember(){};
				bdUInt64 m_userID;
				bdNChar8 m_userName[BD_MAX_USERNAME_LENGTH];
				bdUByte8 m_userType;
		};

		bdGetChannelMembersResult();

		virtual ~bdGetChannelMembersResult();

		virtual bdBool handleResult(const bdUInt numResults, 
									bdBitBufferRef buffer);

		bdArray<bdChannelMember> m_memberList;
};

#endif // BD_GET_CHANNEL_MEMBERS_RESULT_H
