// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS

// PURPOSE: Used for obtaining the result set following a call to bdChannelChat::getChannelList.

#ifndef BD_GET_CHANNEL_LIST_RESULT_H
#define BD_GET_CHANNEL_LIST_RESULT_H

#include <bdCore/bdCore.h>
#include <bdLobby/bdLobbyCommon/bdLobbyServicesCommon.h>
#include <bdLobby/bdLobbyCommon/bdQueryResult.h>

#include <bdLobby/bdChannelChat/bdChannelChat.h>
#include <bdLobby/bdChannelChat/bdChannelInfo.h>

/// Used for obtaining the result set following a call to bdChannelChat::getChannelList,
/// by passing through to bdChannelChat::handleTask.
class bdGetChannelsResult : public bdQueryResult
{
	public:
		BD_DECLARE_NEW_AND_DELETE_OPERATORS
		
		bdGetChannelsResult();

		virtual ~bdGetChannelsResult();

		virtual bdBool handleResult(const bdUInt numResults, bdBitBufferRef buffer);

		/// After passing an instance of this class to bdChannelChat::handleTask,
		/// this array will contain bdChannelInfo instances for each existing
		/// channel.
		bdArray<bdChannelInfo> m_channelList;
};

#endif // BD_GET_CHANNEL_LIST_RESULT_H
