// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS
// PURPOSE: The result set of a call to bdFriends::getGroupedFriends().

#ifndef BD_GET_GROUPED_FRIENDS_RESULT_H
#define BD_GET_GROUPED_FRIENDS_RESULT_H

#include <bdCore/bdCore.h>

#include <bdLobby/bdLobbyCommon/bdLobbyServicesCommon.h>
#include <bdLobby/bdLobbyCommon/bdQueryResult.h>

/// The result set of a call to bdFriends::getGroupedFriends().
/// An instance of this class should be passed to bdFriends::handleTask following
/// successful completion of a task returned from getGroupedFriends() function.
class bdGetGroupedFriendsResult : public bdQueryResult
{
	public:
		BD_DECLARE_NEW_AND_DELETE_OPERATORS
		
		class bdGroupedFriend
		{
		public:
			BD_DECLARE_NEW_AND_DELETE_OPERATORS
			~bdGroupedFriend(){};
			bdOnlineUserID m_userID;
			bdNChar8 m_userName[BD_MAX_USERNAME_LENGTH];
			bdBool m_isOnline;
			bdUByte8 m_groupID;
		};

		bdGetGroupedFriendsResult();

		virtual ~bdGetGroupedFriendsResult();

		virtual bdBool handleResult(const bdUInt numResults, 
									bdBitBufferRef buffer);

		/// After passing an instance of this class to bdFriends::handleTask,
		/// this array will contain entries for each friend, along with the
		/// friends online status, and group ID.
		bdArray<bdGroupedFriend> m_friends;
};

#endif // BD_GET_GROUPED_FRIENDS_RESULT_H
