// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS

// PURPOSE: Container class for storing title specific search parameters. 
//	A game should derive from this class for each title specific query.
//  Result sets are stored in bdQueryResult

#ifndef BD_QUERY_PARAMS_H
#define BD_QUERY_PARAMS_H

#include <bdCore/bdCore.h>

/// Container class for storing title specific search parameters.
///	A game should derive from this class for each title specific query.
/// Result sets are stored in bdQueryResult
class bdQueryParams
{
	public:

		BD_DECLARE_NEW_AND_DELETE_OPERATORS
		
		bdQueryParams();

		virtual ~bdQueryParams();

		virtual void serialize(bdBitBuffer &buffer);

		virtual bdBool deserialize(bdBitBufferRef buffer);
};

#endif // BD_QUERY_PARAMS_H
