// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS

#include <bdLobby/bdMatchMaking/bdSessionCreateResult.h>

bdSessionCreateResult::bdSessionCreateResult()
: m_secID(),
  m_secKey()
{
	bdMemset(m_secID.ab, 0, sizeof(m_secID.ab));
	bdMemset(m_secKey.ab, 0, sizeof(m_secKey.ab));
}

bdBool bdSessionCreateResult::handleResult(const bdUInt numResults, 
										   bdBitBufferRef buffer)
{
	bdBool ok = true;
	m_numResults = 0;
	
	BD_ASSERT(numResults <= 1, "Only expecting 1 or 0 results.");

	if (numResults > 0)
	{
		// read securityID
		bdUInt32 blobLength = BD_SECURITY_ID_LENGTH;
		ok = buffer->readBlob(m_secID.ab, blobLength);

		// read securityKey
		blobLength = BD_SECURITY_KEY_LENGTH;
		ok = ok && buffer->readBlob(m_secKey.ab, blobLength);

		if(ok)
		{
			m_numResults = 1;
		}
	}

	return ok;
}
