// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS

#include <bdLobby/bdMessageStore/bdMessageTypes/bdFriendCustomMessage.h>

bdFriendCustomMessage::bdFriendCustomMessage(const bdUInt messageType)
: bdUserNotificationMessage(messageType)
{
}

bdFriendCustomMessage::~bdFriendCustomMessage()
{
}

bdBool bdFriendCustomMessage::deserialize(bdBitBufferRef buffer)
{
	bdBool ok = bdUserNotificationMessage::deserialize(buffer);
	
	bdUByte8 payloadBuffer[BD_MAXIMUM_CUSTOM_MSG_SIZE];
	bdUInt32 size = sizeof(payloadBuffer);
	ok = ok && buffer->readBlob(payloadBuffer, size);

	if(ok && (size > 0))
	{
		// fail safe
		ok = false;

		m_data = new bdByteBuffer(size);
		if(m_data.notNull())
		{
			ok = m_data->write(payloadBuffer, size);
		}		
	}
	return ok;
}
