// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS

// PURPOSE: Collection of classes that are used in conjuction with the messaging
//	service. Games can derive from these for title specific messages.

#ifndef BD_FRIEND_PROPOSAL_MESSAGE_H
#define BD_FRIEND_PROPOSAL_MESSAGE_H

#include <bdCore/bdCore.h>
#include <bdLobby/bdMessageStore/bdMessageTypes/bdUserNotificationMessage.h>

BD_REFERENCE(bdFriendshipProposalMessage);

/// Represents an invitation to a game session
class bdFriendshipProposalMessage: public bdUserNotificationMessage
{
	public:

		BD_DECLARE_NEW_AND_DELETE_OPERATORS

		bdFriendshipProposalMessage(const bdUInt messageType);

		virtual ~bdFriendshipProposalMessage();

		virtual bdBool deserialize(bdBitBufferRef buffer);

		bdUInt16 m_attachmentSize;
		void * m_attachment;
};

#endif // BD_FRIEND_PROPOSAL_MESSAGE_H
