// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS


#ifndef BD_TEAM_NOTIFICATION_MESSAGE_H
#define BD_TEAM_NOTIFICATION_MESSAGE_H

#include <bdCore/bdCore.h>
#include <bdLobby/bdMessageStore/bdLobbyMessage.h>

BD_REFERENCE(bdTeamNotificationMessage);

/// Represents a notification of a team event
class bdTeamNotificationMessage : public bdLobbyMessage
{
	public:

		BD_DECLARE_NEW_AND_DELETE_OPERATORS

		bdTeamNotificationMessage(const bdUInt messageType);

		virtual ~bdTeamNotificationMessage();

		virtual bdBool deserialize(bdBitBufferRef buffer);

		/// The ID of the user that caused this notification
		bdOnlineUserID m_originatorID;

		/// The name of the user that caused this notification
		bdNChar8 m_originatorName[BD_MAX_USERNAME_LENGTH];

		bdTeamID m_teamID;

		bdNChar8 m_teamName[BD_MAX_TEAMNAME_LENGTH];

};

#endif // BD_TEAM_NOTIFICATION_MESSAGE_H
