// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS


#ifndef BD_TEAM_WIDE_NOTIFICATION_MESSAGE_H
#define BD_TEAM_WIDE_NOTIFICATION_MESSAGE_H

#include <bdCore/bdCore.h>
#include <bdLobby/bdMessageStore/bdMessageTypes/bdTeamNotificationMessage.h>

BD_REFERENCE(bdTeamWideNotificationMessage);

/// Represents a notification of a team event which is sent to all team members
class bdTeamWideNotificationMessage : public bdTeamNotificationMessage
{
	public:

		BD_DECLARE_NEW_AND_DELETE_OPERATORS

		bdTeamWideNotificationMessage(const bdUInt messageType);

		virtual ~bdTeamWideNotificationMessage();

		virtual bdBool deserialize(bdBitBufferRef buffer);

		/// The ID of the user that caused this notification
		bdOnlineUserID m_relevantID;

		/// The name of the user that caused this notification
		bdNChar8 m_relevantName[BD_MAX_USERNAME_LENGTH];
};

#endif // BD_TEAM_WIDE_NOTIFICATION_MESSAGE_H
