// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS


#include <bdLobby/bdStats/bdStatsInfo.h>

#define BD_LOG_LEVEL "statsInfo"

bdStatsInfo::bdStatsInfo()
: m_entityID(0),
  m_rating(0),
  m_rank(0)
{
}

bdStatsInfo::bdStatsInfo(const bdInt64 rating)
: m_entityID(0),
  m_rating(rating),
  m_rank(0)
{
}


bdStatsInfo::~bdStatsInfo()
{
}


void bdStatsInfo::serialize(bdBitBuffer &buffer)
{
	buffer.writeInt64(m_rating);
}

bdBool bdStatsInfo::deserialize(bdBitBufferRef buffer)
{
	bdBool ok = buffer->readUInt64(m_entityID);
	ok = ok && buffer->readInt64(m_rating);
	ok = ok && buffer->readUInt64(m_rank);
	ok = ok && buffer->readString(m_entityName, BD_MAX_USERNAME_LENGTH);

	if (!ok)
	{
		BD_ERR(BD_LOG_LEVEL, "Deserialization failed");
	}
	return ok;
}

void bdStatsInfo::setRating(const bdInt64 rating)
{
	if (m_rating != rating)
	{
		m_rating = rating;
	}
}
bdInt64 bdStatsInfo::getRating() const
{
	return m_rating;
}

void bdStatsInfo::setEntityID(const bdEntityID entityID)
{
	m_entityID = entityID;
}


bdEntityID bdStatsInfo::getEntityID() const
{
	return m_entityID;
}

bdUInt64 bdStatsInfo::getRank() const
{
	return m_rank;
}

void bdStatsInfo::setEntityName(const bdNChar8 *const buf)
{
	bdStrlcpy(m_entityName, buf, sizeof(m_entityName));
}

void bdStatsInfo::getEntityName(bdNChar8* buf, const bdUInt32 bufSize) const
{
	bdStrlcpy(buf, m_entityName, bufSize);
}

bdUInt bdStatsInfo::getNumFields() const
{
	return 1;
}
