// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS

#include <bdCore/bdCore.h>
#include <bdLobby/bdStats/bdWriteMultiStatsResult.h>
#define BD_LOG_LEVEL "writeMultiStatsResult"

bdWriteMultiStatsResult::bdWriteMultiStatsResult()
//: m_usersWritten(0),
//  m_teamsWritten(0)
{
}

bdWriteMultiStatsResult::~bdWriteMultiStatsResult()
{
}

bdBool bdWriteMultiStatsResult::handleResult(const bdUInt, bdBitBufferRef buffer)
{
	bdBool ok = true;
	bdUInt32 userResults = 0;
	bdUInt32 teamResults = 0;

	ok = ok && buffer->readUInt32(userResults);
	ok = ok && buffer->readUInt32(teamResults);

	ok = ok && ((userResults + teamResults) < BD_STATS_MAX_WRITE_ENTITIES);

	m_usersWritten.increaseCapacity(userResults);
	m_teamsWritten.increaseCapacity(teamResults);

	for (bdUInt i=0; i < userResults && ok; i++)
	{
		bdUInt64 t = 0;
		ok = ok && buffer->readUInt64(t);
		if (ok)
		{
			m_usersWritten.pushBack(t);
		}
	}

	for (bdUInt i=0; i < teamResults && ok; i++)
	{
		bdUInt64 t = 0;
		ok = ok && buffer->readUInt64(t);
		if (ok)
		{
			m_teamsWritten.pushBack(t);
		}
	}

	return ok;
}


