// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS

// PURPOSE: Used for obtaining the result set following a call to 
//			bdStorage::listFilesByOwner or bdStorage::listAllPublisherFiles.

#ifndef BD_LIST_FILES_RESULT_H
#define BD_LIST_FILES_RESULT_H

#include <bdCore/bdCore.h>
#include <bdLobby/bdLobbyCommon/bdQueryResult.h>
#include <bdLobby/bdStorage/bdLobbyFileHeader.h>

/// Result set for use following a call to bdStorage::listFilesByOwner or 
/// bdStorage::listAllPublisherFiles.
class bdListFilesResult : public bdQueryResult
{
	public:
		BD_DECLARE_NEW_AND_DELETE_OPERATORS

		bdListFilesResult(){};

		virtual ~bdListFilesResult();

		virtual bdBool handleResult(const bdUInt numResults, 
									bdBitBufferRef buffer);

		/// After passing an instance of this class to bdStorage::handleTask,
		/// this array will contain bdLobbyFileHeaders instances for each file 
		/// returned.
		bdArray<bdLobbyFileHeaderRef> m_fileHeaders;
};

#endif // BD_LIST_FILES_RESULT_H
