// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS

#include <bdLobby/bdStorage/bdLobbyFile.h>

bdLobbyFile::bdLobbyFile(bdUInt size)
: m_data(BD_NULL),
  m_deallocate(false)
{
	if (size)
	{
		m_data = bdMemory::allocate(size);
		m_fileSize = size;
		m_deallocate = true;
	}
}

bdLobbyFile::~bdLobbyFile()
{
	if(m_deallocate && m_data)
	{
		bdMemory::deallocate(m_data);
	}
	m_data = BD_NULL;
}

bdBool bdLobbyFile::deserialize(bdBitBufferRef buffer)
{
	bdBool ok;
	ok = bdLobbyFileHeader::deserialize(buffer);
	ok = ok && buffer->readBlob(static_cast<bdUByte8*>(m_data), m_fileSize);
	return ok;
}

void bdLobbyFile::setData(bdUByte8 *data,
						  bdUInt32 size)
{
	m_data = data;
	m_fileSize = size;
	m_deallocate = false;
}

const void *bdLobbyFile::getData() const
{
	return m_data;
}

void *bdLobbyFile::getData()
{
	return m_data;
}
