// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS

// PURPOSE: Result set container for bdTeams::createTeam tasks.

#ifndef BD_CREATE_TEAM_RESULT_H
#define BD_CREATE_TEAM_RESULT_H

#include <bdLobby/bdLobbyCommon/bdLobbyServicesCommon.h>
#include <bdLobby/bdLobbyCommon/bdQueryResult.h>

/// Result set container for bdTeams::createTeam tasks.
/// An instance of this class should be passed to bdTeams::handleTask upon 
/// successful completion of a bdTeams::createTeam task.
class bdCreateTeamResult : public bdQueryResult
{
	public:

		BD_DECLARE_NEW_AND_DELETE_OPERATORS

		bdCreateTeamResult();

		virtual ~bdCreateTeamResult();

		virtual bdBool handleResult(const bdUInt numResults, 
									bdBitBufferRef buffer);

		/// Following a call to bdTeams::handleTask with an instance of this 
		/// class, this will contain the value of the team ID that was assigned
		/// by the server.
		bdTeamID m_teamID;
};

#endif // BD_CREATE_TEAM_RESULT_H
