 // DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS

// PURPOSE: Result set container for bdTeams::getProposalsList tasks.

#ifndef BD_GET_TEAMS_PROPOSAL_LIST_RESULT_H
#define BD_GET_TEAMS_PROPOSAL_LIST_RESULT_H

#include <bdCore/bdCore.h>
#include <bdLobby/bdLobbyCommon/bdLobbyServicesCommon.h>
#include <bdLobby/bdLobbyCommon/bdQueryResult.h>

/// Result set container for bdTeams::getProposalsList tasks.
/// An instance of this class should be passed to bdTeams::handleTask upon 
/// successful completion of a bdTeams::getProposalsList task.
class bdGetTeamsProposalListResult : public bdQueryResult
{
	public:
		BD_DECLARE_NEW_AND_DELETE_OPERATORS
		
		class bdPotentialMember
		{
			public:
				BD_DECLARE_NEW_AND_DELETE_OPERATORS
				~bdPotentialMember(){};
				bdOnlineUserID m_userID;
				bdTeamID m_teamID;
				bdNChar8 m_userName[BD_MAX_USERNAME_LENGTH];
				bdNChar8 m_teamName[BD_MAX_TEAMNAME_LENGTH];
		};

		bdGetTeamsProposalListResult();

		virtual ~bdGetTeamsProposalListResult();

		virtual bdBool handleResult(const bdUInt numResults, 
									bdBitBufferRef buffer);

		/// Following a call to bdTeams::handleTask with an instance of this 
		/// class, this will contain an array of the outstanding proposals that
		/// have been sent.
		bdArray<bdPotentialMember> m_proposalList;
};

#endif // BD_GET_TEAMS_PROPOSAL_LIST_RESULT_H
