// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS
// PURPOSE: The result set obtained following a call to bdTitleUtilities::getTitleStats.

#ifndef BD_TITLE_STATS_RESULT_H
#define BD_TITLE_STATS_RESULT_H

#include <bdCore/bdCore.h>
#include <bdLobby/bdLobbyCommon/bdQueryResult.h>

class bdTitleStatsResult : public bdQueryResult
{
	public:
		BD_DECLARE_NEW_AND_DELETE_OPERATORS

		// Constructor.
		bdTitleStatsResult();

		virtual bdBool handleResult(const bdUInt numResults, 
									bdBitBufferRef buffer);

		/// The current number of advertized game sessions
		bdUInt32 m_numOnlineSessions;

		/// The total number of registered users
		bdUInt32 m_numTotalUsers;

		/// The number of users that are currently online
		bdUInt32 m_numOnlineUsers;
};

#endif // BD_TITLE_STATS_RESULT_H
