// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS

#ifndef BD_BADNWIDTH_LISTENER_H
#define BD_BADNWIDTH_LISTENER_H

#include <bdCore/bdCore.h>

class bdBandwidthListener
{

	public:

		/// Event notification handler: called when the outgoing
		/// bandwidth usage exceeds the high water mark
		/// \param bytesSent[in] The actual number of bytes sent
		virtual void onSendHighWaterMark(bdUInt32 bytesSent);

		/// Event notification handler: called when the outgoing
		/// bandwidth usage falls below the low water mark
		/// \param bytesSent[in] The actual number of bytes sent
		virtual void onSendLowWaterMark(bdUInt32 bytesSent);

		virtual ~bdBandwidthListener();

};

#endif //BD_BADNWIDTH_LISTENER_H
