// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: ALL
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS

#include <bdNet/bdStream/bdOutStream.h>

bdStreamNum bdOutStream::m_staticNum = 0;

bdOutStream::bdOutStream(const bdConnectionRef connection, 
						 const bdStreamType type,
						 const bdBool reliable,
						 const bdUByte8 priority)
: m_connection(connection),
  m_type(type),
  m_reliable(reliable),
  m_num(m_staticNum++),
  m_priority(priority),
  m_finished(false),
  m_closed(false)
{	
}

bdOutStream::~bdOutStream()
{
}

bdConnectionRef bdOutStream::getConnection() const
{
	return m_connection;
}

bdStreamType bdOutStream::getType() const
{
	return m_type;
}

bdBool bdOutStream::getReliable() const
{
	return m_reliable;
}


bdStreamNum bdOutStream::getNum() const
{
	return m_num;
}

bdUByte8 bdOutStream::getPriority() const
{
	return m_priority;
}

void bdOutStream::close()
{
	m_closed = true;
}

void bdOutStream::finished()
{
	m_finished = true;
}

bdBool bdOutStream::isFinished() const
{
	return m_finished;
}

bdBool bdOutStream::isClosed() const
{
	return m_closed;
}
