// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: WIN32
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS


#include <bdPlatform/bdPlatformRandom/bdPlatformTrulyRandom.h>

#ifndef _WIN32_WINNT
#	define _WIN32_WINNT 0x0400
#endif
#include <windows.h>
#include <wincrypt.h>

// The handle to the random generator.
static bdULong32 s_provider;

class bdPlatformTrulyRandomInit
{
	public:

		bdPlatformTrulyRandomInit()
		{
			CryptAcquireContext(&s_provider, 0, 0, PROV_RSA_FULL, CRYPT_VERIFYCONTEXT);
		}

		~bdPlatformTrulyRandomInit()
		{
			CryptReleaseContext(s_provider, 0);
		}
};
// Used to bind the handle to the generator.
static bdPlatformTrulyRandomInit s_randomInit;

void BD_CALL bdGetRandomUChar8(bdUByte8 in[], 
							   const bdUInt length)
{
	// fixme: 258000 - Memory Leak When You Use the Microsoft Base Cryptographic Provider
	CryptGenRandom(s_provider, length, in);
}

