// DWBS ------------------------------------------------------------------ DWBS
//
// PLATFORM		: WIN32 PS2 UNIX OSX PSP-INFRA PS3
// PRODUCT		: BIT_DEMON
// VISIBILITY	: PUBLIC
//
// DWBS ------------------------------------------------------------------ DWBS

// PURPOSE: DTLS error packet.


#ifndef BD_DTLS_ERROR_H
#define BD_DTLS_ERROR_H

#include <bdCore/bdCore.h>
#include <bdSocket/bdDTLS/bdPacket/bdDTLSHeader.h>

class bdDTLSError : public bdDTLSHeader
{
	public:

		BD_DECLARE_NEW_AND_DELETE_OPERATORS

		enum bdDTLSErrorType
		{
			BD_DTLS_ERROR_BAD_SECID = 0,
			BD_DTLS_INVALID_STATE
		};

		bdDTLSError();

		bdDTLSError(bdUInt16 vtag, bdDTLSErrorType etype);

		virtual ~bdDTLSError();

		virtual bdBool serialize(void *data,const bdUInt size,
			const bdUInt offset, bdUInt &newOffset) const;
		virtual bdBool deserialize(const void* data, const bdUInt size,
			const bdUInt offset, bdUInt &newOffset);

		bdDTLSErrorType getEtype() const;
	protected:
		bdDTLSErrorType m_etype;
};

#endif // BD_DTLS_ERROR_H


