/* SCE CONFIDENTIAL
 "PlayStation 2" Programmer Tool Runtime Library "DNAS" package (Release 2.8.0 version)
 */
/*
 *                      Emotion Engine Library
 *                          Version 1.00
 *                           Shift-JIS
 *
 *      Copyright (C) 2000 Sony Computer Entertainment Inc.
 *                        All Rights Reserved.
 *
 *                       <libdnas2 - dnas2.h>
 *                          <DNAS header>
 *
 *       Version        Date            Design      Log
 *  --------------------------------------------------------------------
 *      1.00            May,10,2001     komaki      first version
 */

#ifndef _DNAS2_H_
#define _DNAS2_H_

#include "com_error.h"

#define INTERNET_MAX_DOWNLEN 32768

#if defined(__R5900__) || defined(__ee__)
#ifndef _eetypes_h_
#include <eetypes.h>
#endif
#else
#include <sys/types.h>
#endif

// f[^i[Ǘp\
typedef struct sceDNAS2Data {
	void *ptr;
	int size;
} sceDNAS2Data_t;

// DNASF؏\
typedef struct sceDNAS2TitleAuthInfo {
	int line_type;
	sceDNAS2Data_t pass_phrase;
	sceDNAS2Data_t auth_data;
} sceDNAS2TitleAuthInfo_t;

// DNASptǗ̍\
typedef struct sceDNAS2LastDate {
	u_char year;
	u_char month;
	u_char date;
	u_char hour;
	u_char min;
	u_char sec;
} sceDNAS2LastDate_t;

// _E[hT[rXŎgp\
typedef struct sceDNAS2DownData {
	int IDslot;
	sceDNAS2LastDate_t lastdate;
	void *ptr;
	int *sizep;
} sceDNAS2DownData_t;

// j[NIDl鎞Ɏgp\
typedef struct sceDNAS2UniqueID {
	unsigned int category;
	void *ptr;
	int *sizep;
	int result;
} sceDNAS2UniqueID_t;

// R[hf[^T[rXŎgp\
#define RECORDDATA_LEN 128
typedef struct sceDNAS2RecordData {
	char data[RECORDDATA_LEN];
} sceDNAS2RecordData_t;

// DNASԂi[邽߂̍\
typedef struct sceDNAS2Status {
	int code;
	int sub_code;
	int progress;
	void *optional;
} sceDNAS2Status_t;

// ^CAEgi[邽߂̍\
typedef struct sceDNAS2Timeout_info {
	int timeout;
	int priority;
} sceDNAS2TimeoutInfo_t;

// lbg[NڑC^Cv
#define sceDNAS2_T_INET		1

// sceDNAS2Init()̕Ԃl
#define sceDNAS2_MALLOC_FAILED		-1
#define sceDNAS2_MEMALIGN_FAILED	-2
#define sceDNAS2_NOT_SHUTDOWNED 	-7
#define sceDNAS2_INVALID_NG_TYPE 	-9
#define sceDNAS2_INVALID_TIMEOUT	-10

// sceDNAS2Auth[Install(), DataDownload(), DataDownload2(), GetUniqueID()]
// sceDNAS2Auth[NetStart(), RecordData()] ̕Ԃl
#define sceDNAS2_NOT_READY			-3
// sceDNAS2Auth[Install(), DataDownload(), DataDownload2(), GetUniqueID()]
// sceDNAS2[Abort(), GetStatus(), SetProxy(), GetProxy()]
// sceDNAS2Auth[NetStart(), RecordData()] ̕Ԃl
#define sceDNAS2_NOT_INITIALIZED 	-8
// sceDNAS2AuthData[Download(), Download2()]̕Ԃl
#define sceDNAS2_INVALID_IDSLOT		-4
#define sceDNAS2_INVALID_SIZE		-5
// sceDNAS2Abort()̕Ԃl
#define sceDNAS2_NOT_IN_COMM        -6

// sceDNAS2GetStatus()̕Ԃl
#define sceDNAS2_OK           0  // I
#define sceDNAS2_NG           -1 // ُI

// sceDNAS2Status_tcodeoɐݒ肳B
#define sceDNAS2_S_DORMANT    1  // 
#define sceDNAS2_S_INIT       2  // Ϗ
#define sceDNAS2_S_INST       3  // F؏
#define sceDNAS2_S_DATA       4  // f[^
#define sceDNAS2_S_END        5  // I
#define sceDNAS2_S_NG         6  // ُI
#define sceDNAS2_S_COM_ERROR  7  // ʐMG[
#define sceDNAS2_S_DATA_DONE  8  // f[^(㑱)I
#define sceDNAS2_S_GETID      9  // j[NID擾
#define sceDNAS2_S_RECORDDATA 10  // f[^R[h
#define sceDNAS2_S_NETSTART   11 // C^[tFCXAbvFؒ

// sceDNAS2Status_tprogressoɐݒ肳
#define sceDNAS2_P_NOPROGRESS          0 // 
#define sceDNAS2_P_CONNECT             1 // ڑ
#define sceDNAS2_P_AUTH                2 // Fؒ
#define sceDNAS2_P_AUTH_DONE           3 // F؏
#define sceDNAS2_P_RECORDDATA          4 // f[^R[h
#define sceDNAS2_P_DOWN                5 // f[^_E[h
#define sceDNAS2_P_DOWN_DONE           7 // f[^_E[h
#define sceDNAS2_P_ID                  8 // j[NID擾

// sceDNAS2UniqueID_t  resultoɐݒ肳
#define sceDNAS2_UNIQUE_R_FIRST             1 // ŏUniqueID擾
#define sceDNAS2_UNIQUE_R_EXIST             2 // 2ڈȍ~UniqueID擾

//
// DNAST[rXɐI(code=sceDNAS2_S_END̏ꍇ)
//
// sub_code̊etB[hl𓾂邽߂̃}N
#define sceDNAS2Status_SubCode_TYPE(status) \
           (status.sub_code & 0x7f000000) >> 24
#define sceDNAS2Status_SubCode_INST_RESULT(status) \
           (status.sub_code & 0x0000000c) >> 2

// sub_code
#define sceDNAS2_SS_NOSUBCODE          0 // 

// sub_codetypetB[hɐݒ肳l
#define sceDNAS2_SS_INST_OK            1 // CXg[\ 
#define sceDNAS2_SS_RECORDDATA_OK      2 // f[^R[h
#define sceDNAS2_SS_DOWNLOAD_OK        3 // _E[h
#define sceDNAS2_SS_GETID_OK           4 // j[NID擾
#define sceDNAS2_SS_DRDATA_OK          5 // DRDATA擾

// sub_codeinst_resulttB[hɐݒ肳l
#define sceDNAS2_SC_InstResult_EXIST       0
#define sceDNAS2_SC_InstResult_OK          1


//
// DNAST[rXɊւăG[(code=sceDNAS2_S_NG)
//     error_codetB[h̐ݒ肳l
//
// INST, DONWLOAD, IDʂŐݒ肳G[l
#define sceDNAS2_SS_SERVER_BUSY        -101 // T[o󂯕tȂ
#define sceDNAS2_SS_BEFORE_SERVICE     -102 // ^Cg̔F؃T[rXJnO
#define sceDNAS2_SS_OUT_OF_SERVICE     -103 // ^Cg̔F؃T[rXI
#define sceDNAS2_SS_END_OF_SERVICE     -104 // DNAST[õT[rXI
#define sceDNAS2_SS_SESSION_TIME_OUT   -105 // ZbV^CAEg
#define sceDNAS2_SS_INVALID_SERVER     -106 // sȃT[oƐڑĂ
#define sceDNAS2_SS_INTERNAL_ERROR     -107 // DNASCuł̃G[
#define sceDNAS2_SS_EXTERNAL_ERROR     -108 // ̑DNAST[oł̃G[


// DOWNLOADT[rXŐݒ肳G[l
#define sceDNAS2_SS_DL_NODATA          -201 // _E[hf[^
#define sceDNAS2_SS_DL_BEFORE_SERVICE  -202 // f[^T[rXJnO
#define sceDNAS2_SS_DL_OUT_OF_SERVICE  -203 // f[^T[rXI
#define sceDNAS2_SS_DL_NOT_UPDATED     -204 // Vf[^

// NCAg[JŐݒ肳G[l
#define sceDNAS2_SS_INVALID_PS2         -401 // PS2̋@ɃANZXs
#define sceDNAS2_SS_INVALID_MEDIA       -402 // fBAANZXɎs
#define sceDNAS2_SS_INVALID_AUTHDATA    -403 // auth_dataُ
#define sceDNAS2_SS_INVALID_HDD_BINDING -404 // HDDbindꂽPS2ł͂Ȃ

// j[NIDT[rXŐݒ肳G[l
#define sceDNAS2_SS_ID_NOUSE           -701 // IDsT[rXo^ĂȂ
#define sceDNAS2_SS_ID_NOT_JOIN_TO_CAT -703 // ^CgJeSɎQĂȂ


//
// ʐMnG[(code=sceDNAS2_S_COM_ERROR)
//     error_codetB[hɐݒ肳l
//
// i-modeʐMG[: -1`-99 (netglue_imode.hQ)
// InternetʐMG[: -500(netglue_net.hQ)
// \G[̈: -600


//
// ̑̃G[(mNGG[)
//
// -800`  unknown NG pɗ\


#ifdef __cplusplus
extern "C" {
#endif

int sceDNAS2Init(sceDNAS2TitleAuthInfo_t *auth_info, int priority, int debug_flag, int ng_type, sceDNAS2TimeoutInfo_t *timeout_info);
int sceDNAS2InitNoHDD(sceDNAS2TitleAuthInfo_t *auth_info, int priority, int debug_flag, int ng_type, sceDNAS2TimeoutInfo_t *timeout_info);
int sceDNAS2Shutdown(void);
int sceDNAS2AuthInstall(void);
int sceDNAS2AuthDataDownload(sceDNAS2DownData_t *data);
int sceDNAS2AuthDataDownload2(sceDNAS2DownData_t *data, int fin);
int sceDNAS2AuthGetUniqueID(sceDNAS2UniqueID_t *data);
int sceDNAS2AuthNetStart(void);
int sceDNAS2GetStatus(sceDNAS2Status_t *status);
int sceDNAS2Abort(void);

/* system reserved */
int sceDNAS2AuthRecordData(sceDNAS2RecordData_t *data);

int sceDNAS2SetProxy(int activate_flag, const char *new_proxy_host, u_short new_proxy_port);
int sceDNAS2GetProxy(int *activate_flag, char *proxy_host, int len, u_short *proxy_port);

/* erx */
void *sceDNAS2NetGetErxEntries(void);

#ifdef __cplusplus
}
#endif

#endif /* _DNAS2_H_ */

