//////////////////////////////////////////////////////////////////////////////
//
// Axon_Project_Behaviour.h
//
// Copyright (c) 2006 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef AXON_PROJECT_BEHAVIOUR_H___
#define AXON_PROJECT_BEHAVIOUR_H___ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "Core/Asura_Maths.h"
#include "Behaviour/Axon_Behaviour.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class Asura_Message;
class AVP_ServerEntity_Actor;
class Axon_Project_Brain;

//////////////////////////////////////////////////////////////////////////////
//
// Axon_Project_Behaviour
//
//////////////////////////////////////////////////////////////////////////////

class Axon_Project_Behaviour : public Axon_Behaviour
{
    typedef Axon_Behaviour PARENT;

public:
    Axon_Project_Behaviour( Axon_Project_Brain* pxBrain, const u_int uType );

	void SetParentBehaviour(Axon_Project_Behaviour* pxBehaviour) {m_pxParentBehaviour = pxBehaviour;}

#ifndef ASURA_NO_DEBUG_OUTPUT
	bool DoVerify();
#endif

	Axon_Project_Brain* GetProjectBrain() const;

protected:
	// Timer & state functions
	void SetCurrentState( int iNextState ) { m_iCurrentState = iNextState; ResetStateTimer(); }
	int  GetCurrentState() const { return m_iCurrentState; }

	void  UpdateStateTimer( const float fTimeslice ) { m_fStateTimer += fTimeslice; }
	void  ResetStateTimer() { m_fStateTimer = 0.0f; } // State timer is reset when switching state with SetCurrentState(), so ideally you don't have to call this ever
	float GetStateTimer() const { return m_fStateTimer; }

#ifndef ASURA_NO_DEBUG_OUTPUT
	virtual bool Verify() { return true; }
#endif

private:
    Axon_Project_Behaviour*	m_pxParentBehaviour;

	// Added this here since most of our behaviours have a state machine anyway, might as well be in one place (AN 27/09/07)
	int		m_iCurrentState;
	float	m_fStateTimer;
};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif // #ifndef AXON_PROJECT_BEHAVIOUR_H___
