//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_AVP3Alien_Flee.h
//
// Copyright (C) 2007 Rebellion. All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////
#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif
#ifndef __AVP_BEHAVIOUR_AVP3ALIEN_FLEE_H__
#define __AVP_BEHAVIOUR_AVP3ALIEN_FLEE_H__ 1
// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////
#include "Behaviour/Axon_Project_Behaviour.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////
class Axon_Project_Brain;

//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_AVP3Alien_Flee
//
// Run away from our Attacker
//
//////////////////////////////////////////////////////////////////////////////
class AVP_Behaviour_AVP3Alien_Flee : public Axon_Project_Behaviour
{
	typedef Axon_Project_Behaviour PARENT;

public:
	
	AVP_Behaviour_AVP3Alien_Flee(Axon_Project_Brain* pxBrain);

	virtual void Deactivate();
	virtual void Update(const float fTimeslice);

#ifndef ASURA_NO_DEBUG_OUTPUT
	virtual void RenderDebugInfo();
#endif

private:

	enum State
	{
		WAITING,
		FLEE,
		REMOVE_FROM_WORLD,
		WAIT_TO_RETURN
	};

	void SwitchToState(const State eNextState);

	Asura_Vector_3 FindDespawnPosition();

private:

	State m_eCurrentState;
	float m_fTimeInState;
	float m_fWaitTime;
};
//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //__AVP_BEHAVIOUR_AVP3ALIEN_FLEE_H__
