//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_AVP3Alien_GetToMovingTarget.h
//
// Copyright (C) 2007 Rebellion. All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AVP_BEHAVIOUR_AVP3ALIEN_GETTOMOVINGTARGET_H__
#define __AVP_BEHAVIOUR_AVP3ALIEN_GETTOMOVINGTARGET_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "Behaviour/Axon_Project_Behaviour.h"
#include "Core/AVP_Navigation.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class Axon_Project_Brain;

//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_AVP3Alien_GetToMovingTarget
//
// Essentially a wrapper for GetToPosition that includes updating the destination
// if the target guid moves.
//
//////////////////////////////////////////////////////////////////////////////

class AVP_Behaviour_AVP3Alien_GetToMovingTarget : public Axon_Project_Behaviour
{
    typedef Axon_Project_Behaviour PARENT;

public:
    AVP_Behaviour_AVP3Alien_GetToMovingTarget( Axon_Project_Brain* pxBrain );

    virtual bool Activate();
    virtual void Deactivate();
    virtual void PerFrameUpdate( const float fTimeslice );

    bool SetTargetGuid( const Asura_Guid uTargetGuid );
    void SetArrivalRange( const float fArrivalRange );
    // The range, in metres, that the target can move before the route will be recomputed.
    void SetTolerance( const float fTolerance ) { m_fToleranceSq = fTolerance * fTolerance; }

private:
    Asura_Guid m_uTargetGuid;
    float      m_fToleranceSq;
};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //__AVP_BEHAVIOUR_AVP3ALIEN_GETTOMOVINGTARGET_H__
