//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_Alien_Ambush.h
//
// Copyright (C) 2008 Rebellion. All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AVP_BEHAVIOUR_ALIEN_AMBUSH_H__
#define __AVP_BEHAVIOUR_ALIEN_AMBUSH_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// asura
#include "Core/Asura_LinkList.h"
#include "Network/Asura_Guid.h"

// axon
#include "Behaviour/Axon_Project_Behaviour.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class Asura_Message;
class AVP_Brain_Actor_Alien;
struct AVP_AlienTeam_Knowledge;

//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_Alien_Ambush
//
//////////////////////////////////////////////////////////////////////////////

class AVP_Behaviour_Alien_Ambush : public Axon_Project_Behaviour
{
	typedef Axon_Project_Behaviour PARENT;

public:
	AVP_Behaviour_Alien_Ambush( AVP_Brain_Actor_Alien* pxBrain );

protected:
	virtual bool Activate();
	virtual void Deactivate();
	virtual void PerFrameUpdate( const float fTimeslice );
	virtual bool HandleMessage( const Asura_Message* pxMessage );

#ifndef ASURA_NO_DEBUG_OUTPUT
	virtual void RenderDebugInfo();
#endif

private:
	enum State
	{
		UNSET,
		AMBUSH,
		PREATTACK,
		HISS,
		ATTACK,
		FINISHED
	};


	AVP_Brain_Actor_Alien* GetAlienBrain() const;
	void SwitchToState( const State eState );

	void UpdateAmbush();
	void UpdatePreAttack();
	void UpdateHiss();
	void UpdateAttack();
	void RequestHiss();
	void LateHandleMessage();	

	bool TookDamage();

private:
	float m_fLastHealth;
	Asura_Guid m_uSeenTarget;
	Asura_LinkList< int > m_xDelayedMsgList;
};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //__AVP_BEHAVIOUR_ALIEN_AMBUSH_H__

