//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_Alien_CycleRoundImmediate.h
//
// Copyright (C) 2008 Rebellion. All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AVP_BEHAVIOUR_ALIEN_CYCLEROUNDIMMEDIATE_H__
#define __AVP_BEHAVIOUR_ALIEN_CYCLEROUNDIMMEDIATE_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// asura
#include "Network/Asura_Guid.h"

// axon
#include "Behaviour/Axon_Project_Behaviour.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class AVP_Brain_Actor_Alien;

//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_Alien_CycleRoundImmediate
//
//////////////////////////////////////////////////////////////////////////////

class AVP_Behaviour_Alien_CycleRoundImmediate : public Axon_Project_Behaviour
{
	typedef Axon_Project_Behaviour PARENT;

public:
	AVP_Behaviour_Alien_CycleRoundImmediate( Axon_Project_Brain* pxBrain );

protected:
	virtual bool Activate();
	virtual void Deactivate();
	virtual void PerFrameUpdate( const float fTimeslice );

#ifndef ASURA_NO_DEBUG_OUTPUT
	virtual void RenderDebugInfo();
#endif

private:
	AVP_Brain_Actor_Alien* GetAlienBrain() const;

private:
	void SwitchToState( int iState );

	enum State
	{
		UNSET,
		TURNING,
		FINISHED
	};

	Asura_Vector_3 m_xThreatPositionAtPathStart;

#ifndef ASURA_NO_DEBUG_OUTPUT
	static const char* s_aszStateStrings[];
#endif
};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //__AVP_BEHAVIOUR_ALIEN_CYCLEROUNDIMMEDIATE_H__
