//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_Alien_Injured.h
//
// Copyright (C) 2008 Rebellion. All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AVP_BEHAVIOUR_ALIEN_INJURED_H__
#define __AVP_BEHAVIOUR_ALIEN_INJURED_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// asura
#include "Network/Asura_Guid.h"

// axon
#include "Behaviour/Axon_Project_Behaviour.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class Asura_Message;
class AVP_Brain_Actor_Alien;
struct AVP_AlienTeam_Knowledge;
//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_Alien_Injured
//
//////////////////////////////////////////////////////////////////////////////

class AVP_Behaviour_Alien_Injured : public Axon_Project_Behaviour
{
	typedef Axon_Project_Behaviour PARENT;

public:
	AVP_Behaviour_Alien_Injured( AVP_Brain_Actor_Alien* pxBrain );

protected:
	virtual bool Activate();
	virtual void Deactivate();
	virtual void Update( const float fTimeslice );
	virtual bool HandleMessage( const Asura_Message* pxMessage );

#ifndef ASURA_NO_DEBUG_OUTPUT
	virtual void RenderDebugInfo();
#endif

private:
	enum State
	{
		UNSET,
		START,
		CRAWLING_ABOUT,
		CRAWLING_IN,
		//PLAYING_DEAD,  // maybe - or would it just be annoying?
		ANKLE_BITING,
		FINISHED,
		NUM_STATES
	};

	AVP_Brain_Actor_Alien* GetAlienBrain() const;
	void SwitchToState( const State eState, Asura_Guid uGuid = ASURA_GUID_UNREGISTERED );

	bool ShouldAttack(const AVP_AlienTeam_Knowledge* pxTargetKnowledge) const;

private:
	float m_fBehaviourTimer;
	bool m_bBeingMeleed;
};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //__AVP_BEHAVIOUR_ALIEN_INJURED_H__
