//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_Alien_Wander.h
//
// Copyright (C) 2007 Rebellion. All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AVP_BEHAVIOUR_ALIEN_WANDER_H__
#define __AVP_BEHAVIOUR_ALIEN_WANDER_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// axon
#include "Behaviour/Axon_Project_Behaviour.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class AVP_Brain_Actor_Alien;

//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_Alien_Wander
//
//////////////////////////////////////////////////////////////////////////////

class AVP_Behaviour_Alien_Wander : public Axon_Project_Behaviour
{
    typedef Axon_Project_Behaviour PARENT;

public:
    AVP_Behaviour_Alien_Wander( AVP_Brain_Actor_Alien* pxBrain );

protected:
    virtual void Deactivate();
    virtual void Update( const float fTimeslice );

#ifndef ASURA_NO_DEBUG_OUTPUT
    virtual void RenderDebugInfo();
#endif

private:
    enum State
    {
		UNSET,
        WAITING,
        WANDERING
    };
    void SwitchToState( const State eNextState );
	void PlanPath();

    AVP_Brain_Actor_Alien* GetAlienBrain() const;

private:
	Asura_Vector_3 m_xStartPosition;
	u_short m_usStartWPID;
	float m_fTimeToWait;
};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //__AVP_BEHAVIOUR_ALIEN_WANDER_H__
