///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_Behaviour_AlienQueen_ForcedRoar.h
// Author : Callum Hope
// Date   : 31/3/09
//
// Copyright (C) 2009 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AVP_Behaviour_AlienQueen_ForcedRoar_H__
#define __AVP_Behaviour_AlienQueen_ForcedRoar_H__ 1

// I N C L U D E S ///////////////////////////////////////////////////////////

// axon
#include "Behaviour/Axon_Project_Behaviour.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class AVP_Brain_Actor_AlienQueen;

// C L A S S /////////////////////////////////////////////////////////////////

class AVP_Behaviour_AlienQueen_ForcedRoar : public Axon_Project_Behaviour
{
public:

	AVP_Behaviour_AlienQueen_ForcedRoar( AVP_Brain_Actor_AlienQueen* pxBrain );
	virtual bool HandleMessage( const Asura_Message* pxMessage );

	void SetTargetOfRoarGuid( Asura_Guid uTargetGuid ) { m_uTargetGuid = uTargetGuid; }

protected:
	virtual void Deactivate();
	virtual void Update( const float fTimeslice );

#ifndef ASURA_NO_DEBUG_OUTPUT
	virtual void RenderDebugInfo();
#endif

private:
	enum State
	{
		INIT,
		MOVE_TO_POSITION,
		REQUEST_ROAR,
		STARTED_ROAR,
		FINISHED
	};

	void SwitchToState( const State eNextState );
	void RequestStaticRoarMove();
	bool FindNewDestinationAndPath();

	AVP_Brain_Actor_AlienQueen* GetAlienQueenBrain() const;

	State			m_eCurrentState;
	float			m_fTimeInState;
	Asura_Guid		m_uTargetGuid;
	Asura_Vector_3	m_xLastUpdatePosition;

	typedef Axon_Project_Behaviour PARENT;

};

//////////////////////////////////////////////////////////////////////////////

#endif 