///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_Behaviour_AlienQueen_Wander.h
// Author : David Wooldridge
// Date   : 13/11/2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AVP_BEHAVIOUR_ALIENQUEEN_WANDER_H__
#define __AVP_BEHAVIOUR_ALIENQUEEN_WANDER_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// axon
#include "Behaviour/Axon_Project_Behaviour.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class AVP_Brain_Actor_AlienQueen;


class AVP_Behaviour_AlienQueen_Wander : public Axon_Project_Behaviour
{
	typedef Axon_Project_Behaviour PARENT;

public:

	AVP_Behaviour_AlienQueen_Wander( AVP_Brain_Actor_AlienQueen* pxBrain );

	void SetCenterPoint(const Asura_Vector_3& xCenter);

protected:
	virtual void Deactivate();
	virtual void Update( const float fTimeslice );

#ifndef ASURA_NO_DEBUG_OUTPUT
	virtual void RenderDebugInfo();
#endif

	

private:
	enum State
	{
		GETTING_TO_POSITION,
		WAIT
	};

	void SwitchToState( const State eNextState );

	AVP_Brain_Actor_AlienQueen* GetAlienQueenBrain() const;

private:

	u_short FindNextRandomWaypoint(u_short usCurrenWaypoint) const;

	State m_eCurrentState;
	float m_fTimeInState;
	u_short m_usCenterWaypoint;
	bool m_bIsCenterValid;

};

#endif 