//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_Dropship.h
//
// Copyright (C) 2007 Rebellion. All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AVP_BEHAVIOUR_DROPSHIP_H__
#define __AVP_BEHAVIOUR_DROPSHIP_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// asura
#include "Core/Asura_LinkList.h"

// avp axon
#include "Behaviour/Axon_Project_Behaviour.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class AVP_Brain_Actor_Dropship;
class AVP_ServerNode_VantagePoint_Dropship;

//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_Dropship
//
//////////////////////////////////////////////////////////////////////////////

class AVP_Behaviour_Dropship : public Axon_Project_Behaviour
{
    typedef Axon_Project_Behaviour PARENT;

public:
    AVP_Behaviour_Dropship( AVP_Brain_Actor_Dropship* pxBrain );

protected:
    virtual void Deactivate();
    virtual void PerFrameUpdate( const float fTimeslice );

#ifndef ASURA_NO_DEBUG_OUTPUT
    virtual void RenderDebugInfo();
#endif

    AVP_Brain_Actor_Dropship* GetDropshipBrain() const;

private:

	Asura_Guid GetTarget() const;
	
    enum State
    {
        UNSET,
		FLY_AROUND,
		FLY_AROUND_AIM_AT_TARGET,
		STOP_TO_FIRE,
		FIRE,
		OPEN_FRONT_PODS,
		OPEN_BACK_PODS,
        NUM_STATES
    };

    void SwitchToState( const State eNextState );

	State m_eCurrentState;
    float m_fTimeInState;


	bool m_bWasFired;
	bool m_bWantToFire;

	enum MissileFireState
	{
		MFS_DEACTIVATED,
		MFS_USE_FRONT_MISSILES,
		MFS_USE_BACK_MISSILES
	} m_eMissileFireState;

};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //__AVP_BEHAVIOUR_DROPSHIP_H__
