//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_FaceHugger.h
//
// Copyright (C) 2008 Rebellion. All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AVP_BEHAVIOUR_FACEHUGGER_H__
#define __AVP_BEHAVIOUR_FACEHUGGER_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "Behaviour/Axon_Project_Behaviour.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class AVP_Brain_Actor_FaceHugger;
class AVP_Behaviour_FaceHugger_MoveToPrey;

//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_FaceHugger
//
//////////////////////////////////////////////////////////////////////////////

class AVP_Behaviour_FaceHugger : public Axon_Project_Behaviour
{
	typedef Axon_Project_Behaviour PARENT;

public:
	AVP_Behaviour_FaceHugger( AVP_Brain_Actor_FaceHugger* pxBrain );
	~AVP_Behaviour_FaceHugger();

protected:
	virtual void Deactivate();
	virtual void Update( const float fTimeslice );

#ifndef ASURA_NO_DEBUG_OUTPUT
	virtual void RenderDebugInfo();
#endif

private:

	bool ShouldAttack(const AVP_Behaviour_FaceHugger_MoveToPrey* pxBehaviour) const;

	enum State
	{
		UNSET,
		PET,
		ATTACK,
		HIDE_IN_SHADOWS
	};

	void SwitchToState( const State eNextState );

	bool SwitchToStateFromBehaviourData();

	AVP_Brain_Actor_FaceHugger* GetFaceHuggerBrain() const;

private:

	bool FarFromSpawn();

	State m_eCurrentState;
	float m_fTimeInState;
};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //__AVP_BEHAVIOUR_FACEHUGGER_H__
