//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_FaceHugger_Attack.h
//
// Copyright (C) 2007 Rebellion. All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AVP_BEHAVIOUR_FACEHUGGER_ATTACK_H__
#define __AVP_BEHAVIOUR_FACEHUGGER_ATTACK_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// axon
#include "Behaviour/Axon_Project_Behaviour.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class AVP_Brain_Actor_FaceHugger;
class AVP_Behaviour_FaceHugger_MoveToPrey;

//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_FaceHugger_Attack
//
//////////////////////////////////////////////////////////////////////////////

class AVP_Behaviour_FaceHugger_Attack : public Axon_Project_Behaviour
{
	typedef Axon_Project_Behaviour PARENT;

public:
	AVP_Behaviour_FaceHugger_Attack( AVP_Brain_Actor_FaceHugger* pxBrain );
	virtual ~AVP_Behaviour_FaceHugger_Attack();

	void AllowAttackFromBehind();

protected:
	virtual void Deactivate();
	virtual void PerFrameUpdate( const float fTimeslice );
	virtual void Update( const float fTimeslice );

#ifndef ASURA_NO_DEBUG_OUTPUT
	virtual void RenderDebugInfo();
#endif

private:
	enum State
	{
		UNSET,
		IDLE,
		WANDER,
		MOVE_TO_PREY,
		RETURN_HOME,
		ATTACKING,
	};

	void SwitchToState( const State eNextState );

	AVP_Brain_Actor_FaceHugger* GetFaceHuggerBrain() const;

	State m_eCurrentState;
	float m_fTimeInState;
	float m_fTimeSinceLastFindTarget;
	float m_fInsertTimer;
	float m_fSinceWantingToAttack;


};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //__AVP_BEHAVIOUR_FACEHUGGER_ATTACK_H__
