//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_FaceHugger_AttackPrey.h
//
// Copyright (C) 2007 Rebellion. All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AVP_BEHAVIOUR_FACEHUGGER_ATTACKPREY_H__
#define __AVP_BEHAVIOUR_FACEHUGGER_ATTACKPREY_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// axon
#include "Behaviour/Axon_Project_Behaviour.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class AVP_Brain_Actor_FaceHugger;

//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_FaceHugger_AttackPrey
//
//////////////////////////////////////////////////////////////////////////////

class AVP_Behaviour_FaceHugger_AttackPrey : public Axon_Project_Behaviour
{
	typedef Axon_Project_Behaviour PARENT;

public:
	AVP_Behaviour_FaceHugger_AttackPrey( AVP_Brain_Actor_FaceHugger* pxBrain );
	virtual ~AVP_Behaviour_FaceHugger_AttackPrey();

	void AllowAttackPreyFromBehind();

protected:
	virtual void Deactivate();
	virtual void PerFrameUpdate( const float fTimeslice );

	virtual bool HandleMessage( const Asura_Message* pxMessage );

#ifndef ASURA_NO_DEBUG_OUTPUT
	virtual void RenderDebugInfo();
#endif

private:
	enum State
	{
		UNSET,
		RUNNING_IN,
		ATTACK_JUMP,
		FINISHED
	};
	void SwitchToState( const State eNextState );

	AVP_Brain_Actor_FaceHugger* GetFaceHuggerBrain() const;

	void InitiateMove();
	void UpdateMove(float fTimeslice);
	void RequestAttackPrey();

	State m_eCurrentState;
	float m_fTimeInState;
	float m_fInsertTimer;

	Asura_Vector_3 m_xDestination;
	float m_fArrivalRange;
	float m_fTimeInJumpRange;

	bool m_bTargetMarked;
	bool m_bAllowAttackPreyFromBehind;

};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //__AVP_BEHAVIOUR_FACEHUGGER_ATTACKPREY_H__
