//---------------------------------------------------------------------------
// File			: AVP_Behaviour_Civilian_alert.h
// Created		: 04 / 03 / 2008
// Created By	: Gareth Thomas
// Copyright (C) 2007 Rebellion. All Rights Reserved.
//---------------------------------------------------------------------------

// BEGIN FILE WRAPPER ///////////////////////////////////////
#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif
#ifndef __AVP_BEHAVIOUR_CIVILIAN_ALERT_H__
#define __AVP_BEHAVIOUR_CIVILIAN_ALERT_H__ 1
// END FILE WRAPPER ///////////////////////////////////////////

// INCLUDES ///////////////////////////////////////////////////////////
#include "Behaviour/Axon_Project_Behaviour.h"

// FORWARD DECLARATIONS ///////////////////////////////////
class AVP_Brain_Actor_Civilian;

//---------------------------------------------------------------------------
// Class		: AVP_Behaviour_Civilian_Alert
//---------------------------------------------------------------------------
class AVP_Behaviour_Civilian_Alert : public Axon_Project_Behaviour
{
	typedef Axon_Project_Behaviour PARENT;

public:

	// Alert Update State Enum
	enum AlertUpdateState
	{
		UNSET,
		MAKE_DECISION,
		TURN_TO_FACE,
		INVESTIGATE,
		FINISHED,
		MAX_STATES
	};

	// Construction / Deconstruction
	AVP_Behaviour_Civilian_Alert						(AVP_Brain_Actor_Civilian* pxBrain);
	virtual ~AVP_Behaviour_Civilian_Alert				(void){}

	// Public Member Virtual Functions...
	virtual bool 					Activate			(void);
	virtual void 					Deactivate			(void);
	virtual void					PerFrameUpdate		(const float fTimeslice);

#ifndef ASURA_NO_DEBUG_OUTPUT
	virtual void					RenderDebugInfo		(void);
#endif

	// Public Member Functions...
	AlertUpdateState				GetUpdateState		(void) const					{return m_eUpdateState;}
	AVP_Brain_Actor_Civilian*		GetCivilianBrain	(void)							{return m_pxCivilianBrain;}

protected:

	void							SetUpdateState			(AlertUpdateState eState)	{m_eUpdateState = eState;}
	void							CreateMovementBehaviour	(AVP_ServerEntity_Actor* pxAlertActor);
	void							CreateMovementBehaviour	( void );
	void							LookAtAlert				(AVP_ServerEntity_Actor* pxAlertActor);

private:

	// Private Member Variables...
	AlertUpdateState				m_eUpdateState;
	AVP_Brain_Actor_Civilian*		m_pxCivilianBrain;
	Asura_Guid						m_uAlertGuid;
	Asura_Vector_3					m_xAlertPosition;

	enum { CURRENT_CHUNK_VERSION = 0 };

};

#endif //__AVP_BEHAVIOUR_CIVILIAN_ALERT_H__

/// End Of File 'AVP_Behaviour_Civilian_Alert.h'
