//---------------------------------------------------------------------------
// File			: AVP_Behaviour_Civilian_Panic.h
// Created		: 04 / 03 / 2008
// Created By	: Gareth Thomas
// Copyright (C) 2007 Rebellion. All Rights Reserved.
//---------------------------------------------------------------------------

// BEGIN FILE WRAPPER ///////////////////////////////////////
#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif
#ifndef __AVP_BEHAVIOUR_CIVILIAN_PANIC_H__
#define __AVP_BEHAVIOUR_CIVILIAN_PANIC_H__ 1
// END FILE WRAPPER ///////////////////////////////////////////

// INCLUDES ///////////////////////////////////////////////////////////
#include "Behaviour/Axon_Project_Behaviour.h"

// FORWARD DECLARATIONS ///////////////////////////////////
class AVP_Brain_Actor_Civilian;

//---------------------------------------------------------------------------
// Class		: AVP_Behaviour_Civilian_Panic
//---------------------------------------------------------------------------
class AVP_Behaviour_Civilian_Panic : public Axon_Project_Behaviour
{
	typedef Axon_Project_Behaviour PARENT;

public:

	// Panic Update State Enum
	enum PanicUpdateState
	{
		UNSET,
		PANIC,
		ROOTED_TO_SPOT,
		FIND_FLEE_POINT,
		FLEEING,
		MOVE_AWAY,
		USE_FLEE_ACTION,
		MAX_STATES
	};

	// Construction / Deconstruction
	AVP_Behaviour_Civilian_Panic						(AVP_Brain_Actor_Civilian* pxBrain);
	virtual ~AVP_Behaviour_Civilian_Panic				(void){}

	// Public Member Virtual Functions...
	virtual bool 					Activate			(void);
	virtual void 					Deactivate			(void);
	virtual void					PerFrameUpdate		(const float fTimeslice);
	virtual bool					HandleMessage		( const Asura_Message* pxMessage );

#ifndef ASURA_NO_DEBUG_OUTPUT
	virtual void					RenderDebugInfo		(void);
#endif

	// Public Member Functions...
	PanicUpdateState				GetUpdateState		(void) const					{return m_eUpdateState;}
	AVP_Brain_Actor_Civilian*		GetCivilianBrain	(void)							{return m_pxCivilianBrain;}

protected:

	void							SetUpdateState			(PanicUpdateState eState)	{m_eUpdateState = eState;}
	void							CreateMovementBehaviour	(const Asura_Vector_3& xGoToPoint);

	void							ChooseAction( void );
	void							SwitchToState( PanicUpdateState eState );

	void							SendMountGamesceneMessage( void );
	Asura_Hash_ID					GetMountGamesceneAnimBlendTemplateBlueprintHash( void );

private:

	// Private Member Variables...
	PanicUpdateState				m_eUpdateState;
	AVP_Brain_Actor_Civilian*		m_pxCivilianBrain;
	Asura_Vector_3					m_xFleeDirection;
	Asura_Guid						m_uFleePoint;
	Asura_Guid						m_uGS2NodeGuid;

	enum { CURRENT_CHUNK_VERSION = 0 };

};

#endif //__AVP_BEHAVIOUR_CIVILIAN_PANIC_H__

/// End Of File 'AVP_Behaviour_Civilian_Panic.h'
