//---------------------------------------------------------------------------
// File			: AVP_Behaviour_Marine_Attack_Travelling.cpp
// Created		: 
// Created By	: Gareth Thomas
// Copyright (C) 2007 Rebellion. All Rights Reserved.
//---------------------------------------------------------------------------

// INCLUDES ///////////////////////////////////////////////////////////

// core
#include "Core/Asura.h"
// header
#include "Behaviour/BehaviourTypes/Human/Marine/AVP_Behaviour_Marine_Attack_Travelling.h"
// asura
#ifndef ASURA_NO_DEBUG_OUTPUT
#include "Rendering/Asura_Font_System.h"
#endif
// axon
// AVP
#include "Entity/PhysicalObject/Actor/Vertebrates/Human/AVP_ServerActor_Human.h"
// AVP axon
#include "Behaviour/BehaviourTypes/AVP_Behaviour_Types.h"
#include "Core/BrainTypes/AVP_Brain_Actor_Marine.h"

//---------------------------------------------------------------------------
// AVP_Behaviour_Marine_Attack_Travelling :: Constructor
//---------------------------------------------------------------------------
AVP_Behaviour_Marine_Attack_Travelling::AVP_Behaviour_Marine_Attack_Travelling( AVP_Brain_Actor_Marine* pxBrain )
: PARENT( pxBrain, AVP_BEHAVIOUR_TYPE_MARINE_ATTACK_TRAVELLING )
, m_pxMarineBrain( pxBrain )
, m_eUpdateState( UNSET )
{

}

//---------------------------------------------------------------------------
// AVP_Behaviour_Marine_Attack_Travelling :: Deconstructor
//---------------------------------------------------------------------------
AVP_Behaviour_Marine_Attack_Travelling::~AVP_Behaviour_Marine_Attack_Travelling( void )
{

}

//---------------------------------------------------------------------------
// AVP_Behaviour_Marine_Attack_Travelling :: Activate
//---------------------------------------------------------------------------
bool AVP_Behaviour_Marine_Attack_Travelling::Activate( void )
{
	const bool bParentOk = PARENT::Activate();
	// Put Code Below This Comment

	// Put Code Above This Comment
	return bParentOk;
}

//---------------------------------------------------------------------------
// AVP_Behaviour_Marine_Attack_Travelling :: Deactivate
//---------------------------------------------------------------------------
void AVP_Behaviour_Marine_Attack_Travelling::Deactivate( void )
{
	// Put Code Above This Comment
	DestroyAllChildren();
	PARENT::Deactivate();
}

//---------------------------------------------------------------------------
// AVP_Behaviour_Marine_Attack_Travelling :: PerFrameUpdate
//---------------------------------------------------------------------------
void AVP_Behaviour_Marine_Attack_Travelling::PerFrameUpdate( const float fTimeslice )
{
	GetMarineBrain()->AimAtThreat();
	GetMarineBrain()->LookAtThreat();

	switch (GetUpdateState())
	{
		case UNSET:
		default:
		{

		}
	}
}

//---------------------------------------------------------------------------
// AVP_Behaviour_Marine_Attack_Travelling :: SwitchToState
//---------------------------------------------------------------------------
void AVP_Behaviour_Marine_Attack_Travelling::SwitchToState( UpdateState eState )
{
	switch (GetUpdateState())
	{
		case UNSET:
		default:
		{

		}
	}

	SetUpdateState( eState );

	switch (GetUpdateState())
	{
		case UNSET:
		default:
		{

		}
	}
}

//---------------------------------------------------------------------------
// AVP_Behaviour_Marine_Attack_Travelling :: RenderDebugInfo
//---------------------------------------------------------------------------
#ifndef ASURA_NO_DEBUG_OUTPUT
static const char* s_aszStateStrings[ AVP_Behaviour_Marine_Attack_Travelling::MAX_STATES ] =
{
	"Attack_Travelling - UNSET",
};

void AVP_Behaviour_Marine_Attack_Travelling::RenderDebugInfo( void )
{
	PARENT::RenderDebugInfo();

	Asura_Font_System::Print
	(
		GetProjectBrain()->GetDebugOutputPos().x,
		GetProjectBrain()->GetDebugOutputPos().y,
		0.5f, 
		0XFFFFFFFF,
		ASURA_TEXTFORMAT_CENTREJUSTIFIED, 
		s_aszStateStrings[GetUpdateState()]
	);

	// Offset the debug output position for other behaviours to render there own text
	GetProjectBrain()->GetDebugOutputPos().y += 10.0f;
}
#endif

/// End Of File 'AVP_behaviour_Marine_Attack_Travelling.cpp'
