//---------------------------------------------------------------------------
// File			: AVP_Behaviour_Marine_Investigate.h
// Created		: 04 / 02 / 08
// Created By	: Gareth Thomas
// Copyright (C) 2007 Rebellion. All Rights Reserved.
//---------------------------------------------------------------------------

// BEGIN FILE WRAPPER ///////////////////////////////////////
#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif
#ifndef __AVP_BEHAVIOUR_MARINE_INVESTIGATE_H__
#define __AVP_BEHAVIOUR_MARINE_INVESTIGATE_H__ 1
// END FILE WRAPPER ///////////////////////////////////////////

// INCLUDES ///////////////////////////////////////////////////////////
#include "Behaviour/Axon_Project_Behaviour.h"

// FORWARD DECLARATIONS ///////////////////////////////////
class AVP_Brain_Actor_Marine;

//---------------------------------------------------------------------------
// Class		: AVP_Behaviour_Marine_Investigate
// Description	: 
//---------------------------------------------------------------------------
class AVP_Behaviour_Marine_Investigate : public Axon_Project_Behaviour
{
	typedef Axon_Project_Behaviour PARENT;

public:

	// InCover Update State Enum
	enum InvestigateUpdateState
	{
		UNSET,
		FIND_ROUTE_TO_ALERT,
		MOVE_TO_ALERT,
		INVESTIGATE,
		FIND_ROUTE_TO_SQUAD,
		MOVE_TO_SQUAD,
		ALERT,
		MAX_STATES
	};

	// Construction / Deconstruction
	AVP_Behaviour_Marine_Investigate							(AVP_Brain_Actor_Marine* pxBrain);
	virtual ~AVP_Behaviour_Marine_Investigate					(void)							{}

	static Asura_Guid GetInvestigatorGuid() { return s_uInvestigatorGuid; }

	// Public Member Virtual Functions...
	virtual bool 					Activate			(void);
	virtual void 					Deactivate			(void);
	virtual void 					Pause				(void);
	virtual void 					Unpause				(void);
	virtual void					PerFrameUpdate		(const float fTimeslice);

#ifndef ASURA_NO_DEBUG_OUTPUT
	virtual void					RenderDebugInfo		(void);
#endif

	// Public Member Functions...
	InvestigateUpdateState			GetUpdateState		(void) const					{return m_eUpdateState;}
	AVP_Brain_Actor_Marine*			GetMarineBrain		(void)							{return m_pxMarineBrain;}

protected:
	void							SetUpdateState		(InvestigateUpdateState eState)	{m_eUpdateState = eState;}

private:

	// Private Member Variables...
	InvestigateUpdateState			m_eUpdateState;
	AVP_Brain_Actor_Marine*			m_pxMarineBrain;
	Asura_Vector_3					m_xAlertPosition;
	float							m_fInvestigateTimer;
	Asura_Guid						m_uSquadGuid;
	Asura_Vector_3					m_xLookAt;
	bool							m_bGetNewLookAtPos;
	Asura_Guid						m_uOurActorGuid;
	float							m_fTimeInBehaviour;
	bool							m_bIsRecon;

	static Asura_Guid				s_uInvestigatorGuid;

	enum { CURRENT_CHUNK_VERSION = 0 };

};

#endif //__AVP_BEHAVIOUR_MARINE_INVESTIGATE_H__

/// End Of File 'AVP_Behaviour_Marine_Investigate.h'
