//---------------------------------------------------------------------------
// File			: AVP_Behaviour_Marine_MeleePlayer.h
// Created		: 
// Created By	: Gareth Thomas
// Copyright (C) 2007 Rebellion. All Rights Reserved.
//---------------------------------------------------------------------------

// BEGIN FILE WRAPPER ///////////////////////////////////////
#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif
#ifndef __AVP_BEHAVIOUR_MARINE_MELEEPLAYER_H__
#define __AVP_BEHAVIOUR_MARINE_MELEEPLAYER_H__ 1
// END FILE WRAPPER ///////////////////////////////////////////

// INCLUDES ///////////////////////////////////////////////////////////
#include "Behaviour/Axon_Project_Behaviour.h"


#include "Core/BrainTypes/AVP_Brain_Actor_Marine.h"

// FORWARD DECLARATIONS ///////////////////////////////////
class AVP_Tactical_System;
class AVP_Knowledge_System_Actor;
class AVP_ServerActor_Human;

//---------------------------------------------------------------------------
// Class		: AVP_Behaviour_Marine_MeleePlayer
// Description	: 
//---------------------------------------------------------------------------
class AVP_Behaviour_Marine_MeleePlayer : public Axon_Project_Behaviour
{
	typedef Axon_Project_Behaviour PARENT;

public:

	// InCover Update State Enum
	enum UpdateState
	{
		UNSET,
		MOVE_TO_PLAYER,
		TURN_TO_FACE,
		MELEE_REQUESTED,
		POST_ATTACK,
		MAX_STATES
	};

	// Construction / Deconstruction
	AVP_Behaviour_Marine_MeleePlayer( AVP_Brain_Actor_Marine* pxBrain );
	virtual ~AVP_Behaviour_Marine_MeleePlayer( void );

	// Public Member Virtual Functions...
	virtual bool 					Activate( void );
	virtual void 					Deactivate( void );
	virtual void					PerFrameUpdate( const float fTimeslice );
	virtual bool					HandleMessage(const Asura_Message* pxMessage);
	#ifndef ASURA_NO_DEBUG_OUTPUT
	virtual void					RenderDebugInfo( void );
	#endif

protected:

	// Public Member Data Access...
	UpdateState						GetUpdateState( void ) const			{ return m_eUpdateState; }
	AVP_Brain_Actor_Marine*			GetMarineBrain( void )					{ return m_pxMarineBrain; }
	AVP_Tactical_System*			GetTacticalSystem( void )				{ return m_pxMarineBrain->GetTacticalSystem(); }
	AVP_Knowledge_System_Actor*		GetKnowledgeSystem( void )				{ return m_pxMarineBrain->GetKnowledgeSystem(); }
	AVP_ServerActor_Human*			GetOurActor( void )						{ return m_pxMarineBrain->GetHumanActor(); }
	void							SetUpdateState( UpdateState eState )	{ m_eUpdateState = eState; }

	// Public Member Functions...
	void							SwitchToState( UpdateState eState );
	bool							IsInAttackRange( void );
	bool							IsLookingAtPlayer( void );
	void							LookAtPlayer( void );
	bool							IsPlayerToFarAwayFromOurDestination( void );


private:

	// Private Member Variables...
	UpdateState						m_eUpdateState;
	AVP_Brain_Actor_Marine*			m_pxMarineBrain;
	Asura_Guid						m_uPlayerGuid;
	bool							m_bMeleeRequested;
	float							m_fWaitTimer;
	bool							m_bFlinchFinished;

	enum { CURRENT_CHUNK_VERSION = 1 };
};

#endif //__AVP_BEHAVIOUR_MARINE_MELEEPLAYER_H__

/// End Of File 'AVP_Behaviour_Marine_MeleePlayer.h'
