//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_Predalien_GS2Move.h
//
// Copyright (C) 2007 Rebellion. All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AVP_BEHAVIOUR_PREDALIEN_GS2MOVE_H__
#define __AVP_BEHAVIOUR_PREDALIEN_GS2MOVE_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// avp axon
#include "Behaviour/Axon_Project_Behaviour.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class AVP_Brain_Actor_Predalien;
class AVP_ServerNode_VantagePoint_Predalien;

//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_Predalien_GS2Move
//
//////////////////////////////////////////////////////////////////////////////

class AVP_Behaviour_Predalien_GS2Move : public Axon_Project_Behaviour
{
    typedef Axon_Project_Behaviour PARENT;

public:
    AVP_Behaviour_Predalien_GS2Move( AVP_Brain_Actor_Predalien* pxBrain );
	bool GetToPosition( const Asura_Vector_3& xDestination );

protected:
	virtual bool Activate();
    virtual void Deactivate();
    virtual void Update( const float fTimeslice );

#ifndef ASURA_NO_DEBUG_OUTPUT
    virtual void RenderDebugInfo();
#endif

    AVP_Brain_Actor_Predalien* GetPredalienBrain() const;

private:
    enum State
    {
        UNSET,
		MOVE_TO_POSITION,
		FINISHED,
        NUM_STATES
    };

	void CalculateMove();
    void SwitchToState( const State eNextState );
private:
    State m_eCurrentState;
    float m_fTimeInState;
	float m_fArrivalRange;
	Asura_Vector_3 m_xDestination;
	bool m_bDestinationSet;
};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //__AVP_BEHAVIOUR_PREDALIEN_GS2MOVE_H__
