//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_Predator_AtVentagePoint.h
//
// Copyright (C) 2007 Rebellion. All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AVP_BEHAVIOUR_PREDATOR_AT_VENTAGE_POINT_H__
#define __AVP_BEHAVIOUR_PREDATOR_AT_VENTAGE_POINT_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// avp axon
#include "Behaviour/Axon_Project_Behaviour.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class AVP_Brain_Actor_Predator;
class AVP_ServerNode_VantagePoint_Predator;

//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_Predator_AtVentagePoint
//
//////////////////////////////////////////////////////////////////////////////

class AVP_Behaviour_Predator_AtVentagePoint : public Axon_Project_Behaviour
{
	typedef Axon_Project_Behaviour PARENT;

public:
	AVP_Behaviour_Predator_AtVentagePoint( AVP_Brain_Actor_Predator* pxBrain );
	void Abort() { m_bAbort = true; }

protected:
	virtual bool Activate();
	virtual void Deactivate();
	virtual void PerFrameUpdate( const float fTimeslice );
	virtual void Update( const float fTimeslice );

#ifndef ASURA_NO_DEBUG_OUTPUT
	virtual void RenderDebugInfo();
#endif

	AVP_Brain_Actor_Predator* GetPredatorBrain() const;

private:
	enum State
	{
		UNSET,
		IDLE,
		FIND_TARGET,
		ORIENT_TO_TARGET,
		DECLOAK,
		EQUIP_PLASMACASTER,
		AIM_NEAR_TARGET,
		AIM_AT_TARGET,
		REAQUIRE_TARGET,
		FIRE,
		WAIT_AFTER_ABORTED_FIRE,
		FINISHED,
		NUM_STATES
	};

	void SwitchToState( const State eNextState );

	void OrientToTarget();
	void AimNearTarget();
	void AimAtTarget();
	bool EstimateNewOrientation();

	void AimAt(const Asura_Vector_3 &xTarget);

	bool IsAtDesiredAim();

	bool Fire();

private:

	State m_eCurrentState;
	float m_fTimeInState;
	int m_iConsecutiveFire;
	int m_iConsecutiveFailedFireAttempts;
	bool m_bFireOccured;

	Asura_Vector_3 m_xStartTrackingPosition;
	Asura_Vector_3 m_xSelectedTargetPosition;

	Asura_Vector_3 m_xDeltaAimDirection;
	Asura_Vector_3 m_xDesiredAimDirection;
	Asura_Vector_3 m_xDesiredTargetPosition;
	bool m_bIsCharging;	
	bool m_bAbort;


};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //__AVP_BEHAVIOUR_PREDATOR_AT_VENTAGE_POINT_H__
