//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_Predator_Flee.h
//
// Copyright (C) 2007 Rebellion. All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AVP_BEHAVIOUR_PREDATOR_FLEE_H__
#define __AVP_BEHAVIOUR_PREDATOR_FLEE_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// avp axon
#include "Behaviour/Axon_Project_Behaviour.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class AVP_Brain_Actor_Predator;
class AVP_ServerNode_VantagePoint_Predator;

//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_Predator_Flee
//
//////////////////////////////////////////////////////////////////////////////

class AVP_Behaviour_Predator_Flee : public Axon_Project_Behaviour
{
	typedef Axon_Project_Behaviour PARENT;

public:
	AVP_Behaviour_Predator_Flee( AVP_Brain_Actor_Predator* pxBrain );

protected:
	virtual bool Activate();
	virtual void Deactivate();
	virtual void Update( const float fTimeslice );

#ifndef ASURA_NO_DEBUG_OUTPUT
	virtual void RenderDebugInfo();
#endif

	AVP_Brain_Actor_Predator* GetPredatorBrain() const;

private:
	enum State
	{
		UNSET,
		FLEE,
		FINISHED,
		NUM_STATES
	};

	void SwitchToState( const State eNextState );

	bool ShouldReplan();

private:
	bool FindHidingPlace();

	State m_eCurrentState;
	float m_fTimeInState;
	Asura_Vector_3 m_xDestination;


};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //__AVP_BEHAVIOUR_PREDATOR_FLEE_H__
