//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_Predator_Stalking.h
//
// Copyright (C) 2007 Rebellion. All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AVP_BEHAVIOUR_PREDATOR_STALKING_H__
#define __AVP_BEHAVIOUR_PREDATOR_STALKING_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// avp axon
#include "Behaviour/Axon_Project_Behaviour.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class AVP_Brain_Actor_Predator;
class AVP_ServerNode_VantagePoint_Predator;

//////////////////////////////////////////////////////////////////////////////
//
// AVP_Behaviour_Predator_Stalking
//
//////////////////////////////////////////////////////////////////////////////

class AVP_Behaviour_Predator_Stalking : public Axon_Project_Behaviour
{
	typedef Axon_Project_Behaviour PARENT;

public:
	AVP_Behaviour_Predator_Stalking( AVP_Brain_Actor_Predator* pxBrain );

	void Abort() { m_bAbort = true; }

protected:
	virtual bool Activate();
	virtual void Deactivate();
	virtual void Update( const float fTimeslice );

#ifndef ASURA_NO_DEBUG_OUTPUT
	virtual void RenderDebugInfo();
#endif

	AVP_Brain_Actor_Predator* GetPredatorBrain() const;

private:
	enum State
	{
		UNSET,
		SELECT_VENTAGE_POINT,
		MOVE_TO_VENTAGE_POINT,
		AT_VENTAGE_POINT,
		FINISHED,
		NUM_STATES
	};

	void SwitchToState( const State eNextState );

	float CalculateThreatsTotalHealth() const;

private:

	State m_eCurrentState;
	float m_fTimeInState;
	const AVP_ServerNode_VantagePoint_Predator* m_pxDestinationVP;
	const AVP_ServerNode_VantagePoint_Predator* m_pxCurrentVP;
	float m_fTotalEnemyHealth;
	bool m_bLastVPSearchWasFast;
	int m_iReselectVPCount;
	bool m_bAbort;


};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //__AVP_BEHAVIOUR_PREDATOR_STALKING_H__
