//////////////////////////////////////////////////////////////////////////////
//
// AVP_Brain_Squad_Marine.h
//
// Copyright (C) 2007 Rebellion. All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AVP_BRAIN_SQUAD_MARINE_H__
#define __AVP_BRAIN_SQUAD_MARINE_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// avp axon
#include "Core/BrainTypes/Axon_Project_Brain.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class AVP_ServerEntity_Squad_Marine;

//////////////////////////////////////////////////////////////////////////////
//
// AVP_Brain_Team_Marine
//
//////////////////////////////////////////////////////////////////////////////

class AVP_Brain_Squad_Marine : public Axon_Project_Brain
{
	typedef Axon_Project_Brain PARENT;

public:
	
	AVP_Brain_Squad_Marine(AVP_ServerEntity_Squad_Marine* pxMarineTeam);

	// Public Virtual Overridden Functions...
	virtual void ReadFromChunkStream( Asura_Chunk_Stream& xStream );
	virtual void WriteToChunkStream( Asura_Chunk_Stream& xStream ) const;
	virtual void DoPerFrameUpdate( const float fTimeslice );

	virtual Axon_Behaviour* CreateBehaviour( const u_int uBehaviourType, const Asura_Message* pxMessage = NULL ) { return NULL; }
	virtual void            DestroyBehaviour( Axon_Behaviour*& pxBehaviour ) {}

	// Public Functions
	u_int GetNumSquadThreats( void )				{ return m_uNumThreats; }
	u_int GetNumMembersWithAssaultWeapons( void )	{ return m_uNumAssaultWeapons; }
	u_int GetNumMembersWithSupportWeapons( void )	{ return m_uNumAssaultWeapons; }

	void AssignAssaulter( void );
	void DealocateAssaulter( void );
    static u_int GetLargestBehaviourSize( void );

protected:

	// Protected Functions...
	void UpdateNumSquadThreats( void );
	void UpdateOurFormation( void );

	// Protected Virtual Overridden Functions...
#ifndef ASURA_NO_DEBUG_OUTPUT
	virtual bool Verify();
#endif

	AVP_ServerEntity_Squad_Marine* GetMarineSquad( void ) const;
	AVP_ServerEntity_Squad_Marine* m_pxMarineSquad;

	u_int	m_uNumThreats;
	u_int	m_uNumAssaultWeapons;
	u_int	m_uNumSupportWeapons;
	u_int	m_uManuallyAssignedAssaulters;

private:
	enum {CURRENT_CHUNK_VERSION = 0};
};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //__AVP_BRAIN_SQUAD_MARINE_H__
