//////////////////////////////////////////////////////////////////////////////
//
// AVP_Brain_Team.cpp
//
// Copyright (C) 2007 Rebellion. All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// core
#include "Core/Asura.h"

// header
#include "Core/BrainTypes/AVP_Brain_Team.h"

// asura
#include "ChunkSystem/Asura_Chunk_Stream.h"

// avp
#include "Entity/Controller/AVP_ServerEntity_Team.h"

//////////////////////////////////////////////////////////////////////////////
//
// AVP_Brain_Team
//
//////////////////////////////////////////////////////////////////////////////

void AVP_Brain_Team::ReadFromChunkStream( Asura_Chunk_Stream& xStream )
{
    int iVersion;
    xStream >> iVersion;

    PARENT::ReadFromChunkStream( xStream );

    if ( iVersion == CURRENT_CHUNK_VERSION )
    {
    }
    else
    {
        Asura_Assertf( false, ( "AVP_Brain_Team::ReadFromChunkStream - unhandled chunk version (%d)", iVersion ) );
    }
}

void AVP_Brain_Team::WriteToChunkStream( Asura_Chunk_Stream& xStream ) const
{
    xStream << CURRENT_CHUNK_VERSION;

    PARENT::WriteToChunkStream( xStream );
}

AVP_Brain_Team::AVP_Brain_Team( AVP_ServerEntity_Team* pxTeam )
: PARENT( pxTeam->GetGuid() )
, m_pxTeam( pxTeam )
{
}

u_int AVP_Brain_Team::GetLargestBehaviourSize()
{
    return 0;
}

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////
