//////////////////////////////////////////////////////////////////////////////
//
// AVP_Knowledge_System.cpp
//
// Created by NJD - 06 December 2006
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// Core
#include "Core/Asura.h"

// This files header
#include "Knowledge/AVP_Knowledge_System.h"

// Asura
#include "ChunkSystem/Asura_Chunk_Stream.h"
#if defined( ASURA_SUPPORT_COMMAND_CONSOLE)
	#include "Interface/Asura_CommandConsole.h"
#endif
#include "Network/Asura_Message.h"

// Axon
#include "Core/BrainTypes/AVP_Brain_Team_Alien.h"
#include "Core/BrainTypes/Axon_Project_Brain.h"
#include "Knowledge/Axon_Knowledge.h"
#include "Knowledge/SenseTypes/AVP_Sense_Hearing_Actor.h"
#include "Knowledge/SenseTypes/AVP_Sense_Vision_Actor.h"

// AVP
#include "Entity/AVP_Entity_Classification.h"
#include "Entity/AVP_Messages.h"
#include "Entity/Controller/AVP_ServerEntity_Team_Alien.h"
#include "Entity/PhysicalObject/Actor/AVP_ServerEntity_Actor.h"
#include "Entity/PhysicalObject/Actor/Vertebrates/Human/AVP_ServerActor_Human.h"
#include "Tactical/AVP_Tactical_System.h"

//////////////////////////////////////////////////////////////////////////////
//
// AVP_Knowledge_System
//
//////////////////////////////////////////////////////////////////////////////

AVP_Knowledge_System::AVP_Knowledge_System( Axon_Project_Brain* pxBrain ) 
: m_pxBrain( pxBrain )
{
}

void AVP_Knowledge_System::ReadFromChunkStream( Asura_Chunk_Stream& xStream )
{
    int iVersion;
    xStream >> iVersion;

    PARENT::ReadFromChunkStream( xStream );

    if ( iVersion == CURRENT_CHUNK_VERSION )
    {
    }
    else
    {
        Asura_Assertf( iVersion == CURRENT_CHUNK_VERSION, ( "AVP_Knowledge_System::ReadFromChunkStream - unhandled chunk version (%d)", iVersion ) );
    }
}

void AVP_Knowledge_System::WriteToChunkStream( Asura_Chunk_Stream& xStream ) const
{
    xStream << CURRENT_CHUNK_VERSION;

    PARENT::WriteToChunkStream( xStream );
}

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////
