//////////////////////////////////////////////////////////////////////////////
//
// AVP_Knowledge_System_Sentrygun.h
//
// Copyright (C) 2007 Rebellion. All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AVP_KNOWLEDGE_SYSTEM_SENTRYGUN_H__
#define __AVP_KNOWLEDGE_SYSTEM_SENTRYGUN_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "Core/BrainTypes/AVP_Brain_Actor_Sentrygun.h"
#include "Knowledge/AVP_Knowledge_System.h"
#include "Knowledge/SenseTypes/AVP_Sense_Vision_Sentrygun.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class AVP_Brain_Actor;

class AVP_Knowledge_System_Sentrygun : public AVP_Knowledge_System
{
public:
	AVP_Knowledge_System_Sentrygun( AVP_Brain_Actor* pxBrain );
	~AVP_Knowledge_System_Sentrygun();

	virtual void ReadFromChunkStream( Asura_Chunk_Stream& xStream );
	virtual void WriteToChunkStream( Asura_Chunk_Stream& xStream ) const;
	virtual void Update( const float fTimeslice );
	virtual void Initialise( void );
#ifndef ASURA_NO_DEBUG_OUTPUT
	virtual bool Verify();
#endif

	virtual Axon_Sense_Vision*  CreateVisionSense() { return new AVP_Sense_Vision_Sentrygun( this ); }
	virtual Axon_Sense_Hearing* CreateHearingSense() { return NULL; }
	virtual Axon_Sense_Touch*   CreateTouchSense() { return NULL; }

	const Axon_Knowledge&		GetBestThreatKnowledge() const { return m_xBestThreatKnowledge; }

	void SetVisionFOV( const float fRange, const float fTanHorHalfFOV, const float fTanVertUpHalfFOV, const float fTanVertDownHalfFOV ) {	if ( m_pxVision ) { static_cast< AVP_Sense_Vision_Sentrygun* > ( m_pxVision )->SetVisionFOV( fRange, fTanHorHalfFOV, fTanVertUpHalfFOV, fTanVertDownHalfFOV ); } }
	void SetVisionFireArc( const float fTanHorHalfFireArc ) {	if ( m_pxVision ) { static_cast< AVP_Sense_Vision_Sentrygun* > ( m_pxVision )->SetVisionFireArc( fTanHorHalfFireArc ); } }
	
	AVP_Brain_Actor* GetActorBrain() const { return static_cast< AVP_Brain_Actor* >( GetBrain() ); }

protected:
	void UpdateBestThreatKnowledge( const float fTimeslice );

	Axon_Knowledge     m_xBestThreatKnowledge;

private:
	typedef AVP_Knowledge_System PARENT;

};

#endif //__AVP_KNOWLEDGE_SYSTEM_SENTRYGUN_H__
