//////////////////////////////////////////////////////////////////////////////
// AVP_Sense_MotionTracker.h
// Created by GBT - 10 February 2009
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AVP_SENSE_MOTIONTRACKER_H__
#define __AVP_SENSE_MOTIONTRACKER_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// Axon
#include "Knowledge/SenseTypes/Axon_Sense_Vision.h"

// AVP
#include "Entity/PhysicalObject/Actor/AVP_ServerEntity_Actor.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class AVP_Knowledge_System_Actor;

//////////////////////////////////////////////////////////////////////////////
//
// AVP_Sense_Vision
//
//////////////////////////////////////////////////////////////////////////////

class AVP_Sense_MotionTracker : public Axon_Sense< Axon_Knowledge >
{
	typedef Axon_Sense< Axon_Knowledge > PARENT;

public:

	AVP_Sense_MotionTracker(AVP_Knowledge_System_Actor* pxAVPKnowledgeSystem);
	virtual ~AVP_Sense_MotionTracker();

	virtual void InitialiseFromBlueprint( const Asura_Blueprint& xBlueprint );
	virtual void ReadFromChunkStream( Asura_Chunk_Stream& xStream );
	virtual void WriteToChunkStream( Asura_Chunk_Stream& xStream ) const;
	static bool  CullOnFOV(const AVP_ServerEntity_Actor* pxOurActor, const AVP_ServerEntity_Actor* pxThreatActor);
	bool LOSCheckOnActor(const AVP_ServerEntity_Actor* pxThreatActor, const bool bFOV = false);

	virtual void Update( const float fTimeslice );
	void ProcessActors( void );
	void ProcessMotionTrackerBlips( void );

	void SetTrackerFOV( const float fTanHorHalfFOV, const float fTanVertUpHalfFOV, const float fTanVertDownHalfFOV );

	int	GetTargetPriority( Asura_Guid uThreatGuid );

	const Asura_Hashed_List< Axon_Knowledge >* GetList() const { return &m_xMTList; }


#ifndef ASURA_NO_DEBUG_OUTPUT
	static void RenderKnowledgeDebugInfo();
#endif

protected:

	AVP_Knowledge_System_Actor* GetActorKnowledgeSystem();

	void InitFromSettingsBlueprint(void);
	void DepricateCurrentKnowledge(const float fTimeslice);
	void AddNewKnowledge(void);
	virtual bool ShouldCullOnFOV( const float fRange, const Asura_Vector_3& xToEntity );
	virtual bool IsPointInFrustum( const Asura_Vector_3& xPoint );
	bool ShouldCullOnRangeAndFOV(const AVP_ServerEntity_Actor* pxOurActor, const Asura_Vector_3& pxMTBlipPos);
	bool ShouldCullOnRange( const float fRange );

	void DestroyAllKnowledge();

	Asura_Hashed_List< Axon_Knowledge > m_xMTList;

private:

	float m_fTanFovX;
	float m_fTanFovYUp;
	float m_fTanFovYDown;

	float m_fMTRange;
	float m_fDetectableVelocity;

	static float s_fVelocity;

	enum { CURRENT_CHUNK_VERSION = 0 };
};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //__AVP_SENSE_MOTIONTRACKER
