
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_Actor_AnimStateData.h
// Author : Will Plano
// Date   : 25/02/2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_ACTOR_ANIMSTATEDATA_H__
#define __AVP_ACTOR_ANIMSTATEDATA_H__

#define AVP_ACTOR_ANIMSTATEDATA_MAX_BLEND_REGIONS 4
#define AVP_ACTOR_ANIMSTATEDATA_MAX_ANIMS_PER_REGION 10

#include "Blueprint/Asura_Blueprint.h"


class Asura_Blueprint;
class Asura_Chunk_Stream;
class AVP_Actor_AnimStateData_Directional_Region;

class AVP_Actor_AnimStateData
{
public:
	AVP_Actor_AnimStateData();
	virtual ~AVP_Actor_AnimStateData() {}

	float			GetMoveDistance() const { return m_fMoveDistance; }
	Asura_Hash_ID	GetCollisionDescriptorHash() const { return m_uCollisionDescriptorHash; }

	Asura_Hash_ID	GetSecondaryAnimHash() const { return m_uSecondaryAnimHash; }
	Asura_Hash_ID	GetAimDownUpAnimHash() const { return m_uAimDownUpAnimHash; }
	Asura_Hash_ID	GetAimDownUpDragAnimHash() const { return m_uAimDownUpDragAnimHash; }
	Asura_Hash_ID	GetAimRightLeftAnimHash() const { return m_uAimRightLeftAnimHash; }
	Asura_Hash_ID	GetAimRightLeftDragAnimHash() const { return m_uAimRightLeftDragAnimHash; }
	Asura_Hash_ID	GetStrafeDragAnimHash() const { return m_uStrafeDragAnimHash; }
	Asura_Hash_ID	GetPrimaryActorShootBeginHash() const { return m_uPrimaryActorShootBeginHash; }
	Asura_Hash_ID	GetPrimaryWeaponShootBeginHash() const { return m_uPrimaryWeaponShootBeginHash; }
	Asura_Hash_ID	GetSecondaryActorShootBeginHash() const { return m_uSecondaryActorShootBeginHash; }
	Asura_Hash_ID	GetSecondaryWeaponShootBeginHash() const { return m_uSecondaryWeaponShootBeginHash; }
	Asura_Hash_ID	GetPrimaryActorShootLoopHash() const { return m_uPrimaryActorShootLoopHash; }
	Asura_Hash_ID	GetPrimaryWeaponShootLoopHash() const { return m_uPrimaryWeaponShootLoopHash; }
	Asura_Hash_ID	GetSecondaryActorShootLoopHash() const { return m_uSecondaryActorShootLoopHash; }
	Asura_Hash_ID	GetSecondaryWeaponShootLoopHash() const { return m_uSecondaryWeaponShootLoopHash; }
	Asura_Hash_ID	GetPrimaryActorShootEndHash() const { return m_uPrimaryActorShootEndHash; }
	Asura_Hash_ID	GetPrimaryWeaponShootEndHash() const { return m_uPrimaryWeaponShootEndHash; }
	Asura_Hash_ID	GetSecondaryActorShootEndHash() const { return m_uSecondaryActorShootEndHash; }
	Asura_Hash_ID	GetSecondaryWeaponShootEndHash() const { return m_uSecondaryWeaponShootEndHash; }
	Asura_Hash_ID	GetWeaponInActorAnimHash() const { return m_uWeaponInActorAnimHash; }
	Asura_Hash_ID	GetWeaponInWeaponAnimHash() const { return m_uWeaponInWeaponAnimHash; }
	Asura_Hash_ID	GetWeaponOutActorAnimHash() const { return m_uWeaponOutActorAnimHash; }
	Asura_Hash_ID	GetWeaponOutWeaponAnimHash() const { return m_uWeaponOutWeaponAnimHash; }
	Asura_Hash_ID	GetScopeInActorAnimHash() const { return m_uScopeInActorAnimHash; }
	Asura_Hash_ID	GetScopeOutActorAnimHash() const { return m_uScopeOutActorAnimHash; }
	Asura_Hash_ID	GetWeaponRestWeaponAnimHash() const { return m_uWeaponRestWeaponAnimHash; }
	Asura_Hash_ID	GetReloadActorHash() const { return m_uReloadActorHash; }
	Asura_Hash_ID	GetReloadWeaponHash() const { return m_uReloadWeaponHash; }
	Asura_Hash_ID	GetStimActorAnimHash() const { return m_uStimActorAnimHash; }
	Asura_Hash_ID	GetStimItemAnimHash() const { return m_uStimItemAnimHash; }
	Asura_Hash_ID	GetStimWeaponAnimHash() const { return m_uStimWeaponAnimHash; }
	Asura_Hash_ID	GetFlareActorAnimHash() const { return m_uFlareActorAnimHash; }
	Asura_Hash_ID	GetCloakActorAnimHash() const { return m_uCloakActorAnimHash; }
	Asura_Hash_ID	GetCloakWeaponAnimHash() const { return m_uCloakWeaponAnimHash; }
	Asura_Hash_ID	GetFidgetBlueprintHash() const { return m_uFidgetBPHash; }

	virtual Asura_Hash_ID	GetAnimHash() const { return ASURA_HASH_ID_UNSET; }
	virtual Asura_Hash_ID	GetTurn45LeftAnimHash() const { return ASURA_HASH_ID_UNSET; }
	virtual Asura_Hash_ID	GetTurn45RightAnimHash() const { return ASURA_HASH_ID_UNSET; }
	virtual Asura_Hash_ID	GetTurn90LeftAnimHash() const { return ASURA_HASH_ID_UNSET; }
	virtual Asura_Hash_ID	GetTurn90RightAnimHash() const { return ASURA_HASH_ID_UNSET; }
	virtual Asura_Hash_ID	GetTurn180LeftAnimHash() const { return ASURA_HASH_ID_UNSET; }
	virtual Asura_Hash_ID	GetTurn180RightAnimHash() const { return ASURA_HASH_ID_UNSET; }

	virtual Asura_Hash_ID	GetAnimBlendTemplateBlueprintHash() const { return ASURA_HASH_ID_UNSET; }
	virtual u_int GetNumBlendRegions() const { return 0; }
	virtual const AVP_Actor_AnimStateData_Directional_Region* GetBlendRegion( u_int uBlendRegion ) const { return NULL; }

//#ifdef ASURA_TOOLS
	void CopyFrom( const AVP_Actor_AnimStateData& xOther );
	virtual void InitialiseFromBlueprint( const Asura_Hash_ID uBPType, const Asura_Blueprint& xBlueprint, const char* const szStateString, const bool bAssertOnFailure );

#ifdef ASURA_TOOLS
	virtual void WriteToChunkStream( Asura_Chunk_Stream& xStream ) const;
#endif
	virtual void ReadFromChunkStream( Asura_Chunk_Stream& xStream );

#ifdef ASURA_TOOLS
	static void WriteToChunkStream( Asura_Chunk_Stream& xStream, const AVP_Actor_AnimStateData* pxStateData ); // this static version also writes the chunk header
#endif
	static AVP_Actor_AnimStateData* CreateFromChunkStream( Asura_Chunk_Stream& xStream );

protected:
//#ifdef ASURA_TOOLS
	bool GetParameterValueByString( const Asura_Blueprint& xBlueprint, const char* const szStateString, const char* const szParamString, const bool bAssertOnFailure, Asura_Value& xValueOut );
//#endif
	float			m_fMoveDistance;

private:
	virtual bool IsDirectional() const = 0;	

	Asura_Hash_ID	m_uCollisionDescriptorHash;
	Asura_Hash_ID	m_uSecondaryAnimHash;
	Asura_Hash_ID	m_uAimDownUpAnimHash;
	Asura_Hash_ID	m_uAimDownUpDragAnimHash;
	Asura_Hash_ID	m_uAimRightLeftAnimHash;
	Asura_Hash_ID	m_uAimRightLeftDragAnimHash;
	Asura_Hash_ID	m_uStrafeDragAnimHash;
	Asura_Hash_ID	m_uPrimaryActorShootBeginHash;
	Asura_Hash_ID	m_uPrimaryWeaponShootBeginHash;
	Asura_Hash_ID	m_uSecondaryActorShootBeginHash;
	Asura_Hash_ID	m_uSecondaryWeaponShootBeginHash;
	Asura_Hash_ID	m_uPrimaryActorShootLoopHash;
	Asura_Hash_ID	m_uPrimaryWeaponShootLoopHash;
	Asura_Hash_ID	m_uSecondaryActorShootLoopHash;
	Asura_Hash_ID	m_uSecondaryWeaponShootLoopHash;
	Asura_Hash_ID	m_uPrimaryActorShootEndHash;
	Asura_Hash_ID	m_uPrimaryWeaponShootEndHash;
	Asura_Hash_ID	m_uSecondaryActorShootEndHash;
	Asura_Hash_ID	m_uSecondaryWeaponShootEndHash;
	Asura_Hash_ID	m_uWeaponInActorAnimHash;
	Asura_Hash_ID	m_uWeaponInWeaponAnimHash;
	Asura_Hash_ID	m_uWeaponOutActorAnimHash;
	Asura_Hash_ID	m_uWeaponOutWeaponAnimHash;
	Asura_Hash_ID	m_uScopeInActorAnimHash;
	Asura_Hash_ID	m_uScopeOutActorAnimHash;
	Asura_Hash_ID	m_uWeaponRestWeaponAnimHash;
	Asura_Hash_ID	m_uReloadActorHash;
	Asura_Hash_ID	m_uReloadWeaponHash;
	Asura_Hash_ID	m_uStimActorAnimHash;
	Asura_Hash_ID	m_uStimItemAnimHash;
	Asura_Hash_ID	m_uStimWeaponAnimHash;
	Asura_Hash_ID	m_uFlareActorAnimHash;
	Asura_Hash_ID	m_uCloakActorAnimHash;
	Asura_Hash_ID	m_uCloakWeaponAnimHash;
	Asura_Hash_ID	m_uFidgetBPHash;

	AVP_Actor_AnimStateData( const AVP_Actor_AnimStateData& xOther );
	AVP_Actor_AnimStateData& operator= ( const AVP_Actor_AnimStateData& xOther );
};

class AVP_Actor_AnimStateData_NonDirectional : public AVP_Actor_AnimStateData
{
public:
	AVP_Actor_AnimStateData_NonDirectional();
	virtual ~AVP_Actor_AnimStateData_NonDirectional() {}
	
//#ifdef ASURA_TOOLS
	virtual void InitialiseFromBlueprint( const Asura_Hash_ID uBPType, const Asura_Blueprint& xBlueprint, const char* const szStateString, const bool bAssertOnFailure );
#ifdef ASURA_TOOLS
	virtual void WriteToChunkStream( Asura_Chunk_Stream& xStream ) const;
#endif
	virtual void ReadFromChunkStream( Asura_Chunk_Stream& xStream );

	virtual Asura_Hash_ID	GetAnimHash() const { return m_uAnimHash; }
	virtual Asura_Hash_ID	GetTurn45LeftAnimHash() const { return m_uTurn45LeftAnimHash; }
	virtual Asura_Hash_ID	GetTurn45RightAnimHash() const { return m_uTurn45RightAnimHash; }
	virtual Asura_Hash_ID	GetTurn90LeftAnimHash() const { return m_uTurn90LeftAnimHash; }
	virtual Asura_Hash_ID	GetTurn90RightAnimHash() const { return m_uTurn90RightAnimHash; }
	virtual Asura_Hash_ID	GetTurn180LeftAnimHash() const { return m_uTurn180LeftAnimHash; }
	virtual Asura_Hash_ID	GetTurn180RightAnimHash() const { return m_uTurn180RightAnimHash; }

private:
	typedef AVP_Actor_AnimStateData PARENT;

	virtual bool IsDirectional() const { return false; }	

	Asura_Hash_ID	m_uAnimHash;
	Asura_Hash_ID	m_uTurn45LeftAnimHash;
	Asura_Hash_ID	m_uTurn45RightAnimHash;
	Asura_Hash_ID	m_uTurn90LeftAnimHash;
	Asura_Hash_ID	m_uTurn90RightAnimHash;
	Asura_Hash_ID	m_uTurn180LeftAnimHash;
	Asura_Hash_ID	m_uTurn180RightAnimHash;

	AVP_Actor_AnimStateData_NonDirectional( const AVP_Actor_AnimStateData_NonDirectional& xOther );
	AVP_Actor_AnimStateData_NonDirectional& operator= ( const AVP_Actor_AnimStateData_NonDirectional& xOther );
};

class AVP_Actor_AnimStateData_Directional_Region
{
public:
	AVP_Actor_AnimStateData_Directional_Region();
	~AVP_Actor_AnimStateData_Directional_Region() {}

//#ifdef ASURA_TOOLS
	void Initialise( const AVP_Actor_AnimStateData& xParentStateData, const Asura_Hash_ID uBPTypeHash, const Asura_Blueprint& xBP, const u_int uRegionItr, const bool bAssertOnFailure );
#ifdef ASURA_TOOLS
	void WriteToChunkStream( Asura_Chunk_Stream& xStream ) const;
#endif
	void ReadFromChunkStream( Asura_Chunk_Stream& xStream );

	u_int							GetNumAnims() const { return m_uNumAnims; }
	float							GetTweenAngleACW() const { return m_fTweenAngleACW; }
	float							GetTweenAngleCW() const { return m_fTweenAngleCW; }
	u_int							GetTweenOnAnimFlags( const u_int uAnimItr ) const { Asura_Assert( uAnimItr < m_uNumAnims, "" ); if ( uAnimItr < m_uNumAnims ) { return m_auTweenOnAnimFlags[ uAnimItr ]; } else { return 0; } }
	const AVP_Actor_AnimStateData*	GetAnimData( const u_int uAnimItr ) const { Asura_Assert( uAnimItr < m_uNumAnims, "" ); if ( uAnimItr < m_uNumAnims ) { return &m_axAnimData[ uAnimItr ]; } else { return NULL; } }
	float							GetAngle( const u_int uAnimItr ) const { Asura_Assert( uAnimItr < m_uNumAnims, "" ); if ( uAnimItr < m_uNumAnims ) { return m_afAngle[ uAnimItr ]; } else { return 0.0f; } }

private:
	float											m_fTweenAngleACW;
	float											m_fTweenAngleCW;
	u_int											m_uNumAnims;
	float											m_afAngle			[ AVP_ACTOR_ANIMSTATEDATA_MAX_ANIMS_PER_REGION ];
	u_int											m_auTweenOnAnimFlags[ AVP_ACTOR_ANIMSTATEDATA_MAX_ANIMS_PER_REGION ];
	AVP_Actor_AnimStateData_NonDirectional			m_axAnimData		[ AVP_ACTOR_ANIMSTATEDATA_MAX_ANIMS_PER_REGION ];
};

class AVP_Actor_AnimStateData_Directional : public AVP_Actor_AnimStateData
{
public:
	AVP_Actor_AnimStateData_Directional();
	virtual ~AVP_Actor_AnimStateData_Directional() {}

#ifdef ASURA_TOOLS
	virtual void WriteToChunkStream( Asura_Chunk_Stream& xStream ) const;
#endif
	virtual void ReadFromChunkStream( Asura_Chunk_Stream& xStream );

	virtual Asura_Hash_ID GetAnimBlendTemplateBlueprintHash() const { return m_uBlendTemplateHash; }
	virtual u_int GetNumBlendRegions() const { return m_uNumBlendRegions; }
	virtual const AVP_Actor_AnimStateData_Directional_Region* GetBlendRegion( u_int uBlendRegion ) const { Asura_Assert( uBlendRegion < m_uNumBlendRegions, "" ); if ( uBlendRegion < m_uNumBlendRegions ) { return &m_axRegion[ uBlendRegion ]; } else { return NULL; } }

private:
	typedef AVP_Actor_AnimStateData PARENT;

	virtual bool IsDirectional() const { return true; }	

//#ifdef ASURA_TOOLS
	virtual void InitialiseFromBlueprint( const Asura_Hash_ID uBPType, const Asura_Blueprint& xBlueprint, const char* const szStateString, const bool bAssertOnFailure );
//#endif

	Asura_Hash_ID								m_uBlendTemplateHash;
	u_int										m_uNumBlendRegions;
	AVP_Actor_AnimStateData_Directional_Region	m_axRegion[ AVP_ACTOR_ANIMSTATEDATA_MAX_BLEND_REGIONS ];

	AVP_Actor_AnimStateData_Directional( const AVP_Actor_AnimStateData_Directional& xOther );
	AVP_Actor_AnimStateData_Directional& operator= ( const AVP_Actor_AnimStateData_Directional& xOther );
};

//#ifdef ASURA_TOOLS
class AVP_Blueprint_ParameterEnumerator_AnimState_Directional_Region : public Asura_Blueprint_ParameterEnumerator
{
public:
	AVP_Blueprint_ParameterEnumerator_AnimState_Directional_Region( const AVP_Actor_AnimStateData& xParentStateData, const Asura_Hash_ID uBPTypeHash, const Asura_Blueprint& xBP, AVP_Actor_AnimStateData_Directional_Region* pxRegion, const bool bAssertOnFailure ) : m_xParentStateData( xParentStateData ), m_uBPTypeHash( uBPTypeHash ), m_xBP( xBP ), m_pxRegion( pxRegion ), m_bAssertOnFailure( bAssertOnFailure ) {}
	virtual ~AVP_Blueprint_ParameterEnumerator_AnimState_Directional_Region() {}

	virtual void BeginEnumeration() {}
	virtual bool Enumerate( const u_int uIndex, char const* const szName, const Asura_Value& xValue);
	virtual void EndEnumeration( const bool bSuccess ) {}

	virtual const char* GetParameterFormat() const { return "%s%0*d.Anim.01"; }

private:
	typedef Asura_Blueprint_ParameterEnumerator PARENT;

	const AVP_Actor_AnimStateData&					m_xParentStateData;
	const Asura_Hash_ID								m_uBPTypeHash;
	const Asura_Blueprint& 							m_xBP;
	AVP_Actor_AnimStateData_Directional_Region*		m_pxRegion;
	bool											m_bAssertOnFailure;
};

class AVP_Blueprint_ParameterEnumerator_AnimState_Directional_Region_AnimData : public Asura_Blueprint_ParameterEnumerator
{
public:
	AVP_Blueprint_ParameterEnumerator_AnimState_Directional_Region_AnimData( const AVP_Actor_AnimStateData&	xParentStateData, const Asura_Hash_ID uBPTypeHash, const Asura_Blueprint& xBP, AVP_Actor_AnimStateData_NonDirectional* pxAnimData, const bool bAssertOnFailure ) : m_xParentStateData( xParentStateData ), m_uBPTypeHash( uBPTypeHash ), m_xBP( xBP ), m_pxAnimData( pxAnimData ), m_bAssertOnFailure( bAssertOnFailure ) {}
	virtual ~AVP_Blueprint_ParameterEnumerator_AnimState_Directional_Region_AnimData() {}

	virtual void BeginEnumeration() {}
	virtual bool Enumerate( const u_int uIndex, char const* const szName, const Asura_Value& xValue);
	virtual void EndEnumeration( const bool bSuccess ) {}

private:
	typedef Asura_Blueprint_ParameterEnumerator PARENT;

	const AVP_Actor_AnimStateData&				m_xParentStateData;
	const Asura_Hash_ID							m_uBPTypeHash;
	const Asura_Blueprint& 						m_xBP;
	AVP_Actor_AnimStateData_NonDirectional*		m_pxAnimData;
	bool										m_bAssertOnFailure;

};

class AVP_Blueprint_ParameterEnumerator_AnimState_Directional_Region_Angle : public Asura_Blueprint_ParameterEnumerator
{
public:
	AVP_Blueprint_ParameterEnumerator_AnimState_Directional_Region_Angle( float* pfAngle ) : m_pfAngle( pfAngle ) {}
	virtual ~AVP_Blueprint_ParameterEnumerator_AnimState_Directional_Region_Angle() {}

	virtual void BeginEnumeration() {}
	virtual bool Enumerate( const u_int uIndex, char const* const szName, const Asura_Value& xValue);
	virtual void EndEnumeration( const bool bSuccess ) {}

private:
	typedef Asura_Blueprint_ParameterEnumerator PARENT;

	float* m_pfAngle;
};
// #endif // ASURA_TOOLS

#endif   // ifndef __AVP_ACTOR_ANIMSTATEDATA_H__

/// End of file. ///
