
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_Actor_FidgetAnimHandler.h
// Author : Emil Popovic
// Date   : 30-Oct-2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_ACTOR_FIDGETANIMHANDLER_H__
#define __AVP_ACTOR_FIDGETANIMHANDLER_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Network/Asura_Guid.h"

#include "Entity/AVP_Messages.h"

////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////

class AVP_ClientEntity_Actor;
class Asura_Blueprint;

////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Actor_FidgetAnimHandler
// Author       : Emil Popovic
// Date         : 30-Oct-2008
//
// Description  : Class to handle interaction by actors.
////////////////////////////////////////////////////////////////////////////////

class AVP_Actor_FidgetAnimHandler
{
public:
	// Public functions...
	AVP_Actor_FidgetAnimHandler( AVP_ClientEntity_Actor& xOwner );
	virtual ~AVP_Actor_FidgetAnimHandler();

	virtual void Update();

	void	SetFidgetTimes( const float fMinTime, const float fMaxTime ) { m_fTimeBetweenAnimationsMin = fMinTime; m_fTimeBetweenAnimationsMax = fMaxTime; }
	void	ResetFidgetTimer();

protected:
	AVP_ClientEntity_Actor& m_xOwner;

private:

	void PlayRandomFidgetAnim( Asura_Blueprint* pxFidgetBlueprint );
	Asura_Hash_ID GetFidgetBlueprintHash();


	Asura_Hash_ID	m_uLastFrameFidgetBlueprintHash;
	Asura_Hash_ID	m_uCurrentPlayedAnimControlerHash;

	float			m_fTimeBetweenAnimationsMin;
	float			m_fTimeBetweenAnimationsMax;

	float			m_fTimeToStartNextFidget;			// In Seconds
	float			m_fFidgetTimer;

};   // End of class 'AVP_Actor_FidgetAnimHandler'.

#endif   // ifndef __AVP_ACTOR_FIDGETANIMHANDLER_H__

/// End of file. ///
