
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_Vehicle_InputHandler.h
// Author : Chris Wallace
// Date   : 17-Apr-2007
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_VEHICLE_INPUTHANDLER_H__
#define __AVP_VEHICLE_INPUTHANDLER_H__


////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Actor/AVP_Actor_InputHandler.h"

#include "Core/Asura_Maths.h"
#include "Input/Asura_ControlMap.h"
#include "Network/Asura_Guid.h"


////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////

class Asura_Message;
class AVP_ClientActor_Vehicle;

////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Vehicle_InputHandler
// Author       : Chris Wallace
// Date         : 17-Apr-2007
//
// Description  : Abstract class to handle input from a player which controls 
//				  a particular type of actor.
////////////////////////////////////////////////////////////////////////////////

class AVP_Vehicle_InputHandler : AVP_Actor_InputHandler
{
public:
	// Public functions...
	virtual ~AVP_Vehicle_InputHandler () {}

protected:
	// Protected variables...

	// Protected functions...
	AVP_Vehicle_InputHandler(const Asura_Guid uOwnerGuid, const u_int uMaxMappings);

	virtual void UpdateMovementInput(AVP_ClientEntity_Actor& xClient);

private:
	// Private variables...

	// Private functions...
	AVP_Vehicle_InputHandler (void);
	AVP_Vehicle_InputHandler (const AVP_Vehicle_InputHandler& xOther);

	AVP_Vehicle_InputHandler&	operator=	(const AVP_Vehicle_InputHandler& xOther);

};   // End of class 'AVP_Vehicle_InputHandler'.


#endif   // ifndef __AVP_VEHICLE_INPUTHANDLER_H__


/// End of file. ///
