
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_Vertebrate_Description.h
// Author : Anthony Gregson
// Date   : 17/03/08
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_VERTEBRATE_DESCRIPTION_H__
#define __AVP_VERTEBRATE_DESCRIPTION_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Core/Asura_Hash.h"

////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Vertebrate_Description
// Author       : Anthony Gregson
// Date         : 17/03/08
//
// Description  : Description of elements common to all vertebrates.
////////////////////////////////////////////////////////////////////////////////

class AVP_Vertebrate_Description
{
public:
	// Public enumerated types...
	enum MarkerPointID
	{
		MPID_TARGET_1,
		MPID_TARGET_2,
		MPID_EYES,
		MPID_MELEEORIGIN,

		NUM_MARKER_POINT_IDS
	};

	// Accessor functions...
	static Asura_Hash_ID GetMarkerPointHashID(const MarkerPointID eID) { return s_auMarkerPointHashIDs[eID]; }

protected:
	static const Asura_Hash_ID s_auMarkerPointHashIDs[NUM_MARKER_POINT_IDS];

private:
	// Private functions...
	AVP_Vertebrate_Description(void);
	AVP_Vertebrate_Description(const AVP_Vertebrate_Description& xOther);
	~AVP_Vertebrate_Description();

	AVP_Vertebrate_Description& operator=(const AVP_Vertebrate_Description& xOther);

	// Private variables...

};   // End of class 'AVP_Vertebrate_Description'.


#endif   // ifndef __AVP_VERTEBRATE_DESCRIPTION_H__


/// End of file. ///
