
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_Alien_AIAnimStateData.h
// Author : Will Plano
// Date   : 8/11/2007
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_ALIEN_AIANIMSTATEDATA_H__
#define __AVP_ALIEN_AIANIMSTATEDATA_H__

#include "Actor/AVP_Actor_PhysicsObjectHandler.h"
#include "Actor/Vertebrates/Alien/AVP_Alien_AIAnimStateMachine.h"

class AVP_Actor_AnimStateData;

class AVP_Alien_AIAnimStateData
{
public:
	static const AVP_Actor_AnimStateData* GetAnimStateData( const Asura_Hash_ID uAnimStateBlueprintType, u_int uState, u_int uGroundType = AVP_Actor_PhysicsObjectHandler::ON_FLOOR, AVP_Alien_AIAnimStateMachine::LimbDamage eLimbDamage = AVP_Alien_AIAnimStateMachine::LIMBDMG_NONE );

	static void Initialise( const Asura_Hash_ID uAnimStateBlueprintType );
	static void ResetStorage();

private:

	static AVP_Actor_AnimStateData*** s_apppxAnimStateData[ AVP_Alien_AIAnimStateMachine::GROUNDTYPE_END ];
	static bool s_bInitialised;

	AVP_Alien_AIAnimStateData();
	AVP_Alien_AIAnimStateData(const AVP_Alien_AIAnimStateData& xOther);
	AVP_Alien_AIAnimStateData&	operator=(const AVP_Alien_AIAnimStateData& xOther);
};

#endif // __AVP_ALIEN_AIANIMSTATEDATA_H__
