
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_Alien_InteractionHandler.h
// Author : Andy Tate
// Date   : 4-Sep-2007
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_ALIEN_INTERACTIONHANDLER_H__
#define __AVP_ALIEN_INTERACTIONHANDLER_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Actor/AVP_Actor_InteractionHandler.h"


////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////
class AVP_ClientActor_Alien;


////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Alien_InteractionHandler
// Author       : Andy Tate
// Date         : 4-Sep-2007
//
// Description  : Class to handle interactions for Aliens.
////////////////////////////////////////////////////////////////////////////////

class AVP_Alien_InteractionHandler : public AVP_Actor_InteractionHandler
{
public:
	AVP_Alien_InteractionHandler(AVP_ClientActor_Alien& xAlien);

	virtual void Update();
	virtual bool HandleInteraction(AVP_INTERACTION_TYPES eType, int iKeyType, float fKeyValue) const;
	virtual bool IsInteracting() const;

	static bool GetIsAlienInteractionMove(const Asura_Hash_ID uMoveHash);

protected:
	virtual Asura_Guid GetGuidForInteraction(AVP_INTERACTION_TYPES eType) const;

	Asura_Guid m_uHeadbiteTarget;

private:
	// Private typedefs...
	typedef AVP_Actor_InteractionHandler PARENT;

};   // End of class 'AVP_Alien_InteractionHandler'.


#endif   // ifndef __AVP_ALIEN_INTERACTIONHANDLER_H__


/// End of file. ///
