
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_Alien_PlayerAnimStateData.h
// Author : Will Plano
// Date   : 21/02/2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_ALIEN_PLAYERANIMSTATEDATA_H__
#define __AVP_ALIEN_PLAYERANIMSTATEDATA_H__

#include "Core/Asura_HashTree.h"

#include "Actor/Vertebrates/AVP_Vertebrate_PlayerAnimStateData.h"
#include "Actor/Vertebrates/Alien/AVP_Alien_PlayerAnimStateHandler.h"

class AVP_Actor_AnimStateData;

class AVP_Alien_PlayerAnimStateData : public AVP_Vertebrate_PlayerAnimStateData
{
public:
	static AVP_Alien_PlayerAnimStateData&	GetSingleton()		{ return s_xSingleton; }

	const AVP_Actor_AnimStateData* GetAnimStateData( const Asura_Hash_ID uAnimStateBlueprintType, const bool bFirstPerson, const bool bOnFloor, const bool bStanding, const bool bJumping, const bool bFalling, AVP_Vertebrate_PlayerAnimStateHandler::MovementSpeed eMoveSpeed );

	void ResetStorage();

#ifdef ASURA_TOOLS
	void Initialise( const Asura_Hash_ID uAnimStateBlueprintType, const bool bMultiplayer );
#endif

	// Override this one since we have special names for these in the alien blueprints.
	const Asura_String GetStateDescription( u_int uState, u_int uSpeed );

protected:

	u_int GetNumSpeeds( const u_int uState );

private:
	typedef AVP_Vertebrate_PlayerAnimStateData PARENT;

	AVP_Actor_AnimStateData* m_aaaapxAnimStateData[ 2 ][ 2 ][ AVP_Vertebrate_PlayerAnimStateHandler::MOVESTATE_END_NOAIM ][ AVP_Vertebrate_PlayerAnimStateHandler::MOVESPEED_END ];
	bool m_bInitialised;

	AVP_Alien_PlayerAnimStateData() { m_bInitialised = false; }
	AVP_Alien_PlayerAnimStateData(const AVP_Alien_PlayerAnimStateData& xOther);
	AVP_Alien_PlayerAnimStateData&	operator=(const AVP_Alien_PlayerAnimStateData& xOther);

	static	AVP_Alien_PlayerAnimStateData	s_xSingleton;

	friend class AVP_Chunk_Alien_PlayerAnimStateData;
};

#endif // __AVP_ALIEN_PLAYERANIMSTATEDATA_H__
