
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_Alien_PlayerAnimStateHandler.h
// Author : Will Plano
// Date   : 25/02/2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_ALIEN_PLAYERANIMSTATEHANDLER_H__
#define __AVP_ALIEN_PLAYERANIMSTATEHANDLER_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Actor/Vertebrates/AVP_Vertebrate_PlayerAnimStateHandler.h"

////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

class AVP_Alien_PlayerAnimStateHandler : public AVP_Vertebrate_PlayerAnimStateHandler
{
public:
	// Public enumerated types...

	// Public functions...
	AVP_Alien_PlayerAnimStateHandler( AVP_ClientEntity_Actor& xClient ) : PARENT( xClient ), m_bCurrentStanding( false ) {}
	virtual ~AVP_Alien_PlayerAnimStateHandler() {}

	virtual void Initialise();

	virtual void Update();

protected:
#ifndef ASURA_NO_DEBUG_OUTPUT
	virtual void RenderDebugInfo( Asura_Vector_3& xOutputPos );
#endif

private:
	typedef AVP_Vertebrate_PlayerAnimStateHandler PARENT;

	bool m_bCurrentStanding;

	AVP_Alien_PlayerAnimStateHandler(const AVP_Alien_PlayerAnimStateHandler& xOther);
	AVP_Alien_PlayerAnimStateHandler&	operator=(const AVP_Alien_PlayerAnimStateHandler& xOther);

}; // End of class 'AVP_Alien_PlayerStateHandler'.

#endif // ifndef __AVP_ALIEN_PLAYERSTATEHANDLER_H__

/// End of file. ///
