///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_AlienQueen_AIAnimStateMachine.h
// Author : David Wooldridge
// Date   : 06/11/2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE



#ifndef __AVP_ALIENQUEEN_AIANIMSTATEMACHINE_H__
#define __AVP_ALIENQUEEN_AIANIMSTATEMACHINE_H__

#include "Actor/Vertebrates/AVP_Vertebrate_AIAnimStateMachine.h"

class AVP_AlienQueen_AIAnimStateMachine : public AVP_Vertebrate_AIAnimStateMachine
{
public:
	// Public enumerated types...
	enum AlienQueenHuggerAnimState
	{
		ALIENQUEEN_STATE_BEGIN = VERTEBRATE_STATE_END,
		ALIENQUEEN_STATE_END = ALIENQUEEN_STATE_BEGIN	// 13
	};

	// Public functions...
	AVP_AlienQueen_AIAnimStateMachine( AVP_ServerEntity_Actor& xServer ) : PARENT( xServer ) {}
	virtual ~AVP_AlienQueen_AIAnimStateMachine() {}

	virtual void Initialise();

	virtual const AVP_Actor_AIAnimStateConnectionData* GetConnectionData( const u_int uFromState, const u_int uToState ) const;

	static bool IsDirectionalState( const u_int uState ) { return PARENT::IsDirectionalState( uState ); }

protected:
	virtual u_int GetNumStates() const { return ALIENQUEEN_STATE_END; }
	virtual const AVP_Actor_AnimStateData* GetStateAnimData( const u_int uState ) const;

#ifndef ASURA_NO_DEBUG_OUTPUT
	virtual void RenderDebugInfo();
#endif

private:
	typedef AVP_Vertebrate_AIAnimStateMachine PARENT;

	AVP_AlienQueen_AIAnimStateMachine();
	AVP_AlienQueen_AIAnimStateMachine(const AVP_AlienQueen_AIAnimStateMachine& xOther);
	AVP_AlienQueen_AIAnimStateMachine&	operator=(const AVP_AlienQueen_AIAnimStateMachine& xOther);
}; // End of class 'AVP_FaceHugger_AIAnimStateMachine'.


#endif