
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_FaceHugger_AIAnimStateMachine.cpp
// Author : Will Plano
// Date   : 02/05/2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Core/Asura.h"

// This file's header...
#include "Actor/Vertebrates/FaceHugger/AVP_FaceHugger_AIAnimStateMachine.h"

#include "Rendering/Asura_Font_System.h"

#include "Actor/Vertebrates/FaceHugger/AVP_FaceHugger_AIAnimStateConnections.h"
#include "Actor/Vertebrates/FaceHugger/AVP_FaceHugger_AIAnimStateData.h"
#include "Blueprint/AVP_Blueprint_HashIDs.h"
#include "Entity/PhysicalObject/Actor/AVP_ServerEntity_Actor.h"

////////////////////////////////////////////////////////////////////////////////
// Public functions...
////////////////////////////////////////////////////////////////////////////////

void AVP_FaceHugger_AIAnimStateMachine::Initialise()
{
	AVP_FaceHugger_AIAnimStateData::Initialise( m_xServerActor.GetAnimStateBlueprintType() );
	PARENT::Initialise();
}

const AVP_Actor_AnimStateData* AVP_FaceHugger_AIAnimStateMachine::GetStateAnimData( const u_int uState ) const
{
	return AVP_FaceHugger_AIAnimStateData::GetAnimStateData( m_xServerActor.GetAnimStateBlueprintType(), uState );
}

const AVP_Actor_AIAnimStateConnectionData* AVP_FaceHugger_AIAnimStateMachine::GetConnectionData( const u_int uFromState, const u_int uToState ) const
{
	return AVP_FaceHugger_AIAnimStateConnections::GetConnectionData( uFromState, uToState );
}

#ifndef ASURA_NO_DEBUG_OUTPUT

void AVP_FaceHugger_AIAnimStateMachine::RenderDebugInfo()
{
	PARENT::RenderDebugInfo();
	// nothing to add
}

#endif

/// End of file. ///
