
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_FaceHugger_AIAnimStateMachine.h
// Author : Will Plano
// Date   : 22/02/2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_FACEHUGGER_AIANIMSTATEMACHINE_H__
#define __AVP_FACEHUGGER_AIANIMSTATEMACHINE_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Actor/Vertebrates/AVP_Vertebrate_AIAnimStateMachine.h"

class AVP_FaceHugger_AIAnimStateMachine : public AVP_Vertebrate_AIAnimStateMachine
{
public:
	// Public enumerated types...
	enum FaceHuggerAnimState
	{
		FACEHUGGER_STATE_BEGIN = VERTEBRATE_STATE_END,
		FACEHUGGER_STATE_END = FACEHUGGER_STATE_BEGIN	// 13
	};

	// Public functions...
	AVP_FaceHugger_AIAnimStateMachine( AVP_ServerEntity_Actor& xServer ) : PARENT( xServer ) {}
	virtual ~AVP_FaceHugger_AIAnimStateMachine() {}

	virtual void Initialise();

	virtual const AVP_Actor_AIAnimStateConnectionData* GetConnectionData( const u_int uFromState, const u_int uToState ) const;

	static bool IsDirectionalState( const u_int uState ) { return false; } // this overrides the default vertebrate behaviour of having movement states with directional blends

protected:
	virtual u_int GetNumStates() const { return FACEHUGGER_STATE_END; }
	virtual const AVP_Actor_AnimStateData* GetStateAnimData( const u_int uState ) const;

#ifndef ASURA_NO_DEBUG_OUTPUT
	virtual void RenderDebugInfo();
#endif

private:
	typedef AVP_Vertebrate_AIAnimStateMachine PARENT;

	AVP_FaceHugger_AIAnimStateMachine();
	AVP_FaceHugger_AIAnimStateMachine(const AVP_FaceHugger_AIAnimStateMachine& xOther);
	AVP_FaceHugger_AIAnimStateMachine&	operator=(const AVP_FaceHugger_AIAnimStateMachine& xOther);
}; // End of class 'AVP_FaceHugger_AIAnimStateMachine'.

#endif // ifndef __AVP_FACEHUGGER_AIANIMSTATEMACHINE_H__

/// End of file. ///
