////////////////////////////////////////////////////////////////
//
// File:		AVP_FaceHugger_MeleeCounter_System.cpp
// Author:		Chris Wallace
// Date:		23-Jan-2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//
////////////////////////////////////////////////////////////////

///////////////////////////////////////////////
// #includes
///////////////////////////////////////////////
#include "Core/Asura.h"

// This files header
#include "Actor/Vertebrates/FaceHugger/AVP_FaceHugger_MeleeCounter_System.h"

// game
#include "Entity/AVP_Entity_Classification.h"
#include "Entity/PhysicalObject/Actor/Vertebrates/FaceHugger/AVP_ServerActor_FaceHugger.h"
#include "Inventory/AVP_Inventory_HashIDs.h"
#include "Inventory/AVP_Inventory_System.h"
#include "Moves/Vertebrates/FaceHugger/AVP_FaceHugger_MovesMelee.h"
#include "Moves/Vertebrates/Human/AVP_Human_MovesMelee.h"

///////////////////////////////////////////////
// #defines
///////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////
//
// Class :	AVP_FaceHugger_MeleeCounter_System
//
//////////////////////////////////////////////////////////////////////

AVP_FaceHugger_MeleeCounter_System::AVP_FaceHugger_MeleeCounter_System(AVP_ServerActor_FaceHugger& xOwner)
: AVP_Vertebrate_MeleeCounter_System(xOwner)
{
}

Asura_Hash_ID AVP_FaceHugger_MeleeCounter_System::GetMeleeMoveHash(u_int uType) const
{
	switch (uType)
	{
	case AVP_MELEEATTACK_TYPE_NORMAL: // TODO - Probably wants to be its own attack.
		return AVP_FaceHugger_Move_Melee_JumpAttack_Start::GetStaticHash();
	default:
		return PARENT::GetMeleeMoveHash(uType);
	}
}

// face hugger doesnt do damage - it insta-kill or do nothing.
float AVP_FaceHugger_MeleeCounter_System::GetAttackDamage() const
{
	return 0.0f; 
}


bool AVP_FaceHugger_MeleeCounter_System::GetCanCounter_HumanCounter(const AVP_ServerEntity_Actor& xEnemy, const u_int uQueuedCounterType, Asura_Hash_ID& uMoveHash, u_int& uNewAttackType, bool& bMakeEnemyIntoPuppet, Asura_Hash_ID& uGrappleSetBlueprintParam) const
{
	if (xEnemy.IsPlayer())
	{
		return false;
	}

	uMoveHash =  AVP_Human_Move_Melee_CounterFaceHugger::GetStaticHash();
	uNewAttackType = AVP_MELEEATTACK_TYPE_COUNTER;
	bMakeEnemyIntoPuppet = false;
	uGrappleSetBlueprintParam = ASURA_HASH_ID_UNSET;
	return true;
}


/// End of file. ///
