
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_Human_PlayerAnimStateHandler.h
// Author : Will Plano
// Date   : 25/02/2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_HUMAN_PLAYERANIMSTATEHANDLER_H__
#define __AVP_HUMAN_PLAYERANIMSTATEHANDLER_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Actor/Vertebrates/AVP_Vertebrate_PlayerAnimStateHandler.h"

////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

class AVP_Human_PlayerAnimStateHandler : public AVP_Vertebrate_PlayerAnimStateHandler
{
public:
	// Public enumerated types...

	// Public functions...
	AVP_Human_PlayerAnimStateHandler( AVP_ClientEntity_Actor& xClient ) : PARENT( xClient ), m_bCurrentCrouch(false), m_bCurrentAim(false) {}
	virtual ~AVP_Human_PlayerAnimStateHandler() {}

	virtual void Initialise();

	virtual void Update();

protected:
#ifndef ASURA_NO_DEBUG_OUTPUT
	virtual void RenderDebugInfo( Asura_Vector_3& xOutputPos );
#endif

private:
	typedef AVP_Vertebrate_PlayerAnimStateHandler PARENT;

	bool m_bCurrentCrouch;
	bool m_bCurrentAim;

	AVP_Human_PlayerAnimStateHandler(const AVP_Human_PlayerAnimStateHandler& xOther);
	AVP_Human_PlayerAnimStateHandler&	operator=(const AVP_Human_PlayerAnimStateHandler& xOther);

}; // End of class 'AVP_Human_PlayerStateHandler'.

#endif // ifndef __AVP_HUMAN_PLAYERSTATEHANDLER_H__

/// End of file. ///
