
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_Predalien_AIAnimStateMachine.h
// Author : Will Plano
// Date   : 22/02/2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_PREDALIEN_AIANIMSTATEMACHINE_H__
#define __AVP_PREDALIEN_AIANIMSTATEMACHINE_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Actor/Vertebrates/AVP_Vertebrate_AIAnimStateMachine.h"

class AVP_Predalien_AIAnimStateMachine : public AVP_Vertebrate_AIAnimStateMachine
{
public:
	// Public enumerated types...

	enum PredalienAnimState
	{
		PREDALIEN_STATE_BEGIN = VERTEBRATE_STATE_END,
		PREDALIEN_STATE_END	= PREDALIEN_STATE_BEGIN
	};

	// Public functions...
	AVP_Predalien_AIAnimStateMachine( AVP_ServerEntity_Actor& xServerActor ) : PARENT( xServerActor ) {}
	virtual ~AVP_Predalien_AIAnimStateMachine() {}

	virtual void Initialise();

	virtual const AVP_Actor_AIAnimStateConnectionData* GetConnectionData( const u_int uFromState, const u_int uToState ) const;

protected:

	virtual u_int	GetNumStates() const { return PREDALIEN_STATE_END; }
	virtual const AVP_Actor_AnimStateData* GetStateAnimData( const u_int uState ) const;

#ifndef ASURA_NO_DEBUG_OUTPUT
	virtual void RenderDebugInfo();
#endif

private:
	typedef AVP_Vertebrate_AIAnimStateMachine PARENT;

	AVP_Predalien_AIAnimStateMachine();
	AVP_Predalien_AIAnimStateMachine(const AVP_Predalien_AIAnimStateMachine& xOther);
	AVP_Predalien_AIAnimStateMachine&	operator=(const AVP_Predalien_AIAnimStateMachine& xOther);
}; // End of class 'AVP_Predalien_AIAnimStateMachine'.

#endif // ifndef __AVP_PREDALIEN_AIANIMSTATEMACHINE_H__

/// End of file. ///
