
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_Predator_AIAnimStateData.h
// Author : Will Plano
// Date   : 8/11/2007
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_PREDATOR_AIANIMSTATEDATA_H__
#define __AVP_PREDATOR_AIANIMSTATEDATA_H__

#include "Core/Asura_HashTree.h"

#include "Actor/Vertebrates/Predator/AVP_Predator_AIAnimStateMachine.h"

class AVP_Actor_AnimStateData;

class AVP_Predator_AIAnimStateData
{
public:
	static const AVP_Actor_AnimStateData* GetAnimStateData( const Asura_Hash_ID uAnimStateBlueprintType, const Asura_Hash_ID uCurrentWeaponHash, u_int uState );

	static void InitialiseWeaponData( const Asura_Hash_ID uAnimStateBlueprintType, const Asura_Hash_ID uHash ) { GetWeaponDataByHash( uAnimStateBlueprintType, uHash ); }
	static void ResetStorage() { s_xHashTree.Reset(); }

private:
	struct AVP_Predator_AIAnimWeaponStateData
	{
		AVP_Predator_AIAnimWeaponStateData();
		~AVP_Predator_AIAnimWeaponStateData();
		
		void InitialiseFromBlueprint( const Asura_Hash_ID uAnimStateBlueprintType, const Asura_Hash_ID uBlueprintHash );

		AVP_Actor_AnimStateData* m_apxAnimStateData[ AVP_Predator_AIAnimStateMachine::PREDATOR_STATE_END ];
	};

	static const AVP_Predator_AIAnimWeaponStateData* GetWeaponDataByHash( const Asura_Hash_ID uAnimStateBlueprintType, const Asura_Hash_ID uHash );

	static Asura_TemplateHashTree< AVP_Predator_AIAnimWeaponStateData > s_xHashTree;

	AVP_Predator_AIAnimStateData();
	AVP_Predator_AIAnimStateData(const AVP_Predator_AIAnimStateData& xOther);
	AVP_Predator_AIAnimStateData&	operator=(const AVP_Predator_AIAnimStateData& xOther);
};

#endif // __AVP_PREDATOR_AIANIMSTATEDATA_H__
