///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_FaceHugger_AIAnimStateConnections.cpp
// Author : Will Plano
// Date   : 05/08/2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#include "Core/Asura.h"

// This file's header...
#include "Actor/Weapons/Sentrygun/AVP_Sentrygun_AIAnimStateConnections.h"

#include "Actor/AVP_Actor_AIAnimStateConnection.h"

static const AVP_Actor_AIAnimStateConnectionListEntry s_axConnectionList[] = 
{
	AVP_Actor_AIAnimStateConnectionListEntry( AVP_Sentrygun_AIAnimStateMachine::ACTOR_STATE_IN_MOVE,		AVP_Sentrygun_AIAnimStateMachine::ACTOR_STATE_IDLE ),
	AVP_Actor_AIAnimStateConnectionListEntry( AVP_Sentrygun_AIAnimStateMachine::ACTOR_STATE_IN_GAMESCENE,	AVP_Sentrygun_AIAnimStateMachine::ACTOR_STATE_IDLE ),
	AVP_Actor_AIAnimStateConnectionListEntry( AVP_Sentrygun_AIAnimStateMachine::ACTOR_STATE_IDLE,			AVP_Sentrygun_AIAnimStateMachine::SENTRYGUN_STATE_SWEEPING, AVP_Actor_AIAnimStateConnectionData( 1.0f, 0.05f, false, false ) ),
	AVP_Actor_AIAnimStateConnectionListEntry( AVP_Sentrygun_AIAnimStateMachine::SENTRYGUN_STATE_SWEEPING,	AVP_Sentrygun_AIAnimStateMachine::ACTOR_STATE_IDLE, AVP_Actor_AIAnimStateConnectionData( 1.0f, 0.05f, false, false ) ),
	AVP_Actor_AIAnimStateConnectionListEntry( AVP_Sentrygun_AIAnimStateMachine::SENTRYGUN_STATE_DISABLED, 	AVP_Sentrygun_AIAnimStateMachine::SENTRYGUN_STATE_SWEEPING, AVP_Actor_AIAnimStateConnectionData( 1.0f, 0.05f, false, false ) ),
	AVP_Actor_AIAnimStateConnectionListEntry( AVP_Sentrygun_AIAnimStateMachine::SENTRYGUN_STATE_SWEEPING, 	AVP_Sentrygun_AIAnimStateMachine::SENTRYGUN_STATE_DISABLED, AVP_Actor_AIAnimStateConnectionData( 1.0f, 0.05f, false, false ) ),
	AVP_Actor_AIAnimStateConnectionListEntry( AVP_Sentrygun_AIAnimStateMachine::ACTOR_STATE_IDLE, 			AVP_Sentrygun_AIAnimStateMachine::SENTRYGUN_STATE_DESTROYED, AVP_Actor_AIAnimStateConnectionData( 1.0f, 0.25f, false, false ) ),
	AVP_Actor_AIAnimStateConnectionListEntry( AVP_Sentrygun_AIAnimStateMachine::ACTOR_STATE_IDLE,			AVP_Sentrygun_AIAnimStateMachine::SENTRYGUN_STATE_DISABLED, AVP_Actor_AIAnimStateConnectionData( 1.0f, 0.5f, false, false ) ),
	AVP_Actor_AIAnimStateConnectionListEntry( AVP_Sentrygun_AIAnimStateMachine::SENTRYGUN_STATE_DISABLED, 	AVP_Sentrygun_AIAnimStateMachine::ACTOR_STATE_IDLE, AVP_Actor_AIAnimStateConnectionData( 1.0f, 0.5f, false, false ) ),
	AVP_Actor_AIAnimStateConnectionListEntry( -1, -1 ) // terminator
};

bool AVP_Sentrygun_AIAnimStateConnections::s_bInitialised = false;
const AVP_Actor_AIAnimStateConnectionData* AVP_Sentrygun_AIAnimStateConnections::s_aapxConnectionsMatrix[ AVP_Sentrygun_AIAnimStateMachine::SENTRYGUN_STATE_END ][ AVP_Sentrygun_AIAnimStateMachine::SENTRYGUN_STATE_END ];

const AVP_Actor_AIAnimStateConnectionData* AVP_Sentrygun_AIAnimStateConnections::GetConnectionData( const u_int uStateFrom, const u_int uStateTo )
{
	if ( !s_bInitialised )
	{
		s_bInitialised = true;
		for ( u_int uFromItr = 0; uFromItr < AVP_Sentrygun_AIAnimStateMachine::SENTRYGUN_STATE_END; ++uFromItr )
		{
			for ( u_int uToItr = 0; uToItr < AVP_Sentrygun_AIAnimStateMachine::SENTRYGUN_STATE_END; ++uToItr )
			{
				s_aapxConnectionsMatrix[ uFromItr ][ uToItr ] = NULL;
			}
		}
		for ( u_int uConnItr = 0; s_axConnectionList[ uConnItr ].m_iStateFrom != -1; ++uConnItr )
		{
			s_aapxConnectionsMatrix[ s_axConnectionList[ uConnItr ].m_iStateFrom ][ s_axConnectionList[ uConnItr ].m_iStateTo ] = &( s_axConnectionList[ uConnItr ].m_xStateData );
		}
	}
	return s_aapxConnectionsMatrix[ uStateFrom ][ uStateTo ];
}
