//////////////////////////////////////////////////////////////////////////////
//
// Asura_Project_Hierarchy.cpp
//
// Copyright (c) 2003 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "Core/Asura.h"

#include "Animation/Asura_Hierarchy.h"

// Asura Platform-independent
#include "Animation/Asura_Animation.h"

// AVP Platform-independent
#include "Animation/AVP_Hierarchy_System.h"


//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

void Asura_Hierarchy_System::Project_RenderSkin( const Asura_Animation* pxAnim, u_int uCamVisFlags, unsigned uRenderFlags, const Asura_Vector_3& xBSCentre, float fBSRadius )
{
	AVP_Hierarchy_System::RenderSkin( pxAnim, uCamVisFlags, uRenderFlags, xBSCentre, fBSRadius );
}

void Asura_Hierarchy_System::Project_Initialise()
{
	AVP_Hierarchy_System::Initialise();
}

void Asura_Hierarchy_System::Project_Shutdown()
{
	AVP_Hierarchy_System::Shutdown();
}

void Asura_Hierarchy_System::Project_Reset()
{
	AVP_Hierarchy_System::Reset();
}

void Asura_Hierarchy_System::Project_RenderHierarchy( const Asura_Animation* pxAnim,
													  u_int uCamVisFlags, u_int uRenderFlags,
													  const Asura_Vector_3& xBSCentre, float fBSRadius )
{
	AVP_Hierarchy_System::RenderHierarchy( pxAnim, uCamVisFlags, uRenderFlags, xBSCentre, fBSRadius );
}

Asura_Hierarchy_Skin* Asura_Hierarchy_System::Project_AllocateSkin()
{
	return new Asura_Hierarchy_Skin;
}

#ifndef ASURA_DISABLE_ANIM_TABLE_CODE
#include "Animation/Asura_AnimTable_System.h"
int Asura_AnimTable_System::Project_ConvertHashToAnimState( Asura_Hash_ID uID )
{
	// HACK: we don't actually use the anim tables, but this allows us to load them.
	static int ls_iTemp = 0;
	return ls_iTemp++;
}
#endif

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////
