
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_Chunk_SurfaceOverlay.h
// Author : Chris Wallace
// Date   : 2-Aug-2007
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_CHUNK_SURFACEOVERLAY_H__
#define __AVP_CHUNK_SURFACEOVERLAY_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "ChunkSystem/AVP_Chunk_Loaders.h"


////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////

class Asura_Chunk_Stream;


////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Chunk_SurfaceOverlay
// Author       : Chris Wallace
// Date         : 2-Aug-2007
//
// Description  : Class used for reading/writing damage table data.
////////////////////////////////////////////////////////////////////////////////

class AVP_Chunk_SurfaceOverlay : public Asura_Chunk_Header
{
public:
	// Public functions...
	AVP_Chunk_SurfaceOverlay  (void);
//	~Tools_Chunk_MaterialResponseOverrides ();

	void ReadFromChunkStream(Asura_Chunk_Stream& xStream);

#if defined(ASURA_TOOLS)
	static void	Create	(Asura_Chunk_Stream& xStream);
	static bool	Save	(const char* szFilename);
#endif


protected:
	// Protected variables...

	// Protected functions...


private:
	// Private variables...

	// Private functions...
	AVP_Chunk_SurfaceOverlay  (const AVP_Chunk_SurfaceOverlay& xOther);

	AVP_Chunk_SurfaceOverlay&	operator=	(const AVP_Chunk_SurfaceOverlay& xOther);

	static const int s_iChunkVersion;	// The version used when reading/writing.

};   // End of class 'AVP_Chunk_SurfaceOverlay'.

#endif	// ifndef __AVP_CHUNK_SURFACEOVERLAY_H__


/// End of file. ///
