////////////////////////////////////////////////////////
// 
// AVP_SmokeTest.h
//
// This class is used to store some data and to handle the input
// when we are doing a smoke test in the AVP_DevelopmentFrontEnd class
// i.e. leave when it have been "playing" for a set amount of seconds
//
/////////////////////////////////////////////////////////


#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __AVP_SMOKETEST_H__
#define __AVP_SMOKETEST_H__

#ifdef AVP_LOG_FILE_LOAD_MEMORY_USE

class AVP_SmokeTest
{
public:
	AVP_SmokeTest(){};
	~AVP_SmokeTest(){};

	static void ClearLogFiles();
	static void LogBeginFileLoad(const char* szFilename);
	static void LogEndFileLoad();

	static void Update();
	static void PrintOutputToLog();
	static void ResetData();
	static void SetNumberOfFrameratesToGet( int iNumber );
	static void SetPlaying( bool bPlaying );
	static void SetRunningSmokeTest( bool bRunSmokeTest );


private:

	static u_int CalculateTotalSizeOfFiles(const char* szFilename);

	static u_int  s_uMemoryUsageOutput[5];
	static int    s_iMemoryBeginData;
	static int    s_iMemoryEndData;
	static int    s_iNumberOfFrameRatesToFetchEveryLevel;
	static int	  s_iNumberOfFrameRatesFetched;
	static float  s_fHighestFPS;
	static float  s_fLowestFPS;
	static float  s_fSummarizedFrameRate;
	static bool	  s_bDoingSmokeTest;
	static bool   s_bFetchedDataFromFirstFrame;
	static bool   s_bHasFileLoadMemoryUseData;
	static bool   s_bLoggingAMap;
	static bool   s_bPlaying;
	static bool   s_bNegativeDifference;
		
	struct FileLoadMemoryUseData
	{
		u_int m_uMemoryAvailableAtStart;
		u_int m_uFileSize;
	};

	static FileLoadMemoryUseData s_xCurrentFileLoadMemoryUseData;

};
#endif // #ifdef AVP_LOG_FILE_LOAD_MEMORY_USE

#endif // __AVP_SMOKETEST_H__