///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_State_FMV.h
// Author : Catalin Arsenescu
// Date   : 24/04/08
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_STATE_FMV_H__
#define __AVP_STATE_FMV_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Core/States/AVP_State.h"


////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////

class AVP_StateMachine;


////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class  : AVP_State_FMV
// Author : Catalin Arsenescu
// Date   : 24/04/08
////////////////////////////////////////////////////////////////////////////////

class AVP_State_FMV : public AVP_State
{
public:
	// Public functions...
	AVP_State_FMV(const char* szStateName, const char* szFilename, const u_int uNextState, AVP_StateMachine& xParentMachine)
	: PARENT(xParentMachine)
	, m_szStateName(szStateName)
	, m_szFilename(szFilename)
	, m_uNextState(uNextState)
	{
	}
	//virtual ~AVP_CoreState_Frontend();

	// Overridden functions...
	virtual	void Enter(const u_int uPreviousState);
	virtual	void Update();
	virtual	void Render() const;
	virtual	void Exit(const u_int uNextState);

	virtual	const char*	GetName(void) const	{ return(m_szStateName); }


protected:
	// Protected variables...
	const char*	m_szStateName;	// The name of this state.
	const char*	m_szFilename;	// The name of the FMV file to play (minus extension).
	u_int		m_uNextState;	// The state to change to when we've finished playing this FMV.


private:
	// Private typedefs...
	typedef AVP_State PARENT;

};   // End of class 'AVP_State_FMV'.

#endif   // ifndef __AVP_STATE_FMV_H__


/// End of file. ///
