
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_ConnectionState_WaitForPlayers.h
// Author : Paul Cardy
// Date   : 25/03/09
//
// Copyright (C) 2009 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_CONNECTIONSTATE_WAITFORLPAYERS_H__
#define __AVP_CONNECTIONSTATE_WAITFORLPAYERS_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Core/Asura_Timers.h"

#include "Core/States/Connection/AVP_State_Connection.h"

////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////

class AVP_Connection;

////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class  : AVP_ConnectionState_WaitForPlayers
// Author : Paul Cardy
// Date   : 25/03/09
////////////////////////////////////////////////////////////////////////////////

class AVP_ConnectionState_WaitForPlayers : public AVP_State_Connection
{
	typedef AVP_State_Connection PARENT;

public:
	// Public functions...
	AVP_ConnectionState_WaitForPlayers(AVP_Connection& xParentMachine)
		: PARENT(xParentMachine)
	{
	}
//	virtual ~AVP_ConnectionState_Loading();

	// Overridden functions...
	virtual	void Enter(const u_int uPreviousState);
	virtual	void Update();
	virtual	void Render() const;
	virtual	void Exit(const u_int uNextState);

	virtual	const char*	GetName(void) const	{ return("WaitForPlayers"); }

protected:
	// Protected variables...

	// Protected functions...

private:
	// Private variables...
	Asura_TickCount	m_xStartTick;	// The tick-count when loading starts.

	// Private functions...

};   // End of class 'AVP_ConnectionState_WaitForPlayers'.


#endif   // ifndef __AVP_CONNECTIONSTATE_WAITFORPLAYERS_H__


/// End of file. ///
