
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_State_Connection.h
// Author : Anthony Gregson
// Date   : 22/11/07
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_STATE_CONNECTION_H__
#define __AVP_STATE_CONNECTION_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Core/States/AVP_State.h"

////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////

class AVP_Connection;

////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class  : AVP_State_Connection
// Author : Anthony Gregson
// Date   : 22/11/07
////////////////////////////////////////////////////////////////////////////////

class AVP_State_Connection : public AVP_State
{
public:
	// Public functions...
	AVP_State_Connection(AVP_Connection& xParentMachine);
	virtual ~AVP_State_Connection() {}

	// Since we can only create one of these using a connection state machine, add standard functions to cast straight to that type in case one of the subclasses needs to access connection-only values.
	AVP_Connection& GetParentConnection();
	const AVP_Connection& GetParentConnection() const;

private:
	typedef AVP_State PARENT;
};   // End of class 'AVP_State_Connection'.


#endif   // ifndef __AVP_STATE_CONNECTION_H__


/// End of file. ///
