///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_CoreState_Frontend.h
// Author : Anthony Gregson
// Date   : 21/11/07
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_CORESTATE_FRONTEND_H__
#define __AVP_CORESTATE_FRONTEND_H__

#if defined(AVP_USE_GAME_FRONTEND)

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Core/States/AVP_State.h"

////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////

class AVP_StateMachine;

////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class  : AVP_CoreState_Frontend
// Author : Anthony Gregson
// Date   : 21/11/07
////////////////////////////////////////////////////////////////////////////////

class AVP_CoreState_Frontend : public AVP_State
{
	typedef AVP_State PARENT;

public:
	// Public functions...
	AVP_CoreState_Frontend(AVP_StateMachine& xParentMachine)
		: PARENT(xParentMachine)
	{
	}
	//	virtual ~AVP_CoreState_Frontend();

	// Overridden functions...
	virtual	void Enter(const u_int uPreviousState);
	virtual	void Update();
	virtual	void Render() const;
	virtual	void Exit(const u_int uNextState);

	virtual	const char*	GetName(void) const	{ return("Frontend"); }

protected:

private:

};   // End of class 'AVP_CoreState_Frontend'.

#endif	//defined(AVP_USE_GAME_FRONTEND)

#endif   // ifndef __AVP_CORESTATE_FRONTEND_H__


/// End of file. ///
