
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_CoreState_LoadingFrontend.h
// Author : Anthony Gregson
// Date   : 21/11/07
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_CORESTATE_LOADINGFRONTEND_H__
#define __AVP_CORESTATE_LOADINGFRONTEND_H__

#if defined(AVP_USE_GAME_FRONTEND)

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Core/Asura_Timers.h"

//#include "Core/States/Core/AVP_State.h"
#include "Core/States/AVP_State.h"


////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////

class AVP_StateMachine_Core;

////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class  : AVP_CoreState_LoadingFrontend
// Author : Anthony Gregson
// Date   : 21/11/07
////////////////////////////////////////////////////////////////////////////////

class AVP_CoreState_LoadingFrontend : public AVP_State
{
	typedef AVP_State PARENT;

public:
	// Public functions...
	AVP_CoreState_LoadingFrontend(AVP_StateMachine& xParentMachine)
		: PARENT(xParentMachine)
	{
	}
//	virtual ~AVP_CoreState_LoadingFrontend();

	// Overridden functions...
	virtual	void Enter(const u_int uPreviousState);
	virtual	void Update();
	virtual	void Render() const;
	virtual	void Exit(const u_int uNextState);

	virtual	const char*	GetName(void) const	{ return("Loading Frontend"); }

	static	inline void	SetStatePostLoad( u_int uState )	{	m_uStatePostLoad = uState; }

	enum
	{
		STATE_POSTLOAD_FRONTEND,
#if defined(ASURA_SUPPORT_LOBBY)
		STATE_POSTLOAD_MPLOBBY,
#endif	//defined(ASURA_SUPPORT_LOBBY)
	};

protected:
	static u_int	m_uStatePostLoad;

	static void	PerformLoad(const void* pUserData);

private:
	static Asura_TickCount	s_xStartTicks;
	static volatile bool	s_bLoadCompleted;

};   // End of class 'AVP_CoreState_LoadingFrontend'.

#endif	//defined(AVP_USE_GAME_FRONTEND)

#endif   // ifndef __AVP_CORESTATE_LOADINGFRONTEND_H__


/// End of file. ///
