
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_CoreState_LoadingTools.cpp
// Author : Anthony Gregson
// Date   : 21/11/07
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Core/Asura.h"

#if defined(ASURA_TOOLS)

// This file's header...
#include "Core/States/Core/AVP_CoreState_LoadingTools.h"

// Game independent header-files...
#include "Core/AVP_Core.h"
#include "Core/AVP_StateMachine_Core.h"

#if defined(ASURA_TOOLS)
// Tools header-files...
#include "Load&Save/Tools_OptionsFile.h"
#endif	// defined(ASURA_TOOLS)


////////////////////////////////////////////////////////////////////////////////
// Constant declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Static variable declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Private functions...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Protected functions...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Public functions...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Function	: AVP_CoreState_LoadingTools::Update
// Author	: Anthony Gregson
// Date		: 21/11/07
////////////////////////////////////////////////////////////////////////////////

void AVP_CoreState_LoadingTools::Update()
{
	if(AVP_Core::GetToolsRequested())
	{
		const float	fTimeInState	= GetParentMachine().GetTimeInCurrentState();

		if(fTimeInState > 0.5f)
		{
			Tools_OptionsFile::Load();
			GetParentMachine().ChangeState(AVP_StateMachine_Core::STATE_TOOLS);
		}
	}
	else
	{
		Asura_Assert(false, "Shouldn't be going to tools here?");
		GetParentMachine().ChangeState(AVP_StateMachine_Core::STATE_TOOLS);
	}
}

/// End of function 'AVP_CoreState_LoadingTools::Update'. ///

#endif	// defined(ASURA_TOOLS)


/// End of file. ///
