///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_StateMachine_GameFrontend.h
// Author : Rav Tharanee
// Date   : 25/02/09
//
// Copyright (C) 2009 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_STATEMACHINE_GAMEFRONTEND_H__
#define __AVP_STATEMACHINE_GAMEFRONTEND_H__

#if defined(AVP_USE_GAME_FRONTEND) || defined(ASURA_SUPPORT_LOBBY)

#include "Core/AVP_StateMachine.h"

class	AVP_StateMachine_GameFrontend	:	public AVP_StateMachine
{
public:

	AVP_StateMachine_GameFrontend();
	virtual ~AVP_StateMachine_GameFrontend()
	{
	}

	enum State
	{
#if defined(AVP_USE_DEVELOPMENT_FRONT_END)
		STATE_DEVELOPMENTFRONTEND,
#endif
#if defined(AVP_USE_GAME_FRONTEND)
		STATE_LOADINGFRONTEND,
		STATE_FRONTEND,
#endif	//defined(AVP_USE_GAME_FRONTEND)
#if defined(ASURA_SUPPORT_LOBBY)
		STATE_MULTIPLAYERLOBBY,
#endif	//defined(ASURA_SUPPORT_LOBBY)
		STATE_SHUTTINGDOWN,
		STATE_GAME,

		MAX_STATES
	};

	virtual void Initialise( void );
	virtual void Update( void );
	virtual void Shutdown( void );

	void	RequestQuitApplication( void );

protected:
	typedef	AVP_StateMachine	PARENT;
private:
};

#endif	//defined(AVP_USE_GAME_FRONTEND) || defined(ASURA_SUPPORT_LOBBY)

#endif