
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_State_Core.h
// Author : Anthony Gregson
// Date   : 21/11/07
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_STATE_CORE_H__
#define __AVP_STATE_CORE_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Core/States/AVP_State.h"

////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////

class AVP_StateMachine_Core;

////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class  : AVP_State_Core
// Author : Anthony Gregson
// Date   : 21/11/07
////////////////////////////////////////////////////////////////////////////////

class AVP_State_Core : public AVP_State
{
public:
	// Public functions...
	AVP_State_Core(AVP_StateMachine_Core& xParentMachine);
	virtual ~AVP_State_Core() {}

	// Since we can only create one of these using a core state machine, add standard functions to cast straight to that type in case one of the subclasses needs to access core machine-only values.
	AVP_StateMachine_Core& GetParentCoreMachine();
	const AVP_StateMachine_Core& GetParentCoreMachine() const;

	virtual void RequestQuitApplication();

private:
	typedef AVP_State PARENT;
};   // End of class 'AVP_State_Core'.


#endif   // ifndef __AVP_STATE_CORE_H__


/// End of file. ///
