
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_PlayingState_Starting.h
// Author : Anthony Gregson
// Date   : 03/12/07
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_PLAYINGSTATE_STARTING_H__
#define __AVP_PLAYINGSTATE_STARTING_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Core/States/Playing/AVP_State_Playing.h"

////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////

class AVP_StateMachine_Playing;

////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class  : AVP_PlayingState_Waiting
// Author : Anthony Gregson
// Date   : 03/12/07
////////////////////////////////////////////////////////////////////////////////

class AVP_PlayingState_Starting : public AVP_State_Playing
{
	typedef AVP_State_Playing PARENT;

public:
	// Public functions...
	AVP_PlayingState_Starting(AVP_StateMachine_Playing& xParentMachine)
		: PARENT(xParentMachine)
	{
	}
//	virtual ~AVP_PlayingState_Starting();

	// Overridden functions...
	virtual	void Enter(const u_int uPreviousState);
	virtual	void Update();
	virtual	void Render() const;
//	virtual	void Exit(const u_int uNextState);

	virtual	const char*	GetName(void) const	{ return("Starting"); }

protected:

private:

};   // End of class 'AVP_PlayingState_Starting'.


#endif   // ifndef __AVP_PLAYINGSTATE_STARTING_H__


/// End of file. ///
