//////////////////////////////////////////////////////////////////////////////
//
// AVP_Cutscene_Event_CloakActor.h
//
// (Ali Jakamy - 30.05.2008) Created
//
// Copyright (c) 2008 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

// ASURA
#include "Cutscene/Asura_Cutscene_Event.h"

// AVP
#include "Animation/AVP_Hierarchy_System.h"
#include "SpecialFX/AVP_CloakEffect.h"

class AVP_Cutscene_Event_CloakActor : public Asura_Cutscene_Event
{
	friend class ToolsAVP_Cutscene_Event_CloakActor;

public :

	AVP_Cutscene_Event_CloakActor(Asura_Cutscene* pxCutscene);
	virtual void Trigger(Asura_Cutscene* pxCutscene);
	virtual void UpdateAfterTrigger(Asura_Cutscene* pxCutscene);
	virtual void Finish();

#ifdef ASURA_TOOLS
	virtual void Copy(Asura_Cutscene_Event* pxEvent);
#endif

	//Load/save functions , defined in Asura_Chunk_Cutscene.cpp
	virtual int  GetChunkSize();
	virtual void SaveToChunk(char*& pcChunkBuffer);
	virtual void LoadFromChunk(Asura_Chunk_CutsceneEvent* pxChunk, Asura_Handle iFileHandle);
	
	// Setters
	void SetDuration( float fDuration) { m_fDuration = fDuration; }
	void SetCloakingDuration( float fDuration) { m_fCloakingDuration = fDuration; }
	void SetUncloakingDuration( float fDuration) { m_fUncloakingDuration = fDuration; }
	void SetLightningScale( float fScale) { m_fLightningScale = fScale; }

private :

	float GetTransitionTime(float fStart, float fCurrent, float fEnd, bool bCloaking);
	void  UpdateCloakingTimerAndState(Asura_Cutscene* pxCutscene);

	enum
	{
		CURRENT_CHUNK_VERSION = 0,
	};
    	
	float           m_fDuration;           // Duration of the cloaking effect
	float           m_fCloakingDuration;   // Time it takes to go from uncloaked to cloaked
	float           m_fUncloakingDuration; // Time it takes to go from cloaked to uncloaked
	float           m_fLightningScale;     // Lightning scale during enter/exit cloaking

    AVP_CloakEffect m_xAVPCloakEffect;
	AVP_Animation_ProjectData m_xAnimProjectData;

    typedef Asura_Cutscene_Event PARENT;
};