//////////////////////////////////////////////////////////////////////////////
//
// AVP_Entity_Classification.h
//
// Copyright (c) 2006 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef AVP_ENTITY_CLASSIFICATION_H___
#define AVP_ENTITY_CLASSIFICATION_H___ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// Engine independent.
#include "Entity/Asura_Entity_Classification.h"

// T Y P E S /////////////////////////////////////////////////////////////////

// NB: These values are saved into entity data, etc. Reordering, insertion
// and deletion are strictly prohibited. Only ever add new entries to the end.
// To minimise the risk of problems, make the actual value of each entry 
// explicit adding +1 for each new entry.
enum AVP_ENTITY_CLASSIFICATION
{
	AVP_ENTITYCLASS_ACTOR	= AsuraEntityClass_ProjectSpecific, // 32768

	AVP_ENTITYCLASS_ALIEN,										// 32769
	AVP_ENTITYCLASS_ALIENCHESTBURSTER,							// 32770
	AVP_ENTITYCLASS_ALIENFACEHUGGER,							// 32771
	AVP_ENTITYCLASS_ALIENQUEEN,									// 32772
	AVP_ENTITYCLASS_HUMAN,										// 32773
	AVP_ENTITYCLASS_PREDATOR,									// 32774

	AVP_ENTITYCLASS_MINE,										// 32775
	AVP_ENTITYCLASS_ACID_DAMAGE,								// 32776
	AVP_ENTITYCLASS_GS2SPLINE,									// 32777
	AVP_ENTITYCLASS_DISC,										// 32778
	AVP_ENTITYCLASS_GIB,										// 32779

	AVP_ENTITYCLASS_INTERACTIONTRIGGER,							// 32780
	AVP_ENTITYCLASS_SPAWNPOINT,									// 32781
	AVP_ENTITYCLASS_AIPOINTCONTROLLER,							// 32782
	AVP_ENTITYCLASS_GOTOPOINT,									// 32783

	AVP_ENTITYCLASS_VERTEBRATE,									// 32784
	AVP_ENTITYCLASS_VEHICLE,									// 32785

	AVP_ENTITYCLASS_PLAYER,										// 32786

	AVP_ENTITYCLASS_ALIEN_HYBRID,								// 32787

	AVP_ENTITYCLASS_PREDATORGRENADE,							// 32788

	AVP_ENTITYCLASS_ORIENTEDNODE,								// 32789
	AVP_ENTITYCLASS_GUARDZONE,									// 32790

	AVP_ENTITYCLASS_GS2NODE,									// 32791
	AVP_ENTITYCLASS_DAMAGEABLEOBJECT,							// 32792

	AVP_ENTITYCLASS_SQUADCONTROLLER,							// 32793
	AVP_ENTITYCLASS_TEAMCONTROLLER,								// 32794

	AVP_ENTITYCLASS_TRIPMINE,									// 32795

	AVP_ENTITYCLASS_HUMANFLARE,									// 32796

	AVP_ENTITYCLASS_DROPSHIP,									// 32797

	AVP_ENTITYCLASS_CARBINE,									// 32798
	AVP_ENTITYCLASS_INTERACTOBJECT,								// 32799
	AVP_ENTITYCLASS_PISTOL,										// 32800

	AVP_ENTITYCLASS_GS2ATTRACTOR,								// 32801

	AVP_ENTITYCLASS_GENERICPROJECTILE,							// 32802

	AVP_ENTITYCLASS_CHECKPOINTNODE,								// 32803

	AVP_ENTITYCLASS_SHOTGUN,									// 32804
	AVP_ENTITYCLASS_BOMBTARGET,									// 32805
	AVP_ENTITYCLASS_PLAYERINFO,									// 32806

	AVP_ENTITYCLASS_ALIENTEAM,									// 32807
	AVP_ENTITYCLASS_ALIENSPAWNPOINT,							// 32808
	AVP_ENTITYCLASS_GAMEPLAYVOLUME,								// 32809
	AVP_ENTITYCLASS_MARINESQUAD,								// 32810
	AVP_ENTITYCLASS_MARINETEAM,									// 32811
	AVP_ENTITYCLASS_ANDROID,									// 32812
	AVP_ENTITYCLASS_LOOKAT,										// 32813
	AVP_ENTITYCLASS_FORMATIONPOINT,								// 32814
	AVP_ENTITYCLASS_VANTAGEPOINT_PREDATOR,						// 32815
	AVP_ENTITYCLASS_AI_OBJECTIVE,								// 32816
	AVP_ENTITYCLASS_AI_MARINE_OBJECTIVE,						// 32817
	AVP_ENTITYCLASS_CIVILIAN,									// 32818
	AVP_ENTITYCLASS_MARINE,										// 32819
	AVP_ENTITYCLASS_HUMANSPAWNPOINT,							// 32820
	AVP_ENTITYCLASS_COVERPOINT,									// 32821
	AVP_ENTITYCLASS_FLEEPOINT,									// 32822

	AVP_ENTITYCLASS_VENT,										// 32823

	AVP_ENTITYCLASS_SPAWNCONTROLLER,							// 32824
	AVP_ENTITYCLASS_SPAWNPOINT2,								// 32825

	AVP_ENTITYCLASS_ALIENSQUAD,									// 32826
	AVP_ENTITYCLASS_WEAPON,										// 32827
	AVP_ENTITYCLASS_SENTRYGUN,									// 32828

	AVP_ENTITYCLASS_GAMEMODE,									// 32829
	AVP_ENTITYCLASS_CAPTUREPOINT,								// 32830
	AVP_ENTITYCLASS_SCOREBOARD,									// 32831

	AVP_ENTITYCLASS_FACEHUGGERSQUAD,							// 32832

	AVP_ENTITYCLASS_PICKUP,						            	// 32833

	AVP_ENTITYCLASS_SHOOTAT,									// 32834
	AVP_ENTITYCLASS_PLAYER_OBJECTIVE,					     	// 32835

	AVP_ENTITYCLASS_DROPSHIP_MISSILE,							// 32836

	AVP_ENTITYCLASS_INTERACT_PREDATOR_LOCK,                     // 32837
	AVP_ENTITYCLASS_INTERACT_TOOL_RECEPTACLE,                   // 32838
	AVP_ENTITYCLASS_INTERACT_BATTERY_RECEPTACLE,                // 32839
	AVP_ENTITYCLASS_INTERACT_HACKING_POINT,                     // 32840
	
	AVP_ENTITYCLASS_COMMANDPOST,								// 32841

	AVP_ENTITYCLASS_INTERACT_RETINAL_SCANNER,                   // 32842

	AVP_ENTITYCLASS_ROOMNODE,                                   // 32843

	AVP_ENTITYCLASS_MOTIONTRACKERBLIP,							// 32844

	AVP_ENTITYCLASS_PLAYER_PROXY,								// 32845

	AVP_ENTITYCLASS_LOCATIONMARKER,                             // 32846

	AVP_ENTITYCLASS_WAYPOINTBLOCKERVOLUME,                      // 32847

	AVP_ENTITYCLASS_PROJECTILE_FLAMETHROWER,					// 32848

	AVP_ENTITYCLASS_PREDALIEN,									// 32849

	AVP_ENTITYCLASS_INTERACT_SENTRYGUN_INVISISWITCH,            // 32850

	AVP_ENTITYCLASS_PROJECTILE_ACIDSPIT,						// 32851

// Not currently used - THIS WILL BE GOING LAST BEFORE MAX PLEASER ADD NEW ENTITIES BEFORE THIS.
//	AVP_ENTITYCLASS_PHEROMONE,									// ?

	AVP_ENTITYCLASS_MAX // must be last
};
// NB: These values are saved into entity data, etc. Reordering, insertion
// and deletion are strictly prohibited. Only ever add new entries to the end.
//
// Don't forget to add to Asura_Network::Project_GetEntityClassificationDesc if you add any new classifications.

#endif // #ifndef AVP_ENTITY_CLASSIFICATION_H___
