//////////////////////////////////////////////////////////////////////////////
//
// AVP_Entity_EventIDs.h
//
// Copyright (C) 2008 Rebellion. All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AVP_ENTITY_EVENTIDS_H__
#define __AVP_ENTITY_EVENTIDS_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// asura
#include "Entity/Asura_Entity_Event.h"

//////////////////////////////////////////////////////////////////////////////
//
// AVP_ENTITY_EVENT
//
// These values are saved out with entities.
// DO NOT CHANGE ANY OF THESE VALUES.
//
//////////////////////////////////////////////////////////////////////////////

enum AVP_ENTITY_EVENT
{
	AVP_ENTITY_EVENT_ONHEALTHPERCENT0 = ASURA_ENTITY_EVENT_FIRSTPROJECTSPECIFIC,
	AVP_ENTITY_EVENT_ONHEALTHPERCENT1,
	AVP_ENTITY_EVENT_ONHEALTHPERCENT2,
	AVP_ENTITY_EVENT_ONHEALTHPERCENT3,
	AVP_ENTITY_EVENT_ONHEALTHPERCENT4,
	AVP_ENTITY_EVENT_ONHEALTHPERCENT5,
	AVP_ENTITY_EVENT_ONHEALTHPERCENT6,
	AVP_ENTITY_EVENT_ONHEALTHPERCENT7,
	AVP_ENTITY_EVENT_ONHEALTHPERCENT8,
	AVP_ENTITY_EVENT_ONHEALTHPERCENT9,

	AVP_ENTITY_EVENT_SQUAD_ELIMINATED = ASURA_ENTITY_EVENT_FIRSTPROJECTSPECIFIC + 100,
	AVP_ENTITY_EVENT_SQUAD_MEMBER_DIED,
	AVP_ENTITY_EVENT_SQUAD_ALERTED,
	AVP_ENTITY_EVENT_SQUAD_ENTERING_COMBAT,
	AVP_ENTITY_EVENT_CIVILIAN_KILLED,
	AVP_ENTITY_EVENT_MARINE_AI_OBJECTIVE_COMPLETE,
	AVP_ENTITY_EVENT_MARINE_AI_OBJECTIVE_ACTIONS_COMPLETE,
	AVP_ENTITY_EVENT_MARINE_ALERTED,
	AVP_ENTITY_EVENT_MARINE_THREAT_SPOTTED,

	AVP_ENTITY_EVENT_ONALIENKILLED = ASURA_ENTITY_EVENT_FIRSTPROJECTSPECIFIC + 200,
	AVP_ENTITY_EVENT_ONALIENSGONE,

	// Spawner stuff.
	AVP_ENTITY_EVENT_SPAWN_ON_SPAWN = ASURA_ENTITY_EVENT_FIRSTPROJECTSPECIFIC + 300,
	AVP_ENTITY_EVENT_SPAWN_ON_SPAWN_COUNT_EXHAUSTED,
	AVP_ENTITY_EVENT_SPAWN_ON_ANY_SPAWNEE_DEATH,
	AVP_ENTITY_EVENT_SPAWN_ON_ALL_SPAWNEES_DEAD,
	AVP_ENTITY_EVENT_DESPAWN_ON_SPAWN,
	

	// Capture point stuff
	AVP_ENTITY_EVENT_CAPTURE_POINT_ONCAPTUREDBYTEAM1 = ASURA_ENTITY_EVENT_FIRSTPROJECTSPECIFIC + 400,
	AVP_ENTITY_EVENT_CAPTURE_POINT_ONCAPTUREDBYTEAM2,
	AVP_ENTITY_EVENT_CAPTURE_POINT_ONCAPTUREDBYTEAM3,
	AVP_ENTITY_EVENT_CAPTURE_POINT_ONCONTESTED,
	
	// Civilian Events // JG - 17 April 2009 - Shouldn't be here really, but is too late to fix it.
	// Please add an offset to new events so we can keep them group by entities
	AVP_ENTITY_EVENT_CIVILIAN_ALERTED,

	// Back to capture point stuff
	AVP_ENTITY_EVENT_CAPTURE_POINT_ONNEUTRALIZED,

	// Player events
	AVP_ENTITY_EVENT_PLAYER_LOW_AMMO_CURRENT_WEAPON = ASURA_ENTITY_EVENT_FIRSTPROJECTSPECIFIC + 500,
	AVP_ENTITY_EVENT_PLAYER_LOW_AMMO_BOTH_WEAPONS,
	AVP_ENTITY_EVENT_PLAYER_NO_AMMO_PRIMARY_WEAPON,
	AVP_ENTITY_EVENT_PLAYER_CLOAKED,
	AVP_ENTITY_EVENT_PLAYER_DECLOAKED,
	AVP_ENTITY_EVENT_ON_PICKED_UP_BY_PLAYER,
	AVP_ENTITY_EVENT_ON_PUT_DOWN_BY_PLAYER,
	AVP_ENTITY_EVENT_PLAYER_ON_DEATH,

	// Sentry gun events
	AVP_ENTITY_EVENT_MARINE_INTERACT = ASURA_ENTITY_EVENT_FIRSTPROJECTSPECIFIC + 600,
	AVP_ENTITY_EVENT_ALIEN_INTERACT,
	AVP_ENTITY_EVENT_PREDATOR_INTERACT,

	AVP_ENTITY_EVENT_GS2_ACTION_ANIM_FLAG_HIT = ASURA_ENTITY_EVENT_FIRSTPROJECTSPECIFIC + 700,
};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //__AVP_ENTITY_EVENTIDS_H__
