//////////////////////////////////////////////////////////////////////////////
//
// AVP_Messages.h
//
// Copyright (c) 2006 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef AVP_MESSAGES_H___
#define AVP_MESSAGES_H___ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// Engine independent.
#include "Network/Asura_Message.h"

// T Y P E S /////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// If you add a message to this enum don't forget to add the description to Asura_Network::Project_GetMsgIDDesc().
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
enum AVP_MSGID
{
    AVP_MSGID_START_OF_STATIC_MESSAGES	= 32768,	//	ASURA_MSG_PROJECT_SPECIFIC = 0x8000,

    //
    // Message IDs for static messages.
    // DO NOT REORDER THE FOLLOWING SECTION OR DELETE ENTRIES. YOU SHOULD
    // ONLY ADD NEW ENTRIES AT THE END.
    //
	// To minimise the risk of problems, make the actual value of each entry 
	// explicit adding +1 for each new entry.
	//
    // ... static msg IDs here ...
	// first entry can be e.g. AVP_A_GENERIC_STATIC_MESSAGE = 32768
	// then e.g. AVP_ANOTHER_GENERIC_STATIC_MESSAGE = 32769 etc.
    //

	AVP_MSGID_END_OF_LEVEL							= 32769,
	AVP_MSGID_CONVERT_PLAYER_TO_AI					= 32770,
	AVP_MSGID_CHUNK									= 32771,
	AVP_MSGID_FORCE_SPAWNED_HUMANS_TO_BE_SCARED		= 32772,
	AVP_MSGID_SET_FORMATION_DIRECTION				= 32773,
    AVP_MSGID_CHANGE_ALIEN_SPAWN_SETTINGS			= 32774,
    AVP_MSGID_ADD_ALIENS_TO_SPAWN_QUEUE				= 32775,
	AVP_MSGID_SPAWN_ALIENS							= 32776,
	AVP_MSGID_ADD_AI_OBJECTIVE						= 32777,
	AVP_MSGID_ADD_SQUAD_MEMBER						= 32778,
    AVP_MSGID_REMOVE_SQUAD_MEMBER					= 32779,

	AVP_MSGID_ALIEN_TEAM_SET_BEHAVIOUR				= 32780,
	AVP_MSGID_ALIEN_TEAM_ADD_SPAWNTOKEN				= 32781,
	AVP_MSGID_ALIEN_TEAM_REMOVE_SPAWNTOKEN			= 32782,
	AVP_MSGID_ALIEN_TEAM_PREPARE_ROOM				= 32783,

    AVP_MSGID_REQUEST_CLOAK_ON	    				= 32784,
    AVP_MSGID_REQUEST_CLOAK_OFF						= 32785,

	AVP_MSGID_SET_PREFERRED_TARGET_TYPE				= 32786,

	AVP_MSGID_REQUEST_TORCH_ON	    				= 32787,
	AVP_MSGID_REQUEST_TORCH_OFF						= 32788,

	AVP_MSGID_ALIEN_TEAM_THREAT_BONUS				= 32789,

	AVP_MSGID_SPAWN_HUMANOIDS						= 32790,
	AVP_MSGID_CHANGE_HUMANOID_SPAWN_SETTINGS		= 32791,
	AVP_MSGID_MERGE_HUMANOID_SQUADS					= 32792,
	AVP_MSGID_SPLIT_HUMANOID_SQUAD					= 32793,

	AVP_MSGID_LIGHT_CHANGE_EVENT					= 32794,

	AVP_MSGID_REQUEST_HUMANOID_PATROL				= 32795,

	AVP_MSGID_PERFORM_AI_OBJECTIVE_ACTION			= 32796,

	AVP_MSGID_SPAWN									= 32797,
	AVP_MSGID_SPAWN_SET_MAX_SPAWN_COUNT				= 32798,
	AVP_MSGID_SPAWN_RESET_SPAWN_COUNTER				= 32799,
	AVP_MSGID_SPAWN_SET_MAX_IN_PLAY					= 32800,

	AVP_MSGID_SET_ALIEN_SQUAD_BEHAVIOUR				= 32801,
	AVP_MSGID_SET_ALIEN_SQUAD_BEHAVIOUR_PARAMS		= 32802,

	AVP_MSGID_SET_AI_TARGET_PRIORITIES				= 32803,
	AVP_MSGID_RESET_AI_TARGET_PRIORITIES			= 32804,

	AVP_MSGID_INTERACTION_OBJECT_ENABLE				= 32805,
	AVP_MSGID_INTERACTION_OBJECT_DISABLE			= 32806,

	AVP_MSGID_ACTIVATE_SELECTED_ENTITIES			= 32807,
	AVP_MSGID_DEACTIVATE_SELECTED_ENTITIES			= 32808,
	AVP_MSGID_AI_OBJECTIVE_COMPLETE					= 32809,

	AVP_MSGID_SENTRYGUN_ENABLE						= 32810,
	AVP_MSGID_SENTRYGUN_DISABLE						= 32811,
	AVP_MSGID_SENTRYGUN_DESTROY						= 32812,

	AVP_MSGID_NOTUSED_32813 						= 32813,
	AVP_MSGID_NOTUSED_32814 						= 32814,
	AVP_MSGID_NOTUSED_32815 						= 32815,
	AVP_MSGID_NOTUSED_32816 						= 32816,
	AVP_MSGID_NOTUSED_32817 						= 32817,
	AVP_MSGID_NOTUSED_32818 						= 32818,
	AVP_MSGID_NOTUSED_32819 						= 32819,
	AVP_MSGID_NOTUSED_32820 						= 32820,

	AVP_MSGID_SET_SQUAD_ALERT_STATUS_TO_PASSIVE		= 32821,

	AVP_MSGID_CHANGE_OWNERSHIP_TO_TEAM1				= 32822,
	AVP_MSGID_CHANGE_OWNERSHIP_TO_TEAM2				= 32823,
	AVP_MSGID_CHANGE_OWNERSHIP_TO_TEAM3				= 32824,

	AVP_MSGID_CAPTUREPOINT_LOCK						= 32825,
	AVP_MSGID_CAPTUREPOINT_UNLOCK					= 32826,

	AVP_MSGID_SET_FACEHUGGER_SQUAD_BEHAVIOUR		= 32827,

	AVP_MSGID_CHANGE_MARINE_SQUAD_SETTINGS			= 32828,
	AVP_MSGID_PROMOTE_TO_SQUAD_LEADER				= 32829,
	AVP_MSGID_ATTACK_SCRIPTED_TARGET				= 32830,
	AVP_MSGID_STOP_ATTACKING_SCRIPTED_TARGET		= 32831,

	AVP_MSGID_PICKUP_SET_INTELLIGENT_AMOUNT         = 32832,

	AVP_MSGID_ADD_PLAYER_OBJECTIVE                  = 32833,
	AVP_MSGID_SET_PLAYER_OBJECTIVE_COMPLETE         = 32834,

	AVP_MSGID_SET_DROPSHIP_ATTACK_MODE              = 32835,
	AVP_MSGID_TRIGGER_INTERACTION_ON_LOCAL_PLAYER	= 32836,

	AVP_MSGID_DISABLE_PICKUP						= 32837,
	AVP_MSGID_ENABLE_PICKUP						    = 32838,

	AVP_MSGID_INTERACTION_OBJECT_INITIALISE_TO_ON	= 32839,
	AVP_MSGID_INTERACTION_OBJECT_INITIALISE_TO_OFF	= 32840,
	AVP_MSGID_SET_PREDATOR_BEHAVIOUR				= 32841,
	AVP_MSGID_CHANGE_HUMANOID_SQUAD_MOVEMENT_MODE	= 32842,

	AVP_MSGID_FUNCTIONALITY_MOTION_TRACKER_ON       = 32843,
	AVP_MSGID_FUNCTIONALITY_MOTION_TRACKER_OFF      = 32844,
	AVP_MSGID_FUNCTIONALITY_VISION_MODES_ON			= 32845,
	AVP_MSGID_FUNCTIONALITY_VISION_MODES_OFF		= 32846,
	AVP_MSGID_FUNCTIONALITY_TORCH_ON		    	= 32847,
	AVP_MSGID_FUNCTIONALITY_TORCH_OFF		        = 32848,

	AVP_MSGID_REPLENISH_PREDATOR_ENERGY		        = 32849,

	AVP_MSGID_LOOK_AT_ENTITY						= 32850,
	AVP_MSGID_STOP_LOOKING_AT_ENTITY				= 32851,
	
	AVP_MSGID_SET_GS2_MOVE_SPEED					= 32852,

	AVP_MSGID_SET_HEALTH							= 32853,

	AVP_MSGID_PLAYER_OBJECTIVE_SET_MARKER_LOCATION  = 32854,
	AVP_MSGID_PLAYER_OBJECTIVE_SET_TARGET_ENTITY    = 32855,
	AVP_MSGID_PLAYER_OBJECTIVE_SET_CURRENT          = 32856,
	AVP_MSGID_PLAYER_OBJECTIVE_SET_COMPLETE         = 32857,
	AVP_MSGID_PLAYER_OBJECTIVE_SET_USE_OWN_LOCATION = 32858,
	AVP_MSGID_PLAYER_OBJECTIVE_SET_NO_MARKER        = 32859,

	AVP_MSGID_PREDATOR_LOCK_POSITION_F              = 32860, 
	AVP_MSGID_PREDATOR_LOCK_POSITION_T              = 32861, 
	AVP_MSGID_PREDATOR_LOCK_POSITION_X              = 32862, 
	AVP_MSGID_PREDATOR_LOCK_POSITION_O              = 32863, 
	AVP_MSGID_SET_PICKUPABLE						= 32864,
	AVP_MSGID_SET_NOT_PICKUPABLE					= 32865,

	AVP_MSGID_SET_DROPPABLE							= 32866,
	AVP_MSGID_SET_NOT_DROPPABLE						= 32867,

	AVP_MSGID_DEACTIVATE_OCCUPIER					= 32868,
	AVP_MSGID_DESTROY_OCCUPIER						= 32869,

	AVP_MSGID_ADD_PLAYER_PICKUP                     = 32870,

	AVP_MSGID_CHANGE_HUMANOID_KNOWLEDGE_SETTINGS	= 32871,
	
	AVP_MSGID_SET_SQUAD_ALERT_STATUS_TO_ACTIVE		= 32872,
	AVP_MSGID_SET_SQUAD_ALERT_STATUS_TO_AGGRESSIVE	= 32873,

	AVP_MSGID_SET_SENTRYGUN_SWEEP_SPEED				= 32874,
	AVP_MSGID_SET_SENTRYGUN_VISION_RANGE			= 32875,
	AVP_MSGID_SET_SENTRYGUN_HOR_FOV					= 32876,
	AVP_MSGID_SET_SENTRYGUN_VER_FOV					= 32877,
	AVP_MSGID_SET_SENTRYGUN_FIRING_ARC				= 32878,
	AVP_MSGID_SET_SENTRYGUN_LETHAL_RANGE			= 32879,

	AVP_MSGID_ATTACH_WEAPON							= 32880,
	AVP_MSGID_DETACH_WEAPON							= 32881,

	AVP_MSGID_CREATE_ATTACHMENT						= 32882,
	AVP_MSGID_DESTROY_ATTACHMENT					= 32883,
	AVP_MSGID_DETACH_ATTACHMENT						= 32884,

	AVP_MSGID_MOUNT_LIFT							= 32885,
	AVP_MSGID_DISMOUNT_LIFT							= 32886,
	AVP_MSGID_ALIENQUEEN_ADD_TO_TARGET_LIST			= 32887,
	AVP_MSGID_ALIENQUEEN_REMOVE_FROM_TARGET_LIST	= 32888,

	AVP_MSGID_START_CAMERA_SHAKE					= 32889,
	AVP_MSGID_STOP_CAMERA_SHAKE						= 32890,

	AVP_MSGID_FACEHUGGER_HUG_ENTITY					= 32891,
	AVP_MSGID_DISMEMBER								= 32892,

	AVP_MSGID_FORCE_AIM								= 32893,
	AVP_MSGID_STOP_FORCE_AIM						= 32894,

	AVP_MSGID_SENTRYGUN_DRYFIRE_TOGGLE				= 32895,

	AVP_MSGID_ALIENQUEEN_FORCE_ROAR					= 32896,
	AVP_MSGID_ALIENQUEEN_SET_BEHAVIOUR				= 32897,

	AVP_MSGID_END_OF_STATIC_MESSAGES,

    // DO NOT REORDER THE SECTION ABOVE OR DELETE ENTRIES. YOU SHOULD ONLY
    // ADD NEW ENTRIES AT THE END.

    //
    // Other messages IDs (for non-static messages).
    // The following section can be safely reordered, to keep related
    // messages grouped together, etc.
    //

    // ... non-static msg IDs here ...

	AVP_MSGID_PREDATORPLAYERCOMMANDS,
	AVP_MSGID_ALIENPLAYERCOMMANDS,
	AVP_MSGID_ALIENFACEHUGGERPLAYERCOMMANDS,
	AVP_MSGID_HUMANPLAYERCOMMANDS,
	
	// Compressed versions of the above message
	AVP_MSGID_PREDATORPLAYERCOMMANDS_COMPRESSED,
	AVP_MSGID_HUMANPLAYERCOMMANDS_COMPRESSED, 
	AVP_MSGID_ALIENPLAYERCOMMANDS_COMPRESSED, 


	AVP_MSGID_LAUNCH_PROJECTILE,

	AVP_MSGID_CREATE_GENERICPROJECTILE,
	AVP_MSGID_CREATE_PROJECTILE_DISC,
	AVP_MSGID_CREATE_PROJECTILE_FLARE,
	AVP_MSGID_CREATE_PROJECTILE_DROPSHIP_MISSILE,
	AVP_MSGID_CREATE_PROJECTILE_MINE,
	AVP_MSGID_CREATE_PROJECTILE_FLAMETHROWER,
	AVP_MSGID_CREATE_PROJECTILE_ACIDSPIT,

	AVP_MSGID_REQUEST_INTERACTION,
	AVP_MSGID_PICKUP_DISC,
    AVP_MSGID_REQUEST_ANIMATION,
	AVP_MSGID_ATTACH_CORPSE,
	AVP_MSGID_DETACH_CORPSE,
	AVP_MSGID_DETACH_ALL_CORPSES,
	AVP_MSGID_CREATEGIB,
	AVP_MSGID_RETURN_DISC,	// Disc return message (forces the disc into the rturn_to_sender state)
	AVP_MSGID_DESTROY_MINE,
	AVP_MSGID_DISC_LASER_TRACKING_ON, // Disc will follow laser
	AVP_MSGID_DISC_LASER_TRACKING_OFF, // Disc will not follow laser

	AVP_MSGID_SET_OBJECTIVE,
	AVP_MSGID_KILL_CLIENT_PLAYER,
	AVP_MSGID_USE_STIM,
	AVP_MSGID_PLAY_DIALOGUE_EVENT,
	AVP_MSGID_REGISTER_GUNFIRE_SOUND,

	// Entity-damage messages...
	AVP_MSGID_ENTITYDAMAGE_REQUEST_VICTIM,
	AVP_MSGID_ENTITYDAMAGE_REQUEST_LINEAR,
	AVP_MSGID_ENTITYDAMAGE_REQUEST_RADIAL,
	AVP_MSGID_ENTITYDAMAGE_REQUEST_VOLUME,
	AVP_MSGID_ENTITYDAMAGE_APPLY_TO_ENTITY,
	AVP_MSGID_ENTITYDAMAGE_APPLY_TO_ENVIRONMENT,
	AVP_MSGID_ENTITYDAMAGE_APPLYRADIAL_TO_BOTANICALS,
	AVP_MSGID_ENTITYDAMAGE_APPLYLINEAR_TO_BOTANICALS,

	AVP_MSGID_CREATE_ACID_DAMAGE,

	// Network game-control messages...
	AVP_MSGID_JOINGAME_REQUEST,
	AVP_MSGID_JOINGAME_RESPONSE,
	AVP_MSGID_JOINGAME_READY, 
	AVP_MSGID_GAME_TERMINATED,
	AVP_MSGID_GAME_RESTART,
	AVP_MSGID_GAME_ROTATE,
	AVP_MSGID_GAME_OVER,

	// Grapple update messages
	AVP_MSGID_GRAPPLE_ATTACKER_UPDATE,
	AVP_MSGID_GRAPPLE_VICTIM_UPDATE,
	AVP_MSGID_ACTIVEGRAPPLE_VALUE,
	AVP_MSGID_ACTIVEGRAPPLE_RESULT,

	AVP_MSGID_GRAPPLE_START,


	// Message to connect the AVP_Player and client PlayerInfo classes to their appropriate actor. Could also be used to connect the server PlayerInfo to it if we wanted.
	AVP_MSGID_SETPUPPETGUID,
	AVP_MSGID_CREATEPLAYERACTOR,

	// Multiplayer specific messages
	AVP_MSGID_SETMULTIPLAYERTEAM, 

	// Inventory-item usage messages - used by the inventory system,
	// but should now work correctly for both client and server items...
	AVP_MSGID_ITEM_BEGIN_USING,
	AVP_MSGID_ITEM_BEGIN_IDLING,
	AVP_MSGID_ITEM_REQUEST_END_USAGE,

	// Game status update messages
	AVP_MSGID_GAMESTATUS_FULLUPDATE,

	AVP_MSGID_ENABLE_IK_SOLVER,
	AVP_MSGID_DISABLE_IK_SOLVER,

	AVP_MSGID_REQUEST_MELEE,
	AVP_MSGID_COUNTER_MELEE,
	AVP_MSGID_MELEE_ATTACK_HIT,
	AVP_MSGID_MELEE_ATTACK_PREPAREGRAPPLE, // Alternative hit message, designed for moves transitioning to the new grapple moves.
	AVP_MSGID_MELEE_ATTACK_FAILED_TO_START,
	AVP_MSGID_FLINCH,
	AVP_MSGID_REQUEST_MELEE_EX,

	AVP_MSGID_INITIALISECOMPLETE,

	// Sent after a ShouldStart succeeds from the server's client's movement system (rather than whichever client is actually in control normally). Used for moves which the server has final say over, such as melee attacks.
	AVP_MSGID_MOVESTART_SERVER,

	AVP_MSGID_LEADER_MOVING_TO_AI_OBJECTIVE, // sent by AI Marine/Android squad leader to get his squad mates to move up with him
	AVP_MSGID_STOP_AI_OBJECTIVE_ACTIONS,

	AVP_MSGID_INCOMING_MELEE_STARTED,
	AVP_MSGID_INCOMING_MELEE_FINISHED,

	AVP_MSGID_SENTRYGUN_PLAYSOUND,
	AVP_MSGID_SENTRYGUN_SWITCH_PLAYANIMATION,

	AVP_MSGID_PHYSICS_REORIENTATION_RESET,

    // Pickup messages
	AVP_MSGID_COLLECT_PICKUP,
	AVP_MSGID_REQUEST_PICKUP,
	AVP_MSGID_DROP_PICKUP,
	AVP_MSGID_PLAY_REST_ANIM_PICKUP,

	// Server is informing client that it should start/stop burning. (mainly used when shot from flamethrower will put on fire enemy alien, etc...)
	AVP_MSG_CLIENT_START_BURNING,
	AVP_MSG_CLIENT_STOP_BURNING,

	AVP_MSGID_MELEE_PLAYER_BACK,

	AVP_MSGID_DISTRACT_AI,
	AVP_MSGID_PLAY_DISTRACTION_SOUND, // TODO - potentially the two distraction messages could share an ID and data. However, at the moment the sound playing doesn't need to know any data.

	// Battery messages
	AVP_MSGID_SET_TOOL_IN,
	AVP_MSGID_SET_TOOL_OUT,

	// Hacking tool messages
	AVP_MSGID_SET_HACKING_TOOL,

	AVP_MSGID_RESTORE_PREVIOUS_WEAPON,

	AVP_MSGID_INVENTORY_ITEM_RELOAD, // send message to clients to reload weapon

	AVP_MSGID_LAUNCH_ACID_SPIT_PROJECTILE, // message from axon AQ client to AQ server actor to launch an acid spit projectile

	AVP_MSGID_CLEAR_PLAYERS_LOF,

	AVP_MSGID_PICK_TEQUILA_UP,
	AVP_MSGID_PUT_TEQUILA_DOWN,

	AVP_MSGID_REQUEST_TURN,

	AVP_MSGID_LIGHT_CHANGE_EVENT_CODE,
	
	AVP_MSG_ID_MAX 
	// AVP_MSG_ID_MAX must be last - please add things above it
};
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// If you add a message to this enum don't forget to add the description to Asura_Network::Project_GetMsgIDDesc().
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////


enum AVP_INTERACTION_TYPES
{
	// Most interactions can be like this.
	AVP_INTERACTION_TYPE_DEFAULT,
	AVP_INTERACTION_TYPE_INITIALISE, //special interaction type to initialise the state of interaction objects without triggering the message blocks

	// Any special-case interaction requests here, normally only needed if the player needs to use a different button to request it, although we could also use it as a safety-check to make sure we're doing what we actually want to do.
	AVP_INTERACTION_TYPE_HEADBITE,

	AVP_INTERACTION_TYPE_PICKUP_BUDDY
};

#endif // #ifndef AVP_MESSAGES_H___
