///////////////////////////////////////////////////////////////////////////////
//
// File: AVP_ClientEntity_CameraVolume.h
//
// Created by Martin G.Harris (6/9/2006)
// 
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __AVP_CLIENT_ENTITY_CAMERA_VOLUME_H__
#define __AVP_CLIENT_ENTITY_CAMERA_VOLUME_H__

#ifdef ASURA_USE_CAMERA_VOLUME

// Includes
#include "Entity/CameraVolume/AVP_CameraVolumeData.h"
#include "Entity/Triggers/Asura_ClientEntity_CameraVolume.h"

///////////////////////////////////////
// AVP_ClientEntity_CameraVolume //
///////////////////////////////////////
class AVP_ClientEntity_CameraVolume: public Asura_ClientEntity_CameraVolume
{
	typedef Asura_ClientEntity_CameraVolume PARENT;

public:
	AVP_ClientEntity_CameraVolume(Asura_Guid uGuid);
	AVP_ClientEntity_CameraVolume(Asura_Guid uGuid, const char*& pcChunkBuffer);

	virtual ~AVP_ClientEntity_CameraVolume();

	const AVP_CameraVolumeData& GetProperty() const { return m_xProperty; }

protected:
	AVP_CameraVolumeData m_xProperty;

public:
	// Static members
	static AVP_ClientEntity_CameraVolume* FindEntity(Asura_Guid uGuid)
	{
		return static_cast<AVP_ClientEntity_CameraVolume*>(PARENT::FindEntity(uGuid));
	}

	// Find the most relevant camera volume, given the position and previous camera volume.
	// Note that this might return null if no volumes are found.
	static const AVP_ClientEntity_CameraVolume* FindVolume(const Asura_Vector_3& xPosition,
															   const Asura_Guid uPreviousVolume)
	{
		return static_cast<const AVP_ClientEntity_CameraVolume*>(PARENT::FindVolume(xPosition, uPreviousVolume));
	}

	// Friends
	friend class AVP_ServerEntity_CameraVolume;
	friend class ToolsAVP_Entity_CameraVolume;
};
#endif //ASURA_USE_CAMERA_VOLUME

#endif //__AVP_CLIENT_ENTITY_CAMERA_VOLUME_H__

