
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_Damage_BotanicalCallback.h
// Author : Andy Tate
// Date   : 11-Jan-2007
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_ENTITYDAMAGE_BOTANICALCALLBACK_H__
#define __AVP_ENTITYDAMAGE_BOTANICALCALLBACK_H__

#ifdef ASURA_USE_BOTANICALS

#include "Botanicals/Asura_Botanical_Game_Render_Type.h"
#include "Botanicals/Asura_Botanical_Game_Render_Types.h"

class Asura_BGR_Instance;
class AVP_EntityDamage_ApplyRadialToBotanicals;
class AVP_EntityDamage_ApplyLinearToBotanicals;

class AVP_EntityDamage_RadialBotanicalCallback
{
public:
	AVP_EntityDamage_RadialBotanicalCallback( const AVP_EntityDamage_ApplyRadialToBotanicals& xDamage ) : m_xDamage(xDamage) {}

	bool	ProcessInstanceHeader	(Asura_BGR_Instances_Header* pxInstanceHeader, const Asura_BGR_Type* pxInstanceType);
	bool	ProcessInstance			(Asura_BGR_Instances_Header* pxInstanceHeader, const Asura_BGR_Instance* pxInstance, const Asura_BGR_Type* pxInstanceType, const Asura_AVector3& xInstancePosition, Asura_BGR_DynamicInstance* const pxDynamicInstance);

private:
	const AVP_EntityDamage_ApplyRadialToBotanicals&	m_xDamage;				// A reference to the damage to apply.

	AVP_EntityDamage_RadialBotanicalCallback  (void);
	AVP_EntityDamage_RadialBotanicalCallback  (const AVP_EntityDamage_RadialBotanicalCallback& xOther);
	AVP_EntityDamage_RadialBotanicalCallback&	operator=	(const AVP_EntityDamage_RadialBotanicalCallback& xOther);

};   // End of class 'AVP_EntityDamage_BotanicalCallback'.

class AVP_EntityDamage_LinearBotanicalCallback
{
public:
	AVP_EntityDamage_LinearBotanicalCallback( const AVP_EntityDamage_ApplyLinearToBotanicals& xDamage ) : m_xDamage(xDamage) {}

	bool	ProcessInstanceHeader	(Asura_BGR_Instances_Header* pxInstanceHeader, const Asura_BGR_Type* pxInstanceType);
	bool	ProcessInstance			(Asura_BGR_Instances_Header* pxInstanceHeader, const Asura_BGR_Instance* pxInstance, const Asura_BGR_Type* pxInstanceType, const Asura_AVector3& xInstancePosition, Asura_BGR_DynamicInstance* const pxDynamicInstance);

private:
	const AVP_EntityDamage_ApplyLinearToBotanicals&	m_xDamage;				// A reference to the damage to apply.

	AVP_EntityDamage_LinearBotanicalCallback  (void);
	AVP_EntityDamage_LinearBotanicalCallback  (const AVP_EntityDamage_LinearBotanicalCallback& xOther);
	AVP_EntityDamage_LinearBotanicalCallback&	operator=	(const AVP_EntityDamage_LinearBotanicalCallback& xOther);

};   // End of class 'AVP_EntityDamage_BotanicalCallback'.

#endif //ifdef ASURA_USE_BOTANICALS

#endif   // ifndef __AVP_ENTITYDAMAGE_BOTANICALCALLBACK_H__


/// End of file. ///
