
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_EntityDamage_Messages.h
// Author : Andy Tate
// Date   : 20-Feb-2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_ENTITYDAMAGE_MESSAGES_H__
#define __AVP_ENTITYDAMAGE_MESSAGES_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Entity/Damage/AVP_EntityDamage_Apply.h"
#include "Entity/Damage/AVP_EntityDamage_Request.h"


////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Message_EntityDamage_ApplyRadialToBotanicals
// Author       : Andy Tate
// Date         : 20-Feb-2008
//
// Description  : Class to pass message to handle applying damage to the botanicals.
////////////////////////////////////////////////////////////////////////////////

class AVP_Message_EntityDamage_ApplyRadialToBotanicals
{
public:
	// Public functions...
	void	SetDamage(const AVP_EntityDamage_ApplyRadialToBotanicals& xData)	{ m_xData = xData; }
	void	GetDamage(AVP_EntityDamage_ApplyRadialToBotanicals& xData) const	{ xData = m_xData; }


protected:
	// Protected variables...

	// Protected functions...


private:
	// Private variables...
	AVP_EntityDamage_ApplyRadialToBotanicals	m_xData;	// The data held within this class - could be compressed.

	// Private functions...
	AVP_Message_EntityDamage_ApplyRadialToBotanicals(void);
	AVP_Message_EntityDamage_ApplyRadialToBotanicals(const AVP_Message_EntityDamage_ApplyRadialToBotanicals& xOther);
	~AVP_Message_EntityDamage_ApplyRadialToBotanicals();

	AVP_Message_EntityDamage_ApplyRadialToBotanicals&	operator=(const AVP_Message_EntityDamage_ApplyRadialToBotanicals& xOther);

};   // End of class 'AVP_Message_EntityDamage_ApplyToBotanicals'.


class AVP_Message_EntityDamage_ApplyLinearToBotanicals
{
public:
	// Public functions...
	void	SetDamage(const AVP_EntityDamage_ApplyLinearToBotanicals& xData)	{ m_xData = xData; }
	void	GetDamage(AVP_EntityDamage_ApplyLinearToBotanicals& xData) const	{ xData = m_xData; }


protected:
	// Protected variables...

	// Protected functions...


private:
	// Private variables...
	AVP_EntityDamage_ApplyLinearToBotanicals	m_xData;	// The data held within this class - could be compressed.

	// Private functions...
	AVP_Message_EntityDamage_ApplyLinearToBotanicals(void);
	AVP_Message_EntityDamage_ApplyLinearToBotanicals(const AVP_Message_EntityDamage_ApplyLinearToBotanicals& xOther);
	~AVP_Message_EntityDamage_ApplyLinearToBotanicals();

	AVP_Message_EntityDamage_ApplyLinearToBotanicals&	operator=(const AVP_Message_EntityDamage_ApplyLinearToBotanicals& xOther);

};   // End of class 'AVP_Message_EntityDamage_ApplyToBotanicals'.



////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Message_EntityDamage_ApplyToEntity
// Author       : Andy Tate
// Date         : 20-Feb-2008
//
// Description  : Class to pass message to handle applying damage to an entity.
////////////////////////////////////////////////////////////////////////////////

class AVP_Message_EntityDamage_ApplyToEntity
{
public:
	// Public functions...
	void	SetDamage(const AVP_EntityDamage_ApplyToEntity& xData)	{ m_xData = xData; }
	void	GetDamage(AVP_EntityDamage_ApplyToEntity& xData) const	{ xData = m_xData; }


protected:
	// Protected variables...

	// Protected functions...


private:
	// Private variables...
	AVP_EntityDamage_ApplyToEntity	m_xData;	// The data held within this class - could be compressed.

	// Private functions...
	AVP_Message_EntityDamage_ApplyToEntity(void);
	AVP_Message_EntityDamage_ApplyToEntity(const AVP_Message_EntityDamage_ApplyToEntity& xOther);
	~AVP_Message_EntityDamage_ApplyToEntity();

	AVP_Message_EntityDamage_ApplyToEntity&	operator=(const AVP_Message_EntityDamage_ApplyToEntity& xOther);

};   // End of class 'AVP_Message_EntityDamage_ApplyToEntity'.



////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Message_EntityDamage_ApplyToEnvironment
// Author       : Andy Tate
// Date         : 20-Feb-2008
//
// Description  : Class to pass message to handle applying damage to the environment.
////////////////////////////////////////////////////////////////////////////////

class AVP_Message_EntityDamage_ApplyToEnvironment
{
public:
	// Public functions...
	void	SetDamage(const AVP_EntityDamage_ApplyToEnvironment& xData)	{ m_xData = xData; }
	void	GetDamage(AVP_EntityDamage_ApplyToEnvironment& xData) const	{ xData = m_xData; }


protected:
	// Protected variables...

	// Protected functions...


private:
	// Private variables...
	AVP_EntityDamage_ApplyToEnvironment	m_xData;	// The data held within this class - could be compressed.

	// Private functions...
	AVP_Message_EntityDamage_ApplyToEnvironment(void);
	AVP_Message_EntityDamage_ApplyToEnvironment(const AVP_Message_EntityDamage_ApplyToEnvironment& xOther);
	~AVP_Message_EntityDamage_ApplyToEnvironment();

	AVP_Message_EntityDamage_ApplyToEnvironment&	operator=(const AVP_Message_EntityDamage_ApplyToEnvironment& xOther);

};   // End of class 'AVP_Message_EntityDamage_ApplyToEnvironment'.



////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Message_EntityDamage_RequestVictim
// Author       : Andy Tate
// Date         : 20-Feb-2008
//
// Description  : Class to pass message to handle requesting a victim to damage.
////////////////////////////////////////////////////////////////////////////////

class AVP_Message_EntityDamage_RequestVictim
{
public:
	// Public functions...
	void	SetDamage(const AVP_EntityDamage_RequestVictim& xData)	{ m_xData = xData; }
	void	GetDamage(AVP_EntityDamage_RequestVictim& xData) const	{ xData = m_xData; }


protected:
	// Protected variables...

	// Protected functions...


private:
	// Private variables...
	AVP_EntityDamage_RequestVictim	m_xData;	// The data held within this class - could be compressed.

	// Private functions...
	AVP_Message_EntityDamage_RequestVictim(void);
	AVP_Message_EntityDamage_RequestVictim(const AVP_Message_EntityDamage_RequestVictim& xOther);
	~AVP_Message_EntityDamage_RequestVictim();

	AVP_Message_EntityDamage_RequestVictim&	operator=(const AVP_Message_EntityDamage_RequestVictim& xOther);

};   // End of class 'AVP_Message_EntityDamage_RequestVictim'.



////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Message_EntityDamage_RequestLinear
// Author       : Andy Tate
// Date         : 20-Feb-2008
//
// Description  : Class to pass message to handle requesting damage linearly.
////////////////////////////////////////////////////////////////////////////////

class AVP_Message_EntityDamage_RequestLinear
{
public:
	// Public functions...
	void	SetDamage(const AVP_EntityDamage_RequestLinear& xData)	{ m_xData = xData; }
	void	GetDamage(AVP_EntityDamage_RequestLinear& xData) const	{ xData = m_xData; }


protected:
	// Protected variables...

	// Protected functions...


private:
	// Private variables...
	AVP_EntityDamage_RequestLinear	m_xData;	// The data held within this class - could be compressed.

	// Private functions...
	AVP_Message_EntityDamage_RequestLinear(void);
	AVP_Message_EntityDamage_RequestLinear(const AVP_Message_EntityDamage_RequestLinear& xOther);
	~AVP_Message_EntityDamage_RequestLinear();

	AVP_Message_EntityDamage_RequestLinear&	operator=(const AVP_Message_EntityDamage_RequestLinear& xOther);

};   // End of class 'AVP_Message_EntityDamage_RequestLinear'.



////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Message_EntityDamage_RequestRadial
// Author       : Andy Tate
// Date         : 20-Feb-2008
//
// Description  : Class to pass message to handle requesting radial-damage.
////////////////////////////////////////////////////////////////////////////////

class AVP_Message_EntityDamage_RequestRadial
{
public:
	// Public functions...
	void	SetDamage(const AVP_EntityDamage_RequestRadial& xData)	{ m_xData = xData; }
	void	GetDamage(AVP_EntityDamage_RequestRadial& xData) const	{ xData = m_xData; }


protected:
	// Protected variables...

	// Protected functions...


private:
	// Private variables...
	AVP_EntityDamage_RequestRadial	m_xData;	// The data held within this class - could be compressed.

	// Private functions...
	AVP_Message_EntityDamage_RequestRadial(void);
	AVP_Message_EntityDamage_RequestRadial(const AVP_Message_EntityDamage_RequestRadial& xOther);
	~AVP_Message_EntityDamage_RequestRadial();

	AVP_Message_EntityDamage_RequestRadial&	operator=(const AVP_Message_EntityDamage_RequestRadial& xOther);

};   // End of class 'AVP_Message_EntityDamage_RequestRadial'.



////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Message_EntityDamage_RequestVolume
// Author       : Andy Tate
// Date         : 20-Feb-2008
//
// Description  : Class to pass message to handle requesting damage in a volune.
////////////////////////////////////////////////////////////////////////////////

class AVP_Message_EntityDamage_RequestVolume
{
public:
	// Public functions...
	void	SetDamage(const AVP_EntityDamage_RequestVolume& xData)	{ m_xData = xData; }
	void	GetDamage(AVP_EntityDamage_RequestVolume& xData) const	{ xData = m_xData; }


protected:
	// Protected variables...

	// Protected functions...


private:
	// Private variables...
	AVP_EntityDamage_RequestVolume	m_xData;	// The data held within this class - could be compressed.

	// Private functions...
	AVP_Message_EntityDamage_RequestVolume(void);
	AVP_Message_EntityDamage_RequestVolume(const AVP_Message_EntityDamage_RequestVolume& xOther);
	~AVP_Message_EntityDamage_RequestVolume();

	AVP_Message_EntityDamage_RequestVolume&	operator=(const AVP_Message_EntityDamage_RequestVolume& xOther);

};   // End of class 'AVP_Message_EntityDamage_RequestVolume'.


#endif   // ifndef __AVP_ENTITYDAMAGE_MESSAGES_H__


/// End of file. ///
