//--------------------------------------------------------------------------------------
//	File	:	AVP_ServerNode_FormationPoint.cpp
//	Author	:	Gareth Thomas
//	Created	:	18 / 12 / 2007
//	Copyright (C) 2006 Rebellion, All Rights Reserved.
//--------------------------------------------------------------------------------------

// Core
#include "Core/Asura.h"

// Header
#include "Entity/Locations/FormationPoint/AVP_ServerNode_FormationPoint.h"

// Asura
#include "ChunkSystem/Asura_Chunk_Stream.h"

// AVP
#include "Entity/AVP_Entity_Classification.h"

//------------------------------------------------------------------------------
// Constants, Defines, Statics and Globals
//------------------------------------------------------------------------------
Asura_Hashed_List<AVP_ServerNode_FormationPoint> AVP_ServerNode_FormationPoint::s_xList;

//--------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------
AVP_ServerNode_FormationPoint::AVP_ServerNode_FormationPoint(const Asura_Guid uGuid)
: PARENT(uGuid)
{
	Classification = AVP_ENTITYCLASS_FORMATIONPOINT;

	SetNeverUpdateClient();
	SetNeverUpdates(true);
	s_xList.AddToList(this);
}

//--------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------
AVP_ServerNode_FormationPoint::~AVP_ServerNode_FormationPoint(void)
{
	s_xList.RemoveFromList(this);
}

//--------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------
void AVP_ServerNode_FormationPoint::PostLoadInitialise(void)
{
	PARENT::PostLoadInitialise();
}

//--------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------
void AVP_ServerNode_FormationPoint::WriteToChunkStream(Asura_Chunk_Stream& xStream) const
{
	//Version
	xStream << CURRENT_CHUNK_VERSION;

	//Parent
	PARENT::WriteToChunkStream(xStream);
}

//--------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------
void AVP_ServerNode_FormationPoint::ReadFromChunkStream(Asura_Chunk_Stream& xStream)
{
	//Version
	u_int uVersion;
	xStream	>> uVersion;

	//Parent
	PARENT::ReadFromChunkStream(xStream);
}

//--------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------
AVP_ServerNode_FormationPoint* AVP_ServerNode_FormationPoint::Create(const Asura_Guid uGuid)
{
	return(new AVP_ServerNode_FormationPoint(uGuid));
}

#ifdef ASURA_TOOLS
void AVP_ServerNode_FormationPoint::ApplyChangesForTemplateInstance( Tools_EntityTemplateInstance* pxInstance )
{
	PARENT::ApplyChangesForTemplateInstance( pxInstance );
}
#endif
