//////////////////////////////////////////////////////////////////////////////
//
// AVP_ServerNode_VantagePoint_Predator.cpp
//
// Copyright (C) 2008 Rebellion. All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// core
#include "Core/Asura.h"

// header
#include "Entity/Locations/VantagePoint/AVP_ServerNode_VantagePoint_Predator.h"

// asura
#include "ChunkSystem/Asura_Chunk_Stream.h"

// avp
#include "Entity/AVP_Entity_Classification.h"

//////////////////////////////////////////////////////////////////////////////
//
// AVP_ServerNode_VantagePoint_Predator
//
//////////////////////////////////////////////////////////////////////////////

Asura_Hashed_List< AVP_ServerNode_VantagePoint_Predator > AVP_ServerNode_VantagePoint_Predator::s_xList;

AVP_ServerNode_VantagePoint_Predator::AVP_ServerNode_VantagePoint_Predator( Asura_Guid uGuid )
: PARENT( uGuid )
{
	Classification = AVP_ENTITYCLASS_VANTAGEPOINT_PREDATOR;

	s_xList.AddToList( this );
}

AVP_ServerNode_VantagePoint_Predator::~AVP_ServerNode_VantagePoint_Predator()
{
	s_xList.RemoveFromList( this );
}

void AVP_ServerNode_VantagePoint_Predator::WriteToChunkStream( Asura_Chunk_Stream& xStream ) const
{
	xStream << CURRENT_CHUNK_VERSION;

	PARENT::WriteToChunkStream( xStream );
}

void AVP_ServerNode_VantagePoint_Predator::ReadFromChunkStream( Asura_Chunk_Stream& xStream )
{
	u_int uVersion;
	xStream >> uVersion;

	PARENT::ReadFromChunkStream( xStream );
}

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////
