
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_Messages_FaceHugger.h
// Author : Chris Wallace
// Date   : 5-Feb-2007
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_MESSAGES_FACEHUGGER_H__
#define __AVP_MESSAGES_FACEHUGGER_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Entity/PhysicalObject/Moves/Asura_Movement_System.h"

#include "Entity/PhysicalObject/Actor/Vertebrates/AVP_Vertebrate_Messages.h"
#include "Entity/PhysicalObject/Actor/Vertebrates/FaceHugger/AVP_ServerActor_FaceHugger.h"
#include "Actor/Vertebrates/Alien/AVP_Alien_JumpHandler.h"


////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////

class Asura_NetMsg;
class Asura_BitPacker;
class Asura_BitUnpacker; 
class AVP_ClientActor_FaceHugger;
class AVP_ClientEntity_Actor;

////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Message_FaceHugger_Move_JumpStart
// Author       : Andy Tate
// Date         : 5-Sep-2007
//
// Description  : Class to send jump-to-surface start move data.
////////////////////////////////////////////////////////////////////////////////

class AVP_Message_FaceHugger_Move_JumpStart : public Asura_Msg_Move
{
public:
    AVP_Message_FaceHugger_Move_JumpStart() {}
    ~AVP_Message_FaceHugger_Move_JumpStart() {}
    
    void SetDestinationOrientation(const Asura_Matrix_3x3 &xOrientation) { m_xDestinationOrientation = xOrientation; }
	void GetDestinationOrientation(Asura_Matrix_3x3 &xOrientation) const { xOrientation = m_xDestinationOrientation; }
	void SetDestinationPosition(const Asura_Vector_3& xPosition) { m_xDestinationPosition = xPosition; }
    void GetDestinationPosition(Asura_Vector_3& xPosition) const { xPosition = m_xDestinationPosition; }

private:
	Asura_Matrix_3x3	m_xDestinationOrientation;
	Asura_Vector_3	m_xDestinationPosition;


	AVP_Message_FaceHugger_Move_JumpStart(const AVP_Message_FaceHugger_Move_JumpStart& xOther);
};


struct AVP_FaceHugger_Hug_Entity
{
	void Initialise()
	{
		m_uVersion = CURRENT_MSG_VERSION;
		m_uTarget = ASURA_GUID_UNREGISTERED;
	}


	u_int m_uVersion;
	Asura_Guid m_uTarget;

private:
	enum { CURRENT_MSG_VERSION = 1 };

};

#endif   // ifndef __AVP_MESSAGES_FACEHUGGER_H__

