
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_ClientActor_Android.cpp
// Author : Andy Tate
// Modified to Android : Chris Wallace
// Date   : 3-Oct-2006
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Core/Asura.h"

// This file's header...
#include "Entity/PhysicalObject/Actor/Vertebrates/Human/Android/AVP_ClientActor_Android.h"

// Game independent header-files...
#include "Entity/AVP_Entity_Classification.h"



////////////////////////////////////////////////////////////////////////////////
// Static variable declarations...
////////////////////////////////////////////////////////////////////////////////
Asura_Hashed_List<AVP_ClientActor_Android>	AVP_ClientActor_Android::s_xList;

//------------------------------------------------------------------------------
// AVP_ClientActor_Android:: Constructor
//------------------------------------------------------------------------------
AVP_ClientActor_Android::AVP_ClientActor_Android(void)
: AVP_ClientActor_Human()
{
	Classification = AVP_ENTITYCLASS_ANDROID;

	// Don't forget to store us in the list...
	s_xList.AddToList(this);
}
/// End of function 'AVP_ClientActor_Android::AVP_ClientActor_Android'. ///

//------------------------------------------------------------------------------
// AVP_ServerActor_Android:: Deconstructor
//------------------------------------------------------------------------------
AVP_ClientActor_Android::~AVP_ClientActor_Android ()
{
	// Don't forget to remove us from the list...
	s_xList.RemoveFromList(this);
}
/// End of function 'AVP_ClientActor_Android::~AVP_ClientActor_Android'. ///

//------------------------------------------------------------------------------
// AVP_ServerActor_Android:: Create
//------------------------------------------------------------------------------
AVP_ClientActor_Android* AVP_ClientActor_Android::Create(const Asura_Message* pxMessage)
{
	AVP_ClientActor_Android*	pxClient	= new AVP_ClientActor_Android;

	// Initialise the entity...
	pxClient->HandleMessage(pxMessage);

	// Return the entity...
	return(pxClient);

}
/// End of function 'AVP_ClientActor_Android::Create'. ///

/// End of file. ///
