///////////////////////////////////////////////////////////////////////////////
// File   : AVP_ClientActor_Android.h
// Author : Gareth Thomas
// Date   : 17-12-2007
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_CLIENTACTOR_ANDROID_H__
#define __AVP_CLIENTACTOR_ANDROID_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Entity/PhysicalObject/Actor/Vertebrates/Human/AVP_ClientActor_Human.h"
#include "Sound/Asura_Sound_Event_System.h"

////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////
class AVP_ClientActor_Human;

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_ClientActor_Android
// Author       : Gareth Thomas
// Date         : 17-12-2006
// Description  : This class handles the operation of the Android actor, the
//				  Android is AI controlled.
////////////////////////////////////////////////////////////////////////////////
class AVP_ClientActor_Android : public AVP_ClientActor_Human
{

public:

	// Public functions...
	static	AVP_ClientActor_Android*	Create	(const Asura_Message* pxMessage);

	// Static Public Functions...
	static	AVP_ClientActor_Android*							FindEntity	(const Asura_Guid uGuid)	{ return(s_xList.FindEntity(uGuid)); }
	static	const Asura_Hashed_List<AVP_ClientActor_Android>*	GetList		(void)						{ return(&s_xList); }


protected:		

	// Protected functions...
	AVP_ClientActor_Android         (void);
	virtual ~AVP_ClientActor_Android	();

private:

	// Private typedefs...
	typedef AVP_ClientActor_Human PARENT;

	// Static Private Member variables
	static	Asura_Hashed_List<AVP_ClientActor_Android>	s_xList;

	// Private functions...
	AVP_ClientActor_Android (const AVP_ClientActor_Android& xOther);
	AVP_ClientActor_Android&	operator=	(const AVP_ClientActor_Android& xOther);

};   // End of class 'AVP_ClientActor_Android'.

#endif   // ifndef __AVP_CLIENTACTOR_ANDROID_H__

/// End of file. ///
