///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_ClientActor_Civilian.cpp
// Author : Gareth Thomas
// Modified to Civilian : Chris Wallace
// Date   : 12 / 02 / 2008
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////
#include "Core/Asura.h"

// This file's header...
#include "Entity/PhysicalObject/Actor/Vertebrates/Human/Civilian/AVP_ClientActor_Civilian.h"

// Game independent header-files...
#include "Core/AVP_Game_Core.h"
#include "Entity/AVP_Entity_Classification.h"
#include "Entity/PhysicalObject/Actor/Vertebrates/Human/AVP_Messages_Human.h"
#include "Moves/AVP_Moves.h"

////////////////////////////////////////////////////////////////////////////////
// Static variable declarations...
////////////////////////////////////////////////////////////////////////////////
Asura_Hashed_List<AVP_ClientActor_Civilian>	AVP_ClientActor_Civilian::s_xList;

//------------------------------------------------------------------------------
// AVP_ClientActor_Civilian:: Constructor
//------------------------------------------------------------------------------
AVP_ClientActor_Civilian::AVP_ClientActor_Civilian(void)
: PARENT()
{
	Classification = AVP_ENTITYCLASS_CIVILIAN;

	// Don't forget to store us in the list...
	s_xList.AddToList(this);
}
/// End of function 'AVP_ClientActor_Civilian::AVP_ClientActor_Civilian'. ///

//------------------------------------------------------------------------------
// AVP_ServerActor_Civilian:: Deconstructor
//------------------------------------------------------------------------------
AVP_ClientActor_Civilian::~AVP_ClientActor_Civilian ()
{
	// Don't forget to remove us from the list...
	s_xList.RemoveFromList(this);
}
/// End of function 'AVP_ClientActor_Civilian::~AVP_ClientActor_Civilian'. ///

//------------------------------------------------------------------------------
// AVP_ServerActor_Civilian:: Create
//------------------------------------------------------------------------------
AVP_ClientActor_Civilian* AVP_ClientActor_Civilian::Create(const Asura_Message* pxMessage)
{
	AVP_ClientActor_Civilian*	pxClient	= new AVP_ClientActor_Civilian;

	// Initialise the entity...
	pxClient->HandleMessage(pxMessage);

	// Return the entity...
	return(pxClient);

}
/// End of function 'AVP_ClientActor_Civilian::Create'. ///

void AVP_ClientActor_Civilian::ReadFromClientCreateStream(Asura_Chunk_Memory_Stream& xStream, float fServerTime)
{
	// Call the base-function...
	PARENT::ReadFromClientCreateStream( xStream, fServerTime );
 
	u_int uCivType;
	xStream >> uCivType;

 	m_eCivType = static_cast<AVP_ServerActor_Civilian::CivilianType>(uCivType);
}

/// End of file. ///
