
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_Messages_Predalien.cpp
// Author : Andy Tate
// Date   : 6-Oct-2006
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Core/Asura.h"

// This file's header...
#include "Entity/PhysicalObject/Actor/Vertebrates/Predalien/AVP_Messages_Predalien.h"

// Asura independent header-files...
#include "Core/Asura_BitPacker.h"
#include "Network/Asura_NetMsg.h"

// Asura platform header-files...

// Game independent header-files...
#include "Actor/Vertebrates/AVP_Vertebrate_Focus.h"
#include "Actor/Vertebrates/AVP_Vertebrate_InputHandler.h"
#include "Actor/Vertebrates/Predalien/AVP_Predalien_MeleeCounter_System.h"
#include "Entity/AVP_Entity_Classification.h"
#include "Entity/AVP_Messages.h"
#include "Entity/PhysicalObject/Actor/Vertebrates/Predalien/AVP_ClientActor_Predalien.h"
#include "Entity/PhysicalObject/Actor/Vertebrates/Predalien/AVP_ServerActor_Predalien.h"
#include "Inventory/AVP_Inventory_System.h"

#include "Core/BrainTypes/AVP_Brain_Actor_Predalien.h"
#include "Knowledge/AVP_Knowledge_System_Actor.h"

// Game platform header-files...

// Tools header-files...


////////////////////////////////////////////////////////////////////////////////
// Constant declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Static variable declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Private functions...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Protected functions...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Public functions...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Function     : AVP_Message_PredalienClientUpdate::FillPredalien
// Author       : Andy Tate
// Date         : 6-Oct-2006
////////////////////////////////////////////////////////////////////////////////

void AVP_Message_PredalienClientUpdate::FillPredalien( const AVP_ServerActor_Predalien& xPredalien )
{
	// Fill-in the base-class...
    FillVertebrate(xPredalien);

	m_uAlertLevel = AVP_Knowledge_System_Actor::AGGRESSIVE_ALERTNESS;//pxPredBrain->GetKnowledgeSystem()->GetAlertLevel();
}

/// End of function 'AVP_Message_PredalienClientUpdate::FillPredalien'. ///


#ifdef ASURA_SUPPORT_NETMSG_SYSTEM
void AVP_Message_PredalienClientUpdate::RegisterFields(u_short usMsgID, u_short usEntityClassification)
{
	Asura_Assert(usMsgID == ASURA_MSG_CLIENTUPDATE, "invalid msg ID");
	Asura_Assert(!Asura_NetMsg::FindNetMsgObject(usMsgID, usEntityClassification), "already exists");
	Asura_Assert(usEntityClassification == AVP_ENTITYCLASS_PREDALIEN, "Unexpected entity classification.");
	
	u_char ucNumFields = GetNumFields();

	Asura_NetMsg* pxNetMsg = new Asura_NetMsg(usMsgID, usEntityClassification, ucNumFields, sizeof(AVP_Message_PredalienClientUpdate));
	RegisterFields(pxNetMsg);
	pxNetMsg->EndRegistration();
}


void AVP_Message_PredalienClientUpdate::RegisterFields(Asura_NetMsg* pxNetMsg)
{
	const AVP_Message_PredalienClientUpdate xDummy;
	AVP_Message_Vertebrate_ClientUpdate::RegisterFields(pxNetMsg);

	Asura_NetMsg_RegisterIntFieldBits(pxNetMsg, xDummy, Asura_FieldType_uint_bits, 2, m_uAlertLevel, 1, Asura_Threshold_AnyChange);
}
#endif//#ifdef ASURA_SUPPORT_NETMSG_SYSTEM
