//////////////////////////////////////////////////////////////////////////////
//
// AVP_ServerEntity_InteractToolReceptacle.h
//
// Created by AJK 24/11/2008
//
// Copyright (c) 2008 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////


#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AVP_SERVERENTITY_INTERACTTOOLRECEPTACLE__
#define __AVP_SERVERENTITY_INTERACTTOOLRECEPTACLE__

// AVP
#include "Entity/PhysicalObject/Interact/AVP_ServerEntity_InteractObject.h"

class AVP_ServerEntity_InteractToolReceptacle : public AVP_ServerEntity_InteractObject
{
public:

	 enum
	 {
		 FLAG_TOOL_INSIDE       = 0x00000001,
	 };

	static AVP_ServerEntity_InteractToolReceptacle* FindEntity(Asura_Guid uGuid)				{ return s_xList.FindEntity(uGuid); }
	static const Asura_Hashed_List<AVP_ServerEntity_InteractToolReceptacle>* GetList()		{ return &s_xList; }    

	virtual void	ReadFromChunkStream(Asura_Chunk_Stream& xStream);
	virtual void	WriteToChunkStream(Asura_Chunk_Stream& xStream) const;
	virtual bool	GetHasCreateMessage() const { return true; }
	virtual void	MakeCreateMessage( Asura_Guid uRequestingClient, bool bSendGuaranteed /*= false*/ );
	virtual void	PostLoadInitialise();
	void            AttachTool(Asura_Guid uActorGuid)  const;
	void            DettachTool() const;

	bool IsToolInside()   const { return IsFlagged(FLAG_TOOL_INSIDE); }
	void SetToolInside   (bool bTrue) { bTrue ? AddFlag(FLAG_TOOL_INSIDE  ) : RemoveFlag(FLAG_TOOL_INSIDE  ); }

	u_int GetFlags() const { return m_uFlags; }

	void		SetToolGuid(const Asura_Guid uGuid) { m_uLastToolGuid = m_uToolGuid; m_uToolGuid = uGuid; }
	Asura_Guid  GetToolGuid(void) const { return m_uToolGuid; }
	Asura_Guid  GetLastUsedToolGuid(void) const { return m_uLastToolGuid; }

	void        InsertTool(Asura_Guid uToolGuid, Asura_Guid uActorGuid);
	void		RemoveTool();

#ifdef ASURA_TOOLS
	virtual void ApplyChangesForTemplateInstance( Tools_EntityTemplateInstance* pxInstance );
#endif // #ifdef ASURA_TOOLS

protected:

	AVP_ServerEntity_InteractToolReceptacle( Asura_Guid uGuid = ASURA_GUID_UNREGISTERED );
	virtual ~AVP_ServerEntity_InteractToolReceptacle();

	u_int			m_uFlags;
	Asura_Guid      m_uToolGuid;
	Asura_Guid      m_uLastToolGuid;
	Asura_Hash_ID   m_uAttachMarker;

private:

	enum
	{
		CURRENT_CHUNK_VERSION = 0,
	};

	// Flag functions
	void                    AddFlag    (u_int uFlag)       { m_uFlags |= uFlag;               }
	void                    RemoveFlag (u_int uFlag)       { m_uFlags &= ~uFlag;              }
	bool                    IsFlagged  (u_int uFlag) const { return ((m_uFlags & uFlag) != 0);}

	static Asura_Hashed_List<AVP_ServerEntity_InteractToolReceptacle> s_xList;

	typedef AVP_ServerEntity_InteractObject PARENT;

#ifdef ASURA_TOOLS
	friend class ToolsAVP_Entity_InteractToolReceptacle;
#endif

};

#endif // #ifndef __AVP_SERVERENTITY_INTERACTTOOLRECEPTACLE__
