//////////////////////////////////////////////////////////////////////////////
//
// AVP_ClientEntity_InteractBatteryReceptacle.h
//
// Created by AJK 25/11/2008
//
// Copyright (c) 2008 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef AVP_CLIENTENTITY_INTERACTBATTERYRECEPTACLE
#define AVP_CLIENTENTITY_INTERACTBATTERYRECEPTACLE

// AVP
#include "Entity/PhysicalObject/Interact/ToolReceptacle/AVP_ClientEntity_InteractToolReceptacle.h"

class AVP_Message_InteractBatteryReceptacle_ClientCreate;
class AVP_ServerEntity_Actor;

class AVP_ClientEntity_InteractBatteryReceptacle : public AVP_ClientEntity_InteractToolReceptacle
{
public:

	static void															        Create( const Asura_Message* pxMsg );
	static AVP_ClientEntity_InteractBatteryReceptacle*							FindEntity( Asura_Guid uGuid )				{ return s_xList.FindEntity( uGuid ); }
	static const Asura_Hashed_List<AVP_ClientEntity_InteractBatteryReceptacle>*	GetList()			{ return &s_xList; }

	void		    OnAlienInteraction(const Asura_Hash_ID  uAnim    );
	virtual InteractionType GetInteractionObjectType() const { return INTERACTION_TYPE_BATTERYRECEPTACLE; };
	virtual bool IsActorUsingRightInteractionItem(const AVP_ClientEntity_Actor& xActor) const;
	virtual Asura_Hash_ID GetToolAnimRelatedToMove(Asura_Hash_ID uMoveHash);
	void UpdatePredatorFocusModePFX();

	void GetMarineInsertBatteryAnimHashes  ( Asura_Hash_ID& uHUDAnimHash, Asura_Hash_ID& uTPAnimHash ) const;
	void GetMarineInsertBatteryLetGoAnimHashes( Asura_Hash_ID& uHUDAnimHash, Asura_Hash_ID& uTPAnimHash ) const;
	void GetMarineRemoveBatteryAnimHashes( Asura_Hash_ID& uHUDAnimHash, Asura_Hash_ID& uTPAnimHash ) const;
	void GetMarineRemoveGrabBatteryAnimHashes( Asura_Hash_ID& uHUDAnimHash, Asura_Hash_ID& uTPAnimHash ) const;
	void GetAlienDestroyBatteryAnimHashes   ( Asura_Hash_ID& uHUDAnimHash, Asura_Hash_ID& uTPAnimHash ) const;
	void GetPredatorUseBatteryAnimHashes( Asura_Hash_ID& uHUDAnimHash, Asura_Hash_ID& uTPAnimHash ) const;

protected:
	AVP_ClientEntity_InteractBatteryReceptacle();
	virtual ~AVP_ClientEntity_InteractBatteryReceptacle();

	void		 ProcessClientCreate( const AVP_Message_InteractBatteryReceptacle_ClientCreate* pxData, float fServerTime, bool bProcessPosAndOri );

	virtual void	      InitialiseFromBlueprint( const Asura_Blueprint& xBlueprint );
	virtual Asura_Guid	  GetToolGuidFromActor (const AVP_ServerEntity_Actor& xActor) const;

private:

	// Predator anims
	Asura_Hash_ID			m_uMarineInsertBatteryHUDAnimID;
	Asura_Hash_ID			m_uMarineInsertBatteryLetGoHUDAnimID;
	Asura_Hash_ID			m_uMarineRemoveBatteryHUDAnimID;
	Asura_Hash_ID			m_uMarineRemoveGrabBatteryHUDAnimID;
	Asura_Hash_ID			m_uMarineInsertBatteryTPAnimID;
	Asura_Hash_ID			m_uMarineInsertBatteryLetGoTPAnimID;
	Asura_Hash_ID			m_uMarineRemoveBatteryTPAnimID;
	Asura_Hash_ID			m_uMarineRemoveGrabBatteryTPAnimID;
	Asura_Hash_ID			m_uAlienDestroyBatteryHUDAnimID;
	Asura_Hash_ID			m_uAlienDestroyBatteryTPAnimID;
	Asura_Hash_ID			m_uPredatorUseBatteryHUDAnimID;
	Asura_Hash_ID			m_uPredatorUseBatteryTPAnimID;
	Asura_Hash_ID			m_uBatteryDestroyedAnimID;
	Asura_Hash_ID			m_uBatteryOnInsertAnimID;
	Asura_Hash_ID			m_uBatteryOnRemoveAnimID;

	static Asura_Hashed_List<AVP_ClientEntity_InteractBatteryReceptacle> s_xList;
	typedef AVP_ClientEntity_InteractToolReceptacle PARENT;
};

#endif // #ifndef AVP_CLIENTENTITY_INTERACTBatteryReceptacle
