//////////////////////////////////////////////////////////////////////////////
//
// AVP_ClientEntity_DamageableObject.h
//
// Copyright (c) 2007 Rebellion. All rights reserved.
//
// Description:
//
//     Physical object which can be affected by explosions (initially static)
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef ___AVP_CLIENTENTITY_DAMAGEABLEOBJECT_H___
#define ___AVP_CLIENTENTITY_DAMAGEABLEOBJECT_H___ 1

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "Entity/PhysicalObject/PhysicsObject/AVP_ClientEntity_PhysicsObject.h"

class AVP_Message_DamageableObject_ClientUpdate;
class AVP_Message_DamageableObject_ClientCreate;

// C L A S S E S /////////////////////////////////////////////////////////////

class AVP_ClientEntity_DamageableObject : public AVP_ClientEntity_PhysicsObject
{
public:
	static void							Create			(const Asura_Message* pxMessage);

	static AVP_ClientEntity_DamageableObject* FindEntity		(Asura_Guid uGuid)			{ return s_xList.FindEntity(uGuid); }
	static const Asura_Hashed_List<AVP_ClientEntity_DamageableObject>* GetList(void)		{ return &s_xList; }

	virtual bool						HandleMessage	(const Asura_Message* pxMessage);

protected:
	void	ProcessClientUpdate(const AVP_Message_DamageableObject_ClientUpdate* pxData, float fServerTime, bool bProcessPosAndOri = true);
	void	ProcessClientCreate(const AVP_Message_DamageableObject_ClientCreate* pxData, float fServerTime, bool bProcessPosAndOri = true);

	AVP_ClientEntity_DamageableObject();
	virtual ~AVP_ClientEntity_DamageableObject();

private:
	typedef AVP_ClientEntity_PhysicsObject PARENT;

	static Asura_Hashed_List<AVP_ClientEntity_DamageableObject> s_xList;
};

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

#endif // #ifndef ___AVP_CLIENTENTITY_DAMAGEABLEOBJECT_H___
