
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_DamageableObject_Messages.cpp
// Author : Andy Tate
// Date   : 13-Sep-2007
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Core/Asura.h"

// This file's header...
#include "Entity/PhysicalObject/PhysicsObject/DamageableObject/AVP_DamageableObject_Messages.h"

// Engine
#include "Network/Asura_Message.h"

#ifdef ASURA_SUPPORT_NETMSG_SYSTEM
#include "Network/Asura_NetMsg.h"
#endif //#ifdef ASURA_SUPPORT_NETMSG_SYSTEM

// Game independent header-files...
#include "Entity/AVP_Entity_Classification.h"


////////////////////////////////////////////////////////////////////////////////
// Constant declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Static variable declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Private functions...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Protected functions...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Public functions...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Function     : AVP_Message_DamageableObject_ClientUpdate::FillDamageable
// Author       : Andy Tate
// Date         : 13-Sep-2007
////////////////////////////////////////////////////////////////////////////////

void AVP_Message_DamageableObject_ClientUpdate::FillDamageable(const AVP_ServerEntity_DamageableObject* pxDamageableObj)
{
	PARENT::FillPhysics(pxDamageableObj);
}

/// End of function 'AVP_Message_DamageableObject_ClientUpdate::FillDamageable'. ///

#ifdef ASURA_SUPPORT_NETMSG_SYSTEM
void AVP_Message_DamageableObject_ClientUpdate::RegisterFields(u_short usMsgID, u_short usEntityClassification)
{
	Asura_Assert(usMsgID == ASURA_MSG_CLIENTUPDATE, "invalid msg ID");
	Asura_Assert(!Asura_NetMsg::FindNetMsgObject(usMsgID, usEntityClassification), "already exists");
	Asura_Assert(usEntityClassification == AVP_ENTITYCLASS_DAMAGEABLEOBJECT, "unexpected classification");

	u_char ucNumFields = GetNumFields();

	Asura_NetMsg* pxNetMsg = new Asura_NetMsg(usMsgID, usEntityClassification, ucNumFields, sizeof(AVP_Message_DamageableObject_ClientUpdate));
	RegisterFields(pxNetMsg);
	pxNetMsg->EndRegistration();
}

void AVP_Message_DamageableObject_ClientUpdate::RegisterFields(class Asura_NetMsg* pxNetMsg)
{
	PARENT::RegisterFields(pxNetMsg);
}
#endif//#ifdef ASURA_SUPPORT_NETMSG_SYSTEM

/// End of file. ///
