//////////////////////////////////////////////////////////////////////////////
//
// File: AVP_Pickup_Ammo.cpp
//
// (AJK - 27.08.2008) Created
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

#include "Core/Asura.h"

// This file's header.
#include "Entity/PhysicalObject/Pickup/AVP_Pickup_Ammo.h"

// ASURA
#include "Blueprint/Asura_Blueprint.h"
#include "Blueprint/Asura_Blueprint_System.h"

// AVP
#include "Blueprint/AVP_Blueprint_HashIDs.h"

AVP_Pickup_Ammo::AVP_Pickup_Ammo(Asura_Hash_ID uBlueprintHash)
: AVP_Pickup(uBlueprintHash)
, m_uAmmoTypeHash(ASURA_HASH_ID_UNSET)
, m_iScarceMinimum(0)
, m_iScarceMaximum(0)
, m_iMediumMinimum(0)
, m_iMediumMaximum(0)
, m_iPlentyMinimum(0)
, m_iPlentyMaximum(0)
{
	m_ePickupType = AVP_Pickup::PICKUP_TYPE_AMMO;
}

void AVP_Pickup_Ammo::InitFromBlueprint()
{
	Asura_Value xValue;
	Asura_Blueprint* pxBlueprint     = Asura_Blueprint_System::GetBlueprintByHashID( uAVP_BLUEPRINT_TYPE_PICKUPS, GetBlueprintHash());

	// Get Ammo Type
	if(pxBlueprint->GetParameterValueByHashID(uAVP_BLUEPRINT_PARAM_PICKUP_AMMO_TYPE, xValue))
	{
		m_uAmmoTypeHash = xValue.GetHashIDValue();
	}	
	else
	{
		Asura_Assert(false, "Blueprint doesn't have AmmoType!");
	}

	// Get Intelligent amounts
	// ScarceMinimum
	if(pxBlueprint->GetParameterValueByHashID(uAVP_BLUEPRINT_PARAM_PICKUP_SCARCE_MINIMUM, xValue))
	{
		m_iScarceMinimum = xValue.GetIntValue();
	}	
	else
	{
		Asura_Assert(false, "Blueprint doesn't have Scarce minimum parameter!");
	}

	// ScarceMaximum
	if(pxBlueprint->GetParameterValueByHashID(uAVP_BLUEPRINT_PARAM_PICKUP_SCARCE_MAXIMUM, xValue))
	{
		m_iScarceMaximum = xValue.GetIntValue();
	}	
	else
	{
		Asura_Assert(false, "Blueprint doesn't have Scarce maximum parameter!");
	}

	// MediumMinimum
	if(pxBlueprint->GetParameterValueByHashID(uAVP_BLUEPRINT_PARAM_PICKUP_MEDIUM_MINIMUM, xValue))
	{
		m_iMediumMinimum = xValue.GetIntValue();
	}	
	else
	{
		Asura_Assert(false, "Blueprint doesn't have Medium minimum parameter!");
	}

	// MediumMaximum
	if(pxBlueprint->GetParameterValueByHashID(uAVP_BLUEPRINT_PARAM_PICKUP_MEDIUM_MAXIMUM, xValue))
	{
		m_iMediumMaximum = xValue.GetIntValue();
	}	
	else
	{
		Asura_Assert(false, "Blueprint doesn't have Medium maximum parameter!");
	}

	// PlentyMinimum
	if(pxBlueprint->GetParameterValueByHashID(uAVP_BLUEPRINT_PARAM_PICKUP_PLENTY_MINIMUM, xValue))
	{
		m_iPlentyMinimum = xValue.GetIntValue();
	}	
	else
	{
		Asura_Assert(false, "Blueprint doesn't have Plenty minimum parameter!");
	}

	// PlentyMaximum
	if(pxBlueprint->GetParameterValueByHashID(uAVP_BLUEPRINT_PARAM_PICKUP_PLENTY_MAXIMUM, xValue))
	{
		m_iPlentyMaximum = xValue.GetIntValue();
	}	
	else
	{
		Asura_Assert(false, "Blueprint doesn't have Plenty maximum parameter!");
	}

	AVP_Pickup::InitFromBlueprint();
}