//////////////////////////////////////////////////////////////////////////////
//
// File: AVP_Pickup_Weapon.cpp
//
// (AJK - 27.08.2008) Created
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

#include "Core/Asura.h"

// This file's header.
#include "Entity/PhysicalObject/Pickup/AVP_Pickup_Weapon.h"

// ASURA
#include "Blueprint/Asura_Blueprint.h"
#include "Blueprint/Asura_Blueprint_System.h"

// AVP
#include "Blueprint/AVP_Blueprint_HashIDs.h"

AVP_Pickup_Weapon::AVP_Pickup_Weapon(Asura_Hash_ID uBlueprintHash)
: AVP_Pickup(uBlueprintHash)
, m_uWeaponTypeHash(ASURA_HASH_ID_UNSET)
{
	m_ePickupType = AVP_Pickup::PICKUP_TYPE_WEAPON;
}

void AVP_Pickup_Weapon::InitFromBlueprint()
{
	AVP_Pickup::InitFromBlueprint();

	Asura_Value xValue;
	Asura_Blueprint* pxBlueprint     = Asura_Blueprint_System::GetBlueprintByHashID( uAVP_BLUEPRINT_TYPE_PICKUPS, GetBlueprintHash());

	// Get Inventory item Hash
	Asura_Hash_ID uInvItemParamHash = AVP_Settings::IsMultiPlayer() ? uAVP_BLUEPRINT_PARAM_PICKUP_MULTIPLAYERINVENTORYITEMBLUEPRINT : uAVP_BLUEPRINT_PARAM_PICKUP_SINGLEPLAYERINVENTORYITEMBLUEPRINT;
	if(pxBlueprint->GetParameterValueByHashID(uInvItemParamHash, xValue))
	{
		m_uWeaponTypeHash     = xValue.GetHashIDValue();

		// Get Mass
		if((pxBlueprint = Asura_Blueprint_System::GetBlueprintByHashID( uAVP_BLUEPRINT_TYPE_INVENTORY_ITEMS, xValue.GetHashIDValue())) != NULL)
		{
			if(pxBlueprint->GetParameterValueByHashID(uAVP_BLUEPRINT_PARAM_MASS, xValue))
			{
				 
				float fMass = xValue.GetFloatValue();
				m_fInvertMass = (fMass == 0.0f) ? 1.0f : ( 1.0f / fMass );
			}
			else
			{
				Asura_Assert(false, "blueprint inventory item has no Mass param.");
			}
		}
	}
}