
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_ClientProjectile_GenericProjectile.h
// Author : Chris Wallace
// Date   : 27-June-2007
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_CLIENTPROJECTILE_ACIDSPIT_H__
#define __AVP_CLIENTPROJECTILE_ACIDSPIT_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Entity/PhysicalObject/Projectile/AVP_ClientProjectile_GenericProjectile.h"

////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////

class AVP_GenericProjectileData;
class AVP_Message_GenericProjectileClientUpdate;

////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_ClientProjectile_AcidSpit
// Author       : Callum Hope
// Date         : 17/4/09
//
// Description  : Class to handle the differences between the acid projectile and the generic one. 
////////////////////////////////////////////////////////////////////////////////

class AVP_ClientProjectile_AcidSpit : public AVP_ClientProjectile_GenericProjectile
{
public:
	// Public functions...
	static	void	Create( const Asura_Message* pxMessage );

	// Overridden functions...
	virtual	void	Update			( void );
	virtual	bool	HandleMessage	( const Asura_Message* pxMessage );

	const AVP_GenericProjectileData* GetProjectileData() const	{ return m_pxProjectileData; }

	// Static list accessors...
	static	AVP_ClientProjectile_AcidSpit*								FindEntity	( const Asura_Guid uGuid )	{ return( s_xList.FindEntity( uGuid ) ); }
	static	const Asura_Hashed_List<AVP_ClientProjectile_AcidSpit>*		GetList		( void )					{ return( &s_xList ); }

protected:

	AVP_ClientProjectile_AcidSpit          ( const AVP_Message_ProjectileClientUpdate* pxData );
	virtual ~AVP_ClientProjectile_AcidSpit ();

	void MakeImpactSplat();

private:
	// Private typedefs...
	typedef AVP_ClientProjectile_GenericProjectile PARENT;

	// Private variables...
	static	Asura_Hashed_List<AVP_ClientProjectile_AcidSpit> s_xList;

	// Private functions...
	AVP_ClientProjectile_AcidSpit  ( const AVP_ClientProjectile_AcidSpit& xOther );

	AVP_ClientProjectile_AcidSpit&	operator= ( const AVP_ClientProjectile_AcidSpit& xOther );

	void ProcessClientUpdate( const AVP_Message_GenericProjectileClientUpdate* pxData,	const float fServerTime, const bool bProcessPosAndOri = true );
};   


#endif   // ifndef __AVP_CLIENTPROJECTILE_ACIDSPIT_H__


/// End of file. ///
