
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_ClientProjectile_Disc.h
// Author : Chris Wallace
// Date   : 04-Dec-2007
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_CLIENTPROJECTILE_DISC_H__
#define __AVP_CLIENTPROJECTILE_DISC_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Entity/PhysicalObject/Projectile/AVP_ClientProjectile_GenericProjectile.h"

////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////

class Asura_Animation;
class AVP_Message_DiscClientUpdate;
class Asura_AnimationController_Animation;
class AVP_GenericProjectileData;

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_ClientProjectile_Disc
// Author       : Chris Wallace
// Date         : 04-Dec-2007
//
// Description  : Class to handle the predator Disc
////////////////////////////////////////////////////////////////////////////////

class AVP_ClientProjectile_Disc : public AVP_ClientProjectile_GenericProjectile
{
public:
	// Public functions...
	static	void	Create(const Asura_Message* pxMessage);

	virtual	bool	HandleMessage	(const Asura_Message* pxMessage);

	// Static list accessors...
	static	AVP_ClientProjectile_Disc*							FindEntity	(const Asura_Guid uGuid)	{ return(s_xList.FindEntity(uGuid)); }
	static	const Asura_Hashed_List<AVP_ClientProjectile_Disc>*	GetList		(void)						{ return(&s_xList); }

protected:
	// Protected variables...

	// Protected functions...
	virtual void PostCreateInitialise();

	AVP_ClientProjectile_Disc          (const AVP_Message_ProjectileClientUpdate* pxData);
	virtual ~AVP_ClientProjectile_Disc ();

private:

	// Private typedefs...
	typedef AVP_ClientProjectile_GenericProjectile PARENT;

	// Private variables...
	static	Asura_Hashed_List<AVP_ClientProjectile_Disc>	s_xList;

	// Private functions...
	AVP_ClientProjectile_Disc  ();
	AVP_ClientProjectile_Disc  (const AVP_ClientProjectile_Disc& xOther);
	AVP_ClientProjectile_Disc&	operator=	(const AVP_ClientProjectile_Disc& xOther);
};   // End of class 'AVP_ClientProjectile_Disc'.


#endif   // ifndef __AVP_CLIENTPROJECTILE_DISC_H__


/// End of file. ///
