//////////////////////////////////////////////////////////////////////////////
//
// AVP_ServerVehicle_Dropship.h
// Author : Sharon Galtzur
// Date   : 24-Sep-2008
//
// Copyright (c) 2007 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Core/Asura.h"

// This file's header...
#include "Entity/PhysicalObject/Projectile/AVP_ClientProjectile_DropshipMissile.h"

// Asura independent header-files...
#include "Network/Asura_Message.h"

// Game independent header-files...
#include "Entity/AVP_Entity_Classification.h"
#include "Entity/PhysicalObject/Projectile/AVP_Projectile_Messages.h"


Asura_Hashed_List<AVP_ClientProjectile_DropshipMissile>	AVP_ClientProjectile_DropshipMissile::s_xList;

AVP_ClientProjectile_DropshipMissile::AVP_ClientProjectile_DropshipMissile ( const AVP_Message_ProjectileClientUpdate* pxData )
: PARENT( pxData )
{
	Classification = AVP_ENTITYCLASS_DROPSHIP_MISSILE;

	s_xList.AddToList(this);
}

AVP_ClientProjectile_DropshipMissile::~AVP_ClientProjectile_DropshipMissile ()
{
	s_xList.RemoveFromList(this);
}

void AVP_ClientProjectile_DropshipMissile::Create (const Asura_Message *pxMessage)
{
	AVP_ClientProjectile_DropshipMissile* pxClient = new AVP_ClientProjectile_DropshipMissile( static_cast< const AVP_Message_ProjectileClientUpdate* >( pxMessage->GetData() ) );

	pxClient->HandleMessage(pxMessage);
}

/// End of file. ///
