///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_ClientProjectile_DropshipMissile.h
// Author : Sharon Galtzur
// Date   : 24-Sep-2008
//
// Copyright (c) 2007 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_CLIENTPROJECTILE_DROPSHIP_MISSILE_H__
#define __AVP_CLIENTPROJECTILE_DROPSHIP_MISSILE_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Entity/PhysicalObject/Projectile/AVP_ClientProjectile_GenericProjectile.h"

////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////

class Asura_Animation;
class Asura_AnimationController_Animation;
class AVP_GenericProjectileData;

class AVP_ClientProjectile_DropshipMissile : public AVP_ClientProjectile_GenericProjectile
{
public:
	// Public functions...
	static	void Create(const Asura_Message* pxMessage);

	// Static list accessors...
	static	AVP_ClientProjectile_DropshipMissile* FindEntity(const Asura_Guid uGuid) { return(s_xList.FindEntity(uGuid)); }
	static	const Asura_Hashed_List<AVP_ClientProjectile_DropshipMissile>* GetList(void) { return(&s_xList); }


protected:
	// Protected variables...

	// Protected functions...
	AVP_ClientProjectile_DropshipMissile(const AVP_Message_ProjectileClientUpdate* pxData);
	virtual ~AVP_ClientProjectile_DropshipMissile ();

private:

	// Private typedefs...
	typedef AVP_ClientProjectile_GenericProjectile PARENT;

	// Private variables...
	static	Asura_Hashed_List<AVP_ClientProjectile_DropshipMissile>	s_xList;

	// Private functions...
	AVP_ClientProjectile_DropshipMissile();
	AVP_ClientProjectile_DropshipMissile(const AVP_ClientProjectile_DropshipMissile& xOther);
	AVP_ClientProjectile_DropshipMissile& operator =(const AVP_ClientProjectile_DropshipMissile& xOther);
};   // End of class 'AVP_ClientProjectile_DropshipMissile'.


#endif   // ifndef __AVP_CLIENTPROJECTILE_DROPSHIP_MISSILE_H__


/// End of file. ///
