
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_ServerProjectile_Flamethrower.h
// Author : Emil Popovic
// Date   : 27 February 2009
//
// Copyright (c) 2009 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_SERVERPROJECTILE_FLAMETHROWER_H__
#define __AVP_SERVERPROJECTILE_FLAMETHROWER_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Entity/PhysicalObject/Projectile/AVP_ServerProjectile_GenericProjectile.h"


class AVP_ServerProjectile_Flamethrower : public AVP_ServerProjectile_GenericProjectile
{
public:
	// Public functions...
	static	AVP_ServerProjectile_Flamethrower* Create( const Asura_Message* pxMsg );

	// Overridden functions...
//	virtual	void Update(void);
//	virtual void Launch(const Asura_Vector_3& xPosition, const Asura_Matrix_3x3& xOrientation, const Asura_Vector_3& xVelocity, const Asura_Guid uGuidToIgnore, float fDamageMultiplier);


	// Overridden chunk-handling functions...
	virtual	void ReadFromChunkStream(Asura_Chunk_Stream& xStream);
	virtual	void WriteToChunkStream(Asura_Chunk_Stream& xStream) const;
	virtual bool CanBeSavedToChunk(void) const	{ return(false); }

	// Legacy chunk handling, to be removed as soon as possible...
	virtual	bool IsFilledFromChunkBuffer (void) const { return(false); }

	// Static list accessors...
	static	AVP_ServerProjectile_Flamethrower* FindEntity(const Asura_Guid uGuid) { return(s_xList.FindEntity(uGuid)); }
	static	const Asura_Hashed_List<AVP_ServerProjectile_Flamethrower>* GetList(void) { return(&s_xList); }

protected:
	// Protected variables...
	
	// Protected functions...
	AVP_ServerProjectile_Flamethrower(const Asura_Guid uGuid, const Asura_Message* pxMsg);
	virtual ~AVP_ServerProjectile_Flamethrower();

	// Overridden entity update functions...
	virtual	void MakeClientUpdateMessage(void);

private:

	typedef AVP_ServerProjectile_GenericProjectile PARENT;

	static		Asura_Hashed_List<AVP_ServerProjectile_Flamethrower>	s_xList;

	// Private functions...
	AVP_ServerProjectile_Flamethrower(void);
	AVP_ServerProjectile_Flamethrower(const AVP_ServerProjectile_Flamethrower& xOther);

	AVP_ServerProjectile_Flamethrower& operator =(const AVP_ServerProjectile_Flamethrower& xOther);

};   // End of class 'AVP_ServerProjectile_Flamethrower'.


#endif   // ifndef __AVP_SERVERPROJECTILE_FLAMETHROWER_H__


/// End of file. ///
