///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_PlayerInfo_Messages.h
// Author : Anthony Gregson
// Date   : 05/11/07
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef ___AVP_PLAYERINFO_MESSAGES_H___
#define ___AVP_PLAYERINFO_MESSAGES_H___

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

// asura
#include "Network/Asura_Guid.h"
#ifdef ASURA_SUPPORT_NETMSG_SYSTEM
#include "Network/Asura_NetMsg.h"
#endif // #ifdef ASURA_SUPPORT_NETMSG_SYSTEM

// AVP
#include "Entity/PlayerInfo/AVP_ClientEntity_PlayerInfo.h"
#include "Entity/PlayerInfo/AVP_ServerEntity_PlayerInfo.h"

////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

class AVP_Message_SetPuppetGuid
{
public:
    Asura_Guid GetPuppetGuid() const { return m_uPuppetGuid; }
	void SetPuppetGuid(Asura_Guid uPuppetGuid) { m_uPuppetGuid = uPuppetGuid; }

protected:
	Asura_Guid m_uPuppetGuid;
};

class AVP_Message_SetMultiplayerTeam
{
public:
	int	GetMultiplayerTeam() const { return m_iMultiplayerTeam; }
	void SetMultiplayerTeam(int iMultiplayerTeam) { m_iMultiplayerTeam = iMultiplayerTeam; }

protected:
	int	m_iMultiplayerTeam; 
};

class AVP_Message_Pickup_SetIntelligentAmount
{
public:
	enum { uCURRENT_VERSION };

    u_int m_uVersion;
	int   m_iIntelligentAmount;
};

class AVP_Message_AddPlayerObjective
{
public:
	enum { uCURRENT_VERSION };

	u_int      m_uVersion;
	Asura_Guid m_uObjectiveGuid;
};

class AVP_Message_PlayerObjectiveComplete
{
public:

	enum { uCURRENT_VERSION };

	u_int      m_uVersion;
	Asura_Guid m_uObjectiveGuid;
};

class AVP_Message_AddPlayerPickup
{
public:
	enum { uCURRENT_VERSION };

	u_int      m_uVersion;
	Asura_Guid m_uPickupGuid;
	bool       m_bSetAsCurrent;
};

class AVP_Message_PlayerInfo_ClientUpdate
{
public:
    Asura_Guid GetPuppetGuid() const { return m_uPuppetGuid; }
	void SetPuppetGuid(Asura_Guid uPuppetGuid) { m_uPuppetGuid = uPuppetGuid; }

	Asura_Guid GetPersecutorGuid() const { return m_uPersecutorGuid; }
	void SetPersecutorGuid(Asura_Guid uPersecutorGuid) { m_uPersecutorGuid = uPersecutorGuid; }

	int GetMultiplayerTeam() const { return static_cast<int>( m_cMultiplayerTeam ); }
	void SetMultiplayerTeam(int iMultiplayerTeam) { m_cMultiplayerTeam = static_cast<char>( iMultiplayerTeam ); }

	int GetMultiplayerRole() const { return static_cast<int>( m_cMultiplayerRole ); }
	void SetMultiplayerRole(int iMultiplayerRole) { m_cMultiplayerRole = static_cast<char>( iMultiplayerRole ); }

	int GetIndividualScore() const { return m_iIndividualScore; }
	void SetIndividualScore(int iIndividualScore) { m_iIndividualScore = iIndividualScore; }

	int GetMissionTime() const { return m_iMissionTime; }
	void SetMissionTime( int iMissionTime ) { m_iMissionTime = iMissionTime; }

	int GetTeamOneScore() const { return m_iTeamOneScore; }
	void SetTeamOneScore(int iTeamOneScore) { m_iTeamOneScore = iTeamOneScore; }

	int GetTeamTwoScore() const { return m_iTeamTwoScore; }
	void SetTeamTwoScore(int iTeamTwoScore) { m_iTeamTwoScore = iTeamTwoScore; }

	int GetTeamThreeScore() const { return m_iTeamThreeScore; }
	void SetTeamThreeScore(int iTeamThreeScore) { m_iTeamThreeScore = iTeamThreeScore; }

	u_int GetNumberOfKillsAsAlien() const { return static_cast<u_int>( m_usNumberOfKillsAsAlien ); }
	void SetNumberOfKillsAsAlien(u_int uKills) { m_usNumberOfKillsAsAlien = static_cast<u_short>( uKills ); }

	u_int GetNumberOfKillsAsMarine() const { return static_cast<u_int>( m_usNumberOfKillsAsMarine ); }
	void SetNumberOfKillsAsMarine(u_int uKills) { m_usNumberOfKillsAsMarine = static_cast<u_short>( uKills ); }

	u_int GetNumberOfKillsAsPredator() const { return static_cast<u_int>( m_usNumberOfKillsAsPredator ); }
	void SetNumberOfKillsAsPredator(u_int uKills) { m_usNumberOfKillsAsPredator = static_cast<u_short>( uKills ); }

	u_int GetKillStreak() const { return static_cast<u_int>( m_usKillStreak ); }
	void SetKillStreak(u_int uKillStreak) { m_usKillStreak = static_cast<u_short>( uKillStreak ); }

	u_int GetNumberOfKillAssists() const { return static_cast<u_int>( m_usNumberOfKillAssists ); }
	void SetNumberOfKillAssists(u_int uKillAssists) { m_usNumberOfKillAssists = static_cast<u_short>( uKillAssists ); }

	u_int GetNumberOfTimesKilled() const { return static_cast<u_int>( m_usNumberOfTimesKilled ); }
	void SetNumberOfTimesKilled(u_int uKilled) { m_usNumberOfTimesKilled = static_cast<u_short>( uKilled ); }

	u_int GetNumberOfHeadshots() const { return static_cast<u_int>( m_usNumberOfHeadshots ); }
	void SetNumberOfHeadshots(u_int uHeadshots) { m_usNumberOfHeadshots = static_cast<u_short>( uHeadshots ); }

	u_int GetNumberOfTrophies() const { return static_cast<u_int>( m_usNumberOfTrophies ); }
	void SetNumberOfTrophies(u_int uTrophies) { m_usNumberOfTrophies = static_cast<u_short>( uTrophies ); }

	u_int GetNumberOfHeadbites() const { return static_cast<u_int>( m_usNumberOfHeadbites ); }
	void SetNumberOfHeadbites(u_int uHeadbites) { m_usNumberOfHeadbites = static_cast<u_short>( uHeadbites ); }

	bool GetLookingAtTarget() const { return m_bLookingAtTarget != 0; }
	void SetLookingAtTarget( const bool bLookingAtTarget ) { m_bLookingAtTarget = bLookingAtTarget ? 1 : 0; }
		
	const Asura_Vector_3& GetLookAtTargetPos() const { return m_xLookAtTargetPos; }
	void SetLookAtTargetPos( const Asura_Vector_3& xTargetPos ) { m_xLookAtTargetPos = xTargetPos; }

	Asura_Guid GetLookAtTargetGuid() const { return m_uLookAtTargetGuid; }
	void SetLookAtTargetGuid( const Asura_Guid uLookAtTargetGuid ) { m_uLookAtTargetGuid = uLookAtTargetGuid; }

	Asura_Hash_ID GetLookAtTargetMP() const { return m_uLookAtTargetMP; }
	void SetLookAtTargetMP( const Asura_Hash_ID uLookAtTargetMP ) { m_uLookAtTargetMP = uLookAtTargetMP; }

	// NetMsg
#ifdef ASURA_SUPPORT_NETMSG_SYSTEM
	static void RegisterFields(u_short usMsgID, u_short usEntityClassification);
	static void RegisterFields(Asura_NetMsg* pxNetMsg);
	static u_char GetNumFields() { return static_cast<u_char>(22); }
#endif//#ifdef ASURA_SUPPORT_NETMSG_SYSTEM

protected:
	Asura_Guid		m_uPuppetGuid;
	Asura_Guid		m_uPersecutorGuid; 
	char			m_cMultiplayerTeam;
	char			m_cMultiplayerRole;
	int				m_iIndividualScore;
	int				m_iMissionTime;
	int				m_iTeamOneScore; 
	int				m_iTeamTwoScore; 
	int				m_iTeamThreeScore; 
	u_short			m_usNumberOfKillsAsAlien; 
	u_short			m_usNumberOfKillsAsMarine; 
	u_short			m_usNumberOfKillsAsPredator; 
	u_short			m_usKillStreak; 
	u_short			m_usNumberOfKillAssists; 
	u_short			m_usNumberOfTimesKilled; 
	u_short			m_usNumberOfHeadshots; 
	u_short			m_usNumberOfTrophies; 
	u_short			m_usNumberOfHeadbites;
	char			m_bLookingAtTarget;
	Asura_Vector_3	m_xLookAtTargetPos;
	Asura_Guid		m_uLookAtTargetGuid;
	Asura_Hash_ID	m_uLookAtTargetMP;
};

class AVP_Message_PlayerInfo_ClientCreate : public AVP_Message_PlayerInfo_ClientUpdate
{
public:

	void Fill(const AVP_ServerEntity_PlayerInfo* pxEntity)
	{
		m_xQuest = pxEntity->GetQuest();
	}

	void Extract(AVP_ClientEntity_PlayerInfo* pxEntity) const
	{
		pxEntity->SetQuest(m_xQuest);
	}

private:

	AVP_Player_Quest m_xQuest;
};

#endif   // ifndef ___AVP_PLAYERINFO_MESSAGES_H___

/// End of file. ///
