//
// AVP_ServerEntity_StartPoint.h
//
// Created by JG - 03 March 2009
//
// Copyright (C) 2009 Rebellion  All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AVP_SERVERENTITY_STARTPOINT_H__
#define __AVP_SERVERENTITY_STARTPOINT_H__

// Asura
#include "Entity/Spawners/Asura_ServerEntity_StartPoint.h"

class AVP_ServerEntity_StartPoint: public Asura_ServerEntity_StartPoint
{
public:
	AVP_ServerEntity_StartPoint(Asura_Guid uGuid); 
	~AVP_ServerEntity_StartPoint(); 

	void SetLastActorSpawnedGuid(Asura_Guid uLastActorSpawnedGuid)			{m_uLastActorSpawnedGuid = uLastActorSpawnedGuid; }
	Asura_Guid GetLastActorSpawnedGuid() const								{return m_uLastActorSpawnedGuid;} 

	static void CreateFromChunkBuffer(Asura_Guid uGuid, const char*& pcChunkBuffer);
	static AVP_ServerEntity_StartPoint* Create(Asura_Guid uGuid);
	
	static AVP_ServerEntity_StartPoint* FindEntity(Asura_Guid uGuid)		{ return s_xList.FindEntity(uGuid); }
	static const Asura_Hashed_List<AVP_ServerEntity_StartPoint>* GetList()	{ return &s_xList;	}

protected:
	Asura_Guid m_uLastActorSpawnedGuid;

private:
	enum { CURRENT_CHUNK_VERSION = 2 };

	static Asura_Hashed_List<AVP_ServerEntity_StartPoint> s_xList;

	typedef Asura_ServerEntity_StartPoint	PARENT;
};

#endif//__AVP_SERVERENTITY_STARTPOINT_H__