/**
*
* \file AVP_ServerEntity_VolumeTrigger.h
*
* Created by Anthony Gregson - 11/12/07
*
* Copyright (C) 2007 Rebellion, All Rights Reserved.
*
**/

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif

#ifndef __AVP_SERVERENTITY_VOLUMETRIGGER_H__
#define __AVP_SERVERENTITY_VOLUMETRIGGER_H__

/************/
/* Includes.*/
/************/
#include "Entity/Triggers/Asura_ServerEntity_VolumeTrigger.h"

class AVP_ServerEntity_PhysicalObject;

const int iAVP_VOLUME_TRIGGER_CHUNK_VERSION = 0;

enum AVP_VOLUMETRIGGER_TYPES
{
	AVP_VTT_SPECIFICGUID	= 0,

	AVP_VTT_PLAYER_ALIEN,
	AVP_VTT_PLAYER_HUMAN,
	AVP_VTT_PLAYER_PREDATOR,
	AVP_VTT_AI_ALIEN,
	AVP_VTT_AI_HUMAN,
	AVP_VTT_AI_PREDATOR,
	AVP_VTT_ANY_PLAYER,
	AVP_VTT_AI_ALIENQUEEN,

	NUM_AVP_VOLUMETRIGGER_TYPES,
};

class AVP_ServerEntity_VolumeTrigger : public Asura_ServerEntity_VolumeTrigger
{
public:
	AVP_ServerEntity_VolumeTrigger(Asura_Guid uGuid);
    virtual ~AVP_ServerEntity_VolumeTrigger();

	virtual bool IsVolumeOccupied() const;

	virtual void WriteToChunkStream(Asura_Chunk_Stream& xStream) const;
	virtual void ReadFromChunkStream(Asura_Chunk_Stream& xStream);

	static const Asura_Hashed_List<AVP_ServerEntity_VolumeTrigger>* GetList() { return &s_xList; }
	static AVP_ServerEntity_VolumeTrigger* FindEntity(Asura_Guid uGuid) { return s_xList.FindEntity(uGuid); }

	static void Create(Asura_Guid uGuid, Asura_Chunk_Stream& xStream);
#ifdef ASURA_TOOLS
	static AVP_ServerEntity_VolumeTrigger* CreateFromTools(Asura_Guid uGuid);
#endif //#ifdef ASURA_TOOLS

protected:
	// Replace the default Contains function with one that takes an entity so we can do some extra checks on it.
	bool ContainsEntity(const AVP_ServerEntity_PhysicalObject& xEntity) const;

	u_int m_uTriggerTypeFlags;

private:
	static Asura_Hashed_List<AVP_ServerEntity_VolumeTrigger> s_xList;

#ifdef ASURA_TOOLS
	static const char* s_aszAVPVolumeTypes[NUM_AVP_VOLUMETRIGGER_TYPES];
#endif

	typedef Asura_ServerEntity_VolumeTrigger PARENT;
	friend class ToolsAVP_Entity_VolumeTrigger;
};


#endif//__AVP_SERVERENTITY_VOLUMETRIGGER_H__
