
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_Trigger_Messages.h
// Author : Chris Wallace
// Date   : 06-March-2007
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_TRIGGER_MESSAGES_H__
#define __AVP_TRIGGER_MESSAGES_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

//Engine
#include "Entity/PhysicalObject/Asura_ServerEntity_PhysicalObject.h"

// Project 
#include "Entity/Triggers/AVP_ServerEntity_InteractionTrigger.h"


////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Message_InteractionTrigger_ClientUpdate
// Author       : Chris Wallace
// Date         : 06-March-2007
////////////////////////////////////////////////////////////////////////////////

class AVP_Message_InteractionTrigger_ClientUpdate
{
public:
	// Public functions...
	const Asura_OrientedVolume* GetVolume(void)const	{ return( &m_xVolume ); }
	void SetVolume(Asura_OrientedVolume xInputVolume)	{ m_xVolume = xInputVolume; }

	int GetNumVolumes(void) const						{ return(m_iNumberOfVolumes); }
	int GetListFlags (void) const						{ return(m_iListFlags); }

	void FillVolume(const AVP_ServerEntity_InteractionTrigger* pxObject)
	{
		if(pxObject->GetNumberOfVolumes()>1)
		{
			Asura_Assert(false, "Interaction Volume contains more than one volume.");
		}
		
		SetVolume(pxObject->GetVolume(0));

		m_iNumberOfVolumes	= pxObject->GetNumberOfVolumes();
		m_iListFlags		= pxObject->GetListFlags();
	}

#ifdef ASURA_SUPPORT_NETMSG_SYSTEM
	static void RegisterFields(u_short usMsgID, u_short usEntityClassification) { Asura_Assert(false, "Shouldn't be using Interaction Triggers in multiplayer maps"); }
	static void RegisterFields(class Asura_NetMsg* pxNetMsg) { Asura_Assert(false, "Shouldn't be using Interaction Triggers in multiplayer maps"); }; 
	static u_char GetNumFields() { return 0; }
#endif//#ifdef ASURA_SUPPORT_NETMSG_SYSTEM

protected:
	// Protected variables...

	Asura_OrientedVolume m_xVolume;
	int m_iNumberOfVolumes;
	int m_iListFlags;

	// Protected functions...


private:
	// Private variables...

	// Private functions...

};   // End of class 'AVP_Message_InteractionTrigger_ClientUpdate'.


#endif   // ifndef __AVP_TRIGGER_MESSAGES_H__


/// End of file. ///
