
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_Vent_Messages.h
// Author : Will Plano
// Date   : 12/03/2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_VENT_MESSAGES_H__
#define __AVP_VENT_MESSAGES_H__

#include "Core/Asura_Maths.h"

class AVP_ServerEntity_Vent;

class AVP_Message_Vent_ClientCreate
{
public:
	enum { MAX_EXIT_POINTS = 4 };

	void FillVent(const AVP_ServerEntity_Vent* pxVent);

	const Asura_Vector_3& GetPosition() const { return m_xPosition; }
	const Asura_Matrix_3x3& GetOrientation() const { return m_xOrientation; }

	bool GetStartDamaged() const { return m_bStartDamaged; }
	bool GetStartActive() const { return m_bStartActive; }
	Asura_Hash_ID GetUndamagedSkinHash() const { return m_uUndamagedSkinHash; }
	Asura_Hash_ID GetDamagedSkinHash() const { return m_uDamagedSkinHash; }

	u_int GetNumExitPoints() const { return m_uNumExitPoints; }
	const Asura_Vector_3& GetExitPointPosition(u_int uIndex) const { return m_axExitPositions[uIndex]; }
	const Asura_Vector_3& GetExitPointNormal(u_int uIndex) const { return m_axExitNormals[uIndex]; }

protected:
	~AVP_Message_Vent_ClientCreate();

private:
	Asura_Vector_3		m_xPosition;
	Asura_Matrix_3x3	m_xOrientation;
	
	bool			m_bStartDamaged;
	bool			m_bStartActive;

	Asura_Hash_ID	m_uUndamagedSkinHash;
	Asura_Hash_ID	m_uDamagedSkinHash;

	u_int m_uNumExitPoints;
	Asura_Vector_3 m_axExitPositions[MAX_EXIT_POINTS];
	Asura_Vector_3 m_axExitNormals[MAX_EXIT_POINTS];

	AVP_Message_Vent_ClientCreate  (void);
	AVP_Message_Vent_ClientCreate  (const AVP_Message_Vent_ClientCreate& xOther);
	AVP_Message_Vent_ClientCreate&	operator=	(const AVP_Message_Vent_ClientCreate& xOther);

};   // End of class 'AVP_Message_DamageableObject_ClientCreate'.

#endif // __AVP_VENT_MESSAGES_H__

/// End of file. ///
