///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_FMV.h
// Author : Catalin Arsenescu
// Date   : 24/04/08
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AVP_FMV__
#define __AVP_FMV__

#include "Core/Asura_LocalisedText.h"

class AVP_FMV
{
	public:

		static void Initialise( void );
		static void Shutdown( void );
		static bool Play( const char* szFilename, bool bLoop = false, Asura_LocalisedText_Language eOverrideLanguage = ASURA_LT_L_NUM_LANGUAGES );

		static void InitialiseFMVConsoleCommands();
		static bool ConsoleCmd_PlayFmvViaMenuByString( const char* szFilename, bool bInterrogate, bool bHelp );		

	private:
		static void Platform_Initialise( void );
		static void Platform_Shutdown( void );
		static bool Platform_Play( const char* szFilename, int iAudioStream, bool bLoop );
};

#endif

//eof
