
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_Inventory_ItemTypes.h
// Author : Will Plano
// Date   : 1/7/08
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_INVENTORY_ITEMTYPES_H__
#define __AVP_INVENTORY_ITEMTYPES_H__

//////////////////////////////////////////////////////////////////////////////
//
// AVPInventoryItemType
//
//////////////////////////////////////////////////////////////////////////////

// This is static data. Do not re-order or insert elements. Only add new types at the end
enum AVPInventoryItemType
{
	AVP_INVENTORYITEMTYPE_WEAPON_RANGED				= 0,
	AVP_INVENTORYITEMTYPE_PREDATORDISC				= 1,
	AVP_INVENTORYITEMTYPE_WEAPON_MELEE				= 2,
	AVP_INVENTORYITEMTYPE_OTHER						= 3, // DO NOT USE THIS!
	AVP_INVENTORYITEMTYPE_SMARTGUN					= 4,
	AVP_INVENTORYITEMTYPE_WEAPON_FLAMETHROWER		= 5,
	AVP_INVENTORYITEMTYPE_DROPSHIP_MISSILE			= 6,
	AVP_INVENTORYITEMTYPE_UNARMED					= 7,
	AVP_INVENTORYITEMTYPE_BATTERY   				= 8,
	AVP_INVENTORYITEMTYPE_TASER						= 9,
	AVP_INVENTORYITEMTYPE_VISION_MODE				= 10,	// A pseudo-type for safer chunk loading code.
	AVP_INVENTORYITEMTYPE_SCOPEDRIFLE				= 11,
	AVP_INVENTORYITEMTYPE_PLASMACASTER				= 12,
	AVP_INVENTORYITEMTYPE_SHOTGUN					= 13,
	AVP_INVENTORYITEMTYPE_TORCH						= 14,
	AVP_INVENTORYITEMTYPE_FLARE						= 15,
	AVP_INVENTORYITEMTYPE_STIM						= 16,
	AVP_INVENTORYITEMTYPE_CLOAK						= 17,
	AVP_INVENTORYITEMTYPE_PREDATORMINE				= 18,
	AVP_INVENTORYITEMTYPE_TEQUILA					= 19,

	NUM_AVP_INVENTORYITEMTYPES
};

//////////////////////////////////////////////////////////////////////////////
//
// AVPInventoryItemSubType
//
//////////////////////////////////////////////////////////////////////////////

// This is static data. Do not re-order or insert elements. Only add new types at the end
enum AVPInventoryItemSubType
{
	AVP_INVENTORYITEMSUBTYPE_NONE					= 0,
	AVP_INVENTORYITEMSUBTYPE_BASE					= 1,
	AVP_INVENTORYITEMSUBTYPE_DYNAMIC				= 2,
	AVP_INVENTORYITEMSUBTYPE_RANGED_WEAPON			= 3,
	NUM_AVP_INVENTORYITEMSUBTYPES
};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif   // ifndef __AVP_INVENTORY_ITEMTYPES_H__
