///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_InventoryGroup_VisionModes.h
// Author : Andy Tate
// Date   : 28-Nov-2007
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_INVENTORYGROUP_VISIONMODES_H__
#define __AVP_INVENTORYGROUP_VISIONMODES_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Inventory/AVP_Inventory_Group.h"

////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_InventoryGroup_VisionModes
// Author       : Andy Tate
// Date         : 28-Nov-2007
//
// Description  : Class to handle the inventory-group for vision-modes.
////////////////////////////////////////////////////////////////////////////////

class AVP_InventoryGroup_VisionModes : public AVP_Inventory_Group
{
public:
	AVP_InventoryGroup_VisionModes(AVP_Inventory_System& xSystem);

protected:
	virtual AVP_Inventory_Item*	CreateItemFromBlueprint(const Asura_Hash_ID uBlueprintHash, const Asura_Hash_ID uNameHash);
	virtual AVP_Inventory_Item*	CreateItemFromType( const int iType, const Asura_Hash_ID uBlueprintHash, const Asura_Hash_ID uNameHash );

private:
	typedef AVP_Inventory_Group PARENT;

	AVP_InventoryGroup_VisionModes(void);
	AVP_InventoryGroup_VisionModes(const AVP_InventoryGroup_VisionModes& xOther);
	AVP_InventoryGroup_VisionModes&	operator=(const AVP_InventoryGroup_VisionModes& xOther);
};

#endif   // ifndef __AVP_INVENTORYGROUP_VISIONMODES_H__

/// End of file. ///
