
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_InventoryItem_DynamicSubType.h
// Author : Will Plano
// Date   : 09/05/2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_INVENTIRYITEM_DYNAMICSUBTYPE_H__
#define __AVP_INVENTIRYITEM_DYNAMICSUBTYPE_H__

#include "Inventory/AVP_InventoryItem_SubType.h"

class AVP_Actor_DynamicStat;

class AVP_InventoryItem_DynamicSubType : public AVP_InventoryItem_SubType
{
public:
	AVP_InventoryItem_DynamicSubType( const int iSubType, const Asura_Hash_ID uBlueprintHashID );
	virtual ~AVP_InventoryItem_DynamicSubType() {}

	virtual void InitialiseFromBlueprint();

	virtual void ReadFromChunkStream( Asura_Chunk_Stream& xStream );
	virtual void WriteToChunkStream( Asura_Chunk_Stream& xStream ) const;

	virtual float	DecreaseQuantity(const float fQuantity);
	virtual float	IncreaseQuantity(const float fQuantity);

	virtual void	InitialiseQuantity(const float fInitial, const float fMax);

	virtual void	SetCurrentQuantity(const float fQuantity);
	virtual float	GetCurrentQuantity(void) const;

	virtual void	SetMaxQuantity(const float fQuantity);
	virtual float	GetMaxQuantity(void) const;

	virtual bool	IsEmpty(void) const;
	virtual bool	IsFull(void) const;

	virtual bool	IsDynamic() const { return m_pxDynamicAmmo != NULL; }

	void			SetDynamicAmmo( AVP_Actor_DynamicStat* pxDynamicAmmo );

protected:
	AVP_Actor_DynamicStat* m_pxDynamicAmmo;

private:
	typedef AVP_InventoryItem_SubType PARENT;

	AVP_InventoryItem_DynamicSubType(void);
	AVP_InventoryItem_DynamicSubType(const AVP_InventoryItem_DynamicSubType& xOther);
	AVP_InventoryItem_DynamicSubType&	operator=(const AVP_InventoryItem_DynamicSubType& xOther);

	static const u_int uCURRENT_CHUNK_VERSION = 0;
};

#endif   // ifndef __AVP_INVENTIRYITEM_DYNAMICSUBTYPE_H__

/// End of file. ///
