
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_InventoryItem_Stim.h
// Author : Will Plano
// Date   : 09/05/2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_INVENTORYITEM_STIM_H__
#define __AVP_INVENTORYITEM_STIM_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Inventory/AVP_Inventory_Item.h"
#include "Inventory/AVP_InventoryItem_SubType.h"

class AVP_InventoryItem_Stim : public AVP_Inventory_Item
{
public:
	enum StimUsageTypes
	{
		UT_STIM	= NUM_ITEM_USAGE_TYPES,
		NUM_STIM_USAGE_TYPES
	};

	// Public functions...
	AVP_InventoryItem_Stim( AVP_Inventory_Group& xParentGroup, const Asura_Hash_ID uBlueprintHash, const char* szName );
	virtual ~AVP_InventoryItem_Stim();

	virtual void InitialiseFromBlueprint();

	virtual void PostLoadInitialise();

	void IncreaseQuantity() { m_ppxSubTypes[0]->IncreaseQuantity( 1.0f ); }
	virtual int	GetSubTypeIndexFromUsageType(const u_int uUsageType) const { return 0; }

	virtual Asura_Animation*		CreateAnimation();
	virtual void					DestroyAnimation();
	virtual Asura_Animation*		GetAnimation( bool bCreateIfNecessary = false );
	virtual const Asura_Animation*	GetAnimation() const;

	bool IsEmpty() const;

	virtual bool GetCanUseUsageType(const u_int uUsageType, const u_int uTransitionType) const;

protected:
	// Overridden state functions...
	virtual void	OnStateChange(const u_int uOldState, const u_int uNewState);

	virtual void	UpdateClientState(AVP_ClientEntity_Actor& xClient);
	virtual void	UpdateServerState(AVP_ServerEntity_Actor& xServer);

	Asura_Animation*	m_pxAnimation;
	Asura_Hash_ID		m_uSkinHash;
	Asura_Hash_ID		m_uActorAACAHash;
	u_int				m_uStimRegenBlocks;
	u_int				m_uStimEnergyBlocksLost;
	float				m_fStimEnergyCost;

private:
	typedef AVP_Inventory_Item PARENT;

	void GetStaticDataFromBlueprint();

	AVP_InventoryItem_Stim(void);
	AVP_InventoryItem_Stim(const AVP_InventoryItem_Stim& xOther);
	AVP_InventoryItem_Stim&	operator=(const AVP_InventoryItem_Stim& xOther);
};   // End of class 'AVP_InventoryItem_Stim'.

#endif   // ifndef __AVP_INVENTORYITEM_STIM_H__

/// End of file. ///
