
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_Taser_ClientEffectsHandler.h
// Author :Chris Wallace
// Date   : 10/11/2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_TASER_CLIENTEFFECTSHANDLER_H__
#define __AVP_TASER_CLIENTEFFECTSHANDLER_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

// asura
#include "Core/Asura_HashTree.h"
#include "Rendering/Asura_Colour.h"
#include "SpecialFX/Asura_Beam_System.h"

// avp 
#include "Inventory/Items/Weapons/AVP_InventoryWeapon_Taser.h"
#include "Inventory/Items/Weapons/AVP_RangedWeapon_ClientEffectsHandler.h"

////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

class AVP_Taser_ClientEffectsHandler : public AVP_RangedWeapon_ClientEffectsHandler
{
public:

	AVP_Taser_ClientEffectsHandler( const Asura_Hash_ID uHash, const Asura_Guid uOwnerGuid );
	~AVP_Taser_ClientEffectsHandler();

	void DoTracerBeam( const Asura_Vector_3& xFirePosition, const Asura_Matrix_3x3& xFireOrientation, const float fRange, const AVP_InventoryWeapon_RangedWeapon::SubType eSubType );
};

#endif   // ifndef __AVP_TASER_CLIENTEFFECTSHANDLER_H__

/// End of file. ///
