///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_InventoryTequila_ClientEffectsHandler.h
// Author : Will Plano
// Date   : 03/03/2009
//
// Copyright (C) 2009 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_INVENTORYTEQUILA_CLIENTEFFECTSHANDLER_H__
#define __AVP_INVENTORYTEQUILA_CLIENTEFFECTSHANDLER_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Animation/IK/Asura_Animation_IK_Solver.h"
#include "Animation/IK/Asura_Animation_IK_Chain_LOS.h"

#include "Inventory/Items/Weapons/AVP_RangedWeapon_ClientEffectsHandler.h"
#include "Animation/AVP_Animation_IK_Chain_Tail.h"

class AVP_InventoryTequila_ClientEffectsHandler : public AVP_RangedWeapon_ClientEffectsHandler
{
public:

	AVP_InventoryTequila_ClientEffectsHandler( const Asura_Hash_ID uHash, const Asura_Guid uOwnerGuid );
	virtual ~AVP_InventoryTequila_ClientEffectsHandler();

	virtual Asura_Animation* CreateAnimation();

	AVP_Animation_IK_Chain_Tail& GetLeftArmChain() { return m_xLeftArmIKChain; }
	
private:
	typedef AVP_RangedWeapon_ClientEffectsHandler PARENT;

	void InitialiseAnimation();

	Asura_Animation_IK_Solver			m_xIKSolver;
	AVP_Animation_IK_Chain_Tail			m_xLeftArmIKChain;
	Asura_Animation_IK_Chain_LOS		m_xLeftLegIKChain;
	Asura_Animation_IK_Chain_LOS		m_xRightLegIKChain;

	AVP_InventoryTequila_ClientEffectsHandler(void);
	AVP_InventoryTequila_ClientEffectsHandler(const AVP_InventoryTequila_ClientEffectsHandler& xOther);

	AVP_InventoryTequila_ClientEffectsHandler&	operator=(const AVP_InventoryTequila_ClientEffectsHandler& xOther);
};

#endif   // ifndef __AVP_INVENTORYTEQUILA_CLIENTEFFECTSHANDLER_H__
