//////////////////////////////////////////////////////////////////////////////
//
// Asura_Project_LoadAndSave.cpp
//
// Copyright (c) 2003 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "Core/Asura.h"

#include "LoadAndSave/Asura_LoadAndSave.h"

#include "Botanicals/Asura_Botanical_Game_Render_Manager.h"
#include "Sound/Asura_Sound_Mixer.h"
#include "SpecialFX/Asura_Decal_System.h"

#include "Core/AVP_Game_Core.h"
#include "Network/AVP_Player.h"
#include "SpecialFX/AVP_CollisionFX_System.h"

#include "Core/Axon_System.h"

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

bool Asura_LoadAndSave::Project_AddHeader( Asura_SaveBlock_Base& xSaveBlock )
{
    return false;
}

bool Asura_LoadAndSave::Project_SaveToBuffer( Asura_SaveBlock_Base& xSaveBlock )
{
    return true;
}

bool Asura_LoadAndSave::Project_LoadFromBuffer( Asura_Chunk_Header* pxChunkHeader, Asura_Chunk_Stream& xStream )
{
    return false;
}

void Asura_LoadAndSave::Project_ResetBeforeLoad( void )
{
	Asura_Sound_Mixer_System::Reset();

#ifdef ASURA_USE_COLLISIONFX
	Asura_CollisionFX_System::Reset();
#endif //ASURA_USE_COLLISIONFX

	// reset the local player
	if (AVP_Game_Core::GetPlayer())
	{
		AVP_Game_Core::GetPlayer()->Reset();
	}

	Axon_System::Reset();

#if defined(ASURA_BGR_UPDATE_JOBS) && defined( ASURA_USE_BOTANICALS )
	Asura_BGR_Manager&	xBGRManager	= Asura_BGR_Manager::GetBGRManager();

	xBGRManager.ResetDynamicData();
#endif	// defined(ASURA_BGR_UPDATE_JOBS)
}

#ifdef ASURA_USE_STREAMING
bool Asura_LoadAndSave::Project_SaveMissionToBuffer( Asura_SaveBlock_Base& xSaveBlock )
{
    return true;
}

bool Asura_LoadAndSave::Project_LoadMissionFromBuffer( const Asura_Chunk_Header* pxChunk, const char*& pcChunkBuffer )
{
    return false;
}

void Asura_LoadAndSave::Project_ResetMissionBeforeLoad( void )
{
}
#endif //#ifdef ASURA_USE_STREAMING

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////
