//----------------------------------//----------------------------------//----------------------------------//----------------------------------
//
// File   : AVP_Human_MovesCover.h
// Author : Gareth Thomas
// Date   : 26 / 06 / 2008
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
//----------------------------------//----------------------------------//----------------------------------//----------------------------------

//----------------------------------//----------------------------------//----------------------------------//----------------------------------
#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE
//----------------------------------//----------------------------------//----------------------------------//----------------------------------

//----------------------------------//----------------------------------//----------------------------------//----------------------------------
#ifndef __AVP_HUMAN_MOVESCOVER_H__
#define __AVP_HUMAN_MOVESCOVER_H__
//----------------------------------//----------------------------------//----------------------------------//----------------------------------

//----------------------------------//----------------------------------//----------------------------------//----------------------------------
// Include files...
//----------------------------------//----------------------------------//----------------------------------//----------------------------------
#include "Entity/PhysicalObject/Moves/Asura_MoveData_Animation.h"
#include "Entity/PhysicalObject/Moves/Asura_MoveData_OrientationInterpolation.h"
#include "Entity/PhysicalObject/Moves/Asura_MoveData_PositionInterpolation.h"
#include "Entity/PhysicalObject/Actor/Vertebrates/Human/AVP_Messages_Human.h"
#include "Moves/AVP_Moves.h"


//----------------------------------//----------------------------------//----------------------------------//----------------------------------
// Forward declarations...
//----------------------------------//----------------------------------//----------------------------------//----------------------------------
class AVP_ClientActor_Human;


//----------------------------------//----------------------------------//----------------------------------//----------------------------------
// Class declaration...
//----------------------------------//----------------------------------//----------------------------------//----------------------------------



//----------------------------------//----------------------------------//----------------------------------//----------------------------------
//----------------------------------//----------------------------------//----------------------------------//----------------------------------
class AVP_Move_Human_EnterCover : public AVP_Move
{
public:
	
	AVP_Move_Human_EnterCover( Asura_Movement_System& xParentSystem ) : PARENT( xParentSystem, GetStaticHash() ) {}
	virtual const char*		GetName( void ) const	{ return( "AVP_Move_Human_EnterCover" ); }
	static Asura_Hash_ID	GetStaticHash( void )	{ return( 0x5405b27b ); } //"AVP_Move_Human_EnterCover"

protected:

	// Protected variables...
	Asura_MoveData_PositionInterpolation	m_xPositionInterpolationData;
	Asura_MoveData_OrientationInterpolation	m_xOrientationInterpolationData;

	virtual bool			Start( const Asura_Msg_Move* pxStartMsg );
	virtual	bool			ShouldStart(void) const { return true; }

private:
	typedef AVP_Move PARENT;

	AVP_Move_Human_EnterCover( void );
	AVP_Move_Human_EnterCover( const AVP_Move_Human_EnterCover& xOther );
	AVP_Move_Human_EnterCover& operator = ( const AVP_Move_Human_EnterCover& xOther );
};

//----------------------------------//----------------------------------//----------------------------------//----------------------------------
//----------------------------------//----------------------------------//----------------------------------//----------------------------------
class AVP_Move_Human_IntoPeekEmerge : public AVP_Move
{
public:

	AVP_Move_Human_IntoPeekEmerge( Asura_Movement_System& xParentSystem );
	virtual const char*		GetName( void ) const	{ return( "AVP_Move_Human_IntoPeekEmerge" ); }
	static Asura_Hash_ID	GetStaticHash( void )	{ return( 0xe036fb0a ); } //"AVP_Move_Human_IntoPeekEmerge"

	Asura_Hash_ID			GetNextMoveAnimHash( void )									{ return m_uNextMoveAnimHash; }
	void					SetNextMoveAnimHash( Asura_Hash_ID uNextMoveAnimHash )		{ m_uNextMoveAnimHash = uNextMoveAnimHash; }

protected:

	virtual bool		Start( const Asura_Msg_Move* pxStartMsg );
	virtual	bool		ShouldStart() const { return true; }

private:
	
	typedef AVP_Move PARENT;

	Asura_Hash_ID			m_uNextMoveAnimHash;

	AVP_Move_Human_IntoPeekEmerge( void );
	AVP_Move_Human_IntoPeekEmerge( const AVP_Move_Human_IntoPeekEmerge& xOther );
	AVP_Move_Human_IntoPeekEmerge& operator = ( const AVP_Move_Human_IntoPeekEmerge& xOther );
};

//----------------------------------//----------------------------------//----------------------------------//----------------------------------
//----------------------------------//----------------------------------//----------------------------------//----------------------------------
class AVP_Move_Human_PeekEmerge : public AVP_Move
{
public:

	AVP_Move_Human_PeekEmerge( Asura_Movement_System& xParentSystem );
	virtual const char*		GetName( void ) const	{ return( "AVP_Move_Human_PeekEmerge" ); }
	static Asura_Hash_ID	GetStaticHash( void )	{ return( 0xae52baaa ); } //"AVP_Move_Human_PeekEmerge"

protected:

	virtual bool		Start( const Asura_Msg_Move* pxStartMsg );
	virtual	bool		ShouldStart() const { return true; }

private:
	typedef AVP_Move PARENT;

	AVP_Move_Human_PeekEmerge( void );
	AVP_Move_Human_PeekEmerge( const AVP_Move_Human_PeekEmerge& xOther );
	AVP_Move_Human_PeekEmerge& operator = ( const AVP_Move_Human_PeekEmerge& xOther );
};

//----------------------------------//----------------------------------//----------------------------------//----------------------------------
//----------------------------------//----------------------------------//----------------------------------//----------------------------------
class AVP_Move_Human_StepOutOfCover : public AVP_Move
{
public:

	AVP_Move_Human_StepOutOfCover( Asura_Movement_System& xParentSystem );
	virtual const char*		GetName( void ) const	{ return( "AVP_Move_Human_StepOutOfCover" ); }
	static Asura_Hash_ID	GetStaticHash( void )	{ return( 0xa663999a ); } //"AVP_Move_Human_StepOutOfCover"

protected:

	virtual bool		Start( const Asura_Msg_Move* pxStartMsg );
	virtual	bool		ShouldStart() const { return true; }

	Asura_MoveData_PositionInterpolation	m_xPositionInterpolationData;

private:
	typedef AVP_Move PARENT;

	AVP_Move_Human_StepOutOfCover( void );
	AVP_Move_Human_StepOutOfCover( const AVP_Move_Human_StepOutOfCover& xOther );
	AVP_Move_Human_StepOutOfCover& operator = ( const AVP_Move_Human_StepOutOfCover& xOther );
};

//----------------------------------//----------------------------------//----------------------------------//----------------------------------
#endif // __AVP_HUMAN_MOVESCOVER_H__
//----------------------------------//----------------------------------//----------------------------------//----------------------------------