///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_Human_MovesMelee.h
// Author : Anthony Gregson
// Date   : 22/02/08
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_HUMAN_MOVES_MELEE_H__
#define __AVP_HUMAN_MOVES_MELEE_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Entity/PhysicalObject/Moves/Asura_MoveData_Animation.h"
#include "Moves/Vertebrates/AVP_MovesMelee.h"

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Human_Move_Melee_FaceHugger_Countered
////////////////////////////////////////////////////////////////////////////////

class AVP_Human_Move_Melee_CounterFaceHugger : public AVP_Move_Melee
{
public:
	// Public functions...
	AVP_Human_Move_Melee_CounterFaceHugger(Asura_Movement_System& xParentSystem);


	// Accessor functions...
	static Asura_Hash_ID GetStaticHash() { return 0x016f84f0; } // Asura_GetHashID("AVP_Human_Move_Melee_CounterFaceHugger")); }

protected:

	virtual bool Start(const Asura_Msg_Move* pxStartMsg);

	Asura_Hash_ID m_uCurrentFirstPersonMeleeBlueprint;
	Asura_Hash_ID m_uCurrentThirdPersonMeleeBlueprint;

private:
	// Private typedef...
	typedef AVP_Move_Melee PARENT;
};

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Human_Move_Melee_Retaliation_Start
//
// **********************************************
// *************** NOTE : AI ONLY ***************
// **********************************************
//
////////////////////////////////////////////////////////////////////////////////
class AVP_Human_Move_Melee_Retaliation_Start : public AVP_Move_Melee
{

public:

	AVP_Human_Move_Melee_Retaliation_Start( Asura_Movement_System& xParentSystem );

	static Asura_Hash_ID GetStaticHash() { return 0x8a6c9658; } // { Asura_Get_Hash_ID( "AVP_Human_Move_Melee_Retaliation_Start" ); }

protected:

	Asura_MoveData_OrientationInterpolation	m_xOrientationInterpolationData;
	
	virtual bool Start( const Asura_Msg_Move* pxStartMsg );

private:

	typedef AVP_Move_Melee PARENT;
};

#endif   // ifndef __AVP_HUMAN_MOVES_MELEE_H__
