///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_Predalien_MovesMelee.h
// Author : Chris Wallace
// Date   : 25-Jan-2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_PREDALIEN_MOVES_MELEE_H__
#define __AVP_PREDALIEN_MOVES_MELEE_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////


#include "Entity/PhysicalObject/Moves/Asura_MoveData_Animation.h"

#include "Moves/Vertebrates/AVP_MovesMelee.h"


////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Close range stand attacks
////////////////////////////////////////////////////////////////////////////////

class AVP_Predalien_Move_Melee_ClawRight_Start : public AVP_Move_Melee_GenericAttack_Start
{
public:
	AVP_Predalien_Move_Melee_ClawRight_Start(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return(0x3b77ef84); } //"AVP_Predalien_Move_Melee_ClawRight_Start"

protected:

private:
	typedef AVP_Move_Melee_GenericAttack_Start PARENT;
};

class AVP_Predalien_Move_Melee_ClawRight_Return_Hit : public AVP_Move_Melee_GenericAttack_Return_Hit
{
public:
	AVP_Predalien_Move_Melee_ClawRight_Return_Hit(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);
	static Asura_Hash_ID GetStaticHash() { return(0xc1536222); } //"AVP_Predalien_Move_Melee_ClawRight_Return_Hit"

protected:

private:
	typedef AVP_Move_Melee_GenericAttack_Return_Hit PARENT;
};


class AVP_Predalien_Move_Melee_ClawRight_Return_Countered : public AVP_Move_Melee_GenericAttack_Return_Countered
{
public:
	AVP_Predalien_Move_Melee_ClawRight_Return_Countered(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return(0xe1743aea); } //"AVP_Predalien_Move_Melee_ClawRight_Return_Countered"

protected:

private:
	typedef AVP_Move_Melee_GenericAttack_Return_Countered PARENT;
};

class AVP_Predalien_Move_Melee_ClawRight_Return_Miss : public AVP_Move_Melee_GenericAttack_Return_Miss
{
public:
	AVP_Predalien_Move_Melee_ClawRight_Return_Miss(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return(0x691b284d); } //"AVP_Predalien_Move_Melee_ClawRight_Return_Miss"

protected:

private:
	typedef AVP_Move_Melee_GenericAttack_Return_Miss PARENT;
}; 



// left
class AVP_Predalien_Move_Melee_ClawLeft_Start : public AVP_Move_Melee_GenericAttack_Start
{
public:
	AVP_Predalien_Move_Melee_ClawLeft_Start(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return(0x52a96685); } //"AVP_Predalien_Move_Melee_ClawLeft_Start"

protected:

private:
	typedef AVP_Move_Melee_GenericAttack_Start PARENT;
};

class AVP_Predalien_Move_Melee_ClawLeft_Return_Hit : public AVP_Move_Melee_GenericAttack_Return_Hit
{
public:
	AVP_Predalien_Move_Melee_ClawLeft_Return_Hit(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);
	static Asura_Hash_ID GetStaticHash() { return(0x932923c1); } //"AVP_Predalien_Move_Melee_ClawLeft_Return_Hit"

protected:

private:
	typedef AVP_Move_Melee_GenericAttack_Return_Hit PARENT;
};


class AVP_Predalien_Move_Melee_ClawLeft_Return_Countered : public AVP_Move_Melee_GenericAttack_Return_Countered
{
public:
	AVP_Predalien_Move_Melee_ClawLeft_Return_Countered(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return(0xad340949); } //"AVP_Predalien_Move_Melee_ClawLeft_Return_Countered"

protected:

private:
	typedef AVP_Move_Melee_GenericAttack_Return_Countered PARENT;
};


class AVP_Predalien_Move_Melee_ClawLeft_Return_Miss : public AVP_Move_Melee_GenericAttack_Return_Miss
{
public:
	AVP_Predalien_Move_Melee_ClawLeft_Return_Miss(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return(0xd1fd9a8e); } //"AVP_Predalien_Move_Melee_ClawLeft_Return_Miss"

protected:

private:
	typedef AVP_Move_Melee_GenericAttack_Return_Miss PARENT;
}; 


////////////////////////////////////////////////////////////////////////////////
// Close range stand attacks - back
////////////////////////////////////////////////////////////////////////////////
class AVP_Predalien_Move_Melee_TailRight : public AVP_Move_Melee
{
public:
	AVP_Predalien_Move_Melee_TailRight(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return(0x86d8b190); } //"AVP_Predalien_Move_Melee_TailRight"

protected:

private:
	typedef AVP_Move_Melee PARENT;
};


class AVP_Predalien_Move_Melee_TailLeft : public AVP_Move_Melee
{
public:
	AVP_Predalien_Move_Melee_TailLeft(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return(0x98fbf213); } //"AVP_Predalien_Move_Melee_TailLeft"

protected:

private:
	typedef AVP_Move_Melee PARENT;
};

////////////////////////////////////////////////////////////////////////////////
// Close range walk attacks
////////////////////////////////////////////////////////////////////////////////

class AVP_Predalien_Move_Melee_WalkClawRight_Start : public AVP_Move_Melee_GenericAttack_Start
{
public:
	AVP_Predalien_Move_Melee_WalkClawRight_Start(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	virtual bool Start( const Asura_Msg_Move* pxStartMsg );
	virtual bool CalculateVelocity(const float fTimeStep, Asura_AVector3_OutParam xVelocity) const;
	virtual bool CalculateOrientation(const float fTimeStep, Asura_Quat& xOrientation) const;
	virtual void UpdateStates(const float fTimeStep);

	static Asura_Hash_ID GetStaticHash() { return(0xf4e6709b); } //"AVP_Predalien_Move_Melee_WalkClawRight_Start"

protected:

private:

	mutable float m_fAnimTime;
	mutable Asura_Vector_3 m_xTargetStartPosition;
	Asura_Guid m_uTarget;
	float m_fVelocityMultiplier;

	typedef AVP_Move_Melee_GenericAttack_Start PARENT;
};

class AVP_Predalien_Move_Melee_WalkClawRight_Return_Hit : public AVP_Move_Melee_GenericAttack_Return_Hit
{
public:
	AVP_Predalien_Move_Melee_WalkClawRight_Return_Hit(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);
	static Asura_Hash_ID GetStaticHash() { return(0x050cf76b); } //"AVP_Predalien_Move_Melee_WalkClawRight_Return_Hit"

protected:

private:
	typedef AVP_Move_Melee_GenericAttack_Return_Hit PARENT;
};


class AVP_Predalien_Move_Melee_WalkClawRight_Return_Countered : public AVP_Move_Melee_GenericAttack_Return_Countered
{
public:
	AVP_Predalien_Move_Melee_WalkClawRight_Return_Countered(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return(0xcc90f573); } //"AVP_Predalien_Move_Melee_WalkClawRight_Return_Countered"

protected:

private:
	typedef AVP_Move_Melee_GenericAttack_Return_Countered PARENT;
};

class AVP_Predalien_Move_Melee_WalkClawRight_Return_Miss : public AVP_Move_Melee_GenericAttack_Return_Miss
{
public:
	AVP_Predalien_Move_Melee_WalkClawRight_Return_Miss(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return(0x9c943c24); } //"AVP_Predalien_Move_Melee_WalkClawRight_Return_Miss"

protected:

private:
	typedef AVP_Move_Melee_GenericAttack_Return_Miss PARENT;
}; 


// left
class AVP_Predalien_Move_Melee_WalkClawLeft_Start : public AVP_Move_Melee_GenericAttack_Start
{
public:
	AVP_Predalien_Move_Melee_WalkClawLeft_Start(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	virtual bool Start( const Asura_Msg_Move* pxStartMsg );
	virtual bool CalculateVelocity(const float fTimeStep, Asura_AVector3_OutParam xVelocity) const;
	virtual bool CalculateOrientation(const float fTimeStep, Asura_Quat& xOrientation) const;
	virtual void UpdateStates(const float fTimeStep);

	static Asura_Hash_ID GetStaticHash() { return(0x716ae68e); } //"AVP_Predalien_Move_Melee_WalkClawLeft_Start"

protected:

private:

	mutable float m_fAnimTime;
	mutable Asura_Vector_3 m_xTargetStartPosition;
	Asura_Guid m_uTarget;
	float m_fVelocityMultiplier;

	typedef AVP_Move_Melee_GenericAttack_Start PARENT;
};

class AVP_Predalien_Move_Melee_WalkClawLeft_Return_Hit : public AVP_Move_Melee_GenericAttack_Return_Hit
{
public:
	AVP_Predalien_Move_Melee_WalkClawLeft_Return_Hit(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);
	static Asura_Hash_ID GetStaticHash() { return(0x00b34158); } //"AVP_Predalien_Move_Melee_WalkClawLeft_Return_Hit"

protected:

private:
	typedef AVP_Move_Melee_GenericAttack_Return_Hit PARENT;
};


class AVP_Predalien_Move_Melee_WalkClawLeft_Return_Countered : public AVP_Move_Melee_GenericAttack_Return_Countered
{
public:
	AVP_Predalien_Move_Melee_WalkClawLeft_Return_Countered(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return(0x93c159a0); } //"AVP_Predalien_Move_Melee_WalkClawLeft_Return_Countered"

protected:

private:
	typedef AVP_Move_Melee_GenericAttack_Return_Countered PARENT;
};


class AVP_Predalien_Move_Melee_WalkClawLeft_Return_Miss : public AVP_Move_Melee_GenericAttack_Return_Miss
{
public:
	AVP_Predalien_Move_Melee_WalkClawLeft_Return_Miss(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return(0x15b72fd7); } //"AVP_Predalien_Move_Melee_WalkClawLeft_Return_Miss"

protected:

private:
	typedef AVP_Move_Melee_GenericAttack_Return_Miss PARENT;
}; 

////////////////////////////////////////////////////////////////////////////////
// Stand -> Leap Attack
////////////////////////////////////////////////////////////////////////////////
class AVP_Predalien_Move_Melee_LeapAttack_Telegraph : public AVP_Move
{
public:
	AVP_Predalien_Move_Melee_LeapAttack_Telegraph(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return(0xe3cac1d1); } //"AVP_Predalien_Move_Melee_LeapAttack_Telegraph"

protected:

	virtual bool Start(const Asura_Msg_Move* pxStartMsg);

private:

	Asura_MoveData_OrientationInterpolation	m_xOrientationInterpolationData;

	typedef AVP_Move PARENT;
};

class AVP_Predalien_Move_Melee_LeapAttack_HitWall : public AVP_Move
{
public:
	AVP_Predalien_Move_Melee_LeapAttack_HitWall(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return(0x6ae9450a); } //"AVP_Predalien_Move_Melee_LeapAttack_HitWall"

protected:

	virtual	bool ShouldStart() const;

private:

	typedef AVP_Move PARENT;
};


class AVP_Predalien_Move_Melee_LeapAttack_Start : public AVP_Move_Melee_GenericAttack_Start
{
public:
	AVP_Predalien_Move_Melee_LeapAttack_Start(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);
	static Asura_Hash_ID GetStaticHash() { return(0xd6a54ccf); } //"AVP_Predalien_Move_Melee_LeapAttack_Start"

	bool SetFromMessage(const Asura_Msg_Move* pxStartMsg);

	bool ShouldGrapple() const;
	bool ShouldHitWall() const;

protected:
	virtual void CheckStatesToStart();
	virtual bool Start(const Asura_Msg_Move* pxStartMsg);
	virtual void UpdateStates(const float fTimeStep);
	virtual bool CalculateVelocity(const float fTimeStep, Asura_AVector3_OutParam xVelocity) const;
	virtual bool CalculateOrientation(const float fTimeStep, Asura_Quat& xOrientation) const;
	virtual	bool ShouldStart() const { return true; }
	virtual bool HasFinished() const;
	virtual bool HandleMessage( const Asura_Message* pxMessage );


	void UpdateTargetPosition(float fTimeStep);
	void UpdateShouldHitWall();

private:

	Asura_MoveData_OrientationInterpolation m_xOrientationInterpolationData;
	// Asura_Quat m_xOrientationForVelocity;
	Asura_Vector_3 m_xTargetPosition;
	Asura_Vector_3 m_xToTargetDirection;
	float m_fToTargetDistance;
	Asura_Guid m_uTargetGuid;
	mutable float m_fAnimationTime;
	Asura_MoveData_OrientationInterpolation m_xOrientationInterpolationDummy;
	bool m_bHitWall;
	bool m_bShouldGrapple;

	typedef AVP_Move_Melee_GenericAttack_Start PARENT;
};

class AVP_Predalien_Move_Melee_LeapAttack_Return_Hit : public AVP_Move_Melee_GenericAttack_Return_Hit
{
public:
	AVP_Predalien_Move_Melee_LeapAttack_Return_Hit(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);
	static Asura_Hash_ID GetStaticHash() { return(0x4cf39bb7); } //"AVP_Predalien_Move_Melee_LeapAttack_Return_Hit"
	
protected:

	virtual bool ShouldStart() const;

private:
	typedef AVP_Move_Melee_GenericAttack_Return_Hit PARENT;
};


class AVP_Predalien_Move_Melee_LeapAttack_Return_Countered : public AVP_Move_Melee_GenericAttack_Return_Countered
{
public:
	AVP_Predalien_Move_Melee_LeapAttack_Return_Countered(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return(0x424630bf); } //"AVP_Predalien_Move_Melee_LeapAttack_Return_Countered"

protected:

	virtual	bool ShouldStart() const;

private:
	typedef AVP_Move_Melee_GenericAttack_Return_Countered PARENT;
};

class AVP_Predalien_Move_Melee_LeapAttack_Return_Miss : public AVP_Move_Melee_GenericAttack_Return_Miss
{
public:
	AVP_Predalien_Move_Melee_LeapAttack_Return_Miss(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return(0x51822158); } //"AVP_Predalien_Move_Melee_LeapAttack_Return_Miss"

protected:

	virtual	bool ShouldStart() const;

private:
	typedef AVP_Move_Melee_GenericAttack_Return_Miss PARENT;
}; 

class AVP_Predalient_Move_Melee_PredatorGrapple_Start : public AVP_Move_Melee_GenericPuppeteer_Start
{
public:
	AVP_Predalient_Move_Melee_PredatorGrapple_Start(Asura_Movement_System& xParentSystem);

	static Asura_Hash_ID GetStaticHash() { return 0x2cce36af; } //"AVP_Predalient_Move_Melee_PredatorGrapple_Start"

protected:

	virtual bool ShouldStart() const;

private:
	typedef AVP_Move_Melee_GenericPuppeteer_Start PARENT;
};

class AVP_Predalien_Move_Melee_PredatorGrapple_Kill : public AVP_Move_Melee_GenericPuppeteer_Success
{
public:
	AVP_Predalien_Move_Melee_PredatorGrapple_Kill(Asura_Movement_System& xParentSystem);

	static Asura_Hash_ID GetStaticHash() { return 0xea6a7081; } //"AVP_Predalien_Move_Melee_PredatorGrapple_Kill"

private:
	typedef AVP_Move_Melee_GenericPuppeteer_Success PARENT;
};

class AVP_Predalien_Move_Melee_PredatorGrapple_Countered : public AVP_Move_Melee_GenericPuppeteer_Countered
{
public:
	AVP_Predalien_Move_Melee_PredatorGrapple_Countered(Asura_Movement_System& xParentSystem);

	static Asura_Hash_ID GetStaticHash() { return 0xb5f45c58; } //"AVP_Predalien_Move_Melee_PredatorGrapple_Countered"

private:
	typedef AVP_Move_Melee_GenericPuppeteer_Countered PARENT;
};

////////////////////////////////////////////////////////////////////////////////
// Jump Down Attack
////////////////////////////////////////////////////////////////////////////////
class AVP_Predalien_Move_Melee_JumpDownAttack_Start : public AVP_Move
{
public:
	AVP_Predalien_Move_Melee_JumpDownAttack_Start(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return(0xf30e6537); } //"AVP_Predalien_Move_Melee_JumpDownAttack_Start"

protected:

	virtual bool Start(const Asura_Msg_Move* pxStartMsg);

private:

	Asura_MoveData_PositionInterpolation m_xPositionInterpolationData;
	Asura_MoveData_OrientationInterpolation	m_xOrientationInterpolationData;

	typedef AVP_Move PARENT;
};


class AVP_Predalien_Move_Melee_JumpDownAttack_MoveDown : public AVP_Move_Melee_GenericAttack_Start
{
public:
	AVP_Predalien_Move_Melee_JumpDownAttack_MoveDown(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);
	static Asura_Hash_ID GetStaticHash() { return(0x638742fe); } //"AVP_Predalien_Move_Melee_JumpDownAttack_MoveDown"

	bool SetFromMessage(const Asura_Msg_Move* pxStartMsg);

protected:
	virtual bool Start(const Asura_Msg_Move* pxStartMsg);
	virtual	bool ShouldStart() const { return true; }

private:

	Asura_Vector_3 m_xTargetPosition;

	Asura_MoveData_PositionInterpolation m_xPositionInterpolationData;


	typedef AVP_Move_Melee_GenericAttack_Start PARENT;
};

class AVP_Predalien_Move_Melee_JumpDownAttack_Return_Hit : public AVP_Move_Melee_GenericAttack_Return_Hit
{
public:
	AVP_Predalien_Move_Melee_JumpDownAttack_Return_Hit(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);
	static Asura_Hash_ID GetStaticHash() { return(0x2ff1844f); } //"AVP_Predalien_Move_Melee_JumpDownAttack_Return_Hit"

protected:

private:
	typedef AVP_Move_Melee_GenericAttack_Return_Hit PARENT;
};


class AVP_Predalien_Move_Melee_JumpDownAttack_Return_Countered : public AVP_Move_Melee_GenericAttack_Return_Countered
{
public:
	AVP_Predalien_Move_Melee_JumpDownAttack_Return_Countered(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return(0x41e94757); } //"AVP_Predalien_Move_Melee_JumpDownAttack_Return_Countered"

protected:

private:
	typedef AVP_Move_Melee_GenericAttack_Return_Countered PARENT;
};

class AVP_Predalien_Move_Melee_JumpDownAttack_Return_Miss : public AVP_Move_Melee_GenericAttack_Return_Miss
{
public:
	AVP_Predalien_Move_Melee_JumpDownAttack_Return_Miss(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return(0xce414bc0); } //"AVP_Predalien_Move_Melee_JumpDownAttack_Return_Miss"

protected:

private:
	typedef AVP_Move_Melee_GenericAttack_Return_Miss PARENT;
}; 

class AVP_Predalien_Move_Melee_JumpDownAttack_SuperHit : public AVP_Move
{
public:
	AVP_Predalien_Move_Melee_JumpDownAttack_SuperHit(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return(0x05fce143); } //"AVP_Predalien_Move_Melee_JumpDownAttack_SuperHit"

private:

	typedef AVP_Move PARENT;
};

////////////////////////////////////////////////////////////////////////////////
// Being knocked down
////////////////////////////////////////////////////////////////////////////////
class AVP_Predalien_Move_KnockedDown_Start : public AVP_Move
{
public:
	AVP_Predalien_Move_KnockedDown_Start(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return(0x2a2ff247); } //"AVP_Predalien_Move_KnockedDown_Start"

protected:

private:

	typedef AVP_Move PARENT;
};


class AVP_Predalien_Move_KnockedDown_Middle : public AVP_Move
{
public:
	AVP_Predalien_Move_KnockedDown_Middle(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return(0x10f76850); } //"AVP_Predalien_Move_KnockedDown_Middle"

protected:

private:

	typedef AVP_Move PARENT;
};

class AVP_Predalien_Move_KnockedDown_Finish : public AVP_Move
{
public:
	AVP_Predalien_Move_KnockedDown_Finish(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return(0x050a1b4e); } //"AVP_Predalien_Move_KnockedDown_Finish"

protected:

private:

	typedef AVP_Move PARENT;
};


#endif   // ifndef __AVP_PREDALIEN_MOVES_MELEE_H__

/// End of file. ///
