///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_Predator_MovesMelee.h
// Author : Chris Wallace
// Date   : 25-Jan-2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_PREDATOR_MOVES_MELEE_H__
#define __AVP_PREDATOR_MOVES_MELEE_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Entity/PhysicalObject/Moves/Asura_MoveData_Animation.h"

#include "Moves/Vertebrates/AVP_MovesMelee.h"


////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////

class Asura_AnimationAttachment;

////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_MeleeCharge_Start
// Author       : Anthony Gregson
// Date         : 02/05/08
////////////////////////////////////////////////////////////////////////////////

class AVP_Predator_Move_MeleeCharge_Start : public AVP_Move_Melee
{
public:
	// Public functions...
	AVP_Predator_Move_MeleeCharge_Start(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);
	//	virtual ~AVP_Predator_Move_MeleeCharge_Start();

	static Asura_Hash_ID GetStaticHash() { return 0x9C0B9E81; } //Asura_GetHashID("AVP_Predator_Move_MeleeCharge_Start");

protected:
	// Overridden functions...

private:
	// Private typedef...
	typedef AVP_Move_Melee PARENT;
};   // End of class 'AVP_Predator_Move_MeleeCharge_Start'.


////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_MeleeCharge_Loop
// Author       : Anthony Gregson
// Date         : 02/05/08
////////////////////////////////////////////////////////////////////////////////

class AVP_Predator_Move_MeleeCharge_Loop : public AVP_Move_Melee
{
public:
	// Public functions...
	AVP_Predator_Move_MeleeCharge_Loop(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);
	//	virtual ~AVP_Predator_Move_MeleeCharge_Loop();

	static Asura_Hash_ID GetStaticHash() { return 0xAA2EACA5; } //Asura_GetHashID("AVP_Predator_Move_MeleeCharge_Loop");

protected:
	// Overridden functions...
	virtual bool ShouldStart() const { return true; }

private:
	// Private typedef...
	typedef AVP_Move_Melee PARENT;
};   // End of class 'AVP_Predator_Move_MeleeCharge_Loop'.


////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_MeleeCharge_End
// Author       : Anthony Gregson
// Date         : 28/05/08
////////////////////////////////////////////////////////////////////////////////

class AVP_Predator_Move_MeleeCharge_End : public AVP_Move_Melee
{
public:
	// Public functions...
	AVP_Predator_Move_MeleeCharge_End(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);
	//	virtual ~AVP_Predator_Move_MeleeCharge_End();

	static Asura_Hash_ID GetStaticHash() { return 0x91E05EBA; } //Asura_GetHashID("AVP_Predator_Move_MeleeCharge_End");

protected:
	// Overridden functions...

private:
	// Private typedef...
	typedef AVP_Move_Melee PARENT;
};   // End of class 'AVP_Predator_Move_MeleeCharge_End'.


////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_Wristblade_QuickAttack_Start
// Author       : Anthony Gregson
// Date         : 02/05/08
////////////////////////////////////////////////////////////////////////////////

class AVP_Predator_Move_Melee_Wristblade_QuickAttack_Start : public AVP_Move_Melee_GenericAttack_Start
{
public:
	// Public functions...
	AVP_Predator_Move_Melee_Wristblade_QuickAttack_Start(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);
	//	virtual ~AVP_Predator_Move_Melee_Wristblade_QuickAttack_Start();

	// Accessor functions...
	static Asura_Hash_ID GetStaticHash() { return(0x0DA27EB7); } // Asura_GetHashID("AVP_Predator_Move_Melee_Wristblade_QuickAttack_Start")); }

protected:
	virtual bool Start(const Asura_Msg_Move* pxStartMsg);

private:

	Asura_MoveData_OrientationInterpolation m_xOrientationInterpolationData;

	// Private typedef...
	typedef AVP_Move_Melee_GenericAttack_Start PARENT;
};   // End of class 'AVP_Predator_Move_Melee_Wristblade_QuickAttack_Start'.




////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_Wristblade_QuickAttack_Return_Hit
// Author       : Anthony Gregson
// Date         : 02/05/08
////////////////////////////////////////////////////////////////////////////////

class AVP_Predator_Move_Melee_Wristblade_QuickAttack_Return_Hit : public AVP_Move_Melee_GenericAttack_Return_Hit
{
public:
	// Public functions...
	AVP_Predator_Move_Melee_Wristblade_QuickAttack_Return_Hit(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);
	//	virtual ~AVP_Predator_Move_Melee_Wristblade_QuickAttack_Return_Hit();

	// Accessor functions...
	static Asura_Hash_ID GetStaticHash() { return(0x15715ACF); } // Asura_GetHashID("AVP_Predator_Move_Melee_Wristblade_QuickAttack_Return_Hit")); }

protected:
	static const char* s_szParameterNameLeft;
	static const char* s_szParameterNameRight;

private:
	// Private typedef...
	typedef AVP_Move_Melee_GenericAttack_Return_Hit PARENT;
};   // End of class 'AVP_Predator_Move_Melee_Wristblade_QuickAttack_Return_Hit'.



////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_Wristblade_QuickAttack_Return_Countered
// Author       : Anthony Gregson
// Date         : 02/05/08
////////////////////////////////////////////////////////////////////////////////

class AVP_Predator_Move_Melee_Wristblade_QuickAttack_Return_Countered : public AVP_Move_Melee_GenericAttack_Return_Countered
{
public:
	// Public functions...
	AVP_Predator_Move_Melee_Wristblade_QuickAttack_Return_Countered(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);
	//	virtual ~AVP_Predator_Move_Melee_Wristblade_QuickAttack_Return_Countered();

	// Accessor functions...
	static Asura_Hash_ID GetStaticHash() { return(0xB4CE3DD7); } // Asura_GetHashID("AVP_Predator_Move_Melee_Wristblade_QuickAttack_Return_Countered")); }

protected:
	static const char* s_szParameterNameLeft;
	static const char* s_szParameterNameRight;

private:
	// Private typedef...
	typedef AVP_Move_Melee_GenericAttack_Return_Countered PARENT;
};   // End of class 'AVP_Predator_Move_Melee_Wristblade_QuickAttack_Return_Countered'.


////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_Wristblade_QuickAttack_Return_Miss
// Author       : Anthony Gregson
// Date         : 02/05/08
////////////////////////////////////////////////////////////////////////////////

class AVP_Predator_Move_Melee_Wristblade_QuickAttack_Return_Miss : public AVP_Move_Melee_GenericAttack_Return_Miss
{
public:
	// Public functions...
	AVP_Predator_Move_Melee_Wristblade_QuickAttack_Return_Miss(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);
	//	virtual ~AVP_Predator_Move_Melee_Wristblade_QuickAttack_Return_Miss();

	// Accessor functions...
	static Asura_Hash_ID GetStaticHash() { return(0x98BC4540); } // Asura_GetHashID("AVP_Predator_Move_Melee_Wristblade_QuickAttack_Return_Miss")); }

protected:
	static const char* s_szParameterNameLeft;
	static const char* s_szParameterNameRight;

private:
	// Private typedef...
	typedef AVP_Move_Melee_GenericAttack_Return_Miss PARENT;
};   // End of class 'AVP_Predator_Move_Melee_Wristblade_QuickAttack_Return_Miss'.


////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_Wristblade_PowerAttack_Start
// Author       : Anthony Gregson
// Date         : 02/05/08
////////////////////////////////////////////////////////////////////////////////

class AVP_Predator_Move_Melee_Wristblade_PowerAttack_Start : public AVP_Move_Melee_GenericAttack_Start
{
public:
	// Public functions...
	AVP_Predator_Move_Melee_Wristblade_PowerAttack_Start(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);
	//	virtual ~AVP_Predator_Move_Melee_Wristblade_PowerAttack_Start();

	// Accessor functions...
	static Asura_Hash_ID GetStaticHash() { return(0xA6DDFDCF); } // Asura_GetHashID("AVP_Predator_Move_Melee_Wristblade_PowerAttack_Start")); }

protected:

private:
	// Private typedef...
	typedef AVP_Move_Melee_GenericAttack_Start PARENT;
};   // End of class 'AVP_Predator_Move_Melee_Wristblade_PowerAttack_Start'.




////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_Wristblade_PowerAttack_Return_Hit
// Author       : Anthony Gregson
// Date         : 02/05/08
////////////////////////////////////////////////////////////////////////////////

class AVP_Predator_Move_Melee_Wristblade_PowerAttack_Return_Hit : public AVP_Move_Melee_GenericAttack_Return_Hit
{
public:
	// Public functions...
	AVP_Predator_Move_Melee_Wristblade_PowerAttack_Return_Hit(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);
	//	virtual ~AVP_Predator_Move_Melee_Wristblade_PowerAttack_Return_Hit();

	// Accessor functions...
	static Asura_Hash_ID GetStaticHash() { return(0xE9818AB7); } // Asura_GetHashID("AVP_Predator_Move_Melee_Wristblade_PowerAttack_Return_Hit")); }

protected:

private:
	// Private typedef...
	typedef AVP_Move_Melee_GenericAttack_Return_Hit PARENT;
};   // End of class 'AVP_Predator_Move_Melee_Wristblade_PowerAttack_Return_Hit'.



////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_Wristblade_PowerAttack_Return_Countered
// Author       : Anthony Gregson
// Date         : 02/05/08
////////////////////////////////////////////////////////////////////////////////

class AVP_Predator_Move_Melee_Wristblade_PowerAttack_Return_Countered : public AVP_Move_Melee_GenericAttack_Return_Countered
{
public:
	// Public functions...
	AVP_Predator_Move_Melee_Wristblade_PowerAttack_Return_Countered(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);
	//	virtual ~AVP_Predator_Move_Melee_Wristblade_PowerAttack_Return_Countered();

	// Accessor functions...
	static Asura_Hash_ID GetStaticHash() { return(0x7264DFBF); } // Asura_GetHashID("AVP_Predator_Move_Melee_Wristblade_PowerAttack_Return_Countered")); }

protected:

private:
	// Private typedef...
	typedef AVP_Move_Melee_GenericAttack_Return_Countered PARENT;
};   // End of class 'AVP_Predator_Move_Melee_Wristblade_PowerAttack_Return_Countered'.


////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_Wristblade_PowerAttack_Return_Miss
// Author       : Anthony Gregson
// Date         : 02/05/08
////////////////////////////////////////////////////////////////////////////////

class AVP_Predator_Move_Melee_Wristblade_PowerAttack_Return_Miss : public AVP_Move_Melee_GenericAttack_Return_Miss
{
public:
	// Public functions...
	AVP_Predator_Move_Melee_Wristblade_PowerAttack_Return_Miss(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);
	//	virtual ~AVP_Predator_Move_Melee_Wristblade_PowerAttack_Return_Miss();

	// Accessor functions...
	static Asura_Hash_ID GetStaticHash() { return(0x46B21258); } // Asura_GetHashID("AVP_Predator_Move_Melee_Wristblade_PowerAttack_Return_Miss")); }

protected:

private:
	// Private typedef...
	typedef AVP_Move_Melee_GenericAttack_Return_Miss PARENT;
};   // End of class 'AVP_Predator_Move_Melee_Wristblade_PowerAttack_Return_Miss'.


////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_Wristblade_SlowAttack
// Author       : Chris Wallace
// Date         : 30-Jan-2008
////////////////////////////////////////////////////////////////////////////////

class AVP_Predator_Move_Melee_Wristblade_SlowAttack : public AVP_Move_Melee
{
public:
	// Public functions...
	AVP_Predator_Move_Melee_Wristblade_SlowAttack(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);
	//	virtual ~AVP_Predator_Move_Melee_Wristblade_SlowAttack();

	// Accessor functions...
	static Asura_Hash_ID GetStaticHash() { return(0x66EC63CA); } // Asura_GetHashID("AVP_Predator_Move_Melee_Wristblade_SlowAttack")); }

protected:

private:
	// Private typedef...
	typedef AVP_Move_Melee PARENT;
};   // End of class 'AVP_Predator_Move_Melee_Wristblade_SlowAttack'.


////////////////////////////////////////////////////////////////////////////////
// Block and counter
////////////////////////////////////////////////////////////////////////////////


class AVP_Predator_Move_Melee_FarCounter : public AVP_Move_Melee
{
public:
	// Public functions...
	AVP_Predator_Move_Melee_FarCounter(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);
	//	virtual ~AVP_Predator_Move_Melee_FarCounter();

	// Accessor functions...
	static Asura_Hash_ID GetStaticHash() { return 0xACB787FA; } // Asura_GetHashID("AVP_Predator_Move_Melee_FarCounter")); }

protected:

private: 
	// Private typedef...
	typedef AVP_Move_Melee PARENT;
};   // End of class 'AVP_Predator_Move_Melee_FarCounter'.


class AVP_Predator_Move_Melee_CounterAlienJumpAttack_Throw : public AVP_Move_Melee
{
public:
	AVP_Predator_Move_Melee_CounterAlienJumpAttack_Throw(Asura_Movement_System& xParentSystem, const Asura_Hash_ID uHash);
	//	virtual ~AVP_Predator_Move_Melee_CounterAlienJumpAttack_Throw_Left();

protected:
	virtual bool Start(const Asura_Msg_Move* pxStartMsg);

private:
	// Private typedef...
	typedef AVP_Move_Melee PARENT;
};


class AVP_Predator_Move_Melee_CounterAlienJumpAttack_Throw_Left : public AVP_Predator_Move_Melee_CounterAlienJumpAttack_Throw
{
public:
	// Public functions...
	AVP_Predator_Move_Melee_CounterAlienJumpAttack_Throw_Left(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);
	//	virtual ~AVP_Predator_Move_Melee_CounterAlienJumpAttack_Throw_Left();

	// Accessor functions...
	static Asura_Hash_ID GetStaticHash() { return 0xD5825FA9; } // Asura_GetHashID("AVP_Predator_Move_Melee_CounterAlienJumpAttack_Throw_Left")); }

protected:

private:
	// Private typedef...
	typedef AVP_Predator_Move_Melee_CounterAlienJumpAttack_Throw PARENT;
};   // End of class 'AVP_Predator_Move_Melee_CounterAlienJumpAttack_Throw_Left'.


class AVP_Predator_Move_Melee_CounterAlienJumpAttack_Throw_Right : public AVP_Predator_Move_Melee_CounterAlienJumpAttack_Throw
{
public:
	// Public functions...
	AVP_Predator_Move_Melee_CounterAlienJumpAttack_Throw_Right(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);
	//	virtual ~AVP_Predator_Move_Melee_CounterAlienJumpAttack_Throw_Right();

	// Accessor functions...
	static Asura_Hash_ID GetStaticHash() { return 0xDB1FF6BA; } // Asura_GetHashID("AVP_Predator_Move_Melee_CounterAlienJumpAttack_Throw_Right")); }

protected:

private:
	// Private typedef...
	typedef AVP_Predator_Move_Melee_CounterAlienJumpAttack_Throw PARENT;
};   // End of class 'AVP_Predator_Move_Melee_CounterAlienJumpAttack_Throw_Right'.


class AVP_Predator_Move_Melee_CounterAlienJumpAttack_Hit_Left : public AVP_Move_Melee
{
public:
	// Public functions...
	AVP_Predator_Move_Melee_CounterAlienJumpAttack_Hit_Left(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);
	//	virtual ~AVP_Predator_Move_Melee_CounterAlienJumpAttack_Hit_Left();

	// Accessor functions...
	static Asura_Hash_ID GetStaticHash() { return 0xB8FABD5C; } // Asura_GetHashID("AVP_Predator_Move_Melee_CounterAlienJumpAttack_Hit_Left")); }

protected:
	virtual void UpdateStates(const float fTimeStep);

private:
	// Private typedef...
	typedef AVP_Move_Melee PARENT;
};   // End of class 'AVP_Predator_Move_Melee_CounterAlienJumpAttack_Hit_Left'.


class AVP_Predator_Move_Melee_CounterAlienJumpAttack_Hit_Right : public AVP_Move_Melee
{
public:
	// Public functions...
	AVP_Predator_Move_Melee_CounterAlienJumpAttack_Hit_Right(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);
	//	virtual ~AVP_Predator_Move_Melee_CounterAlienJumpAttack_Hit_Right();

	// Accessor functions...
	static Asura_Hash_ID GetStaticHash() { return 0x66B34F67; } // Asura_GetHashID("AVP_Predator_Move_Melee_CounterAlienJumpAttack_Hit_Right")); }

protected:
	virtual void UpdateStates(const float fTimeStep);

private:
	// Private typedef...
	typedef AVP_Move_Melee PARENT;
};   // End of class 'AVP_Predator_Move_Melee_CounterAlienJumpAttack_Hit_Right'.



////////////////////////////////////////////////////////////////////////////////
// Quick finishing moves (don't attach to enemy)
////////////////////////////////////////////////////////////////////////////////

class AVP_Predator_Move_Melee_QuickFinisher_Start : public AVP_Move_Melee_GenericAttack_Start
{
public:
	// Public functions...
	AVP_Predator_Move_Melee_QuickFinisher_Start(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);
	//	virtual ~AVP_Predator_Move_Melee_QuickFinisher_Start();

	// Accessor functions...
	static Asura_Hash_ID GetStaticHash() { return(0x93CFF9BB); } // Asura_GetHashID("AVP_Predator_Move_Melee_QuickFinisher_Start")); }

protected:

private:
	// Private typedef...
	typedef AVP_Move_Melee_GenericAttack_Start PARENT;
};   // End of class 'AVP_Predator_Move_Melee_QuickFinisher_Start'.


class AVP_Predator_Move_Melee_QuickFinisher_Return_Hit : public AVP_Move_Melee_GenericAttack_Return_Hit
{
public:
	// Public functions...
	AVP_Predator_Move_Melee_QuickFinisher_Return_Hit(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);
	//	virtual ~AVP_Predator_Move_Melee_QuickFinisher_Return_Hit();

	// Accessor functions...
	static Asura_Hash_ID GetStaticHash() { return(0x4E4C224B); } // Asura_GetHashID("AVP_Predator_Move_Melee_QuickFinisher_Return_Hit")); }

protected:

private:
	// Private typedef...
	typedef AVP_Move_Melee_GenericAttack_Return_Hit PARENT;
};   // End of class 'AVP_Predator_Move_Melee_QuickFinisher_Return_Hit'.


class AVP_Predator_Move_Melee_QuickFinisher_Return_Countered : public AVP_Move_Melee_GenericAttack_Return_Countered
{
public:
	// Public functions...
	AVP_Predator_Move_Melee_QuickFinisher_Return_Countered(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);
	//	virtual ~AVP_Predator_Move_Melee_QuickFinisher_Return_Countered();

	// Accessor functions...
	static Asura_Hash_ID GetStaticHash() { return(0xF9BC7853); } // Asura_GetHashID("AVP_Predator_Move_Melee_QuickFinisher_Return_Countered")); }

protected:

private:
	// Private typedef...
	typedef AVP_Move_Melee_GenericAttack_Return_Countered PARENT;
};   // End of class 'AVP_Predator_Move_Melee_QuickFinisher_Return_Countered'.


class AVP_Predator_Move_Melee_QuickFinisher_Return_Miss : public AVP_Move_Melee_GenericAttack_Return_Miss
{
public:
	// Public functions...
	AVP_Predator_Move_Melee_QuickFinisher_Return_Miss(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);
	//	virtual ~AVP_Predator_Move_Melee_QuickFinisher_Return_Miss();

	// Accessor functions...
	static Asura_Hash_ID GetStaticHash() { return(0x7B3A6D44); } // Asura_GetHashID("AVP_Predator_Move_Melee_QuickFinisher_Return_Miss")); }

protected:

private:
	// Private typedef...
	typedef AVP_Move_Melee_GenericAttack_Return_Miss PARENT;
};   // End of class 'AVP_Predator_Move_Melee_QuickFinisher_Return_Miss'.



////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_CounterAlienLeftClawAttack
// Author       : Anthony Gregson
// Date         : 12/03/08
////////////////////////////////////////////////////////////////////////////////

class AVP_Predator_Move_Melee_CounterAlienLeftClawAttack : public AVP_Move_Melee_GenericPuppeteer_Start
{
public:
	// Public functions...
	AVP_Predator_Move_Melee_CounterAlienLeftClawAttack(Asura_Movement_System& xParentSystem);
	//	virtual ~AVP_Predator_Move_Melee_CounterAlienLeftClawAttack();

	// Accessor functions...
	static Asura_Hash_ID GetStaticHash() { return(0xF91A5AAE); } // Asura_GetHashID("AVP_Predator_Move_Melee_CounterAlienLeftClawAttack")); }

protected:

private:
	// Private typedef...
	typedef AVP_Move_Melee_GenericPuppeteer_Start PARENT;
};   // End of class 'AVP_Predator_Move_Melee_CounterAlienLeftClawAttack'.


////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_CounterAlienRightClawAttack
// Author       : Anthony Gregson
// Date         : 12/03/08
////////////////////////////////////////////////////////////////////////////////

class AVP_Predator_Move_Melee_CounterAlienRightClawAttack : public AVP_Move_Melee_GenericPuppeteer_Start
{
public:
	// Public functions...
	AVP_Predator_Move_Melee_CounterAlienRightClawAttack(Asura_Movement_System& xParentSystem);
	//	virtual ~AVP_Predator_Move_Melee_CounterAlienRightClawAttack();

	// Accessor functions...
	static Asura_Hash_ID GetStaticHash() { return(0x88935283); } // Asura_GetHashID("AVP_Predator_Move_Melee_CounterAlienRightClawAttack")); }

protected:

private:
	// Private typedef...
	typedef AVP_Move_Melee_GenericPuppeteer_Start PARENT;
};   // End of class 'AVP_Predator_Move_Melee_CounterAlienRightClawAttack'.


////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_CounterAlienStandingTailStab_Start
// Author       : Anthony Gregson
// Date         : 14/03/08
////////////////////////////////////////////////////////////////////////////////

class AVP_Predator_Move_Melee_CounterAlienStandingTailStab_Start : public AVP_Move_Melee_GenericPuppeteer_Start
{
public:
	// Public functions...
	AVP_Predator_Move_Melee_CounterAlienStandingTailStab_Start(Asura_Movement_System& xParentSystem);
	//	virtual ~AVP_Predator_Move_Melee_CounterAlienStandingTailStab_Start();

	// Accessor functions...
	static Asura_Hash_ID GetStaticHash() { return(0xB16995C1); } // Asura_GetHashID("AVP_Predator_Move_Melee_CounterAlienStandingTailStab_Start")); }

protected:

private:
	// Private typedef...
	typedef AVP_Move_Melee_GenericPuppeteer_Start PARENT;
};   // End of class 'AVP_Predator_Move_Melee_CounterAlienStandingTailStab_Start'.

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_CounterAlienStandingTailStab_Kill
// Author       : Anthony Gregson
// Date         : 14/03/08
////////////////////////////////////////////////////////////////////////////////

class AVP_Predator_Move_Melee_CounterAlienStandingTailStab_Kill : public AVP_Move_Melee_GenericPuppeteer_Success
{
public:
	// Public functions...
	AVP_Predator_Move_Melee_CounterAlienStandingTailStab_Kill(Asura_Movement_System& xParentSystem);
	//	virtual ~AVP_Predator_Move_Melee_CounterAlienStandingTailStab_Kill();

	// Accessor functions...
	static Asura_Hash_ID GetStaticHash() { return(0x8194421F); } // Asura_GetHashID("AVP_Predator_Move_Melee_CounterAlienStandingTailStab_Kill")); }

protected:

private:
	// Private typedef...
	typedef AVP_Move_Melee_GenericPuppeteer_Success PARENT;
};   // End of class 'AVP_Predator_Move_Melee_CounterAlienStandingTailStab_Kill'.

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_CounterAlienStandingTailStab_Countered
// Author       : Anthony Gregson
// Date         : 14/03/08
////////////////////////////////////////////////////////////////////////////////

class AVP_Predator_Move_Melee_CounterAlienStandingTailStab_Countered : public AVP_Move_Melee_GenericPuppeteer_Countered
{
public:
	// Public functions...
	AVP_Predator_Move_Melee_CounterAlienStandingTailStab_Countered(Asura_Movement_System& xParentSystem);
	//	virtual ~AVP_Predator_Move_Melee_CounterAlienStandingTailStab_Countered();

	// Accessor functions...
	static Asura_Hash_ID GetStaticHash() { return(0xE2E2DD7A); } // Asura_GetHashID("AVP_Predator_Move_Melee_CounterAlienStandingTailStab_Countered")); }

protected:

private:
	// Private typedef...
	typedef AVP_Move_Melee_GenericPuppeteer_Countered PARENT;
};   // End of class 'AVP_Predator_Move_Melee_CounterAlienStandingTailStab_Countered'.


////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_CounterAlienPounceAttack
// Author       : Anthony Gregson
// Date         : 12/03/08
////////////////////////////////////////////////////////////////////////////////

class AVP_Predator_Move_Melee_CounterAlienPounceAttack : public AVP_Move_Melee_GenericPuppeteer_Start
{
public:
	// Public functions...
	AVP_Predator_Move_Melee_CounterAlienPounceAttack(Asura_Movement_System& xParentSystem);
	//	virtual ~AVP_Predator_Move_Melee_CounterAlienPounceAttack();

	// Accessor functions...
	static Asura_Hash_ID GetStaticHash() { return(0xA9C03402); } // Asura_GetHashID("AVP_Predator_Move_Melee_CounterAlienPounceAttack")); }

protected:

private:
	// Private typedef...
	typedef AVP_Move_Melee_GenericPuppeteer_Start PARENT;
};   // End of class 'AVP_Predator_Move_Melee_CounterAlienPounceAttack'.


////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_PickupHuman_Start
// Author       : Anthony Gregson
// Date         : 04/06/08
////////////////////////////////////////////////////////////////////////////////

class AVP_Predator_Move_Melee_PickupHuman_Start : public AVP_Move_Melee_GenericAttack_Start
{
public:
	// Public functions...
	AVP_Predator_Move_Melee_PickupHuman_Start(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);
//	virtual ~AVP_Predator_Move_Melee_PickupHuman_Start();

	// Accessor functions...
	static Asura_Hash_ID GetStaticHash() { return(0x1D88603F); } // Asura_GetHashID("AVP_Predator_Move_Melee_PickupHuman_Start")); }

protected:

private:
	// Private typedef...
	typedef AVP_Move_Melee_GenericAttack_Start PARENT;
};   // End of class 'AVP_Predator_Move_Melee_PickupHuman_Start'.

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_PickupHuman_Return_Hit
// Author       : Anthony Gregson
// Date         : 04/06/08
////////////////////////////////////////////////////////////////////////////////

// Not sure if this move is actually needed, but included for safety.
class AVP_Predator_Move_Melee_PickupHuman_Return_Hit : public AVP_Move_Melee_GenericAttack_Return_Hit
{
public:
	// Public functions...
	AVP_Predator_Move_Melee_PickupHuman_Return_Hit(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);
	//	virtual ~AVP_Predator_Move_Melee_PickupHuman_Return_Hit();

	virtual bool ShouldStart() const;

	// Accessor functions...
	static Asura_Hash_ID GetStaticHash() { return(0x07232E47); } // Asura_GetHashID("AVP_Predator_Move_Melee_PickupHuman_Return_Hit")); }

protected:

private:
	// Private typedef...
	typedef AVP_Move_Melee_GenericAttack_Return_Hit PARENT;
};   // End of class 'AVP_Predator_Move_Melee_PickupHuman_Return_Hit'.

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_PickupHuman_Return_Countered
// Author       : Anthony Gregson
// Date         : 04/06/08
////////////////////////////////////////////////////////////////////////////////

// Again, not sure this is needed, we may just miss.
class AVP_Predator_Move_Melee_PickupHuman_Return_Countered : public AVP_Move_Melee_GenericAttack_Return_Countered
{
public:
	// Public functions...
	AVP_Predator_Move_Melee_PickupHuman_Return_Countered(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);
	//	virtual ~AVP_Predator_Move_Melee_PickupHuman_Return_Countered();

	// Accessor functions...
	static Asura_Hash_ID GetStaticHash() { return(0x6C81974F); } // Asura_GetHashID("AVP_Predator_Move_Melee_PickupHuman_Return_Countered")); }

protected:

private:
	// Private typedef...
	typedef AVP_Move_Melee_GenericAttack_Return_Countered PARENT;
};   // End of class 'AVP_Predator_Move_Melee_PickupHuman_Return_Countered'.

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_PickupHuman_Return_Miss
// Author       : Anthony Gregson
// Date         : 04/06/08
////////////////////////////////////////////////////////////////////////////////

class AVP_Predator_Move_Melee_PickupHuman_Return_Miss : public AVP_Move_Melee_GenericAttack_Return_Miss
{
public:
	// Public functions...
	AVP_Predator_Move_Melee_PickupHuman_Return_Miss(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);
	//	virtual ~AVP_Predator_Move_Melee_PickupHuman_Return_Miss();

	// Accessor functions...
	static Asura_Hash_ID GetStaticHash() { return(0xDD44E0C8); } // Asura_GetHashID("AVP_Predator_Move_Melee_PickupHuman_Return_Miss")); }

protected:

private:
	// Private typedef...
	typedef AVP_Move_Melee_GenericAttack_Return_Miss PARENT;
};   // End of class 'AVP_Predator_Move_Melee_PickupHuman_Return_Miss'.

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_PickupHuman_Grapple_Start
// Author       : Anthony Gregson
// Date         : 04/06/08
////////////////////////////////////////////////////////////////////////////////

class AVP_Predator_Move_Melee_PickupHuman_Grapple_Start : public AVP_Move_Melee_GenericPuppeteer_Start
{
public:
	// Public functions...
	AVP_Predator_Move_Melee_PickupHuman_Grapple_Start(Asura_Movement_System& xParentSystem);
	//	virtual ~AVP_Predator_Move_Melee_PickupHuman_Grapple_Start();

	// Accessor functions...
	static Asura_Hash_ID GetStaticHash() { return(0x1F4EF04F); } // Asura_GetHashID("AVP_Predator_Move_Melee_PickupHuman_Grapple_Start")); }

protected:

private:
	// Private typedef...
	typedef AVP_Move_Melee_GenericPuppeteer_Start PARENT;
};   // End of class 'AVP_Predator_Move_Melee_PickupHuman_Grapple_Start'.

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_PickupHuman_Grapple_TrophyKill
// Author       : Anthony Gregson
// Date         : 04/06/08
////////////////////////////////////////////////////////////////////////////////

class AVP_Predator_Move_Melee_PickupHuman_Grapple_TrophyKill : public AVP_Move_Melee_GenericPuppeteer_Success
{
public:
	// Public functions...
	AVP_Predator_Move_Melee_PickupHuman_Grapple_TrophyKill(Asura_Movement_System& xParentSystem);
	virtual ~AVP_Predator_Move_Melee_PickupHuman_Grapple_TrophyKill();

	// Accessor functions...
	static Asura_Hash_ID GetStaticHash() { return(0x55FBA9C1); } // Asura_GetHashID("AVP_Predator_Move_Melee_PickupHuman_Grapple_TrophyKill")); }

protected:
	virtual bool ShouldStart() const;
	virtual void Abort();
	virtual void Finish();

	virtual void UpdateStates(const float fTimeStep);

	void AttachTrophy();
	void DetachTrophy();

	Asura_AnimationAttachment* m_pxTrophyAttachment;
	Asura_Hash_ID m_uTrophyMarkerPoint;
	Asura_Hash_ID m_uTrophyAnim;

private:
	// Private typedef...
	typedef AVP_Move_Melee_GenericPuppeteer_Success PARENT;
};   // End of class 'AVP_Predator_Move_Melee_PickupHuman_Grapple_TrophyKill'.

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_PickupHuman_Grapple_Countered
// Author       : Anthony Gregson
// Date         : 04/06/08
////////////////////////////////////////////////////////////////////////////////

class AVP_Predator_Move_Melee_PickupHuman_Grapple_Countered : public AVP_Move_Melee_GenericPuppeteer_Countered
{
public:
	// Public functions...
	AVP_Predator_Move_Melee_PickupHuman_Grapple_Countered(Asura_Movement_System& xParentSystem);
	//	virtual ~AVP_Predator_Move_Melee_PickupHuman_Grapple_Countered();

	// Accessor functions...
	static Asura_Hash_ID GetStaticHash() { return(0xD25C4108); } // Asura_GetHashID("AVP_Predator_Move_Melee_PickupHuman_Grapple_Countered")); }

protected:
	virtual bool ShouldStart() const;

private:
	// Private typedef...
	typedef AVP_Move_Melee_GenericPuppeteer_Countered PARENT;
};   // End of class 'AVP_Predator_Move_Melee_PickupHuman_Grapple_Countered'.


////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_StealthPickupHuman_Start
// Author       : Anthony Gregson
// Date         : 30/09/08
////////////////////////////////////////////////////////////////////////////////

class AVP_Predator_Move_Melee_StealthPickupHuman_Start : public AVP_Move_Melee_GenericAttack_Start
{
public:
	AVP_Predator_Move_Melee_StealthPickupHuman_Start(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return 0x2025A566; } // Asura_GetHashID("AVP_Predator_Move_Melee_StealthPickupHuman_Start")); }

private:
	typedef AVP_Move_Melee_GenericAttack_Start PARENT;
};   // End of class 'AVP_Predator_Move_Melee_StealthPickupHuman_Start'.

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_StealthPickupHuman_Return_Hit
// Author       : Anthony Gregson
// Date         : 30/09/08
////////////////////////////////////////////////////////////////////////////////

// Not sure if this move is actually needed, but included for safety.
class AVP_Predator_Move_Melee_StealthPickupHuman_Return_Hit : public AVP_Move_Melee_GenericAttack_Return_Hit
{
public:
	AVP_Predator_Move_Melee_StealthPickupHuman_Return_Hit(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	virtual bool ShouldStart() const;

	static Asura_Hash_ID GetStaticHash() { return 0x1F960980; } // Asura_GetHashID("AVP_Predator_Move_Melee_StealthPickupHuman_Return_Hit")); }

private:
	typedef AVP_Move_Melee_GenericAttack_Return_Hit PARENT;
};   // End of class 'AVP_Predator_Move_Melee_StealthPickupHuman_Return_Hit'.

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_StealthPickupHuman_Return_Countered
// Author       : Anthony Gregson
// Date         : 30/09/08
////////////////////////////////////////////////////////////////////////////////

// Again, not sure this is needed, we may just miss.
class AVP_Predator_Move_Melee_StealthPickupHuman_Return_Countered : public AVP_Move_Melee_GenericAttack_Return_Countered
{
public:
	AVP_Predator_Move_Melee_StealthPickupHuman_Return_Countered(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return 0xA36763C8; } // Asura_GetHashID("AVP_Predator_Move_Melee_StealthPickupHuman_Return_Countered")); }

private:
	typedef AVP_Move_Melee_GenericAttack_Return_Countered PARENT;
};   // End of class 'AVP_Predator_Move_Melee_StealthPickupHuman_Return_Countered'.

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_StealthPickupHuman_Return_Miss
// Author       : Anthony Gregson
// Date         : 30/09/08
////////////////////////////////////////////////////////////////////////////////

class AVP_Predator_Move_Melee_StealthPickupHuman_Return_Miss : public AVP_Move_Melee_GenericAttack_Return_Miss
{
public:
	AVP_Predator_Move_Melee_StealthPickupHuman_Return_Miss(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return 0xD32D6CAF; } // Asura_GetHashID("AVP_Predator_Move_Melee_StealthPickupHuman_Return_Miss")); }

private:
	typedef AVP_Move_Melee_GenericAttack_Return_Miss PARENT;
};   // End of class 'AVP_Predator_Move_Melee_StealthPickupHuman_Return_Miss'.


////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_StealthPickupHuman_Grapple
// Author       : Anthony Gregson
// Date         : 30/09/08
////////////////////////////////////////////////////////////////////////////////

class AVP_Predator_Move_Melee_StealthPickupHuman_Grapple : public AVP_Move_Melee_GenericPuppeteer_Start
{
public:
	AVP_Predator_Move_Melee_StealthPickupHuman_Grapple(Asura_Movement_System& xParentSystem);

	static Asura_Hash_ID GetStaticHash() { return 0x2F1C8153; } // Asura_GetHashID("AVP_Predator_Move_Melee_StealthPickupHuman_Grapple")); }
	
	virtual void UpdateStates(const float fTimeStep);

protected:
	virtual bool Start(const Asura_Msg_Move* pxStartMsg);

private:
	typedef AVP_Move_Melee_GenericPuppeteer_Start PARENT;
};   // End of class 'AVP_Predator_Move_Melee_StealthPickupHuman_Grapple'.


////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_PickupDownedAlien_Start
// Author       : Anthony Gregson
// Date         : 07/07/08
////////////////////////////////////////////////////////////////////////////////

class AVP_Predator_Move_Melee_PickupDownedAlien_Start : public AVP_Move_Melee_GenericAttack_Start
{
public:
	AVP_Predator_Move_Melee_PickupDownedAlien_Start(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return 0x119E87B8; } // Asura_GetHashID("AVP_Predator_Move_Melee_PickupDownedAlien_Start")); }

private:
	typedef AVP_Move_Melee_GenericAttack_Start PARENT;
};   // End of class 'AVP_Predator_Move_Melee_PickupDownedAlien_Start'.

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_PickupDownedAlien_Return_Hit
// Author       : Anthony Gregson
// Date         : 07/07/08
////////////////////////////////////////////////////////////////////////////////

// Not sure if this move is actually needed, but included for safety.
class AVP_Predator_Move_Melee_PickupDownedAlien_Return_Hit : public AVP_Move_Melee_GenericAttack_Return_Hit
{
public:
	AVP_Predator_Move_Melee_PickupDownedAlien_Return_Hit(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	virtual bool ShouldStart() const;

	static Asura_Hash_ID GetStaticHash() { return 0x8C47CA6E; } // Asura_GetHashID("AVP_Predator_Move_Melee_PickupDownedAlien_Return_Hit")); }

private:
	typedef AVP_Move_Melee_GenericAttack_Return_Hit PARENT;
};   // End of class 'AVP_Predator_Move_Melee_PickupDownedAlien_Return_Hit'.

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_PickupDownedAlien_Return_Countered
// Author       : Anthony Gregson
// Date         : 07/07/08
////////////////////////////////////////////////////////////////////////////////

// Again, not sure this is needed, we may just miss.
class AVP_Predator_Move_Melee_PickupDownedAlien_Return_Countered : public AVP_Move_Melee_GenericAttack_Return_Countered
{
public:
	AVP_Predator_Move_Melee_PickupDownedAlien_Return_Countered(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return 0xE1D43A36; } // Asura_GetHashID("AVP_Predator_Move_Melee_PickupDownedAlien_Return_Countered")); }

private:
	typedef AVP_Move_Melee_GenericAttack_Return_Countered PARENT;
};   // End of class 'AVP_Predator_Move_Melee_PickupDownedAlien_Return_Countered'.

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_PickupDownedAlien_Return_Miss
// Author       : Anthony Gregson
// Date         : 07/07/08
////////////////////////////////////////////////////////////////////////////////

class AVP_Predator_Move_Melee_PickupDownedAlien_Return_Miss : public AVP_Move_Melee_GenericAttack_Return_Miss
{
public:
	AVP_Predator_Move_Melee_PickupDownedAlien_Return_Miss(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return 0xFCB3C981; } // Asura_GetHashID("AVP_Predator_Move_Melee_PickupDownedAlien_Return_Miss")); }

private:
	typedef AVP_Move_Melee_GenericAttack_Return_Miss PARENT;
};   // End of class 'AVP_Predator_Move_Melee_PickupDownedAlien_Return_Miss'.


////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_PickupDownedAlien_Grapple_Start
// Author       : Anthony Gregson
// Date         : 14/10/08
////////////////////////////////////////////////////////////////////////////////

class AVP_Predator_Move_Melee_PickupDownedAlien_Grapple_Start : public AVP_Move_Melee_GenericPuppeteer_Start
{
public:
	AVP_Predator_Move_Melee_PickupDownedAlien_Grapple_Start(Asura_Movement_System& xParentSystem);

	static Asura_Hash_ID GetStaticHash() { return 0x1EA68EC8; } // Asura_GetHashID("AVP_Predator_Move_Melee_PickupDownedAlien_Grapple_Start")); }

private:
	typedef AVP_Move_Melee_GenericPuppeteer_Start PARENT;
};   // End of class 'AVP_Predator_Move_Melee_PickupDownedAlien_Grapple_Start'.

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_PickupDownedAlien_Grapple_Success
// Author       : Anthony Gregson
// Date         : 14/10/08
////////////////////////////////////////////////////////////////////////////////

class AVP_Predator_Move_Melee_PickupDownedAlien_Grapple_Success : public AVP_Move_Melee_GenericPuppeteer_Success
{
public:
	AVP_Predator_Move_Melee_PickupDownedAlien_Grapple_Success(Asura_Movement_System& xParentSystem);

	static Asura_Hash_ID GetStaticHash() { return 0x110808E9; } // Asura_GetHashID("AVP_Predator_Move_Melee_PickupDownedAlien_Grapple_Success")); }

protected:
	virtual bool ShouldStart() const;

	virtual void UpdateStates(const float fTimeStep);

private:
	typedef AVP_Move_Melee_GenericPuppeteer_Success PARENT;
};   // End of class 'AVP_Predator_Move_Melee_PickupDownedAlien_Grapple_Success'.

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_PickupDownedAlien_Grapple_Countered
// Author       : Anthony Gregson
// Date         : 14/10/08
////////////////////////////////////////////////////////////////////////////////

class AVP_Predator_Move_Melee_PickupDownedAlien_Grapple_Countered : public AVP_Move_Melee_GenericPuppeteer_Countered
{
public:
	AVP_Predator_Move_Melee_PickupDownedAlien_Grapple_Countered(Asura_Movement_System& xParentSystem);

	static Asura_Hash_ID GetStaticHash() { return 0x075DFB01; } // Asura_GetHashID("AVP_Predator_Move_Melee_PickupDownedAlien_Grapple_Countered")); }

protected:
	virtual bool ShouldStart() const;

private:
	typedef AVP_Move_Melee_GenericPuppeteer_Countered PARENT;
};   // End of class 'AVP_Predator_Move_Melee_PickupDownedAlien_Grapple_Countered'.


////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_PickupAlienCrouching_Start
// Author       : Anthony Gregson
// Date         : 05/11/08
////////////////////////////////////////////////////////////////////////////////

class AVP_Predator_Move_Melee_PickupAlienCrouching_Start : public AVP_Move_Melee_GenericAttack_Start
{
public:
	AVP_Predator_Move_Melee_PickupAlienCrouching_Start(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return 0x9211CB15; } // Asura_GetHashID("AVP_Predator_Move_Melee_PickupAlienCrouching_Start")); }

private:
	typedef AVP_Move_Melee_GenericAttack_Start PARENT;
};   // End of class 'AVP_Predator_Move_Melee_PickupAlienCrouching_Start'.

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_PickupAlienCrouching_Return_Hit
// Author       : Anthony Gregson
// Date         : 05/11/08
////////////////////////////////////////////////////////////////////////////////

// Not sure if this move is actually needed, but included for safety.
class AVP_Predator_Move_Melee_PickupAlienCrouching_Return_Hit : public AVP_Move_Melee_GenericAttack_Return_Hit
{
public:
	AVP_Predator_Move_Melee_PickupAlienCrouching_Return_Hit(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	virtual bool ShouldStart() const;

	static Asura_Hash_ID GetStaticHash() { return 0x4F191931; } // Asura_GetHashID("AVP_Predator_Move_Melee_PickupAlienCrouching_Return_Hit")); }

private:
	typedef AVP_Move_Melee_GenericAttack_Return_Hit PARENT;
};   // End of class 'AVP_Predator_Move_Melee_PickupAlienCrouching_Return_Hit'.

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_PickupAlienCrouching_Return_Countered
// Author       : Anthony Gregson
// Date         : 05/11/08
////////////////////////////////////////////////////////////////////////////////

// Again, not sure this is needed, we may just miss.
class AVP_Predator_Move_Melee_PickupAlienCrouching_Return_Countered : public AVP_Move_Melee_GenericAttack_Return_Countered
{
public:
	AVP_Predator_Move_Melee_PickupAlienCrouching_Return_Countered(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return 0xF5522AB9; } // Asura_GetHashID("AVP_Predator_Move_Melee_PickupAlienCrouching_Return_Countered")); }

private:
	typedef AVP_Move_Melee_GenericAttack_Return_Countered PARENT;
};   // End of class 'AVP_Predator_Move_Melee_PickupAlienCrouching_Return_Countered'.

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_PickupAlienCrouching_Return_Miss
// Author       : Anthony Gregson
// Date         : 05/11/08
////////////////////////////////////////////////////////////////////////////////

class AVP_Predator_Move_Melee_PickupAlienCrouching_Return_Miss : public AVP_Move_Melee_GenericAttack_Return_Miss
{
public:
	AVP_Predator_Move_Melee_PickupAlienCrouching_Return_Miss(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return 0x940C531E; } // Asura_GetHashID("AVP_Predator_Move_Melee_PickupAlienCrouching_Return_Miss")); }

private:
	typedef AVP_Move_Melee_GenericAttack_Return_Miss PARENT;
};   // End of class 'AVP_Predator_Move_Melee_PickupAlienCrouching_Return_Miss'.


////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_PickupAlienCrouching_Grapple_Start
// Author       : Anthony Gregson
// Date         : 05/11/08
////////////////////////////////////////////////////////////////////////////////

class AVP_Predator_Move_Melee_PickupAlienCrouching_Grapple_Start : public AVP_Move_Melee_GenericPuppeteer_Start
{
public:
	AVP_Predator_Move_Melee_PickupAlienCrouching_Grapple_Start(Asura_Movement_System& xParentSystem);

	static Asura_Hash_ID GetStaticHash() { return 0x42032525; } // Asura_GetHashID("AVP_Predator_Move_Melee_PickupAlienCrouching_Grapple_Start")); }

private:
	typedef AVP_Move_Melee_GenericPuppeteer_Start PARENT;
};   // End of class 'AVP_Predator_Move_Melee_PickupAlienCrouching_Grapple_Start'.

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_PickupAlienCrouching_Grapple_Success
// Author       : Anthony Gregson
// Date         : 05/11/08
////////////////////////////////////////////////////////////////////////////////

class AVP_Predator_Move_Melee_PickupAlienCrouching_Grapple_Success : public AVP_Move_Melee_GenericPuppeteer_Success
{
public:
	AVP_Predator_Move_Melee_PickupAlienCrouching_Grapple_Success(Asura_Movement_System& xParentSystem);

	static Asura_Hash_ID GetStaticHash() { return 0xCF987C06; } // Asura_GetHashID("AVP_Predator_Move_Melee_PickupAlienCrouching_Grapple_Success")); }

protected:
	virtual void UpdateStates(const float fTimeStep);

private:
	typedef AVP_Move_Melee_GenericPuppeteer_Success PARENT;
};   // End of class 'AVP_Predator_Move_Melee_PickupAlienCrouching_Grapple_Success'.

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_PickupAlienCrouching_Grapple_Countered
// Author       : Anthony Gregson
// Date         : 05/11/08
////////////////////////////////////////////////////////////////////////////////

class AVP_Predator_Move_Melee_PickupAlienCrouching_Grapple_Countered : public AVP_Move_Melee_GenericPuppeteer_Countered
{
public:
	AVP_Predator_Move_Melee_PickupAlienCrouching_Grapple_Countered(Asura_Movement_System& xParentSystem);

	static Asura_Hash_ID GetStaticHash() { return 0x639E1ADE; } // Asura_GetHashID("AVP_Predator_Move_Melee_PickupAlienCrouching_Grapple_Countered")); }

private:
	typedef AVP_Move_Melee_GenericPuppeteer_Countered PARENT;
};   // End of class 'AVP_Predator_Move_Melee_PickupAlienCrouching_Grapple_Countered'.


////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_PickupAlienStanding_Start
// Author       : Anthony Gregson
// Date         : 05/11/08
////////////////////////////////////////////////////////////////////////////////

class AVP_Predator_Move_Melee_PickupAlienStanding_Start : public AVP_Move_Melee_GenericAttack_Start
{
public:
	AVP_Predator_Move_Melee_PickupAlienStanding_Start(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return 0x612FF7A5; } // Asura_GetHashID("AVP_Predator_Move_Melee_PickupAlienStanding_Start")); }

private:
	typedef AVP_Move_Melee_GenericAttack_Start PARENT;
};   // End of class 'AVP_Predator_Move_Melee_PickupAlienStanding_Start'.

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_PickupAlienStanding_Return_Hit
// Author       : Anthony Gregson
// Date         : 05/11/08
////////////////////////////////////////////////////////////////////////////////

// Not sure if this move is actually needed, but included for safety.
class AVP_Predator_Move_Melee_PickupAlienStanding_Return_Hit : public AVP_Move_Melee_GenericAttack_Return_Hit
{
public:
	AVP_Predator_Move_Melee_PickupAlienStanding_Return_Hit(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	virtual bool ShouldStart() const;

	static Asura_Hash_ID GetStaticHash() { return 0x4DB046A1; } // Asura_GetHashID("AVP_Predator_Move_Melee_PickupAlienStanding_Return_Hit")); }

private:
	typedef AVP_Move_Melee_GenericAttack_Return_Hit PARENT;
};   // End of class 'AVP_Predator_Move_Melee_PickupAlienStanding_Return_Hit'.

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_PickupAlienStanding_Return_Countered
// Author       : Anthony Gregson
// Date         : 05/11/08
////////////////////////////////////////////////////////////////////////////////

// Again, not sure this is needed, we may just miss.
class AVP_Predator_Move_Melee_PickupAlienStanding_Return_Countered : public AVP_Move_Melee_GenericAttack_Return_Countered
{
public:
	AVP_Predator_Move_Melee_PickupAlienStanding_Return_Countered(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return 0x03CD8429; } // Asura_GetHashID("AVP_Predator_Move_Melee_PickupAlienStanding_Return_Countered")); }

private:
	typedef AVP_Move_Melee_GenericAttack_Return_Countered PARENT;
};   // End of class 'AVP_Predator_Move_Melee_PickupAlienStanding_Return_Countered'.

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_PickupAlienStanding_Return_Miss
// Author       : Anthony Gregson
// Date         : 05/11/08
////////////////////////////////////////////////////////////////////////////////

class AVP_Predator_Move_Melee_PickupAlienStanding_Return_Miss : public AVP_Move_Melee_GenericAttack_Return_Miss
{
public:
	AVP_Predator_Move_Melee_PickupAlienStanding_Return_Miss(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return 0x685AD3AE; } // Asura_GetHashID("AVP_Predator_Move_Melee_PickupAlienStanding_Return_Miss")); }

private:
	typedef AVP_Move_Melee_GenericAttack_Return_Miss PARENT;
};   // End of class 'AVP_Predator_Move_Melee_PickupAlienStanding_Return_Miss'.


////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_PickupAlienStanding_Grapple_Start
// Author       : Anthony Gregson
// Date         : 05/11/08
////////////////////////////////////////////////////////////////////////////////

class AVP_Predator_Move_Melee_PickupAlienStanding_Grapple_Start : public AVP_Move_Melee_GenericPuppeteer_Start
{
public:
	AVP_Predator_Move_Melee_PickupAlienStanding_Grapple_Start(Asura_Movement_System& xParentSystem);

	static Asura_Hash_ID GetStaticHash() { return 0x3CB3C1B5; } // Asura_GetHashID("AVP_Predator_Move_Melee_PickupAlienStanding_Grapple_Start")); }

private:
	typedef AVP_Move_Melee_GenericPuppeteer_Start PARENT;
};   // End of class 'AVP_Predator_Move_Melee_PickupAlienStanding_Grapple_Start'.

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_PickupAlienStanding_Grapple_Success
// Author       : Anthony Gregson
// Date         : 05/11/08
////////////////////////////////////////////////////////////////////////////////

class AVP_Predator_Move_Melee_PickupAlienStanding_Grapple_Success : public AVP_Move_Melee_GenericPuppeteer_Success
{
public:
	AVP_Predator_Move_Melee_PickupAlienStanding_Grapple_Success(Asura_Movement_System& xParentSystem);

	static Asura_Hash_ID GetStaticHash() { return 0xE0943496; } // Asura_GetHashID("AVP_Predator_Move_Melee_PickupAlienStanding_Grapple_Success")); }

protected:
	virtual void UpdateStates(const float fTimeStep);

private:
	typedef AVP_Move_Melee_GenericPuppeteer_Success PARENT;
};   // End of class 'AVP_Predator_Move_Melee_PickupAlienStanding_Grapple_Success'.

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_PickupAlienStanding_Grapple_Countered
// Author       : Anthony Gregson
// Date         : 05/11/08
////////////////////////////////////////////////////////////////////////////////

class AVP_Predator_Move_Melee_PickupAlienStanding_Grapple_Countered : public AVP_Move_Melee_GenericPuppeteer_Countered
{
public:
	AVP_Predator_Move_Melee_PickupAlienStanding_Grapple_Countered(Asura_Movement_System& xParentSystem);

	static Asura_Hash_ID GetStaticHash() { return 0x248DEF6E; } // Asura_GetHashID("AVP_Predator_Move_Melee_PickupAlienStanding_Grapple_Countered")); }

private:
	typedef AVP_Move_Melee_GenericPuppeteer_Countered PARENT;
};   // End of class 'AVP_Predator_Move_Melee_PickupAlienStanding_Grapple_Countered'.


////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_StealthPickupAlienCrouching_Start
// Author       : Anthony Gregson
// Date         : 31/09/08
////////////////////////////////////////////////////////////////////////////////

class AVP_Predator_Move_Melee_StealthPickupAlienCrouching_Start : public AVP_Move_Melee_GenericAttack_Start
{
public:
	AVP_Predator_Move_Melee_StealthPickupAlienCrouching_Start(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return 0x32C261CE; } // Asura_GetHashID("AVP_Predator_Move_Melee_StealthPickupAlienCrouching_Start")); }

private:
	typedef AVP_Move_Melee_GenericAttack_Start PARENT;
};   // End of class 'AVP_Predator_Move_Melee_StealthPickupAlienCrouching_Start'.

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_StealthPickupAlienCrouching_Return_Hit
// Author       : Anthony Gregson
// Date         : 31/09/08
////////////////////////////////////////////////////////////////////////////////

// Not sure if this move is actually needed, but included for safety.
class AVP_Predator_Move_Melee_StealthPickupAlienCrouching_Return_Hit : public AVP_Move_Melee_GenericAttack_Return_Hit
{
public:
	AVP_Predator_Move_Melee_StealthPickupAlienCrouching_Return_Hit(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	virtual bool ShouldStart() const;

	static Asura_Hash_ID GetStaticHash() { return 0xCF06CE18; } // Asura_GetHashID("AVP_Predator_Move_Melee_StealthPickupAlienCrouching_Return_Hit")); }

private:
	typedef AVP_Move_Melee_GenericAttack_Return_Hit PARENT;
};   // End of class 'AVP_Predator_Move_Melee_StealthPickupAlienCrouching_Return_Hit'.

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_StealthPickupAlienCrouching_Return_Countered
// Author       : Anthony Gregson
// Date         : 31/09/08
////////////////////////////////////////////////////////////////////////////////

// Again, not sure this is needed, we may just miss.
class AVP_Predator_Move_Melee_StealthPickupAlienCrouching_Return_Countered : public AVP_Move_Melee_GenericAttack_Return_Countered
{
public:
	AVP_Predator_Move_Melee_StealthPickupAlienCrouching_Return_Countered(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return 0xACE85660; } // Asura_GetHashID("AVP_Predator_Move_Melee_StealthPickupAlienCrouching_Return_Countered")); }

private:
	typedef AVP_Move_Melee_GenericAttack_Return_Countered PARENT;
};   // End of class 'AVP_Predator_Move_Melee_StealthPickupAlienCrouching_Return_Countered'.

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_StealthPickupAlienCrouching_Return_Miss
// Author       : Anthony Gregson
// Date         : 31/09/08
////////////////////////////////////////////////////////////////////////////////

class AVP_Predator_Move_Melee_StealthPickupAlienCrouching_Return_Miss : public AVP_Move_Melee_GenericAttack_Return_Miss
{
public:
	AVP_Predator_Move_Melee_StealthPickupAlienCrouching_Return_Miss(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return 0x11D53B17; } // Asura_GetHashID("AVP_Predator_Move_Melee_StealthPickupAlienCrouching_Return_Miss")); }

private:
	typedef AVP_Move_Melee_GenericAttack_Return_Miss PARENT;
};   // End of class 'AVP_Predator_Move_Melee_StealthPickupAlienCrouching_Return_Miss'.


////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_StealthPickupAlienCrouching_Grapple
// Author       : Anthony Gregson
// Date         : 31/09/08
////////////////////////////////////////////////////////////////////////////////

class AVP_Predator_Move_Melee_StealthPickupAlienCrouching_Grapple : public AVP_Move_Melee_GenericPuppeteer_Start
{
public:
	AVP_Predator_Move_Melee_StealthPickupAlienCrouching_Grapple(Asura_Movement_System& xParentSystem);

	static Asura_Hash_ID GetStaticHash() { return 0x0D7BC3BB; } // Asura_GetHashID("AVP_Predator_Move_Melee_StealthPickupAlienCrouching_Grapple")); }
	
	virtual void UpdateStates(const float fTimeStep);

protected:
	virtual bool Start(const Asura_Msg_Move* pxStartMsg);

private:
	typedef AVP_Move_Melee_GenericPuppeteer_Start PARENT;
};   // End of class 'AVP_Predator_Move_Melee_StealthPickupAlienCrouching_Grapple'.


////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_StealthPickupAlienStanding_Start
// Author       : Anthony Gregson
// Date         : 31/09/08
////////////////////////////////////////////////////////////////////////////////

class AVP_Predator_Move_Melee_StealthPickupAlienStanding_Start : public AVP_Move_Melee_GenericAttack_Start
{
public:
	AVP_Predator_Move_Melee_StealthPickupAlienStanding_Start(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return 0x7F2525CC; } // Asura_GetHashID("AVP_Predator_Move_Melee_StealthPickupAlienStanding_Start")); }

private:
	typedef AVP_Move_Melee_GenericAttack_Start PARENT;
};   // End of class 'AVP_Predator_Move_Melee_StealthPickupAlienStanding_Start'.

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_StealthPickupAlienStanding_Return_Hit
// Author       : Anthony Gregson
// Date         : 31/09/08
////////////////////////////////////////////////////////////////////////////////

// Not sure if this move is actually needed, but included for safety.
class AVP_Predator_Move_Melee_StealthPickupAlienStanding_Return_Hit : public AVP_Move_Melee_GenericAttack_Return_Hit
{
public:
	AVP_Predator_Move_Melee_StealthPickupAlienStanding_Return_Hit(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	virtual bool ShouldStart() const;

	static Asura_Hash_ID GetStaticHash() { return 0x6254D8DA; } // Asura_GetHashID("AVP_Predator_Move_Melee_StealthPickupAlienStanding_Return_Hit")); }

private:
	typedef AVP_Move_Melee_GenericAttack_Return_Hit PARENT;
};   // End of class 'AVP_Predator_Move_Melee_StealthPickupAlienStanding_Return_Hit'.

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_StealthPickupAlienStanding_Return_Countered
// Author       : Anthony Gregson
// Date         : 31/09/08
////////////////////////////////////////////////////////////////////////////////

// Again, not sure this is needed, we may just miss.
class AVP_Predator_Move_Melee_StealthPickupAlienStanding_Return_Countered : public AVP_Move_Melee_GenericAttack_Return_Countered
{
public:
	AVP_Predator_Move_Melee_StealthPickupAlienStanding_Return_Countered(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return 0x227FC7A2; } // Asura_GetHashID("AVP_Predator_Move_Melee_StealthPickupAlienStanding_Return_Countered")); }

private:
	typedef AVP_Move_Melee_GenericAttack_Return_Countered PARENT;
};   // End of class 'AVP_Predator_Move_Melee_StealthPickupAlienStanding_Return_Countered'.

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_StealthPickupAlienStanding_Return_Miss
// Author       : Anthony Gregson
// Date         : 31/09/08
////////////////////////////////////////////////////////////////////////////////

class AVP_Predator_Move_Melee_StealthPickupAlienStanding_Return_Miss : public AVP_Move_Melee_GenericAttack_Return_Miss
{
public:
	AVP_Predator_Move_Melee_StealthPickupAlienStanding_Return_Miss(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return 0xE8488895; } // Asura_GetHashID("AVP_Predator_Move_Melee_StealthPickupAlienStanding_Return_Miss")); }

private:
	typedef AVP_Move_Melee_GenericAttack_Return_Miss PARENT;
};   // End of class 'AVP_Predator_Move_Melee_StealthPickupAlienStanding_Return_Miss'.


////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_StealthPickupAlienStanding_Grapple
// Author       : Anthony Gregson
// Date         : 31/09/08
////////////////////////////////////////////////////////////////////////////////

class AVP_Predator_Move_Melee_StealthPickupAlienStanding_Grapple : public AVP_Move_Melee_GenericPuppeteer_Start
{
public:
	AVP_Predator_Move_Melee_StealthPickupAlienStanding_Grapple(Asura_Movement_System& xParentSystem);

	static Asura_Hash_ID GetStaticHash() { return 0xCC3D8039; } // Asura_GetHashID("AVP_Predator_Move_Melee_StealthPickupAlienStanding_Grapple")); }
	
	virtual void UpdateStates(const float fTimeStep);

protected:
	virtual bool Start(const Asura_Msg_Move* pxStartMsg);

private:
	typedef AVP_Move_Melee_GenericPuppeteer_Start PARENT;
};   // End of class 'AVP_Predator_Move_Melee_StealthPickupAlienStanding_Grapple'.



////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_CounterAlienCrawlStandAttackLeft
// Author       : Anthony Gregson
// Date         : 11/07/08
////////////////////////////////////////////////////////////////////////////////

class AVP_Predator_Move_Melee_CounterAlienCrawlStandAttackLeft : public AVP_Move_Melee_GenericPuppeteer_Start
{
public:
	AVP_Predator_Move_Melee_CounterAlienCrawlStandAttackLeft(Asura_Movement_System& xParentSystem);

	static Asura_Hash_ID GetStaticHash() { return 0xABB0CD9E; } // Asura_GetHashID("AVP_Predator_Move_Melee_CounterAlienCrawlStandAttackLeft")); }

protected:
	virtual bool Start(const Asura_Msg_Move* pxStartMsg);

private:
	typedef AVP_Move_Melee_GenericPuppeteer_Start PARENT;
};   // End of class 'AVP_Predator_Move_Melee_CounterAlienCrawlStandAttackLeft'.


////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_Predator_Move_Melee_CounterAlienCrawlStandAttackRight
// Author       : Anthony Gregson
// Date         : 11/07/08
////////////////////////////////////////////////////////////////////////////////

class AVP_Predator_Move_Melee_CounterAlienCrawlStandAttackRight : public AVP_Move_Melee_GenericPuppeteer_Start
{
public:
	AVP_Predator_Move_Melee_CounterAlienCrawlStandAttackRight(Asura_Movement_System& xParentSystem);

	static Asura_Hash_ID GetStaticHash() { return 0xCABF4765; } // Asura_GetHashID("AVP_Predator_Move_Melee_CounterAlienCrawlStandAttackRight")); }

protected:
	virtual bool Start(const Asura_Msg_Move* pxStartMsg);

private:
	typedef AVP_Move_Melee_GenericPuppeteer_Start PARENT;
};   // End of class 'AVP_Predator_Move_Melee_CounterAlienCrawlStandAttackRight'.


////////////////////////////////////////////////////////////////////////////////
// Counter Predalien Close Attacks
////////////////////////////////////////////////////////////////////////////////

class AVP_Predator_Move_Melee_CounterPredalienLeftClawAttack : public AVP_Move_Melee_GenericPuppeteer_Start
{
public:
	AVP_Predator_Move_Melee_CounterPredalienLeftClawAttack(Asura_Movement_System& xParentSystem);

	static Asura_Hash_ID GetStaticHash() { return(0x010eb66d); } // AVP_Predator_Move_Melee_CounterPredalienLeftClawAttack

protected:

private:
	typedef AVP_Move_Melee_GenericPuppeteer_Start PARENT;
};

class AVP_Predator_Move_Melee_CounterPredalienRightClawAttack : public AVP_Move_Melee_GenericPuppeteer_Start
{
public:
	AVP_Predator_Move_Melee_CounterPredalienRightClawAttack(Asura_Movement_System& xParentSystem);

	static Asura_Hash_ID GetStaticHash() { return(0x7f2a6ea4); } // AVP_Predator_Move_Melee_CounterPredalienRightClawAttack

protected:

private:
	typedef AVP_Move_Melee_GenericPuppeteer_Start PARENT;
};


class AVP_Predator_Move_Melee_CounterPredalienTailSwipe : public AVP_Move_Melee
{
public:
	AVP_Predator_Move_Melee_CounterPredalienTailSwipe(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return(0x3a743bcb); } // AVP_Predator_Move_Melee_CounterPredalienTailSwipe

protected:

private:
	typedef AVP_Move_Melee PARENT;
};


////////////////////////////////////////////////////////////////////////////////
// Counter Predalien Jump Down Attack
////////////////////////////////////////////////////////////////////////////////

class AVP_Predator_Move_Melee_CounterPredalienJumpDownAttack : public AVP_Move_Melee_GenericPuppeteer_Start
{
public:
	AVP_Predator_Move_Melee_CounterPredalienJumpDownAttack(Asura_Movement_System& xParentSystem);

	static Asura_Hash_ID GetStaticHash() { return(0xca24c9d7); } // AVP_Predator_Move_Melee_CounterPredalienJumpDownAttack

protected:
	virtual bool Start(const Asura_Msg_Move* pxStartMsg);

private:
	typedef AVP_Move_Melee_GenericPuppeteer_Start PARENT;
};


////////////////////////////////////////////////////////////////////////////////
// Knocked down Predalien attacks
////////////////////////////////////////////////////////////////////////////////

class AVP_Predator_Move_Melee_PredalienPounceAttack_StartBase : public AVP_Move_Melee_GenericAttack_Start
{
public:
	AVP_Predator_Move_Melee_PredalienPounceAttack_StartBase(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash, Asura_Hash_ID);

protected:

private:

	typedef AVP_Move_Melee_GenericAttack_Start PARENT;
};   

class AVP_Predator_Move_Melee_PredalienPounceAttack_Start1 : public AVP_Predator_Move_Melee_PredalienPounceAttack_StartBase
{
public:

	AVP_Predator_Move_Melee_PredalienPounceAttack_Start1(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return 0x9ce6739b; } // Asura_GetHashID("AVP_Predator_Move_Melee_PredalienPounceAttack_Start1")); }

private:

	typedef AVP_Predator_Move_Melee_PredalienPounceAttack_StartBase PARENT;
};   

class AVP_Predator_Move_Melee_PredalienPounceAttack_Start2 : public AVP_Predator_Move_Melee_PredalienPounceAttack_StartBase
{
public:

	AVP_Predator_Move_Melee_PredalienPounceAttack_Start2(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return 0x9ce6739c; } // Asura_GetHashID("AVP_Predator_Move_Melee_PredalienPounceAttack_Start2")); }

private:

	typedef AVP_Predator_Move_Melee_PredalienPounceAttack_StartBase PARENT;
};   

class AVP_Predator_Move_Melee_PredalienPounceAttack_StartKill : public AVP_Predator_Move_Melee_PredalienPounceAttack_StartBase
{
public:

	AVP_Predator_Move_Melee_PredalienPounceAttack_StartKill(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return 0xa60317b4; } // Asura_GetHashID("AVP_Predator_Move_Melee_PredalienPounceAttack_StartKill")); }

private:

	typedef AVP_Predator_Move_Melee_PredalienPounceAttack_StartBase PARENT;
};   


class AVP_Predator_Move_Melee_PredalienPounceAttack_Return_Hit : public AVP_Move_Melee_GenericAttack_Return_Hit
{
public:
	AVP_Predator_Move_Melee_PredalienPounceAttack_Return_Hit(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	virtual bool ShouldStart() const;

	static Asura_Hash_ID GetStaticHash() { return 0xc738ed90; } // Asura_GetHashID("AVP_Predator_Move_Melee_PredalienPounceAttack_Return_Hit")); }

private:
	typedef AVP_Move_Melee_GenericAttack_Return_Hit PARENT;
};   

class AVP_Predator_Move_Melee_PredalienPounceAttack_Return_Countered : public AVP_Move_Melee_GenericAttack_Return_Countered
{
public:
	AVP_Predator_Move_Melee_PredalienPounceAttack_Return_Countered(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return 0xe4b2fbd8; } // Asura_GetHashID("AVP_Predator_Move_Melee_PredalienPounceAttack_Return_Countered")); }

private:
	typedef AVP_Move_Melee_GenericAttack_Return_Countered PARENT;
}; 

class AVP_Predator_Move_Melee_PredalienPounceAttack_Return_Miss : public AVP_Move_Melee_GenericAttack_Return_Miss
{
public:
	AVP_Predator_Move_Melee_PredalienPounceAttack_Return_Miss(Asura_Movement_System& xParentSystem, Asura_Hash_ID uFirstPersonBlueprintHash, Asura_Hash_ID uThirdPersonBlueprintHash);

	static Asura_Hash_ID GetStaticHash() { return 0x1fe70a9f; } // Asura_GetHashID("AVP_Predator_Move_Melee_PredalienPounceAttack_Return_Miss")); }

private:
	typedef AVP_Move_Melee_GenericAttack_Return_Miss PARENT;
};

class AVP_Predator_Move_Melee_PredalienPounceAttack_Grapple1 : public AVP_Move_Melee_GenericPuppeteer_Start
{
public:
	AVP_Predator_Move_Melee_PredalienPounceAttack_Grapple1(Asura_Movement_System& xParentSystem);

	static Asura_Hash_ID GetStaticHash() { return 0xb4a0514e; } // Asura_GetHashID("AVP_Predator_Move_Melee_PredalienPounceAttack_Grapple1")); }

	virtual void UpdateStates(const float fTimeStep);

protected:
	virtual bool Start(const Asura_Msg_Move* pxStartMsg);

private:
	typedef AVP_Move_Melee_GenericPuppeteer_Start PARENT;
};   

class AVP_Predator_Move_Melee_PredalienPounceAttack_Grapple2 : public AVP_Move_Melee_GenericPuppeteer_Start
{
public:
	AVP_Predator_Move_Melee_PredalienPounceAttack_Grapple2(Asura_Movement_System& xParentSystem);

	static Asura_Hash_ID GetStaticHash() { return 0xb4a0514f; } // Asura_GetHashID("AVP_Predator_Move_Melee_PredalienPounceAttack_Grapple2")); }

	virtual void UpdateStates(const float fTimeStep);

protected:
	virtual bool Start(const Asura_Msg_Move* pxStartMsg);

private:
	typedef AVP_Move_Melee_GenericPuppeteer_Start PARENT;
};   

class AVP_Predator_Move_Melee_PredalienPounceAttack_GrappleKill : public AVP_Move_Melee_GenericPuppeteer_Start
{
public:
	AVP_Predator_Move_Melee_PredalienPounceAttack_GrappleKill(Asura_Movement_System& xParentSystem);

	static Asura_Hash_ID GetStaticHash() { return 0xac717921; } // Asura_GetHashID("AVP_Predator_Move_Melee_PredalienPounceAttack_GrappleKill")); }

	virtual void UpdateStates(const float fTimeStep);

protected:
	virtual bool Start(const Asura_Msg_Move* pxStartMsg);

private:
	typedef AVP_Move_Melee_GenericPuppeteer_Start PARENT;
};   


#endif   // ifndef __AVP_PREDATOR_MOVES_MELEE_H__

/// End of file. ///
