//
// AVP_Multiplayer_KillCounter.h
//
// Created by JG - 18 August 2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AVP_MULTIPLAYER_KILLCOUNTER_H__
#define __AVP_MULTIPLAYER_KILLCOUNTER_H__

//----------------------------------------------------------------------------------------
//////////////////////////////////////////////////////////////////////////////////////////
//  CLASS    :  AVP_Multiplayer_KillCounter
//  CREATED  :  JG (18.8.2008)
//  DESC     :  Stores number of times a player have killed / have been killed by another.
//				Up to the using class, probably both type of counters are going to be useful
//////////////////////////////////////////////////////////////////////////////////////////
//----------------------------------------------------------------------------------------
class AVP_Multiplayer_KillCounter
{
public:
	// Contructor / destructor
	AVP_Multiplayer_KillCounter( Asura_Guid uPlayerInfoGuid ); 
	~AVP_Multiplayer_KillCounter(); 

	// Reset kill counter
	void Reset( void ) ;

	// Accesor to the player guid
	Asura_Guid GetGuid( void) const							{ return m_uPlayerInfoGuid; }

	// Accesors to number of kills
	void SetNumberOfKills( u_int uNumberOfKills )			{ m_uNumberOfKills = uNumberOfKills; }
	u_int GetNumberOfKills( void ) const					{ return m_uNumberOfKills; }

	// Required by the hashed list find object
	bool IsDestroyed( void )								{ return false; }

protected: 
	Asura_Guid		m_uPlayerInfoGuid; 
	u_int			m_uNumberOfKills; 
}; 

#endif//__AVP_MULTIPLAYER_KILLCOUNTER_H__