//
// AVP_Multiplayer_ScoreBoard.h
//
// Created by JG - 29 May 2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AVP_MULTIPLAYER_SCOREBOARD_H__
#define __AVP_MULTIPLAYER_SCOREBOARD_H__

#include "Core/Asura_List.h"

// Project
#include "Core/AVP_Settings.h"
#include "Entity/PlayerInfo/AVP_ClientEntity_PlayerInfo.h"
#include "GUIMenu/AVP_GUIMenu_System.h"

// Forward declarations
class AVP_ClientEntity_PlayerInfo; 

// data needed for listbox image display conditions. 
struct AVP_Multiplayer_PlayerData
{
	bool m_bTalking;
	bool m_bLocalPlayer;
	int m_iSpecies;
};

class AVP_Multiplayer_ScoreBoard
{
public: 
	AVP_Multiplayer_ScoreBoard(); 
	~AVP_Multiplayer_ScoreBoard(); 

	// Global funtions for the ScoreBoard system
	static void Initialise(); 
	static void Update(); 
	static void RenderDebugInfo();
	static void Render();
	static void Shutdown(); 
	static void InitialiseScoreBoardHudCommands();
	static void ActivateResultsTables();

	// Show / hide the scoreboard
	static void SetScoreBoardVisible(bool bVisible)				{ s_bRenderScoreBoard = bVisible; }

	// Data
	static bool s_bRenderDebugInfo; 
	static bool s_bRenderScoreBoard;

	// access functions for the scoreboard, used because population and visibility functions cannot have extra arguments
	static bool ConsoleCmd_PopulateScoreTeam0( u_int uElementIndex, bool bInterrogate, bool bHelp )		{ if ( bInterrogate || bHelp ){ return true; } return GetScoreListValue( uElementIndex, AVP_Settings::AVP_TEAM_NONE ); }
	static bool ConsoleCmd_PopulateScoreTeam1( u_int uElementIndex, bool bInterrogate, bool bHelp )		{ if ( bInterrogate || bHelp ){ return true; } return GetScoreListValue( uElementIndex, AVP_Settings::AVP_TEAM_ONE ); }
	static bool ConsoleCmd_PopulateScoreTeam2( u_int uElementIndex, bool bInterrogate, bool bHelp )		{ if ( bInterrogate || bHelp ){ return true; } return GetScoreListValue( uElementIndex, AVP_Settings::AVP_TEAM_TWO ); }
	static bool ConsoleCmd_PopulateScoreTeam3( u_int uElementIndex, bool bInterrogate, bool bHelp )		{ if ( bInterrogate || bHelp ){ return true; } return GetScoreListValue( uElementIndex, AVP_Settings::AVP_TEAM_THREE ); }

	static bool ConsoleCmd_PopulateNameTeam0( u_int uElementIndex, bool bInterrogate, bool bHelp )		{ if ( bInterrogate || bHelp ){ return true; } return GetNameListValue( uElementIndex, AVP_Settings::AVP_TEAM_NONE ); }
	static bool ConsoleCmd_PopulateNameTeam1( u_int uElementIndex, bool bInterrogate, bool bHelp )		{ if ( bInterrogate || bHelp ){ return true; } return GetNameListValue( uElementIndex, AVP_Settings::AVP_TEAM_ONE ); }
	static bool ConsoleCmd_PopulateNameTeam2( u_int uElementIndex, bool bInterrogate, bool bHelp )		{ if ( bInterrogate || bHelp ){ return true; } return GetNameListValue( uElementIndex, AVP_Settings::AVP_TEAM_TWO ); }
	static bool ConsoleCmd_PopulateNameTeam3( u_int uElementIndex, bool bInterrogate, bool bHelp )		{ if ( bInterrogate || bHelp ){ return true; } return GetNameListValue( uElementIndex, AVP_Settings::AVP_TEAM_THREE ); }
	
	static bool ConsoleCmd_PopulateKillsTeam0( u_int uElementIndex, bool bInterrogate, bool bHelp )		{ if ( bInterrogate || bHelp ){ return true; } return GetKillsListValue( uElementIndex, AVP_Settings::AVP_TEAM_NONE ); }
	static bool ConsoleCmd_PopulateKillsTeam1( u_int uElementIndex, bool bInterrogate, bool bHelp )		{ if ( bInterrogate || bHelp ){ return true; } return GetKillsListValue( uElementIndex, AVP_Settings::AVP_TEAM_ONE ); }
	static bool ConsoleCmd_PopulateKillsTeam2( u_int uElementIndex, bool bInterrogate, bool bHelp )		{ if ( bInterrogate || bHelp ){ return true; } return GetKillsListValue( uElementIndex, AVP_Settings::AVP_TEAM_TWO ); }
	static bool ConsoleCmd_PopulateKillsTeam3( u_int uElementIndex, bool bInterrogate, bool bHelp )		{ if ( bInterrogate || bHelp ){ return true; } return GetKillsListValue( uElementIndex, AVP_Settings::AVP_TEAM_THREE ); }

	static bool ConsoleCmd_PopulateDeathsTeam0( u_int uElementIndex, bool bInterrogate, bool bHelp )	{ if ( bInterrogate || bHelp ){ return true; } return GetDeathsListValue( uElementIndex, AVP_Settings::AVP_TEAM_NONE ); }
	static bool ConsoleCmd_PopulateDeathsTeam1( u_int uElementIndex, bool bInterrogate, bool bHelp )	{ if ( bInterrogate || bHelp ){ return true; } return GetDeathsListValue( uElementIndex, AVP_Settings::AVP_TEAM_ONE ); }
	static bool ConsoleCmd_PopulateDeathsTeam2( u_int uElementIndex, bool bInterrogate, bool bHelp )	{ if ( bInterrogate || bHelp ){ return true; } return GetDeathsListValue( uElementIndex, AVP_Settings::AVP_TEAM_TWO ); }
	static bool ConsoleCmd_PopulateDeathsTeam3( u_int uElementIndex, bool bInterrogate, bool bHelp )	{ if ( bInterrogate || bHelp ){ return true; } return GetDeathsListValue( uElementIndex, AVP_Settings::AVP_TEAM_THREE ); }

	static bool ConsoleCmd_PopulateStreakTeam0( u_int uElementIndex, bool bInterrogate, bool bHelp )	{ if ( bInterrogate || bHelp ){ return true; } return GetStreakListValue( uElementIndex, AVP_Settings::AVP_TEAM_NONE ); }
	static bool ConsoleCmd_PopulateStreakTeam1( u_int uElementIndex, bool bInterrogate, bool bHelp )	{ if ( bInterrogate || bHelp ){ return true; } return GetStreakListValue( uElementIndex, AVP_Settings::AVP_TEAM_ONE ); }
	static bool ConsoleCmd_PopulateStreakTeam2( u_int uElementIndex, bool bInterrogate, bool bHelp )	{ if ( bInterrogate || bHelp ){ return true; } return GetStreakListValue( uElementIndex, AVP_Settings::AVP_TEAM_TWO ); }
	static bool ConsoleCmd_PopulateStreakTeam3( u_int uElementIndex, bool bInterrogate, bool bHelp )	{ if ( bInterrogate || bHelp ){ return true; } return GetStreakListValue( uElementIndex, AVP_Settings::AVP_TEAM_THREE ); }

	static bool ConsoleCmd_PopulateRatioTeam0( u_int uElementIndex, bool bInterrogate, bool bHelp )	{ if ( bInterrogate || bHelp ){ return true; } return GetRatioListValue( uElementIndex, AVP_Settings::AVP_TEAM_NONE ); }
	static bool ConsoleCmd_PopulateRatioTeam1( u_int uElementIndex, bool bInterrogate, bool bHelp )	{ if ( bInterrogate || bHelp ){ return true; } return GetRatioListValue( uElementIndex, AVP_Settings::AVP_TEAM_ONE ); }
	static bool ConsoleCmd_PopulateRatioTeam2( u_int uElementIndex, bool bInterrogate, bool bHelp )	{ if ( bInterrogate || bHelp ){ return true; } return GetRatioListValue( uElementIndex, AVP_Settings::AVP_TEAM_TWO ); }
	static bool ConsoleCmd_PopulateRatioTeam3( u_int uElementIndex, bool bInterrogate, bool bHelp )	{ if ( bInterrogate || bHelp ){ return true; } return GetRatioListValue( uElementIndex, AVP_Settings::AVP_TEAM_THREE ); }

	static bool ConsoleCmd_PopulateTeamScore( u_int uElementIndex, bool bInterrogate, bool bHelp );
	
	static bool DeactivateResultScreens( u_int uPageID, bool bInterrogate, bool bHelp );
	static bool ActivateResultScreens( u_int uPageID, bool bInterrogate, bool bHelp );

	static bool ConsoleCmd_VisibleMarineTeam0( u_int uElementIndex, bool bInterrogate, bool bHelp )		{ if ( bInterrogate || bHelp ){ return true; } return GetSpeciesVisible( uElementIndex, AVP_Settings::AVP_TEAM_NONE, AVP_Settings::AVP_SPECIES_HUMAN ); }
	static bool ConsoleCmd_VisibleMarineTeam1( u_int uElementIndex, bool bInterrogate, bool bHelp )		{ if ( bInterrogate || bHelp ){ return true; } return GetSpeciesVisible( uElementIndex, AVP_Settings::AVP_TEAM_ONE, AVP_Settings::AVP_SPECIES_HUMAN ); }
	static bool ConsoleCmd_VisibleMarineTeam2( u_int uElementIndex, bool bInterrogate, bool bHelp )		{ if ( bInterrogate || bHelp ){ return true; } return GetSpeciesVisible( uElementIndex, AVP_Settings::AVP_TEAM_TWO, AVP_Settings::AVP_SPECIES_HUMAN ); }
	static bool ConsoleCmd_VisibleMarineTeam3( u_int uElementIndex, bool bInterrogate, bool bHelp )		{ if ( bInterrogate || bHelp ){ return true; } return GetSpeciesVisible( uElementIndex, AVP_Settings::AVP_TEAM_THREE, AVP_Settings::AVP_SPECIES_HUMAN ); }

	static bool ConsoleCmd_VisibleAlienTeam0( u_int uElementIndex, bool bInterrogate, bool bHelp )		{ if ( bInterrogate || bHelp ){ return true; } return GetSpeciesVisible( uElementIndex, AVP_Settings::AVP_TEAM_NONE, AVP_Settings::AVP_SPECIES_ALIEN ); }
	static bool ConsoleCmd_VisibleAlienTeam1( u_int uElementIndex, bool bInterrogate, bool bHelp )		{ if ( bInterrogate || bHelp ){ return true; } return GetSpeciesVisible( uElementIndex, AVP_Settings::AVP_TEAM_ONE, AVP_Settings::AVP_SPECIES_ALIEN ); }
	static bool ConsoleCmd_VisibleAlienTeam2( u_int uElementIndex, bool bInterrogate, bool bHelp )		{ if ( bInterrogate || bHelp ){ return true; } return GetSpeciesVisible( uElementIndex, AVP_Settings::AVP_TEAM_TWO, AVP_Settings::AVP_SPECIES_ALIEN ); }
	static bool ConsoleCmd_VisibleAlienTeam3( u_int uElementIndex, bool bInterrogate, bool bHelp )		{ if ( bInterrogate || bHelp ){ return true; } return GetSpeciesVisible( uElementIndex, AVP_Settings::AVP_TEAM_THREE, AVP_Settings::AVP_SPECIES_ALIEN ); }

	static bool ConsoleCmd_VisiblePredatorTeam0( u_int uElementIndex, bool bInterrogate, bool bHelp )	{ if ( bInterrogate || bHelp ){ return true; } return GetSpeciesVisible( uElementIndex, AVP_Settings::AVP_TEAM_NONE, AVP_Settings::AVP_SPECIES_PREDATOR ); }
	static bool ConsoleCmd_VisiblePredatorTeam1( u_int uElementIndex, bool bInterrogate, bool bHelp )	{ if ( bInterrogate || bHelp ){ return true; } return GetSpeciesVisible( uElementIndex, AVP_Settings::AVP_TEAM_ONE, AVP_Settings::AVP_SPECIES_PREDATOR ); }
	static bool ConsoleCmd_VisiblePredatorTeam2( u_int uElementIndex, bool bInterrogate, bool bHelp )	{ if ( bInterrogate || bHelp ){ return true; } return GetSpeciesVisible( uElementIndex, AVP_Settings::AVP_TEAM_TWO, AVP_Settings::AVP_SPECIES_PREDATOR ); }
	static bool ConsoleCmd_VisiblePredatorTeam3( u_int uElementIndex, bool bInterrogate, bool bHelp )	{ if ( bInterrogate || bHelp ){ return true; } return GetSpeciesVisible( uElementIndex, AVP_Settings::AVP_TEAM_THREE, AVP_Settings::AVP_SPECIES_PREDATOR ); }

	static bool ConsoleCmd_VisibleTalkingTeam0( u_int uElementIndex, bool bInterrogate, bool bHelp )	{ if ( bInterrogate || bHelp ){ return true; } return GetTalkingVisible( uElementIndex, AVP_Settings::AVP_TEAM_NONE ); }
	static bool ConsoleCmd_VisibleTalkingTeam1( u_int uElementIndex, bool bInterrogate, bool bHelp )	{ if ( bInterrogate || bHelp ){ return true; } return GetTalkingVisible( uElementIndex, AVP_Settings::AVP_TEAM_ONE ); }
	static bool ConsoleCmd_VisibleTalkingTeam2( u_int uElementIndex, bool bInterrogate, bool bHelp )	{ if ( bInterrogate || bHelp ){ return true; } return GetTalkingVisible( uElementIndex, AVP_Settings::AVP_TEAM_TWO ); }
	static bool ConsoleCmd_VisibleTalkingTeam3( u_int uElementIndex, bool bInterrogate, bool bHelp )	{ if ( bInterrogate || bHelp ){ return true; } return GetTalkingVisible( uElementIndex, AVP_Settings::AVP_TEAM_THREE ); }

	static bool ConsoleCmd_VisibleHighlightTeam0( u_int uElementIndex, bool bInterrogate, bool bHelp )	{ if ( bInterrogate || bHelp ){ return true; } return GetHighlightVisible( uElementIndex, AVP_Settings::AVP_TEAM_NONE ); }
	static bool ConsoleCmd_VisibleHighlightTeam1( u_int uElementIndex, bool bInterrogate, bool bHelp )	{ if ( bInterrogate || bHelp ){ return true; } return GetHighlightVisible( uElementIndex, AVP_Settings::AVP_TEAM_ONE ); }
	static bool ConsoleCmd_VisibleHighlightTeam2( u_int uElementIndex, bool bInterrogate, bool bHelp )	{ if ( bInterrogate || bHelp ){ return true; } return GetHighlightVisible( uElementIndex, AVP_Settings::AVP_TEAM_TWO ); }
	static bool ConsoleCmd_VisibleHighlightTeam3( u_int uElementIndex, bool bInterrogate, bool bHelp )	{ if ( bInterrogate || bHelp ){ return true; } return GetHighlightVisible( uElementIndex, AVP_Settings::AVP_TEAM_THREE ); }

	/////////////////////////////////////////////////////////////////
	// CAH temporary function to fill leaderboards with pseudo data. 
	static bool ConsoleCmd_PopulateLeaderBoard( u_int uElementIndex, bool bInterrogate, bool bHelp );	

protected:

	// Team score based on individual player scores
	static int GetBasicTeamScore( AVP_Settings::Team eTeam ); 

	// Function to sort player info entities in a list
	static int SortByScore(const AVP_ClientEntity_PlayerInfo& xPlayerInfoA, const AVP_ClientEntity_PlayerInfo& xPlayerInfoB );
	static int SortByKills(const AVP_ClientEntity_PlayerInfo& xPlayerInfoA, const AVP_ClientEntity_PlayerInfo& xPlayerInfoB );
	static int SortByDeaths(const AVP_ClientEntity_PlayerInfo& xPlayerInfoA, const AVP_ClientEntity_PlayerInfo& xPlayerInfoB );

	// lists to populate the score board listboxs, filled in each frame the list is rendered. array '0' is for non-teamed games. 
	static Asura_List<AVP_ClientEntity_PlayerInfo> m_axPlayerInfoSortedLists[AVP_Settings::AVP_NUM_TEAMS]; 



private:

	// board value returns for population.
	static bool GetScoreListValue( u_int uElementIndex, u_int uTeamIndex );
	static bool GetNameListValue( u_int uElementIndex, u_int uTeamIndex );
	static bool GetKillsListValue( u_int uElementIndex, u_int uTeamIndex );
	static bool GetDeathsListValue( u_int uElementIndex, u_int uTeamIndex );
	static bool GetStreakListValue( u_int uElementIndex, u_int uTeamIndex );
	static bool GetRatioListValue( u_int uElementIndex, u_int uTeamIndex );

	// board value returns for visibility.
	static bool GetSpeciesVisible( u_int uElementIndex, u_int uTeamIndex, u_int uSpecies );
	static bool GetTalkingVisible( u_int uElementIndex, u_int uTeamIndex );
	static bool GetHighlightVisible( u_int uElementIndex, u_int uTeamIndex );

	static void SetScoreBoardTitle( u_int uPageIndex, bool bRender );
	static void UpdatePlayerInfo();
	static void FillTextWidgetWithData( AVP_GUIMenu_System::STORED_WIDGETS eWidgetToFill, u_int uIdOfPageContainingWidget, const Asura_UnicodeChar* awcTextToEnter );
	static void FillTextWidgetWithText( AVP_GUIMenu_System::STORED_WIDGETS eWidgetToFill, u_int uIdOfPageContainingWidget, u_int uTextHashId );
	static void MakeRatioString( float fValueOne, float fValueTwo, Asura_UnicodeChar* awcBufferToFill );
	static int FindTotalKillsForTeam( u_int uTeam );
	static int FindTotalDeathsForTeam( u_int uTeam );
	static int FindHighestScoringIndividualInTeam( u_int uTeam );

	static bool s_b3TeamsPlaying;
	static bool s_bUseLargeTable;
	static bool s_bTeamBased;

	/////////////////////////////////////////////////////////////////
	// CAH temporary varigabel to fill leaderboards with pseudo data. 
	static bool s_bSpeciesToggle;

};
#endif//__AVP_MULTIPLAYER_SCOREBOARD_H__
