//
// AVP_Multiplayer_ScoreRules.h
//
// Created by JG - 30 June 2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AVP_MULTIPLAYER_SCORERULES_H__
#define __AVP_MULTIPLAYER_SCORERULES_H__

#include "Core/Asura.h"

#include "Blueprint/Asura_Blueprint.h"

#include "Core/AVP_Settings.h"

//----------------------------------------------------------------------------------------
//////////////////////////////////////////////////////////////////////////////////////////
//  CLASS    :  AVP_Multiplayer_ScoreRules
//  CREATED  :  JG (30.6.2008)
//  DESC     :  Team specific score information
//////////////////////////////////////////////////////////////////////////////////////////
//----------------------------------------------------------------------------------------

class AVP_Multiplayer_ScoreRules
{
public:
	static void Initialise(); 
	static void Shutdown(); 

	void SetRole(const AVP_Settings::Role iRole)							{ m_iRole = iRole; }
	void SetScoreKillAlien(const int iScoreKillAlien)						{ m_iScoreKillAlien = iScoreKillAlien; }
	void SetScoreKillAssist(const int iScoreKillAssist)						{ m_iScoreKillAssist = iScoreKillAssist; }
	void SetScoreKillHuman(const int iScoreKillHuman)						{ m_iScoreKillHuman = iScoreKillHuman; }
	void SetScoreKillPersecutorBonus(const int iScoreKillPersecutorBonus)	{ m_iScoreKillPersecutorBonus = iScoreKillPersecutorBonus; }
	void SetScoreKillPredator(const int iScoreKillPredator)					{ m_iScoreKillPredator = iScoreKillPredator; }
	void SetScoreKillTeammate(const int iScoreKillTeammate)					{ m_iScoreKillTeammate = iScoreKillTeammate; }
	void SetScoreKillYourself(const int iScoreKillYourself)					{ m_iScoreKillYourself = iScoreKillYourself; }
	void SetSpecies(const AVP_Settings::Species iSpecies)					{ m_iSpecies = iSpecies; }

	int GetRole() const									{ return  m_iRole; }
	int GetScoreKillAlien() const						{ return  m_iScoreKillAlien; }
	int GetScoreKillAssist() const						{ return  m_iScoreKillAssist; }
	int GetScoreKillHuman() const						{ return  m_iScoreKillHuman; }
	int GetScoreKillPersecutorBonus() const				{ return  m_iScoreKillPersecutorBonus; }
	int GetScoreKillPredator() const					{ return  m_iScoreKillPredator; }
	int GetScoreKillTeammate() const					{ return  m_iScoreKillTeammate; }
	int GetScoreKillYourself() const					{ return  m_iScoreKillYourself; }
	int GetSpecies() const								{ return  m_iSpecies; }

	int GetScoreKillSpecies( AVP_Settings::Species eSpecie ); 

	// Score based on species / game type
	static AVP_Multiplayer_ScoreRules* GetScoreTable( AVP_Settings::Species eSpecie, AVP_Settings::GameType eGametype ); 

private:
	AVP_Multiplayer_ScoreRules( Asura_Hash_ID uBlueprintType, Asura_Hash_ID uBlueprintName ); 
	~AVP_Multiplayer_ScoreRules(); 

	void Initialise( Asura_Hash_ID uBlueprintType, Asura_Hash_ID uBlueprintName ); 
	void InitialiseFromBlueprint( const Asura_Blueprint& xBlueprint ); 

	Asura_Hash_ID	m_uBlueprintType; 
	Asura_Hash_ID	m_uBlueprintName; 

	AVP_Settings::Role				m_iRole;
	int								m_iScoreKillAlien; 
	int								m_iScoreKillAssist;
	int								m_iScoreKillHuman; 
	int								m_iScoreKillPersecutorBonus; 
	int								m_iScoreKillPredator;
	int								m_iScoreKillTeammate; 
	int								m_iScoreKillYourself; 
	AVP_Settings::Species			m_iSpecies;

	// Team scores
	static bool	s_bInitialised; 
	static AVP_Multiplayer_ScoreRules*	s_aapxScoreTable[AVP_Settings::AVP_NUM_SPECIES][AVP_Settings::AVP_NUM_GAMETYPES];
};

#endif//__AVP_MULTIPLAYER_SCORERULES_H__