//
// AVP_Multiplayer_SpawnSystem.h
//
// Created by JG - 13 October 2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

// Engine
#include "Entity/Spawners/AVP_ServerEntity_StartPoint.h"

// Project 
#include "Core/AVP_Settings.h"

// Forward declarations
class AVP_ServerEntity_StartPoint; 
template<typename T> class Asura_List;
template<typename T> class Asura_Hashed_List;

#ifndef __AVP_MULTIPLAYER_SPAWNSYSTEM_H__
#define __AVP_MULTIPLAYER_SPAWNSYSTEM_H__

class AVP_Multiplayer_SpawnSystem
{
public:
	static void Initialise(); 
	static void Update(); 
	static void Render();
	static void Shutdown(); 
	
	static AVP_ServerEntity_StartPoint* FindRandomStartPointForIndividual( Asura_Guid uPlayerGuid );
	static AVP_ServerEntity_StartPoint* FindRandomStartPointForIndividual( AVP_Settings::Species eSpecies );
	static AVP_ServerEntity_StartPoint* FindRandomStartPointForTeam( Asura_Guid uPlayerGuid );
	static AVP_ServerEntity_StartPoint* FindRandomStartPointForTeam( AVP_Settings::Team eTeam );

protected:
	static void ClearStartPointLists();
	static void BuildStartPointList( Asura_Hashed_List<AVP_ServerEntity_StartPoint>& xStartPointList, Asura_Hash_ID uBlueprintParameterHash ); 
	static void CreateSuitableStartPointList( const Asura_Hashed_List<AVP_ServerEntity_StartPoint>& xInputList, 
											  Asura_List<AVP_ServerEntity_StartPoint>& xOutputList );
	
	static Asura_Hashed_List<AVP_ServerEntity_StartPoint>& GetStartPointListForTeam( AVP_Settings::Team eTeam ); 
	static Asura_Hashed_List<AVP_ServerEntity_StartPoint>& GetStartPointListForSpecies( AVP_Settings::Species eTeam ); 

	static Asura_Hashed_List<AVP_ServerEntity_StartPoint> s_xSpeciesAlienStartPointList;
	static Asura_Hashed_List<AVP_ServerEntity_StartPoint> s_xSpeciesHumanStartPointList;
	static Asura_Hashed_List<AVP_ServerEntity_StartPoint> s_xSpeciesPredatorStartPointList;
	static Asura_Hashed_List<AVP_ServerEntity_StartPoint> s_xTeamOneStartPointList; 
	static Asura_Hashed_List<AVP_ServerEntity_StartPoint> s_xTeamTwoStartPointList;
	static Asura_Hashed_List<AVP_ServerEntity_StartPoint> s_xTeamThreeStartPointList; 
}; 

#endif//__AVP_MULTIPLAYER_SPAWNSYSTEM_H__