
///////////////////////////////////////////////////////////////////////////////
//
// File   : Asura_StreamingConfiguration.h
// Author : Andy Tate
// Date   : 3-Mar-2006
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __ASURA_STREAMINGCONFIGURATION_H__
#define __ASURA_STREAMINGCONFIGURATION_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// General defines...
////////////////////////////////////////////////////////////////////////////////

// Size of the cache to use...
#if defined(WIN32)
#define AUSRA_STREAMING_FILE_CACHE_SIZE					(10 * 1024 * 1024)
#else
#define AUSRA_STREAMING_FILE_CACHE_SIZE					(((2 * 1024) + 512) * 1024)
#endif	// defined(WIN32)
#define AUSRA_STREAMING_NUM_FILE_CACHE_SECTIONS			2

// One-off defines...
#define ASURA_STREAMING_PERMANENT_RESOURCE_SIZE			(1 * 1024 * 1024)
#define ASURA_STREAMING_COMMON_RESOURCE_SIZE			(((2 * 1024) + 512) * 1024)
#define ASURA_STREAMING_SKYBOX_RESOURCE_SIZE			(272 * 1024)

// High-detail defines...
#define ASURA_STREAMING_MAX_RESIDENT_HIGH_DETAIL_ZONES	4
#define ASURA_STREAMING_HIGH_DETAIL_ZONE_RESOURCE_SIZE	(((1 * 1024) + 800) * 1024)

// Low-detail defines...
#define ASURA_STREAMING_MAX_RESIDENT_LOW_DETAIL_ZONES	8
#define ASURA_STREAMING_LOW_DETAIL_ZONE_RESOURCE_SIZE	(85 * 1024)

// Mission-specific defines...
#define ASURA_STREAMING_MAX_RESIDENT_MISSIONS			1
#define ASURA_STREAMING_MISSION_RESOURCE_SIZE			(((1 * 1024) + 400) * 1024)

#endif   // ifndef __ASURA_STREAMINGCONFIGURATION_H__


/// End of file. ///
