//////////////////////////////////////////////////////////////////////////////
//
// AVP_Rewards_System.h
//
// Copyright (c) 2009 Rebellion. All rights reserved.
//
// Description:
//
//     defintions for project rewards
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef AVP_REWARDS_SYSTEM_H___
#define AVP_REWARDS_SYSTEM_H___ 1

// NY - 31 March 2009 - make sure ifdef guards are used, so it's easy to turn off if needed (can't see it being wanted in tools for example)
#ifdef ASURA_USE_REWARDS

// NY - 31 March 2009 - define events for the project. These represent each event the handler needs to invoked for, and won't always correspond directly to a reward.
// these are broadly independent - whilst some might only be invoked by one platform, or invoked differently, defining them all in one place is much tidier
static const Asura_Hash_ID uAVP_EVENT_LEVEL_COMPLETE = 0x9e057b94; //"level_complete"

// NY - 31 March 2009 - enumeration of project rewards - these are all rewards for all platforms, mapping (or not) to achievements or trophies is done seperatly
// the event handlers can then unlock any of these rewards without having to worry about whether they are mapped on the current platform
enum AVP_REWARDS
{
	AVP_REWARD_COMPLETE_LEVEL = 0,// NY - 07 April 2009 - placeholder

	AVP_NUM_REWARDS // used for array bounds
};
#endif // #ifdef ASURA_USE_REWARDS

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

#endif // #ifndef AVP_REWARDS_SYSTEM_H___
