//////////////////////////////////////////////////////////////////////////////
//
// Asura_Project_Rewards_System.cpp
//
// Copyright (c) 2009 Rebellion. All rights reserved.
//
// Description:
//
//     Project functions for rewards system
//
//////////////////////////////////////////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "Core/Asura.h"

#ifdef ASURA_USE_REWARDS

#include "Rewards/Asura_Rewards_System.h"

#include "Rewards/AVP_Rewards_System.h"

// NY - 31 March 2009 - platform independent event handler - ideally all handling should go here,
// unless it either requires platform specific code or is unique to one platform
void Asura_Rewards_System::Project_HandleEvent(Asura_Hash_ID uEventHash, int iEventData)
{
	switch (uEventHash)
	{
		case uAVP_EVENT_LEVEL_COMPLETE:
		{
			if (!IsRewardUnlocked(AVP_REWARD_COMPLETE_LEVEL))
			{
				Platform_UnlockReward(AVP_REWARD_COMPLETE_LEVEL);
			}
			break;
		}
		default:
		{
			// do nothing
			break;
		}
	}
}
#endif // #ifdef ASURA_USE_REWARDS
