
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_DamagePFX.h
// Author : Steven Lovesey
// Date   : 30-Apr-2009
//
// Copyright (C) 2009 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_DAMAGEPFX_H__
#define __AVP_DAMAGEPFX_H__

///////////////////
// Include files //
///////////////////

#include "Core/Asura.h"
#include "Core/Asura_Maths.h"
#include "Core/Asura_List.h"
////////////////////////////////
// Forward class declarations //
////////////////////////////////

class AVP_DamagePFX;
class Asura_Bounding_Box;

///////////////////////
// Class declaration //
///////////////////////

class AVP_DamagePFX
{
	public:
	
		static void Update();
		static void Shutdown();
		static void AddDamagePFX( u_int uPFXHandle , float fDamageDelay, float fDamageInterval, float fLifetime, float fDamage, float fBBScale, Asura_Hash_ID uDamageType);

		static bool s_bDebugRender;

	protected:

		AVP_DamagePFX();
		virtual ~AVP_DamagePFX();
		void ResizeBoundingBox(Asura_Bounding_Box* xBB);
		bool UpdateElement();
		void DoCollisionTests(Asura_Bounding_Box* xBB);

		u_int m_uPFXHandle;

		float m_fDamageDelay;
		float m_fDamageInterval;
		float m_fLifetime; 
		float m_fDamage;
		float m_fBBScale;
		Asura_Hash_ID m_uDamageType;

		float m_fTimeSinceLastDamage;
		static Asura_List<AVP_DamagePFX> s_xList;
	
};
	

#endif   // ifndef __AVP_DAMAGEPFX_H__

/// End of file. ///
