
///////////////////////////////////////////////////////////////////////////////
//
// File   : Asura_Project_Streaming_SubsystemHandlers.cpp
// Author : Andy Tate
// Date   : 3-Apr-2006
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Core/Asura.h"

// This file's header...
#include "Streaming/Asura_Streaming_SubsystemHandlers.h"

// Asura independent header-files...

// Asura platform header-files...

// Game independent header-files...

// Game platform header-files...

// Tools header-files...


////////////////////////////////////////////////////////////////////////////////
// Constant declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Static variable declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Private functions...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Function     : Asura_Streaming_SubsystemHandlers::Project_CreateHandlerData
// Author       : Andy Tate
// Date         : 8-May-2006
////////////////////////////////////////////////////////////////////////////////

bool Asura_Streaming_SubsystemHandlers::Project_CreateHandlerData (u_int& uHandlerIndex,
																   const Asura_Hash_ID uHandlerHash,
																   const u_int uDataIndex,
																   const char* szName,
																   const Asura_Hash_ID uParentHandlerHash)
{
	// What about platform-specific zone-handlers?
	switch(uHandlerIndex)
	{
		case BEGIN_PROJECT_HANDLER_INDEX + 0:
		{
			uHandlerIndex	= END_PROJECT_HANDLER_INDEX;
			return(true);
		}

		default:
		{
			return(false);
		}
	}		// End of switch.
}

/// End of function 'Asura_Streaming_SubsystemHandlers::Project_CreateHandlerData'. ///



////////////////////////////////////////////////////////////////////////////////
// Function     : Asura_Streaming_SubsystemHandlers::Project_CreateZoneData
// Author       : Andy Tate
// Date         : 8-May-2006
////////////////////////////////////////////////////////////////////////////////

bool Asura_Streaming_SubsystemHandlers::Project_CreateZoneData (u_int& uHandlerIndex,
																const Asura_Hash_ID uHandlerHash,
																const u_int uDataIndex,
																const char* szName,
																const Asura_Hash_ID uParentHandlerHash,
																const Asura_Hash_ID uZoneHash,
																const bool bAllowEnvironment)
{
	// What about platform-specific zone-handlers?
	switch(uHandlerIndex)
	{
        case BEGIN_PROJECT_ZONE_INDEX + 0:
        {
            uHandlerIndex = END_PROJECT_ZONE_INDEX;
            return(true);
        }

		default:
		{
			return(false);
		}
	}		// End of switch.
}

/// End of function 'Asura_Streaming_SubsystemHandlers::Project_CreateZoneData'. ///



////////////////////////////////////////////////////////////////////////////////
// Function     : Asura_Streaming_SubsystemHandlers::Project_DestroyHandlerData
// Author       : Andy Tate
// Date         : 8-May-2006
////////////////////////////////////////////////////////////////////////////////

bool Asura_Streaming_SubsystemHandlers::Project_DestroyHandlerData (u_int& uHandlerIndex,
																	const Asura_Hash_ID uHandlerHash,
																	const u_int uDataIndex)
{
	// What about platform-specific zone-handlers?
	switch(uHandlerIndex)
	{
		case BEGIN_PROJECT_HANDLER_INDEX + 0:
		{
			uHandlerIndex	= END_PROJECT_HANDLER_INDEX;
			return(true);
		}

		default:
		{
			return(false);
		}
	}		// End of switch.
}

/// End of function 'Asura_Streaming_SubsystemHandlers::Project_DestroyHandlerData'. ///



////////////////////////////////////////////////////////////////////////////////
// Function     : Asura_Streaming_SubsystemHandlers::Project_DestroyZoneData
// Author       : Andy Tate
// Date         : 8-May-2006
////////////////////////////////////////////////////////////////////////////////

bool Asura_Streaming_SubsystemHandlers::Project_DestroyZoneData (u_int& uHandlerIndex,
																 const Asura_Hash_ID uHandlerHash,
																 const u_int uDataIndex,
																 const bool bAllowEnvironment)
{
	// What about platform-specific zone-handlers?
	switch(uHandlerIndex)
	{
        case BEGIN_PROJECT_ZONE_INDEX + 0:
        {
            uHandlerIndex = END_PROJECT_ZONE_INDEX;
            return(true);
        }

		default:
		{
			return(false);
		}
	}		// End of switch.
}

/// End of function 'Asura_Streaming_SubsystemHandlers::Project_DestroyZoneData'. ///



////////////////////////////////////////////////////////////////////////////////
// Function     : Asura_Streaming_SubsystemHandlers::Project_SetAllHandlerData
// Author       : Andy Tate
// Date         : 8-May-2006
////////////////////////////////////////////////////////////////////////////////

void Asura_Streaming_SubsystemHandlers::Project_SetAllHandlerData (const Asura_Hash_ID uHandlerHash,
																   const u_int uDataIndex)
{
}

/// End of function 'Asura_Streaming_SubsystemHandlers::Project_SetAllHandlerData'. ///



////////////////////////////////////////////////////////////////////////////////
// Function     : Asura_Streaming_SubsystemHandlers::Project_SetAllZoneData
// Author       : Andy Tate
// Date         : 8-May-2006
////////////////////////////////////////////////////////////////////////////////

void Asura_Streaming_SubsystemHandlers::Project_SetAllZoneData (const Asura_Hash_ID uHandlerHash,
																const u_int uDataIndex,
																const bool bAllowEnvironment)
{
}

/// End of function 'Asura_Streaming_SubsystemHandlers::Project_SetAllZoneData'. ///



////////////////////////////////////////////////////////////////////////////////
// Protected functions...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Public functions...
////////////////////////////////////////////////////////////////////////////////


/// End of file. ///
