///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_PC_Actor_ControlMapper.h
// Author : Andy Tate
// Date   : 27-Sep-2007
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
// JL - 01 April 2009 - Modified version of PC file, used in PC-CLI
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_PC_ACTOR_CONTROLMAPPER_H__
#define __AVP_PC_ACTOR_CONTROLMAPPER_H__

////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////

class AVP_Actor_InputHandler;

////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_PC_Actor_ControlMapper
// Author       : Andy Tate
// Date         : 27-Sep-2007
//
// Description  : Class to handle the abstraction of PC actor-specific controls.
////////////////////////////////////////////////////////////////////////////////

class AVP_PC_Actor_ControlMapper
{
public:
	// Public functions...
	AVP_PC_Actor_ControlMapper(void)		{}
	virtual ~AVP_PC_Actor_ControlMapper()	{}

	void Initialise( AVP_Actor_InputHandler& xInputHandler );


protected:
	// Protected variables...

	// Protected functions...
	virtual void	InitialiseControlsPC(AVP_Actor_InputHandler& xInputHandler);
	virtual void	InitialiseControlsPS2(AVP_Actor_InputHandler& xInputHandler);
	virtual void	InitialiseControlsPS3(AVP_Actor_InputHandler& xInputHandler);
	virtual void	InitialiseControlsXBox360(AVP_Actor_InputHandler& xInputHandler);


private:
	// Private variables...

	// Private functions...
	AVP_PC_Actor_ControlMapper(const AVP_PC_Actor_ControlMapper& xOther);

	AVP_PC_Actor_ControlMapper&	operator=(const AVP_PC_Actor_ControlMapper& xOther);

};   // End of class 'AVP_PC_Actor_ControlMapper'.


#endif   // ifndef __AVP_PC_ACTOR_CONTROLMAPPER_H__


/// End of file. ///
