//////////////////////////////////////////////////////////////////////////////
//
// Asura_Platform_Project_Core.cpp
//
// Copyright (c) 2003 Rebellion. All rights reserved.
//
// JL - 01 April 2009 - Edited PC version used in PC-CLI, it has all references
// to directX removed to make sure PC-CLI doesnt need directX installed to run
//
//////////////////////////////////////////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "Core/Asura.h"

#include "ChunkSystem/Asura_Chunk_Loaders.h"
#include "Core/Asura_Core.h"
#include "Core/Asura_UserInput.h"

#ifdef ASURA_PC_SUPPORT_STEAMWORKS
#include "Network/Steamworks/Asura_PC_Steamworks.h"
#endif

#ifndef ASURA_TOOLS
#include "Core/Asura_Windows.h"
#endif

#include "Network/Steamworks/Asura_PC_SteamworksServer.h"

void Asura_Core::PlatformProject_EarlyInitialise()
{
	#ifdef ASURA_PC_SUPPORT_STEAMWORKS
	Asura_PC_Steamworks::EnableSteamworks();
	#endif
}

void Asura_Core::PlatformProject_LateInitialise()
{
#ifndef ASURA_TOOLS
	Asura_Windows::SetPauseWhileMinimised(false);
#endif

#ifdef ASURA_PC_SUPPORT_STEAMWORKS
	Asura_PC_Steamworks::RegisterConsoleCmds();
#endif
}
