
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_PC_Vertebrate_ControlMapper.cpp
// Author : Andy Tate
// Date   : 27-Sep-2007
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Core/Asura.h"

// This file's header...
#include "Actor/Vertebrates/AVP_PC_Vertebrate_ControlMapper.h"

// Asura independent header-files...

// Asura platform header-files...
#include "Input/Asura_PlatformInput.h"
#include "Input/Asura_PC_Input_Joystick.h"

// Game independent header-files...
#include "Actor/Vertebrates/AVP_Vertebrate_InputHandler.h"


////////////////////////////////////////////////////////////////////////////////
// Constant declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Static variable declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Private functions...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Protected functions...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Function     : AVP_PC_Vertebrate_ControlMapper::InitialiseControlsPC
// Author       : Andy Tate
// Date         : 27-Sep-2007
////////////////////////////////////////////////////////////////////////////////

void AVP_PC_Vertebrate_ControlMapper::InitialiseControlsPC(AVP_Actor_InputHandler& xInputHandler)
{
	AVP_Vertebrate_InputHandler&	xVertebrateInputHandler	= *(static_cast<AVP_Vertebrate_InputHandler*>(&xInputHandler));

	Asura_ControlMap&				xFirst					= xVertebrateInputHandler.GetMapFirstPerson();

	PARENT::InitialiseControlsPC(xInputHandler);

	// first person mappings
	xVertebrateInputHandler.MapAttacks(xFirst, ASURA_KEYID_MOUSEBUTTON1, ASURA_KEYID_MOUSEBUTTON2, ASURA_KEYID_MOUSEBUTTON1, ASURA_KEYID_MOUSEBUTTON2);
	xVertebrateInputHandler.MapFocusKeys(xFirst, ASURA_KEYID_MOUSEBUTTON2, ASURA_KEYID_MOUSEBUTTON2);
	xVertebrateInputHandler.MapMelee(xFirst, 'e', 'e', ASURA_KEYID_SPACE);
	xVertebrateInputHandler.MapJump(xFirst, ASURA_KEYID_SPACE);
}

/// End of function 'AVP_PC_Vertebrate_ControlMapper::InitialiseControlsPC'. ///



////////////////////////////////////////////////////////////////////////////////
// Function     : AVP_PC_Vertebrate_ControlMapper::InitialiseControlsPS2
// Author       : Andy Tate
// Date         : 27-Sep-2007
////////////////////////////////////////////////////////////////////////////////

void AVP_PC_Vertebrate_ControlMapper::InitialiseControlsPS2(AVP_Actor_InputHandler& xInputHandler)
{
	AVP_Vertebrate_InputHandler&	xVertebrateInputHandler	= *(static_cast<AVP_Vertebrate_InputHandler*>(&xInputHandler));

	Asura_ControlMap&				xFirst					= xVertebrateInputHandler.GetMapFirstPerson();

	PARENT::InitialiseControlsPS2(xInputHandler);

	// first person mappings
	xVertebrateInputHandler.MapAttacks(xFirst, ASURA_PC_KEYID_PS2PAD1_R1, ASURA_PC_KEYID_PS2PAD1_L1, ASURA_PC_KEYID_PS2PAD1_L1, ASURA_PC_KEYID_PS2PAD1_R1);
	xVertebrateInputHandler.MapFocusKeys(xFirst, ASURA_PC_KEYID_PS2PAD1_L1, ASURA_PC_KEYID_PS2PAD1_L1);
	xVertebrateInputHandler.MapMelee(xFirst, ASURA_PC_KEYID_PS2PAD1_R2, ASURA_PC_KEYID_PS2PAD1_R2, ASURA_PC_KEYID_PS2PAD1_CROSS);
	xVertebrateInputHandler.MapJump(xFirst, ASURA_PC_KEYID_PS2PAD1_CROSS);
}

/// End of function 'AVP_PC_Vertebrate_ControlMapper::InitialiseControlsPS2'. ///



////////////////////////////////////////////////////////////////////////////////
// Function     : AVP_PC_Vertebrate_ControlMapper::InitialiseControlsPS3
// Author       : Andy Tate
// Date         : 27-Sep-2007
////////////////////////////////////////////////////////////////////////////////

void AVP_PC_Vertebrate_ControlMapper::InitialiseControlsPS3(AVP_Actor_InputHandler& xInputHandler)
{
	AVP_Vertebrate_InputHandler&	xVertebrateInputHandler	= *(static_cast<AVP_Vertebrate_InputHandler*>(&xInputHandler));

	Asura_ControlMap&				xFirst					= xVertebrateInputHandler.GetMapFirstPerson();

	PARENT::InitialiseControlsPS3(xInputHandler);

	// first person mappings
	xVertebrateInputHandler.MapAttacks(xFirst, ASURA_PC_KEYID_PS3PAD1_R1, ASURA_PC_KEYID_PS3PAD1_L1, ASURA_PC_KEYID_PS3PAD1_L1, ASURA_PC_KEYID_PS3PAD1_R1);
	xVertebrateInputHandler.MapFocusKeys(xFirst, ASURA_PC_KEYID_PS3PAD1_L1, ASURA_PC_KEYID_PS3PAD1_L1);
	xVertebrateInputHandler.MapMelee(xFirst, ASURA_PC_KEYID_PS3PAD1_R2, ASURA_PC_KEYID_PS3PAD1_R2, ASURA_PC_KEYID_PS3PAD1_CROSS);
	xVertebrateInputHandler.MapJump(xFirst, ASURA_PC_KEYID_PS3PAD1_CROSS);
}

/// End of function 'AVP_PC_Vertebrate_ControlMapper::InitialiseControlsPS3'. ///



////////////////////////////////////////////////////////////////////////////////
// Function     : AVP_PC_Vertebrate_ControlMapper::InitialiseControlsXBox360
// Author       : Andy Tate
// Date         : 27-Sep-2007
////////////////////////////////////////////////////////////////////////////////

void AVP_PC_Vertebrate_ControlMapper::InitialiseControlsXBox360(AVP_Actor_InputHandler& xInputHandler)
{
	AVP_Vertebrate_InputHandler&	xVertebrateInputHandler	= *(static_cast<AVP_Vertebrate_InputHandler*>(&xInputHandler));

	Asura_ControlMap&				xFirst					= xVertebrateInputHandler.GetMapFirstPerson();

	PARENT::InitialiseControlsXBox360(xInputHandler);

	// first person mappings
	xVertebrateInputHandler.MapAttacks		(xFirst, ASURA_PC_KEYID_XBOX360PAD1_R_TRIGGER, ASURA_PC_KEYID_XBOX360PAD1_L_TRIGGER, ASURA_PC_KEYID_XBOX360PAD1_L_TRIGGER, ASURA_PC_KEYID_XBOX360PAD1_R_TRIGGER);
	xVertebrateInputHandler.MapFocusKeys	(xFirst, ASURA_PC_KEYID_XBOX360PAD1_L_TRIGGER, ASURA_PC_KEYID_XBOX360PAD1_L_TRIGGER);
	xVertebrateInputHandler.MapMelee		(xFirst, ASURA_PC_KEYID_XBOX360PAD1_R_BUMPER, ASURA_PC_KEYID_XBOX360PAD1_R_BUMPER, ASURA_PC_KEYID_XBOX360PAD1_A);
	xVertebrateInputHandler.MapJump(xFirst, ASURA_PC_KEYID_XBOX360PAD1_A);
}

/// End of function 'AVP_PC_Vertebrate_ControlMapper::InitialiseControlsXBox360'. ///



////////////////////////////////////////////////////////////////////////////////
// Public functions...
////////////////////////////////////////////////////////////////////////////////


/// End of file. ///
