
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_PC_Predator_ControlMapper.h
// Author : Andy Tate
// Date   : 27-Sep-2007
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __AVP_PC_PREDATOR_CONTROLMAPPER_H__
#define __AVP_PC_PREDATOR_CONTROLMAPPER_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Actor/Vertebrates/AVP_PC_Vertebrate_ControlMapper.h"


////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class        : AVP_PC_Predator_ControlMapper
// Author       : Andy Tate
// Date         : 27-Sep-2007
//
// Description  : Class to handle the abstraction of PC Predator-specific controls.
////////////////////////////////////////////////////////////////////////////////

class AVP_PC_Predator_ControlMapper : public AVP_PC_Vertebrate_ControlMapper
{
public:
	// Public functions...
	AVP_PC_Predator_ControlMapper(void)	{}
//	~AVP_PC_Predator_ControlMapper();


protected:
	// Protected variables...

	// Protected functions...
	virtual void	InitialiseControlsPC(AVP_Actor_InputHandler& xInputHandler);
	virtual void	InitialiseControlsPS2(AVP_Actor_InputHandler& xInputHandler);
	virtual void	InitialiseControlsPS3(AVP_Actor_InputHandler& xInputHandler);
	virtual void	InitialiseControlsXBox360(AVP_Actor_InputHandler& xInputHandler);


private:
	// Private typedefs...
	typedef AVP_PC_Vertebrate_ControlMapper PARENT;

	// Private variables...

	// Private functions...
	AVP_PC_Predator_ControlMapper(const AVP_PC_Predator_ControlMapper& xOther);

	AVP_PC_Predator_ControlMapper&	operator=(const AVP_PC_Predator_ControlMapper& xOther);

};   // End of class 'AVP_PC_Predator_ControlMapper'.


#endif   // ifndef __AVP_PC_PREDATOR_CONTROLMAPPER_H__


/// End of file. ///
