
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_Platform_Predator_InputHandler.cpp
// Author : Andy Tate
// Date   : 3-Oct-2006
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Core/Asura.h"

// This file's header...
#include "Actor/Vertebrates/Predator/AVP_Predator_InputHandler.h"

// Asura platform header files...
#include "Input/Asura_PC_Input_Joystick.h"

// AVP platform header files...
#include "Actor/Vertebrates/Predator/AVP_PC_Predator_ControlMapper.h"



////////////////////////////////////////////////////////////////////////////////
// Function     : AVP_Predator_InputHandler::Platform_InitialiseControlMap
// Author       : Andy Tate
// Date         : 27-Sep-2007
////////////////////////////////////////////////////////////////////////////////

void AVP_Predator_InputHandler::Platform_InitialiseControlMap(void)
{
	AVP_PC_Predator_ControlMapper	xControlMapper;
	const u_int						uNumJoysticks	= Asura_PC_Input_Joystick::GetNumJoysticks();

	// Add each connected joystick in-turn...
	for(u_int u = 0; u < uNumJoysticks; u++)
	{
		const Asura_PC_Input_Joystick::ASURA_PC_JS_TYPE	eJoystickType	= Asura_PC_Input_Joystick::GetJoystickType(u);

		xControlMapper.Initialise(*this, eJoystickType);
	}

	xControlMapper.Initialise(*this);
}

/// End of function 'AVP_Predator_InputHandler::Platform_InitialiseControlMap'. ///


/// End of file. ///
