
///////////////////////////////////////////////////////////////////////////////
//
// File   : AVP_Platform_Game_Core.cpp
// Author : Andy McDonald
// Date   : 29-Jan-2006
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Core/Asura.h"

// This file's header...
#include "Core/AVP_Game_Core.h"

// Asura independent header-files...
#include "Core/Asura_UserInput.h"

// Asura platform header-files...
#include "Rendering/Asura_Direct3D.h"


////////////////////////////////////////////////////////////////////////////////
// Constant declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Static variable declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Private functions...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Protected functions...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Public functions...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Function     : AVP_Game_Core::Platform_Initialise
// Author       : Andy Tate
// Date         : 1-Oct-2007
////////////////////////////////////////////////////////////////////////////////

void AVP_Game_Core::Platform_Initialise(void)
{
#if defined(AVP_ALLOW_GAME_TIME_SCALE_CHANGE)
	s_xGameTimeScaleControlMap.AddKeyMapping(GTS_CHANGE_SPEED, '=', Asura_ControlMapping::ON_DEBOUNCED_PRESS,  0.1f);
	s_xGameTimeScaleControlMap.AddKeyMapping(GTS_CHANGE_SPEED, '-', Asura_ControlMapping::ON_DEBOUNCED_PRESS, -0.1f);
	s_xGameTimeScaleControlMap.AddKeyMapping(GTS_CHANGE_SPEED, ASURA_KEYID_NUMPADADD, Asura_ControlMapping::ON_DEBOUNCED_PRESS,  0.1f);
	s_xGameTimeScaleControlMap.AddKeyMapping(GTS_CHANGE_SPEED, ASURA_KEYID_NUMPADSUB, Asura_ControlMapping::ON_DEBOUNCED_PRESS, -0.1f);

	s_xGameTimeScaleControlMap.AddKeyMapping(GTS_RESET, ASURA_KEYID_SCROLLOK, Asura_ControlMapping::ON_DEBOUNCED_PRESS);
	s_xGameTimeScaleControlMap.AddKeyMapping(GTS_ADVANCE_ONE_FRAME, ASURA_KEYID_INS, Asura_ControlMapping::ON_DEBOUNCED_PRESS);
#endif	// defined(AVP_ALLOW_GAME_TIME_SCALE_CHANGE)
}

/// End of function 'AVP_Game_Core::Platform_Initialise'. ///



////////////////////////////////////////////////////////////////////////////////
// Function     : AVP_Game_Core::Platform_Shutdown
// Author       : Andy Tate
// Date         : 1-Oct-2007
////////////////////////////////////////////////////////////////////////////////

void AVP_Game_Core::Platform_Shutdown(void)
{
}

/// End of function 'AVP_Game_Core::Platform_Shutdown'. ///


/// End of file. ///
