///////////////////////////////////////////////////////////////////////////////
//
// File      : AVP_Platform_Rumble.cpp
// Author    : Ali Jakamy
// Created   : 31/03/2009
//
// Copyright (C) 2009 Rebellion. All Rights Reserved
//
///////////////////////////////////////////////////////////////////////////////
#include "Core/Asura.h"

// This file's header
#include "Input/AVP_Rumble_System.h"

// Asura Headers
#include "Input/Asura_Rumble_System.h"
#include "Core/Asura_Hash.h"

Asura_Hash_ID AVP_Rumble_System::GetPlatformBuleprint( Asura_Hash_ID uBlueprint )
{
	return Asura_ConcatenateHashID( uBlueprint, "PS3" );	
}

bool AVP_Rumble_System::GetPlatformSupport2Motors( )
{
	return true;
}

void AVP_Rumble_System::PlatformSetupRumbleMotor( AVP_Rumble* pxRumble, AVP_Rumble_Motor eMotor, Asura_Handle iRumble)
{
	if( eMotor == AVP_RUMBLE_MOTOR1)
	{
		pxRumble->m_apxMotorRumbles[ASURA_PS3_SMALL_MOTOR] = Asura_Rumble::GetRumblePointer(iRumble);
	}
	else
	{
		pxRumble->m_apxMotorRumbles[ASURA_PS3_LARGE_MOTOR] = Asura_Rumble::GetRumblePointer(iRumble);
	}
}

void AVP_Rumble::PlatformSetup()
{
	m_apxMotorRumbles[ASURA_PS3_SMALL_MOTOR] = NULL;
	m_apxMotorRumbles[ASURA_PS3_LARGE_MOTOR] = NULL;
}