//
// CloakEffect_FP.h
//
// Created by Catalin Arsenescu - 11 October 2007
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_PS3_CLOAKEFFECT_FP_H__
#define __ASURA_PS3_CLOAKEFFECT_FP_H__

extern uint32_t _binary_PS3_CloakEffect_FP_bin_start;
extern uint32_t _binary_PS3_CloakEffect_FP_bin_end;

enum FRAGMENT_SHADER_UNIFORM
{
	FP_DistortionScales,
	FP_Params,
	FP_Offset,
	FP_LightningColour,
	FP_Time,
	FP_ELEMENTS
};

enum TEXTURE_UNITS
{
	FP_SceneSampler,
	FP_NoiseTexture,
	FP_TU_ELEMENTS
};

class Asura_PS3_CloakEffect_Handles : public Asura_PS3_FP_Handles
{
public:
	Asura_PS3_CloakEffect_Handles() : Asura_PS3_FP_Handles( FP_ELEMENTS, FP_TU_ELEMENTS )
	{}

	void InitialiseFromShader( Asura_PS3_FragmentShaderBase* pxShader )
	{
		pxShader->InitUniformElement( FP_DistortionScales,	"g_xDistortionScales",	1 );
		pxShader->InitUniformElement( FP_Params,			"g_xParams",			1 );
		pxShader->InitUniformElement( FP_Offset,			"g_xOffset",			1 );
		pxShader->InitUniformElement( FP_LightningColour,	"g_xLightningColour",	1 );
		pxShader->InitUniformElement( FP_Time,				"g_fTime",				1 );

		pxShader->InitTextureUnit( FP_NoiseTexture,			"g_xNoiseTextureSampler", CELL_GCM_TEXTURE_WRAP, CELL_GCM_TEXTURE_WRAP, CELL_GCM_TEXTURE_LINEAR_LINEAR, CELL_GCM_TEXTURE_LINEAR );

		//Note: this is used after tonemapping so we have to tell it to do sRGB conversion
		pxShader->InitTextureUnit( FP_SceneSampler,			"g_xSceneSampler",	CELL_GCM_TEXTURE_CLAMP, CELL_GCM_TEXTURE_CLAMP, CELL_GCM_TEXTURE_NEAREST, CELL_GCM_TEXTURE_NEAREST, true );
	}
};


extern uint32_t _binary_PS3_CloakEffect_Simple_FP_bin_start;
extern uint32_t _binary_PS3_CloakEffect_Simple_FP_bin_end;

class Asura_PS3_CloakEffect_Simple_Handles : public Asura_PS3_FP_Handles
{
public:
	Asura_PS3_CloakEffect_Simple_Handles() : Asura_PS3_FP_Handles( 1, 1 )
	{}

	void InitialiseFromShader( Asura_PS3_FragmentShaderBase* pxShader )
	{
		pxShader->InitUniformElement( FP_DistortionScales,	"g_xDistortionScales",	1 );

		//Note: this is used after tonemapping so we have to tell it to do sRGB conversion
		pxShader->InitTextureUnit( FP_SceneSampler,			"g_xSceneSampler",	CELL_GCM_TEXTURE_CLAMP, CELL_GCM_TEXTURE_CLAMP, CELL_GCM_TEXTURE_NEAREST, CELL_GCM_TEXTURE_NEAREST, true );
	}
};

#endif //#ifndef __ASURA_PS3_CLOAKEFFECT_FP_H__
