//
// Laser_FP.h
//
// Created by Catalin Arsenescu - 11 October 2007
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __ASURA_PS3_LASER_FP_H__
#define __ASURA_PS3_LASER_FP_H__

extern uint32_t _binary_PS3_Laser_FP_bin_start;
extern uint32_t _binary_PS3_Laser_FP_bin_end;

//BW unused and out of date
// static Asura_PS3_GCM_FragmentShaderUniform g_axFragmentShaderUniform[] =
// {
// 	//m_szName, m_usArraySize, m_sizeInFloatsForOneElement, m_usaOffsets, m_faLastValues
// 	{ "g_xCameraPosition",		1, 4, NULL, NULL },
// 	{ "g_xColour",				1, 4, NULL, NULL },
// 	{ "s_fContrast",			1, 1, NULL, NULL },
// 	{ "s_fDepth",				1, 1, NULL, NULL },
// 	{ "g_fTime",				1, 1, NULL, NULL },
// };

enum FRAGMENT_SHADER_UNIFORM
{
	FP_Colour,
	FP_Time,
	FP_CameraPosition,
	FP_DepthAdjustment,
	FP_ELEMENTS
};

enum TEXTURE_UNITS
{
	FP_NoiseTexture,
	FP_DepthTexture,
	FP_TU_ELEMENTS
};

class Asura_PS3_Laser_Handles : public Asura_PS3_FP_Handles
{
public:
	Asura_PS3_Laser_Handles() : Asura_PS3_FP_Handles( FP_ELEMENTS, FP_TU_ELEMENTS )
	{}

	void InitialiseFromShader( Asura_PS3_FragmentShaderBase* pxShader )
	{
		pxShader->InitUniformElement( FP_Colour,			"g_xColour",			1 );
		pxShader->InitUniformElement( FP_Time,				"g_fTime",				1 );
		pxShader->InitUniformElement( FP_CameraPosition,	"g_xCameraPosition",	1 );
		pxShader->InitUniformElement( FP_DepthAdjustment,	"g_xDepthAdjustment",	1 );

		pxShader->InitTextureUnit( FP_NoiseTexture,				"g_xNoiseTextureSampler", CELL_GCM_TEXTURE_WRAP, CELL_GCM_TEXTURE_WRAP, CELL_GCM_TEXTURE_LINEAR_LINEAR, CELL_GCM_TEXTURE_LINEAR );
		pxShader->InitTextureUnit( FP_DepthTexture,				"g_xDepthTextureSampler", CELL_GCM_TEXTURE_CLAMP, CELL_GCM_TEXTURE_CLAMP, CELL_GCM_TEXTURE_NEAREST, CELL_GCM_TEXTURE_NEAREST );
	}
};

#endif //#ifndef __ASURA_PS3_LASER_FP_H__
