//
// GlowOutlinesSkin_VP.h
//
// Created by Andrew Southgate - 19 Febuary 2009
//
// Copyright (C) 2009 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AVP_PS3_GLOWOUTLINESSKIN_VP_H__
#define __AVP_PS3_GLOWOUTLINESSKIN_VP_H__

extern uint32_t _binary_PS3_GlowOutlinesSkin_VP_bin_start;
extern uint32_t _binary_PS3_GlowOutlinesSkin_VP_bin_end;

static Asura_PS3_GCM_VertexShaderUniformParameter g_axVertexShaderUniform_PhermoneGlowSkin[] =
{
	//m_szName, m_usArraySize, m_sizeInFloat4ForOneElement, m_usRegister
	{ "g_xWorldViewProjection",	1, 4, NULL },
	{ "g_xBlurColour",					1, 1, NULL },
};

enum GLOWOUTLINESSKIN_VERTEX_SHADER_UNIFORM
{
	SK_PhermoneGlowSkin_WorldViewProj,
	SK_PhermoneGlowSkin_BlurColour
};

class AVP_PS3_VP_GlowOutlinesSkin : public Asura_PS3_GCM_VertexShader
{
public:
	AVP_PS3_VP_GlowOutlinesSkin() : Asura_PS3_GCM_VertexShader( (unsigned char *)&_binary_PS3_GlowOutlinesSkin_VP_bin_start, (unsigned char *)&_binary_PS3_GlowOutlinesSkin_VP_bin_end, g_axVertexShaderUniform_PhermoneGlowSkin, sizeof ( g_axVertexShaderUniform_PhermoneGlowSkin ) / sizeof ( Asura_PS3_GCM_VertexShaderUniformParameter ) )
	{
	}

	~AVP_PS3_VP_GlowOutlinesSkin()
	{
		u_int i;
		for( i = 0; i < sizeof( g_axVertexShaderUniform_PhermoneGlowSkin ) / sizeof( Asura_PS3_GCM_VertexShaderUniformParameter ); ++i )
		{
			g_axVertexShaderUniform_PhermoneGlowSkin[ i ].CleanUp();
		}
	}
};



extern uint32_t _binary_PS3_GlowOutlinesSkin_No_SPU_VP_bin_start;
extern uint32_t _binary_PS3_GlowOutlinesSkin_No_SPU_VP_bin_end;

static Asura_PS3_GCM_VertexShaderUniformParameter g_axVertexShaderUniform_PhermoneGlowSkin_No_SPU[] =
{
	//m_szName, m_usArraySize, m_sizeInFloat4ForOneElement, m_usRegister
	{ "g_xWorldViewProjectionMatrix",	1, 4, NULL },
	{ "g_axTransforms",				  450, 1, NULL },
	{ "g_xBlurColour",					1, 1, NULL },
};

enum GLOWOUTLINESSKIN_NO_SPU_VERTEX_SHADER_UNIFORM
{
	SK_PhermoneGlowSkin_No_SPU_WorldViewProj,
	SK_PhermoneGlowSkin_No_SPU_BoneTransforms,
	SK_PhermoneGlowSkin_No_SPU_BlurColour,
};

class AVP_PS3_VP_GlowOutlinesSkin_No_SPU : public Asura_PS3_GCM_VertexShader
{
public:
	AVP_PS3_VP_GlowOutlinesSkin_No_SPU() : Asura_PS3_GCM_VertexShader( (unsigned char *)&_binary_PS3_GlowOutlinesSkin_No_SPU_VP_bin_start, (unsigned char *)&_binary_PS3_GlowOutlinesSkin_No_SPU_VP_bin_end, g_axVertexShaderUniform_PhermoneGlowSkin_No_SPU, sizeof ( g_axVertexShaderUniform_PhermoneGlowSkin_No_SPU ) / sizeof ( Asura_PS3_GCM_VertexShaderUniformParameter ) )
	{
	}

	~AVP_PS3_VP_GlowOutlinesSkin_No_SPU()
	{
		u_int i;
		for( i = 0; i < sizeof( g_axVertexShaderUniform_PhermoneGlowSkin_No_SPU ) / sizeof( Asura_PS3_GCM_VertexShaderUniformParameter ); ++i )
		{
			g_axVertexShaderUniform_PhermoneGlowSkin_No_SPU[ i ].CleanUp();
		}
	}
};



#endif //#ifndef __AVP_PS3_GLOWOUTLINESSKIN_VP_H__
