///////////////////////////////////////////////////////////////////////////////
//
// File   : PheromoneTrail_VP.h
// Author : Andy Southgate
// Date   : 16-Jan-2009
//
// Copyright (C) 2009 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////


#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __PHEROMONETRAIL_VP_H__
#define __PHEROMONETRAIL_VP_H__

extern uint32_t _binary_PS3_PheromoneTrail_VP_bin_start;
extern uint32_t _binary_PS3_PheromoneTrail_VP_bin_end;

static Asura_PS3_GCM_VertexShaderUniformParameter g_axVertexShaderUniform[] =
{
	//m_szName, m_usArraySize, m_sizeInFloat4ForOneElement, m_usRegister
	{ "g_xViewProjectionMatrix",	1, 4, NULL },
};

enum VERTEX_SHADER_UNIFORM
{
	VP_ViewProjectionMatrix,
};

class Asura_PS3_VP_PheromoneTrail: public Asura_PS3_GCM_VertexShader
{
public:
	Asura_PS3_VP_PheromoneTrail() : Asura_PS3_GCM_VertexShader( (unsigned char *)&_binary_PS3_PheromoneTrail_VP_bin_start, (unsigned char *)&_binary_PS3_PheromoneTrail_VP_bin_end, g_axVertexShaderUniform, sizeof ( g_axVertexShaderUniform ) / sizeof ( Asura_PS3_GCM_VertexShaderUniformParameter ) )
	{
	}

	~Asura_PS3_VP_PheromoneTrail()
	{
		u_int i;
		for( i = 0; i < sizeof( g_axVertexShaderUniform ) / sizeof( Asura_PS3_GCM_VertexShaderUniformParameter ); ++i )
		{
			g_axVertexShaderUniform[ i ].CleanUp();
		}
	}
};

#endif // !defined(__PHEROMONETRAIL_VP_H__)

/// End of file. ///
