#ifndef _AVP_PLATFORM_LASER_H
#define _AVP_PLATFORM_LASER_H

class AVP_Platform_Laser_System
{
public:
	static void Initialise();
	static void Shutdown();
	static void Reset();
	static void RenderStart();
	static void SetupLaserParams(AVP_Laser *pxLaser);
	static void RenderLaser(AVP_Laser *pxLaser, const Asura_Vector_3 &xPosition, const Asura_Vector_3 &xRight, const Asura_Vector_3 &xDown, const Asura_Vector_3 &xForward, float fLength);
	static void RenderEnd();
#if defined(ASURA_PS3_ALLOW_SHADER_RELOAD)
	static bool ReloadShaders( bool bHelp );
#endif

private:
	static int s_iNoiseTexture;
};

#endif //_AVP_PLATFORM_LASER_H
