//////////////////////////////////////////////////////////////////////////////
//
// Asura_EngineConfiguration.h
//
// Copyright (c) 2006 Rebellion. All rights reserved.
//
// Description:
//
//     AVP Project-specific, Xbox 360-specific defines
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef ___ASURA_ENGINECONFIGURATION_H___
#define ___ASURA_ENGINECONFIGURATION_H___ 1

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "ProjectSettings/AVP_ProjectConfiguration.h"


////////////////////////////////////////////////////////////////////////////////
// Defines...
////////////////////////////////////////////////////////////////////////////////

// Platform-specific settings.

#if defined AVP_SUBMISSION
	#if 0	//!defined PROFILE
		#define ASURA_XBOX360_USE_VSYNC						1
	#endif
#else
	#define ASURA_XBOX360_ALLOW_STATS						1

	//#define ASURA_SUPPORT_COMMAND_CONSOLE_QUIT			1
#endif

#if defined _DEBUG || defined PROFILE
	#define ASURA_XBOX360_ENABLE_PIX						1
#endif

#define ASURA_USE_VIDEO_TO_TEXTURE_SYSTEM					1
#define ASURA_PLATFORM_MENU_MAX_SUPPORTED_CONTROLLERS		4
#define ASURA_LOCALISEDTEXT_PAGE_STORAGE_SIZE				11

#define ASURA_FILEACCESS_SUSPICIOUS_BYTE_COUNT				(300 * 1024 * 1024)
#define ASURA_XBOX360_COMMAND_BUFFER_SIZE					(10 * 1024 * 1024)
//#define ASURA_XBOX360_DEBUG_MAX_XMEM_ALLOCATIONS			8192

#define ASURA_SUPPORT_MULTITHREADED_JOB_QUEUE				1
#define ASURA_USE_FASTPATH_PFX								1
#define ASURA_FASTPATH_PFX_VERTEXBUFFER_SIZE				20000
#define ASURA_FASTPATH_PFX_VERTEXBUFFER_COUNT				2

#define ASURA_BOTANICAL_SUPPORT_INTERACTIVE					1
#define ASURA_BOTANICAL_SUPPORT_STATES						1
#define ASURA_BOTANICAL_SUPPORT_SECTION_VERSIONS			1
#define ASURA_BOTANICAL_SUPPORT_INTERACTIVE_MULTITHREADED   1

#define ASURA_SUPPORT_DOWNLOADABLE_CONTENT					1

#define ASURA_SUPPORT_LEADERBOARDS							1

//#define ASURA_USE_REWARDS									1

#define ASURA_TEXTURE_STREAMING_MEMORY_ALLOWED_MB			20

// Platform-specific AvP defines...
#define AVP_EXPORTED_LEVEL_FILE_EXTENSION					".xbox360"
#define AVP_GENERATE_FULL_LEVEL_FILENAME(f)					"Envs\\" f ".xbox360"
#define AVP_RENDER_SKYBOX_AFTER_SCENE						1

#define AVP_MAX_FRAME_RATE									60.0f
#define AVP_MAX_INGAME_FRAME_RATE							30.0f

#define AVP_PHEROMONES_ENABLED								1

#define ASURA_XBOX360_MATERIALS_TEXTURE_HEIGHT				1024

#define ASURA_CGR_MESH_VB_SIZE								0x10000

#define ASURA_EDGE_ANTIALIASING	1
//#define ASURA_USE_AMBIENT_OCCLUSION							(1)

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

#endif // #ifndef ___ASURA_ENGINECONFIGURATION_H___
