//////////////////////////////////////////////////////////////////////////////
//
// AVP_Platform_Stencil_Setup.h
//
// Author : Andrew Southgate / Ben Weston
// Date   : 2/5/2008 
//
// Copyright (c) 2008 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif   // ASURA_USE_PRAGMA_ONCE

#ifndef AVP_PLATFORM_STENCIL_SETUP_H__
#define AVP_PLATFORM_STENCIL_SETUP_H__

#include "Rendering/Asura_Xbox360_Graphics.h"


enum {
	AVP_STENCIL_BIT_VISION_FIRST = ASURA_STENCIL_BIT_FIRST_PROJECT_SPECIFIC,
	AVP_STENCIL_BIT_VISION_ALIEN = AVP_STENCIL_BIT_VISION_FIRST,
	AVP_STENCIL_BIT_VISION_HOT,
	AVP_STENCIL_BIT_VISION_TECH,
	AVP_STENCIL_BIT_VISION_LAST = AVP_STENCIL_BIT_VISION_TECH,

	AVP_STENCIL_BIT_FIRST_UNUSED
};
#define AVP_STENCIL_MASK_VISION				((1<<AVP_STENCIL_BIT_VISION_TECH) | (1<<AVP_STENCIL_BIT_VISION_HOT) | (1<<AVP_STENCIL_BIT_VISION_ALIEN))


class AVP_PlatformStencilSetup
{
public:
	static void MaterialContextCallback(u_int uPrimaryContext, u_int uSecondaryContext);
	static void SetTestFunction( D3DCMPFUNC uFunction, u_int uRef, u_int uMask );
	static void ResetTestFunction( void );

private:
	static D3DCMPFUNC	s_uFunction;
	static u_int		s_uTestRef;
	static u_int		s_uTestMask;
};


#endif // AVP_PLATFORM_STENCIL_SETUP_H__



