//////////////////////////////////////////////////////////////////////////////
//
// Asura_Project_Platform_Rewards_System.cpp
//
// Copyright (c) 2009 Rebellion. All rights reserved.
//
// Description:
//
//     Platform specific project reward functions
//
//////////////////////////////////////////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "Core/Asura.h"

#ifdef ASURA_USE_REWARDS

#include "Rewards/Asura_Rewards_System.h"
#include "Rewards/Asura_Xbox360_Achievements_System.h"

#include "Rewards/AVP_Rewards_System.h"
#include "AVP3.spa.h"

// NY - 31 March 2009 - array to store mappings of independent rewards to 360 achievements
// Asura_Xbox360_Achievements_System::s_uInvalid_Achievement means reward not mapped on 360
u_int auAVP_360_Rewards[AVP_NUM_REWARDS] =
{
	ACHIEVEMENT_TEMPACHIEVEMENT1, // AVP_REWARD_COMPLETE_LEVEL
};

// NY - 31 March 2009 - platform specific event handler, for anything that needs platform specific code, or that only relates to one platform
void Asura_Rewards_System::Project_Platform_HandleEvent(Asura_Hash_ID uEventHash, int iEventData)
{
	switch (uEventHash)
	{
		default:
		{
			// do nothing
			break;
		}
	}
}

// NY - 31 March 2009 - reward mapping - just do a bounds checked lookup on the array
u_int Asura_Xbox360_Achievements_System::Project_ConvertReward(u_int uRewardIndex)
{
	if (uRewardIndex < AVP_NUM_REWARDS)
	{
		return auAVP_360_Rewards[uRewardIndex];
	}
	Asura_Assert(false, "Reward index out of range");
	return Asura_Xbox360_Achievements_System::s_uInvalid_Achievement;
}

// NY - 31 March 2009 - return how many achievements project has on 360. Unfortunatly no other way to do this than counting them by hand,
// as the sdk needs to be told how many to expect before enumerating.
u_int Asura_Xbox360_Achievements_System::Project_GetNumAchievements()
{
	return 1;
}

#endif // #ifdef ASURA_USE_REWARDS
