
///////////////////////////////////////////////////////////////////////////////
//
// File   : Tools_Project_BotanicalCreation_StateTables.cpp
// Author : Andy Tate
// Date   : 26-Jan-2007
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Core/Asura.h"

// This file's header...
#include "BotanicalCreation/Tools_BotanicalCreation_StateTables.h"

#if (defined( ASURA_BOTANICAL_SUPPORT_STATES) && 1 == ASURA_BOTANICAL_SUPPORT_STATES)

// Asura independent header-files...
#include "Interface/Asura_Dialog.h"

#include "Material/ToolsAVP_SurfaceOverlay.h"

////////////////////////////////////////////////////////////////////////////////
// Function     : Asura_Overlay_Botanical_State_Tables::Project_CreateVersionOverlay
// Author       : Andy Tate
// Date         : 26-Jan-2007
////////////////////////////////////////////////////////////////////////////////

void Asura_Overlay_Botanical_State_Tables::Project_CreateVersionOverlay (Asura_Vector_2& xOffset,
																		 float& xMaxColumnWidth)
{
	Asura_Dialog* pxDialog;
	pxDialog = new ToolsAVP_MaterialSurfaceType_DropDownListDialog( xOffset, 8, &m_uProjectFlags, &m_bDataChanged, "Botanical SurfaceType " );
																			//	^^ the project flags hold the hash of the surface type
	pxDialog->SetHelpText("The surface type of botanical used. (Used for PFX and stuff)");
	AddDialog(pxDialog);
	xOffset.y		+= Asura_Dialog::LargeSpacing();
	xMaxColumnWidth	 = Asura_Maths::Max(xMaxColumnWidth, pxDialog->GetMaxCoords().x);
}

/// End of function 'Asura_Overlay_Botanical_State_Tables::Project_CreateVersionOverlay'. ///

#endif	// (defined( ASURA_BOTANICAL_SUPPORT_STATES) && 1 == ASURA_BOTANICAL_SUPPORT_STATES)

/// End of file. ///
