//////////////////////////////////////////////////////////////////////////////
//
// ToolsAVP_Cutscene_Event_CloakActor.h
//
// Created by Ali Jakamy 30/06/2008
//
// Copyright (c) 2008 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __TOOLSAVP_CUTSCENE_EVENT_CLOAKACTOR_H__
#define __TOOLSAVP_CUTSCENE_EVENT_CLOAKACTOR_H__

// ASURA
#include "Core/Asura_Maths.h"

// Tools
#include "Cutscene/Tools_Cutscene_Event.h"
#include "Interface/Asura_Dialog.h"


class ToolsAVP_Cutscene_Event_CloakActor : public Tools_Cutscene_Event
{
public :

	ToolsAVP_Cutscene_Event_CloakActor(Asura_Cutscene_Event* pxEvent,Tools_Cutscene_Object* pxCutsceneObject, int iEventID);

	virtual const char* GetTypeDescription(){ return "Cloak actor"; }
	virtual const char* GetAbbreviatedTypeDescription(){ return "Cloaking"; }
	virtual void AddOverlayControls(Asura_Overlay* pxOverlay, Asura_Vector_2& xOffset);
	virtual Asura_String GetDescription();
	virtual void UpdateBackupVariables();
	virtual void AskForRequiredData();

	// Accessors
	float GetDurationBackup() const { return m_fDurationBackup; }
	float GetCloakingDurationBackup() const { return m_fCloakingDurationBackup; }
	float GetUncloakingDurationBackup() const { return m_fUncloakingDurationBackup; }
	float GetLightningScaleBackup() const { return m_fLightningScaleBackup; }

private :

	float m_fDurationBackup;           // Duration of the cloaking effect
	float m_fCloakingDurationBackup;   // Time it takes to go from uncloaked to cloaked
	float m_fUncloakingDurationBackup; // Time it takes to go from cloaked to uncloaked
    float m_fLightningScaleBackup;     // The scale of lightning during the Enter/Exit cloaking phase

	typedef Tools_Cutscene_Event PARENT;

};

#endif // #ifndef __TOOLSAVP_CUTSCENE_EVENT_SETVISIONMODE_H__