//////////////////////////////////////////////////////////////////////////////
//
// ToolsAVP_Cutscene_Event_CloakActor_Undo.cpp
//
// Created by Ali Jakamy 25/06/2008
//
// Copyright (c) 2008 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

#include "Core/Asura.h"

// Own header
#include "Cutscene/ToolsAVP_Cutscene_Event_CloakActor_Undo.h"

// AVP
#include "Cutscene/AVP_Cutscene_Event.h"
#include "Cutscene/AVP_Cutscene_Event_CloakActor.h"

// AVP Tools
#include "Cutscene/ToolsAVP_Cutscene_Event_CloakActor.h"

ToolsAVP_Cutscene_Event_CloakActor_Undo::ToolsAVP_Cutscene_Event_CloakActor_Undo(Tools_Cutscene_Event* pxEvent)
: CutsceneUndoData_Event_Changed(pxEvent)
{
	ToolsAVP_Cutscene_Event_CloakActor* pxToolsEvent = static_cast<ToolsAVP_Cutscene_Event_CloakActor*> (pxEvent);

	m_fDuration			  = pxToolsEvent->GetDurationBackup();
	m_fCloakingDuration   = pxToolsEvent->GetCloakingDurationBackup();
    m_fUncloakingDuration = pxToolsEvent->GetUncloakingDurationBackup();
	m_fLightningScale     = pxToolsEvent->GetLightningScaleBackup();
}

void ToolsAVP_Cutscene_Event_CloakActor_Undo::SwapWithEvent(Tools_Cutscene_Event* pxEvent)
{
	CutsceneUndoData_Event_Changed::SwapWithEvent(pxEvent);

	//get the event
	Asura_Assert(pxEvent->Event->m_iType == AVP_CET_CloakActor,"");


	ToolsAVP_Cutscene_Event_CloakActor* pxToolsEvent = static_cast<ToolsAVP_Cutscene_Event_CloakActor*> (pxEvent);
	AVP_Cutscene_Event_CloakActor* pxAVPEvent        = static_cast<AVP_Cutscene_Event_CloakActor*> (pxEvent->Event);

	//swap the values between the undo data and the event
	pxAVPEvent->SetDuration(m_fDuration);
    m_fDuration = pxToolsEvent->GetDurationBackup();

	pxAVPEvent->SetCloakingDuration(m_fCloakingDuration);
    m_fCloakingDuration = pxToolsEvent->GetCloakingDurationBackup();

	pxAVPEvent->SetUncloakingDuration(m_fUncloakingDuration);
    m_fUncloakingDuration = pxToolsEvent->GetUncloakingDurationBackup();

	pxAVPEvent->SetLightningScale(m_fLightningScale);
    m_fLightningScale = pxToolsEvent->GetLightningScaleBackup();


}