//////////////////////////////////////////////////////////////////////////////
//
// ToolsAVP_Cutscene_Event_SetVisionMode_Undo.cpp
//
// Created by Ali Jakamy 25/06/2008
//
// Copyright (c) 2008 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

#include "Core/Asura.h"

// Own header
#include "Cutscene/ToolsAVP_Cutscene_Event_SetVisionMode_Undo.h"

// AVP
#include "Cutscene/AVP_Cutscene_Event.h"
#include "Cutscene/AVP_Cutscene_Event_SetVisionMode.h"

// AVP Tools
#include "Cutscene/ToolsAVP_Cutscene_Event_SetVisionMode.h"

ToolsAVP_Cutscene_Event_SetVisionMode_Undo::ToolsAVP_Cutscene_Event_SetVisionMode_Undo(Tools_Cutscene_Event* pxEvent)
: CutsceneUndoData_Event_Changed(pxEvent)
{
	ToolsAVP_Cutscene_Event_SetVisionMode* pxToolsEvent = static_cast<ToolsAVP_Cutscene_Event_SetVisionMode*> (pxEvent);

	m_uVisionModeHash  = pxToolsEvent->GetVisionModeHashBackup();
	m_fDuration        = pxToolsEvent->GetDurationBackup();
    m_uFlags           = pxToolsEvent->GetFlagsBackup();
}

void ToolsAVP_Cutscene_Event_SetVisionMode_Undo::SwapWithEvent(Tools_Cutscene_Event* pxEvent)
{
	CutsceneUndoData_Event_Changed::SwapWithEvent(pxEvent);

	//get the event
	Asura_Assert(pxEvent->Event->m_iType == AVP_CET_SetVisionMode,"");


	ToolsAVP_Cutscene_Event_SetVisionMode* pxToolsEvent = static_cast<ToolsAVP_Cutscene_Event_SetVisionMode*> (pxEvent);
	AVP_Cutscene_Event_SetVisionMode* pxAVPEvent        = static_cast<AVP_Cutscene_Event_SetVisionMode*> (pxEvent->Event);

	//swap the values between the undo data and the event
	pxAVPEvent->SetVisionModeHash(m_uVisionModeHash);
    m_uVisionModeHash = pxToolsEvent->GetVisionModeHashBackup();

	pxAVPEvent->SetDuration(m_fDuration);
    m_fDuration = pxToolsEvent->GetDurationBackup();

	pxAVPEvent->SetFlags(m_uFlags);
    m_uFlags = pxToolsEvent->GetFlagsBackup();
}