//////////////////////////////////////////////////////////////////////////////
//
// ToolsAVP_Entity_AlienTeam.h
//
// Copyright (C) 2007 Rebellion. All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __TOOLSAVP_ENTITY_ALIENTEAM_H__
#define __TOOLSAVP_ENTITY_ALIENTEAM_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////
#include "Entity/Tools_Entity_Object.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////
class AVP_ServerEntity_Team_Alien;
class ToolsAVP_Entity_AlienSpawnPoint;

//////////////////////////////////////////////////////////////////////////////
//
// ToolsAVP_Entity_AlienTeam
//
//////////////////////////////////////////////////////////////////////////////

class ToolsAVP_Entity_AlienTeam : public Tools_Entity_Object
{
    typedef Tools_Entity_Object PARENT;

public:

    ToolsAVP_Entity_AlienTeam( Asura_Entity* pxEntity );
    virtual ~ToolsAVP_Entity_AlienTeam();

    virtual const char* GetTypeDescription()			{return "Alien Team";}
    virtual bool        CanBeCopied()					{return false;}
    virtual bool        CanBeDestroyed()				{return false;}
    virtual void		UpdateToolsData()				{}
    virtual void        UpdatePositionInAsuraData(bool /*updateLinkedObjects*/);
	virtual bool        HandlesThisMessage(int iMessageID);
	virtual bool		HandlesThisEvent(int iEventID) const;
	virtual void		AddOverlayControls(Asura_Overlay* pxNewOverlay, Asura_Vector_2& xOffset);
	virtual void		UpdateWhileSelected();
    virtual void		AddFilesToExportListFromMessage(u_short usMessageID, void* pData, List<Asura_String>& nameList) const;

    static void	Create();
    static Tools_Object* Create(Asura_Entity* pxEntity);
    static ToolsAVP_Entity_AlienTeam* GetInstance()		{return s_pxToolsAlienTeam;}

protected:

	void UpdateSpawnPointsList(void);
	void UpdateCategoryList(void);
	void InitAgilityFilter(void);
	void UpdateOverlay(void);
	void UpdateSelectedSpawnPoint(void);

private:

	// There should only ever be one of these in a level.
	static ToolsAVP_Entity_AlienTeam* s_pxToolsAlienTeam;

	static void ChooseBlueprint(void);
	static void GoToSpawnPoint(void);
	static void EditSelectedSpawnPoint(void);
	static void EditSelectedSpawnPoint(int iDummyVariable) {EditSelectedSpawnPoint();}

	static void SelectedAgilityChanged(void) {s_bSelectedAgilityChanged = true;}

	// private memebr
	Asura_String GetBlueprintString();

	int GetNumEntriesToDisplay();
	int GetNumRowsToDisplay();

    AVP_ServerEntity_Team_Alien* m_pxAlienTeam;
	List <ToolsAVP_Entity_AlienSpawnPoint*> m_xAlienSpawnList;

	static int							s_iNumSpawners;
	static const char**					s_ppszSpawnerNames;
	static Asura_Guid*					s_ppuSpawnerGuids;
	static int							s_iSelectedSpawner;
	static class Asura_List_Dialog*		s_pxSpawnerListDialog;
	static int							s_iNumCategories;
	static const char**					s_ppszCategoryNames;
	static int							s_iSelectedCategory;
	static bool							s_bSelectedCategoryChanged;
	ToolsAVP_Entity_AlienSpawnPoint*	m_pxSelectedSpawnPoint;
	static const char**					s_ppszAgilityNames;
	static int							s_iSelectedAgility;
	static bool							s_bSelectedAgilityExclusive;
	static bool							s_bSelectedAgilityChanged;
};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //__TOOLSAVP_ENTITY_ALIENTEAM_H__
