//////////////////////////////////////////////////////////////////////////////
//
// ToolsAVP_Entity_Squad.cpp
//
// Copyright (C) 2008 Rebellion. All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// core
#include "Core/Asura.h"

// header
#include "Entity/Controller/ToolsAVP_Entity_Squad.h"

// asura
#include "Interface/Asura_Dialog.h"
#include "Interface/Asura_Overlay.h"

// avp
#include "Entity/AVP_Messages.h"
#include "Entity/AVP_Entity_EventIDs.h"
#include "Entity/Controller/AVP_ServerEntity_Squad.h"

//////////////////////////////////////////////////////////////////////////////
//
// ToolsAVP_Entity_Squad
//
//////////////////////////////////////////////////////////////////////////////

Asura_Hashed_List< ToolsAVP_Entity_Squad > ToolsAVP_Entity_Squad::s_xList;

ToolsAVP_Entity_Squad::ToolsAVP_Entity_Squad( Asura_Entity* pxEntity )
: PARENT( pxEntity )
{
	s_xList.AddToList( this );
}

ToolsAVP_Entity_Squad::~ToolsAVP_Entity_Squad()
{
	s_xList.RemoveFromList( this );
}

AVP_ServerEntity_Squad* ToolsAVP_Entity_Squad::GetSquad() const
{
	return static_cast< AVP_ServerEntity_Squad* >( Entity );
}

bool ToolsAVP_Entity_Squad::HandlesThisEvent( int iEventID ) const
{
	if ( iEventID == AVP_ENTITY_EVENT_SQUAD_ELIMINATED ||
		iEventID == AVP_ENTITY_EVENT_SQUAD_MEMBER_DIED )
	{
		return true;
	}
	else
	{
		return PARENT::HandlesThisEvent( iEventID );
	}
}

bool ToolsAVP_Entity_Squad::HandlesThisMessage( int iMessageID )
{
	if ( iMessageID == AVP_MSGID_SET_AI_TARGET_PRIORITIES ||
		iMessageID == AVP_MSGID_RESET_AI_TARGET_PRIORITIES ||
		iMessageID == ASURA_MSG_AXON_GS2_EXIT_GAMESCENE ||
		iMessageID == ASURA_MSG_SET_DESTRUCTIBLE )
	{
		return true;
	} 
	else
	{
		return PARENT::HandlesThisMessage( iMessageID );
	}
}

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////
