//////////////////////////////////////////////////////////////////////////////
//
// ToolsAVP_Entity_Squad_FaceHugger.h
//
// Copyright (C) 2008 Rebellion. All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __TOOLSAVP_ENTITY_SQUAD_FACEHUGGER_H__
#define __TOOLSAVP_ENTITY_SQUAD_FACEHUGGER_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// avp
#include "Entity/Controller/ToolsAVP_Entity_Squad.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class AVP_ServerEntity_Squad_FaceHugger;
class Asura_List_Dialog;

//////////////////////////////////////////////////////////////////////////////
//
// ToolsAVP_Entity_Squad_FaceHugger
//
//////////////////////////////////////////////////////////////////////////////

class ToolsAVP_Entity_Squad_FaceHugger : public ToolsAVP_Entity_Squad
{
	typedef ToolsAVP_Entity_Squad PARENT;

public:
	ToolsAVP_Entity_Squad_FaceHugger( Asura_Entity* pxEntity );
	virtual ~ToolsAVP_Entity_Squad_FaceHugger();

	virtual const char*	GetTypeDescription() { return "FaceHugger Squad"; }
	virtual bool CanBeDestroyed();
	virtual void AddOverlayControls( Asura_Overlay* pxOverlay, Asura_Vector_2& xOffset );
	virtual void OnSelection();
	virtual void OnDeselection();
	virtual void UpdateWhileSelected();
	virtual bool HandlesThisMessage( int iMessage );

	static void Create();
	static Tools_Object* Create( Asura_Entity* pxEntity );
	static void CreateDefault();
	static void CreateDefaultPet();


	// call back functions
	static void SelectGPVolume();
	static void AddGPVolume(Asura_Guid uGuid); 
	static void RemoveSelectedGPVolume();

private:

	void Validate();
	
	AVP_ServerEntity_Squad_FaceHugger* GetFaceHuggerSquad() const;
	void RequestRefreshOverlay() { m_bRefreshOverlay = true; }

	Asura_List_Dialog* CreateGPVolumeList( const Asura_Vector_2& xOffset );
	void DestroyGPVolumeList();

	static void BehaviourDataChanged( int iThis );


	bool m_bRefreshOverlay;

	Tools_DynamicArray< char* > m_xArray_pszGPVolumeNames;
	int m_iPGVolumeSelectedIndex;

	static ToolsAVP_Entity_Squad_FaceHugger* s_pxCurrentActive;
};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //__TOOLSAVP_ENTITY_SQUAD_FACEHUGGER_H__
