
///////////////////////////////////////////////////////////////////////////////
//
// File   : ToolsAVP_Entity_FeedingZone.h
// Author : Stuart Perry
// Date   : 20-Mar-2007
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __TOOLSAVP_ENTITY_FEEDINGZONE_H__
#define __TOOLSAVP_ENTITY_FEEDINGZONE_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Entity/FeedingZone/AVP_ServerEntity_FeedingZone.h"

#include "Entity/Tools_Entity_Object.h"
#include "Objects/Tools_Object_System.h"

////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class        : ToolsAVP_Entity_FeedingZone
// Author       : Stuart Perry
// Date         : 20-Mar-2007
//
// Description  : Class to handle Tools editing of feeder zones.
////////////////////////////////////////////////////////////////////////////////

class ToolsAVP_Entity_FeedingZone : public Tools_Entity_Object
{
public:

	// Public functions...
	ToolsAVP_Entity_FeedingZone(Asura_Entity* pxEntity);

	static void				Project_Create();
	static void				Create();
	static Tools_Object*	Create( Asura_Entity* pxEntity );

	// Overridden functions...
	virtual void		UpdatePositionInAsuraData	(bool bUpdateLinkedObjects);
	virtual void		AddOverlayControls(class Asura_Overlay* newOverlay,class Asura_Vector_2& offset);
	virtual void		UpdateWhileSelected();

protected:
	// Protected variables...


	// Protected functions...


private:
	// Private typedefs...
	typedef Tools_Entity_Object PARENT;

	// Private variables...
	bool			m_bActive;

	// Private functions...
	ToolsAVP_Entity_FeedingZone  (void);
	ToolsAVP_Entity_FeedingZone  (const ToolsAVP_Entity_FeedingZone& xOther);

	ToolsAVP_Entity_FeedingZone&	operator=	(const ToolsAVP_Entity_FeedingZone& xOther);

};   // End of class 'ToolsAVP_Entity_FeedingZone'.

#endif   // ifndef __TOOLSAVP_ENTITY_FEEDERZONE_H__

/// End of file. ///
