//////////////////////////////////////////////////////////////////////////////
//
// ToolsAVP_Node_GS2Spline.h
//
// Copyright (C) 2008 Rebellion. All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __TOOLSAVP_NODE_GS2SPLINE_H__
#define __TOOLSAVP_NODE_GS2SPLINE_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// tools
#include "Entity/Locations/Spline/GamesceneSpline/Tools_EntityNode_GS2Spline.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class Asura_Tabs_Dialog;
class Asura_Vector_2;
class AVP_ServerNode_GS2Spline;

//////////////////////////////////////////////////////////////////////////////
//
// ToolsAVP_Node_GS2Spline
//
//////////////////////////////////////////////////////////////////////////////

class ToolsAVP_Node_GS2Spline : public Tools_EntityNode_GS2Spline
{
	typedef Tools_EntityNode_GS2Spline PARENT;

public:
	ToolsAVP_Node_GS2Spline( Asura_Entity* pxEntity );

	const char* GetTypeDescription() { return "AVP GS2 Spline"; }
	virtual bool IsBaseOrDerivativeOf( int iToolsObjectType ) const;
	virtual bool GetParameter( Asura_Hash_ID uParamID, Tools_Parameter* pxParam ) const;
	virtual bool SetParameter( Asura_Hash_ID uParamID, const Tools_Parameter* pxParam );

	virtual void Copy( const Tools_Object* pxObject );

	static ToolsAVP_Node_GS2Spline* Create();
	static ToolsAVP_Node_GS2Spline* Create( Asura_Entity* pxEntity );

protected:
	
	virtual void AddPropertiesTabControls( Asura_Tabs_Dialog* pxTabsDialogue, Asura_Vector_2& xOffset );
	virtual AVP_ServerNode_GS2Spline* GetAVPGameSpline() const;

private:
};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //__TOOLSAVP_NODE_GS2SPLINE_H__
