//////////////////////////////////////////////////////////////////////////////
// 
// FILE : ToolsAVP_Entity_AlienQueen.h
//
// AUTHOR : Andrew McCabe
//
// Copyright 2008 Rebellion, All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef _TOOLSAVP_ENTITY_ALIENQUEEN_H_
#define _TOOLSAVP_ENTITY_ALIENQUEEN_H_

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "Entity/PhysicalObject/Actor/ToolsAVP_Entity_Actor.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class AVP_ServerActor_AlienQueen;

//////////////////////////////////////////////////////////////////////////////
//
// ToolsAVP_Entity_AlienQueen
//
//////////////////////////////////////////////////////////////////////////////

class ToolsAVP_Entity_AlienQueen : public ToolsAVP_Entity_Actor
{
public:
	static Tools_Object* Create( const bool bFullInit );
    static Tools_Object* Create( Asura_Entity* pxEntity );
	static void Project_Create();
	virtual Tools_Object* CreateObjectOfThisType() const { return Create( false ); }

	virtual void OnSelection();
	virtual void OnDeselection();

protected:
	ToolsAVP_Entity_AlienQueen(AVP_ServerActor_AlienQueen* pxActor);

    virtual const char* GetTypeDescription() { return "AlienQueen"; }
	virtual void AddFilesToExportList(List<Asura_String>& nameList) const;
	virtual bool HandlesThisMessage( int iMessageID );

    virtual Asura_Hash_ID GetDefaultBlueprintHashID() const { return 0x5907A4C3; } // Asura_GetHashID( "AlienQueen" )
	virtual void          RestoreMesh(); 

private:

    typedef ToolsAVP_Entity_Actor PARENT;

	AVP_ServerActor_AlienQueen* m_pxAlienQueen; // cached pointer to entity

	static ToolsAVP_Entity_AlienQueen* s_pxThisTool;

};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //_TOOLSAVP_ENTITY_ALIENQUEEN_H_
