//////////////////////////////////////////////////////////////////////////////
// 
// FILE : ToolsAVP_Entity_Sentrygun.h
//
// AUTHOR : Martin G. Harris - Modified By Chris Wallace
//
// Copyright 2002 Rebellion, All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef _TOOLSAVP_ENTITY_SENTRYGUN_H_
#define _TOOLSAVP_ENTITY_SENTRYGUN_H_

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "Entity/AVP_Messages.h"
#include "Entity/PhysicalObject/Actor/ToolsAVP_Entity_Actor.h"
#include "Objects/ToolsAVP_Object_Type.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class AVP_ServerWeapon_Sentrygun;

//////////////////////////////////////////////////////////////////////////////
//
// ToolsAVP_Entity_Sentrygun
//
//////////////////////////////////////////////////////////////////////////////

class ToolsAVP_Entity_Sentrygun : public ToolsAVP_Entity_Actor
{
public:
	static Tools_Object* Create( Asura_Entity* pxEntity );
	static void Project_Create();
	static Tools_Object* Create( const bool bFullInit );
	virtual Tools_Object*	CreateObjectOfThisType() const { return Create( false ); }

	virtual bool			CanBeCopied() const { return ( Type == TOT_Entity_Sentrygun ); }
	virtual void			Copy( const Tools_Object* pxObject );
	
	virtual const char* GetTypeDescription() { return "Sentrygun"; }

	virtual bool HandlesThisMessage( int iMessageID );
	virtual void AddOverlayControls( Asura_Overlay* pxOverlay, Asura_Vector_2& xOffset );
	virtual void OnSelection() { s_pxThis = this; PARENT::OnSelection(); }
	virtual void OnDeselection() { s_pxThis = NULL; ; PARENT::OnDeselection(); } 
	virtual void Render();

	virtual bool GetParameter(Asura_Hash_ID uParamID,class Tools_Parameter* pxParam) const;
	virtual bool SetParameter(Asura_Hash_ID uParamID,const class Tools_Parameter* pxParam);

protected:
	ToolsAVP_Entity_Sentrygun(AVP_ServerWeapon_Sentrygun* pxActor);
	virtual ~ToolsAVP_Entity_Sentrygun() {}

	virtual void AddFilesToExportList( List<Asura_String>& xNameList ) const;
	virtual Asura_Hash_ID	GetDefaultBlueprintHashID(void) const { return 0xfd5d8ead; } // Asura_GetHashID( "SentryGun SingleBarrel" );

	void GetFrutumVertsWithTwoHorFovAngles( float fVisionRange, float fTanHorHalfFOV );
private:
	typedef ToolsAVP_Entity_Actor PARENT;

	AVP_ServerWeapon_Sentrygun* m_pxSentrygun; // cached pointer to entity

	static ToolsAVP_Entity_Sentrygun* s_pxThis;
};

#endif //_TOOLSAVP_ENTITY_SENTRYGUN_H_
