//////////////////////////////////////////////////////////////////////////////
//
// ToolsAVP_Entity_InteractPredatorLock.h
//
// Created by AJK 21/10/2008
//
// Copyright (c) 2008 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __TOOLSAVP_ENTITY_INTERACTPREDATORLOCK__
#define __TOOLSAVP_ENTITY_INTERACTPREDATORLOCK__

#include "Entity/PhysicalObject/Interact/ToolsAVP_Entity_InteractObject.h"

class AVP_ServerEntity_InteractPredatorLock;

class ToolsAVP_Entity_InteractPredatorLock : public ToolsAVP_Entity_InteractObject
{
public:
	static void				Create();
	static Tools_Object*	Create(Asura_Entity* pxEntity);
	static ToolsAVP_Entity_InteractPredatorLock*	FindEntity(Asura_Guid uGuid)		{ return s_xList.FindEntity(uGuid); }

	virtual bool			CanBeCopied() const { return ( Type == TOT_Entity_InteractPredatorLock ); }
	virtual Tools_Object*	CreateObjectOfThisType() const;
	virtual const char*		GetTypeDescription(){return "Predator Lock";}
	virtual bool			OwnsThisMessageBlock( unsigned short usMessageBlockID );
	virtual void            AddActionsControls( Asura_Overlay* pxOverlay, Asura_Vector_2& xOffset );
	virtual bool			GetEventDescForMessageBlock( unsigned short usMessageBlockID, Asura_String& xOutputDesc );
    virtual bool			HandlesThisMessage(int messageID);
	virtual	void			Destroy();

private:
	ToolsAVP_Entity_InteractPredatorLock(AVP_ServerEntity_InteractPredatorLock* pxInteractObject);
	virtual ~ToolsAVP_Entity_InteractPredatorLock();


	typedef ToolsAVP_Entity_InteractObject PARENT;

	static void	EditOnReachPosition1Messages();
	static void	EditOnLeavePosition1Messages();
	static void	EditOnReachPosition2Messages();
	static void	EditOnLeavePosition2Messages();
	static void	EditOnReachPosition3Messages();
	static void	EditOnLeavePosition3Messages();
	static void	EditOnReachPosition4Messages();
	static void	EditOnLeavePosition4Messages();

	static void EditMessageBlock(const char* szText, u_short* pusMessageBlock);

	static Asura_Hashed_List<ToolsAVP_Entity_InteractPredatorLock> s_xList;
};

#endif // #ifndef __TOOLSAVP_ENTITY_INTERACTPREDATORLOCK__
