//////////////////////////////////////////////////////////////////////////////
// 
// FILE : ToolsAVP_Entity_DamageableObject.h
//
// AUTHORS: Paul Humphries
//
// Copyright 2007 Rebellion, All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef _TOOLSAVP_ENTITY_DAMAGEABLEOBJECT_H_
#define _TOOLSAVP_ENTITY_DAMAGEABLEOBJECT_H_

// I N C L U D E S ///////////////////////////////////////////////////////////

//#include "Entity/PhysicalObject/ToolsAVP_Entity_PhysicalObject.h"

#include "Entity/PhysicalObject/PhysicsObject/ToolsAVP_Entity_PhysicsObject.h"
#include "Camera/Asura_Camera.h"

// C O N S T A N T S /////////////////////////////////////////////////////////

const Asura_Hash_ID uTOOLS_SHAREDPARAMHASH_DAMAGEABLEOBJECT_THRESHOLDSKIN = 0xD52B7557; // Asura_GetHashID("DamageableObject_ThresholdSkin")
const Asura_Hash_ID uTOOLS_SHAREDPARAMHASH_DAMAGEABLEOBJECT_THRESHOLDDYNAMIC = 0xCAF48A25; // Asura_GetHashID("DamageableObject_ThresholdDynamic")
const Asura_Hash_ID uTOOLS_SHAREDPARAMHASH_DAMAGEABLEOBJECT_BEGINSSTATIC = 0xD01988EF; // Asura_GetHashID("DamageableObject_BeginsStatic")

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class AVP_ServerEntity_DamageableObject;
class Asura_Camera;

//////////////////////////////////////////////////////////////////////////////
//
// ToolsAVP_Entity_DamageableObject
//
//////////////////////////////////////////////////////////////////////////////

class ToolsAVP_Entity_DamageableObject : public ToolsAVP_Entity_PhysicsObject
{
public:
	static void Create();
	static Tools_Object* CreateObject();
	static Tools_Object* Create( Asura_Entity* pxEntity );
	static void SelectDamagedSkinAndAnim_Dialog(int iIndex);
	static void SelectDamagedSkinAndAnimGroup_Dialog(int iIndex);
	void SelectDamagedSkinAndAnim(int iIndex);
	void SelectDamagedSkinAndAnimGroup(int iIndex);

	virtual bool GetParameter(Asura_Hash_ID uParamID,class Tools_Parameter* pxParam) const;
	virtual bool SetParameter(Asura_Hash_ID uParamID,const class Tools_Parameter* pxParam);

	virtual void OnSelection();
	virtual void OnDeselection();

protected:
	ToolsAVP_Entity_DamageableObject(AVP_ServerEntity_DamageableObject* pxEntity);
	virtual ~ToolsAVP_Entity_DamageableObject() {}

	virtual const char* GetTypeDescription() { return "Damageable Object"; }
	virtual void AddFilesToExportList(List<Asura_String>& nameList) const;

	virtual void AddOverlayControls( Asura_Overlay* pxNewOverlay, Asura_Vector_2& xOffset );
	virtual void UpdateWhileSelected();

	static ToolsAVP_Entity_DamageableObject* s_pxCurrentlySelectedObject;

private:

	typedef						ToolsAVP_Entity_PhysicsObject PARENT;

	AVP_ServerEntity_DamageableObject*	m_pxDamageableObject; // cached pointer to entity

	ToolsAVP_Entity_DamageableObject  (void);
	ToolsAVP_Entity_DamageableObject  (const ToolsAVP_Entity_DamageableObject& xOther);
	ToolsAVP_Entity_DamageableObject&	operator=	(const ToolsAVP_Entity_DamageableObject& xOther);

	bool						m_bChanged;
	u_int						m_auDamagedSkinHashID[6];
	u_int						m_auDamagedSkinFileHashID[6];
	u_int						m_auDamagedAnimHashID[6];
	u_int						m_auDamagedAnimFileHashID[6];
	float						m_fDamageThresholdSkin;
	float						m_fDamageThresholdDynamic;
	bool						m_bBeginsStatic;
};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //_TOOLSAVP_ENTITY_DAMAGEABLEOBJECT_H_
