//////////////////////////////////////////////////////////////////////////////
//
// ToolsAVP_Entity_PhysicsObject.h
//
// Copyright (c) 2006 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef TOOLSAVP_ENTITY_PHYSICSOBJECT_H___
#define TOOLSAVP_ENTITY_PHYSICSOBJECT_H___ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// Tools.
#include "Entity/Tools_Entity_PhysicsObject.h"

// Project tools.
#include "Entity/PhysicalObject/ToolsAVP_Entity_PhysicalObject.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class AVP_ServerEntity_PhysicsObject;

// C L A S S E S /////////////////////////////////////////////////////////////

class ToolsAVP_Entity_PhysicsObject : public ToolsAVP_Entity_PhysicalObject, public virtual Tools_Entity_PhysicsObject
{

public:

	virtual bool	CanBeCopied			(void) const			{ return true; }
	virtual bool	UseStreamCopy		(void) const			{ return true; }

    static void Create( bool bStatic );
    static Tools_Object* Create( Asura_Entity* pxEntity );
    static ToolsAVP_Entity_PhysicsObject* FindEntity( Asura_Guid uGUID ) { return s_xList.FindEntity( uGUID ); }

    virtual void Edit( void );
    virtual bool GetParameter( Asura_Hash_ID uParamID, Tools_Parameter* pxParam ) const;
    virtual const char* GetTypeDescription( void );
	virtual const char* GetTypeDescriptionForObjectType(){return GetTypeDescription(); }
	virtual void OnSelection() { PARENT_ASURA::OnSelection(); PARENT::OnSelection(); }
	virtual void OnDeselection() { PARENT_ASURA::OnDeselection(); PARENT::OnDeselection(); }
	virtual void UpdateWhileSelected();
	virtual void AddOverlayControls( Asura_Overlay* pxNewOverlay, Asura_Vector_2& xOffset );
    virtual bool HandlesThisMessage( int iMessageID );
    virtual void PrintInfo( float& fX, float& fY );
    virtual bool SetParameter( Asura_Hash_ID uParamID, const Tools_Parameter* pxParam );
	virtual bool AddSharedParamDialogToOverlay( Asura_Overlay* pxOverlay, const Asura_Vector_2& xOffset, Asura_Hash_ID uParamID );
	virtual void UpdateToolsData();

protected:

    ToolsAVP_Entity_PhysicsObject( AVP_ServerEntity_PhysicsObject* pxPhysicsObject );        
    virtual ~ToolsAVP_Entity_PhysicsObject( void );

    AVP_ServerEntity_PhysicsObject* m_pxPhysicsObject;

private:

    typedef Tools_Entity_PhysicsObject PARENT_ASURA;
    typedef ToolsAVP_Entity_PhysicalObject PARENT;

    friend class Tools_Entity_PhysicsObject;

    static Asura_Hashed_List<ToolsAVP_Entity_PhysicsObject> s_xList;
};

#endif // #ifndef TOOLSAVP_ENTITY_PHYSICSOBJECT_H___
