//////////////////////////////////////////////////////////////////////////////
//
// ToolsAVP_Entity_PlayerProxy.h
//
// Copyright (C) 2007 Rebellion. All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __TOOLSAVP_ENTITY_PLAYERPROXY_H__
#define __TOOLSAVP_ENTITY_PLAYERPROXY_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////
#include "Entity/Tools_Entity_Object.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////
class AVP_ServerEntity_PlayerProxy;

//////////////////////////////////////////////////////////////////////////////
//
// ToolsAVP_Entity_PlayerProxy
//
//////////////////////////////////////////////////////////////////////////////

class ToolsAVP_Entity_PlayerProxy : public Tools_Entity_Object
{
	typedef Tools_Entity_Object PARENT;

public:
	ToolsAVP_Entity_PlayerProxy( Asura_Entity* pxEntity );
	virtual ~ToolsAVP_Entity_PlayerProxy();

	virtual const char*	GetTypeDescription() { return "Alien Squad"; }

	virtual bool CanBeCopied() const { return true; }
	virtual bool HandlesThisMessage( int iMessageID );
	virtual bool HandlesThisEvent( int iEventID ) const;

	virtual void AddOverlayControls( Asura_Overlay* pxOverlay, Asura_Vector_2& xOffset );
	virtual void OnSelection();
	virtual void UpdateWhileSelected();

	static void Create();
	static ToolsAVP_Entity_PlayerProxy* Create( Asura_Entity* pxEntity );
	static ToolsAVP_Entity_PlayerProxy* FindEntity( Asura_Guid uGuid ) { return s_xList.FindEntity( uGuid ); }
	static Asura_Hashed_List< ToolsAVP_Entity_PlayerProxy >* GetList() { return &s_xList; }

private:
	AVP_ServerEntity_PlayerProxy* GetPlayerProxy() const;

	bool m_bRefreshOverlay;

	static Asura_Hashed_List< ToolsAVP_Entity_PlayerProxy > s_xList;

};
//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //__TOOLSAVP_ENTITY_PLAYERPROXY_H__
