
///////////////////////////////////////////////////////////////////////////////
//
// File   : Tools_Project_Entity_CheckPointNode.h
// Author : Chris Wallace
// Date   : 28-June-2007
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __TOOLS_PROJECT_ENTITY_CHECKPOINTNODE_H__
#define __TOOLS_PROJECT_ENTITY_CHECKPOINTNODE_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Entity/Tools_Entity_StartPoint.h"


////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class        : Tools_Project_Entity_CheckPointNode
// Author       : Chris Wallace
// Date         : 28-June-2007
//
// Description  : Class to handle Tools editing of checkpoints.
////////////////////////////////////////////////////////////////////////////////

class Tools_Project_Entity_CheckPointNode : public Tools_Entity_Object
{
public:
	// Public functions...
	Tools_Project_Entity_CheckPointNode(Asura_Entity* pxEntity);
//	~Tools_Entity_TeleportDestination ();

	static void	Create	(void);

	// Overridden functions...
	virtual void		UpdatePositionInAsuraData	(bool bUpdateLinkedObjects);
	virtual	bool		HandlesThisMessage	(int iMessageID);

	const char* GetTypeDescription(){return "Checkpoint Node";}

protected:
	// Protected variables...

	// Protected functions...


private:
	// Private typedefs...
	typedef Tools_Entity_Object PARENT;

	// Private variables...

	// Private functions...
	Tools_Project_Entity_CheckPointNode  (void);
	Tools_Project_Entity_CheckPointNode  (const Tools_Project_Entity_CheckPointNode& xOther);

	Tools_Project_Entity_CheckPointNode&	operator=	(const Tools_Project_Entity_CheckPointNode& xOther);

};   // End of class 'Tools_Project_Entity_CheckPointNode'.


#endif   // ifndef __TOOLS_PROJECT_ENTITY_CHECKPOINTNODE_H__


/// End of file. ///
