//
// ToolsAVP_Entity_WaypointBlockerVolume.h
//
// Created by Anthony Gregson - 11/12/07
// 
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __TOOLSAVP_ENTITY_WAYPOINTBLOCKERVOLUME_H__
#define __TOOLSAVP_ENTITY_WAYPOINTBLOCKERVOLUME_H__

#include "Entity/Tools_Entity_WaypointBlockerVolume.h"
#include "Objects/Tools_Object_System.h"

class Asura_Overlay;
class Asura_Vector_2;

//////////////////////////////////////////////////////////////////////////////
//
// ToolsAVP_Entity_WaypointBlockerVolume
//
//////////////////////////////////////////////////////////////////////////////

class ToolsAVP_Entity_WaypointBlockerVolume : public Tools_Entity_WaypointBlockerVolume
{
public:
	ToolsAVP_Entity_WaypointBlockerVolume( Asura_Entity* pxEntity );
	
 	virtual void OnSelection();
 	virtual void OnDeselection();
	virtual void AddOverlayControls( Asura_Overlay* pxNewOverlay, Asura_Vector_2& xOffset );
	virtual const char* GetTypeDescription() { return "Waypoint Blocker Volume (AVP)"; }
	virtual bool Verify( const bool bAutomatic );

	static ToolsAVP_Entity_WaypointBlockerVolume* Create(Asura_Entity* pxEntity);
	static void Create();

private:
	static ToolsAVP_Entity_WaypointBlockerVolume* CreateMain();
	static void UpdateClick(int iThis);

private:
	bool m_bChanged;
	bool m_bNewHuman;
	bool m_bNewAlien;
	bool m_bNewPredator;

	typedef Tools_Entity_WaypointBlockerVolume TOOLS_PARENT;
};

#endif //__TOOLSAVP_ENTITY_WAYPOINTBLOCKERVOLUME_H__
