//////////////////////////////////////////////////////////////////////////////
//
// ToolsAVP_Mode_MeshEdit.h
//
// Copyright (C) 2009 Rebellion. All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __TOOLSAVP_MODE_MESHEDIT_H__
#define __TOOLSAVP_MODE_MESHEDIT_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// asura
#include "Core/Asura_LinkList.h"
#include "MeshEdit/Tools_Mode_MeshEdit.h"

// tools
#include "Misc/Tools_Polygon_Selection.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class Asura_CollisionMesh;

//////////////////////////////////////////////////////////////////////////////
//
// ToolsAVP_Mode_MeshEdit
//
//////////////////////////////////////////////////////////////////////////////

class ToolsAVP_Mode_MeshEdit : public Tools_Mode_MeshEdit
{
	typedef Tools_Mode_MeshEdit PARENT;

public:
	ToolsAVP_Mode_MeshEdit() {}
	virtual ~ToolsAVP_Mode_MeshEdit() {}

	virtual void Update();
	virtual void RenderWorld_PostToneMap();
	virtual void ShutdownMode();

	struct BadPolyPair
	{
		PolygonID m_xBase;
		PolygonID m_xAdj;
	};
	static const Asura_ListElt< BadPolyPair >* GetBPPElt( const u_int uIndex ) { return s_xBadPolyList[ uIndex ]; }
	static void RenderBPP( const u_int uIndex ) { s_uRenderBadPolyPairIndex = uIndex; }

protected:
	virtual void AddOverlayControls( Asura_Overlay* pxOverlay, Asura_Vector_2& xOffset );

private:
	static void CheckPolyAngles();
	static bool PolyIsFullyAdjacent( const Asura_Vector_3 axBaseVerts[ 4 ], const bool bBaseIsQuad,
									 const Asura_Vector_3 axAdjVerts[ 4 ], const bool bAjdIsQuad,
									 int& iNonCoincidentAdjPolyVertIdx );

private:
	// In rads, UI in degrees.
	static bool  s_bMinAngleChanged;
	static bool  s_bMaxAngleChanged;
	static float s_fMinAngle;
	static float s_fMaxAngle;
	static Asura_LinkList< BadPolyPair > s_xBadPolyList;
	static u_int s_uRenderBadPolyPairIndex;
};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //__TOOLSAVP_MODE_MESHEDIT_H__
