#ifdef ASURA_USE_AXON
//////////////////////////////////////////////////////////////////////////////
//
// Axon_BehaviourParams_GS2Node.h
//
// Copyright (C) 2008 Rebellion. All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AXON_BEHAVIOURPARAMS_GS2NODE_H__
#define __AXON_BEHAVIOURPARAMS_GS2NODE_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// axon
#include "Behaviour/Axon_BehaviourParams.h"
#include "Behaviour/BehaviourTypes/Axon_Behaviour_GS2Node.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class Tools_AnimTemplates_Preview;
template< typename T > class List;

//////////////////////////////////////////////////////////////////////////////
//
// Axon_BehaviourParams_GS2Node
//
//////////////////////////////////////////////////////////////////////////////

class Axon_BehaviourParams_GS2Node : public Axon_BehaviourParams
{
	typedef Axon_BehaviourParams PARENT;

public:
	Axon_BehaviourParams_GS2Node( const Axon_BehaviourParams_GS2Node& xNodeParams );
	Axon_BehaviourParams_GS2Node( const u_int uBehaviourType );
	Axon_BehaviourParams_GS2Node( const u_int uParamsType, const u_int uBehaviourType );

	virtual bool IsBaseOrDerivativeOf( const u_int uParamsType ) const;

	bool  m_bStopHere;
	u_int m_uAnimSet;
	int   m_iExitCondition;
	float m_fMinExitWaitTime;
	float m_fMaxExitWaitTime;

	static const char* s_pszExitConditionStrings[ AXON_GS2_NEC_NUM_CORE_CONDITIONS ];

protected:
	virtual void ReadFromChunkStream( Asura_Chunk_Stream& xStream );
	virtual void WriteToChunkStream( Asura_Chunk_Stream& xStream ) const;
	virtual bool HandleMessage( const Asura_Message* pxMessage );

private:
	enum { CURRENT_CHUNK_VERSION = 0 };

#ifdef ASURA_TOOLS
protected:
	virtual void Render();
	virtual void StartPreview();
	virtual bool UpdatePreview();
	virtual void StopPreview();
	virtual void AddOverlayControls( Asura_Tabs_Dialog* pxTabsDialog, Asura_Vector_2& xOffset );
	virtual void AddFilesToExportList( List< Asura_String >& xNameList ) const;
	virtual bool HandlesThisMessage( const int iMessageID );
	virtual bool GetParameter( const Asura_Hash_ID uParamID, Tools_Parameter* pxParam ) const;
	virtual bool SetParameter( const Asura_Hash_ID uParamID, const Tools_Parameter* pxParam );
	virtual bool Verify( const bool bAutomatic );
	virtual Axon_BehaviourParams* Clone() const;

private:
	static void PickAnimSet( int iThis );
	static void PickExitCondition( int iThis );

private:
	Tools_AnimTemplates_Preview* m_pxPreviewAnimation;
	float m_fPreviewTimeoutTime;
#endif
};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //__AXON_BEHAVIOURPARAMS_GS2NODE_H__
#endif // ASURA_USE_AXON
