#ifdef ASURA_USE_AXON
//////////////////////////////////////////////////////////////////////////////
//
// Axon_Knowledge.h
//
// Created by NJD - 29 August 2006
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AXON_KNOWLEDGE_H__
#define __AXON_KNOWLEDGE_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// asura
#include "Core/Asura_Maths.h"
#include "Network/Asura_Guid.h"

// axon
#include "Knowledge/SenseTypes/Axon_Sense_Types.h"

//////////////////////////////////////////////////////////////////////////////
//
// Axon_Knowledge / Axon_Knowledge_ID
//
//////////////////////////////////////////////////////////////////////////////

typedef unsigned int Axon_Knowledge_ID;

struct Axon_Knowledge
{
	Axon_Knowledge_ID m_uKnowledgeID;
    Asura_Guid        m_uSourceGuid;
    unsigned int      m_uSourceClassification;
    int				  m_iSenseID;
    unsigned int      m_uTypeInformation;
    float             m_fAge;
	float             m_fThreatValue;
    Asura_Vector_3    m_xPosition;
	//(T.I - 20.11.2007) - This is implied in the name ('direction' rather than 'offset') but to avoid confusion this should be a unit vector.
    Asura_Vector_3    m_xDirection;
    float             m_fDistance;
	u_int			  m_uProjectData;

	Axon_Knowledge()
	: m_uKnowledgeID( 0 )
	, m_uSourceGuid( ASURA_GUID_UNREGISTERED )
	, m_uSourceClassification( 0 )
	, m_iSenseID( AXON_SENSE_TYPE_INVALID )
	, m_uTypeInformation( 0 )
	, m_fAge( 0.0f )
	, m_fThreatValue( 0.0f )
	, m_xPosition( Asura_Maths::ZeroVector3 )
	, m_xDirection( Asura_Maths::ZeroVector3 )
	, m_fDistance( 0.0f )
	, m_uProjectData( 0 )
    {
    }

	void Reset()
	{
		m_uKnowledgeID          = 0;
		m_uSourceGuid           = ASURA_GUID_UNREGISTERED;
		m_uSourceClassification = 0;
		m_iSenseID              = AXON_SENSE_TYPE_INVALID;
		m_uTypeInformation      = 0;
		m_fAge                  = 0.0f;
		m_fThreatValue          = 0.0f;
		m_xPosition             = Asura_Maths::ZeroVector3;
		m_xDirection            = Asura_Maths::ZeroVector3;
		m_fDistance             = 0.0f;
		m_uProjectData			= 0;
	}

    Asura_Guid GetGuid()     const { return m_uSourceGuid; }
    bool       IsDestroyed() const { return false; }
};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //__AXON_KNOWLEDGE_H__
#endif
