#ifdef ASURA_USE_AXON
//////////////////////////////////////////////////////////////////////////////
//
// Axon_Knowledge_System_Standard.h
//
// Created by NJD - 29 August 2006
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AXON_KNOWLEDGE_SYSTEM_STANDARD_H__
#define __AXON_KNOWLEDGE_SYSTEM_STANDARD_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// axon
#include "Knowledge/Axon_Knowledge_System.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

struct Axon_Knowledge;
class Asura_Blueprint;
class Axon_Sense_Hearing;
class Axon_Sense_Touch;
class Axon_Sense_Vision;

//////////////////////////////////////////////////////////////////////////////
//
// Axon_Knowledge_System_Standard
//
//////////////////////////////////////////////////////////////////////////////

class Axon_Knowledge_System_Standard : public Axon_Knowledge_System< Axon_Knowledge >
{
public:
    Axon_Knowledge_System_Standard();
    virtual ~Axon_Knowledge_System_Standard();

    virtual void InitialiseFromBlueprint( const Asura_Blueprint& xBlueprint );
    virtual void ReadFromChunkStream( Asura_Chunk_Stream& xStream );
    virtual void WriteToChunkStream( Asura_Chunk_Stream& xStream ) const;
    virtual void Initialise();
    virtual void Update( const float fTimeslice );
    virtual void Shutdown();
    virtual bool HandleMessage( const Asura_Message* pxMessage );
#ifndef ASURA_NO_DEBUG_OUTPUT
    virtual void RenderDebugInfo();
#endif

protected:
    virtual Axon_Sense_Vision*  CreateVisionSense();
    virtual void                DestroyVisionSense( Axon_Sense_Vision*& pxSense );
    virtual Axon_Sense_Hearing* CreateHearingSense();
    virtual void                DestroyHearingSense( Axon_Sense_Hearing*& pxSense );
    virtual Axon_Sense_Touch*   CreateTouchSense();
    virtual void                DestroyTouchSense( Axon_Sense_Touch*& pxSense );

protected:
    Axon_Sense_Vision*  m_pxVision;
    Axon_Sense_Hearing* m_pxHearing;
    Axon_Sense_Touch*   m_pxTouch;

private:
    enum { CURRENT_CHUNK_VERSION = 1 };
};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //__AXON_KNOWLEDGE_SYSTEM_STANDARD_H__
#endif
