//////////////////////////////////////////////////////////////////////////////
//
// Axon_LOD_System.cpp
//
// Created by NJD - 20 November 2006
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// core
#include "Core/Asura.h"

// header
#include "LOD/Axon_LOD_System.h"

// asura
#include "Debugging/Asura_Assert.h"

//////////////////////////////////////////////////////////////////////////////
//
// Axon_LOD_System
//
//////////////////////////////////////////////////////////////////////////////

void Axon_LOD_System::Initialise()
{
    AllocateLODStorage();
}

void Axon_LOD_System::PostLoadInitialise()
{
    UpdateLOD();
}

void Axon_LOD_System::Shutdown()
{
    delete [] m_pxLODs;
    m_pxLODs = NULL;
}

void Axon_LOD_System::UpdateLOD( const int iLODType /*= -1*/ )
{
    SetLOD( SYSTEM_LOD, 0 );
}

int Axon_LOD_System::GetLOD( const int iLODType ) const
{
    if ( 0 <= iLODType && iLODType < m_iNumLODs )
    {
        return m_pxLODs[ iLODType ];
    }
    else
    {
        Asura_Assert( false, "Axon_LOD_System::GetLOD - bad LOD type" );
        return 0;
    }
}

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

void Axon_LOD_System::AllocateLODStorage()
{
    m_iNumLODs = 1;
    m_pxLODs   = new int [ m_iNumLODs ];
}

void Axon_LOD_System::SetLOD( const int iLODType, const int iLOD )
{
    if ( 0 <= iLODType && iLODType < m_iNumLODs )
    {
        m_pxLODs[ iLODType ] = iLOD;
    }
    else
    {
        Asura_Assert( false, "Axon_LOD_System::GetLOD - bad LOD type" );
    }
}

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////
