//////////////////////////////////////////////////////////////////////////////
//
// Axon_LOD_System.h
//
// Created by NJD - 20 November 2006
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __AXON_LOD_SYSTEM_H__
#define __AXON_LOD_SYSTEM_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
//
// Axon_LOD_System
//
//////////////////////////////////////////////////////////////////////////////

class Axon_LOD_System
{
public:
    enum Axon_LOD_Types
    {
        SYSTEM_LOD,

        AXON_LOD_TYPE_FIRST_PROJECT_SPECIFIC
    };

    Axon_LOD_System() : m_iNumLODs( 0 ), m_pxLODs( NULL ) {}
    virtual ~Axon_LOD_System() {}

    virtual void Initialise();
    virtual void PostLoadInitialise();
    virtual void Shutdown();

    // If LOD type is -1 the system should update all LOD types.
    virtual void UpdateLOD( const int iLODType = -1 );

    int GetLOD( const int iLODType ) const;

protected:
    virtual void AllocateLODStorage();
    void SetLOD( const int iLODType, const int iLOD );

private:
    int  m_iNumLODs;
    int* m_pxLODs;
};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //__AXON_LOD_SYSTEM_H__
