//*******************************************************************
//
// File: Tools_BotanicalCreation_BasicInteractive.cpp
//
// Created: 15 Nov 2006
//
// Description: 
//
//*******************************************************************

// system libraries
#include "Core/Asura.h"

#if defined( ASURA_USE_BOTANICALS) && defined( ASURA_TOOLS) && defined( ASURA_BOTANICAL_SUPPORT_INTERACTIVE)

// main header
#include "Tools_BotanicalCreation_BasicInteractive.h"

// other libraries
#include "Botanical/Asura_Direct3D_Botanicals_Game_Render.h"
#include "Botanicals/Asura_Botanicals_ShapeManager.h"

#include "Rendering/Asura_Viewport.h"
//#include "Rendering/Asura_Render.h"

#include "Tools_Overlays.h"
#include "Load&Save/Tools_SaveAsura.h"
//#include "Misc/Tools_Modal_Overlay.h"

#include "Interface/Asura_Interface.h"
#include "Interface/Asura_CommandConsole.h"
#include "Interface/Asura_Overlay.h"
#include "Interface/Asura_Overlay_System.h"
#include "Interface/Asura_Dialog.h"

//#include "Rendering/Asura_Render.h"
//#include "Rendering/Asura_Direct3d.h"
//#include "Rendering/Asura_Direct3d_Shaders.h"

//#include "Camera/Asura_Camera.h"

#include "BotanicalCreation/Tools_BotanicalCreation_BotanicalShape.h"
#include "BotanicalCreation/Tools_Mode_BotanicalCreation.h"
//#include "BotanicalCreation/Tools_BotanicalCreation_EditLODs.h"


// internal dependencies

//*******************************************************************
// Constants
//*******************************************************************


//*******************************************************************
// Local Data
//*******************************************************************

Asura_Vector_2	Tools_BotanicalCreation_BasicInteractive::s_xOverlayPosition = Asura_Vector_2( 4, 24);
bool Tools_BotanicalCreation_BasicInteractive::s_bOverlayOpen = false;
Tools_BotanicalCreation_BasicInteractive::Mode Tools_BotanicalCreation_BasicInteractive::s_eMode = Tools_BotanicalCreation_BasicInteractive::MODE_NORMAL;

bool Tools_BotanicalCreation_BasicInteractive::s_bDataChanged = false;
bool Tools_BotanicalCreation_BasicInteractive::s_bEnableBasicInteractive = false;
float Tools_BotanicalCreation_BasicInteractive::s_fMass = 1.0f;
float Tools_BotanicalCreation_BasicInteractive::s_fDrag = 1.0f;
float Tools_BotanicalCreation_BasicInteractive::s_fSpringStrength = 1.0f;
float Tools_BotanicalCreation_BasicInteractive::s_fSpringLength = 1000.0f;
float Tools_BotanicalCreation_BasicInteractive::s_fBoneWeightGamma = 1.0f;
bool Tools_BotanicalCreation_BasicInteractive::s_bUsePaintedColoursAsWeights = false;
Asura_Vector_3 Tools_BotanicalCreation_BasicInteractive::s_xPositionBone0;
Asura_Vector_3 Tools_BotanicalCreation_BasicInteractive::s_xPositionBone1;

Asura_Mesh* Tools_BotanicalCreation_BasicInteractive::s_pxBoneMesh = NULL;

Asura_Dialog* Tools_BotanicalCreation_BasicInteractive::s_pxDialog_Enable = NULL;

Asura_Dialog* Tools_BotanicalCreation_BasicInteractive::s_pxDialog_Mass = NULL;
Asura_Dialog* Tools_BotanicalCreation_BasicInteractive::s_pxDialog_Drag = NULL;
Asura_Dialog* Tools_BotanicalCreation_BasicInteractive::s_pxDialog_SpringStrength = NULL;
Asura_Dialog* Tools_BotanicalCreation_BasicInteractive::s_pxDialog_StringLength = NULL;
Asura_Dialog* Tools_BotanicalCreation_BasicInteractive::s_pxDialog_VertexWeights = NULL;

Asura_Dialog* Tools_BotanicalCreation_BasicInteractive::s_pxDialog_X1 = NULL;
Asura_Dialog* Tools_BotanicalCreation_BasicInteractive::s_pxDialog_Y1 = NULL;
Asura_Dialog* Tools_BotanicalCreation_BasicInteractive::s_pxDialog_Z1 = NULL;
Asura_Dialog* Tools_BotanicalCreation_BasicInteractive::s_pxDialog_X2 = NULL;
Asura_Dialog* Tools_BotanicalCreation_BasicInteractive::s_pxDialog_Y2 = NULL;
Asura_Dialog* Tools_BotanicalCreation_BasicInteractive::s_pxDialog_Z2 = NULL;
Asura_Dialog* Tools_BotanicalCreation_BasicInteractive::s_pxDialog_BoneWeightGamma = NULL;

//*******************************************************************
// Local Classes
//*******************************************************************
class Asura_Overlay_Botanical_Basic_Interactive : public Asura_Overlay
{
public:
	Asura_Overlay_Botanical_Basic_Interactive( const char* pszOverlayName, const bool bAlwaysOnTop, Asura_Vector_2* pxPosition);
	virtual ~Asura_Overlay_Botanical_Basic_Interactive();
};

//*******************************************************************
// Function Definitions
//*******************************************************************
Asura_Overlay_Botanical_Basic_Interactive::Asura_Overlay_Botanical_Basic_Interactive( const char* pszOverlayName, const bool bAlwaysOnTop, Asura_Vector_2* pxPosition) :
	Asura_Overlay( pszOverlayName, bAlwaysOnTop, pxPosition)
{
}

Asura_Overlay_Botanical_Basic_Interactive::~Asura_Overlay_Botanical_Basic_Interactive()
{
	Tools_BotanicalCreation_BasicInteractive::CloseOverlay();
}

void Tools_BotanicalCreation_BasicInteractive::Reset()
{
#if 0
	return Asura_Overlay_System::DoesOverlayExist(TOOLS_OVERLAY_RENDEROPTIONS);
	if(!RenderOptionsOverlayIsOn())
	{
		CreateRenderOptionsOverlay();
	}
	else
	{
		Asura_Overlay_System::CloseOverlays(TOOLS_OVERLAY_RENDEROPTIONS);
	}
#endif
	if( true == IsActive())
	{
		CloseOverlay();		
//		CloseImpostersOverlay();
	}	
}

void Tools_BotanicalCreation_BasicInteractive::CreateOverlay()
{
	CloseOverlay();
	
	s_eMode = MODE_NORMAL;
	
//	Asura_String mesh_name = "ToolsShape_Light";
//	Mesh = Asura_Mesh_System::GetMesh(mesh_name);
	if( NULL == s_pxBoneMesh)
	{
		Asura_String xBoneMeshName = "ToolsShape_Diamond";
		s_pxBoneMesh = Asura_Mesh_System::GetMesh( xBoneMeshName);
		Asura_Assertf( NULL != s_pxBoneMesh, ("Failed to find '%s'", xBoneMeshName.GetString()));
	}

	Asura_BotanicalShape* pxAsuraShape = Tools_Mode_BotanicalCreation::GetCurrentBotanicalShape();
	Tools_BotanicalShape* pxShape = pxAsuraShape->GetToolsShape();
	
	s_bEnableBasicInteractive = pxShape->m_bIsInteractive;
	s_fMass = pxShape->m_fMass;
	s_fDrag = pxShape->m_fDrag;
	s_fSpringStrength = pxShape->m_fSpringStrength;
	s_fSpringLength = pxShape->m_fSpringLength;
	s_xPositionBone0 = pxShape->m_xInteractiveBone0;
	s_xPositionBone1 = pxShape->m_xInteractiveBone1;
	s_fBoneWeightGamma = pxShape->m_fBoneWeightGamma;
	s_bUsePaintedColoursAsWeights = pxShape->m_bUsePaintedColoursAsWeights;

	Asura_Overlay* pxNewOverlay;
	Asura_Dialog*  pxNewDialog;
	Asura_Vector_2 xOffset = Asura_Vector_2(1.0f,3.0f);

	pxNewOverlay = new Asura_Overlay_Botanical_Basic_Interactive( "Basic Interactive", false, &s_xOverlayPosition);
	pxNewOverlay->SetAlwaysFullBright( true);
	
 	s_pxDialog_Enable = pxNewDialog = new Asura_Tickbox_Dialog( "Enabled", xOffset, &s_bEnableBasicInteractive, &s_bDataChanged);
	pxNewDialog->SetHelpText( "Turns on Basic Interactive behavour for this Botanical.");
	pxNewOverlay->AddDialog( pxNewDialog);
	xOffset.y += Asura_Dialog::DefaultSpacing();

	s_pxDialog_Mass = pxNewDialog = new Asura_Numerical_Dialog("Mass", xOffset, &s_fMass, 0.1f, 10000.0f, 0.1f, "%7.1f", &s_bDataChanged);	
	pxNewDialog->SetHelpText( "The Mass of the Botanical.");
	pxNewOverlay->AddDialog(pxNewDialog);
	xOffset.y += Asura_Dialog::DefaultSpacing();

	s_pxDialog_Drag = pxNewDialog = new Asura_Numerical_Dialog("Drag", xOffset, &s_fDrag, 0.1f, 10000.0f, 0.1f, "%7.1f", &s_bDataChanged);	
	pxNewDialog->SetHelpText( "The air friction Drag of the Botanical.");
	pxNewOverlay->AddDialog(pxNewDialog);
	xOffset.y += Asura_Dialog::DefaultSpacing();

	s_pxDialog_SpringStrength = pxNewDialog = new Asura_Numerical_Dialog("Spring Strength", xOffset, &s_fSpringStrength, 0.1f, 10000.0f, 0.1f, "%7.1f", &s_bDataChanged);	
	pxNewDialog->SetHelpText( "The springyness of the Botanical.");
	pxNewOverlay->AddDialog(pxNewDialog);
	xOffset.y += Asura_Dialog::DefaultSpacing();

	s_pxDialog_StringLength = pxNewDialog = new Asura_Numerical_Dialog("Spring Length", xOffset, &s_fSpringLength, 0.1f, 1000.0f, 0.1f, "%5.1f", &s_bDataChanged);	
	pxNewDialog->SetHelpText( "The maximum length of the spring.");
	pxNewOverlay->AddDialog(pxNewDialog);
	xOffset.y += Asura_Dialog::DefaultSpacing();

 	s_pxDialog_VertexWeights = pxNewDialog = new Asura_Tickbox_Dialog( "Vertex Weights", xOffset, &s_bUsePaintedColoursAsWeights, &s_bDataChanged);
	pxNewDialog->SetHelpText( "Use Vertex Painting to Defaine the vertex Weights.");
	pxNewOverlay->AddDialog( pxNewDialog);
	xOffset.y += Asura_Dialog::DefaultSpacing();

	s_pxDialog_X1 = pxNewDialog = new Asura_Numerical_Dialog("X1", xOffset, &s_xPositionBone0.x, -500.0f, 500.0f, 0.1f, "%7.1f", &s_bDataChanged);	
//	pxNewDialog->SetHelpText( "The springyness of the Botanical.");
	pxNewOverlay->AddDialog(pxNewDialog);
	xOffset.y += Asura_Dialog::DefaultSpacing();

	s_pxDialog_Y1 = pxNewDialog = new Asura_Numerical_Dialog("Y1", xOffset, &s_xPositionBone0.y, -500.0f, 500.0f, 0.1f, "%7.1f", &s_bDataChanged);	
//	pxNewDialog->SetHelpText( "The springyness of the Botanical.");
	pxNewOverlay->AddDialog(pxNewDialog);
	xOffset.y += Asura_Dialog::DefaultSpacing();

	s_pxDialog_Z1 = pxNewDialog = new Asura_Numerical_Dialog("Z1", xOffset, &s_xPositionBone0.z, -500.0f, 500.0f, 0.1f, "%7.1f", &s_bDataChanged);	
//	pxNewDialog->SetHelpText( "The springyness of the Botanical.");
	pxNewOverlay->AddDialog(pxNewDialog);
	xOffset.y += Asura_Dialog::DefaultSpacing();

	s_pxDialog_X2 = pxNewDialog = new Asura_Numerical_Dialog("X2", xOffset, &s_xPositionBone1.x, -500.0f, 500.0f, 0.1f, "%7.1f", &s_bDataChanged);	
//	pxNewDialog->SetHelpText( "The springyness of the Botanical.");
	pxNewOverlay->AddDialog(pxNewDialog);
	xOffset.y += Asura_Dialog::DefaultSpacing();

	s_pxDialog_Y2 = pxNewDialog = new Asura_Numerical_Dialog("Y2", xOffset, &s_xPositionBone1.y, -500.0f, 500.0f, 0.1f, "%7.1f", &s_bDataChanged);	
//	pxNewDialog->SetHelpText( "The springyness of the Botanical.");
	pxNewOverlay->AddDialog(pxNewDialog);
	xOffset.y += Asura_Dialog::DefaultSpacing();

	s_pxDialog_Z2 = pxNewDialog = new Asura_Numerical_Dialog("Z2", xOffset, &s_xPositionBone1.z, -500.0f, 500.0f, 0.1f, "%7.1f", &s_bDataChanged);	
//	pxNewDialog->SetHelpText( "The springyness of the Botanical.");
	pxNewOverlay->AddDialog(pxNewDialog);
	xOffset.y += Asura_Dialog::DefaultSpacing();

	s_pxDialog_BoneWeightGamma = pxNewDialog = new Asura_Numerical_Dialog("Bone Weighting Gamma", xOffset, &s_fBoneWeightGamma, 0.1f, 50.0f, 0.1f, "%4.1f", &s_bDataChanged);	
	pxNewDialog->SetHelpText( "Changes the lineararity of the bone weighting.");
	pxNewOverlay->AddDialog(pxNewDialog);
	xOffset.y += Asura_Dialog::DefaultSpacing();


	//submit the overlay
	pxNewOverlay->m_uID = TOOLS_OVERLAY_BOTANICALCREATION_BASICINTERACTIVE;
	Asura_Overlay_System::SubmitNewOverlay( pxNewOverlay, true, true, false);
	
	s_bOverlayOpen = true;
	
	Dialog_Enable();
}

void Tools_BotanicalCreation_BasicInteractive::CloseOverlay()
{
	if( NULL != s_pxBoneMesh)
	{
		s_pxBoneMesh = NULL;
	}
	
	if ( true == s_bOverlayOpen)
	{
		Asura_Overlay_System::CloseOverlays( TOOLS_OVERLAY_BOTANICALCREATION_BASICINTERACTIVE);
		s_bOverlayOpen = false;
	}
}

void Tools_BotanicalCreation_BasicInteractive::SetMode( const Mode eMode)
{
	s_eMode = eMode;
	
	Dialog_Enable();
}

void Tools_BotanicalCreation_BasicInteractive::Update()
{
	if( false == s_bOverlayOpen)
	{
		return;
	}
	
	if( true == s_bDataChanged)
	{
		Tools_SaveAsura::SetBotanicalCreationModified(true);

		if( true == IsActive())
		{
			Asura_BotanicalShape* pxAsuraShape = Tools_Mode_BotanicalCreation::GetCurrentBotanicalShape();
			Tools_BotanicalShape* pxShape = pxAsuraShape->GetToolsShape();
			
			pxShape->m_bIsInteractive = s_bEnableBasicInteractive;
			pxShape->m_fMass = s_fMass;
			pxShape->m_fDrag = s_fDrag;
			pxShape->m_fSpringStrength = s_fSpringStrength;
			pxShape->m_fSpringLength = s_fSpringLength;
			pxShape->m_xInteractiveBone0 = s_xPositionBone0;
			pxShape->m_xInteractiveBone1 = s_xPositionBone1;
			pxShape->m_fBoneWeightGamma = s_fBoneWeightGamma;
			pxShape->m_bUsePaintedColoursAsWeights = s_bUsePaintedColoursAsWeights;
			
#if defined( ASURA_BOTANICALS_BGR_IN_EDIT)
			Asura_Direct3D_Botanicals_Game_Render::UpdateTypesInteractive( pxShape);
#endif
			
			Dialog_Enable();
			
			s_bDataChanged = false;
		}
	}
}

void Tools_BotanicalCreation_BasicInteractive::Dialog_Enable()
{
	if( false == s_bOverlayOpen)
	{
		return;
	}
	
	const bool bNormal = (MODE_NORMAL == s_eMode);
	const bool bEnable = s_bEnableBasicInteractive;
	const bool bEnableNormal = bEnable && bNormal;
	
	s_pxDialog_Enable->SetEnabled( bNormal);
	
	s_pxDialog_Mass->SetEnabled( bEnable);
	s_pxDialog_Drag->SetEnabled( bEnable);
	s_pxDialog_SpringStrength->SetEnabled( bEnable);
	s_pxDialog_StringLength->SetEnabled( bEnable);
	
	s_pxDialog_VertexWeights->SetEnabled( bEnableNormal);
	
	Dialog_EnableAutoWeights( );
}

void Tools_BotanicalCreation_BasicInteractive::Dialog_EnableAutoWeights()
{
	const bool bEnable = (s_bEnableBasicInteractive) && (false == s_bUsePaintedColoursAsWeights) && (MODE_NORMAL == s_eMode);
	
	s_pxDialog_X1->SetEnabled( bEnable);
	s_pxDialog_Y1->SetEnabled( bEnable);
	s_pxDialog_Z1->SetEnabled( bEnable);
	s_pxDialog_X2->SetEnabled( bEnable);
	s_pxDialog_Y2->SetEnabled( bEnable);
	s_pxDialog_Z2->SetEnabled( bEnable);
	s_pxDialog_BoneWeightGamma->SetEnabled( bEnable);
}

void Tools_BotanicalCreation_BasicInteractive::Render()
{
	if( false == s_bOverlayOpen || MODE_NORMAL != s_eMode)
	{
		return;
	}
	
	if( NULL != s_pxBoneMesh && true == s_bEnableBasicInteractive && false == s_bUsePaintedColoursAsWeights)
	{
		Asura_Vector_3 xOrigin = Tools_Mode_BotanicalCreation::GetOrigin();
		Asura_Matrix_3x3 xOrientation;
		xOrientation.Identity();

		{
			Asura_Vector_3 xPosition = xOrigin + s_xPositionBone0;

			Asura_Mesh_System::PlatformRenderMesh( s_pxBoneMesh, &xPosition, &xOrientation);
		}

		{
			Asura_Vector_3 xPosition = xOrigin + s_xPositionBone1;

			Asura_Mesh_System::PlatformRenderMesh( s_pxBoneMesh, &xPosition, &xOrientation);
		}
	}
//	#error Draw the Bone Locations
}


//*******************************************************************
//
// (c) 2006 Rebellion
//
// Warning: This computer program is protected by copyright law and 
// international treaties. Unauthorized reproduction or distribution
// of this program, or any portion of it, may result in severe civil and
// criminal penalties, and will be prosecuted to the maximum extent 
// possible under the law.
//
//*******************************************************************

#endif //defined( ASURA_BOTANICAL_SUPPORT_INTERACTIVE)
