
//
// Tools_Carpet_Styles.h
//
// Created by Dave Reed - 23/11/2005
// 
// Copyright (C) 2005 Rebellion (Derby), All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __TOOLS_CARPET_STYLES_H__
#define __TOOLS_CARPET_STYLES_H__

#ifdef ASURA_USE_CARPET

class Asura_String;
class Asura_Vector_2;
class Tools_UV_Editor;

class Tools_Carpet_Styles
{

public:

	static void Initialise(void);
	static void Shutdown(void);
	static void Update(void);
	static void Render(void);

	static void OpenStyleList(void);
	static void CloseStyleList(void);

	static void OpenStyleEditor(int nStyle);
	static void CloseStyleEditor(void);

private:	

	static void				CreateStyle(void);
	static void				EditStyle(void);
	static void				DeleteStyle(void);
	static void				ChooseTexture();
	static int				RebuildStyleList(void);
	static void			    FreeStyleListStrings(void);

	static void				StartUVEdit(void);
	static void				FinishUVEdit(void);
	static void				UpdateUVEdit(void);
	static Tools_UV_Editor* s_pxUVEditor;
	
	static bool				s_bStyleListOverlayOpen;
	static bool				s_bStyleEditOverlayOpen;

	static Asura_Vector_2	s_vListOverlayPosition;
	static Asura_Vector_2	s_vEditOverlayPosition;

	static char			  **s_apszStyleNames;
	static int			    s_iNumStylesInList;
	static int			    s_iStyleListOffset;
	static int              s_iSelectedStyleInList;
	static int              s_iStyleBeingEdited;
	static int			    s_iBillboardBeingEdited;
	static int				s_iBillboardSelectedForEditing;
	static Asura_String		s_xStyleNameString;
};


#endif //ASURA_USE_CARPET
#endif // __TOOLS_CARPET_STYLES_H__
