//
// Tools_Mode_Carpet.h
//
// Created by Dave Reed - 22/11/2005
// 
// Copyright (C) 2005 Rebellion (Derby), All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifdef ASURA_USE_CARPET

#ifndef __TOOLS_MODE_CARPET_H__
#define __TOOLS_MODE_CARPET_H__

#include "Core/Asura_Handle.h"
#include "Core/Asura_Maths.h"
#include "Core/Asura_LinkList.h"
#include "Network/Asura_Guid.h"

#include "Tools_Mode.h"


class Tools_Mode_Carpet : public Tools_Mode
{
public:
	enum DialogIDs
	{
		DialogID_SelectedStyle,
		DialogID_PolyCount
	};


	Tools_Mode_Carpet()
	{
		Initialise();
	}

	virtual ~Tools_Mode_Carpet()
	{
		Shutdown();
	}

	virtual void PreSave();
	virtual void PostSave();
	virtual void QuickSave(void);

	virtual bool IsModified( void );
	void SetModified( const bool bHasChanged = true );

	void Initialise(void);
	void Update(void);
	void RenderWorld_PreToneMap(void);
	void RenderWorld_PostToneMap(void);
	void RenderUI(void);
	void Shutdown(void);
	
	static void				UpdateSelectedPaintStyle(int iStyle);

private:

	static Asura_Handle		s_iMenuHandle;
	static bool				s_bPaintOverlayOpen;	
	static bool				s_bPaintingActive;	
	static bool				s_bUseTextureFlag;
	static bool				s_bUsePolyFlag;
	static float		    s_fSprayRate;
	static float		    s_fSprayRadius;
	static bool				s_bShowMesh;
	static float			s_fMaxSlopeAngle;
	static char				s_szCarpetMeshPolys[128];
	static int				s_iSelectedStyle;

	static void				CreatePaintOverlay(void);
	static void				TogglePaintOverlay(void);
	static bool				PaintOverlayIsOn(void)			{return s_bPaintOverlayOpen;}
	void					UpdatePainting(void);
	void					RenderPainting(void);

	static Asura_Vector_2	s_xPaintOverlayPosition;	
	
	static bool				s_bStaticObjectsVisible;	
	static bool				s_bStaticObjectsCreated;
	static bool				s_bShowStaticObjects;
	static bool				s_bHideCarpet;
	static bool				s_bHideCarpetClicked;

	STATIC_VOID_FN(			EditStyles );
	STATIC_VOID_FN(			ChangeActiveStyle );
	STATIC_VOID_FN(			UpdateLighting );
	STATIC_VOID_FN(			CleanMesh );
	STATIC_VOID_FN(			ClearMesh );
	STATIC_VOID_FN(			ClearMeshIfDontRender );

	// static this pointer
	static Tools_Mode_Carpet* s_pxThis;
};


#endif //__TOOLS_MODE_CARPET_H__

#endif // ASURA_USE_CARPET

