//
// Tools_Chunk_HelperObject.cp
//
// Created by Richard Rice - 01/09/2006
// 
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//

#include "Core/Asura.h"
#include "ChunkSystem/Tools_Chunk_HelperObject.h"

//asura
#include "ChunkSystem/Asura_Chunk_Stream.h"
#include "ChunkSystem/Asura_SaveBlock.h"
#include "FileAccess/Asura_FileAccess.h"

//tools
#include "HelperObject/Tools_HelperObject.h"
#include "HelperObject/Tools_HelperObject_System.h"

#define TOOLS_CHUNK_HELPEROBJECT_VERSION 0



bool Tools_Chunk_HelperObject::Process(Asura_Chunk_Stream& xStream,const char* szFilename) const
{
	
	// Is this the correct version?

	if (Version > TOOLS_CHUNK_HELPEROBJECT_VERSION)
	{
		Asura_Assertf(false, ("Unknown chunk version %d for tools helper object",Version));
		return false;
	}

	Tools_HelperObject* pxHelper = Tools_HelperObject_System::AllocateHelperObject();
		
	xStream >> pxHelper->m_xName;
	xStream >> pxHelper->m_xComment;
	xStream >> pxHelper->m_xPosition;
	xStream >> pxHelper->m_xOrientation;
	xStream >> pxHelper->m_xVolume.m_xBox;
	xStream >> pxHelper->m_xVolume.m_xOrient;
	xStream >> pxHelper->m_bImportIntoMax;

	//Get the filename for this object
	Asura_String xFilename = szFilename;
	xFilename.SplitFilename(0,&pxHelper->m_xFile,0);

	return true;
}

bool Tools_Chunk_HelperObject::Process(Asura_Handle iFileHandle) const
{
	Asura_Chunk_File_Stream	xStream(iFileHandle);
	return Process(xStream,Asura_FileAccess::GetFilename(iFileHandle));
}

void Tools_Chunk_HelperObject::Create(const class Tools_HelperObject* pxHelper,Asura_Chunk_Stream& xStream)
{
	//start on the chunk
	u_int uChunkFlags = 0;
	xStream.WriteChunk_Start(TOOLS_CHUNK_HELPEROBJECT, TOOLS_CHUNK_HELPEROBJECT_VERSION, uChunkFlags);

	xStream << pxHelper->m_xName;
	xStream << pxHelper->m_xComment;
	xStream << pxHelper->m_xPosition;
	xStream << pxHelper->m_xOrientation;
	xStream << pxHelper->m_xVolume.m_xBox;
	xStream << pxHelper->m_xVolume.m_xOrient;
	xStream << pxHelper->m_bImportIntoMax;

	xStream.WriteChunk_End();
}

void Tools_Chunk_HelperObject::Create(const class Tools_HelperObject* pxHelper,Asura_SaveBlock* pxSaveBlock)
{
	Asura_Chunk_SaveBlock_Stream xStream(pxSaveBlock);
	Create(pxHelper,xStream);
}
