
///////////////////////////////////////////////////////////////////////////////
//
// File   : Tools_Chunk_MaterialResponseOverrides.h
// Author : Andy Tate
// Date   : 4-May-2007
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __TOOLS_CHUNK_MATERIALRESPONSEOVERRIDES_H__
#define __TOOLS_CHUNK_MATERIALRESPONSEOVERRIDES_H__

#if defined(ASURA_USE_MATERIAL_RESPONSE_SYSTEM)

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "ChunkSystem/Asura_Chunk_Loaders.h"


////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////

class Asura_Chunk_Stream;


////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class        : Tools_Chunk_MaterialResponseOverrides
// Author       : Andy Tate
// Date         : 4-May-2007
//
// Description  : Class used for reading/writing material-response override data.
////////////////////////////////////////////////////////////////////////////////

class Tools_Chunk_MaterialResponseOverrides : public Asura_Chunk_Header
{
public:
	// Public functions...
	Tools_Chunk_MaterialResponseOverrides  (void);
//	~Tools_Chunk_MaterialResponseOverrides ();

	bool		Process	(const Asura_Handle iFileHandle) const;

	static void	Create	(Asura_Chunk_Stream& xStream);
	static bool	Save	(const char* szFilename);


protected:
	// Protected variables...

	// Protected functions...


private:
	// Private variables...

	// Private functions...
	Tools_Chunk_MaterialResponseOverrides  (const Tools_Chunk_MaterialResponseOverrides& xOther);

	Tools_Chunk_MaterialResponseOverrides&	operator=	(const Tools_Chunk_MaterialResponseOverrides& xOther);

};   // End of class 'Tools_Chunk_MaterialResponseOverrides'.


#endif	// defined(ASURA_USE_MATERIAL_RESPONSE_SYSTEM)

#endif	// ifndef __TOOLS_CHUNK_MATERIALRESPONSEOVERRIDES_H__


/// End of file. ///
