//////////////////////////////////////////////////////////////////////////////
//
// Tools_Chunk_StaticDecals.h
//
// Copyright (c) 2007 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

#if defined ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#if !defined __TOOLS_CHUNK_STATICDECALS_H__
#define __TOOLS_CHUNK_STATICDECALS_H__

/******************************************************************************/
/* Included Files                                                             */
/******************************************************************************/

// Asura Platform-independent
#include "ChunkSystem/Asura_Chunk_Loaders.h"
#include "Core/Asura_Handle.h"

/******************************************************************************/
/* Classes                                                                    */
/******************************************************************************/

class Asura_Chunk_Stream;

////////////////////////////////////////////////////////////////////////////////
//
// Tools_Chunk_StaticDecals
//
// Tools data for static decals - includes the vertex data rendered by tools,
// to avoid having to reconstruct it on load
//
////////////////////////////////////////////////////////////////////////////////

class Tools_Chunk_StaticDecals : public Asura_Chunk_Header
{
public:

	bool Process( Asura_Chunk_Stream& xStream ) const;
	bool Process( const Asura_Handle iFileHandle ) const;

	static void Create( Asura_Chunk_Stream& xStream );
	static bool Create( char *szFileName );

protected:
};

#endif // !defined __TOOLS_CHUNK_STATICDECALS_H__
