//////////////////////////////////////////////////////////////////////////////
//
// Tools_Chunk_ToolsLights.h
//
// Copyright (c) 2007 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

#if defined ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#if !defined __TOOLS_CHUNK_TOOLSLIGHTS_H__
#define __TOOLS_CHUNK_TOOLSLIGHTS_H__

/******************************************************************************/
/* Included Files                                                             */
/******************************************************************************/

// Asura Platform-independent
#include "ChunkSystem/Asura_Chunk_Loaders.h"
#include "Core/Asura_Handle.h"

/******************************************************************************/
/* Classes                                                                    */
/******************************************************************************/

class Asura_Chunk_Stream;

////////////////////////////////////////////////////////////////////////////////
//
// Tools_Chunk_ToolsLights
//
// Chunk to store info about simple Tools lights (Tools_Photon_Object), which
// are created through the "Simple Lights" entry in the Utility menu
//
////////////////////////////////////////////////////////////////////////////////

class Tools_Chunk_ToolsLights : public Asura_Chunk_Header
{
public:

	bool Process( Asura_Chunk_Stream& xStream ) const;
	bool Process( const Asura_Handle iFileHandle ) const;

	static void Create( Asura_Chunk_Stream& xStream );
	static void Create( const Asura_Handle iFileHandle );

	static bool LoadedAnyLights() { return s_bLoadedAnyLights; }

protected:

	static bool s_bLoadedAnyLights;
};

#endif // !defined __TOOLS_CHUNK_TOOLSLIGHTS_H__
