//
// Tools_Cutscene_RecordAnimation.h
//
// Created by Richard Rice - 26/01/2009
// 
// Copyright (C) 2009 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __TOOLS_CUTSCENE_RECORDANIMATION__
#define __TOOLS_CUTSCENE_RECORDANIMATION__

class Asura_Cutscene;
class Asura_Cutscene_Actor;
class Asura_Cutscene_Actor_Hierarchy;
class Asura_Hierarchy_Skin;
class Asura_Hierarchy_Anim;


//This deals with recording an Asura_Hierarchy_Anim for an actor in a cutscene , mainly
//to allow it to be imported into Max for further tweakage.

class Tools_Cutscene_RecordAnimation
{
public :

	//Starts the recording process
	static void StartRecording(Asura_Cutscene* pxCutscene, Asura_Cutscene_Actor* pxActor);
	//Finishes recording , and writes out the animation
	static void EndRecording();
	//Aborts/clears up the recording process
	static void AbortRecording();

	static bool IsRecording(){return s_pxRecordedAnim != 0;}

	//Get the cutscene timer needed for this frame
	static float GetDesiredCutsceneTimer();

	//Copies the current frame into the animation
	static void AddFrame();

private :
	static void InitialiseAnimation();
	static void AllocateFrames();
	static void AddSkinExportTransToAnim(Asura_Hierarchy_Skin* pxSkin, Asura_Hierarchy_Anim* pxAnim);
	static void GetRelativeQuatAndPos(const Asura_Quat& xParentQuat, const Asura_Vector_3& xParentPos, const Asura_Quat& xThisQuat, const Asura_Vector_3& xThisPos, Asura_Quat& xRelQuat, Asura_Vector_3& xRelPos);

	

	static Asura_Cutscene* s_pxCutscene;
	static Asura_Cutscene_Actor_Hierarchy* s_pxActor;
	static Asura_Hierarchy_Skin* s_pxSkin;

	static Asura_Hierarchy_Anim* s_pxRecordedAnim;
	static float s_fFPS;
	static int s_iNumFrames;
	static int s_iNextFrame;
	static bool s_bDoneFirstUpdate;
	static Asura_String s_xFilename;

	//storage for the current positions of all the bones
	static int s_iNumberOfBones;
	static Asura_Quat* s_pxBoneQuat;
	static Asura_Vector_3* s_pxBonePos; 

	static Asura_Quat s_xActorStartQuat;
	static Asura_Vector_3 s_xActorStartPos;
};



#endif //__TOOLS_CUTSCENE_RECORDANIMATION__
