
// Tools_EffectVolume_FogOverlay.h
//
// Created by Emil Popovic - 12/01/2009
// 
// Copyright (C) 2009 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif


#ifndef __TOOLS_EFFECTVOLUME_FOGOVERLAY_H__
#define __TOOLS_EFFECTVOLUME_FOGOVERLAY_H__

#include "Independent/Rendering/Asura_Fog.h"
#include "Entity/Tools_Entity_Object.h"

class Tools_EffectVolume_FogOverlay  : public Tools_Modal_Overlay
{
public:
	Tools_EffectVolume_FogOverlay ( Asura_Fog_Parameters& xFogParameters );
	virtual ~Tools_EffectVolume_FogOverlay ();

	bool DoModal();
	void WriteNewValuesToFogParameters( Asura_Fog_Parameters& xFogParameters );


protected:
	virtual void InitialiseOverlay(class Asura_Overlay* pxOverlay);
	virtual void Update();

private:

	static void OkayPressed( int iUserData );
	static void CancelPressed( int iUserData );


	Asura_Fog_Parameters&	m_xFogParameters;
	bool					m_bReturnValue;


	// Static values for real-time editing.
	static bool		s_bChangedFogOverlay;
	static bool		s_bGraphFogEnabled;
	static float	s_fSkyboxFogBlendFactor;
	static bool		s_bMadeChanges;
	static float	s_fFogRed;
	static float	s_fFogGreen;
	static float	s_fFogBlue;
	static bool		s_bChangedMinFog;
	static bool		s_bChangedMaxFog;
	static float	s_fFogNearPlane;
	static float	s_fFogFarPlane;
	static float	s_fFogValueAtFarPlane;
	static Asura_Graph<float>* s_pxFogDensityGraph;



	typedef Tools_Modal_Overlay PARENT;
};


#endif //__TOOLS_EFFECTVOLUME_FOGOVERLAY_H__
