//////////////////////////////////////////////////////////////////////////////
//
// Tools_EntityNode_OrientedNode.h
//
// Created by NJD - 12 October 2006
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __TOOLS_ENTITYNODE_ORIENTEDNODE_H__
#define __TOOLS_ENTITYNODE_ORIENTEDNODE_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// tools
#include "Entity/Locations/Tools_Entity_Node.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class Asura_ServerNode_OrientedNode;

//////////////////////////////////////////////////////////////////////////////
//
// Tools_EntityNode_OrientedNode
//
//////////////////////////////////////////////////////////////////////////////

class Tools_EntityNode_OrientedNode : public Tools_Entity_Node
{
public:
    typedef Tools_Entity_Node PARENT;

public:
    Tools_EntityNode_OrientedNode( Asura_Entity* pxEntity );

    const char*  GetTypeDescription() { return "Orientated Node"; }

	virtual const char* GetMyNamePrefix() const { return Tools_EntityNode_OrientedNode::GetNamePrefix(); }

	virtual void Destroy();
    virtual bool IsBaseOrDerivativeOf( int iToolsObjectType ) const;
	virtual void OnSelection();
	virtual void OnDeselection();
    virtual void UpdatePositionInAsuraData(bool /*updateLinkedObjects*/);

    virtual bool          CanBeCopied() const { return Type == TOT_Entity_OrientedNode; }
    virtual void          Copy( const Tools_Object* pxObject );
    virtual Tools_Object* CreateObjectOfThisType() const;

	static void Create();

#ifdef ASURA_USE_AXON
	void SetGuardZoneGuid( const Asura_Guid uGZGuid ) { m_uMyToolsGZGuid = uGZGuid; }

	static void CreateGuardPoint( Tools_EntityNode_OrientedNode** ppxNewNode, Asura_Guid uGZGuid );
#endif

	static const char* GetNamePrefix() { return "ON_"; }

protected:
	Asura_ServerNode_OrientedNode* GetGameOrientedNode() const;

protected:
#ifdef ASURA_USE_AXON
	Asura_Guid m_uMyToolsGZGuid;
#endif

private:
	static Tools_EntityNode_OrientedNode* CreateAndReturn();
	static Tools_EntityNode_OrientedNode* s_pxThisToolsOrientedNode;
};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //__TOOLS_ENTITYNODE_ORIENTEDNODE_H__
