//////////////////////////////////////////////////////////////////////////////
//
// Tools_Object_PFXSplinePoint.h
//
// Created by KOR - 23/01/2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __TOOLS_OBJECT_PFXSPLINEPOINT_H__
#define __TOOLS_OBJECT_PFXSPLINEPOINT_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// tools
#include "Entity/Locations/Spline/Tools_Object_SplinePoint.h"

class Tools_Entity_PFX_Effect;

//////////////////////////////////////////////////////////////////////////////
//
// Tools_Object_PFXSplinePoint
//
//////////////////////////////////////////////////////////////////////////////

class Tools_Object_PFXSplinePoint: public Tools_Object_SplinePoint
{
    typedef Tools_Object_SplinePoint PARENT;

public :
    Tools_Object_PFXSplinePoint( Asura_Spline<Asura_Vector_3>* pxParentSpline,
        Tools_Entity_PFX_Effect* pxParentSplineTools,
        int iIndex,
        bool bCanBeDestroyed);
    virtual ~Tools_Object_PFXSplinePoint();

	virtual void UpdatePositionInAsuraData(bool /*updateLinkedObjects*/);
	virtual const char* GetTypeDescription(){return "PFX Spline Control Point";}
    virtual void Destroy();
	virtual bool CanBeMoved();
    virtual void AddOverlayControls(class Asura_Overlay* pxOverlay, class Asura_Vector_2& xOffset);
	virtual void OnSelection();
	virtual void OnDeselection();
	virtual void UpdateWhileSelected();

protected:
    static void SelectEffect();
	virtual void CreateNew(const Asura_Vector_3& xPosition, const int iIndexAfter);

private:
    Tools_Entity_PFX_Effect* m_pxParentTools; //private, as derivations will have their own pointer to their derivation of the spline tool class

    static Tools_Object_PFXSplinePoint* s_pxThisSplinePoint;
};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //__TOOLS_OBJECT_PFXSPLINEPOINT_H__
