//////////////////////////////////////////////////////////////////////////////
//
// Tools_Object_SplinePoint.h
//
// Created by NJD - 16 October 2006
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef __TOOLS_OBJECT_SPLINEPOINT_H__
#define __TOOLS_OBJECT_SPLINEPOINT_H__ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

// tools
#include "Objects/Tools_Object.h"

template <typename T> class Asura_Spline;

//////////////////////////////////////////////////////////////////////////////
//
// Tools_Object_SplinePoint
//
//////////////////////////////////////////////////////////////////////////////

class Tools_Object_SplinePoint : public Tools_Object
{
    typedef Tools_Object PARENT;

public :
    Tools_Object_SplinePoint( Asura_Spline<Asura_Vector_3>* pxParentSpline,
		Tools_Object* pxParentObject,
        int iIndex,
        bool bIsEndPoint);
    virtual ~Tools_Object_SplinePoint();

    virtual void UpdatePositionInAsuraData(bool /*updateLinkedObjects*/);
    virtual void UpdatePositionFromAsuraData();
    virtual const char* GetName(){return m_szName;}
    virtual const char* GetTypeDescription(){return "Spline Control Point";}
    virtual bool CanBeDestroyed();
    virtual void Destroy();
    void DestroyToolsObjectOnly();
    virtual void AddOverlayControls(class Asura_Overlay* pxOverlay, class Asura_Vector_2& xOffset);
	virtual bool ShouldCreateObjectOverlay() { return true; }
    virtual void OnSelection();
    virtual void OnDeselection();
	virtual void UpdateWhileSelected();
	virtual bool SuppressCantExportToTemplateWarning() const {return true;} //RAR 25/10/2007 Prevent warning message caused by selecting these along with the entities when exporting to a template
	virtual bool IsHidden();

	void SetPosition( const Asura_Vector_3& xPosition );
	void SetOrientation( const Asura_Matrix_3x3& xOrientM );

	int GetIndex() const { return m_iIndex; }

protected:
    static void AddAfter();
    static void AddBefore();
    static bool CanAddAfter();
    static bool CanAddBefore();
    virtual void CreateNew(const Asura_Vector_3& xPosition, const int iIndexAfter);

    Asura_Vector_3* m_pxPositionInAsura;
    int             m_iIndex;
    bool            m_bIsEndPoint;
	bool			m_bStraight;
	bool			m_bChanged;
    char*           m_szName;

private:
    Asura_Spline<Asura_Vector_3>* m_pxParentSpline;
	Tools_Object* m_pxParentObject;
    static Tools_Object_SplinePoint* s_pxThisSplinePoint;
};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif //__TOOLS_OBJECT_SPLINEPOINT_H__
