//
// Tools_Entity_Activatable_Object.h
//
// Created by Richard Rice - 18/09/2002
// 
// Copyright (C) 2002 Rebellion, All Rights Reserved.
//


#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef _TOOLS_ENTITY_ACTIVATABLE_OBJECT_H_
#define _TOOLS_ENTITY_ACTIVATABLE_OBJECT_H_

#include "Entity/Tools_Entity_Object.h"

class Tools_Entity_Activatable_Object : public Tools_Entity_Object
{
	typedef Tools_Entity_Object PARENT;

	public :
		Tools_Entity_Activatable_Object(Asura_Entity* entity);
		
		//virtual function overides
		const char* GetTypeDescription(){return "Activatable";}
		void UpdateWhileSelected();

		static const char* GetNamePrefix() { return "AO_"; }
		virtual const char* GetMyNamePrefix() const { return Tools_Entity_Activatable_Object::GetNamePrefix(); }

		virtual void AddOverlayControls(class Asura_Overlay* newOverlay,class Asura_Vector_2& offset);

		// for compatability with existing code, some entities still deal with activate/deactivate themselves.
		virtual bool DealsInternallyWithActivate() const { return true; }

		virtual bool HandlesThisMessage(int messageID);
		virtual void PrintInfo(float& x,float& y);

		virtual void Copy(const Tools_Object* pxObject);

		virtual void UpdateClient();

		virtual bool GetParameter(Asura_Hash_ID uParamID,class Tools_Parameter* pxParam) const;
		virtual bool SetParameter(Asura_Hash_ID uParamID,const class Tools_Parameter* pxParam);

	public :

		bool m_bActive;

};


class Tools_Entity_ActivatableWithPosition_Object : public Tools_Entity_Activatable_Object
{
	public :
		Tools_Entity_ActivatableWithPosition_Object(Asura_Entity* pxEntity);
		
		//virtual function overides
		virtual const char* GetTypeDescription(){return "Activatable With Position";}
		virtual void UpdatePositionInAsuraData(bool /*bUpdateLinkedObjects*/);

		virtual void UpdateClient();
};


#endif //_TOOLS_ENTITY_ACTIVATABLE_OBJECT_H_
