
///////////////////////////////////////////////////////////////////////////////
//
// File   : Tools_Entity_Affector_Wind.h
// Author : Andy Tate
// Date   : 8-Dec-2006
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __TOOLS_ENTITY_AFFECTOR_WIND_H__
#define __TOOLS_ENTITY_AFFECTOR_WIND_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Entity/Tools_Entity_Object.h"


#if defined(ASURA_USE_AFFECTORS)

////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class        : Tools_Entity_Affector_Wind
// Author       : Andy Tate
// Date         : 8-Dec-2006
//
// Description  : Class to handle the Tools editing of affectors.
////////////////////////////////////////////////////////////////////////////////

class Tools_Entity_Affector_Wind : public Tools_Entity_Object
{
public:
	// Public functions...
	Tools_Entity_Affector_Wind          (Asura_Entity* pxEntity);
//	virtual ~Tools_Entity_Affector_Wind ();

	// Overridden functions...
	virtual	const char*	GetTypeDescription	(void)	{ return("Wind Affector"); }

	virtual const char* GetMyNamePrefix() const { return Tools_Entity_Affector_Wind::GetNamePrefix(); }

	virtual	void		AddOverlayControls	(Asura_Overlay* pxOverlay, Asura_Vector_2& xOffset);
	virtual	void		UpdateWhileSelected	(void);
	virtual	bool		HandlesThisMessage	(int iMessageID);
	virtual	void		PrintInfo			(float& fX, float& fY);

	// Overridden copy functions...
	virtual	bool			CanBeCopied				(void) const	{ return(true); }
	virtual	void			Copy					(const Tools_Object* pxObject);
	virtual	Tools_Object*	CreateObjectOfThisType	(void) const;

	// Static functions...
	static void		Create	(void);

	static const char* GetNamePrefix() { return "WA_"; }

	virtual void SetEntityModified();

protected:
	// Protected variables...
	float	m_fStrength;		// The strength of this affector.
	float	m_fResponseScale;	// The response-scale for this affector.

	// Protected functions...


private:
	// Private typedefs...
	typedef Tools_Entity_Object PARENT;

	// Private variables...

	// Private functions...
	Tools_Entity_Affector_Wind  (void);
	Tools_Entity_Affector_Wind  (const Tools_Entity_Affector_Wind& xOther);

	Tools_Entity_Affector_Wind&	operator=	(const Tools_Entity_Affector_Wind& xOther);

};   // End of class 'Tools_Entity_Affector_Wind'.

#endif	// defined(ASURA_USE_AFFECTORS)


#endif   // ifndef __TOOLS_ENTITY_AFFECTOR_WIND_H__


/// End of file. ///
