//////////////////////////////////////////////////////////////////////////////
//
// Tools_Entity_ClockTrigger_Object.h
//
// Copyright (c) 2004 Rebellion. All rights reserved.
//
// Created by Nick Davis
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef ___TOOLS_ENTITY_CLOCKTRIGGER_OBJECT_H___
#define ___TOOLS_ENTITY_CLOCKTRIGGER_OBJECT_H___ 1

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
//
// includes
//
//////////////////////////////////////////////////////////////////////////////

// tools
#include "Entity/Tools_Entity_Trigger_Object.h"

//////////////////////////////////////////////////////////////////////////////
//
// Tools_Entity_ClockTrigger_Object
//
//////////////////////////////////////////////////////////////////////////////

class Tools_Entity_ClockTrigger_Object : public Tools_Entity_Trigger_Object
{
public:
    Tools_Entity_ClockTrigger_Object( Asura_Entity* pxEntity );
    static void Create();
    static Tools_Entity_ClockTrigger_Object* Create( bool bGenerateName );

    virtual const char* GetTypeDescription() { return "Clock Trigger"; }
    virtual bool HandlesThisMessage( int iMessageID );

	static const char* GetNamePrefix() { return "ClkT_"; }
	virtual const char* GetMyNamePrefix() const { return Tools_Entity_ClockTrigger_Object::GetNamePrefix(); }

	virtual void Destroy();
    virtual void AddOverlayControls( class Asura_Overlay* pxNewOverlay, class Asura_Vector_2& xOffset );
    virtual bool OwnsThisMessageBlock( unsigned short uMessageBlockID );

    virtual void PrintInfo( float& x, float& y );

    virtual void          Copy( const Tools_Object* pxObject );
    virtual bool          CanBeCopied() const { return Type == TOT_Entity_ClockTrigger; }
    virtual Tools_Object* CreateObjectOfThisType() const;

protected:
    static void EditMessages_EveryQuarterHour();
    static void EditMessages_EveryHalfHour();
    static void EditMessages_EveryThreeQuarterHour();
    static void EditMessages_EveryHour();
    static void EditMessages_HourCount();
    static void EditMessages_AtSpecifiedTime();

    static void SetHourHandObject( int iThis );
    static void SetMinuteHandObject( int iThis );
};

//////////////////////////////////////////////////////////////////////////////
//
// 
//
//////////////////////////////////////////////////////////////////////////////

#endif
