#ifndef __TOOLS_ENTITY_DEBUGWAYPOINTTRIGGER_OBJECT_H__
#define __TOOLS_ENTITY_DEBUGWAYPOINTTRIGGER_OBJECT_H__

#ifdef ASURA_USE_DEBUG_MESSAGE_TRIGGER

#include "Entity/Tools_Entity_Trigger_Object.h"

//////////////////////////////////////////////////////////////////////////////////////////////////
/*--------------------------------------------**
** Tools_Entity_DebugWaypointTrigger_Object **
**--------------------------------------------*/

class Tools_Entity_DebugWaypointTrigger_Object : public Tools_Entity_Trigger_Object
{
	typedef Tools_Entity_Trigger_Object PARENT;

public :
	Tools_Entity_DebugWaypointTrigger_Object( Asura_Entity* pxEntity );
	static Tools_Object* Create( Asura_Entity* pxEntity );

	static void Create();
	static Tools_Entity_DebugWaypointTrigger_Object* Create( bool bGenerateName );

	//virtual function overides
	const char* GetTypeDescription(){return "DebugWaypoint_Trigger";}
	bool HandlesThisMessage(int iMessageID);

	static const char* GetNamePrefix() { return "DWT_"; }
	virtual const char* GetMyNamePrefix() const { return Tools_Entity_DebugWaypointTrigger_Object::GetNamePrefix(); }

	void AddOverlayControls( class Asura_Overlay* pxNewOverlay, class Asura_Vector_2& xOffset );

	virtual void PrintInfo(float& fX,float& fY);

	virtual void Copy( const Tools_Object* pxObject );
	virtual bool CanBeCopied() const { return true; }
	virtual Tools_Object* CreateObjectOfThisType() const;

	virtual bool GetParameter(Asura_Hash_ID uParamID,class Tools_Parameter* pxParam) const;
	virtual bool SetParameter(Asura_Hash_ID uParamID,const class Tools_Parameter* pxParam);

	virtual void UpdatePositionInAsuraData(bool bUpdateLinkedObjects);


	//Shape/anim
	static void ChooseSkin(int iThis)	{ (reinterpret_cast<Tools_Entity_DebugWaypointTrigger_Object*>(iThis))->ChooseSkin(); }
	static void ChooseAnim(int iThis)	{ (reinterpret_cast<Tools_Entity_DebugWaypointTrigger_Object*>(iThis))->ChooseAnim(); }
	static void ChooseShape(int iThis)	{ (reinterpret_cast<Tools_Entity_DebugWaypointTrigger_Object*>(iThis))->ChooseShape(); }

	void ChooseAnim();
	void ChooseShape();
	void ChooseSkin();

	void ClearInternalShapeAndAnim();
	void SetInternalSkinAndAnim(u_int uInternalSkin, u_int uInternalAnim);
	void SetInternalShape(u_int uInternalShape);

	void UpdateServerEntitySkinAnim();

	bool m_bSkin;
	Asura_Hash_ID m_uShapeID;	//Shape or Skin
	Asura_Hash_ID m_uAnimID;	//Animation

	void Render();

	virtual void AddFilesToExportList(List<Asura_String>& xNameList) const;
};

#endif //ASURA_USE_DEBUG_MESSAGE_TRIGGER

#endif // #ifndef __TOOLS_ENTITY_DEBUGWAYPOINTTRIGGER_OBJECT_H__