//////////////////////////////////////////////////////////////////////////////
//
// Tools_Entity_DestructibleLight.h
//
// Copyright (c) 2006 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef TOOLS_ENTITY_DESTRUCTIBLELIGHT_H___
#define TOOLS_ENTITY_DESTRUCTIBLELIGHT_H___ 1

#ifndef ASURA_TARGET_SM3

// I N C L U D E S ///////////////////////////////////////////////////////////

// Engine independent.
#include "Entity/PhysicalObject/Asura_ServerEntity_DestructibleLight.h"

// Tools.
#include "Entity/Tools_Entity_PhysicsObject.h"

// C L A S S E S /////////////////////////////////////////////////////////////

class Tools_Entity_DestructibleLight : public virtual Tools_Entity_PhysicsObject
{

public:

	static void Project_Create();
	static void _EditBoundingBox();
	static void _SelectCoronaTexture(){s_pxSelectedObject->SelectCoronaTexture();}	

	static const char* GetNamePrefix() { return "DesL_"; }
	virtual const char* GetMyNamePrefix() const { return Tools_Entity_DestructibleLight::GetNamePrefix(); }

protected:

	static const char* const s_szLongName;
	static const char* const s_szShortName;
	static Tools_Entity_DestructibleLight* s_pxSelectedObject;

	Tools_Entity_DestructibleLight(Asura_ServerEntity_DestructibleLight* pxDestLight);
	virtual ~Tools_Entity_DestructibleLight();

	// virtual function overrides
    virtual const char* GetTypeDescription() { return s_szLongName; }
	virtual void PrintInfo(float& x,float& y) {} // no need to call parent

	virtual void AddOverlayControls(Asura_Overlay* pxNewOverlay, Asura_Vector_2& xOffset);
	virtual void UpdateOverlayControls(Asura_Overlay* pxOverlay);
	virtual void UpdateWhileSelected();

	virtual void OnSelection();
	virtual void OnDeselection();

	virtual void Copy(const Tools_Object*);
	virtual bool CanBeCopied() const {return Type == TOT_Entity_DestructibleLight;}
	virtual Tools_Object* CreateObjectOfThisType() const;

    // internal use functions
    virtual void SetPhotonToValuesOfEntity();

	void EditBoundingBox();
	void SelectCoronaTexture();

	void UpdateCorona();
	void SetPhotonAndCoronaColour(float fRed,float fGreen,float fBlue);
	void SetPhotonAndCoronaActive(bool bActive);

    virtual void SelectShape( void );

	bool m_bUsingClientPhoton;
	class Asura_Photon* m_pxPhoton;
	Asura_ServerEntity_DestructibleLight* m_pxDestLight; // cached pointer to entity

	bool m_bUsingClientCorona;
	Asura_Handle m_iCoronaHandle;

	unsigned m_uVolumeEditID;

	enum DialogID
	{
		DialogID_Texture,
	};

private:

    typedef Tools_Entity_PhysicsObject PARENT;

	static Asura_Hashed_List<Tools_Entity_DestructibleLight> s_xList;

};

#endif // #ifndef ASURA_TARGET_SM3

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

#endif // #ifndef TOOLS_ENTITY_DESTRUCTIBLELIGHT_H___
