
////////////////////////////////////////////////////////////////////////////////
//
// Tools_Entity_FMVSpeaker.h
// Author    : Jason Turner
// Copyright (C) 2009 Rebellion, All Rights Reserved.
//
////////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef _TOOLS_ENTITY_FMVSPEAKER_H_
#define _TOOLS_ENTITY_FMVSPEAKER_H_

#include "Entity/Tools_Entity_Activatable_Object.h"
#include "Objects/Tools_VolumeGroupEdit_Controller.h"

class Tools_Entity_FMVSpeaker : public Tools_Entity_Activatable_Object
{
	typedef Tools_Entity_Activatable_Object PARENT;

	public :
		Tools_Entity_FMVSpeaker(Asura_Entity* pxEntity);
		~Tools_Entity_FMVSpeaker();
		static void Create();
		static Tools_Entity_FMVSpeaker* Create(bool bGenerateName);

		virtual bool HandlesThisEvent(int iEventID) const;
		virtual bool HandlesThisMessage(int iMessageID);

		//virtual function overides
		virtual const char* GetTypeDescription(){return "FMV Speaker";}
		virtual void AddOverlayControls(class Asura_Overlay* pxOverlay,class Asura_Vector_2& xOffset);

		static const char* GetNamePrefix() { return "FMVS_"; }
		virtual const char* GetMyNamePrefix() const { return Tools_Entity_FMVSpeaker::GetNamePrefix(); }

		virtual void Copy(const Tools_Object*);
		virtual bool CanBeCopied() const {return Type == TOT_Entity_FMVSpeaker;}
		virtual Tools_Object* CreateObjectOfThisType() const;

		virtual void Render();		
		virtual void UpdatePositionInAsuraData(bool /*updateLinkedObjects*/);

	protected :
		static void SelectFMV(int iThis){((Tools_Entity_FMVSpeaker*)iThis)->SelectFMV();}
		void SelectFMV();
		static bool GetLoopChecked(void *pData);
		static void SetLoopChecked(bool bValue, void *pData);
};

#endif // _TOOLS_ENTITY_FMVSPEAKER_H_
