//
// Tools_Entity_LogicTrigger_Object.h
//
// Created by Richard Rice - 10/07/2004
// 
// Copyright (C) 2004 Rebellion, All Rights Reserved.
//


#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef _TOOLS_ENTITY_LOGICTRIGGER_OBJECT_H_
#define _TOOLS_ENTITY_LOGICTRIGGER_OBJECT_H_

#include "Tools_Entity_Activatable_Object.h"

class Tools_Entity_LogicTrigger_Object : public Tools_Entity_Activatable_Object
{
	public :
		Tools_Entity_LogicTrigger_Object(Asura_Entity* pxEntity);
		~Tools_Entity_LogicTrigger_Object();

		static void Create();
		static Tools_Entity_LogicTrigger_Object* Create(bool bGenerateName);
		
		//virtual function overides
		const char* GetTypeDescription(){return "Logic Trigger";}
		void Destroy();
		void UpdateWhileSelected();
		virtual void PrintInfo(float& x,float& y);

		static const char* GetNamePrefix() { return "LT_"; }
		virtual const char* GetMyNamePrefix() const { return Tools_Entity_LogicTrigger_Object::GetNamePrefix(); }

		void AddOverlayControls(class Asura_Overlay* pxNewOverlay,class Asura_Vector_2& xOffset);
		bool HandlesThisMessage(int iMessageID);

		virtual bool GetEventDescForMessageBlock(unsigned short usMessageBlockID,Asura_String& xOutputDesc);

		virtual void Copy(const Tools_Object*);
		virtual bool CanBeCopied() const {return Type == TOT_Entity_LogicTrigger;}
		virtual Tools_Object* CreateObjectOfThisType() const;

		virtual bool OwnsThisMessageBlock(unsigned short usMessageBlockID);

		//controls for editing messages to a logic trigger
		static void AddOverlayControls_Input(struct Asura_StaticMessage* pxMessage,class Asura_Overlay* pxOverlay,class Asura_Vector_2& xOffset);
		static void EditInputMessage(Asura_StaticMessage* pxMessage);
	
		const char* GetInputNameFromHash(Asura_Hash_ID uNameHash) const;


protected :
		//prompt for an input to be chosen , returns index of selection , or -1
		int SelectInputIndex(const char* pszMessage);
		Asura_Hash_ID SelectInputHash(const char* pszMessage);

		//changes mesh according to type
		void UpdateMesh();

		//overlay functions
		static void AddInput(int iThis){((Tools_Entity_LogicTrigger_Object*)iThis)->AddInput();}
		void AddInput();

		static void DeleteInput(int iThis){((Tools_Entity_LogicTrigger_Object*)iThis)->DeleteInput();}
		void DeleteInput();

		static void RenameInput(int iThis){((Tools_Entity_LogicTrigger_Object*)iThis)->RenameInput();}
		void RenameInput();


		static void EditOnMessages();
		static void EditOffMessages();

		static void EditInputMessage(int iMessage);

		bool* m_pbActive;

};


#endif //_TOOLS_ENTITY_LOGICTRIGGER_OBJECT_H_
