//////////////////////////////////////////////////////////////////////////////
//
// Tools_Entity_StartPoint.h
//
// Copyright (c) 2005 Rebellion. All rights reserved.
//
// Description:
//
//     Tools start point entity
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef ___TOOLS_ENTITY_STARTPOINT_H___
#define ___TOOLS_ENTITY_STARTPOINT_H___ 1

#include "Entity/Tools_Entity_Object.h"

class Tools_Entity_StartPoint : public Tools_Entity_Object
{
public:
	Tools_Entity_StartPoint(Asura_Entity* pxEntity);

	static Tools_Entity_StartPoint* CreateAndReturn();
	static void Create()	{ CreateAndReturn(); }

	#ifndef TOOLS_USE_OLD_ENTITY_MANAGER
	virtual const char* GetShortName(){return "START";}
	#endif

	static void Project_Create();

	// virtual function overrides
	virtual bool			UseStreamCopy(void) const			{ return(true); }
	virtual const char*		GetTypeDescription(void)			{ return("Start Point"); }
	virtual bool			CanBeCopied(void) const				{ return(true); }
	virtual Tools_Object*	CreateObjectOfThisType(void) const	{ return(CreateAndReturn()); }

	virtual void			UpdatePositionInAsuraData(bool);

	static const char*		GetNamePrefix()						{ return "StartP_"; }
	virtual const char*		GetMyNamePrefix() const				{ return Tools_Entity_StartPoint::GetNamePrefix(); }
};

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

#endif // #ifndef ___TOOLS_ENTITY_STARTPOINT_H___
