
///////////////////////////////////////////////////////////////////////////////
//
// File   : Tools_Entity_TeleportDestination.h
// Author : Andy Tate
// Date   : 2-Mar-2007
//
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __TOOLS_ENTITY_TELEPORTDESTINATION_H__
#define __TOOLS_ENTITY_TELEPORTDESTINATION_H__

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Entity/Tools_Entity_StartPoint.h"


////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class        : Tools_Entity_TeleportDestination
// Author       : Andy Tate
// Date         : 2-Mar-2007
//
// Description  : Class to handle Tools editing of teleport destinations.
////////////////////////////////////////////////////////////////////////////////

class Tools_Entity_TeleportDestination : public Tools_Entity_Object
{
public:
	// Public functions...
	Tools_Entity_TeleportDestination(Asura_Entity* pxEntity);
//	~Tools_Entity_TeleportDestination ();

	static void	Create	(void);

	// Overridden functions...
	virtual	const char*	GetTypeDescription	(void)	{ return("Teleport Destination"); }

	static const char* GetNamePrefix		()		{ return "TD_"; }
	virtual const char* GetMyNamePrefix		() const{ return Tools_Entity_TeleportDestination::GetNamePrefix(); }

	virtual void							UpdatePositionInAsuraData	(bool bUpdateLinkedObjects);

	// Overridden copy functions...
	virtual	bool CanBeCopied(void) const { return(true); }
	//virtual	void Copy(const Tools_Object* pxObject); //Nothing that needs to be done in Copy() for this class.
	virtual	Tools_Object* CreateObjectOfThisType(void) const;



protected:
	// Protected variables...

	// Protected functions...


private:
	// Private typedefs...
	typedef Tools_Entity_Object PARENT;

	// Private variables...

	// Private functions...
	static Tools_Object* CreateMain(void);


	Tools_Entity_TeleportDestination  (void);
	Tools_Entity_TeleportDestination  (const Tools_Entity_TeleportDestination& xOther);

	Tools_Entity_TeleportDestination&	operator=	(const Tools_Entity_TeleportDestination& xOther);

};   // End of class 'Tools_Entity_TeleportDestination'.


#endif   // ifndef __TOOLS_ENTITY_TELEPORTDESTINATION_H__


/// End of file. ///
