//
// Tools_Mode_FSFX_Template.h
//
// Created by JGP 03/02/06
// 
// Copyright (C) 2006 Rebellion (Derby), All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifdef ASURA_USE_FSFX

#ifndef __TOOLS_MODE_FSFX_TEMPLATE_H__
#define __TOOLS_MODE_FSFX_TEMPLATE_H__

#include "Tools_Mode_FSFX_Helpers.h"
#include "Core/Asura_Maths.h"

class Asura_FSFX_Template;
class Asura_FSFX_Component;
class Asura_Overlay;
struct Tools_Mode_FSFX_Template_Callback;
class Asura_FSFX_Component_Test;
class Asura_FSFX_Component_BrightnessAndContrast;
class Asura_FSFX_Component_DesaturateAndTint;
class Asura_FSFX_Component_Noise;
class Asura_FSFX_Component_GaussianBlur;
class Asura_FSFX_Component_RadialBlur;
class Asura_FSFX_Component_DepthOfField;
class Asura_FSFX_Component_Bloom;
class Asura_FSFX_Component_Gamma;
class Asura_FSFX_Component_RGBGamma;
class Asura_FSFX_Component_SM30_Bloom;
class Asura_FSFX_Component_ColourMap;
class Asura_FSFX_Component_SM30_DepthOfField;
class Asura_FSFX_Component_SM30_MotionBlur;
class Asura_FSFX_Component_SM30_FishEye;
class Asura_FSFX_Component_SM30_DoubleVision;

class ListSelection_Overlay;

class Tools_Mode_FSFX_Template
{

public:

	// construct destruct

	Tools_Mode_FSFX_Template( Asura_FSFX_Template* pxTemplate, const bool bReadOnly );
	~Tools_Mode_FSFX_Template();

	Asura_FSFX_Template* const GetOldTemplate() { return m_pxOldTemplate; }
	Asura_FSFX_Template* const GetTemplate() { return m_pxTemplate; }

	// rebuild on request

	void InvalidateOverlay();

private:

    // private functions

	void InitialiseOverlay();
	void CloseOverlay();

	void AddInterfaceForComponent( Asura_FSFX_Component* pxComponent, Asura_Overlay* const pxOverlay, Asura_Vector_2& xOffset );
	void AddInterfaceForComponentTest( Asura_FSFX_Component_Test* pxComponent, Asura_Overlay* const pxOverlay, Asura_Vector_2& xOffset );
	void AddInterfaceForComponentBrightnessAndContrast( Asura_FSFX_Component_BrightnessAndContrast* pxComponent, Asura_Overlay* const pxOverlay, Asura_Vector_2& xOffset );
	void AddInterfaceForComponentDesaturateAndTint( Asura_FSFX_Component_DesaturateAndTint* pxComponent, Asura_Overlay* const pxOverlay, Asura_Vector_2& xOffset );
	void AddInterfaceForComponentNoise( Asura_FSFX_Component_Noise* pxComponent, Asura_Overlay* const pxOverlay, Asura_Vector_2& xOffset );
	void AddInterfaceForComponentGaussianBlur( Asura_FSFX_Component_GaussianBlur* pxComponent, Asura_Overlay* const pxOverlay, Asura_Vector_2& xOffset );
	void AddInterfaceForComponentRadialBlur( Asura_FSFX_Component_RadialBlur* pxComponent, Asura_Overlay* const pxOverlay, Asura_Vector_2& xOffset );
	void AddInterfaceForComponentDepthOfField( Asura_FSFX_Component_DepthOfField* pxComponent, Asura_Overlay* const pxOverlay, Asura_Vector_2& xOffset );
	void AddInterfaceForComponentBloom( Asura_FSFX_Component_Bloom* pxComponent, Asura_Overlay* const pxOverlay, Asura_Vector_2& xOffset );
	void AddInterfaceForComponentGamma( Asura_FSFX_Component_Gamma* pxComponent, Asura_Overlay* const pxOverlay, Asura_Vector_2& xOffset );
	void AddInterfaceForComponentRGBGamma( Asura_FSFX_Component_RGBGamma* pxComponent, Asura_Overlay* const pxOverlay, Asura_Vector_2& xOffset );
	void AddInterfaceForComponentSM30Bloom( Asura_FSFX_Component_SM30_Bloom* pxComponent, Asura_Overlay* const pxOverlay, Asura_Vector_2& xOffset );
	void AddInterfaceForComponentColourMap( Asura_FSFX_Component_ColourMap* pxComponent, Asura_Overlay* const pxOverlay, Asura_Vector_2& xOffset );
	void AddInterfaceForComponentSM30DepthOfField( Asura_FSFX_Component_SM30_DepthOfField* pxComponent, Asura_Overlay* const pxOverlay, Asura_Vector_2& xOffset );
	void AddInterfaceForComponentSM30MotionBlur( Asura_FSFX_Component_SM30_MotionBlur* pxComponent, Asura_Overlay* const pxOverlay, Asura_Vector_2& xOffset );
	void AddInterfaceForComponentSM30FishEye( Asura_FSFX_Component_SM30_FishEye* pxComponent, Asura_Overlay* const pxOverlay, Asura_Vector_2& xOffset );
	void AddInterfaceForComponentSM30DoubleVision( Asura_FSFX_Component_SM30_DoubleVision* pxComponent, Asura_Overlay* const pxOverlay, Asura_Vector_2& xOffset );


	void Project_AddComponentsToCreationList( ListSelection_Overlay& xOverlay );
	bool Project_AddInterfaceForComponent( Asura_FSFX_Component* pxComponent, Asura_Overlay* const pxOverlay, Asura_Vector_2& xOffset );

	// widgets

	void AddColourOverlay( float* const pfRed, float* const pfGreen, float* const pfBlue, Asura_Overlay* const pxOverlay, Asura_Vector_2& xOffset ); 

	// callbacks

	STATIC_VOID_USING_INT_THIS( Tools_Mode_FSFX_Template, OnCloseAndSave );
	STATIC_VOID_USING_INT_THIS( Tools_Mode_FSFX_Template, OnCloseAndDiscard );

	STATIC_VOID_USING_INT_THIS( Tools_Mode_FSFX_Template, OnCreateComponent );
	static void _OnExpandCollapse( int iParam );
	void OnExpandCollapse( const int iIndex );
	static void _OnDelete( int iParam );
	void OnDelete( const int iIndex );
	static void _OnMoveUp( int iParam );
	void OnMoveUp( const int iIndex );
	static void _OnMoveDown( int iParam );
	void OnMoveDown( const int iIndex );

	static void ComponentNoiseChooseTexture( int iUserData );
	
	// static data

	static Asura_Vector_2 s_xOverlayPosition;	// store position
	static class Asura_Dialog* s_pxChooseTextureDialog;

	// vars

	bool m_bReadOnly;
	Asura_FSFX_Template* m_pxTemplate;
	Asura_FSFX_Template* m_pxOldTemplate;
	Tools_Mode_FSFX_Template_Callback* m_pxCallbackData;
	int m_iNumComponents;

};


#endif //__TOOLS_MODE_FSFX_TEMPLATE_H__

#endif // ASURA_USE_FSFX
