
///////////////////////////////////////////////////////////////////////////////
//
// File   : Tools_FacialAnimation_AnimationHandler_HierarchyMode.h
// Author : Andy Tate
// Date   : 22-May-2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif   // ifdef ASURA_USE_PRAGMA_ONCE

#ifndef __TOOLS_FACIALANIMATION_ANIMATIONHANDLER_HIERARCHYMODE_H__
#define __TOOLS_FACIALANIMATION_ANIMATIONHANDLER_HIERARCHYMODE_H__

#if defined(ASURA_USE_FACIAL_ANIMATION_SYSTEM)

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "FacialAnimation/Asura_FacialAnimation_AnimationHandler.h"


////////////////////////////////////////////////////////////////////////////////
// Forward class declarations...
////////////////////////////////////////////////////////////////////////////////

class Tools_FacialAnimation_Face;


////////////////////////////////////////////////////////////////////////////////
// Class declaration...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Class        : Tools_FacialAnimation_AnimationHandler_HierarchyMode
// Author       : Andy Tate
// Date         : 22-May-2008
//
// Description  : Class used to allow facial-animations to be manipulated in
//				  hierarchy-mode in Tools.
////////////////////////////////////////////////////////////////////////////////

class Tools_FacialAnimation_AnimationHandler_HierarchyMode : public Asura_FacialAnimation_AnimationHandler
{
public:
	// Public functions...
	Tools_FacialAnimation_AnimationHandler_HierarchyMode(const Asura_Hash_ID uFaceHash);
	virtual ~Tools_FacialAnimation_AnimationHandler_HierarchyMode();

	// Overridden functions...
	virtual	void	Update(const float fTimeStep);

	//Plays a facial animation that is associated with a standard Asura_Hierarcy_Anim , and so
	//should have the timer kept in sync
	void HierarchyMode_PlayFacialAnimation( Asura_Hash_ID uAnimHash, bool bLooped = false);
	void HierarchyMode_StopFacialAnimation();


protected:
	// Protected variables...

	// Protected functions...


private:
	// Private typedefs...
	typedef Asura_FacialAnimation_AnimationHandler PARENT;

	// Private variables...
	Asura_Hash_ID	m_uFaceHash;	// The hash-ID of the face to use when handling facial-animations in hierarchy mode.

	Asura_Hash_ID m_uAnimHash; //The current facial/body animation

	// Private functions...
	Tools_FacialAnimation_AnimationHandler_HierarchyMode(const Tools_FacialAnimation_AnimationHandler_HierarchyMode& xOther);

	Tools_FacialAnimation_AnimationHandler_HierarchyMode&	operator=(const Tools_FacialAnimation_AnimationHandler_HierarchyMode& xOther);

};   // End of class 'Tools_FacialAnimation_AnimationHandler_HierarchyMode'.

#endif	//defined(ASURA_USE_FACIAL_ANIMATION_SYSTEM)

#endif   // ifndef __TOOLS_FACIALANIMATION_ANIMATIONHANDLER_HIERARCHYMODE_H__


/// End of file. ///
