
///////////////////////////////////////////////////////////////////////////////
//
// File   : Tools_FacialAnimation_LipsyncConversion.cpp
// Author : Andy Tate
// Date   : 6-Aug-2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Include files...
////////////////////////////////////////////////////////////////////////////////

#include "Core/Asura.h"

#if defined(ASURA_USE_FACIAL_ANIMATION_SYSTEM)

// This file's header...
#include "FacialAnimation/Tools_FacialAnimation_LipsyncConversion.h"

// Tools header-files...
#include "FacialAnimation/Tools_FacialAnimation_System.h"


////////////////////////////////////////////////////////////////////////////////
// Constant declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Static variable declarations...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Private functions...
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
// Protected functions...
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
// Function     : Tools_FacialAnimation_LipsyncConversion::BeginAnimationCreation
// Author       : Andy Tate
// Date         : 6-Aug-2008
////////////////////////////////////////////////////////////////////////////////

Tools_FacialAnimation_FaceAnimation* Tools_FacialAnimation_LipsyncConversion::BeginAnimationCreation(const char* szFaceTypeName,
																									 const char* szBaseFacePoseName,
																									 const char* szWAVFilename) const
{
	const Asura_String						xAnimationName(Tools_FacialAnimation_System::ConvertSoundFilenameToFaceAnimationName(szWAVFilename));

	const char*								szAnimationName	= xAnimationName.GetString();
	Tools_FacialAnimation_FaceAnimation*	pxAnimation		= Tools_FacialAnimation_System::FindAnimation(szAnimationName);

	if(pxAnimation != NULL)
	{
		Tools_FacialAnimation_System::DestroyAnimation(szAnimationName);
	}

	// Create (and initialise) the new animation...
	pxAnimation	= Tools_FacialAnimation_System::CreateAnimation(szFaceTypeName, szBaseFacePoseName, szAnimationName, szWAVFilename);
	return(pxAnimation);
}

/// End of function 'Tools_FacialAnimation_LipsyncConversion::BeginAnimationCreation'. ///



////////////////////////////////////////////////////////////////////////////////
// Function     : Tools_FacialAnimation_LipsyncConversion::EndAnimationCreation
// Author       : Andy Tate
// Date         : 7-Aug-2008
////////////////////////////////////////////////////////////////////////////////

void Tools_FacialAnimation_LipsyncConversion::EndAnimationCreation(Tools_FacialAnimation_FaceAnimation& xAnimation) const
{
	xAnimation.ConvertToMuscleGroupAnimation();
	xAnimation.CreateAsuraFaceAnimation();
}

/// End of function 'Tools_FacialAnimation_LipsyncConversion::EndAnimationCreation'. ///



////////////////////////////////////////////////////////////////////////////////
// Public functions...
////////////////////////////////////////////////////////////////////////////////

#endif	//defined(ASURA_USE_FACIAL_ANIMATION_SYSTEM)


/// End of file. ///
