//
// Tools_LZX_Decoder.h
//
// Created by Richard Rice - 08/01/2008
// 
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//


#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif


#ifndef _TOOLS_LZX_DECODER_H_
#define _TOOLS_LZX_DECODER_H_
#ifdef ASURA_TOOLS

#include "Core/Asura_String.h"

//Class for decoding the LZX compression used by the Xbox360 exports.
//Since I haven't had much luck with getting the files using transparent compression
//decompressed in code , this just uses the standalone utility to decompress to a temporary
//file , and loads that instead.


class Tools_LZX_Decoder 
{

public:

    Tools_LZX_Decoder();
    ~Tools_LZX_Decoder();

	//Start decompression on a file
    void Begin( Asura_Handle iFileHandle);

	//Get the original uncompressed file size
    u_int GetDecompressedSize() const { return m_uUncompressedSize; }

	//Decompress the new uNumBytes to the destination buffer.
	//returns the number actually decompressed
    u_int Decompress( void* pDest, u_int uNumBytes );

	//End decompression and cleanup
    void End();

private:
	HANDLE m_pFile;

	u_int m_uUncompressedSize;
	Asura_String m_xTempFileName;
};




#endif //ASURA_TOOLS
#endif //_TOOLS_LZX_DECODER_H_
