//
// Tools_GUIMenu_Audio_Overlay.h
//
// Created by Steven Keen - 12/04/2007
// 
// Copyright (C) 2007 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __TOOLS_GUIMENU_AUDIO_OVERLAY__
#define __TOOLS_GUIMENU_AUDIO_OVERLAY__

#ifdef ASURA_USE_GUI_MENU_SYSTEM
#include "Interface/Asura_Dialog.h"
#include "Interface/Asura_Overlay.h"


#include "Misc/list_tem.hpp"

class Tools_GUIMenu_Audio_Overlay : public Asura_Overlay
{
private :
	Tools_GUIMenu_Audio_Overlay();
	~Tools_GUIMenu_Audio_Overlay();

public :
	static void EditAudio( void);
	static void CloseOverlay( void);


	//overlay callback functions
	//defines for routeing static callback functions to non-static versions
#define OVERLAY_VOID_CALLBACK(__FnName)\
	static void __FnName(int iThis){((Tools_GUIMenu_Audio_Overlay*)iThis)->__FnName();}\
	void __FnName();

#define OVERLAY_BOOL_CALLBACK(__FnName)\
	static bool __FnName(int iThis){return ((Tools_GUIMenu_Audio_Overlay*)iThis)->__FnName();}\
	bool __FnName();


	OVERLAY_VOID_CALLBACK(SetNavigateEvent)
	OVERLAY_VOID_CALLBACK(SetAcceptEvent)
	OVERLAY_VOID_CALLBACK(SetCancelEvent)
	OVERLAY_VOID_CALLBACK(SetValueChangeEvent)
	OVERLAY_VOID_CALLBACK(SetFailEvent)
	OVERLAY_VOID_CALLBACK(SetCursorNavigateEvent)

	#undef OVERLAY_VOID_CALLBACK
	#undef OVERLAY_BOOL_CALLBACK

private :
	virtual void PerFrameUpdate(void);
	virtual void ShowOverlay();
	
	Asura_Hash_ID ChooseAudioEvent( Asura_Hash_ID uInitialID);



	class Asura_Subwindow_Dialog* m_pxSubwindow;


	static Asura_Vector_2 s_xOverlayPosition;
	static Tools_GUIMenu_Audio_Overlay* s_pxThis;


	static bool		s_bDataChanged;
	static float	s_fOffsetX;

};
#endif // ASURA_USE_GUI_MENU_SYSTEM
#endif //__TOOLS_GUIMENU_AUDIO_OVERLAY__


