//
// Tools_GUIMenu_Widget_Group.h
//
// Created by Richard Rice - 05/12/2006
// 
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//


#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif


#ifndef _TOOLS_GUIMENU_WIDGET_GROUP_H_
#define _TOOLS_GUIMENU_WIDGET_GROUP_H_
#ifdef ASURA_USE_GUI_MENU_SYSTEM

#include "GUIMenu/Tools_GUIMenu_Widget_Base.h"


class Asura_GUIMenu_Widget_Group;

class Tools_GUIMenu_Widget_Group : public Tools_GUIMenu_Widget_Base
{
	typedef Tools_GUIMenu_Widget_Base PARENT;
	friend class Tools_GUIMenu_PickItem_AddWidgetToGroup;

public :
	Tools_GUIMenu_Widget_Group(Asura_GUIMenu_Widget_Group* pxAsuraGroup,Tools_GUIMenu_Root* pxToolsParent);

	virtual void OnSelection();
	virtual void OnDeselection();

	virtual void Update();

	virtual void ChangeParent(Tools_GUIMenu_Root* pxParent);

	virtual bool IsValidChildType(int iItemType) const;

	void LinkGroup(Tools_GUIMenu_Widget_Group* pxGroup);
	
	bool CheckForCyclicLink(Tools_GUIMenu_Widget_Group *pxGroup);

	Asura_Hash_ID	GetAsuraGroupID();

protected :
	virtual void AddBasicOverlayControls(Asura_Overlay* pxOverlay,Asura_Vector_2& xOffset);
	virtual void AddOverlayControls(Asura_Overlay* pxOverlay,Asura_Vector_2& xOffset);

	#define OVERLAY_VOID_CALLBACK(__FnName)\
	static void __FnName(int iThis){((Tools_GUIMenu_Widget_Group*)iThis)->__FnName();}\
	virtual void __FnName();
	#define OVERLAY_BOOL_CALLBACK(__FnName)\
	static bool __FnName(int iThis){return ((Tools_GUIMenu_Widget_Group*)iThis)->__FnName();}\
	virtual bool __FnName();

	OVERLAY_VOID_CALLBACK(AddWidget);
	OVERLAY_VOID_CALLBACK(ChooseGroupToLink);
	OVERLAY_VOID_CALLBACK(RemoveLink);

	OVERLAY_BOOL_CALLBACK(HasLinkedGroup);

	#undef OVERLAY_VOID_CALLBACK
	#undef OVERLAY_BOOL_CALLBACK

	void AddWidget(Tools_GUIMenu_Root* pxItem);

private :
	static void CreateWidget(int iType);
	static bool CanCreateWidget();

	Asura_GUIMenu_Widget_Group* m_pxAsuraGroup;

	static Tools_GUIMenu_Widget_Group* s_pxSelectedGroup;

};




#endif //ASURA_USE_GUI_MENU_SYSTEM
#endif //_TOOLS_GUIMENU_WIDGET_GROUP_H_
