//
// Tools_GUIMenu_Widget_ProgressBar.h
//
// Created by Richard Rice - 25/01/2007
// 
// Copyright (C) 2007 Rebellion , All Rights Reserved.
//


#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif


#ifndef _TOOLS_GUIMENU_WIDGET_PROGRESSBAR_H_
#define _TOOLS_GUIMENU_WIDGET_PROGRESSBAR_H_
#ifdef ASURA_USE_GUI_MENU_SYSTEM

#include "Tools_GUIMenu_Widget_Base.h"
#include "GUIMenu/Asura_GUIMenu_Widget_ProgressBar.h"
#include "GUIMenu/Asura_GUIMenu_Menu_Page.h"
#include "Interface/Asura_CommandConsole.h"

class Asura_GUIMenu_Widget_ProgressBar;

class Tools_GUIMenu_Widget_ProgressBar : public Tools_GUIMenu_Widget_Base
{
typedef Tools_GUIMenu_Widget_Base PARENT;

public :
	Tools_GUIMenu_Widget_ProgressBar(Asura_GUIMenu_Widget_ProgressBar* pxAsuraProgressBar,Tools_GUIMenu_Root* pxToolsParent);
	~Tools_GUIMenu_Widget_ProgressBar( void);

	virtual void Update( void);

	virtual void CalculateExtents();

	virtual void NotifyParentOnDeselection( void);

	virtual void AddToPreviewOverlay() const;

protected:
	virtual void AddOverlayControls(Asura_Overlay* pxOverlay,Asura_Vector_2& xOffset);
	virtual void UpdateReferences(Asura_Hash_ID uOldID,Asura_Hash_ID uNewID,bool bPostCopy);
//	virtual void UpdateOverlayControls(Asura_Overlay* pxOverlay);
	virtual u_int GetFlagsToEdit() const;
	virtual const char* GetLocalDataFlagName(u_int uFlagValue) const;
	virtual void Copy(const Tools_GUIMenu_Root* pxSource);

private:
	void		 AddImageManipulationControls(Asura_Overlay* pxOverlay,Asura_Vector_2& xOffset);
	void		 BuildImageManipulationList( void);
	int			 FindIndexMatchforImageName( Asura_Hash_ID uHashID);
	Asura_GUIMenu_Root* FindImageElementMatchFromName( const Asura_Char* pcName);

private :

	#define OVERLAY_BOOL_CALLBACK(__FnName)\
	static bool __FnName(int iThis){return ((Tools_GUIMenu_Widget_ProgressBar*)iThis)->__FnName();}\
	bool __FnName();

	OVERLAY_BOOL_CALLBACK(CanEditMinimum)
	OVERLAY_BOOL_CALLBACK(CanEditMaximum)
	OVERLAY_BOOL_CALLBACK(CanEditStep)
	OVERLAY_BOOL_CALLBACK(CanEditOverlays)

	#undef OVERLAY_BOOL_CALLBACK



	Asura_GUIMenu_Widget_ProgressBar*	m_pxAsuraProgressBar;

	float m_fEditMin;
	float m_fEditMax;
	float m_fEditStep;

	bool m_bChangedMin;
	bool m_bChangedMax;
	bool m_bChangedStep;

	bool m_bChangedConsoleVar;

	bool m_abOverlayImageChanged[ASURA_GUIMENU_MAX_PROGRESSBAR_IMAGE_OVERLAYS];
	int	 m_aiOverlayImageIndex[ASURA_GUIMENU_MAX_PROGRESSBAR_IMAGE_OVERLAYS];
	int	 m_aiOverlayAxisIndex[ASURA_GUIMENU_MAX_PROGRESSBAR_IMAGE_OVERLAYS];

	const Asura_Char**					m_ppcOverlayImageOptions;
	u_int								m_uOverlayImageCount;
};




#endif //ASURA_USE_GUI_MENU_SYSTEM
#endif //_TOOLS_GUIMENU_WIDGET_PROGRESSBAR_H_
