//
// Tools_GUIMenu_Widget_Slider.h
//
// Created by Richard Rice - 05/12/2006
// 
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//


#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif


#ifndef _TOOLS_GUIMENU_WIDGET_SLIDER_H_
#define _TOOLS_GUIMENU_WIDGET_SLIDER_H_
#ifdef ASURA_USE_GUI_MENU_SYSTEM

#include "GUIMenu/Tools_GUIMenu_Widget_Base.h"


class Asura_GUIMenu_Widget_Slider;

class Tools_GUIMenu_Widget_Slider : public Tools_GUIMenu_Widget_Base
{
	typedef Tools_GUIMenu_Widget_Base PARENT;

public :
	Tools_GUIMenu_Widget_Slider(Asura_GUIMenu_Widget_Slider* pxAsuraSlider,Tools_GUIMenu_Root* pxToolsParent);

	virtual void CheckRequiredReferences();

	virtual void Update( void);

	virtual void AddToPreviewOverlay() const;

protected :
	virtual void InitialiseNewItem();
	virtual u_int GetFlagsToEdit() const;
	virtual const char* GetLocalDataFlagName(u_int uFlagValue) const;

	virtual void AddOverlayControls(Asura_Overlay* pxOverlay,Asura_Vector_2& xOffset);

private:
	#define OVERLAY_VOID_CALLBACK(__FnName)\
	static void __FnName(int iThis){((Tools_GUIMenu_Widget_Slider*)iThis)->__FnName();}\
	void __FnName();

	#define OVERLAY_BOOL_CALLBACK(__FnName)\
	static bool __FnName(int iThis){return ((Tools_GUIMenu_Widget_Slider*)iThis)->__FnName();}\
	bool __FnName();

	OVERLAY_VOID_CALLBACK(SelectAudioEvent)
	OVERLAY_BOOL_CALLBACK(CanEditNumSteps)
	OVERLAY_BOOL_CALLBACK(CanEditButtonFlags)

	#undef OVERLAY_VOID_CALLBACK
	#undef OVERLAY_BOOL_CALLBACK

private :
	Asura_GUIMenu_Widget_Slider* m_pxAsuraSlider;

	bool	m_bDataChanged;
	
	bool	m_bNumStepsChanged;
	u_int	m_uNumSteps;

};




#endif //ASURA_USE_GUI_MENU_SYSTEM
#endif //_TOOLS_GUIMENU_WIDGET_SLIDER_H_
