//
// Tools_Hierarchy_BodyPart_System.h
//
// Created by Richard Rice - 10/10/02
// 
// Copyright (C) 2002 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __TOOLS_HIERARCHY_BODYPART_SYSTEM_H__
#define __TOOLS_HIERARCHY_BODYPART_SYSTEM_H__

#include "Core/Asura_NameTree.h"

class Tools_EnumerationReader;


class Tools_Hierarchy_BodyPart_System
{
	public :
		Tools_Hierarchy_BodyPart_System();
		virtual ~Tools_Hierarchy_BodyPart_System();

		static void ReadIniFile(){Asura_Assert(s_pxThis,"");s_pxThis->_ReadIniFile();}
		
		static void AddAnimation(const char* pszName);
		static int GetBodyPartEnum(const char* pszName);
		static int GetDeathTypeEnum(const char* pszName);

	private :
		virtual const char* GetIniFileName(){return "ToolsIniFiles\\HierarchyBodyPart.ini";}
		virtual const char* GetEnumFileName(){return "ToolsIniFiles\\Asura_Hierarchy_BodyPart_ProjectEnumeration.h";}

		void _ReadIniFile();

		Tools_EnumerationReader* m_pxBodyPartEnum;
		Tools_EnumerationReader* m_pxDeathTypeEnum;
		

	public :
		static Tools_Hierarchy_BodyPart_System* s_pxThis;

};


#endif //__TOOLS_HIERARCHY_BODYPART_SYSTEM_H__
