// Tools_SkinLOD.h
//
// Created by Richard Rice - 30/08/2002
// 
// Copyright (C) 2002 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef _TOOLS_SKINLOD_H_
#define _TOOLS_SKINLOD_H_

#include "MeshProcessing/Tools_VIPM.h"

class Tools_SkinLOD
{
public :
	Tools_SkinLOD(class Asura_Hierarchy_Skin* pxSkin);
	~Tools_SkinLOD();

	int GetMaxPolygons(){return m_iNumberOfTriangles;}
	int SetNumberOfPolygons(int iDesiredPolygons);

	int GenerateSkin(int iDesiredPolygons,float fDistance);

private :
	bool GenerateMesh(class Asura_Mesh*& pxNewMesh,int*& piVertConv);

	Asura_Mesh* m_pxMesh;
	Asura_Hierarchy_Skin* m_pxSkin;
		
	int m_iMaterialID;
	int m_iNumberOfTriangles;
	int m_iNumberOfVertices;

	int* m_piOriginalVertexIndices;
	int* m_piOriginalPolygonIndices;

#if !defined(ASURA_PC_DISABLE_PRESM3_SMOOTH_SKIN_RENDERER) || !ASURA_PC_DISABLE_PRESM3_SMOOTH_SKIN_RENDERER
	Tools_VIPM m_xVipm;
#endif
};



#endif //_TOOLS_SKINLOD_H_
