//
// Tools_Overlay_EnlargedGraph.h
//
// Created by RAR - 05/02/2009 
//
// Copyright (C) 2009 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif

#ifndef __TOOLS_OVERLAY_ENLARGEDGRAPH_H__
#define __TOOLS_OVERLAY_ENLARGEDGRAPH_H__

#include "Interface/Asura_Overlay.h"

//Class used by the Asura_Graph_Dialog for creating an overlay containing a larger resizable
//version of the graph

class Tools_Overlay_EnlargedGraph : public Asura_Overlay
{
public :
	~Tools_Overlay_EnlargedGraph();

	//Creates the overlay , adding the copy of the graph dialog to it
	static void Create(const Asura_Dialog* pxGraphSource, Asura_Dialog* pxGraphCopy);
	//Closes the overlay if it was created using the specific dialog
	static void CloseOverlay(const Asura_Dialog* pxGraphSource);


	void PerFrameUpdate(void);

private :
	Tools_Overlay_EnlargedGraph(const char* szName, const Asura_Dialog* pxGraphSource, Asura_Dialog* pxGraphCopy);
	
	static void LoadSettings();
	static void SaveSettings();
	static void LoadOrSaveSettings(int iMode);


	Asura_Dialog* m_pxGraphDialog;
	const Asura_Dialog* m_pxGraphSource;

	
	static Asura_Vector_2 s_xOverlayPosition;
	static Asura_Vector_2 s_xGraphSize;

};


#endif //__TOOLS_OVERLAY_ENLARGEDGRAPH_H__
