//
// Tools_Mode_LOD.cpp
//
// Created by Richard Rice - 26/09/2002
// 
// Copyright (C) 2002 Rebellion, All Rights Reserved.
//

#include "Core/Asura.h"
#include "Debugging/Asura_Assert.h"

#include "LevelOfDetail/Tools_Mode_LOD.h"

#include "Rendering/Asura_Module.h"

#include "Mesh/Asura_Mesh.h"

#include "Objects/Tools_Object_System.h"
#include "LevelOfDetail/Tools_Object_LOD.h"
#include "Load&Save/Tools_SaveAsura.h"
#include "Misc/Tools_Render_Options.h"


void Tools_Mode_LOD::Initialise()
{
	//enable object system
	Tools_Object_System::EnableAllControls(true);

	Tools_Render_Options::HideEnvironment = true;


	//create LOD object for every non-detaillevel mesh
	for(int i=0;i<Asura_Module_System::GetNumberOfModules();i++)
	{
		Asura_Mesh* pxMesh = Asura_Module_System::GetMeshForModule(i);
		if(pxMesh && !pxMesh->IsDetailMesh())
		{
			Asura_Vector_3 xPos;
			Asura_Module_System::GetPositionOfModule(i,xPos);
			
			new Tools_Object_LOD(pxMesh,&xPos);
		}
	}
}

void Tools_Mode_LOD::Shutdown()
{
	Tools_Render_Options::HideEnvironment = false;

	//delete all the objects
	Tools_Object_System::DeleteAllModeSpecific();

	//and stop the object system
	Tools_Object_System::EnableAllControls(false);
}

void Tools_Mode_LOD::Update()
{
}

void Tools_Mode_LOD::RenderUI()
{
}




bool Tools_Mode_LOD::IsModified()
{
	return Tools_SaveAsura::IsMainFileModified();
}

void Tools_Mode_LOD::QuickSave()
{
	Tools_SaveAsura::QuickSaveFile();
}
