//
// Tools_Corona_Object.h
//
// Created by Richard Rice - 21/02/2003
// 
// Copyright (C) 2003 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef _TOOLS_CORONA_OBJECT_H_
#define _TOOLS_CORONA_OBJECT_H_

#include "Objects/Tools_Object.h"
#include "SpecialFX/Asura_StaticCorona_System.h"

class Tools_Corona_Object : public Tools_Object
{
public :
	Tools_Corona_Object(int iCoronaIndex);
	~Tools_Corona_Object();

	virtual void UpdatePositionInAsuraData(bool /*bUpdateLinkedObjects*/);

	virtual const char* GetName(){return m_xName.GetString();}
	virtual const char* GetTypeDescription(){return "Corona";}

	virtual void Destroy();
	virtual void OnSelection();
	virtual void OnDeselection();
	virtual void UpdateWhileSelected();
	virtual void Update();
	virtual bool IsSelectable();
	virtual bool IsHidden();
 	virtual void PrintInfo(float& x,float& y);


	static void _CreateCorona();
	static Tools_Corona_Object* CreateCorona();

	static Tools_Corona_Object* GetCoronaObjectFromID(u_int uID);


	static const List<Tools_Corona_Object*>* GetList(){return &s_xCoronaList;}

	void SetModified() const;

protected :

	virtual bool GetParameter(Asura_Hash_ID uParamID,class Tools_Parameter* pxParam) const;
	virtual bool SetParameter(Asura_Hash_ID uParamID,const class Tools_Parameter* pxParam);

private :
	void CreatePropertiesOverlay();

	void UpdateToolsName();


	static void _SelectTexture(int iThis){((Tools_Corona_Object*)iThis)->SelectTexture();}
	void SelectTexture();

	static void Rename(int iThis){((Tools_Corona_Object*)iThis)->Rename();}
	void Rename();



	// Copy/paste support
	virtual void Copy(const Tools_Object* pxObject);
	virtual bool CanBeCopied() const {return true;}
	virtual Tools_Object* CreateObjectOfThisType() const;



	Asura_String m_xName;
	int m_iCoronaIndex;
	bool m_bChanged;

	Asura_Guid m_uTemplateGuid;
	u_int m_uID;

	Asura_StaticCorona m_xUserCorona;

	static List<Tools_Corona_Object*> s_xCoronaList;

};


#endif //_TOOLS_CORONA_OBJECT_H_
