//
// Tools_GlobalIllumination_LightProbe.h
//
// Created by KJFL - 2004-06-18 17:29:29
//
// Copyright (C) 2004 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif

#ifndef __TOOLS_GLOBALILLUMINATION_LIGHTPROBE_H__
#define __TOOLS_GLOBALILLUMINATION_LIGHTPROBE_H__

#include "Core/Asura_Hash.h"
#include "Core/Asura_String.h"

#include "Objects/Tools_Object.h"

struct Tools_LightProbe_FavoriteShape;

class Tools_GlobalIllumination_LightProbe : public Tools_Object
{
	public :
		Tools_GlobalIllumination_LightProbe(const Asura_Vector_3* pxPosition,const Asura_Matrix_3x3* pxOrientaiton);
		~Tools_GlobalIllumination_LightProbe();

		//virtual void Render();
		virtual bool UseLighting(){return true;}

		virtual const char* GetName(){return "GI Light Probe";}
		virtual const char* GetTypeDescription(){return "GI Light Probe";}

		virtual void OnSelection();
		virtual void OnDeselection();
		virtual void UpdateWhileSelected();
		virtual bool ShouldRenderSelectionOutline(){return false;}


		//loads list of favourite shapes from ini file
		static void LoadFavoriteShapeList();
		//clears list of favourite shapes
		static void DeleteFavoriteShapeList();
		
	private :
		void CreateOverlay();
		void DeleteOverlay();

		static void ChooseSkin(int iThis){((Tools_GlobalIllumination_LightProbe*)iThis)->ChooseSkin();}
		void ChooseSkin();

		static void ChooseAnim(int iThis){((Tools_GlobalIllumination_LightProbe*)iThis)->ChooseAnim();}
		void ChooseAnim();

		static void ChooseShape(int iThis){((Tools_GlobalIllumination_LightProbe*)iThis)->ChooseShape();}
		void ChooseShape();

		void ClearShapeAndAnim();


		//save list of favourite shapes to ini file
		void SaveFavoriteShapeList();

		static void BuildFavoriteNameArray();
		
		//work what the fav shape index should be based on the current shape/animation
		void DetermineCurrentFavoriteShapeIndex();

		static void AddToFavorite(int iThis){((Tools_GlobalIllumination_LightProbe*)iThis)->AddToFavorite();}
		void AddToFavorite();

		static void DeleteFromFavorite(int iThis){((Tools_GlobalIllumination_LightProbe*)iThis)->DeleteFromFavorite();}
		void DeleteFromFavorite();

		void SetShapeOrSkin(const Tools_LightProbe_FavoriteShape* pxFav);

		Asura_Hash_ID m_uShapeID;

		int m_iFavSelection;
		bool m_bFavSelectionChanged;

		static List<Tools_LightProbe_FavoriteShape*> s_xFavList;
		static int s_iFavNamesSize;
		static const char** s_ppszFavNames;

		static Asura_Vector_2 s_xOverlayPosition;

};

struct Tools_LightProbe_FavoriteShape
{
	Tools_LightProbe_FavoriteShape()
	{m_uShapeID = m_uSkinID = m_uAnimID = ASURA_HASH_ID_UNSET;}

	Asura_String m_xName;
	Asura_Hash_ID m_uShapeID;
	Asura_Hash_ID m_uSkinID;
	Asura_Hash_ID m_uAnimID;
};


#endif//__TOOLS_GLOBALILLUMINATION_LIGHTPROBE_H__
