//
// Tools_PhotonMapping_LightSource.cpp
//
// Created by KJL - 15/01/2004 12:56:24
//
// Copyright (C) 2004 Rebellion, All Rights Reserved.
//

#include "Core/Asura.h"

// This file's header.
#include "Tools_PhotonMapping_LightSource.h"

// Stdlib independent.
#include <stdlib.h>

// Tools independent
#include "EntityTemplate/Tools_EntityTemplate_System.h"

static float g_fOneOverNumberOfSamples;


// KJFL - 2004-06-08 11:48:54 - need to replace this fn call
// check current asura stuff is up-to-scratch
static float randf(void)
{
	float f = ((float)rand())/((float)RAND_MAX);

	return f;
}

u_int Tools_PhotonMapping_TemplateData::s_uNextID = 1;

void Tools_PhotonMapping_LightSource::SetStratificationLevels(u_int uNumberOfSamples)
{
	g_fOneOverNumberOfSamples  = 1.0f/(float)uNumberOfSamples;
}

void Tools_PhotonMapping_LightSource::GetStratifiedPhotonPositionAndDirection(Asura_Vector_3& xPosition, Asura_Vector_3& xDirection, u_int uX, u_int uY)
{
	if (m_bParallel)
	{
	}
	else
	{
		xPosition = m_xPosition;

		float r = randf();
		float s = randf();

		float fX = ((float)uX+r)*g_fOneOverNumberOfSamples;
		float fY = ((float)uY+s)*g_fOneOverNumberOfSamples;

		float fTheta = 2.0f * Asura_Maths::ArcCosine(Asura_Maths::Sqrt( Asura_Maths::Max(0.0f, 1.0f-fX) ));
		float fPhi = 2.0f * Asura_Maths::Pi*fY;

		float fSineTheta = Asura_Maths::Sine(fTheta);
		float fCosineTheta = Asura_Maths::Cosine(fTheta);
		float fSinePhi = Asura_Maths::Sine(fPhi);
		float fCosinePhi = Asura_Maths::Cosine(fPhi);

		xDirection.x = fSineTheta*fCosinePhi;
		xDirection.y = fSineTheta*fSinePhi;
		xDirection.z = fCosineTheta;

	}

}

float Tools_PhotonMapping_LightSource::GetStratifiedPhotonEnergy(void)
{
	return g_fOneOverNumberOfSamples * g_fOneOverNumberOfSamples;
}


void Tools_PhotonMapping_LightSource::ApplyChangesForTemplateInstance(class Tools_EntityTemplateInstance* pxInstance)
{
	m_xPosition = pxInstance->TransformPosition(m_xPosition);
	m_xOrientation = pxInstance->TransformMatrix(m_xOrientation);
}
