//
// Tools_CharacterProcessor_NormalMapped.h
//
// Created by KJFL - 2004-07-26 16:08:29
//
// Copyright (C) 2004 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif

#ifndef __TOOLS_CHARACTERPROCESSOR_NORMALMAPPED_H__
#define __TOOLS_CHARACTERPROCESSOR_NORMALMAPPED_H__


#include "Core/Asura_Maths.h"
class Asura_Mesh;
class Asura_Hierarchy_Skin;

class Tools_CharacterProcessor_Vertex_NormalMapped
{
	public:
		Asura_Vector_3	m_xPosition;
		Asura_Vector_3	m_xNormal;
		float			m_fU;
		float			m_fV;
		float			m_afIndex[4];
		float			m_afWeight[4];
		Asura_Vector_3	m_xTangent;
		Asura_Vector_3	m_xBinormal;
		u_int			m_uColour;

		inline bool operator == ( const Tools_CharacterProcessor_Vertex_NormalMapped& v) const
		{
			return((m_xPosition == v.m_xPosition)
				&& (m_xNormal == v.m_xNormal)
				&& (m_fU == v.m_fU)
				&& (m_fV == v.m_fV)
//				&& (m_xTangent == v.m_xTangent)
//				&& (m_xBinormal == v.m_xBinormal)
				&& (m_afIndex[0] == v.m_afIndex[0])
				&& (m_afIndex[1] == v.m_afIndex[1])
				&& (m_afIndex[2] == v.m_afIndex[2])
				&& (m_afIndex[3] == v.m_afIndex[3])
				&& (m_afWeight[0] == v.m_afWeight[0])
				&& (m_afWeight[1] == v.m_afWeight[1])
				&& (m_afWeight[2] == v.m_afWeight[2])
				&& (m_afWeight[3] == v.m_afWeight[3])
				&& (m_uColour == v.m_uColour)
			  );
		}



};

class Tools_CharacterProcessor_Strip_NormalMapped
{
	public:
		
		Tools_CharacterProcessor_Strip_NormalMapped()
		{
			m_pxVertices = 0;
			m_pusIndices = 0;
		}
		
		~Tools_CharacterProcessor_Strip_NormalMapped()
		{
			delete [] m_pxVertices;
			delete [] m_pusIndices;
		}

		u_int											m_uNumberOfIndices;
		u_int											m_uNumberOfTriangles;
		u_int											m_uNumberOfVertices;
														
		int												m_iMaterialID;

		Tools_CharacterProcessor_Vertex_NormalMapped*	m_pxVertices;
		u_short*										m_pusIndices;
		bool											m_bHasColour;
};



class Tools_CharacterProcessor_NormalMapped
{
	public:
		static bool Initialise(Asura_Mesh* mesh,const Asura_Hierarchy_Skin* skin);
		static void Shutdown(void);

		static const Tools_CharacterProcessor_Strip_NormalMapped* GetProcessedStrip();
		static u_int GetTotalNumberOfVertices(void);
		static u_int GetTotalNumberOfIndices(void);
		
		static Tools_CharacterProcessor_Strip_NormalMapped*	s_pxProcessedStrip;
		static u_int										s_uTotalNumberOfVertices;
		static u_int										s_uTotalNumberOfIndices;
		static bool											s_bBeenInitialised;
	private:

		static void CalculateTangentSpaceVectors(const class Asura_Mesh* pxMesh, u_int uPoly, Asura_Vector_3& xTangent, Asura_Vector_3& xBinormal);
};


#endif//__TOOLS_CHARACTERPROCESSOR_NORMALMAPPED_H__
