//////////////////////////////////////////////////////////////////////////////
//
// Tools_MeshSubdivision.cpp
//
// Copyright (c) 2003 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "Core/Asura.h"

// This file's header.
#include "MeshProcessing/Tools_MeshSubdivision.h"

// Engine independent.
#include "Core/Asura_TextureManagement.h"
#include "Rendering/Asura_Bicubic_Patch.h"

// Tools independent.
#include "Load&Save/LevelExport/Tools_Level_Export.h"
#include "Misc/Tools_Render_Options.h"

// T Y P E S /////////////////////////////////////////////////////////////////

//struct TextureDimensions
//{
//    u_int uWidth;  // UINT_MAX => not calculated yet.
//    u_int uHeight;
//};

// G L O B A L S /////////////////////////////////////////////////////////////

//static TextureDimensions g_axTextureDimensions[ASURA_MAX_NO_OF_TEXTURES];

// C L A S S   I M P L E M E N T A T I O N S /////////////////////////////////

bool Tools_MeshSubdivision::ShouldForceFlatSubdivision( const Asura_Bicubic_Patch* pxPatch,
                                                        const Asura_Bicubic_Patch_Vertex* pxV1,
                                                        const Asura_Bicubic_Patch_Vertex* pxV2,
                                                        const Asura_Bicubic_Patch_Vertex* pxMidpoint )
{
    // (MP - 12.02.2003) This code unfortunately generates a huge number of
    // polys. I assume this is because our texel density is so high. It may
    // be worth experimenting to see if subdividing to ensure polys use no
    // more than a texture page (ie. a texture area of 128x64, or 126x62 if
    // taking bilinear into account) is a win.
    return false;

    // (MP - 12.02.2003) TODO: this code will currently produce T-junctions
    // due to adjacent polys having differing texture densities.

//    static bool bInitd = false;
//    if( !bInitd )
//    {
//        for( u_int u = 0; u < ASURA_MAX_NO_OF_TEXTURES; ++u )
//        {
//            g_axTextureDimensions[u].uWidth = UINT_MAX;
//        }
//        bInitd = true;
//    }
//
//    if( TOOLS_SUBDIVIDE_NEARWAYPOINTS != Tools_Render_Options::GetSubdivisionMode() )
//    {
//        return false;
//    }
//
//    if( !Tools_Render_Options::ShouldSubdivideForPS2TextureSize() )
//    {
//        return false;
//    }
//
//    TextureDimensions& xTexDims = g_axTextureDimensions[pxPatch->TextureIndex];
//    if( UINT_MAX == xTexDims.uWidth )
//    {
//        if( !Tools_Level_Export::GetTIM2Proportions(pxPatch->TextureIndex, &xTexDims.uWidth, &xTexDims.uHeight) )
//        {
//            return false;
//        }
//    }
//
//    // Assuming we're using 8-bit textures (which is currently the case for
//    // everything on the environment) we want to limit the area of the
//    // texture used to 62x30 texels. Here's why:
//    //
//    //     - The texture cache on the PS2 is a single texture page, ie. 8Kb.
//    //       For 8-bit textures this is equivalent to 128x64 texels.
//    //
//    //     - However, due to the arrangement of blocks within a page,
//    //       performance will suffer if we use more than a quarter of a page.
//    //       (Further details in the GS Masterclass document available from
//    //       ps2-pro.com.)
//    //
//    //     - Furthermore, bilinear sampling, which we're currently using on
//    //       the PS2, may lead to data a single texel outside of the
//    //       specified region to be sampled. To counter this, we reduce the
//    //       size allowed by 2 pixels in each dimension.
//    float fDeltaU = Asura_Maths::Abs( (pxV2->u - pxV1->u) * static_cast<float>(xTexDims.uWidth)  );
//    float fDeltaV = Asura_Maths::Abs( (pxV2->v - pxV1->v) * static_cast<float>(xTexDims.uHeight) );
//    if( fDeltaU <= 62.0f && fDeltaV <= 30.0f )
//    {
//        return false;
//    }
//
//    return true;
}
