//////////////////////////////////////////////////////////////////////////////
//
// Tools_SmoothSkin_Processor_Xbox360.h
//
// Copyright (c) 2006 Rebellion. All rights reserved.
//
//////////////////////////////////////////////////////////////////////////////

#if defined ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#if !defined __TOOLS_SMOOTHSKIN_PROCESSOR_XBOX360_H__
#define __TOOLS_SMOOTHSKIN_PROCESSOR_XBOX360_H__

/******************************************************************************/
/* Included Files                                                             */
/******************************************************************************/

// Misc
#include <windows.h>

/******************************************************************************/
/* Classes                                                                    */
/******************************************************************************/

class Asura_Chunk_Stream;
class Tools_SmoothSkin_Processor;
class Tools_SmoothSkin_Vertex;

////////////////////////////////////////////////////////////////////////////////
//
// Tools_SmoothSkin_Processor_Xbox360
//
// Takes the data from a generic Tools_SmoothSkin_Processor and outputs a chunk
// suitable for Xbox 360
//
////////////////////////////////////////////////////////////////////////////////

class Tools_SmoothSkin_Processor_Xbox360
{
public:

	// Constructor / destructor
	Tools_SmoothSkin_Processor_Xbox360();
	~Tools_SmoothSkin_Processor_Xbox360();

	// Functions
	bool Initialise( const Tools_SmoothSkin_Processor& xSrcProcessor );
	bool InitialiseFromHierarchyProcessor();
	bool OutputToChunk( HANDLE pvFile ) const;
	bool OutputToChunk( Asura_Chunk_Stream& ) const;

protected:

	// Functions
	void WriteVtxToStream( const Tools_SmoothSkin_Vertex& xVtx, Asura_Chunk_Stream& xStream ) const;

	// Types
	class ProcessedStrip;

	// Data

	const Tools_SmoothSkin_Processor* m_pxSrcProcessor;
	const char*                       m_szSrcName;

	ProcessedStrip*	   m_pxProcessedStrips;
	u_int			   m_uNumProcessedStrips;	
	u_int              m_uTotalVertices;
	u_int              m_uTotalIndices;
	u_int              m_uTotalTriangles;
};

#endif // !defined __TOOLS_SMOOTHSKIN_PROCESSOR_XBOX360_H__
