//
// Tools_PFX_Vector_Object.h
//
// Created by KOR - 25/08/2004
//
// Copyright (C) 2004 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif

#ifndef __TOOLS_PFX_VECTOR_OBJECT_H__
#define __TOOLS_PFX_VECTOR_OBJECT_H__

#include "Core/Asura_String.h"
#include "Objects/Tools_Object.h"

// Generic vector edit object, for gravity, source offset, source velocity, etc.
class Tools_PFX_Vector_Object : public Tools_Object
{
	public:
		// Default constructor
		Tools_PFX_Vector_Object();
		// Destructor
		~Tools_PFX_Vector_Object();

		// Virtual Tools_Object methods
		void UpdateWhileSelected();
		void Update();
		void UpdatePositionInAsuraData(bool);
		const char* GetTypeDescription() { return m_xTypeDescription.GetString();}
		const char* GetName() { return m_xName.GetString();}
		virtual bool IsTemporaryEditObject() const {return true;}

		// Members
		bool m_bGameEntitiesNeedUpdating;
		bool m_bReadyToDelete;
		Asura_String m_xTypeDescription;
		Asura_String m_xName;
};

class Tools_PFX_Effect_Collision_Plane : public Tools_PFX_Vector_Object
{
	public:
		Tools_PFX_Effect_Collision_Plane() : Tools_PFX_Vector_Object()
		{
			m_xTypeDescription = "PFX Effect Collision Plane";
			m_xName = "Particle collision plane for current PFX effect";
		}

		void Render();
};

#endif//__TOOLS_PFX_VECTOR_OBJECT_H__

