#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef _TOOLS_STARTPOSITION_OBJECT_H_
#define _TOOLS_STARTPOSITION_OBJECT_H_

#include "Tools_Object.h"
#include "Core/Asura_String.h"

class Asura_Environment_StartPosition;

class Tools_StartPosition_Object : public Tools_Object
{
protected :
	Tools_StartPosition_Object(int index);

public:
	//creates all the tools objects from the asura data
	static void CreateAllObjects();
	static void CreateStartPosition();//creates a new start position object
	static void CreateOverlay();
	static void DeleteOverlay();
	static Tools_StartPosition_Object* Project_CreateStartPositionObject(int iIndex);
	void OnSelection();
	void OnDeselection();

	//virtual function overides
	virtual void UpdatePositionFromAsuraData();
	virtual void UpdatePositionInAsuraData(bool /*updateLinkedObjects*/);
	virtual void UpdateWhileSelected();
	virtual void AddOverlayControls( class Asura_Overlay* pxOverlay, Asura_Vector_2& xOffset );
	
	const char* GetName();
	const char* GetTypeDescription(){return "Start Position";}

	void Destroy();


	//flags entity/asura file as modified according to where start positions are being saved
	static void SetFileModified();
	
protected:
	//data
	Asura_String Name;
	int Index;
	bool m_bChanged;

	// static stuff for overlays
	static Asura_Vector_2           s_xOverlayPosition;
	static Tools_StartPosition_Object* s_pxThisStartPos;
};



#endif //_TOOLS_STARTPOSITION_OBJECT_H_
