//////////////////////////////////////////////////////////////////////
// Tools_VolumeSphereEdit_Object.h							//
// SJL 19/11/07														//
// Copyright (C) 2007 Rebellion, All Rights Reserved.			    //
//////////////////////////////////////////////////////////////////////


#ifdef ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#ifndef _TOOLS_VOLUMESPHEREEDIT_OBJECT_H_
#define _TOOLS_VOLUMESPHEREEDIT_OBJECT_H_

#include "Core/Asura_String.h"
#include "Objects/Tools_Object.h"
#include "Volume/Asura_Volume.h"
#include "Volume/Asura_Volume_Sphere.h"
#include "Objects/Tools_VolumeBaseEdit_Object.h"

class Tools_VolumeSphereEdit_Object : public Tools_VolumeBaseEdit_Object
{
private:
	typedef Tools_VolumeBaseEdit_Object PARENT;
public :

	Tools_VolumeSphereEdit_Object(const char* name, Asura_Volume_Sphere* pxVolume, bool* pbModifiedFlag = 0);
	~Tools_VolumeSphereEdit_Object();

	virtual bool ObjectIsInLOS(const Asura_Vector_3& xStart, const Asura_Vector_3& xDir, float& fLowest);
	virtual void Displace(const Asura_Vector_3& xOffset);
	virtual void RotateAbout(const Asura_Vector_3& xCentre, const Asura_Matrix_3x3& xOri);

	virtual void UpdatePositionInAsuraData(bool /*updateLinkedObjects*/);	// Update game entities position from tools objects position.

protected :
	
	void SetToolsDataFromVolumeData();
	void SetVolumeDataFromToolsData();

	virtual void SetDefaultPositionFromVolume() { SetToolsDataFromVolumeData(); }

	virtual void AddOverlayControls(class Asura_Overlay* pxOverlay,Asura_Vector_2& xOffset);

	virtual void Render();

	virtual void UpdateWhileSelected();

	virtual void SelectFaceUnderCursor( const bool bGetFurthest );
	virtual void SnapFaceToCursor(const bool bAlsoExpandOppositeFace);

	Asura_Vector_3*				m_pxPosition;
	float*						m_pfRadius;

	Asura_Vector_3				m_xOverlayPosition;
	float						m_fOverlayRadius;

	bool						m_bOverlayPositionChanged;
	bool					    m_bOverlayRadiusChanged;

};

#endif _TOOLS_VOLUMESPHEREEDIT_OBJECT_H_