// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef ___DMAEMU_H___
#define ___DMAEMU_H___ 1

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "PS2/PS2Strip/PS2Strip_PS2Stuff.h"

// B E G I N   N A M E S P A C E /////////////////////////////////////////////

namespace DMADebug
{

// T Y P E S /////////////////////////////////////////////////////////////////

enum DMAID
{
	DMA_REFE = 0,
	DMA_CNT,
	DMA_NEXT,
	DMA_REF,
	DMA_REFS,
	DMA_CALL,
	DMA_RET,
	DMA_END
};

// C O N S T A N T S /////////////////////////////////////////////////////////

static const u_int MEM_MAX_32  = 0x01ffffff;
static const u_int MEM_MAX_128 = 0x07ffffff;

// G L O B A L S /////////////////////////////////////////////////////////////

// Globally accessible QWord which is what the DMA emulator puts onto the 'bus'.
extern int gChan;
extern u_int *gDmaTransferQWord;
extern bool gDmaTransferQWordIsTag;		// Is this word a DMA tag?

// Upper limit on memory size, used for bounds checking
extern u_int gUpperMainMemLimit;

// P R O T O T Y P E S   A N D   I N L I N E   F U N C T I O N S /////////////

int DMA_getCRC( u_int* puResult );

bool DMA_isValidAddress( void* pvAddr );
void *DMA_convertToMainMemAddress( void* pvAddr );
void DMA_parseConfig( const char* szInitString );
int DMA_emulateDMACycle( void );
int DMA_startDmaTransfer( int iChannelNum, u_int uCHCR );
int DMA_sceDmaSend( PS2STRIP_DMA_CHAN_ID eChanID, void* pvTag);
int DMA_sceDmaSendN( PS2STRIP_DMA_CHAN_ID eChanID, void* pvAddr, int iSize );

// E N D   N A M E S P A C E /////////////////////////////////////////////////

}

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

#endif // #ifndef ___DMAEMU_H___
