// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef ___GIFCURSOR_H___
#define ___GIFCURSOR_H___ 1

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "PS2/PS2Strip/PS2Strip_PS2Stuff.h"

// B E G I N   N A M E S P A C E /////////////////////////////////////////////

namespace DMADebug
{

// T Y P E S /////////////////////////////////////////////////////////////////

enum GIFREG
{
    GIFREG_PRIM     = 0,
    GIFREG_RGBAQ    = 1,
    GIFREG_ST       = 2,
    GIFREG_UV       = 3,
    GIFREG_XYZF2    = 4,
    GIFREG_XYZ2     = 5,
    GIFREG_TEX0_1   = 6,
    GIFREG_TEX0_2   = 7,
    GIFREG_CLAMP_1  = 8,
    GIFREG_CLAMP_2  = 9,
    GIFREG_FOG      = 0xa,
    GIFREG_RESERVED = 0xb,
    GIFREG_XYZF3    = 0xc,
    GIFREG_XYZ3     = 0xd,
    GIFREG_A_D      = 0xe,
    GIFREG_NOP      = 0xf
};

struct GIFTag
{
    u_int *tagaddr;            // RAM address of this GIF tag

    u_int nloop;
    bool eop;
    bool pre;
    u_int prim;
    u_int flg;
    u_int nreg;
    u_int regs[2];
    char regidx[16];
};

// C O N S T A N T S /////////////////////////////////////////////////////////

enum GIFTAG_FLG
{
    GIFTAG_FLG_PACKED,
    GIFTAG_FLG_REGLIST,
    GIFTAG_FLG_IMAGE,
    GIFTAG_FLG_DISABLE,
};

static const int NUMGIFREGS = 72;

// G L O B A L S /////////////////////////////////////////////////////////////

extern u_int *gGifInput;

// P R O T O T Y P E S   A N D   I N L I N E   F U N C T I O N S /////////////

void GIF_parseConfig( const char* szInitString );
void GIF_saveGifRegisters( void );
bool GIF_isIdle( void );
int GIF_emulateGifCycle( void );
int GIF_disassemble( void );
int GIF_disassembleDmaList( PS2STRIP_DMA_CHAN_ID eChanID, void* pvTag );
int GIF_disassembleDmaListN( PS2STRIP_DMA_CHAN_ID eChanID, void* pvTag, int iNumQWs );
int GIF_disassembleXGKICK( void* pvAddr );
void GIF_reset( void );

// E N D   N A M E S P A C E /////////////////////////////////////////////////

}

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

#endif // #ifndef ___GIFCURSOR_H___
