//
// Tools_RagdollCollision_Object.h
//
// Created by KJFL - 22 October 2008
//
// Copyright (C) 2008 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef _TOOLS_RAGDOLLCOLLISION_OBJECT_H_
#define _TOOLS_RAGDOLLCOLLISION_OBJECT_H_

#include "Core/Asura_List.h"
#include "Objects/Tools_Object.h"

class Asura_Physics_Ragdoll_Desc_CollisionObject;

class Tools_RagdollCollision_Object : public Tools_Object
{
	public :

		Tools_RagdollCollision_Object( Asura_Physics_Ragdoll_Desc_CollisionObject* pxCollisionObject, u_int uCollisionObjectIndex, const char* szNodeName );

		~Tools_RagdollCollision_Object();

		const char* GetName();
		const char* GetTypeDescription(){return "RagdollCollision";}

		virtual bool IsSelectable();
		virtual void OnSelection();
		virtual void OnDeselection();
		virtual void OnGroupDeselection();

		virtual void Update();
		virtual void Render();
		virtual void PrintInfo( float& x,float& y );
		virtual bool CanBeDestroyed(){return true;}
		virtual bool CanBeMoved(){return false;}

		void UpdatePosition(const Asura_Vector_3& xPos,const Asura_Matrix_3x3& xMat);
		virtual bool ObjectIsInLOS(const Asura_Vector_3& xAlpha, const Asura_Vector_3& xBeta, float& fLowest);

		static Asura_List<Tools_RagdollCollision_Object>& GetList(void) { return s_xList; }

		Asura_Physics_Ragdoll_Desc_CollisionObject* GetCollisionObject( void ) const
		{
			return m_pxCollisionObject;
		}

		u_int GetCollisionObjectIndex( void ) const
		{
			return m_uCollisionObjectIndex;
		}

		void SetCollisionObject( Asura_Physics_Ragdoll_Desc_CollisionObject* pxNewObject, u_int uCollisionObjectIndex )
		{
			m_pxCollisionObject = pxNewObject;
			m_uCollisionObjectIndex = uCollisionObjectIndex;
		}

		void GetRagdollObjectOrientationAndPosition( Asura_AMatrix3x3& xMatrix, Asura_AVector3& xPosition ) const;

	private :

		
		void CreatePropertiesOverlay( void );
		void DeletePropertiesOverlay( void );

		Asura_Physics_Ragdoll_Desc_CollisionObject*	m_pxCollisionObject;
		u_int										m_uCollisionObjectIndex;

		Asura_String m_xName;

		float	m_fRadius;
		bool	m_bRadiusModified;

		float	m_fMass;
		bool	m_bMassModified;

		static Asura_List<Tools_RagdollCollision_Object> s_xList;
		static Asura_Vector_2 s_xPropertiesOverlayPosition;
};

#endif //_TOOLS_RAGDOLLCOLLISION_OBJECT_H_
