//
// Tools_Mode_Regions.h
//
// Created by Richard Rice - 15/10/2002
// 
// Copyright (C) 2002 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __TOOLS_MODE_REGIONS_H__
#define __TOOLS_MODE_REGIONS_H__

// I N C L U D E S ///////////////////////////////////////////////////////////

// Tools.
#include "Tools_Mode.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

template< typename T >
class List;

// C L A S S E S /////////////////////////////////////////////////////////////

class Tools_Mode_Regions : public Tools_Mode
{
    public:

        // C L A S S   M E T H O D S /////////////////////////////////////////

        static u_int CalculateMaxReqdDmaChainPieces( const u_int* puNumDmaChainPiecesPerRgn,
                                                     u_int* puRegionsForMaxChainPieces,
                                                     List<int>* pxCausingModuleList,
                                                     u_int* puOtherRegionsForMaxChainPieces,
                                                     List<int>* pxOtherCausingModuleList );

        static void DealWithModifiedModuleLinks( void );

        static bool IsModuleInHiddenRegion( int iModuleIdx );
        
        // C O N S T R U C T O R S   /   D E S T R U C T O R S ///////////////

        Tools_Mode_Regions( void ) { Initialise(); }

        ~Tools_Mode_Regions( void ) { Shutdown(); }

        // M E T H O D S /////////////////////////////////////////////////////

        virtual void Update(void);
        virtual void RenderWorld_PostToneMap(void);
    
        virtual bool IsModified( void );
        virtual void PreSave( void );
		virtual void QuickSave();

    private:

        // C L A S S   M E T H O D S /////////////////////////////////////////

        static void HandleKeyboard(void);

        static void Undo();
        static void Redo();

        // M E T H O D S /////////////////////////////////////////////////////

        void Initialise( void );
        void Shutdown( void );

};


#endif//__TOOLS_MODE_REGIONS_H__
