//
// Tools_DSPADPCM_Conversion.h
//
// Created by KOR - 08/06/2003 17:08:37
//
// Copyright (C) 2003 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif

#ifndef __TOOLS_DSPADPCM_CONVERSION_H__
#define __TOOLS_DSPADPCM_CONVERSION_H__

/*--------------------------------------------------------------------------*
    dsptool.dll exports
 *--------------------------------------------------------------------------*/
typedef struct _ADPCMINFO
{
    // start context
    unsigned short coef[16];
    unsigned short gain;
    unsigned short pred_scale;
    unsigned short yn1;
    unsigned short yn2;

    // loop context
    unsigned short loop_pred_scale;
    unsigned short loop_yn1;
    unsigned short loop_yn2;

} ADPCMINFO; 

typedef struct _ADPCMHeader
{
	// for header generation during decode
	unsigned int num_samples;		// total number of RAW samples
	unsigned int num_adpcm_nibbles;	// number of ADPCM nibbles (including frame headers)
	unsigned int sample_rate;		// Sample rate, in Hz
	// DSP addressing and decode context
	unsigned short loop_flag;		// 1=LOOPED, 0=NOT LOOPED
	unsigned short format;			// Always 0x0000, for ADPCM
	unsigned int sa;				// Start offset address for looped samples (zero for non-looped)
	unsigned int ea;				// End offset address for looped samples
	unsigned int ca;				// always zero
	unsigned short coef[16];		//-decode coefficients (eight pairs of 16-bit words)
	// DSP decoder initial state
	unsigned short gain;			//-always zero for ADPCM
	unsigned short ps;				//-predictor/scale
	unsigned short yn1;				//-sample history
	unsigned short yn2;				//-sample history
	// DSP decoder loop context
	unsigned short lps;				//-predictor/scale for loop context
	unsigned short lyn1;			//-sample history (n-1) for loop context
	unsigned short lyn2;			//-sample history (n-2) for loop context
	unsigned short pad[11];			// reserved
} ADPCMHeader;

// Essentially the same as the PS2 vag equivalents
enum Tools_ConvertDSPFile_Errors
{
    Tools_ConvertDSPFile_Success,
    Tools_ConvertDSPFile_FailedToLoadDLL,
    Tools_ConvertDSPFile_FailedToOpenWav,
    Tools_ConvertDSPFile_FailedToReadWav,
    //Tools_ConvertDSPFile_FirstSampleTooBig,
    Tools_ConvertDSPFile_FailedToCreateDSP,
    Tools_ConvertDSPFile_FailedToWriteDSP,
};

bool ConvertDSPFile(const char* szInputFileName, const char* szOutputFileName, const struct ToolsSoundConversionData* pxConvertData, u_int* puFailureCode = 0);

#endif//__TOOLS_DSPADPCM_CONVERSION_H__
