// Tools_Audio_DSP.h
// Thomas Young / Andrew McDonald - 17.03.09
// Copyright (C) 2009 Rebellion, All Rights Reserved.

// F I L E   W R A P P E R ///////////////////////////////////////////////////

#if defined ASURA_USE_PRAGMA_ONCE
#pragma once
#endif

#if !defined __TOOLS_AUDIO_DSP_H__
#define __TOOLS_AUDIO_DSP_H__

//#ifdef ASURA_USE_AUDIO_SYSTEM

// I N C L U D E S ///////////////////////////////////////////////////////////

#include "Core/Asura_List.h"
#include "Interface/Asura_Dialog.h"
#include "Interface/Asura_Overlay.h"

// F O R W A R D   D E C L A R A T I O N S ///////////////////////////////////

class Asura_List_Dialog;
class Asura_Vector_2;

// C L A S S   D E C L A R A T I O N S ///////////////////////////////////////

//________________________ Tools_Audio_DSP _____________________________

class Tools_Audio_DSP
{
	friend class Tools_DSPChain_DropDownList_Dialog;
	friend class Tools_Audio_DSPChainOverlay;

	public:

		static void 		CreateOverlay		( );
		static void 		DestroyOverlay		( );
		static void 		ToggleOverlay		( );
		static bool			IsOverlayOpen		( );

		//static void			Save				( );
		static bool&		Modified			( ) { return s_bModified; }
		static void			TransferModeData	( const int iMode );

		static Asura_Vector_2 s_xChainListOverlayPos;
		static Asura_Vector_2 s_xChainOverlayPos;

	protected:

		static bool s_bModified;
};

//__________________ Tools_DSPChain_DropDownList_Dialog _______________________

class Tools_DSPChain_DropDownList_Dialog : public Asura_Hash_DropDownList_Dialog
{
	public:

		Tools_DSPChain_DropDownList_Dialog	(	const Asura_Vector_2& xOffset
											,	const int iNumLines
											,	Asura_Hash_ID* const puHashID
											,	bool* const pbChanged
											,	const char* const szName = NULL );

		static void RefreshChains ( );

	protected:

		virtual int			GetListValidID			( )				const { return s_iChainListValidID; }
		virtual u_int		GetNumberOfHashValues	( )				const;
		virtual const char* GetNameByIndex			( int iIndex )	const;

	private:

		static int s_iChainListValidID;
};

//#endif // defined ASURA_USE_AUDIO_SYSTEM

#endif // !defined __TOOLS_AUDIO_DSP_H__

//eof
