//
// Tools_Mode_Streaming.h
//
// Created by Richard Rice - 03/03/2006
// 
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//


#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __TOOLS_MODE_STREAMING_H__
#define __TOOLS_MODE_STREAMING_H__
#ifdef ASURA_USE_STREAMING

#include "Core/Asura_Maths.h"
#include "Tools_Mode.h"


class Asura_Streaming_Zone;

class Tools_Mode_Streaming : public Tools_Mode
{
	public:

		void InitialiseMode(void);
		void ShutdownMode(void);
		void Update(void);
		void RenderUI(void);

		void QuickSave(void);
 		bool IsModified();

		static Asura_Streaming_Zone* GetStreamingZone(void) { return(s_pxZone); }


	private:
		void TransferModeData(int iMode);

		//void HandleKeyboard(void);
		
		void CreateModeOverlay(void);


		static void AddConnection();
		static void DeleteConnection();

		static bool CanDeleteConnection();


		static void BuildConnectionStringList();
		static void DeleteConnectionStringList();
		static void UpdateConnectionList();

		Asura_Vector_2 m_xModeOverlayPosition;

		static Asura_Streaming_Zone* s_pxZone;

		static int s_iConnectionIndex;//index of current selection
		static int s_iConnectionStringListSize;
		static char** s_pszConnectionStrings;

};


#endif //ASURA_USE_STREAMING
#endif //__TOOLS_MODE_STREAMING_H__

