//
// Tools_StreamingConnection_Object.h
//
// Created by Richard Rice - 06/03/2006
// 
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef _TOOLS_STREAMINGCONNECTION_OBJECT_H_
#define _TOOLS_STREAMINGCONNECTION_OBJECT_H_
#ifdef ASURA_USE_STREAMING

#include "Objects/Tools_VolumeEdit_Object.h"

class Tools_StreamingConnection_Object : public Tools_VolumeEdit_Object
{
public :
	Tools_StreamingConnection_Object(const char* szConnectionName,class Asura_Streaming_Zone* pxZone);
	~Tools_StreamingConnection_Object();


	static Tools_StreamingConnection_Object* FindByName(const char* szName);

protected:
	const char* GetTypeDescription(){return "Zone Connection";}

	virtual void Update();
	virtual void Render();		

	virtual void AddOverlayControls(class Asura_Overlay* pxOverlay,Asura_Vector_2& xOffset);
	virtual Asura_Vector_2* GetOverlayPosition() {return &s_xOverlayPosition;}
	virtual bool AllowEndVolumeEditing() const {return false;}
	
	virtual bool CanBeDestroyed(){return false;}

private:
	class Asura_Streaming_Connection* GetConnection();

	Asura_Hash_ID m_uConnectionHash;
	class Asura_Streaming_Zone* m_pxZone;

	Asura_Bounding_Box m_xBox;
	bool m_bConnectionModified;
	bool m_bUseBox;
	bool m_bLowDetail;

	static Asura_Vector_2 s_xOverlayPosition;

};

#endif //ASURA_USE_STREAMING
#endif //_TOOLS_STREAMINGCONNECTION_OBJECT_H_