//
// Tools_StreamingModuleNames.h
//
// Created by Richard Rice - 10/04/2006
// 
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __TOOLS_STREAMINGMODULENAMES_H__
#define __TOOLS_STREAMINGMODULENAMES_H__
#ifdef ASURA_USE_STREAMING

#include "Core/Asura_String.h"

class Tools_StreamingModuleNames_Zone;
class Asura_Chunk_Stream;

/*
This class holds the names of the zones and modules as they were when the .mod file was saved. Its used
for detecting external changes to the .asr files ,so the module linking indeces can be corrected.
*/


class Tools_StreamingModuleNames
{
public :
	static void Initialise();
	static void Shutdown();

	static void ResyncAll();
	static void ResyncConnectionIndices();
	static void ResyncConnection(u_int uIndex);

	static void ReadFromChunkStream(Asura_Chunk_Stream& xStream,int iVersion);
	static void WriteToChunkStream(Asura_Chunk_Stream& xStream);

private :
	static u_int s_uNumConnectedZones;
	static Tools_StreamingModuleNames_Zone** s_ppxConnectedZones;

};

class Tools_StreamingModuleNames_Zone
{
public :
	Tools_StreamingModuleNames_Zone();
	Tools_StreamingModuleNames_Zone(const char* szZoneName);
	~Tools_StreamingModuleNames_Zone();

	const char* GetName() const {return m_xZoneName.GetString();}

	void Resync(u_int uIndex);

	void ReadFromChunkStream(Asura_Chunk_Stream& xStream,int iVersion);
	void WriteToChunkStream(Asura_Chunk_Stream& xStream);

private :
	Asura_String m_xZoneName;
	
	u_int m_uNumModules;
	Asura_String* m_pxModuleNames;		
	
};





#endif //ASURA_USE_STREAMING
#endif //__TOOLS_STREAMINGMODULENAMES_H__
