////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//
// Tools_Cubemap_Generator.h
//
// Created by Dan Clarke - 07/08/2008
//
// Copyright (C) 2008 Rebellion.  All Rights Reserved.
//

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __TOOLS_CUBEMAP_GENERATOR_H
#define __TOOLS_CUBEMAP_GENERATOR_H

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "Rendering/Asura_Direct3D.h"
#include "Interface/Asura_Dialog.h"

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

class Tools_Cubemap_Generator
{
	public:
		static void Create();
		static void Update();
		static bool Render();
		static void ToggleOverlay();
		static bool IsOpen() { return s_bIsOverlayVisible; }

	private:
		static void CreateOverlay();
		static void CloseOverlay();
		static bool GenerateCubeMap();
		static bool GenerateHDRCubeMap();
		static bool InitCubeMapGeneration();
		static void CleanupCubeMapGeneration();
		static bool CropImageToSquareAspect(Direct3D_Texture* pxTexture, Direct3D_Surface* pxTargetSurface);
		static bool CreateVertexBuffer();
		static bool ShowSaveAsDialogBox();
		static bool WriteTextureToDXT1CubeTextureFace(Direct3D_Surface* pxSourceSurface, Direct3D_CubeTexture* pxDestCubeTexture, u_int uFaceIndex);
		static bool CopyHDRBackbufferToSurface(D3DCUBEMAP_FACES eFace);

		enum StateEnum
		{
			STATE_IDLE,
			STATE_START_CAPTURES,
			STATE_SNAP_FRONT,
			STATE_SNAP_LEFT,
			STATE_SNAP_RIGHT,
			STATE_SNAP_BACK,
			STATE_SNAP_UP,
			STATE_SNAP_DOWN,
			STATE_GENERATE_CUBEMAP,
		};

		static StateEnum s_eState;
		static Asura_Matrix_3x3 s_xOriginalOrientation;
		static Asura_Angle s_xOriginalFOV;
		static Direct3D_VertexBuffer* s_pxVertexBuffer;
		static u_int s_uScreenshotWidth;
		static u_int s_uScreenshotHeight;

		static Direct3D_Surface* s_pxOriginalRenderTarget;
		static Direct3D_VertexBuffer* s_pxOriginalVertexBuffer;
		static u_int s_uOriginalVBOffset, s_uOriginalVBStride;
		static DWORD s_lOriginalFVF;
		static bool s_bIsOverlayVisible;
		static Asura_Overlay* s_pxOverlay;
		static float s_fCubeMapDimension;
		static bool s_bOriginalOverlaysHidden;
		static bool s_bHideOverlay;
		static bool s_bGenerateHDR;
		static Asura_String s_szFileLocationString;
		static Direct3D_CubeTexture* s_pxCubemapTexture;
};

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#endif // __TOOLS_CUBEMAP_GENERATOR_H

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
