//
// Tools_Batch_Waypointing.h
//
// Created by Andrew Weinkove - 16/09/03
//
// Code to enable batch waypoint generation.
// 
// Copyright (C) 2001 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef __TOOLS_BATCH_WAYPOINTING_H__
#define __TOOLS_BATCH_WAYPOINTING_H__

template< typename T >
class List;

// (AW - 16.09.2003) - This method for batch waypointing is nicked wholesale from Rich Rice's code to batch export levels.
// (AW - 02.02.2004) - Changed to an instantiable class to allow sniper to override and add its own coverpoint generation.
class Tools_Batch_Waypointing
{
public:
	Tools_Batch_Waypointing();
	virtual ~Tools_Batch_Waypointing();

	static Tools_Batch_Waypointing* GetThis();
	virtual void BatchWaypointing_WaypointLevel();
	virtual void BatchWaypointing_GetIdentifiers( List<const char*>* pxIdentifiers );

protected:
	static Tools_Batch_Waypointing* s_pxThis;

    enum Waypointing_Identifiers
    {
        WID_FILE,
        WID_GENERATE_COVERPOINTS,
        WID_CALCULATE_ZONE_INFORMATION,
        WID_MIN_WP_RADIUS,
        WID_MAX_WP_RADIUS,
        WID_MIN_DENSE_WP_RADIUS,
        WID_MAX_DENSE_WP_RADIUS,
        WID_MIN_LINK_LENGTH,
        WID_MAX_LINK_LENGTH,

        WID_NUM_WAYPOINTING_IDENTIFIERS
    };
    static const char* s_pszIdentifiers[ WID_NUM_WAYPOINTING_IDENTIFIERS ];
};


#endif//__TOOLS_BATCH_WAYPOINTING_H__
