/**
*
* \file Tools_Wii_DisplayList.h
*
* Created by Andrew Southgate - 30/08/2007
*
* Copyright (C) 2007 Rebellion, All Rights Reserved.
*
* \brief
*
**/

#include "Core/Asura_Endian.h"

class Tools_Wii_StripSet;

class Tools_Wii_DisplayListFactory
{
	Tools_Wii_StripSet *m_pxStripSet;

	u_int GenerateList(void *&pxDisplayList, u_int &uSize);

protected:
	// couple of helper functions for the derived classes
	static void IncrementPtr(void *&pV, u_int uAmount)
	{
		pV = static_cast<void*>((static_cast<char*>(pV) + uAmount));
	}
	template <typename T> static void Store(void *&pV, T Val)
	{
		*static_cast<T*>(pV) = Asura_Endian::SwapBytes(Val);
		IncrementPtr(pV, sizeof(T));
	}

	// how many bytes per vert does the display list use
	virtual u_int SizePerVert() = 0;
	// what vertex format does this display list use
	virtual u_char StripType() = 0;
	// store one vertex worth of data
	virtual void StoreVert(void *&pV, u_int uIndex) = 0;
	Tools_Wii_DisplayListFactory()
	{
		m_pxStripSet = NULL;
	}
public:
	void BeginList();
	void AddStrip(u_short *pusIndicies, u_int uNumIndicies);
	u_int EndList(void *&pxDisplayList, u_int &uSize);
	// returns number of tris;
	u_int CreateDisplayList(void *&pxDisplayList, u_int &uSize, u_short *pusIndicies, u_int uNumIndicies);

};

