//
// Tools_Wii_Textures.h
//
// Created by KOR - 18/09/2003 14:30:47
//
// Copyright (C) 2003 Rebellion, All Rights Reserved.
//

#ifdef ASURA_USE_PRAGMA_ONCE
	#pragma once
#endif

#ifndef __TOOLS_WII_TEXTURES_H__
#define __TOOLS_WII_TEXTURES_H__

// For texture conversion data
#include "Load&Save/LevelExport/Tools_Level_Export.h"
#include "Wii/TPLWriter.h"

#define ASURA_MAX_TEXTURE_SIZES 16
// Most levels have under 100...
#define ASURA_MAX_WII_EXPORT_TEXTURES 256

enum Asura_RGB_Channel
{
	Asura_Channel_Red = 0,
	Asura_Channel_Green = 1,
	Asura_Channel_Blue = 2,
};

struct Asura_RGB_Buffer
{
	Asura_RGB_Channel eCurrentChannel;
	unsigned int uHeight;
	unsigned int uWidth;
	unsigned int uMipsToDrop;
	unsigned char* pucBuffer;
	unsigned int uExportNumber;
};

struct Asura_Wii_Alpha_Mapping
{
	Asura_String xSourceTexture;
	Asura_String xAlphaTexture;
	Asura_RGB_Channel eChannel;
};

class Tools_Wii_Textures
{
public:
	static void BeginExport(const char* szExportName);
	static void EndExport(HANDLE hSaveHandle);
	static bool ExportTexture(const char* inputName,const char* outputName, const TextureConversionData& xConversionData, u_int uMinTexRes, u_int uMaxMipDrops);
	static bool ConvertTexture(Asura_String xIn, Asura_String xOut, TPLOptions xOpts);
	static void SetMergeAlphaTextures(bool bValue) { s_bMergeAlphaTextures = bValue; }
	static bool ShouldMergeAlphaTextures() { return s_bMergeAlphaTextures; }
private:
	static void GetAlphaTextureTPLFilename(Asura_RGB_Buffer* pxRGBBuffer, char szFilename[]);
	static void GetAlphaTextureBMPFilename(Asura_RGB_Buffer* pxRGBBuffer, char szFilename[]);
	static bool SaveWindowsBitmap(Asura_RGB_Buffer* pxRGBBuffer, const char* szFilename);
	static bool					s_bInitialised;
	static Asura_String			s_xExportName;
	static Asura_NameTree		s_xSizeBufferTree;
	static Asura_RGB_Buffer		s_axRGBBuffers[ASURA_MAX_TEXTURE_SIZES];
	static Asura_Wii_Alpha_Mapping	s_axMappings[ASURA_MAX_WII_EXPORT_TEXTURES];
	static u_int				s_uNumMappings;
	static bool					s_bMergeAlphaTextures;
};

#endif//__TOOLS_WII_TEXTURES_H__
