//
// Tools_Zone_VolumeEdit_Controller.h
//
// Created by Richard Rice - 25/01/05
// 
// Copyright (C) 2005 Rebellion, All Rights Reserved.
//


#ifndef __TOOLS_ZONE_VOLUMEEDIT_CONTROLLER_H__
#define __TOOLS_ZONE_VOLUMEEDIT_CONTROLLER_H__

#include "Core/Asura_OrientedVolume.h"
#include "Zone/Asura_Zone.h"

#include "Objects/Tools_VolumeEdit_Object.h"

class Tools_Zone_Editor;

//For dealing with editing the volumes attached to a zone
class Tools_Zone_VolumeEdit_Controller : public Tools_VolumeEdit_Controller
{
	public :
		Tools_Zone_VolumeEdit_Controller(Asura_Zone* pxZone,bool* pbChanged);

		virtual void StartVolumeEditing();
		//virtual void EndVolumeEditing();
	
	protected :
		virtual bool CanCreateVolume()
		{return true;}
		
		virtual bool CanDeleteVolume()
		{return GetNumberOfVolumes()>1;}
		
		

		//Gets the current number of volumes
		virtual int GetNumberOfVolumes()
		{return m_pxZone->m_iNumberOfVolumes;}
		
		//Gets a pointer to the bounding box for a given volume
		virtual Asura_Bounding_Box* GetVolumeBox(int iIndex)
		{return &(m_pxZone->m_pxVolumes[iIndex].m_xBox);}

		//Gets a pointer to the orientation for a given volume. Returns 0 if there is none
		virtual Asura_Quat* GetVolumeOrient(int iIndex)
		{return &(m_pxZone->m_pxVolumes[iIndex].m_xOrient);}

		//Gets a default position for volume objects that have yet to gain a proper volume
		virtual Asura_Vector_3 GetDefaultPosition();

		//Gets the name of the owner , to use for part of the volume names
		virtual const char* GetName()
		{return m_pxZone->m_xName.GetString();}

		//Creates the new volume in the asura data
		virtual void CreateVolumeMain();

		//Deletes the volume from the asura data
		virtual void DeleteVolumeMain(int iIndex);

		virtual Asura_Vector_2* GetOverlayPosition(){return &s_xOverlayPosition;}


	private :
		Asura_Zone* m_pxZone;
		bool* m_pbChanged;

		static Asura_Vector_2 s_xOverlayPosition;

};

#endif //__TOOLS_ZONE_VOLUMEEDIT_CONTROLLER_H__
