//
// Project_CommandConsole.cpp
//
// Created by RJF - 26 September 2006
//
// Copyright (C) 2006 Rebellion, All Rights Reserved.
//

#include "Core/Asura.h"

#ifdef ASURA_UNITTEST_BATCHMODE

// This file's header.
#include "Interface/Asura_CommandConsole.h"

#include "Interface/Asura_CommandConsole_IO.h"

#include <iostream>
#include <string>

class UnitTest_TextOutput_Console : public Asura_CommandConsole_IO
{
public:
	// C O N S T R U C T O R S   /   D E S T R U C T O R S ///////////////

	UnitTest_TextOutput_Console( void ) { }
	virtual ~UnitTest_TextOutput_Console( void ) { }

	// M E T H O D S /////////////////////////////////////////////////////

	virtual void Reset( void ) { }

	virtual void Update( void ) { }
	virtual void Render( void ) { }

	virtual bool CanBeHidden( void ) const { return false; }
	virtual void SetDown( bool bDown, bool bInstantTransition ) { }
	virtual void SetPartiallyDown(u_int uLines, bool bInstantTransition) { }

	virtual bool CanArchiveOutput( void ) const { return true; }
	virtual void AddOutput( const Asura_UnicodeChar* wszLatestOutput )
	{ 
		fputws(wszLatestOutput, stdout);
		fputws(L"\n", stdout);
	}
	virtual void ClearOutput( void ) { }

	virtual void Scroll( bool bDown, bool bToEnd ) { }

	virtual void SetTextScale( float fScale ) { }
	virtual void SetBorderX( float fBorderX ) { }
	virtual float GetTextScale( void ) const { return 1.0f; }
	virtual float GetBorderX( void ) const { return 0.0f; }

	virtual void SetTexture( int iTextureID ) { }
	virtual void SetBackgroundColour( u_int uColour ) { }
	virtual void SetFont( const char* szFontName ) { }
	virtual bool SetFont( Asura_Handle iHandle ) { return true; }

	virtual const Asura_UnicodeChar* GetLineSplitPoint(const Asura_UnicodeChar* wszLine)
	{
		while(*wszLine)wszLine++; return wszLine;
	}

	virtual float GetBottomY() const {return 1.f;} 
};

Asura_CommandConsole_IO* Asura_CommandConsole::Project_CreateIO( void )
{
	return ( new UnitTest_TextOutput_Console() );
}

bool Asura_CommandConsole::Project_OnConsoleUp()
{
	return true;
}

bool Asura_CommandConsole::Project_OnConsoleDown()
{
	return true;
}

bool Asura_CommandConsole::Project_IsConsoleToggled()
{
	return false;
}

bool Asura_CommandConsole::Project_CheckRestrictions( u_int uRestrictions, bool bIsCmd )
{
	return true;
}

#endif