//////////////////////////////////////////////////////////////////////////////
//
// Asura_EngineConfiguration.h
//
// Copyright (c) 2002 Rebellion. All rights reserved.
//
// Description:
//
//     Project-specific, PSP-specific defines
//
//////////////////////////////////////////////////////////////////////////////

// B E G I N   F I L E   W R A P P E R ///////////////////////////////////////

#ifdef ASURA_USE_PRAGMA_ONCE
    #pragma once
#endif

#ifndef ___ASURA_ENGINECONFIGURATION_H___
#define ___ASURA_ENGINECONFIGURATION_H___ 1

// M A C R O S ///////////////////////////////////////////////////////////////

// Independent settings.
#define ASURA_ASSERT											(1)
//#define ASURA_USE_PROFILING_SYSTEM								(1)
//#define ASURA_DISABLE_ANIM_TABLE_CODE							(1)
//#define ASURA_LOGFILES_ENABLED									(1)
#define ASURA_LOCALISEDTEXT_PAGE_STORAGE_SIZE					(11)
//#define ASURA_MAIN												(1)
#define ASURA_MAX_NO_OF_BONES_PER_MODEL							(100)
#define ASURA_MAX_NO_OF_TEXTURE_TILES							(128)
#define	ASURA_MAX_SHAPES										(512)

//#define ASURA_MEMHEAP_REPLACEMENT								(1)
#define ASURA_MEMORYMANAGEMENT_LOGGING							(0)
//#define ASURA_MEMORYMANAGEMENT_ENABLED							(1) // (MP - 29.10.2002) TODO: Don't we want to turn this off in release?
//#define ASURA_MEMORYMANAGEMENT_FILL							(1)
//#define ASURA_MEMORYMANAGEMENT_PROCESS_ALLOCATED_MEM			(1)

#define ASURA_NO_NETWORK_LAG_COMPENSATION						(1)
#define ASURA_SORTEDRENDER_QUEUESIZE (300) //maximum number of items that can be queued up
#define ASURA_SORTEDRENDER_STORAGESIZE (16384) //storage space in bytes for the items to be rendered
#define ASURA_SORTEDRENDER_SORTALPHAONDISTANCE					(1)
//#define ASURA_SUPPORT_COMMAND_CONSOLE                           (1)
//#define ASURA_SUPPORT_COMMAND_CONSOLE_QUIT                      (1)
//#define ASURA_SUPPORT_FMV_TEXTURES								(1)
//#define ASURA_SUPPORT_MULTIPLAYER_COMMS						(1)
#define ASURA_SUPPORT_NORMAL_MAPS								(1)
#define ASURA_SUPPORT_WEATHER_SYSTEM							(1)
//#define ASURA_TOOLS												(1)
#define ASURA_UPDATE_CLIENTENTITIES_EVERY_FRAME					(1)
//#define ASURA_USE_BILLBOARD_PLANTS							(1)
//#define ASURA_USE_DEBUG_TEXT									(1)
#ifdef ASURA_USE_DEBUG_TEXT
	#define ASURA_DEBUG_TEXT_MAX_BLOCKS		16
	#define ASURA_DEBUG_TEXT_MAX_CHARS		512
#endif
//#define ASURA_USE_DEFORMATRON_SYSTEM							(1)

// As far as I'm aware, we only need this for the environment smoke.
// Should the environment smoke move to PFX, we can probably drop it.
//#define ASURA_USE_ORIGINAL_PARTICLE_SYSTEM						(1)
#define ASURA_USE_PFX											(1)
#define ASURA_GRAPH_LEAN_AND_MEAN								(1)

//#define ASURA_USE_PHYSICS_PHASE_ONE_LOS							(1)
#define ASURA_DEVELOPMENT_PHYSICS								(1)
#define ASURA_USE_SAVED_MESH_COLOURS							(1)
#define ASURA_USE_SHADER_FRAGMENTS								(1)
//#define ASURA_USE_SKYSPHERE										(1)
//#define ASURA_USE_WIND_SYSTEM									(1)
//#define ASURA_USE_SCREENSHOT_SYSTEM								(1)
#define ASURA_SUPPORT_PARTICLES_USING_ANIMATION_HIERARCHY		(1)

#define ASURA_SUPPORT_MULTITHREADED_JOB_QUEUE					(1)
#define ASURA_PFX_TEMPLATES_SUPPORT_DATABLOCK					(1)

// Platform-specific settings.
//#define ASURA_PLATFORM_HAS_LONG_LONG_TYPE						(1)
#define ASURA_PLATFORM_MENU_MAX_SUPPORTED_CONTROLLERS			(2)

#define ASURA_USE_PLATFORM_VECTORS								(1)
#define ASURA_SUPPORT_UNITTEST									(1)

#if 1//_DEBUG
#define ASURA_UNITTEST_FAILURE_ACTION {asm("break 1");asm("nop");}
#endif

// E N D   F I L E   W R A P P E R ///////////////////////////////////////////

#endif // #ifndef ___ASURA_ENGINECONFIGURATION_H___
